/* Generated by Together */

#ifndef CBEVOELKERUNGSDICHTEELEMENT_H
#define CBEVOELKERUNGSDICHTEELEMENT_H

#include "CPunkt.h"

/**
 * Ein Element der Bevoelkerungsdichtenliste. Hiermit soll fuer einen Matrix-Index der Bezug zum Koordinatensystem geschaffen werden. 
 */
class CBevoelkerungsdichteElement {
private:    
    /**
     * Entspricht der Position, welche als Mittelpunkt fuer weitere Aussagen
     * betreffs Bevoelkerungsanzahl, angenommen wird.
     */
    CPunkt * hs;

    /**
     * Entspricht der Anzahl der in dem Umkreis lebenden Bevoelkerung.
     */
    double dichte;

    /**
     * Entspricht dem Umkreis, ueber den eine Aussage betreffs Bevoelkerungsanzahl gemacht wird.
     */
    double radius;
    
public:

  /**
   * "get"-Methode fr den Punkt, der in einem Element gespeichert ist
   * @return Liefert den Mittelpunkt des Bevoelkerungsraumes.
   */
  CPunkt* holenPunkt();
  
  /**
   * Holen-Methode fr die Dichte eines Elementes
   * @return Liefert die Anzahl der in dem angegebenen Raum lebenden Bevoelkerung.
   */
  double holenDichte();
  
  /**
   * Methode, um den Radius eines Elementes zu holen
   * @return Liefert den Umkreis, in welchem die angegebene Bevoelkerungsanzahl lebt.
   */
  double holenRadius();

  
  
  /**
   * set-Methode fr den Punkt eines BevlkerungsdichteElementes.
   * @param EinPunkt Der Mittelpunkt des zu betrachtenden Bevoelkerungsraumes.
   */
  void setzenPunkt(CPunkt* EinPunkt);
  
  
  /**
   * set-Methode, um die Dichte eines Elementes zu setzen
   */
  void setzenDichte(double d);
  
  
  /**
   * set-Methode, um den Radius eines Elementes zu setzen
   */
  void setzenRadius(double r);
  
  
  /**
   * Konstruktor
   */
  CBevoelkerungsdichteElement(CPunkt *EinPunkt,double d, double r);

  
  /**
   * Destruktor
   */
  ~CBevoelkerungsdichteElement();
};
#endif //CBEVOELKERUNGSDICHTEELEMENT_H
