//------------------------------------------------------------------------------
// Projektname:		Module Datenstruktur
// Dateiname:		CFPlanGraphKnoten.cpp
// Beschreibung:	Knoten Beschriftung des Linienplans
// Autor(en):		Mike Sarnowski
// Version:		0.1
// Gendert von:	Mike Sarnowski
// Gendert am:		19.01.2001
// Zustand:		In Arbeit
//------------------------------------------------------------------------------

#include "CFPlanGraphKnoten.h"

//------------------------------------------------------------------------------
// Funktionsname:	CFPlanGraphKnoten
// Beschreibung:	Default Konstruktuor
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
CFPlanGraphKnoten::CFPlanGraphKnoten(){
  this->knotenID = 0;
}

//------------------------------------------------------------------------------
// Funktionsname:	CFPlanGraphKnoten
// Beschreibung:	Kopier Konstruktor
// Parameter:		Das zu kopierende Objekt
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
CFPlanGraphKnoten::CFPlanGraphKnoten(const CFPlanGraphKnoten& originalBeschriftung){
  this->knotenID = originalBeschriftung.knotenID;
}
    
//------------------------------------------------------------------------------
// Funktionsname:	operator=
// Beschreibung:	= Operator
// Parameter:		Das zu kopierende Objekt
// Rueckgabe:		Zeiger auf das kopierte Objekte
// Besonderheiten:	
//------------------------------------------------------------------------------
CFPlanGraphKnoten CFPlanGraphKnoten::operator= (const CFPlanGraphKnoten& originalBeschriftung){
  if (this!=&originalBeschriftung) {
    this->knotenID = originalBeschriftung.knotenID;
  }
  return *this;
}
    
//------------------------------------------------------------------------------
// Funktionsname:	operator>>
// Beschreibung:	>> Operator
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
istream& operator>> (istream& is, CFPlanGraphKnoten& beschriftung){
  is >> beschriftung.knotenID;
  is.clear();
  return is;
}

//------------------------------------------------------------------------------
// Funktionsname:	operator<<
// Beschreibung:	<< Operator
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
ostream& operator<< (ostream& os, const CFPlanGraphKnoten& beschriftung){
  os << "(" << beschriftung.knotenID << ")";
  return os;
}

//------------------------------------------------------------------------------
// Funktionsname:	setzenID
// Beschreibung:	Setzen-Methode des Attributes knotenID
// Parameter:		ID des Knotens
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CFPlanGraphKnoten::setzenID(int knotenID){
  this->knotenID = knotenID;
}

//------------------------------------------------------------------------------
// Funktionsname:	holenID
// Beschreibung:	Geben-Methode des Attributes knotenID
// Parameter:		
// Rueckgabe:		Knoten ID
// Besonderheiten:	
//------------------------------------------------------------------------------
int CFPlanGraphKnoten::holenID(){
  return this->knotenID;
}
