#ifndef CFAHRPLANELEMENT_H
#define CFAHRPLANELEMENT_H

#include <iostream.h>

class CFahrplanElement {
public:
  
    /**
     * Default Konstruktor
     */
    CFahrplanElement();

    /**
     * Diesem Konstruktor wird ein Fahrplaneintrag uebergeben.
     * 1. Parameter : HaltestellenID
     * 2. Parameter : LinienID
     * 3. Parameter : ID der Linien - Starthaltestelle
     * 4. Parameter : Abfahrtszeit Stunde
     * 5. Parameter : Abfahrtszeit Minute
     */
    CFahrplanElement(int,int,int,int,int);

    /**
     * Kopier Konstruktor
     */
    CFahrplanElement(const CFahrplanElement&);

    /**
     * = Operator
     */
    CFahrplanElement operator= (const CFahrplanElement&);

    /**
     * >> Operator
     */
    friend istream& operator>> (istream&, CFahrplanElement&);

    /**
     * << Operator
     */
    friend ostream& operator<< (ostream&, const CFahrplanElement&);

    /**
     * Setzen-Methode des Attributes haltestellenID
     * Uebergeben wird die HaltestellenID
     */
    void setzenHaltestelle(int);

    /**
     * Setzen-Methode des Attributes linienID und startHaltestellenID
     * Uebergeben wird die LinienID
     */
    void setzenLinie(int);

    /**
     * Setzen-Methode des Attributes startHaltestellenID
     * Uebergeben wird die ID der Starthaltestelle
     */
    void setzenLinienStartHaltestelle(int);
 
    /**
     * Setzen-Methode des Attributes Abfahrtszeittunde
     * Uebergeben wird die Stunde der Abfahrtszeit
     */
    void setzenAbfahrtszeitStunde(int);

    /**
     * Setzen-Methode des Attributes AbfahrtszeitMinute
     * Uebergeben wird die Minute der Abfahrtszeit
     */
    void setzenAbfahrtszeitMinute(int);

    /**
     * Geben-Methode des Attributes haltestellenID
     * Die ID wird zurueckgeliefert
     */
    int gebenHaltestelle();

    /**
     * Geben-Methode des Attributes linienID
     * Die ID der Linie wird zurueckgegeben
     */
    int gebenLinie();

    /**
     * Geben-Methode des Attributes startHaltestellenID
     * Es wird die ID der Haltestelle zurueckgegeben, mit der die Linie beginnt. (Richtung der Linie)
     */
    int gebenLinienStartHaltestelle();

    /**
     * Geben-Methode des Attributes abfahrtszeitStunde
     * Es wird die Stunde der Abfahrtszeit zurueckgegeben
     */
    int gebenAbfahrtszeitStunde();

    /**
     * Geben-Methode des Attributes abfahrtszeitMinute
     * Es wird die Minute der Abfahrtszeit zurueckgegeben
     */
    int gebenAbfahrtszeitMinute();


private:    
    int haltestellenID;
    int linienID;
    int startHaltestelleID;
    int abfahrtszeitStunde;
    int abfahrtszeitMinute;

};
#endif //CFAHRPLANELEMENT_H
