
#include <sys/time.h>
#include "CFortschritt.h"
#include "Debug.h"

#define HINTERGRUND 220,220,220
#define VORDERGRUND 0,0,0
#define INTERVALL_ZEIT 3000
#define INTERVALL_FORTSCHRITT 100

color bunt(int prozent){
	color e;
	if (prozent <= 50) {
		e = color(255,((prozent*255)/50),0);
	} else {
		e = color(255-(((prozent-50)*255)/50),255,0);
	}
	return e;
}

unsigned long getcurrenttime(timeval *zeit) {
	void *blah;
	gettimeofday(zeit,blah);
	unsigned long CurrentTime=((zeit->tv_sec%3153600)*1000+(zeit->tv_usec/1000));
	return CurrentTime;
}


//___________________________________________________________________________

CFortschritt::CFortschritt(const char *titel="Vorgang wird bearbeitet...",bool batch=false) {
  Debug(1,"CFortschritt wird konstruiert\n");
  BatchModus = batch;
  Status = 0;
  Promille = 0;
  timeold=0;
  reset_samples();
  arbeitsSchritt=0;
  CurrentTime=0;
  ElapsedTime=0;
  ETA=0;
  LastUpdateTime=0;
  LastUpdateProgress=0;
  zeit = new struct timeval;
/*  set_item_width(350);
  FortschrittSlider=int_item("Fortschritt: ",Promille,1,1000);
  FortschrittAnalyse = "\\blue 0.0%\\black ELT: \\blue 00:00:00 \\black ETA: \\red n/a";
  FortschrittLabel = text_item(FortschrittAnalyse);
  new_line();
//  separator();
  text_item("\\red \\bf Status:");
  new_line();
  LaufzeitMeldung = text_item("...");
  new_line();
//  separator();
  text_item("\\red \\bf Schritte:");
  new_line();
//  separator();
  for (int zaehler=0;zaehler<5;zaehler++) {
	  schrittFeld[zaehler]=text_item("...");
	  new_line();
  }
//  separator();
*/  
  if(BatchModus) return;
  W=new window(400,240,titel);
  W->set_color(color(VORDERGRUND));
  W->set_bg_color(color(HINTERGRUND));
  W->set_flush(false);
//  start_buffering();
  W->init(0,400,0);
  W->display(W->center,W->center);
  neuzeichnen(true);
//  Debug(2,"CFortschritt ist erfolgreich initialisiert");
} // CFortschritt

//___________________________________________________________________________

CFortschritt::~CFortschritt() {
//	Debug(2,"Zerstoere CFortschritt");
//	stop_buffering();
	delete zeit;
//	Debug(2,"zeit deleted");
	if (BatchModus) return;
	W->close();
	delete W;
	Debug(2,"CFortschritt zerstoert");
} // ~CFortschritt

//___________________________________________________________________________

void CFortschritt::neuzeichnen(bool zwingen=false){
	if (BatchModus) return;
//	Debug(3,"ET: "<<(long)ElapsedTime<<" LUT: "<<(long)LastUpdateTime<<" P: "<<Promille<<" LUP: "<<LastUpdateProgress<<" Z: "<<zwingen);
	if ((labs((long)ElapsedTime-(long)LastUpdateTime) < INTERVALL_ZEIT) && (labs(Promille-LastUpdateProgress)<INTERVALL_FORTSCHRITT) &&!zwingen) return;
//	Debug(3,"Neuzeichnen...");
	LastUpdateTime=ElapsedTime;
	LastUpdateProgress=Promille;
	W->start_buffering();
	W->draw_box(0,0,400,250,color(HINTERGRUND));
	W->draw_rectangle(20,70,380,170); //das Schrittfeld
	W->draw_rectangle(20,220,380,240); //der Fortschrittbalkenkasten
	//draw_rectangle(300,20,350,60); //der Abbrechen-button
	W->draw_box(21,221,((Promille*358)/1000+21),239,color(0,0,255)); //der Fortschrittsbalken
	char fa[LAENGE];
	unsigned int ELTstd, ELTmin, ELTsek, ETAstd, ETAmin, ETAsek;
//	ElapsedTime /= 1000;
//	ETA = (ETA+500)/1000;
//	CurrentTime=getcurrenttime(zeit);
	unsigned long ElapsedTime = (timeold==0 ? 0 : (CurrentTime - timeold) / 1000);
	unsigned long ETA = this->ETA / 1000;
	ELTsek = ElapsedTime%60;
	ELTmin = (ElapsedTime/60)%60;
	ELTstd = ElapsedTime/3600;
	ETAsek = ETA%60;
	ETAmin = (ETA/60)%60;
	ETAstd = ETA/3600;
 	snprintf(fa, LAENGE-1,"Dauer: \\blue %.2d:%.2d:%.2d \\black Verbleibend: \\blue %.2d:%.2d:%.2d",ELTstd,ELTmin,ELTsek,ETAstd,ETAmin,ETAsek);
	FortschrittAnalyse=fa;
	W->text_box(20,380,210,FortschrittAnalyse); //die Fortschrittsanalyse
 	snprintf(fa, LAENGE-1,"%i.%.1d%% ",Promille/10,Promille%10);
	FortschrittAnalyse=fa;
	W->draw_ctext(200,230,FortschrittAnalyse);
	W->draw_text(20,190,LaufzeitMeldung); //die laufzeitmeldung
	W->draw_disc(20,20,10,color(Status*255,Status*255,Status*255));
	
	if ((arbeitsSchritt >= 0) && ((int)arbeitsSchritt<=(schritte.length()-1))) {
		for (int i=0;i<5;i++) {
			string teil("");
			int k=arbeitsSchritt-2+i;
//			Debug(5,"i: "<<i<<"\tk: "<<k);
			if (i==2) { //der aktuelle Schritt soll fett sein und vertikal zentriert
			  teil="\\bf ";
			}
			if ((k>=0) && (k<=(schritte.length()-1))) { //wenn in der Liste
				teil+=schritte.inf(schritte[k]);
//				draw_text(25,71+i*19,teil);
				W->text_box(25,375,71+(5-i)*19,teil);
//				set_text(schrittFeld[i],teil);
//				Debug(6,"Setze Feld "<<k<<"zu "<<teil);
			} else {  //ansonsten leer lassen
//				set_text(schrittFeld[i],"...");
//				Debug(6,"Loesche Feld "<<k);
			}
//			redraw_panel(schrittFeld[i]);
		}
	}
	
	W->flush_buffer();
	W->stop_buffering();
}

//____________________________________________________________________________________

void CFortschritt::anzeigenFortschritt(unsigned long aktuell, unsigned long maximum) {
//  static long timeold;
//	Debug(5,"aktuell: "<<aktuell<<" max: "<<maximum);
	if (BatchModus) return;
  CurrentTime = getcurrenttime(zeit);
  if ((timeold == 0) || (aktuell==0) || (aktuell==1)) { timeold=CurrentTime; reset_samples(); Promille=0;}
  maximum++;
  int stand=(aktuell*1000)/maximum;
  if ((Promille - stand)>500) { 
//	  Debug(5,"UNSAUBERE FORTSCHRITTSWERTE!!");
	  timeold=CurrentTime; reset_samples();
	  }
  //falls wir ploetzlich mit kleinen Werten aufgerufen werden
  Promille= stand;
  
  ElapsedTime=(CurrentTime-timeold);
  unsigned long prediction=do_prediction(ElapsedTime,Promille);
  ETA=prediction-ElapsedTime;
/*  char fa[LAENGE];
  unsigned int ELTstd, ELTmin, ELTsek, ETAstd, ETAmin, ETAsek;
  ElapsedTime /= 1000;
  ETA = (ETA+500)/1000;
  ELTsek = ElapsedTime%60;
  ELTmin = (ElapsedTime/60)%60;
  ELTstd = ElapsedTime/3600;
  ETAsek = ETA%60;
  ETAmin = (ETA/60)%60;
  ETAstd = ETA/3600;
  snprintf(fa, LAENGE-1,"\\blue %i.%.1d%% \\black ELT: \\blue %.2d:%.2d:%.2d \\black ETA: \\blue %.2d:%.2d:%.2d",Promille/10,Promille%10,ELTstd,ELTmin,ELTsek,ETAstd,ETAmin,ETAsek);
  FortschrittAnalyse=fa;
*/  neuzeichnen();
/*  set_text(FortschrittLabel,FortschrittAnalyse);
  redraw_panel(FortschrittLabel);
  redraw_panel(FortschrittSlider);
*///  flush();
  } // anzeigenFortschritt

//___________________________________________________________________________

void CFortschritt::anzeigenFortschrittSteigenderAufwand(unsigned long aktuell, unsigned long maximum) {
//  static long timeold;
	if (BatchModus) return;
//  unsigned long CurrentTime = time(0);
	CurrentTime = getcurrenttime(zeit);
  if ((timeold == 0) || (aktuell==0) || (aktuell==1)) { timeold=CurrentTime; }
//  cout << "\r -|";
  maximum++;
  maximum = Summe(maximum);
  aktuell = Summe(aktuell);
  int stand=(aktuell*1000)/maximum;
  if ((Promille - stand)>500) { timeold=CurrentTime; reset_samples();}
  //falls wir ploetzlich mit kleinen Werten aufgerufen werden
  Promille= stand;
  ElapsedTime=CurrentTime-timeold;
  ETA=(ElapsedTime*(maximum-aktuell)/(aktuell==0 ? 1 : aktuell))+1;
//  ElapsedTime*=1000;
//  ETA*=1000;
//  int ETA=(int)((1/(round(aktuell*1000000/maximum).to_double()/1000000))*ElapsedTime)-ElapsedTime;
/*  char fa[LAENGE];
  unsigned int ELTstd, ELTmin, ELTsek, ETAstd, ETAmin, ETAsek;
  ELTsek = ElapsedTime%60;
  ELTmin = (ElapsedTime/60)%60;
  ELTstd = ElapsedTime/3600;
  ETAsek = ETA%60;
  ETAmin = (ETA/60)%60;
  ETAstd = ETA/3600;
  snprintf(fa, LAENGE-1,"\\blue %i.%.1d%% \\black ELT: \\blue %.2d:%.2d:%.2d \\black ETA: \\blue %.2d:%.2d:%.2d",Promille/10,Promille%10,ELTstd,ELTmin,ELTsek,ETAstd,ETAmin,ETAsek);
  FortschrittAnalyse=fa;  
*/  CurrentTime=getcurrenttime(zeit);
	neuzeichnen();
//  set_text(FortschrittLabel,FortschrittAnalyse);
//  redraw_panel(FortschrittLabel);
//  redraw_panel(FortschrittSlider);
  } // anzeigenFortschritt

//___________________________________________________________________________

void CFortschritt::anzeigenAktivitaet(void) {
	if (BatchModus) return;
	++Status %= 2;
	CurrentTime=getcurrenttime(zeit);
	neuzeichnen(true);
} // anzeigenAktivitaet

//___________________________________________________________________________

void CFortschritt::meldenLaufzeitAusgabe(char* text)
{
	if(BatchModus) {
		cout << text << "\n";
		cout.flush();
		return;
	}
	LaufzeitMeldung=text;
	CurrentTime=getcurrenttime(zeit);
	neuzeichnen();
//	Debug(5,"meldenLaufzeitAusgabe");
/*	set_text(LaufzeitMeldung,text);
	redraw_panel(LaufzeitMeldung);
*/}

//___________________________________________________________________________

void CFortschritt::setzenTeilschritte(unsigned int anzahl, char ** Teilschritte) {
//	Debug(2,"setzenTeilschritte gestartet");
	this->Teilschritte = Teilschritte;
	AnzahlTeilschritte = anzahl;
	if (!schritte.empty()) {
	  schritte.clear();
//	  Debug(6,"schritte geloescht");
	}
	for (unsigned int i=0; i<anzahl; i++) {
	  schritte += Teilschritte[i];
//	  Debug(6,"Fuege hinzu Eintrag "<<Teilschritte[i]<<",Laenge nun "<<schritte.length());
	}
	setzenNaechstenSchritt(0);
//	Debug(2,"setzenTeilschritte ende");
} // setzenTeilschritte

//___________________________________________________________________________

void CFortschritt::setzenNaechstenSchritt(void) {
//	Debug(2,"SetzenNaechstenSchritt(void): ->"<<arbeitsSchritt+1);
	setzenNaechstenSchritt(arbeitsSchritt+1);
} // setzenNaechstenSchritt

//___________________________________________________________________________

void CFortschritt::setzenNaechstenSchritt(unsigned int Schritt) {
//	Debug(2,"setzenNaechstenSchritt("<<Schritt<<") gestartet");
	arbeitsSchritt=Schritt;
	if (BatchModus && (Schritt >= 0) && ((int)Schritt<=(schritte.length()-1))) {
		cout << "--- " << schritte.inf(schritte[Schritt]) << " ---\n";
		cout.flush();
		return;
	}
/*	if ((Schritt >= 0) && ((int)Schritt<=(schritte.length()-1))) {
		for (int i=0;i<5;i++) {
			string teil("");
			int k=Schritt-2+i;
//			Debug(5,"i: "<<i<<"\tk: "<<k);
			if (i==2) { //der aktuelle Schritt soll fett sein und vertikal zentriert
			  teil="\\bf ";
			}
			if ((k>=0) && (k<=(schritte.length()-1))) { //wenn in der Liste
				teil+=schritte.inf(schritte[k]);
//				set_text(schrittFeld[i],teil);
//				Debug(6,"Setze Feld "<<k<<"zu "<<teil);
			} else {  //ansonsten leer lassen
//				set_text(schrittFeld[i],"...");
//				Debug(6,"Loesche Feld "<<k);
			}
//			redraw_panel(schrittFeld[i]);
		}
	}
*/	CurrentTime= getcurrenttime(zeit);
	neuzeichnen(true);
} // setzenNaechstenSchritt

//___________________________________________________________________________

unsigned long int CFortschritt::Summe(unsigned long int Hoechstwert) {
  unsigned long int Summe = ((1+Hoechstwert)*Hoechstwert)/2;
  return Summe;
}

//___________________________________________________________________________

void CFortschritt::reset_samples() {
//	Debug(2,"resetting regression samples");
	for (int i=0;i<NR_SAMPLES;i++) {
		samples[i][0]=0;
		samples[i][1]=0;
	}
	current_sample=0;
}

//___________________________________________________________________________

unsigned long CFortschritt::do_prediction(unsigned long time, int fortschritt) {
//	Debug(2,"predicting with new data: timecode "<<time<<",progress "<<fortschritt<<" at "<<current_sample);
	int stelle=(int)(((long)(NR_SAMPLES*fortschritt)) / 1000);
	samples[stelle][0]=time;
	samples[stelle][1]=fortschritt;
	unsigned long sum_time=0, sum_progress=0;
	for (int i=0;i<NR_SAMPLES;i++){
		sum_time+=samples[i][0];
		sum_progress+=samples[i][1];
	}
	unsigned long average_time = sum_time / NR_SAMPLES;
	unsigned long average_progress = sum_progress / NR_SAMPLES;
//	Debug(6,"at:"<<average_time<<" ap:"<<average_progress);
	unsigned long sum_delta=0,sum_squared_time_delta=0,time_of_completion=0;
	for (int i=0;i<NR_SAMPLES;i++){
		sum_delta+=(samples[i][0]-average_time)*(samples[i][1]-average_progress);
		sum_squared_time_delta+=(samples[i][0]-average_time)*(samples[i][0]-average_time);
	}
	long double a_ls=0.0, b_ls=0.0;
	if (sum_squared_time_delta) {
		b_ls=(long double)sum_delta/(long double)sum_squared_time_delta;
		a_ls=(long double)samples[stelle][1]-b_ls*(long double)samples[stelle][0];
//		Debug (6,"b_ls="<<b_ls<<" a_ls="<<a_ls<<" sum_delta="<<sum_delta<<" sum_std="<<sum_squared_time_delta);
	
		time_of_completion=(unsigned long)((long double)(1000.0-a_ls)/(long double)b_ls);
	} 
	//	Debug(2,"predicted completion at timecode "<<time_of_completion);
	return time_of_completion;
}

