#include "CLeda.h"

//------------------------------------------------------------------------------
// Funktionsname:	pruefenKnotenverbindung()
// Beschreibung:	
// Parameter:	
// Rueckgabe:	
// Besonderheiten:	Der uebergebene Graph enthaelt nur undefinierte Zeiger.
// Autor:		Marc Pompl
//------------------------------------------------------------------------------

bool pruefenKnotenverbindung(GRAPH<void *, void * > * DerGraph, node * knotenVon, node * knotenNach) {
  bool wert = false;
  node * knoten = new node();
  list<node> * knotenliste = new list<node>;
  *knotenliste = DerGraph->adj_nodes(*knotenVon);
  forall(*knoten,*knotenliste) {
    if (DerGraph->inf(*knoten)==DerGraph->inf(*knotenNach)) {
      wert =  true;
      break;
    }
  }
  delete knotenliste;
  delete knoten;
  return wert;
} // pruefenKnotenverbindung

//------------------------------------------------------------------------------
// Funktionsname:	holenKnotenverbindung()
// Beschreibung:	
// Parameter:	
// Rueckgabe:	
// Besonderheiten:	Der uebergebene Graph enthaelt nur undefinierte Zeiger.
// Autor:		Marc Pompl
//------------------------------------------------------------------------------

edge * holenKnotenverbindung(GRAPH<void *, void * > * DerGraph, node * knotenVon, node * knotenNach) {
  edge * wert = NULL;
  edge * kante = new edge();
  node * knoten = new node();
  list<edge> * kantenliste = new list<edge>;
  *kantenliste = DerGraph->out_edges(*knotenVon);
  forall(*kante,*kantenliste) {
    *knoten = DerGraph->target(*kante);
    if (DerGraph->inf(*knoten)==DerGraph->inf(*knotenNach)) {
      wert = new edge(*kante);
      break;
    }
  }
  delete kante;
  delete knoten;
  delete kantenliste;
  return wert;
} // holenKnotenverbindung

//------------------------------------------------------------------------------
// Funktionsname:	holenKnoten()
// Beschreibung:	
// Parameter:	
// Rueckgabe:		Start und Ziel enthalten die zu der Kante gehoerigen Knoten.
// Besonderheiten:	Der uebergebene Graph enthaelt nur undefinierte Zeiger.
// Autor:		Joerg Draeger, Marc Pompl
//------------------------------------------------------------------------------

void holenKnoten(GRAPH<void *, void * > * DerGraph, edge *  AktuelleKante, node * Start, node * Ziel)
{
  /*
   * LEDA bietet die GRAPH-Methoden G.source(edge e) und G.target(edge e)
   * an, um den Anfangs- bzw. Endknoten einer Kante herauszufinden.
   */
  *Start = DerGraph->source(*AktuelleKante);
  *Ziel = DerGraph->target(*AktuelleKante);
} // holenKnoten

