#include <LEDA/graph.h>

/**
 * Gibt zurueck, ob zwischen zwei gegeben Knoten
 * ausgehend von knotenVon zu knotenNach eine Kante
 * existiert.
 *
 * @param DerGraph Der Graph, aus welchem die Knoten entstammen.
 * @param knotenVon Knoten, von welchem aus auf eine Kante geprueft werden soll.
 * @param knotenNach Knoten, zu welchem auf eine Kante geprueft werden soll.
 * @returns true, falls eine Kante existiert, false sonst.
 */
bool pruefenKnotenverbindung(GRAPH<void *, void * > * DerGraph, node * knotenVon, node * knotenNach);

/**
 * Gibt die Verbindung zwischen zwei Knoten zurueck, falls
 * vorhanden.
 *
 * @param DerGraph Der Graph, aus welchem die Knoten entstammen.
 * @param knotenVon Knoten, von welchem aus auf eine Kante geprueft werden soll.
 * @param knotenNach Knoten, zu welchem auf eine Kante geprueft werden soll.
 * @returns Eine edge, falls die Kante existiert, NULL sonst.
 */
edge * holenKnotenverbindung(GRAPH<void *, void * > * DerGraph, node * knotenVon, node * knotenNach);

/**
 * Gibt die zugehoerigen Knoten zur uebergebenen Kante zurueck.
 */
void holenKnoten(edge* AktuelleKante, node * Start, node * Ziel);

