#include "Debug.h"
#include "Fehler.h"
#include "CParameterHaltestelle.h"

CParameterHaltestelle::CParameterHaltestelle(list<list<CPunkt*>*>* Strassennetzliste, list<CPunkt*> * Pflichthaltestellen, list<list<CPunkt*>*> * Wege, list<CBevoelkerungsdichteElement*> * Bevoelkerungsdichtenliste,matrix * QuelleZielMatrix,list<CQuelleZielListeElement*> * QuelleZielListe,matrix * Pendlermatrix,list<CPendlerListeElement* > * Pendlerliste, list<list<CPunkt *> *> * Gebaeudeliste, TAlgorithmus Algorithmustyp=stochastisch,int Zufallszahlengeneratorinitialisierung=-1,double minimalesEinzugsgebiet=150,double maximalesEinzugsgebiet=450,double verbindungsradius=1200,TRadius Radiustyp=luftlinie,double Haltestellenlage=0,double toleranzgrenze=0.5,unsigned int BevoelkerungsrasterEinheiten=10,double koeffizientBevoelkerungsueberversorgung=0.5,double koeffizientBevoelkerungsunterversorgung=0.5,double koeffizientFlaechenueberversorgung=0.5,double koeffizientFlaechenunterversorgung=0.5,double koeffizientFahrtwunscheinbeziehung=0.5,double koeffizientStrassenanpassung=0.5, bool AnzeigenLegende = true, bool AnzeigenStrassennetz = true, bool AnzeigenBevoelkerung = true, bool AnzeigenFlaeche = true) {
	Debug(1,"[CParameterHaltestelle]");
	setzenStrassennetzliste(Strassennetzliste);
	setzenWegeliste(Wege);
	setzenBevoelkerungsdichtenliste(Bevoelkerungsdichtenliste);
	setzenQuelleZielMatrix(QuelleZielMatrix);
	setzenQuelleZielListe(QuelleZielListe);
	setzenPendlermatrix(Pendlermatrix);
	setzenPendlerliste(Pendlerliste);
	setzenGebaeudeliste(Gebaeudeliste);
	setzenAlgorithmustyp(Algorithmustyp);
	setzenZufallszahlengeneratorinitialisierung(Zufallszahlengeneratorinitialisierung);
	setzenMinimalesEinzugsgebiet(minimalesEinzugsgebiet);
	setzenMaximalesEinzugsgebiet(maximalesEinzugsgebiet);
	setzenVerbindungsradius(verbindungsradius);
	setzenRadiustyp(Radiustyp);
	setzenHaltestellenlage(Haltestellenlage);
	setzenToleranzgrenze(toleranzgrenze);
	setzenPflichthaltestellen(Pflichthaltestellen);
	setzenBevoelkerungsrasterEinheiten(BevoelkerungsrasterEinheiten);
	setzenKoeffizientBevoelkerungsueberversorgung(koeffizientBevoelkerungsueberversorgung);
	setzenKoeffizientBevoelkerungsunterversorgung(koeffizientBevoelkerungsunterversorgung);
	setzenKoeffizientFlaechenueberversorgung(koeffizientFlaechenueberversorgung);
	setzenKoeffizientFlaechenunterversorgung(koeffizientFlaechenunterversorgung);
	setzenKoeffizientFahrtwunscheinbeziehung(koeffizientFahrtwunscheinbeziehung);
	setzenKoeffizientStrassenanpassung(koeffizientStrassenanpassung);
	setzenAnzeigenLegende(AnzeigenLegende);
	setzenAnzeigenStrassennetz(AnzeigenStrassennetz);
	setzenAnzeigenBevoelkerung(AnzeigenBevoelkerung);
	setzenAnzeigenFlaeche(AnzeigenFlaeche);
	BatchModus=false;
} // CParameterHaltestelle

CParameterHaltestelle::~CParameterHaltestelle() {
/*
  // Strassenplan
  // wird in CStrassennetz::erzeugenStrassennetzgraph geloescht.

  // Pendlermatrix
  if (Pendlermatrix!=NULL)
    delete Pendlermatrix;
  // Fahrtwunschmatrix
  if (Fahrtwunschmatrix!=NULL)
    delete Fahrtwunschmatrix;
  // Pflichthaltestellen
  if (Pflichthaltestellen!=NULL) {
    for(int i=0; i<Pflichthaltestellen->size(); i++)
      delete Pflichthaltestellen->contents(Pflichthaltestellen->get_item(i));
    delete Pflichthaltestellen;
  }
  // QuelleZielListe
  // QuelleZielMatrix
  if (QuelleZielMatrix!=NULL)
    delete QuelleZielMatrix;
*/
}

void CParameterHaltestelle::laden(const char * Dateiname) {
} // laden

void CParameterHaltestelle::speichern(const char * Dateiname) {
} // speichern

TAlgorithmus CParameterHaltestelle::holenAlgorithmustyp(void) {
	return Algorithmustyp;
}
void CParameterHaltestelle::setzenAlgorithmustyp(TAlgorithmus Algorithmustyp) {
	this->Algorithmustyp = Algorithmustyp;
}
	
int CParameterHaltestelle::holenZufallszahlengeneratorinitialisierung(void) {
	return Zufallszahlengeneratorinitialisierung;
}
void CParameterHaltestelle::setzenZufallszahlengeneratorinitialisierung(int Zufallszahlengeneratorinitialisierung){
	assert(((Zufallszahlengeneratorinitialisierung==-1) || (Zufallszahlengeneratorinitialisierung>=0)));
	this->Zufallszahlengeneratorinitialisierung=Zufallszahlengeneratorinitialisierung;
}

double CParameterHaltestelle::holenMinimalesEinzugsgebiet(void){
	return minimalesEinzugsgebiet;
}
void CParameterHaltestelle::setzenMinimalesEinzugsgebiet(double minimalesEinzugsgebiet){
	assert(minimalesEinzugsgebiet>0);
	this->minimalesEinzugsgebiet=minimalesEinzugsgebiet;
}
	
double CParameterHaltestelle::holenMaximalesEinzugsgebiet(void){
	return maximalesEinzugsgebiet;
}
void CParameterHaltestelle::setzenMaximalesEinzugsgebiet(double maximalesEinzugsgebiet){
	assert(maximalesEinzugsgebiet>minimalesEinzugsgebiet);
	this->maximalesEinzugsgebiet=maximalesEinzugsgebiet;
}
	
double CParameterHaltestelle::holenVerbindungsradius(void){
	return verbindungsradius;
}
void CParameterHaltestelle::setzenVerbindungsradius(double verbindungsradius){
	assert(verbindungsradius>=0);
	this->verbindungsradius=verbindungsradius;
}
	
TRadius CParameterHaltestelle::holenRadiustyp(void){
	return Radiustyp;
}
void CParameterHaltestelle::setzenRadiustyp(TRadius Radiustyp){
	this->Radiustyp=Radiustyp;
}
	
double CParameterHaltestelle::holenHaltestellenlage(void){
	return Haltestellenlage;
}
void CParameterHaltestelle::setzenHaltestellenlage(double Haltestellenlage){
	assert((Haltestellenlage>=0) && (Haltestellenlage<=1));
	this->Haltestellenlage=Haltestellenlage;
}
	
double CParameterHaltestelle::holenToleranzgrenze(void){
	return toleranzgrenze;
}
void CParameterHaltestelle::setzenToleranzgrenze(double toleranzgrenze){
	assert(toleranzgrenze>0);
	this->toleranzgrenze=toleranzgrenze;
}

list<CPunkt*> * CParameterHaltestelle::holenPflichthaltestellen(void){
	return Pflichthaltestellen;
}
void CParameterHaltestelle::setzenPflichthaltestellen(list<CPunkt*> * Pflichthaltestellen){
	assert(Pflichthaltestellen!=NULL);
	this->Pflichthaltestellen=Pflichthaltestellen;
}
	
list<list<CPunkt*>*> * CParameterHaltestelle::holenStrassennetzliste(void){
	return Strassennetzliste;
}
void CParameterHaltestelle::setzenStrassennetzliste(list<list<CPunkt*>*> * Strassennetzliste){
	assert(Strassennetzliste!=NULL);
	this->Strassennetzliste=Strassennetzliste;
}

list<list<CPunkt*>*> * CParameterHaltestelle::holenWegeliste(void){
	return Wegeliste;
}
void CParameterHaltestelle::setzenWegeliste(list<list<CPunkt*>*> * wege){
	assert(wege!=NULL);
	this->Wegeliste=wege;
}
	
unsigned int CParameterHaltestelle::holenBevoelkerungsrasterEinheiten(void){
	return BevoelkerungsrasterEinheiten;
}
void CParameterHaltestelle::setzenBevoelkerungsrasterEinheiten(unsigned int BevoelkerungsrasterEinheiten){
	assert(BevoelkerungsrasterEinheiten>=1);
	this->BevoelkerungsrasterEinheiten=BevoelkerungsrasterEinheiten;
}
	
double CParameterHaltestelle::holenKoeffizientBevoelkerungsueberversorgung(void){
	return koeffizientBevoelkerungsueberversorgung;
}
void CParameterHaltestelle::setzenKoeffizientBevoelkerungsueberversorgung(double koeffizientBevoelkerungsueberversorgung){
	assert((koeffizientBevoelkerungsueberversorgung>=0) && (koeffizientBevoelkerungsueberversorgung<=1));
	this->koeffizientBevoelkerungsueberversorgung=koeffizientBevoelkerungsueberversorgung;
}
	
double CParameterHaltestelle::holenKoeffizientBevoelkerungsunterversorgung(void){
	return koeffizientBevoelkerungsunterversorgung;
}
void CParameterHaltestelle::setzenKoeffizientBevoelkerungsunterversorgung(double koeffizientBevoelkerungsunterversorgung){
	assert((koeffizientBevoelkerungsunterversorgung>=0) && (koeffizientBevoelkerungsunterversorgung<=1));
	this->koeffizientBevoelkerungsunterversorgung=koeffizientBevoelkerungsunterversorgung;
}
	
double CParameterHaltestelle::holenKoeffizientFlaechenueberversorgung(void){
	return koeffizientFlaechenueberversorgung;
}
void CParameterHaltestelle::setzenKoeffizientFlaechenueberversorgung(double koeffizientFlaechenueberversorgung){
	assert((koeffizientFlaechenueberversorgung>=0) && (koeffizientFlaechenueberversorgung<=1));
	this->koeffizientFlaechenueberversorgung=koeffizientFlaechenueberversorgung;
}
	
double CParameterHaltestelle::holenKoeffizientFlaechenunterversorgung(void){
	return koeffizientFlaechenunterversorgung;
}
void CParameterHaltestelle::setzenKoeffizientFlaechenunterversorgung(double koeffizientFlaechenunterversorgung){
	assert((koeffizientFlaechenunterversorgung>=0) && (koeffizientFlaechenunterversorgung<=1));
	this->koeffizientFlaechenunterversorgung=koeffizientFlaechenunterversorgung;
}
	
double CParameterHaltestelle::holenKoeffizientFahrtwunscheinbeziehung(void){
	return koeffizientFahrtwunscheinbeziehung;
}
void CParameterHaltestelle::setzenKoeffizientFahrtwunscheinbeziehung(double koeffizientFahrtwunscheinbeziehung){
	assert((koeffizientFahrtwunscheinbeziehung>=0) && (koeffizientFahrtwunscheinbeziehung<=1));
	this->koeffizientFahrtwunscheinbeziehung=koeffizientFahrtwunscheinbeziehung;
}
	
double CParameterHaltestelle::holenKoeffizientStrassenanpassung(void){
	return koeffizientStrassenanpassung;
}
void CParameterHaltestelle::setzenKoeffizientStrassenanpassung(double koeffizientStrassenanpassung){
	assert((koeffizientStrassenanpassung>=0) && (koeffizientStrassenanpassung<=1));
	this->koeffizientStrassenanpassung=koeffizientStrassenanpassung;
}

bool CParameterHaltestelle::pruefenAnzeigenLegende(void) {
  if (BatchModus) return false;
  return AnzeigenLegende;
}

void CParameterHaltestelle::setzenAnzeigenLegende(bool anzeigen) {
  AnzeigenLegende = anzeigen;
}
	
bool CParameterHaltestelle::pruefenAnzeigenStrassennetz(void) {
  if (BatchModus) return false;
  return AnzeigenStrassennetz;
}

void CParameterHaltestelle::setzenAnzeigenStrassennetz(bool anzeigen) {
  AnzeigenStrassennetz = anzeigen;
}
	
bool CParameterHaltestelle::pruefenAnzeigenBevoelkerung(void) {
  if (BatchModus) return false;
  return AnzeigenBevoelkerung;
}

void CParameterHaltestelle::setzenAnzeigenBevoelkerung(bool anzeigen) {
  AnzeigenBevoelkerung = anzeigen;
}
	
bool CParameterHaltestelle::pruefenAnzeigenFlaeche(void) {
  if (BatchModus) return false;
  return AnzeigenFlaeche;
}

void CParameterHaltestelle::setzenAnzeigenFlaeche(bool anzeigen) {
  AnzeigenFlaeche = anzeigen;
}

bool CParameterHaltestelle::pruefenBatchModus(void)
{
    return BatchModus;
}
void CParameterHaltestelle::setzenBatchModus(bool istbatchmodus=false)
{
    BatchModus=istbatchmodus;
}
		

list<CBevoelkerungsdichteElement*> * CParameterHaltestelle::holenBevoelkerungsdichtenliste(void){
	return Bevoelkerungsdichtenliste;
}
void CParameterHaltestelle::setzenBevoelkerungsdichtenliste(list<CBevoelkerungsdichteElement*> * Bevoelkerungsdichtenliste){
	assert(Bevoelkerungsdichtenliste!=NULL);
	this->Bevoelkerungsdichtenliste=Bevoelkerungsdichtenliste;
}
	
matrix * CParameterHaltestelle::holenQuelleZielMatrix(void){
	return QuelleZielMatrix;
}
void CParameterHaltestelle::setzenQuelleZielMatrix(matrix * QuelleZielMatrix){
	assert(QuelleZielMatrix!=NULL);
	this->QuelleZielMatrix=QuelleZielMatrix;
}
	
list<CQuelleZielListeElement*> * CParameterHaltestelle::holenQuelleZielListe(void){
	return QuelleZielListe;
}
void CParameterHaltestelle::setzenQuelleZielListe(list<CQuelleZielListeElement*> * QuelleZielListe){
	assert(QuelleZielListe!=NULL);
	this->QuelleZielListe=QuelleZielListe;
}
	
matrix * CParameterHaltestelle::holenPendlermatrix(void){
	return Pendlermatrix;
}
void CParameterHaltestelle::setzenPendlermatrix(matrix * Pendlermatrix){
	assert(Pendlermatrix!=NULL);
//	cout << *Pendlermatrix;
	this->Pendlermatrix=Pendlermatrix;
}
	
list<CPendlerListeElement* > * CParameterHaltestelle::holenPendlerliste(void){
	return Pendlerliste;
}
void CParameterHaltestelle::setzenPendlerliste(list<CPendlerListeElement* > * Pendlerliste){
	assert(Pendlerliste!=NULL);
	this->Pendlerliste=Pendlerliste;
}

list<list<CPunkt* > * > * CParameterHaltestelle::holenGebaeudeliste(void){
	return Gebaeudeliste;
}
void CParameterHaltestelle::setzenGebaeudeliste(list<list<CPunkt* > * > * Gebaeudeliste){
	assert(Gebaeudeliste!=NULL);
	this->Gebaeudeliste=Gebaeudeliste;
}

TStrategie CParameterHaltestelle::pruefenStrategie(void) {
	return Strategie;
}

void CParameterHaltestelle::setzenStrategie(TStrategie strategie) {
	Strategie = strategie;
}
	
unsigned int CParameterHaltestelle::pruefenAnzahlEltern(void) {
	return AnzahlEltern;
}

void CParameterHaltestelle::setzenAnzahlEltern(unsigned int anzahl) {
	AnzahlEltern = anzahl;
}
	
unsigned int CParameterHaltestelle::pruefenAnzahlKinder(void) {
	return AnzahlKinder;
}

void CParameterHaltestelle::setzenAnzahlKinder(unsigned int anzahl) {
	AnzahlKinder = anzahl;
}
	
unsigned int CParameterHaltestelle::pruefenAnzahlGenerationen(void) {
	return AnzahlGenerationen;
}

void CParameterHaltestelle::setzenAnzahlGenerationen(unsigned int anzahl) {
	AnzahlGenerationen = anzahl;
}
	
bool CParameterHaltestelle::pruefenWerteunterschreitung(void) {
	return Werteunterschreitung;
}

void CParameterHaltestelle::setzenWerteunterschreitung(bool aktiv) {
	Werteunterschreitung = aktiv;
}
	
double CParameterHaltestelle::pruefenGrenzwert(void) {
	return Grenzwert;
}

void CParameterHaltestelle::setzenGrenzwert(double wert) {
	Grenzwert = wert;
}
	
unsigned int CParameterHaltestelle::holenAnzahlHaltestellen(void) {
	return AnzahlHaltestellen;
}

void CParameterHaltestelle::setzenAnzahlHaltestellen(unsigned int anzahl) {
	AnzahlHaltestellen = anzahl;
}

