/* Generated by Together */

#ifndef CPUNKT_H
#define CPUNKT_H

#include <iostream.h>
#include "Debug.h"

/**
 * Start- und Zielpunkte werden hierber definiert. 
 */
class CPunkt {
public:

    /**
     * Konstruktor, welcher das Setzen der Koordinaten
     * uebernimmt.
     * @param xKoordinate X-Koordinate des zu erzeugenden Punktes.
     * @param yKoordinate Y-Koordinate des zu erzeugenden Punktes.
     */
    CPunkt(double xKoordinate, double yKoordinate);

    /**
     * << Operator
     */
    friend ostream& operator<< (ostream&, const CPunkt&);

    /**
     * Setze das Koordinatenpaar des Punktes 
     * @param xKoordinate X-Koordinate des zu setzenden Punktes.
     * @param yKoordinate Y-Koordinate des zu setzenden Punktes.
     */
    void setzen(double xKoordinate, double yKoordinate);

    /**
     * Gibt das Koordinatenpaar des Punktes als Zeiger zurueck 
     * @param xKoordinate X-Koordinate des zu ermittelnden Punktes.
     * @param yKoordinate Y-Koordinate des zu ermittelnden Punktes.
     */
    void holen(double * xKoordinate, double * yKoordinate);
    
    /**
     * Gibt das Koordinatenpaar des Punktes zurueck 
     * @param xKoordinate X-Koordinate des zu ermittelnden Punktes.
     * @param yKoordinate Y-Koordinate des zu ermittelnden Punktes.
     */
    void holen(double& x, double& y);

    /**
     * Gibt den X-Wert des Punktes zurueck 
     */	
    double holenX();
    /**
     * Gibt den Y-Wert des Punktes zurueck 
     */	
    double holenY();


    /**
     * Konstruktor.
     * Setzt die Position auf (0/0).
     */
         CPunkt(void);
	
    /**
     * Kopierkonstruktor
     */
         CPunkt(const CPunkt& originalBeschriftung);

    /**
     * Destruktor
     */
        ~CPunkt();

private:
    /**
     * X-Koordiante des Punktes.
     */
    double xKoordinate;

    /**
     * Y-Koordiante des Punktes.
     */
    double yKoordinate;
};
#endif //CPUNKT_H
