//------------------------------------------------------------------------------
// Projektname:		Modul - Fahrplan
// Dateiname:		CKantenBeschriftung.cpp
// Beschreibung:	Attribute, die den Kanten im Transportkettengraph zugeordnet werden
// Autor(en):		Mike Sarnowski
// Version:		0.2
// Gendert von:	Michael Wintergerst
// Gendert am:		22.01.2001; neuer Konstruktor
// Zustand:		Erste Version
//------------------------------------------------------------------------------

#include "CReisebewertung.h"


//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
CReisebewertung::CReisebewertung(){
  this->fahrzeit = 0;
  this->wartezeit = 0;
  this->anzahlDerUmstiege = 0;
  this->idealeFahrzeit = 0.0;
  this->reiseweg = list<three_tuple<int,int,int> >();
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
CReisebewertung::~CReisebewertung(){
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
CReisebewertung::CReisebewertung(const CReisebewertung& reisebewertungOriginal){
  this->fahrzeit = reisebewertungOriginal.fahrzeit;
  this->wartezeit = reisebewertungOriginal.wartezeit;
  this->anzahlDerUmstiege = reisebewertungOriginal.anzahlDerUmstiege;
  this->idealeFahrzeit = reisebewertungOriginal.idealeFahrzeit;
  this->reiseweg = reisebewertungOriginal.reiseweg;
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
istream& operator>> (istream& instream, CReisebewertung& reisebewertung){
  instream >> reisebewertung.fahrzeit >> reisebewertung.wartezeit >> reisebewertung.anzahlDerUmstiege >> reisebewertung.idealeFahrzeit;
  instream.clear(); 
  return instream;
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
ostream& operator<< (ostream& outstream, const CReisebewertung& reisebewertung){
  outstream << "\nAusgabe Reisebewertung!";
  return outstream;
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
CReisebewertung& CReisebewertung::operator=(const CReisebewertung& reisebewertungOriginal){
  this->fahrzeit = reisebewertungOriginal.fahrzeit;
  this->wartezeit = reisebewertungOriginal.wartezeit;
  this->anzahlDerUmstiege = reisebewertungOriginal.anzahlDerUmstiege;
  this->idealeFahrzeit = reisebewertungOriginal.idealeFahrzeit;
  this->reiseweg = reisebewertungOriginal.reiseweg;
  return *this;
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CReisebewertung::setzenFahrzeit(int fahrzeit){
  this->fahrzeit = fahrzeit;
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
int CReisebewertung::gebenFahrzeit(){
  return this->fahrzeit;
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CReisebewertung::setzenWartezeit(int wartezeit){
  this->wartezeit = wartezeit;
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
int CReisebewertung::gebenWartezeit(){
  return this->wartezeit;
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CReisebewertung::setzenAnzahlDerUmstiege(int umstiege){
  this->anzahlDerUmstiege = umstiege;
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
int CReisebewertung::gebenAnzahlDerUmstiege(){
  return this->anzahlDerUmstiege;
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CReisebewertung::setzenIdealeFahrzeit(double idealeFahrzeit){
  this->idealeFahrzeit = idealeFahrzeit;
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
double CReisebewertung::gebenIdealeFahrzeit(){
  return this->idealeFahrzeit;
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CReisebewertung::setzenReiseweg(list<three_tuple<int,int,int> > reiseweg){
  this->reiseweg = reiseweg;
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
list<three_tuple<int,int,int> > CReisebewertung::gebenReiseweg(){
  return this->reiseweg;
}
