#ifndef CREISEBEWERTUNG_H
#define CREISEBEWERTUNG_H

#include <LEDA/list.h>
#include <LEDA/tuple.h>

/**
 * Bei dieser Klasse handelt es sich um eine Sammelstelle fuer Fahrplan Guetemasse
 */

class CReisebewertung {

    public:
        /**
         * Default Konstruktor
         */
        CReisebewertung();

        /**
         * Default Destruktor
         */
	~CReisebewertung();

        /**
	 * Kopier-Konstruktor
	 */
        CReisebewertung(const CReisebewertung&);

	/**
	 * >> Operator
	 */
	friend istream& operator>> (istream&, CReisebewertung&);

	/**
	 * << Operator
	 */
	friend ostream& operator<< (ostream&, const CReisebewertung&);

	/**
	 * = Operator
	 */
	CReisebewertung& operator=(const CReisebewertung&);

	void setzenFahrzeit(int);

	int gebenFahrzeit();

	void setzenWartezeit(int);

	int gebenWartezeit();

	void setzenAnzahlDerUmstiege(int);

	int gebenAnzahlDerUmstiege();

	void setzenIdealeFahrzeit(double);

	double gebenIdealeFahrzeit();

	void setzenReiseweg(list<three_tuple<int,int,int> >);

	list<three_tuple<int,int,int> > gebenReiseweg();

    private: // Attribute

	/**
	 * reine Busfahrzeit
	 */
	int fahrzeit;
	
	/**
	 * Wartezeit zusammengesetzt aus Haltezeiten, Umsteigezeiten und netzbedingten Wartezeiten
	 */
	int wartezeit;

	/**
	 * Die Anzahl der Umsteigeaktionen waehrend der Reise
	 */
	int anzahlDerUmstiege;
	
	/**
	 * Die Fahrzeit im Idealfall. Also wenn mann sich nicht an die Linien halten muss
	 */
	double idealeFahrzeit; // Entspricht der Autofahrzeit

	/**
	 * In dieser Liste steht die Reihenfolge der Reise beschrieben durch ein Thrre_Tuple
	 * mit LinieVon,Haltestelle,LinieNach.
	 */
	list<three_tuple<int,int,int> > reiseweg;
};
#endif //CREISEBEWERTUNG_H
