#ifndef DEBUG_H
#define DEBUG_H

#include "../Datenstruktur/Fehler.h"
#include <iostream.h>
#include "define.h"

//#ifdef DEBUG

/**
 * Dient dem Ausgeben von Debuginformationen.
 *
 * Die Level sind hierbei wie folgt definiert:
 *
 * ...
 *
 *
 * @param level Level, bis dem die Meldung ausgegeben werden soll.
 * @param debugtext Auszugebende Meldung.
 */
//void Debug(int level, char * debugtext);

#define DEBUG_KEINE_MELDUNG 0
#define DEBUG_OBJEKT 1
#define DEBUG_METHODE 2
#define DEBUG_METHODE_FUNDAMENTAL 2
#define DEBUG_METHODE_HILFE 3
#define DEBUG_METHODE_SUB 4
#define DEBUG_ALGO 5
#define DEBUG_ALGORITHMUS 5
#define DEBUG_ALGORITHMUS_DETAIL 6
#define DEBUG_RESERVIERT 7
#define DEBUG_ALGORITHMEN_SUB 8
#define DEBUG_ALLES 9 


//#define DEBUG_LEVEL 9   ==> ab jetzt in define.h
#define Debug(a,b) if(a<=DEBUG_LEVEL){cerr<<"[DEBUG:"<<__FILE__<<":"<<__LINE__<<"] ";if(a==1)cerr<<"[Objekt ] ";if(a==2)cerr<<"[MetFund] ";if(a==3)cerr<<"[MetHilf] ";if(a==4)cerr<<"[MetRest] ";if(a==5)cerr<<"[AlgoStE] ";if(a==6)cerr<<"[AlgoDet] ";if(a==7)cerr<<"[reservd] ";if(a==8)cerr<<"[AlgoSub] ";if(a==9)cerr<<"[rest   ] ";cerr<<b<<endl;cerr.flush();}

//#else
//#define Debug(a,b)
//#endif //DEBUG

#define Error(a) cerr << "Fehler: " << a << "\n"; cerr.flush();

/**
 * Gibt eine kurze Meldung aus und wartet auf das Druecken einer Taste.
 */
void wartenTaste(void);

#endif //DEBUG_H






