#ifndef CENTSCHEIDUNGSBAUMVERFAHREN_H
#define CENTSCHEIDUNGSBAUMVERFAHREN_H

#include "CLoesungsgenerator.h"
#include "Debug.h"
#include "CKantenBeschriftung.h"
#include "CKnotenBeschriftung.h"
#include <LEDA/graph.h>
#include <LEDA/tuple.h>
#include <LEDA/h_array.h>

/**
 * In dieser Klasse ist die Fahrplangenerierung per Entscheidungsbaumverfahren
 * implementiert
 */
class CEntscheidungsbaumverfahren : public CLoesungsgenerator {
 public:
  /**
   * Konstruktor des Entscheidungsbaumverfahrens. Der erste Wert gibt die ZusammenhangskomponentenID an
   */
  CEntscheidungsbaumverfahren(int,CTransportkettengraph*,int);

  /**
   * Destruktor der Klasse CEntscheidungsbaumverfahren
   */
  ~CEntscheidungsbaumverfahren();

  /**
   * Mit dieser Methode wird die Berechnung gestartet
   * holen alle Kanten der Zusammenhangskomponente
   * Berechne alle Kanten mit festerBindung
   * Setzen Maximalgeruest
   * Berechnen Maximalgeruest
   */
  void starten();

  /**
   * Mit dieser Methode  wird die Berechnung kontrolliert gestoppt.
   */
  void stoppen();

 private:
  int baumtiefe;
};

#endif //CENTSCHEIDUNGSBAUMVERFAHREN_H



