//------------------------------------------------------------------------------
// Projektname:		Modul - Fahrplan
// Dateiname:		CKantenBeschriftung.cpp
// Beschreibung:	Attribute, die den Kanten im Transportkettengraph zugeordnet werden
// Autor(en):		Mike Sarnowski
// Version:		0.2
// Gendert von:	Michael Wintergerst
// Gendert am:		22.01.2001; neuer Konstruktor
// Zustand:		Erste Version
//------------------------------------------------------------------------------

#include "CKantenBeschriftung.h"

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
CKantenBeschriftung::CKantenBeschriftung (int kantenID,
					  int verkehrsstrom=0, bool istUmsteigeKante=false) {
  this->kantenID = kantenID;
  this->verkehrsstrom = verkehrsstrom;
  this->festeBindung = false;
  this->imMaximalgeruest = false;
  this->positionInSimplextableau = -1;
  this->netzbedingteWartezeit = 0;
  this->mindestHaltezeit = 0;
  this->mindestUmsteigezeit = 0;
  this->istUmsteigekante = istUmsteigeKante;
}
        
//------------------------------------------------------------------------------
// Funktionsname:       CKantenBeschriftung
// Beschreibung:	Kopier-Konstrukt der Klasse CKantenBeschriftung
// Parameter:		Objekt, das kopiert werden soll
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
CKantenBeschriftung::CKantenBeschriftung(const CKantenBeschriftung& kantenBeschriftungOriginal){
  this->verkehrsstrom = kantenBeschriftungOriginal.verkehrsstrom;
  this->festeBindung = kantenBeschriftungOriginal.festeBindung;
  this->imMaximalgeruest = kantenBeschriftungOriginal.imMaximalgeruest;
  this->kantenID = kantenBeschriftungOriginal.kantenID;
  this->positionInSimplextableau = kantenBeschriftungOriginal.positionInSimplextableau;
  this->netzbedingteWartezeit = kantenBeschriftungOriginal.netzbedingteWartezeit;
  this->mindestHaltezeit = kantenBeschriftungOriginal.mindestHaltezeit;
  this->mindestUmsteigezeit = kantenBeschriftungOriginal.mindestUmsteigezeit;
  this->istUmsteigekante = kantenBeschriftungOriginal.istUmsteigekante;
}

//------------------------------------------------------------------------------
// Funktionsname:	operator=
// Beschreibung:	Hier wird der = Operator ueberladen
// Parameter:		Linke Operant des = Operators
// Rueckgabe:		Rechte Operant des = Operators
// Besonderheiten:	
//------------------------------------------------------------------------------
CKantenBeschriftung& CKantenBeschriftung::operator=(const CKantenBeschriftung& kantenBeschriftungOriginal){
  this->verkehrsstrom = kantenBeschriftungOriginal.verkehrsstrom;
  this->festeBindung = kantenBeschriftungOriginal.festeBindung;
  this->imMaximalgeruest = kantenBeschriftungOriginal.imMaximalgeruest;
  this->kantenID = kantenBeschriftungOriginal.kantenID;
  this->positionInSimplextableau = kantenBeschriftungOriginal.positionInSimplextableau;
  this->netzbedingteWartezeit = kantenBeschriftungOriginal.netzbedingteWartezeit;
  this->mindestHaltezeit = kantenBeschriftungOriginal.mindestHaltezeit;
  this->mindestUmsteigezeit = kantenBeschriftungOriginal.mindestUmsteigezeit;
  this->istUmsteigekante = kantenBeschriftungOriginal.istUmsteigekante;
  return *this;
}
	
//------------------------------------------------------------------------------
// Funktionsname:	operator>>
// Beschreibung:	Hier wird der >> Operator ueberladen
// Parameter:		Linke Operant des >> Operators
// Rueckgabe:		Rechte Operant des >> Operators
// Besonderheiten:	
//------------------------------------------------------------------------------
istream& operator>> (istream& instream, CKantenBeschriftung& beschriftung){
  instream >> beschriftung.kantenID >> beschriftung.verkehrsstrom;
  instream.clear(); 
  return instream;
}
	
//------------------------------------------------------------------------------
// Funktionsname:	operator<<
// Beschreibung:	Hier wird der << Operator ueberladen
// Parameter:		Linke Operant des << Operators
// Rueckgabe:		Rechte Operant des << Operators
// Besonderheiten:	
//------------------------------------------------------------------------------
ostream& operator<< (ostream& outstream, const CKantenBeschriftung& beschriftung){
  outstream << "(" << beschriftung.kantenID << "," << beschriftung.verkehrsstrom << "," << beschriftung.istUmsteigekante << "," << beschriftung.mindestHaltezeit << "," << beschriftung.mindestUmsteigezeit << "," <<  beschriftung.positionInSimplextableau << ")"; 
  return outstream;
}

//------------------------------------------------------------------------------
// Funktionsname:	setzenIstUmsteigekante
// Beschreibung:	Setzen-Methode des Attributes istUmsteigekante
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	Wird die Methode aufgerufen, so wird das Attribut stezenIstUmsteigekante
//                      immer auf true gesetzt
//------------------------------------------------------------------------------
void CKantenBeschriftung::setzenIstUmsteigekante() {
  this->istUmsteigekante = true;
}

//------------------------------------------------------------------------------
// Funktionsname:	setzenVerkehrsstrom
// Beschreibung:	Setzen-Methode des Attributes verkehrsstrom
// Parameter:		Es wird der Verkehrsstrom der Kante uebergeben
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CKantenBeschriftung::setzenVerkehrsstrom(int verkehrsstrom) {
  this->verkehrsstrom = verkehrsstrom;
}

//------------------------------------------------------------------------------
// Funktionsname:	setzenFesteVerbindung
// Beschreibung:	Setzen-Methode des Attributes festeBindung
// Parameter:		Es wird ein Boolean uebergeben, der besagt, ob die Kante 
//                      gekennzeichnet werden soll oder nicht
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CKantenBeschriftung::setzenFesteVerbindung(bool setzen) {
  this->festeBindung = setzen;
}


//------------------------------------------------------------------------------
// Funktionsname:	abfragenFesteVerbindung
// Beschreibung:	Geben-Methode des Attributes festeBindung
// Parameter:		
// Rueckgabe:		Gibt den Wert des Attributes zurueck
// Besonderheiten:	
//------------------------------------------------------------------------------
bool CKantenBeschriftung::abfragenFesteVerbindung() {
  return this->festeBindung;
}

//------------------------------------------------------------------------------
// Funktionsname:	abfragenVerkehrsstrom
// Beschreibung:	Geben-Methode des Attributes verkehrsstrom
// Parameter:		
// Rueckgabe:		Gibt den Wert des Attributes zurueck
// Besonderheiten:	
//------------------------------------------------------------------------------
int CKantenBeschriftung::abfragenVerkehrsstrom() {
  return this->verkehrsstrom;
}

//------------------------------------------------------------------------------
// Funktionsname:	gebenImMaximalgeruest
// Beschreibung:	Geben-Methode des Attributes imMaximalgeruest
// Parameter:		
// Rueckgabe:		Gibt den Wert des Attributes zurueck
// Besonderheiten:	
//------------------------------------------------------------------------------
bool CKantenBeschriftung::gebenImMaximalgeruest() {
  return this->imMaximalgeruest;
}

//------------------------------------------------------------------------------
// Funktionsname:	setzenImMaximalgeruest
// Beschreibung:	Setzen-Methode des Attributes imMaximalgeruest
// Parameter:		Es wird ein Boolean uebergeben, der besagt, ob die Kante im
//                      Maximalgeruest liegt oder nicht.
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CKantenBeschriftung::setzenImMaximalgeruest(bool setzen) {
  this->imMaximalgeruest = setzen;
}

//------------------------------------------------------------------------------
// Funktionsname:	setzenKantenID
// Beschreibung:	Setzen-Methode des Attributes kantenID
// Parameter:		Es wird die ID der Kante uebergeben
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CKantenBeschriftung::setzenKantenID(int id) {
  this->kantenID = id;
}

//------------------------------------------------------------------------------
// Funktionsname:	gebenKantenID
// Beschreibung:	Geben-Methode des Attributes kantenID
// Parameter:		
// Rueckgabe:		Gibt den Wert des Attributes zurueck
// Besonderheiten:	
//------------------------------------------------------------------------------
int CKantenBeschriftung::gebenKantenID () {
  return this->kantenID;
}
       
//------------------------------------------------------------------------------
// Funktionsname:	setzenPositionImSimplexTableau
// Beschreibung:	Setzen-Methode des Attributes positionInSimplextablea
// Parameter:		Es wird die Position der Kante im Simplextableau uebergeben
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CKantenBeschriftung::setzenPositionImSimplexTableau(int position) {
  this->positionInSimplextableau = position;
}

//------------------------------------------------------------------------------
// Funktionsname:	gebenPositionImSimplexTableau
// Beschreibung:	Geben-Methode des Attributes positionInSimplextableau
// Parameter:		
// Rueckgabe:		Gibt den Wert des Attributes zurueck
// Besonderheiten:	
//------------------------------------------------------------------------------
int CKantenBeschriftung::gebenPositionImSimplexTableau () {
  return this->positionInSimplextableau;
}

//------------------------------------------------------------------------------
// Funktionsname:	gebenNetzbedingteWartezeit
// Beschreibung:	Geben-Methode des Attributes netzbedingteWartezeit
// Parameter:		
// Rueckgabe:		Gibt den Wert des Attributes zurueck
// Besonderheiten:	
//------------------------------------------------------------------------------
int CKantenBeschriftung::gebenNetzbedingteWartezeit () {
  return this->netzbedingteWartezeit;
}

//------------------------------------------------------------------------------
// Funktionsname:	gebenMindestHaltezeit
// Beschreibung:	Geben-Methode des Attributes mindestHaltezeit
// Parameter:		
// Rueckgabe:		Gibt den Wert des Attributes zurueck
// Besonderheiten:	
//------------------------------------------------------------------------------
int CKantenBeschriftung::gebenMindestHaltezeit () {
  return this->mindestHaltezeit;
}

//------------------------------------------------------------------------------
// Funktionsname:	gebenMindestUmsteigezeit
// Beschreibung:	Geben-Methode des Attributes mindestUmsteigezeit
// Parameter:		
// Rueckgabe:		Gibt den Wert des Attributes zurueck
// Besonderheiten:	
//------------------------------------------------------------------------------
int CKantenBeschriftung::gebenMindestUmsteigezeit () {
  return this->mindestUmsteigezeit;
}

//------------------------------------------------------------------------------
// Funktionsname:	setzenNetzbedingteWartezeit
// Beschreibung:	Setzen-Methode des Attributes netzbedingteWartezeit
// Parameter:		Es wird die netzbedingte Wartezeit uebergeben
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CKantenBeschriftung::setzenNetzbedingteWartezeit (int wartezeit) {
  this->netzbedingteWartezeit = wartezeit;
}

//------------------------------------------------------------------------------
// Funktionsname:	setzenMindestHaltezeit
// Beschreibung:	Setzen-Methode des Attributes mindestWartezeit
// Parameter:		Es wird die mindest Haltezeit uebergeben
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CKantenBeschriftung::setzenMindestHaltezeit (int wartezeit) {
  this->mindestHaltezeit = wartezeit;
}

//------------------------------------------------------------------------------
// Funktionsname:	setzenMindestUmsteigezeit
// Beschreibung:	Setzen-Methode des Attributes mindestUmsteigezeit
// Parameter:		Es wird die mindest Wartezeit uebergeben
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CKantenBeschriftung::setzenMindestUmsteigezeit (int wartezeit) {
  this->mindestUmsteigezeit = wartezeit;
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
int CKantenBeschriftung::gebenWartezeit(){
    return this->mindestHaltezeit + this->mindestUmsteigezeit + this->netzbedingteWartezeit;
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
bool CKantenBeschriftung::gebenIstUmsteigekante () {
  return this->istUmsteigekante;
}

bool CKantenBeschriftung::istNichtImMaximalgeruest(){
  return this->nichtImMaximalgeruest;
}

void CKantenBeschriftung::setzenNichtImMaximalgeruest(bool austragen){
  this->nichtImMaximalgeruest = austragen;
}

bool CKantenBeschriftung::gebenMussInsMaximalgeruest(){
    return this->mussInsMaximalgeruest;
}

void CKantenBeschriftung::setzenMussInsMaximalgeruest(bool eintragen){
    this->mussInsMaximalgeruest = eintragen;
}



