//------------------------------------------------------------------------------
// Projektname:		Fahrplan-Modul
// Dateiname:	        CKnotenBeschriftung.cpp
// Beschreibung:	Beschreibung der Knotenklasse des Transportkettengraphen
// Autor(en):		Michael Wintergerst
// Version:		0.1
// Gendert von:       
// Gendert am:		
// Zustand:		Erst-Version      
//------------------------------------------------------------------------------

#include "CKnotenBeschriftung.h"

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
CKnotenBeschriftung::CKnotenBeschriftung () {
  this->tempVerkehrsstrom = 0;
  this->knotenID = 0;
  this->abfahrtzeit = 0;
  this->fahrzeit = 0;
  this->liniennummer = 0;
  this->haltestellenID1 = 0;
  this->haltestellenID2 = 0;
  this->fahrplanzeitGesetzt = false;
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
CKnotenBeschriftung::CKnotenBeschriftung (int knotenID,
					  int liniennr=0,
					  int haltestellenID1=0,
					  int haltestellenID2=0,
					  int fahrzeit=0) {
  this->tempVerkehrsstrom = 0;
  this->knotenID = knotenID;
  this->abfahrtzeit = 0;
  this->fahrzeit = fahrzeit;
  this->liniennummer = liniennr;
  this->haltestellenID1 = haltestellenID1;
  this->haltestellenID2 = haltestellenID2;
}

//------------------------------------------------------------------------------
// Funktionsname: CKnotenBeschriftung	
// Beschreibung: Copy-Konstruktor	
// Parameter: Referenz auf eine Instanz von CKnotenBeschriftung		
// Rueckgabe: void		
// Besonderheiten: Elementweises Kopieren	
//------------------------------------------------------------------------------
CKnotenBeschriftung::CKnotenBeschriftung (const CKnotenBeschriftung& copy) {
  this->tempVerkehrsstrom = copy.tempVerkehrsstrom;
  this->knotenID = copy.knotenID;
  this->abfahrtzeit = copy.abfahrtzeit;
  this->fahrzeit = copy.fahrzeit;
  this->liniennummer = copy.liniennummer;
  this->haltestellenID1 = copy.haltestellenID1;
  this->haltestellenID2 = copy.haltestellenID2;
}

//------------------------------------------------------------------------------
// Funktionsname: operator=	
// Beschreibung: Zuweisungsoperator	
// Parameter: Referenz auf eine Instanz von CKnotenBeschriftung		
// Rueckgabe: Referenz auf eine Instanz von CKnotenBeschriftung		
// Besonderheiten: Elementweises Kopieren; Beachtung bei a=a Zuweisung	
//------------------------------------------------------------------------------
CKnotenBeschriftung& CKnotenBeschriftung::operator= (const CKnotenBeschriftung& copy) {
  if (this != &copy) {
    this->liniennummer = copy.liniennummer;
    this->knotenID = copy.knotenID;
    this->tempVerkehrsstrom = copy.tempVerkehrsstrom;
    this->haltestellenID1 = copy.haltestellenID1;
    this->haltestellenID2 = copy.haltestellenID2;
    this->fahrzeit = copy.fahrzeit;
    this->abfahrtzeit = copy.abfahrtzeit;
  }
  return *this;
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
int CKnotenBeschriftung::gebenKnotenID () {
  return this->knotenID;
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
int CKnotenBeschriftung::gebenTempVerkehrsstrom () {
  return this->tempVerkehrsstrom;
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
int CKnotenBeschriftung::ausgebenHaltestellenID1 () {
  return this->haltestellenID1;
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
int CKnotenBeschriftung::ausgebenHaltestellenID2 () {
  return this->haltestellenID2;
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
int CKnotenBeschriftung::ausgebenLiniennummer () {
  return this->liniennummer;
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
int CKnotenBeschriftung::ausgebenFahrzeit () {
  return this->fahrzeit;
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
int CKnotenBeschriftung::ausgebenAbfahrtzeit () {
  return this->abfahrtzeit;
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//-----------------------------------------------------------------------------
void CKnotenBeschriftung::setzenTempVerkehrsstrom(int verkehrsstrom) {
  this->tempVerkehrsstrom = verkehrsstrom;
}
        
//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//-----------------------------------------------------------------------------
void CKnotenBeschriftung::setzenHaltestellenID1 (int id) {
  this->haltestellenID1 = id;
} 

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//-----------------------------------------------------------------------------
void CKnotenBeschriftung::setzenHaltestellenID2 (int id) {
  this->haltestellenID2 = id;
}  

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//-----------------------------------------------------------------------------
void CKnotenBeschriftung::setzenLiniennummer (int nummer) {
  this->liniennummer = nummer;
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//-----------------------------------------------------------------------------
void CKnotenBeschriftung::setzenFahrzeit (int fahrzeit) {
  this->fahrzeit = fahrzeit;
} 

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//-----------------------------------------------------------------------------
void CKnotenBeschriftung::setzenAbfahrtzeit (int fahrzeit) {
  this->abfahrtzeit = fahrzeit;
  this->fahrplanzeitGesetzt = true;
} 

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//-----------------------------------------------------------------------------
void CKnotenBeschriftung::setzenKnotenID (int id) {
  this->knotenID = id;
} 

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------

istream& operator>> (istream& is, CKnotenBeschriftung& beschriftung) {
  is >> beschriftung.knotenID >> beschriftung.liniennummer >> beschriftung.haltestellenID1 >> beschriftung.haltestellenID2 >> beschriftung.abfahrtzeit >> beschriftung.fahrzeit;
  is.clear();
  return is;
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
ostream& operator<< (ostream& os, const CKnotenBeschriftung& beschriftung) {
  os << "(" << beschriftung.knotenID << "," << beschriftung.liniennummer << "," << beschriftung.haltestellenID1 << "," << beschriftung.haltestellenID2 << "," 
     << beschriftung.abfahrtzeit << "," << beschriftung.fahrzeit << ")";
  return os;
}

void CKnotenBeschriftung::initialisierenFahrplanzeitGesetzt(){
    this->fahrplanzeitGesetzt = false;
}

bool CKnotenBeschriftung::ausgebenFahrplanzeitGesetzt(){
    return this->fahrplanzeitGesetzt;
}
