//------------------------------------------------------------------------------
// Projektname:		Fahrplan-Modul
// Dateiname:		CTransportkettengraph
// Beschreibung:	
// Autor(en):		Michael Wintergerst
// Version:		0.1
// Gendert von:       
// Gendert am:		
// Zustand:	       	Teil-Erst-Version
//------------------------------------------------------------------------------

#include"CTransportkettengraph.h"

//------------------------------------------------------------------------------
// Funktionsname: CTransportkettengraph	
// Beschreibung: Konstruktor, der Umbau des uebergegebenen Graphen steuert	
// Parameter: Referenz auf parametrisierten Graph "Netz der Transportverbindungen"
// Rueckgabe: void		
// Besonderheiten:	
//------------------------------------------------------------------------------
CTransportkettengraph::CTransportkettengraph(GRAPH<CFPlanGraphKnoten*, CFPlanGraphKante*>* NetzDerTransportverbindungen){

  //  this->ZeichnenNetzDerTransportverbindungen (NetzDerTransportverbindungen);

  Debug (1, "[CLASS::] CTransportkettengraph()");
  this->transportkettengraph = new GRAPH<CKnotenBeschriftung*, CKantenBeschriftung*>;
  Debug (2, "CTransportkettengraph::umbauen()");
  this->umbauenTransportkettengraph (NetzDerTransportverbindungen);

  //  this->ZeichnenTransportkettengraph ();

  Debug (2, "CTransportkettengraph::reduzierenTransportkettengraph()");
  this->reduzierenTransportkettengraph();
  Debug (2, "CTransportkettengraph::berechnenZusammenhangskomponenten()");
  this->berechnenZusammenhangskomponenten();
  Debug (2, "CTransportkettengraph::berechnenZklomatischeZahl()");
  this->berechnenZyklomatischeZahl ();
  //this->ausgebenTGraph();

  //  this->ZeichnenZusammenhangskomponente ();
} // ende konstruktor

//------------------------------------------------------------------------------
// Funktionsname:	~CTransportkettengraph
// Beschreibung:	Destruktor
// Parameter:		keine
// Rueckgabe:		keine
// Besonderheiten:	keine
//------------------------------------------------------------------------------
CTransportkettengraph::~CTransportkettengraph () {
  node currentNode;
  edge currentEdge;
  CKantenBeschriftung* informationCurrentEdge;
  CKnotenBeschriftung* informationCurrentNode;
  
  Debug (2, "CTransportkettengraph::~CTransportkettengraph()");

  // loeschen der zusammenhangskompoenten
  // iteration ueber alle zusammenhangskomponenten
  if (this->FeldDerZusammenhangskomponenten) {
    for(int i=0; i < FeldDerZusammenhangskomponenten->size(); i++){
      if (FeldDerZusammenhangskomponenten->get(i) != 0) {
	delete FeldDerZusammenhangskomponenten->get(i); 
      }
    } // ende iteration ueber alle zusammenhangskomponenten
  }

  // loeschen transportkettengraph
  // iteration ueber alle kanten
  if (this->transportkettengraph != 0) { 
    forall_edges (currentEdge, *(this->transportkettengraph)) {
      informationCurrentEdge = this->transportkettengraph->inf (currentEdge);
      if (informationCurrentEdge) 
	delete informationCurrentEdge;
    } // iteration ueber alle kanten
  } // falls definiert

  // iteration ueber alle knoten
  if (this->transportkettengraph != 0) {
    forall_nodes (currentNode, *(this->transportkettengraph)) {
      informationCurrentNode = this->transportkettengraph->inf (currentNode);
      if (informationCurrentNode)
	delete informationCurrentNode;
    } // iteration ueber alle knoten
  } // falls definiert

  if (this->transportkettengraph != 0)
    delete this->transportkettengraph;
} // ende destruktor

int CTransportkettengraph::ausgebenMindesthaltezeit(int haltestellenID){
    return(0);
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CTransportkettengraph:: ausgebenTGraph(){
  CKantenBeschriftung* InfoAktKante;
  CKnotenBeschriftung* InfoAktKnoten;
  CKnotenBeschriftung*  InfoTargetKnoten;
  node  aktKnoten;
  list<edge> KantenListeAktKnoten;
  edge aktKante;

  // Iteration ueber alle Knoten des Graphen
  forall_nodes (aktKnoten, *(this->transportkettengraph))
     {
       // CKnotenBeschriftung holen und ausgeben mittels ueberladenem << Operator
       InfoAktKnoten=this->transportkettengraph->inf(aktKnoten);
//       cout<< "Werte des aktuellen Knoten: " << (*InfoAktKnoten) << endl;
      
       // Holen aller adjazenten Kanten dieses Knotens und ausgeben dieser Werte, sofern
       // der Knoten ueber adjazente Kanten verfuegt.
       KantenListeAktKnoten=this->transportkettengraph->adj_edges(aktKnoten);
       

       if (!KantenListeAktKnoten.empty()){

              for (int i=0; i < KantenListeAktKnoten.length(); i++){
//		cout<< "Werte der "<< i+1 << " . adjazenten Kante dieses Knoten: ";
	          aktKante=KantenListeAktKnoten.contents(KantenListeAktKnoten.get_item(i));
                  InfoAktKante=this->transportkettengraph->inf(aktKante);
		  
		  // Holen und ausgeben des Target Knotens der jeweils aktuellen Kante. 
		  InfoTargetKnoten=this->transportkettengraph->inf(this->transportkettengraph->target(aktKante));
//                  cout<< (*InfoAktKante) << endl;   
//		  cout<< "Werte des Targetknoten dieser Kante: " << (*InfoTargetKnoten) << endl; 

               };//Ende for-Schleife

       }//Ende if Block
       else cout<< "Keine adjazenten Kanten an Knoten "<<InfoAktKnoten->gebenKnotenID() << "!"<< endl;
       cout << endl;

     };// Ende forall_nodes  

}
//------------------------------------------------------------------------------
// Funktionsname:  initialisierenFesterVerbindungen
// Beschreibung:   Iteriert ueber alle Zusammenhangskomponenten und ruft dort
//                 die Methode intialisierenFesterVerbindungen auf 
// Parameter:	  
// Rueckgabe:	  
// Besonderheiten:	
//------------------------------------------------------------------------------
void CTransportkettengraph::initialisierenFesterVerbindungen(){
  
  CZusammenhangskomponenten* zusammenhangskomponente;

  for(int i=0; i < FeldDerZusammenhangskomponenten->size();i++){
    zusammenhangskomponente=FeldDerZusammenhangskomponenten->get(i);
    zusammenhangskomponente->initialisierenFesterVerbindungen(); 
  };
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CTransportkettengraph::gebenWartezeiten (
  double& summeNetzbedingteWartezeiten, double& wartezeitAufwand,
  double& mindestWartezeitAufwand, double& gesamtWartezeitAufwand) {

  CZusammenhangskomponenten* zusammenhangskomponente;

  // init
  summeNetzbedingteWartezeiten = 0;
  wartezeitAufwand = 0;
  mindestWartezeitAufwand = 0;
  gesamtWartezeitAufwand = 0;

  for(int i=0; i < FeldDerZusammenhangskomponenten->size();i++){
    zusammenhangskomponente=FeldDerZusammenhangskomponenten->get(i);
    summeNetzbedingteWartezeiten += 
      zusammenhangskomponente->gebenSummeNetzbedingteWartezeiten(); 
    wartezeitAufwand +=
      zusammenhangskomponente->gebenWartezeitAufwand ();
    mindestWartezeitAufwand +=
      zusammenhangskomponente->gebenMindestWartezeitAufwand ();
    gesamtWartezeitAufwand +=
      zusammenhangskomponente->gebenGesamtWartezeitAufwand ();
  }
} // ende gebenWartezeiten

//------------------------------------------------------------------------------
// Funktionsname:	setzenMindesthaltezeit
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CTransportkettengraph::setzenMindesthaltezeit(h_array<int, int>* mindesthaltezeit){
  CZusammenhangskomponenten* zusammenhangskomponente;

  // iteration ueber alle zusammenhangskomponenten
  for(int i=0; i < FeldDerZusammenhangskomponenten->size();i++){
	zusammenhangskomponente=FeldDerZusammenhangskomponenten->get(i);
        zusammenhangskomponente->setzenMindesthaltezeit(mindesthaltezeit); 
  } // ende iteration ueber alle zusammenhangskomponenten

  //  delete mindesthaltezeit;
} // ende setzenMindesthaltezeit

//------------------------------------------------------------------------------
// Funktionsname:	InitMindesthaltezeit
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CTransportkettengraph::InitMindestHaltezeit(int mindesthaltezeit){
  CZusammenhangskomponenten* zusammenhangskomponente;

  // iteration ueber alle zusammenhangskomponenten
  for(int i=0; i < FeldDerZusammenhangskomponenten->size();i++){
	zusammenhangskomponente=FeldDerZusammenhangskomponenten->get(i);
        zusammenhangskomponente->InitMindestHaltezeit(mindesthaltezeit); 
  } // ende iteration ueber alle zusammenhangskomponenten
} // ende InitMindesthaltezeit

//------------------------------------------------------------------------------
// Funktionsname:	InitMindesthaltezeit
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CTransportkettengraph::InitMindestUmsteigezeit(int mindestUmsteigezeit){
  CZusammenhangskomponenten* zusammenhangskomponente;

  // iteration ueber alle zusammenhangskomponenten
  for(int i=0; i < FeldDerZusammenhangskomponenten->size();i++){
	zusammenhangskomponente=FeldDerZusammenhangskomponenten->get(i);
        zusammenhangskomponente->InitMindestUmsteigezeit(mindestUmsteigezeit); 
  } // ende iteration ueber alle zusammenhangskomponenten
} // ende InitMindestumsteigezeit

int CTransportkettengraph::ausgebenMindestumsteigezeit(int haltestellenID, int Liniennummer1, int Liniennummer2){
    return(0);
}

//------------------------------------------------------------------------------
// Funktionsname:	setzenMindestumsteigezeit
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void  CTransportkettengraph::setzenMindestumsteigezeit(h_array<int,list<three_tuple<int,int,int>* >*>* mindestumsteigezeit){
   CZusammenhangskomponenten* zusammenhangskomponente;
   //list<three_tuple<int, int, int>* >* currentList;
   //  three_tuple<int,int,int>* currentTripel;
   
   // iteration ueber alle zusammenhangskomponenten
   for(int i=0; i < FeldDerZusammenhangskomponenten->size();i++){
     zusammenhangskomponente=FeldDerZusammenhangskomponenten->get(i);
     zusammenhangskomponente->setzenMindestumsteigezeit(mindestumsteigezeit); 
   } // ende iteration ueber alle zusammenhangskomponenten
   
   // loeschen der mindestumsteigezeit
   //  forall (currentList, *mindestumsteigezeit) {
   //   if (currentList) {
   //     forall (currentTripel, *currentList) {
   // delete currentTripel;
   //     }
   //     delete currentList;
   //  }
   // }
   // delete mindestumsteigezeit;
} // setzenMindestumsteigezeit

void CTransportkettengraph::setzenNetzbedingteWartezeiten(h_array<int,int> netzbedingteWartezeit){
}
//------------------------------------------------------------------------------
// Funktionsname: setzenFesterBindungen 
// Beschreibung:   
// Parameter:	  
// Rueckgabe:	  
// Besonderheiten:	
//------------------------------------------------------------------------------
void CTransportkettengraph::setzenFesterBindungen(list<four_tuple<int,int,int,int>* >* festeBindungen){
    four_tuple<int, int, int, int >* aktFesteVerbindung;
  CZusammenhangskomponenten* aktZusammenhangskomponente;

    if (festeBindungen == 0)
    {
      return;
    }

//    std::cout << "Feste Bindung" << endl;
    // Iterieren ueber alle Elemete der Liste der festen Verbindungen.
    for(int i=0; i < festeBindungen->length(); i++){
      // aktuelles 4-Tupel aus Liste holen.
      aktFesteVerbindung = festeBindungen->inf(festeBindungen->get_item(i));
//      std::cout << "Feste B: " << *aktFesteVerbindung << endl;
      // Zeiger auf richtige Zusammenhangskomponente holen.
      aktZusammenhangskomponente= this->FeldDerZusammenhangskomponenten->get(aktFesteVerbindung->first());

      // In der geholten Zusammenhangskomponente die Funktion setzenFesterBindungen mit den
      // Parametern LinienID1, LinienID2, HaltestellenID aufrufen.
    aktZusammenhangskomponente->setzenFesterBindungen(aktFesteVerbindung->third(),aktFesteVerbindung->fourth(), aktFesteVerbindung->second());
  }; 
}

//------------------------------------------------------------------------------
// Funktionsname:  berechnenListenDerHaltestellenInAllenZusammenhangskomponenten	
// Beschreibung:   gibt als Array die Liste aller Haltestellen in allen
//                 Zusammenhangskomponenten zurueck	
// Parameter:	   void	
// Rueckgabe:	   array von Listen von drei-Tupeln	
// Besonderheiten:	
//------------------------------------------------------------------------------
array<list<three_tuple<int,int,int>* >* >* CTransportkettengraph::berechnenListenDerHaltestellenInAllenZusammenhangskomponenten(){
 
  this->InhaltDerZusammenhangskomponenten = new array<list<three_tuple<int,int,int>* >*> (this->FeldDerZusammenhangskomponenten->size());
 
 // iteration ueber alle zusammenhangskomponenten und anhaengen der Liste an Array InhaltDerZusammenhangskomponente
  for (int i=0; i < this->FeldDerZusammenhangskomponenten->size(); i++) {
    
   InhaltDerZusammenhangskomponenten->set(i, ( this->FeldDerZusammenhangskomponenten->get (i) )->  gebenZusammenhangskomponenteAlsListe ());
 
  } // ende der iteration uber alle zusammenhangskomponenten
    
  return(InhaltDerZusammenhangskomponenten);
}


//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CTransportkettengraph::berechnenSimplexTableau(int zusammenhangskomponentenID){
  (this->FeldDerZusammenhangskomponenten->get (zusammenhangskomponentenID))
    ->berechnenSimplexTableau ();
} // ende berechnenSimplexTableau

void CTransportkettengraph::berechnenKnotenPartition(int zusammenhangskomponentenID){
}

array<CZusammenhangskomponenten>* CTransportkettengraph::ausgebenZusammenhangskomponenten(){
    return(0);
}
        
GRAPH<CKnotenBeschriftung,CKantenBeschriftung>* CTransportkettengraph::liefernZeigerAufGraph(int zusammenhangskomponentenID){
    return(0);
}

//------------------------------------------------------------------------------
// Funktionsname:       berechnenMaximalgeruest	
// Beschreibung:	Anstoss der Berechnung des maximalen Geruestes
//                      in der uebergebenen Zusammenhangskomponente
// Parameter:		ID der Zusammenhangskomponente
// Rueckgabe:		void
// Besonderheiten:	
//------------------------------------------------------------------------------    
void CTransportkettengraph::berechnenMaximalgeruest(int zusammenhangskomponentenID){
  this->FeldDerZusammenhangskomponenten->get(zusammenhangskomponentenID)->berechnenMaximalgeruest();
} // ende berechnenMaximalgeruest
        
//------------------------------------------------------------------------------
// Funktionsname:	berechnenFahrplan
// Beschreibung:	Diese Methode ruft in jeder Zusammenhangskomponente die
//                      Methode berchnenFahrplan auf und verknuepft am Ende die
//                      Fahrplaene der einzelnen Zusammenhangskomponenten
// Parameter:		Abfahrtszeiten und Intervall des Fahrplans
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CTransportkettengraph::berechnenFahrplan(array<three_tuple<int,int,int>* >* abfahrtszeiten,four_tuple<int,int,int,int>* fahrplanIntervall){
  // Zeiger auf Fahrplan erzeugen
  fahrplan = new list<CFahrplanElement*>(); 

  // Fahrplaene in den einzelnen Zusammenhangskomponenten erzeugen
  for (int i=0; i < this->FeldDerZusammenhangskomponenten->size(); i++) {
    (this->FeldDerZusammenhangskomponenten->get(i))->berechnenFahrplan(abfahrtszeiten->get(i),fahrplanIntervall);
  };

  this->gesamtFahrzeugAnzahl = 0;
  // Einzelne Fahrplaene verknuepfen
  for (int i=0; i < this->FeldDerZusammenhangskomponenten->size(); i++) {
    list<CFahrplanElement*>* fahrplanDerZusammenhangskomponente = (this->FeldDerZusammenhangskomponenten->get(i))->gebenFahrplan();
    fahrplan->conc(*fahrplanDerZusammenhangskomponente,LEDA::after);
    this->gesamtFahrzeugAnzahl +=
      (this->FeldDerZusammenhangskomponenten->get(i))->gebenFahrzeugAnzahl(); 
  };
}

//------------------------------------------------------------------------------
// Funktionsname:	gebenFahrplan
// Beschreibung:	Gibt den erstellten Fahrplan zurueck
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
list<CFahrplanElement*>* CTransportkettengraph::gebenFahrplan(){
    return this->fahrplan;
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
int CTransportkettengraph::gebenFahrzeugAnzahl (){
    return this->gesamtFahrzeugAnzahl;
}

//------------------------------------------------------------------------------
// Funktionsname: umbauenTransportkettengraph	
// Beschreibung: Baut in den uebergegeben Graphen "Netz der Transportverbindungen
//               in den Transportkettengraph um	
// Parameter: Referenz auf parametrisierten Graph "Netz der Transportverbindungen"     
// Rueckgabe: void		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CTransportkettengraph::umbauenTransportkettengraph(GRAPH<CFPlanGraphKnoten*, CFPlanGraphKante*>* NetzDerTransportverbindungen){
  edge kanteNetzDerTransportverbindungen, ingradKanteAktKnoten,
       outgradKanteAktKnoten;
  node knotenNetzDerTransportverbindungen, knotenTransportkettenGraph,
       sourceKnotenIngradKante, targetKnotenOutGradKante;
  int gesamtVerkehrsstrom;
  int fortlaufendeID = 0;
  int fortlaufendeKantenID = 0;
  bool istUmsteigeKante;
  h_array<edge, node> *mappingArrayKantenKnoten = new h_array<edge, node>;
  CFPlanGraphKnoten *informationSourceKnoten, *informationTargetKnoten;
  CFPlanGraphKante *informationIngradKante, *informationOutgradKante, *informationAktKante;


  // erzeugung der transportkettengraph-knoten + deren beschriftung
  // iteration ueber alle Kanten 
  forall_edges (kanteNetzDerTransportverbindungen, *NetzDerTransportverbindungen) {
     informationSourceKnoten = NetzDerTransportverbindungen->inf (NetzDerTransportverbindungen->source (kanteNetzDerTransportverbindungen));
     informationTargetKnoten = NetzDerTransportverbindungen->inf (NetzDerTransportverbindungen->target (kanteNetzDerTransportverbindungen));
     informationAktKante = NetzDerTransportverbindungen->inf (kanteNetzDerTransportverbindungen);

     // fehler werfen, falls die werte an den kanten oder knoten
     // nicht instanziiert wurden
     if ( (informationSourceKnoten == 0) || (informationTargetKnoten == 0)
          || (informationAktKante == 0))
       throw NichtInstanzierteParameter ();

     knotenTransportkettenGraph = 
       this->transportkettengraph->new_node (new CKnotenBeschriftung(fortlaufendeID,
    							    informationAktKante->holenLinienID(),
    							    informationSourceKnoten->holenID(),
							    informationTargetKnoten->holenID(),
    							    informationAktKante->holenFahrtzeit()
    							    ));						    
     (*mappingArrayKantenKnoten)[kanteNetzDerTransportverbindungen] =
       knotenTransportkettenGraph;
    ++fortlaufendeID;
  } // ende iteration ueber alle Kanten
  

  // erzeugen der kanten zwischen den existierenden knoten
  // iteration ueber alle Knoten
  forall_nodes (knotenNetzDerTransportverbindungen, *NetzDerTransportverbindungen) {
    // iteration ueber alle ingrad-Kanten des aktuellen Knotens
    forall_in_edges (ingradKanteAktKnoten, knotenNetzDerTransportverbindungen) {
      informationIngradKante = NetzDerTransportverbindungen->inf (ingradKanteAktKnoten);
      sourceKnotenIngradKante = NetzDerTransportverbindungen->source (ingradKanteAktKnoten);
      informationSourceKnoten = NetzDerTransportverbindungen->inf (sourceKnotenIngradKante);

      // fehler werfen, falls nicht instanziierte werte an den knoten
      if ( (informationIngradKante==0) || (informationSourceKnoten==0))
	throw NichtInstanzierteParameter ();

      // iteration ueber alle outgrad-Kanten des aktuellen Knotens
      forall_out_edges (outgradKanteAktKnoten, knotenNetzDerTransportverbindungen) {
  	targetKnotenOutGradKante = NetzDerTransportverbindungen->target (outgradKanteAktKnoten);
	informationTargetKnoten = NetzDerTransportverbindungen->inf (targetKnotenOutGradKante);
	// einfuegen kante zwischen beiden knoten 
  	if (informationTargetKnoten->holenID() != informationSourceKnoten->holenID()) {
	  informationOutgradKante = NetzDerTransportverbindungen->inf (outgradKanteAktKnoten);
  	  gesamtVerkehrsstrom = informationIngradKante->holenVerkehrsstrom() + 
	    informationOutgradKante->holenVerkehrsstrom();
	  // ueberpruefung, ob umsteigekante vorliegt
	  if (informationIngradKante->holenLinienID() != 
	      informationOutgradKante->holenLinienID()) {
	    istUmsteigeKante = true;
	  }
	  else {
	    istUmsteigeKante = false;
	  }
	  this->transportkettengraph->new_edge ((*mappingArrayKantenKnoten)[ingradKanteAktKnoten],
						(*mappingArrayKantenKnoten)[outgradKanteAktKnoten],
						new CKantenBeschriftung (fortlaufendeKantenID,
									 gesamtVerkehrsstrom,
									 istUmsteigeKante));
	  fortlaufendeKantenID++;
	}
      } // ende iteration ueber alle outgrad-Kanten
    } // ende iteration ueber ingrad-Kanten
  } // ende iteration ueber alle Knoten

  delete mappingArrayKantenKnoten;
} //ende umbauenTransportkettengraph
        
void CTransportkettengraph::reduzierenTransportkettengraph(){
}

//------------------------------------------------------------------------------
// Funktionsname: berechnenZusammenhangskomponenten	
// Beschreibung:  berechnung der zusammenhangskomponenten aus dem 
//                transportkettengraph	
// Parameter:	  keine	
// Rueckgabe:	  keine	
// Besonderheiten:keine	
//------------------------------------------------------------------------------
void CTransportkettengraph::berechnenZusammenhangskomponenten(){
  node_array<int> *komponentenNum = new node_array<int> (*(this->transportkettengraph));
  int anzahlKomponenten = 0;
  node aktKnoten, sourceKnoten, targetKnoten;
  edge aktKante;
  CKnotenBeschriftung *informationAktKnoten, *informationTargetKnoten,
                      *informationSourceKnoten;
  CKantenBeschriftung *informationAktKante;
  CZusammenhangskomponenten* aktZusammenhangskomponente;
  int zusammenhangskomponentenID;

  // berechnung der zusammenhangskomponenten 
  // betrachtung als ungerichteter graph
  anzahlKomponenten = COMPONENTS (*(this->transportkettengraph), *komponentenNum);

  Debug (5, "Anzahl der gefundenen Zusammenhangskomponenten: " << anzahlKomponenten);

  // falls keine zusammenhangskomponente gefunden, dann ist das netz der
  // transportverbindungen leer und somit die berechnung unsinning
  if (anzahlKomponenten == 0)
    throw UnsinnigeErzeugung ();

  // feld der zusammenhangskomponenten initialisieren
  this->FeldDerZusammenhangskomponenten = new array<CZusammenhangskomponenten*> (anzahlKomponenten);
  for (int i=0; i < anzahlKomponenten; i++) {
    this->FeldDerZusammenhangskomponenten->set (i, new CZusammenhangskomponenten (i));
  }

  // iteration ueber alle knoten des transportkettengraphen
  // anfuegen der knoten in die jeweilige zusammenhangskomponente
  forall_nodes (aktKnoten, *(this->transportkettengraph)) {
    informationAktKnoten = this->transportkettengraph->inf (aktKnoten);
    aktZusammenhangskomponente = this->FeldDerZusammenhangskomponenten->get ((*komponentenNum)[aktKnoten]);
    aktZusammenhangskomponente->anfuegenKnoten (*informationAktKnoten);
  } // ende der iteration ueber alle knoten

  // iteration ueber alle kanten des transportkettengraphen
  // anfuegen der kanten in die entsprechende zusammenhangskomponente
  forall_edges (aktKante, *(this->transportkettengraph)) {
    sourceKnoten = this->transportkettengraph->source (aktKante);
    targetKnoten = this->transportkettengraph->target (aktKante);
    informationAktKante = this->transportkettengraph->inf (aktKante);
    informationSourceKnoten = this->transportkettengraph->inf (sourceKnoten);
    informationTargetKnoten = this->transportkettengraph->inf (targetKnoten);
    zusammenhangskomponentenID = (*komponentenNum)[sourceKnoten];
    aktZusammenhangskomponente =
      this->FeldDerZusammenhangskomponenten->get(zusammenhangskomponentenID);
    aktZusammenhangskomponente->anfuegenKante (				  
			      informationSourceKnoten->gebenKnotenID (),
  			      informationTargetKnoten->gebenKnotenID (),
  			      informationAktKante->gebenKantenID (),
  			      informationAktKante->abfragenVerkehrsstrom (),
			      informationAktKante->gebenIstUmsteigekante());					 
  } // ende der iteration ueber alle kanten

  delete komponentenNum;
} // ende berechnenZusammenhangskomponenten


//------------------------------------------------------------------------------
// Funktionsname: berechnenZyklomatischenZahl	
// Beschreibung:  Iteration ueber alle Zusammenhangskomponenten
//                und Aufruf der Funktion berechnenZyklomatischenZahl	
// Parameter:	  void	
// Rueckgabe:	  void	
// Besonderheiten:	
//------------------------------------------------------------------------------    
void CTransportkettengraph::berechnenZyklomatischeZahl(){  
  // iteration ueber alle zusammenhangskomponenten
  for (int i=0; i < this->FeldDerZusammenhangskomponenten->size(); i++) {
    (this->FeldDerZusammenhangskomponenten->get (i))->berechnenZyklomatischeZahl();
  } // ende iteration ueber alle zusammenhangskomponenten
} // ende berechnenZyklomatischen Zahl


//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------      
void CTransportkettengraph::setzenTakt(int zusammenhangskomponente, int takt){
  this->takt = takt;
  (this->FeldDerZusammenhangskomponenten->get (zusammenhangskomponente))->
    setzenTakt (takt);
} // ende setzenTakt
       
int CTransportkettengraph::gebenTakt(){
    return(0);
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CTransportkettengraph::berechnenWartezeitResultate () {
  // iteration ueber alle zusammenhangskomponenten
  for (int i=0; i < this->FeldDerZusammenhangskomponenten->size(); i++) {
    (this->FeldDerZusammenhangskomponenten->get (i))->berechnenWartezeitResultate();
  } // ende iteration ueber alle zusammenhangskomponenten
}

int CTransportkettengraph::gebenZyklomatischeZahl(int zusammenhangskomponente){
  return (this->FeldDerZusammenhangskomponenten->get (zusammenhangskomponente))->gebenZyklomatischeZahl();
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CTransportkettengraph::startenLokaleSuche (int zusammenhangskomponentenID)
{
  (this->FeldDerZusammenhangskomponenten->get (zusammenhangskomponentenID))->
    startenLokaleSuche ();
} // ende startenLokaleSuche

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CTransportkettengraph::berechnenBesteLoesung(int zusammenhangskomponentenID, int baumtiefe) {
  (this->FeldDerZusammenhangskomponenten->get (zusammenhangskomponentenID))->
    berechnenBesteLoesung (baumtiefe);
} // ende berechnenBesteLoesung

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CTransportkettengraph::ZeichnenTransportkettengraph () {
  node currentNode, node1, node2;
  edge currentEdge;
  CKnotenBeschriftung *information, *information1, *information2;
  CKantenBeschriftung *informationEdge;
  node nodes[transportkettengraph->number_of_nodes()];
  
  GRAPH<CKnotenBeschriftung, CKantenBeschriftung> graphTmp;
  forall_nodes (currentNode, *transportkettengraph) {
    information = transportkettengraph->inf (currentNode);
    nodes[information->gebenKnotenID()] = graphTmp.new_node (*information);
  }

  forall_edges (currentEdge, *transportkettengraph) {
    node1 = transportkettengraph->source (currentEdge);
    information1 = transportkettengraph->inf (node1);
    node2 = transportkettengraph->target (currentEdge);
    information2 = transportkettengraph->inf (node2);
    informationEdge = transportkettengraph->inf (currentEdge);
    graphTmp.new_edge (nodes[information1->gebenKnotenID()],
		       nodes[information2->gebenKnotenID()],
		       *informationEdge);
  }
  
  CVisualFahrplan visual (&graphTmp);
  visual.Zeichnen (550, 800);
} // ende zeichenTransportkettengraph

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CTransportkettengraph::ZeichnenNetzDerTransportverbindungen (
  GRAPH<CFPlanGraphKnoten*, CFPlanGraphKante*>* netz) {

  node currentNode, node1, node2;
  edge currentEdge;
  CFPlanGraphKnoten *information, *information1, *information2;
  CFPlanGraphKante *informationEdge;
  h_array<int, node> nodes (0, netz->number_of_nodes());

  GRAPH<CFPlanGraphKnoten, CFPlanGraphKante> graphTmp;
  forall_nodes (currentNode, *netz) {
    information = netz->inf (currentNode);
    nodes[information->holenID()] = graphTmp.new_node (*information);
  }

  forall_edges (currentEdge, *netz) {
    node1 = netz->source (currentEdge);
    information1 = netz->inf (node1);
    node2 = netz->target (currentEdge);
    information2 = netz->inf (node2);
    informationEdge = netz->inf (currentEdge);
    graphTmp.new_edge (nodes[information1->holenID()],
		       nodes[information2->holenID()],
		       *informationEdge);
  }
  
  CVisualFahrplan visual (&graphTmp);
  visual.Zeichnen (550, 800);  
} // ende zeichenNetzDerTransportverbindungen

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CTransportkettengraph::ZeichnenZusammenhangskomponente () 
{
  // iteration ueber alle zusammenhangskomponenten
  for (int i=0; i < this->FeldDerZusammenhangskomponenten->size(); i++) {
    (this->FeldDerZusammenhangskomponenten->get (i))->ZeichnenZusammenhangskomponente ();
  } // ende iteration ueber alle zusammenhangskomponenten
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CTransportkettengraph::initialisierenGeruest() {
  for (int i=0; i < this->FeldDerZusammenhangskomponenten->size(); i++) {
    (this->FeldDerZusammenhangskomponenten->get (i))->initWartezeitResultate();
  } // ende iteration ueber alle zusammenhangskomponenten
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
h_array<three_tuple<int,int,int>*,int>* CTransportkettengraph::gebenListeNetzbedingtewartezeit() {
  h_array<three_tuple<int,int,int>*,int>* wartezeitListe = new h_array<three_tuple<int,int,int>*,int>();
  three_tuple<int,int,int>* hash1;
  h_array<three_tuple<int,int,int>*,int>* wartezeitListeDerZusammenhangskomponente;
  
  for (int i=0; i < this->FeldDerZusammenhangskomponenten->size(); i++) {
    wartezeitListeDerZusammenhangskomponente = (this->FeldDerZusammenhangskomponenten->get(i))->gebenListeNetzbedingtewartezeit();
    forall_defined(hash1,*(wartezeitListeDerZusammenhangskomponente)) {
      (*wartezeitListe)[hash1] = (*wartezeitListeDerZusammenhangskomponente)[hash1];
    }
  } // ende iteration ueber alle zusammenhangskomponenten
  
  return wartezeitListe;
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CTransportkettengraph::fuellenReisebewertung(map2<int,int,CReisebewertung>& reisebewertung, int anzahlHaltestellen){
  map2<int,int,CReisebewertung>* bewertung = new map2<int,int,CReisebewertung>();
  CReisebewertung reise1, reise2;
  for (int i=0; i < this->FeldDerZusammenhangskomponenten->size(); i++) {
    (this->FeldDerZusammenhangskomponenten->get(i))->fuellenReisebewertung(*bewertung);
    for (int i=0;i<anzahlHaltestellen;i++) {
      for (int j=0;j<anzahlHaltestellen;j++) {
	if (bewertung->defined(i,j)) {
	  reise2 = (*bewertung)(i,j);
	  if (reisebewertung.defined(i,j)) {
	    reise1 = reisebewertung(i,j);
	    if ((reise2.gebenFahrzeit() + reise2.gebenWartezeit()) < (reise1.gebenFahrzeit() + reise1.gebenWartezeit())) {
	      reisebewertung(i,j) = reise2;
	    }
	  } else {
	    reisebewertung(i,j) = reise2;
	  }
	}
      }
    }
  } // ende iteration ueber alle zusammenhangskomponenten
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
double CTransportkettengraph::gebenFahrplanWirkungsgrad(){
  double fahrplanWirkungsgrad = 0.0;

  for (int i=0; i < this->FeldDerZusammenhangskomponenten->size(); i++) {
    fahrplanWirkungsgrad += (FeldDerZusammenhangskomponenten->get(i))->gebenFahrplanWirkungsgrad (); 
  };
  return fahrplanWirkungsgrad / (double) this->FeldDerZusammenhangskomponenten->size ();
}	

int CTransportkettengraph::gebenFahrgastfahrten(){
  int fahrgastfahrten = 0;
  for (int i=0; i < this->FeldDerZusammenhangskomponenten->size(); i++) {
    fahrgastfahrten += (this->FeldDerZusammenhangskomponenten->get(i))->gebenFahrgastfahrten(); 
  };
  return fahrgastfahrten;  
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CTransportkettengraph::setzenStoppenFlag ()
{
  if (this->FeldDerZusammenhangskomponenten != 0)
  {
    for (int i=0; i < this->FeldDerZusammenhangskomponenten->size(); i++) {
      this->FeldDerZusammenhangskomponenten->get(i)->setzenStoppenFlag (); 
    };
  }
}



