#include "LEDA/graph.h"
#include "CKantenBeschriftung.h"
#include "CKnotenBeschriftung.h"
#include <iostream.h>

class vergleichenKanten: public leda_cmp_base<edge> { 
  const GRAPH<CKnotenBeschriftung* ,CKantenBeschriftung*>& G;
 public:
  vergleichenKanten(const GRAPH<CKnotenBeschriftung*,CKantenBeschriftung*>& g): G(g){}
  
  int operator()(const edge& kante1, const edge& kante2) const
    {
      
      
      bool kantenFlag1=false;
      bool kantenFlag2=false;
      bool nichtMaximalgeruestFlag1=false;
      bool nichtMaximalgeruestFlag2=false;

      int ausgabeInt=0;
      CKantenBeschriftung* kantenBeschriftung1, *kantenBeschriftung2;	  
      
      // Rausholen bool Werte, um nicht so viel schreiben zu muessen :)
      kantenBeschriftung1=G.inf(kante1);
      
      kantenBeschriftung2=G.inf(kante2);
      
      // Wenn FesteVerbindung oder ImMaximalgeruest setze kantenFlagx auf true
      if (((kantenBeschriftung1->abfragenFesteVerbindung()) || (kantenBeschriftung1->gebenMussInsMaximalgeruest()))){
	kantenFlag1 = true;
      } else {
	kantenFlag1 = false;
      }
       if (((kantenBeschriftung2->abfragenFesteVerbindung()) || (kantenBeschriftung2->gebenMussInsMaximalgeruest()))){
	kantenFlag2 = true;
      } else {
	kantenFlag2 = false;
      }

      // Wenn nicht im Maximalgeruest, setze nichtMaximalgeruestFlagx auf true
      nichtMaximalgeruestFlag1 = kantenBeschriftung1->istNichtImMaximalgeruest();
      nichtMaximalgeruestFlag2 = kantenBeschriftung2->istNichtImMaximalgeruest();
      
      // Abfragen der drei Faelle. Falls auf beiden gleicher Verkehrsstrom, dann erste zurueck
      
      // 1. Fall: Beides feste Verbindungen. 
      if (kantenFlag1 && kantenFlag2)
	{
	  if (kantenBeschriftung1->abfragenVerkehrsstrom()< kantenBeschriftung2->abfragenVerkehrsstrom()) ausgabeInt=1;
	  else 
	    if (kantenBeschriftung1->abfragenVerkehrsstrom() == kantenBeschriftung2->abfragenVerkehrsstrom()) {
	      ausgabeInt=0;
	    }
	    else ausgabeInt=-1; 
	};  
      
      // 2. Fall: Eine Kante feste Verbindung.
      if (kantenFlag1 && !kantenFlag2) ausgabeInt=-1;
      if (!kantenFlag1 && kantenFlag2) ausgabeInt=1;
      
      // 3.Fall: Keine Kante feste Verbindung.
      if (!kantenFlag1 && !kantenFlag2)
	{  
	  if (kantenBeschriftung1->abfragenVerkehrsstrom()< kantenBeschriftung2->abfragenVerkehrsstrom()) ausgabeInt=1;
	  else 
	    if (kantenBeschriftung1->abfragenVerkehrsstrom() == kantenBeschriftung2->abfragenVerkehrsstrom()) {
	      ausgabeInt=0;
	    }
	    else ausgabeInt = -1;
	};

      // 4.Fall: Beide Kante NichtImMaximalgeruest.
      if (nichtMaximalgeruestFlag1 && nichtMaximalgeruestFlag2)
	{
	  if (kantenBeschriftung1->abfragenVerkehrsstrom()< kantenBeschriftung2->abfragenVerkehrsstrom()) ausgabeInt=1;
	  else 
	    if (kantenBeschriftung1->abfragenVerkehrsstrom() == kantenBeschriftung2->abfragenVerkehrsstrom()) {
	      ausgabeInt=0;
	    }
	    else ausgabeInt=-1; 
	};  

      // 5.Fall: Eine Kante NichtImMaximalgeruest.
      if (nichtMaximalgeruestFlag1 && !nichtMaximalgeruestFlag2) ausgabeInt=-1;
      if (!nichtMaximalgeruestFlag1 && nichtMaximalgeruestFlag2) ausgabeInt=1;
      
      return ausgabeInt;
      
    } 
};

