/* Generated by Together */

#include "CHaltestelle.h"
#include "CStrassennetzStochastisch.h"
#include "CStrassennetzStochastischUmgebung.h"
#include "CStrassennetzES.h"
#include "../Datenstruktur/CFortschritt.h"

//______________________________________________________________________________

void CHaltestelle::stoppen(void)
{
//  Debug(2, "CHaltestelle::stoppen()");
  Fortschritt->meldenLaufzeitAusgabe("Stopp signalisiert!");
  abbrechen = true;
} // stoppen

//______________________________________________________________________________

void CHaltestelle::starten(void)
{
//  Debug(2, "CHaltestelle::starten()");
  char * Teilschritte[] = {"Initialisierung","Haltestellenberechnung","Nachbearbeitung"};
  Fortschritt->setzenTeilschritte(3,Teilschritte);
  Fortschritt->meldenLaufzeitAusgabe("gestartet");
  switch (Parameter->holenAlgorithmustyp()) {
  case stochastisch:
      Fortschritt->meldenLaufzeitAusgabe("Stochastischer Algorithmus");
      lnkHaltestelle = new CStrassennetzStochastisch(&abbrechen,lnkSchnittstelle,Parameter,Fortschritt);
    break;
  case stochastischUmgebung:
      Fortschritt->meldenLaufzeitAusgabe("Stochastischer Algorithmus mit Pruefung der Umgebung");
      lnkHaltestelle = new CStrassennetzStochastischUmgebung(&abbrechen,lnkSchnittstelle,Parameter,Fortschritt);
    break;
  case evolutionaereStrategie:
      Fortschritt->meldenLaufzeitAusgabe("Evolutionaere Strategie");
      lnkHaltestelle = new CStrassennetzES(&abbrechen,lnkSchnittstelle,Parameter,Fortschritt);
    break;
  default:
      Fortschritt->meldenLaufzeitAusgabe("Nur Pflichthaltestellen uebernehmen");
      lnkHaltestelle = new CStrassennetz(&abbrechen,lnkSchnittstelle,Parameter,Fortschritt);
    break;
  }
  // Starten der Berechnung...
  lnkHaltestelle->starten();
  Fortschritt->meldenLaufzeitAusgabe("beendet");
} // starten

//______________________________________________________________________________

CHaltestelle::CHaltestelle(CHSSchnittstelle * lnkSchnittstelle)
{
//  Debug(1, "CHaltestelle()");
  // Schnittstelle
  if (lnkSchnittstelle==NULL)
    throw NichtInstanzierteParameter();
  this->lnkSchnittstelle = lnkSchnittstelle;
  Parameter = lnkSchnittstelle->anfordernWerte();
  Fortschritt = new CFortschritt("Modul Haltestellen",Parameter->pruefenBatchModus());
  // HaltestellenAlgorithmus
  lnkHaltestelle = NULL;
  // Abbruchsbedingung
  abbrechen = false;
  Fortschritt->meldenLaufzeitAusgabe("erzeugt");
} // CHaltestelle

//______________________________________________________________________________

CHaltestelle::~CHaltestelle(void)
{
//  Debug(1, "CHaltestelle()");
  if (lnkHaltestelle!=NULL) {
    delete lnkHaltestelle;
  }
  if (Parameter!=NULL) {
    delete Parameter;
  }
  Fortschritt->meldenLaufzeitAusgabe("vernichtet");
  delete Fortschritt;
} // ~CHaltestelle
