/* Generated by Together */

#ifndef CHALTESTELLE_H
#define CHALTESTELLE_H

#include "CStrassennetz.h"
#include "../Programm/CHSSchnittstelle.h"

class CHSSchnittstelle;

/**
 * Schnittstelle zur Programmgruppe. Hat die Kontrolle &uuml;ber das Package Haltestelle und alle darin enthaltenen Klasse.
 */
class CHaltestelle {
 public:

  /**
   * Leitet die Berechnung der Haltestellen und darauf aufbauender
   * Algorithmen ein.
   *
   * - ruft berechnenKreuzungen(), berechnenEntfernungen(), setzenHaltestellen() und ermittelnKuerzesteWege() auf.
   *
   * - kontrolliert die Berechnungen durch die Methodenaufrufe
   *
   * - beruecksichtigt das Stoppen durch die Methode stoppen()
   */
  void starten(void);

  /**
   * Signalisiert das Stoppen der Haltestellenberechnung und
   * darauf aufbauender Algorithmen.
   *
   * Setzt dann ein Flag, das von der starten()-Methode ausgewertet wird
   *
   * Wird vom Programm aufgerufen.
   */
  void stoppen(void);

 private:

  /**
   * Verweis auf die Schnittstellen von CStrassennetz.
   * @clientCardinality 1
   * @supplierCardinality 1 
   */
  CStrassennetz * lnkHaltestelle;

 public:

  /**
   * Konstruktor.
   * Holt sich die Daten aus der Schnittstelle (mit CHSSchnittstelle.anfordernWerte()).
   * Baut eigene Datenstrukturen (Fahrtwunschmatrix, Pendlermatrix, Strassennetz und
   * Wegenetzgraph) auf.
   * Setzt die Pflichthaltestellen.
   *
   * @param lnkSchnittstelle Die Schnittstelle, welche von aussen uebergeben wird. Die Vernichtung erfolgt ebenfalls ausserhalb.
   */
  CHaltestelle(CHSSchnittstelle * lnkSchnittstelle);

  /**
   * Destruktor.
   * Dient dem Aufraeumen der Datenstrukturen.
   */
  ~CHaltestelle(void);

 private:
  /**
   * Wird von der Methode stoppen() auf true gesetzt, wenn das Programm ein Abbruchsignal gesendet hat.
   */
  bool abbrechen;

  /**
   * Verweis auf die Schnittstelle des Programmmoduls.
   * Wird beim Erzeugen dieser Klasse uebergeben und
   * von aussen vernichtet.
   *
   * @supplierCardinality 1
   */
  CHSSchnittstelle * lnkSchnittstelle;

  CParameterHaltestelle * Parameter;

  CFortschritt * Fortschritt;

};
#endif //CHALTESTELLE_H
