/* Generated by Together */

#include <math.h>
#include <time.h>
#include "CStrassennetz.h"

#define DEBUG_berechnenKreuzungen 10 // Werden nicht mehr angezeigt.
#define DEBUG_berechnenSchnittpunkt 10
#define DEBUG_berechnenPunkt 10
#define DEBUG_Verkehrsbedarfsmatrix 10
#define DEBUG_erstellenKantenListe 10

// #define REALWEG_TEST_UMGEBUNG

class CPunkt;


//------------------------------------------------------------------------------
// Funktionsname:   berechnenSchnittpunkt	
// Beschreibung:	 Berechnet einen Schnittpunkt zweier Geraden
// Parameter:	Steigungsfaktor m1 und m2, y-Achsenabschnitt t1 und t2	
// Rueckgabe:	den berechneten Schnittpunkt vom Typ CPunkt
// Besonderheiten:	./.
//------------------------------------------------------------------------------

CPunkt* CStrassennetz::berechnenSchnittpunkt(double m1, double t1, double m2, double t2)
{
// implementiert
  //  Debug(2, "CStrassennetz::berechnenSchnittpunkt()");
  CPunkt * schnittpunkt = new CPunkt();

  double x=(t2-t1)/(m1-m2);
  double y=m1*x+t1;
  schnittpunkt->setzen(x,y);
  Debug(DEBUG_berechnenSchnittpunkt, "Setze Schnittpunkt: " << *schnittpunkt);
  return schnittpunkt;
}


//------------------------------------------------------------------------------
// Funktionsname:	berechnenPunkt
// Beschreibung:	Berechnet einen Punkt einer Geraden, indem in die
// 		Geradengleichung eingesetzt wird
// Parameter:	Geradengleichung in der Form m * x + t 	
// Rueckgabe:	Der berechnete f(x)-Wert  y	
// Besonderheiten:	./.
//-----------------------------------------------------------------------------

CPunkt* CStrassennetz::berechnenPunkt(double m, double t, double x)
{
// implementiert
  //  Debug(2, "CStrassennetz::berechnenPunkt()");
  CPunkt * Punkt = new CPunkt();

  double y=m*x+t;
  Punkt->setzen(x,y);
  Debug(DEBUG_berechnenPunkt,"Setze Punkt: " << *Punkt);
  return Punkt;
}


//------------------------------------------------------------------------------
// Funktionsname:	~CStrassennetz
// Beschreibung:	Destruktor
// Parameter:	
// Rueckgabe:	
// Besonderheiten:	
//------------------------------------------------------------------------------

CStrassennetz::~CStrassennetz()
{
/*****************
 * NOCH FALSCH!!!
 *****************/
  // TODO: Loeschen aller(!) nicht weitergereichten Datenstrukturen!
  // Visualisierungen entfernen
  if (StrassenVisualisierung!=NULL) {
    delete StrassenVisualisierung;
  }
  if (BevoelkerungsversorgungVisualisierung!=NULL) {
    delete BevoelkerungsversorgungVisualisierung;
  }
  if (FlaechendeckungVisualisierung!=NULL) {
    delete FlaechendeckungVisualisierung;
  }
  if (LegendeVisualisierung!=NULL) {
    delete LegendeVisualisierung;
  }
  // Eingabedaten lschen
  delete Parameter;
  // Strassennetzgraph
  if (Strassennetz!=NULL) {
    Strassennetz->del_all_edges();
    Strassennetz->del_all_nodes();
    delete Strassennetz;
  }
  // Haltestellen
//  if (Haltestellen!=NULL) {
//    CPunkt* terminator;
//    forall(terminator,*Haltestellen) {
//      delete terminator;
//    }
//    delete Haltestellen;
//  }
  if (HaltestellenKnoten!=NULL) {
    // Auf gar keinen Fall die Eintraege der Liste loeschen,
    // da selbige im Wegenetzgraphen eingebaut sind!
    delete HaltestellenKnoten;
  }
  if (HaltestellenImStrassennetz!=NULL) {
    delete HaltestellenImStrassennetz;
  }
  // Bevoelkerungsraster
  if (Bevoelkerungsraster!=NULL)
    delete Bevoelkerungsraster;
  // Flaechenraster
  if (Flaechenraster!=NULL)
    delete Flaechenraster;
  // Fahrtwunschraster
  if (Fahrtwunschraster!=NULL)
    delete Fahrtwunschraster;
  // Sektoren fuer die Aufnahme der Kanten
  if (Sektor!=NULL) {
    for (unsigned int i=0; i<SektorAnzahl*SektorAnzahl; i++) {
      delete Sektor[i];
    }
  }
//  Debug(1, "~CStrassennetz()");
}

//------------------------------------------------------------------------------
// Funktionsname:	initialisieren()
// Beschreibung:	
// Parameter:	
// Rueckgabe:	
// Besonderheiten:	
//------------------------------------------------------------------------------

void CStrassennetz::initialisieren(void) {
// implementiert

//  Debug(3,"initialisieren()");
  Fortschritt->setzenNaechstenSchritt(0);
  Guetemasse = lnkSchnittstelle->holenGuetemasse();
  BevoelkerungsversorgungVisualisierung = NULL;
  FlaechendeckungVisualisierung = NULL;

  LegendeVisualisierung = NULL;
  if (Parameter->pruefenAnzeigenLegende()) LegendeVisualisierung = new CVisualisierung("Legende",600,25);
  if (Parameter->pruefenAnzeigenLegende()) LegendeVisualisierung->zeigenLegende();
  StrassenVisualisierung = NULL;
  dijkstraKanten = NULL;
//  Haltestellen = NULL;
  Strassennetz = NULL;
  HaltestellenKnoten = NULL;
  HaltestellenImStrassennetz = NULL;
  Bevoelkerungsraster = NULL;
  Flaechenraster = NULL;
  Fahrtwunschraster = NULL;
  Strassennetz = new GRAPH<rat_point,rat_segment>;
  // Sektoren fuer die Aufnahme der Kanten...
  Sektor = NULL;;
  // Abbruchsflagge
  //abbrechen = NULL;
  if (lnkSchnittstelle!=NULL)
  {
  char dummy[100];
  if (Parameter->holenZufallszahlengeneratorinitialisierung()==-1) {
    long zahl = (long)time(NULL);
    srand48(zahl);
    sprintf(dummy, "Zufallszahl = %d", (int) zahl);
  } else {
    sprintf(dummy, "Zufallszahl = %d", Parameter->holenZufallszahlengeneratorinitialisierung());
    srand48(Parameter->holenZufallszahlengeneratorinitialisierung());
  }
  Fortschritt->meldenLaufzeitAusgabe(dummy);
  Debug(0,dummy);

    // Begrenzungen ermitteln
    Fortschritt->meldenLaufzeitAusgabe("Begrenzungen");
    suchenBegrenzungen(Parameter->holenStrassennetzliste());

    double radius;
//    radius = (3*Parameter->holenMinimalesEinzugsgebiet()+Parameter->holenMaximalesEinzugsgebiet())/4;
    radius = (4*Parameter->holenMinimalesEinzugsgebiet()+Parameter->holenMaximalesEinzugsgebiet())/5;
    if (Parameter->holenAnzahlHaltestellen()==0) {
      MaximaleAnzahlHaltestellen = (unsigned int)(fabs(((begrenzungLinks-begrenzungRechts)*(begrenzungUnten-begrenzungOben))/(PI*radius*radius)));
    } else {
      MaximaleAnzahlHaltestellen = Parameter->holenAnzahlHaltestellen();
    }

    Fortschritt->meldenLaufzeitAusgabe("Bevoelkerungsdichte");
    double * raster;
    raster = rasternBevoelkerung(Parameter->holenBevoelkerungsdichtenliste());
    MaximumBevoelkerung = 0.01;
    for (unsigned int i=0; i<Parameter->holenBevoelkerungsrasterEinheiten(); i++) {
      for (unsigned int j=0; j<Parameter->holenBevoelkerungsrasterEinheiten(); j++) {
        if (raster[i*Parameter->holenBevoelkerungsrasterEinheiten()+j]>MaximumBevoelkerung) {
          MaximumBevoelkerung = raster[i*Parameter->holenBevoelkerungsrasterEinheiten()+j];
        }
      }
    }
    for (unsigned int i=0; i<Parameter->holenBevoelkerungsrasterEinheiten(); i++) {
      for (unsigned int j=0; j<Parameter->holenBevoelkerungsrasterEinheiten(); j++) {
        raster[i*Parameter->holenBevoelkerungsrasterEinheiten()+j] += MaximumBevoelkerung/100;
      }
    }
    Bevoelkerungsraster = new matrix(Parameter->holenBevoelkerungsrasterEinheiten(),Parameter->holenBevoelkerungsrasterEinheiten(),raster);
    delete[] raster;
    if (Parameter->pruefenAnzeigenBevoelkerung()) BevoelkerungsversorgungVisualisierung = new CVisualisierung("Bevoelkerungsversorgung",500,25);
    if (Parameter->pruefenAnzeigenBevoelkerung())BevoelkerungsversorgungVisualisierung->zeigenMatrixRelativ(Bevoelkerungsraster,MaximumBevoelkerung);
    Fortschritt->meldenLaufzeitAusgabe("Flaechenverteilung");
    raster = rasternFlaeche();
    Flaechenraster = new matrix(Parameter->holenBevoelkerungsrasterEinheiten(),Parameter->holenBevoelkerungsrasterEinheiten(),raster);
    delete[] raster;
    if (Parameter->pruefenAnzeigenFlaeche()) FlaechendeckungVisualisierung = new CVisualisierung("Flaechendeckung",500,150,100,100);
    if (Parameter->pruefenAnzeigenFlaeche()) FlaechendeckungVisualisierung->zeigenMatrixRelativ(Flaechenraster,MaximumFlaeche);
    //rasternFahrtwuensche();

    // Strassennetz erstellen
    Fortschritt->meldenLaufzeitAusgabe("Strassennetzgraph");
//    Debug(5,"Strassen           = " << Parameter->holenStrassennetzliste()->size());
    erzeugenStrassennetzGraph();
    Debug(5,"Strassensegmente   = " << Strassennetz->number_of_edges());
    Debug(5,"Strassenkreuzungen = " << Strassennetz->number_of_nodes());
    Fortschritt->meldenLaufzeitAusgabe("Strassennetzkuerzung");
    kuerzenStrassennetz();
//wartenTaste();
//    ausgebenStrassennetzGraph();
    if (Parameter->pruefenAnzeigenStrassennetz()) StrassenVisualisierung = new CVisualisierung("Strassennetz", 800,25);
//    StrassenVisualisierung->minimize();
    if (Parameter->pruefenAnzeigenStrassennetz()) StrassenVisualisierung->zeigenStrassen(Strassennetz,begrenzungLinks,begrenzungOben,begrenzungRechts,begrenzungUnten);

    // Sektoren mit Strassensegmenten erstellen
    Fortschritt->meldenLaufzeitAusgabe("Sektorgruppierung");
    anfordernSektoren(SektorAusdehnung);
    aufbauenSektoren();

//wartenTaste();

  } else {
    cerr << "Aufruf ohne Schnittstelle!\n";
  }
} // initialisieren

//------------------------------------------------------------------------------
// Funktionsname:	CStrassennetz()
// Beschreibung:	Konstruktor
// Parameter:	
// Rueckgabe:	
// Besonderheiten:	
//------------------------------------------------------------------------------

CStrassennetz::CStrassennetz()
{
// implementiert
//  Debug(1, "CStrassennetz()");
  lnkSchnittstelle=NULL;
//  initialisieren();
  Debug(0, "Unsinnige Erzeugung");
} // CStrassennetz


//------------------------------------------------------------------------------
// Funktionsname:	CStrassennetz()
// Beschreibung:	2. Konstruktor
// Parameter:	
// Rueckgabe:	
// Besonderheiten:	
//------------------------------------------------------------------------------

CStrassennetz::CStrassennetz(bool * abbruch, CHSSchnittstelle * lnkSchnittstelle, CParameterHaltestelle * Parameter, CFortschritt * Fortschritt = NULL)
{
// implementiert
//  Debug(1, "CStrassennetz(bool * abbruch)");
  this->Fortschritt = Fortschritt;
  if (lnkSchnittstelle==NULL) {
    string meldung("Es fehlen instanzierte Verweise auf die Schnitstelle!");
    Error(meldung);
    throw CHaltestelleExceptions(meldung);
  }
  this->lnkSchnittstelle = lnkSchnittstelle;
  this->Parameter = Parameter;
//  initialisieren();
  if (abbruch==NULL) {
    string meldung("Es fehlen instanzierte Verweise auf die Schnitstelle!");
    Error(meldung);
    throw CHaltestelleExceptions(meldung);
  }
  abbrechen = abbruch;
} // CStrassennetz

//------------------------------------------------------------------------------
// Funktionsname:	starten()
// Beschreibung:	Startet die Berechnung der Haltestellen und
//		die Erzeugung der Verkehrsbedarfsmatrix.
//		Stoppt die Berechnung, falls das Flag abbrechen
//		gesetzt wurde.
// Parameter:	
// Rueckgabe:	
// Besonderheiten:	Gibt die Eregebnisse der Berechnungen an die Schnittstelle
//		durch Aufruf der Methode haltestellenErgebnisrueckgabe zurueck	
// Autor: 		Marc Pompl
//------------------------------------------------------------------------------

void CStrassennetz::starten(void)
{
  initialisieren();
// implementiert
  Fortschritt->setzenNaechstenSchritt();
  char ausgabe[200];

  //Debug(2, "CStrassennetz::starten()");
  if (*abbrechen)
    return;

  // Haltestellen berechnen
  Fortschritt->meldenLaufzeitAusgabe("Haltestellenberechnung");
  berechnenHaltestellen();

//  ausgebenHaltestellen();
//  wartenTaste();

  if (*abbrechen)
    return;

  // Haltestellen an das Strassennetz anpassen
  Fortschritt->meldenLaufzeitAusgabe("Haltestellenanpassung");
  anpassenHaltestellenStrassennetz();
  if (*abbrechen)
    return;

//  ausgebenHaltestellen();
//  wartenTaste();

  // Haltestellen an das Strassennetz anpassen
  Fortschritt->meldenLaufzeitAusgabe("Haltestellenkorrektur");
  bearbeitenUeberfluessigerHaltestellen();
  if (Parameter->pruefenAnzeigenStrassennetz()) StrassenVisualisierung->zeigenHaltestellen(HaltestellenKnoten, begrenzungLinks, begrenzungOben, begrenzungRechts, begrenzungUnten);
  if (*abbrechen)
    return;

//  ausgebenHaltestellen();
//  wartenTaste();

//  ausgebenHaltestellen();
//  wartenTaste();

  // Bewerten
  Fortschritt->meldenLaufzeitAusgabe("Haltestellenbewertung");
  sprintf(ausgabe,"Bewertung = %f",bewerten(HaltestellenKnoten));
  Fortschritt->meldenLaufzeitAusgabe(ausgabe);
  if (*abbrechen)
    return;

  Fortschritt->setzenNaechstenSchritt();

  // Verkehrsbedarfsmatrix erstellen
  Fortschritt->meldenLaufzeitAusgabe("Verkehrsbedarfsmatrixerstellung");
  erzeugenVerkehrsbedarfsmatrix();
  if (*abbrechen)
    return;
//wartenTaste();

  // Strassennetz um Haltestellen erweitern
  Fortschritt->meldenLaufzeitAusgabe("Strassennetzerweiterung");
  HaltestellenImStrassennetz = einfuegenHaltestellenStrassennetz(Strassennetz,HaltestellenKnoten);
//  Debug(5,"Haltestellen = " << HaltestellenImStrassennetz->size());
//  if (Parameter->pruefenAnzeigenStrassennetz()) StrassenVisualisierung->zeigenStrassen(Strassennetz,begrenzungLinks,begrenzungOben,begrenzungRechts,begrenzungUnten);
  if (Parameter->pruefenAnzeigenStrassennetz()) StrassenVisualisierung->zeigenHaltestellen(HaltestellenKnoten, begrenzungLinks, begrenzungOben, begrenzungRechts, begrenzungUnten);

  if (*abbrechen)
    return;

  // Strassennetz Bidirektional
  Fortschritt->meldenLaufzeitAusgabe("Strassennetzverbindung");
//  Make_Connected(*Strassennetz);
  Strassennetz->make_bidirected();

#ifdef REALWEG_TEST_UMGEBUNG
  // holt sich die erste Haltestelle (ab '1' gezaehlt)
  Debug(0, "WARNING: OVERRIDE ACTIVE!");
  berechnenRealwegumgebung(Strassennetz, HaltestellenImStrassennetz->contents(HaltestellenImStrassennetz->get_item(1)));
  Debug(0, "Realwegberechnung fertig.");
#endif

  if (*abbrechen)
    return;

  // Haltestellen an das Strassennetz anpassen
  Fortschritt->meldenLaufzeitAusgabe("Haltestellennummerierung");
  nummerierenHaltestellen();

  if (*abbrechen)
    return;

  // Wegenetzgraph erstellen
  Fortschritt->meldenLaufzeitAusgabe("Wegenetzgrapherstellung");
  berechnenWegenetzgraph();

  if (*abbrechen)
    return;

  // Wegenetzgraph zusammenhaengen
  Fortschritt->meldenLaufzeitAusgabe("Wegenetzgraphzusammenhaengung");
  erstellenZusammenhangWegenetzgraph();
//  ausgebenWegenetzGraph(Wegenetzgraph);
  Guetemasse->speichernAnzahlHaltestellen(Wegenetzgraph->number_of_nodes());

  if (*abbrechen)
    return;

  // Haltestellenpositionen kuerzen
  Fortschritt->meldenLaufzeitAusgabe("Koordinatenkuerzung");
  kuerzenKoordinaten(Wegenetzgraph);

//wartenTaste();

  assert(Wegenetzgraph);
  assert(Is_Connected(*Wegenetzgraph));
  assert(Is_Bidirected(*Wegenetzgraph));
  assert(Verkehrsbedarfsmatrix);
  // Werte an Schnittstelle zurueckgeben
  Fortschritt->meldenLaufzeitAusgabe("Guetemasse");
  Guetemasse->speichernFusswegProHaltestelle((Parameter->holenMinimalesEinzugsgebiet()*2+Parameter->holenMaximalesEinzugsgebiet())/6);
  lnkSchnittstelle->speichernGuetemasse(Guetemasse);
  Fortschritt->meldenLaufzeitAusgabe("Werterueckgabe");
  //Guetemasse->setzenQuelleZielMatrix(Verkehrsbedarfsmatrix);   Geschieht im Moment in der Methode erzeugenVerkehrsbedarfsmatrix!!! (Jrg)
  lnkSchnittstelle->haltestellenErgebnisrueckgabe(Wegenetzgraph,Verkehrsbedarfsmatrix);
  *abbrechen=true;
} // starten

//------------------------------------------------------------------------------
// Funktionsname:	berechnenHaltestellen()
// Beschreibung:	Diese Methode wird in der Klasse implementiert,
//		die von dieser Klasse erbt. Dort wird das jeweilige
//		Verfahren angewandt
//		@see CStrassennetz - Vererbungs-hierarchie
// Parameter:	
// Rueckgabe:	
// Besonderheiten:	Das Ergebnis der Berechnung ist eine Liste von Haltestellen.
//------------------------------------------------------------------------------

void CStrassennetz::berechnenHaltestellen()
{
//  Debug(2, "CStrassennetz::berechnenHaltestellen()");
  CWegenetzKnoten * myk;
  // Nur eine leere Liste anlegen.
  HaltestellenKnoten = new list<CWegenetzKnoten*>;
  // Pflichthaltestellen eintragen...
  Debug(5,"Pflichthaltestellen = " << Parameter->holenPflichthaltestellen()->size());
  for (int i=0; i<Parameter->holenPflichthaltestellen()->size(); i++) {
    myk = new CWegenetzKnoten(i,10);
    myk->setzenPosition(Parameter->holenPflichthaltestellen()->contents(Parameter->holenPflichthaltestellen()->get_item(i)));
    HaltestellenKnoten->append(myk);
  }
//  Debug(7,"Haltestellen = " << HaltestellenKnoten->size());
} // berechnenHaltestellen

//------------------------------------------------------------------------------
// Funktionsname:	faellenLot()
// Beschreibung:	Die Haltestellen werden an die STRASSEN
//		angepasst
// Parameter:	Die Haltestelle haltestelle vom Typ CPunkt
// Rueckgabe:	Den Punkt selbst, wenn es einen Lot-Fusspunkt gibt,
//		ansonsten NULL
//Besonderheiten:	./.
//------------------------------------------------------------------------------

CPunkt * CStrassennetz::faellenLot(CPunkt * haltestelle, bool NotfallsEndpunkteNehmen = false)
{
// implementiert
//  edge * kante = new edge();
  CPunkt * zielpunkt = NULL, * fusspunkt;
  double entfernung = MAX_DOUBLE, entfernungNeu;
  rat_point * p;
  double x,y;
  unsigned int sektor;
  rat_segment * seg = new rat_segment();
  rat_segment * lot;
  list<edge> * Strassen = NULL;
  bool zielIstKante = false;
  bool zielIstEndpunkt = false;
  edge zielKante;
  double laenge;
  unsigned int position;

  haltestelle->holen(&x,&y);
  p = new rat_point(x,y);
//  Debug(3, "CStrassennetz::faellenLot()");
  // In welchem Sektor befinden wir uns? Dort muessen wir nur die
  // Strassen pruefen!
  sektor = pruefenSektor(*p);
//  Debug(8,"Sektor: " << sektor);
  Strassen = sammelnStrassenAusSektoren(sektor);
  for(int i=0; i<Strassen->size(); i++) { // Alle Strasen des Sektors holen
//    cout << i << "\n";
    *seg = Strassennetz->inf(Strassen->contents(Strassen->get_item(i)));
    if (NotfallsEndpunkteNehmen) { // Endpunkte des Segmentes ueberpruefen?
      // Punkt 1 ueberpruefen...
      x = haltestelle->holenX()-seg->xcoord1D();
      y = haltestelle->holenY()-seg->ycoord1D();
      entfernungNeu = sqrt((x*x)+(y*y));
      if (entfernungNeu<entfernung) { // Nur bernehmen, wenn neue Entfernung krzer, als bisherige!
//      Debug(9,"Entfernung: " << entfernungNeu);
        entfernung = entfernungNeu;
        if (zielpunkt!=NULL) {
          delete zielpunkt;
        }
        zielpunkt = new CPunkt(seg->xcoord1D(),seg->ycoord1D());
        zielKante = Strassen->contents(Strassen->get_item(i));
        zielIstEndpunkt = true;
        zielIstKante = false;
      }
      // Punkt 2 ueberpruefen...
      x = haltestelle->holenX()-seg->xcoord2D();
      y = haltestelle->holenY()-seg->ycoord2D();
      entfernungNeu = sqrt((x*x)+(y*y));
      if (entfernungNeu<entfernung) { // Nur bernehmen, wenn neue Entfernung krzer, als bisherige!
//      Debug(9,"Entfernung: " << entfernungNeu);
        entfernung = entfernungNeu;
        if (zielpunkt!=NULL) {
          delete zielpunkt;
        }
        zielpunkt = new CPunkt(seg->xcoord2D(),seg->ycoord2D());
        zielKante = Strassen->contents(Strassen->get_item(i));
        zielIstEndpunkt = true;
        zielIstKante = false;
      }
    }
    // Pruefen des Lotes...
    lot = new rat_segment();
    if (seg->is_trivial()) { // Ist doch wohl keine degenerierte Strasse?
      string message("Eine degenerierte Strasse, bei der das Segment auf einen Punkt faellt!");
      throw CHaltestelleExceptions(message);
    };
    *lot = seg->perpendicular(*p);
//    Debug(9,"Strassensegment: " << *seg);
//    Debug(9,"Lotpunkt       : " << *p);
    if (lot->is_trivial()) { // Ist das lot degeneriert?
//      Debug(9,"Triviales Lot    : " << *lot);
      entfernung = 0;
      zielpunkt = new CPunkt(p->xcoordD(),p->ycoordD());
      i=Strassen->size();
//      wartenTaste();
      break;
    };
    if (seg->intersection(*lot)) { // Ist der Lotfusspunkt Teil der Linie?
      fusspunkt = new CPunkt(lot->xcoord2D(),lot->ycoord2D());
//      Debug(9,"Lot            : " << *lot);
      x = lot->xcoord1D()-lot->xcoord2D();
      y = lot->ycoord1D()-lot->ycoord2D();
      entfernungNeu = sqrt((x*x)+(y*y));
      if (entfernungNeu<entfernung) { // Nur bernehmen, wenn neue Entfernung krzer, als bisherige!
//      Debug(9,"Entfernung: " << entfernungNeu);
        entfernung = entfernungNeu;
        if (zielpunkt!=NULL) {
          delete zielpunkt;
        }
        zielpunkt = fusspunkt;
// TODO:
        zielIstEndpunkt = false;
        zielIstKante = true;
        zielKante = Strassen->contents(Strassen->get_item(i));
      } else {
        delete fusspunkt;
      }
    }
    delete lot;
  };

  if ((zielIstKante) || (zielIstEndpunkt)) {
//    if (zielIstKante) { cout << "zielIstKante\n"; } else { cout << "zielistEndpunkt\n"; }
    // Ermitteln des Pfades zu den angrenzenden Kreuzungen
    node * KreuzungsKnoten_1 = new node(), * KreuzungsKnoten_2 = new node();
    list<node *> * linkeKnotenfolge = new list<node *>,  * rechteKnotenfolge = new list<node *>;
    ermittelnInzidenteKnoten(&zielKante, KreuzungsKnoten_1, KreuzungsKnoten_2, linkeKnotenfolge, rechteKnotenfolge);
    // Uebernehmen des kuerzeren Pfades
    list<CPunkt * > * linkerPfad = new list<CPunkt *>,  * rechterPfad = new list<CPunkt *>, * pfad = NULL;
      // Pfad 1 bestimmen
      linkerPfad->append(zielpunkt);
//      Debug(8,"Linker Pfad: " << linkeKnotenfolge->size());
      for (int i=0; i<linkeKnotenfolge->size(); i++) {
        linkerPfad->append(new CPunkt(Strassennetz->inf(*linkeKnotenfolge->contents(linkeKnotenfolge->get_item(i))).xcoordD(),Strassennetz->inf(*linkeKnotenfolge->contents(linkeKnotenfolge->get_item(i))).ycoordD()));
      }
      linkerPfad->append(new CPunkt(Strassennetz->inf(*KreuzungsKnoten_1).xcoordD(),Strassennetz->inf(*KreuzungsKnoten_1).ycoordD()));
      // Pfad 2 bestimmen
      rechterPfad->append(zielpunkt);
//      Debug(8,"Rechter Pfad: " << rechteKnotenfolge->size());
      for (int i=0; i<rechteKnotenfolge->size(); i++) {
        rechterPfad->append(new CPunkt(Strassennetz->inf(*rechteKnotenfolge->contents(rechteKnotenfolge->get_item(i))).xcoordD(),Strassennetz->inf(*rechteKnotenfolge->contents(rechteKnotenfolge->get_item(i))).ycoordD()));
      }
      rechterPfad->append(new CPunkt(Strassennetz->inf(*KreuzungsKnoten_2).xcoordD(),Strassennetz->inf(*KreuzungsKnoten_2).ycoordD()));
      if (Strassennetz->degree(*KreuzungsKnoten_1)<=2) {
        pfad = rechterPfad;
      }
      if (Strassennetz->degree(*KreuzungsKnoten_2)<=2) {
        pfad = linkerPfad;
      }
    if (pfad == NULL) {
      if (ermittelnLaenge(rechterPfad)>=ermittelnLaenge(linkerPfad)) {
        pfad = linkerPfad;
      } else {
        pfad = rechterPfad;
      }
    }
    // Ablaufen des Pfades
    laenge = ermittelnLaenge(pfad);
//    Debug(9,"Laenge: " << laenge);
    laenge *= Parameter->holenHaltestellenlage();
//    Debug(9,"Laenge: " << laenge);
    position = 1;
    while (laenge>ermittelnLaenge(pfad,position)) {
//      Debug(9,"Abgelaufene Laenge: " << ermittelnLaenge(pfad,position));
      position++;
//      cout << position << "\n";
    }
//    Debug(8,"Position ermittelt: " << position);
    double x1 = pfad->contents(pfad->get_item(position-1))->holenX();
    double y1 = pfad->contents(pfad->get_item(position-1))->holenY();
    if (position==1) { // Eigentlich unmoeglich ...
    } else {
        double x2 = pfad->contents(pfad->get_item(position-2))->holenX();
        double y2 = pfad->contents(pfad->get_item(position-2))->holenY();
        double xDiff = x2-x1;
        double yDiff = y2-y1;
        double faktor = (ermittelnLaenge(pfad,position)-laenge)/sqrt((xDiff*xDiff)+(yDiff*yDiff));
        zielpunkt->setzen(x1+(faktor*xDiff),y1+(faktor*yDiff));
    }

    for (int l=0; l<linkerPfad->size(); l++) {
      delete linkerPfad->contents(linkerPfad->get_item(l));
    }
    delete linkerPfad;
    for (int l=0; l<linkerPfad->size(); l++) {
      delete rechterPfad->contents(rechterPfad->get_item(l));
    }
    delete rechterPfad;
  }
  delete p;
  delete seg;
  Strassen->clear();
  delete Strassen;
  if (zielpunkt!=NULL) {
//    Debug(9,"Quellpunkt: " << *haltestelle);
//    Debug(9,"Zielpunkt: " << *zielpunkt);
  }
  return zielpunkt;
} // faellenLot

//------------------------------------------------------------------------------
// Funktionsname:	faellenLot()
// Beschreibung:	Fuer die Haltestellen wird kontrolliert, ob
//		sie auf einer Linien, d.h. auf einem Strassenteil
//		liegt.
// Parameter:	Die Haltestelle haltestelle vom Typ CPunkt,
//		den Linienanfang und das ~ende.
// Rueckgabe:	Ein CPunkt, der die Haltestelle darstellt, falls der
//		Lot-Fusspunkt auf der Linie liegt, ansonsten NULL
// Besonderheiten:	./.
//------------------------------------------------------------------------------

CPunkt * CStrassennetz::faellenLot(CPunkt * haltestelle, CPunkt * linienanfang, CPunkt * linienende) {
// implementiert
  double xp, yp, x1, y1, s, m, x2, y2, xl, yl, sl, ml;
  CPunkt * fusspunkt, * punkt;
//  Debug(4, "CStrassennetz::faellenLot()");
  haltestelle->holen(&xp,&yp);
  linienanfang->holen(&x1,&y1);
  linienende->holen(&x2,&y2);
  if (x1>x2) {
    // Linienanfang muss links von Linienende liegen!
//    Debug(9,"Punkt tauschen");
    fusspunkt = linienanfang;
    linienanfang = linienende;
    linienende = fusspunkt;
    fusspunkt = NULL;
  }
  linienanfang->holen(&x1,&y1);
  linienende->holen(&x2,&y2);

//  Debug(8,"Punkt    : " << *haltestelle );				//Fuer TIm auskommentiert
//  Debug(8,"Linie    : "<< *linienanfang << " - " << *linienende );                          //Fuer TIm auskommentiert

  if (x2==x1) {
    // vertikale Linie

//    Debug(9,"Gerade   : y = " << yp);     //Fuer Tim auskommentiert
//    Debug(9,"Lot      : x = " << x1);     //Fuer Tim auskommentiert

    if (((y1<=yp) && (yp<=y2)) || ((y2<=yp) && (yp<=y1))) {
      fusspunkt = new CPunkt(x1,yp);
    } else {
      // kein Fusspunkt auf der Linie
      fusspunkt = NULL;
    }
  } else if (y2==y1){
    // horizontale Linie
    if (((x1<=xp) && (xp<=x2)) || ((x2<=xp) && (xp<=x1))) {
      fusspunkt = new CPunkt(xp,y1);
    } else {
      // kein Fusspunkt auf der Linie
      fusspunkt = NULL;
    }
  } else {
    // geneigte Linie
    s = (y2-y1)/(x2-x1);
    m = y1-s*x1;
    sl = -1/s;
    ml = yp-sl*xp;
    punkt = berechnenSchnittpunkt(s,m,sl,ml);
    punkt->holen(&xl,&yl);
    delete punkt;
    if (((x1<=xl) && (xl<=x2)) || ((x2<=xl) && (xl<=x1))) {
      fusspunkt = new CPunkt(xl,yl);
    } else {
      // kein Fusspunkt auf der Linie
      fusspunkt = NULL;
    }
  }
  return fusspunkt;
} // faellenLot


//------------------------------------------------------------------------------
// Funktionsname:	anpassenHaltestellenStrassennetz()
// Beschreibung:	Ruft anpassenHaltestellenStrassennetz mit den
//		HaltestellenKnoten auf und legt diese wiederum dort ab.
// Parameter:	
// Rueckgabe:	
// Besonderheiten:	./.
//------------------------------------------------------------------------------

void CStrassennetz::anpassenHaltestellenStrassennetz()
{
// implementiert
  list<CWegenetzKnoten *> * knoten;
//  Debug(2, "CStrassennetz::anpassenHaltestellenStrassennetz()");
//  Debug(5,"Haltestellen (nicht angepasst) = " << HaltestellenKnoten->size());
  knoten = anpassenHaltestellenStrassennetz(HaltestellenKnoten);
  for (int i=0; i<HaltestellenKnoten->size();i++) {
    delete HaltestellenKnoten->contents(HaltestellenKnoten->get_item(i))->holenPosition();
    delete HaltestellenKnoten->contents(HaltestellenKnoten->get_item(i));
  } // for i
  delete HaltestellenKnoten;

  HaltestellenKnoten = knoten;
//  Debug(4,"Haltestellen (angepasst) = " << HaltestellenKnoten->size());
} // anpassenHaltestellenStrassennetz


//------------------------------------------------------------------------------
// Funktionsname:	anpassenHaltestellenStrassennetz()
// Beschreibung:	Passt eine Haltestelle an das Strassennetz an
//		Benutzt dazu faellenLot()
// Parameter:	eine Haltestelle vom Typ CPunkt
// Rueckgabe:	Die angepasste Haltestelle ansonsten NULL
// Besonderheiten:	./.
//------------------------------------------------------------------------------

CPunkt * CStrassennetz::anpassenHaltestellenStrassennetz(CPunkt * haltestelle)
{
// implementiert
//  node knoten;
  CPunkt * Punkt;
//  double entfernung = MAX_DOUBLE, entfernungNeu;
//  Debug(3, "CStrassennetz::anpassenHaltestellenStrassennetz()");
  Punkt = faellenLot(haltestelle,true);

  return Punkt;
} // anpassenHaltestellenStrassennetz

//------------------------------------------------------------------------------
// Funktionsname:	anpassenHaltestellenStrassennetz()
// Beschreibung:	Passt Haltestellen an das Strassennetz an
//		Benutzt dauz faellenLot()
// Parameter:	eine Haltestelle vom Typ CWegenetzKnoten
// Rueckgabe:	Eine Liste von CWegenetzKnoten, die Haltestellen darstellen
// Besonderheiten:	./.
//------------------------------------------------------------------------------

list<CWegenetzKnoten *> * CStrassennetz::anpassenHaltestellenStrassennetz(list<CWegenetzKnoten *> * haltestellen)
{
// implementiert
  list<CWegenetzKnoten *> * haltestellenNeu = new list<CWegenetzKnoten *>;
  CPunkt * haltestelle;
  CWegenetzKnoten * knoten;
//  Debug(2, "CStrassennetz::anpassenHaltestellenStrassennetz()");
  for (int k=0; k<haltestellen->size(); k++) {
  Fortschritt->anzeigenFortschritt(k,haltestellen->size()-1);
    haltestelle = anpassenHaltestellenStrassennetz(haltestellen->contents(haltestellen->get_item(k))->holenPosition());
    if (haltestelle!=NULL) {
      knoten = new CWegenetzKnoten(haltestellen->contents(haltestellen->get_item(k))->holenKnotenId(), haltestellen->contents(haltestellen->get_item(k))->holenPrioritaet());
      knoten->setzenPosition(haltestelle);
      haltestellenNeu->append(knoten);
//      Debug(7,"Haltestelle: " << *knoten);
    }
  }
//  wartenTaste();
  return haltestellenNeu;
} // anpassenHaltestellenStrassennetz


//------------------------------------------------------------------------------
// Funktionsname: bearbeitenUeberfluessigeHaltestellen	
// Beschreibung:	
// Parameter:	
// Rueckgabe:	
// Besonderheiten:	
//------------------------------------------------------------------------------

void CStrassennetz::bearbeitenUeberfluessigerHaltestellen(void)
{
// implementiert
  CPunkt * haltestelleA, * haltestelleB;
  list<CWegenetzKnoten *> * knoten;
  bool uebernehmen = true;
  // Jetzt kuerzen wir noch doppelte Haltestellen, da durch das Anpassen einige auf die gleichen Positionen gefallen sein koennen!
  knoten = new list<CWegenetzKnoten *>;
  for (int i=0; i<HaltestellenKnoten->size();i++) {
    haltestelleA= HaltestellenKnoten->contents(HaltestellenKnoten->get_item(i))->holenPosition();
    uebernehmen = true;
    if (HaltestellenKnoten->contents(HaltestellenKnoten->get_item(i))->holenPrioritaet()<10) {
      for (int j=0; j<i;j++) {
        if (i!=j) {
          haltestelleB = HaltestellenKnoten->contents(HaltestellenKnoten->get_item(j))->holenPosition();
/*          if (Parameter->holenAlgorithmustyp()==evolutionaereStrategie) {
            if (ermittelnEntfernung(haltestelleA,haltestelleB)<Parameter->holenToleranzgrenze()) {
              uebernehmen = false;
            }
          } else {*/
            if (ermittelnEntfernung(haltestelleA,haltestelleB)<Parameter->holenMinimalesEinzugsgebiet()) {
              uebernehmen = false;
            }
//          }
        }
      } // for j
    }
    if (uebernehmen) {
      knoten->append(new CWegenetzKnoten(*HaltestellenKnoten->contents(HaltestellenKnoten->get_item(i))));
    }
  } // for i

  // Loeschen der Haltstellen in der Liste!
  for (int i=0; i<HaltestellenKnoten->size(); i++) {
    delete HaltestellenKnoten->contents(HaltestellenKnoten->get_item(i));
  }
  delete HaltestellenKnoten;
  HaltestellenKnoten = knoten;
//  Debug(5,"Haltestellen (gekuerzt) = " << HaltestellenKnoten->size());
} // bearbeitenUeberfluessigerHaltestellen

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:	
// Rueckgabe:	
// Besonderheiten:	
//------------------------------------------------------------------------------

list<CPunkt *> * CStrassennetz::ermittelnKuerzesteWege(double radius, CPunkt * startHaltestelle, CPunkt * zielHaltestelle)
{
  list<CPunkt *> * weg = new list<CPunkt *>;
//  Debug(3, "CStrassennetz::ermittelnKuerzesteWege()");
  return weg;
} // ermittelnKuerzesteWege

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:	
// Rueckgabe:	
// Besonderheiten:	
//------------------------------------------------------------------------------

double CStrassennetz::berechnenEntfernungen(CPunkt * startpunkt, CPunkt * zielpunkt)
{
// implementiert
//  Debug(2, "CStrassennetz::berechnenEntfernungen()");
  switch (Parameter->holenRadiustyp()) {
    case luftlinie: // Wir nehmen die Luftlinie!
      return ermittelnEntfernung(startpunkt,zielpunkt)/EntfernungsFaktor;
      break;
    case realweg: // Wir nehmen den Realweg!
        list<CPunkt *> * verbindung = suchenVerbindung(startpunkt,zielpunkt);
        double entfernung = ermittelnLaenge(verbindung);
        for (int i=0; i<verbindung->size(); i++) {
          delete verbindung->contents(verbindung->get_item(i));
        }
        delete verbindung;
        return entfernung;
      break;
  }
  // Kann ja eh' nie erreicht werden!
  return MAX_DOUBLE;
} // berechnenEntfernungen


//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:	
// Rueckgabe:	
// Besonderheiten:	
//------------------------------------------------------------------------------

void CStrassennetz::erzeugenVerkehrsbedarfsmatrix()
{
  // ist aktuell von Marc in Arbeit!!!
  int AnzahlHaltestellen;
  double * VerkehrsBedarfsMatrix;
  CWegenetzKnoten * haltestelle;
//  CQuelleZielListeElement * qzpunkt;
//  list<CPunkt *> * liste;
//  double einflussFaktor;
  CPunkt * Punkt;
  double xStep, yStep;
  double xPos, yPos;
  double reisende;
//  Debug(2, "CStrassennetz::erzeugenVerkehrsbedarfsmatrix()");
  // Vorbereitungen...
  AnzahlHaltestellen = HaltestellenKnoten->size();
  if (AnzahlHaltestellen==0) {
    // keine Haltestellen, also auch keine Matrix erstellbar!
    string meldung("Keine Haltestellen!");
    throw CHaltestelleExceptions(meldung);
  }
  if (AnzahlHaltestellen==1) {
    // zu wenig Haltestellen, also auch keine Matrix erstellbar!
    string meldung("Zu wenig Haltestellen!");
    throw CHaltestelleExceptions(meldung);
  }
  VerkehrsBedarfsMatrix = new double[AnzahlHaltestellen*AnzahlHaltestellen];
  // mit Werten belegen...
  for (int i=0; i<AnzahlHaltestellen; i++) {
    // fuer alle Haltestellen...
    Fortschritt->anzeigenFortschritt(i,AnzahlHaltestellen);
//    Debug(8,"Haltestelle " << i);
    haltestelle = HaltestellenKnoten->contents(HaltestellenKnoten->get_item(i));
    // Ueperpruefen der Eintraege aus der Bevoelkerungsdichtenliste...
//    Debug(6,"Bevoelkerungsraster");
    // schrittweite in GRASS-Einheiten berechnen...
    xStep = (begrenzungRechts-begrenzungLinks)/Parameter->holenBevoelkerungsrasterEinheiten();
    yStep = (begrenzungOben-begrenzungUnten)/Parameter->holenBevoelkerungsrasterEinheiten();
    for(int y=0; y<Bevoelkerungsraster->dim2(); y++) {
      yPos = y*yStep+begrenzungOben;
      for(int x=0; x<Bevoelkerungsraster->dim1(); x++) {
	xPos = x*xStep+begrenzungLinks;
	Punkt = new CPunkt(xPos,yPos);
//        Debug(9,"Rasterposition: [" << x << "/" << y << "]");
        reisende = ((*Bevoelkerungsraster)(x,y));
//        Debug(9,"Reisende      : " << reisende);
        if (ermittelnEntfernung(Punkt, (HaltestellenKnoten->contents(HaltestellenKnoten->get_item(i)))->holenPosition())<=Parameter->holenMinimalesEinzugsgebiet()) {
          reisende = (*Bevoelkerungsraster)(x,y);
        }
        if (ermittelnEntfernung(Punkt, (HaltestellenKnoten->contents(HaltestellenKnoten->get_item(i)))->holenPosition())<=Parameter->holenMaximalesEinzugsgebiet()) {
          reisende += (*Bevoelkerungsraster)(x,y)*0.6;
        }
        for (int m=0; m<AnzahlHaltestellen; m++) {
          if (m!=i) {
// Zur Sicherheit berall einen Fahrgast hinzuaddieren
            VerkehrsBedarfsMatrix[m*AnzahlHaltestellen+i] = (reisende/(AnzahlHaltestellen-1))*1000+1;
          }
        } // for
        delete Punkt;
//        cout << VerkehrsBedarfsMatrix[y*AnzahlHaltestellen+x] << " ";
      } // for x
//      cout << "\n";
    } // for y
//    delete liste;
    // Nun noch die existierenden Fahrtwuensche ummappen
    list<CQuelleZielListeElement*> * QuelleZielListe = Parameter->holenQuelleZielListe();
    double x1 = haltestelle->holenPosition()->holenX(), y1 = haltestelle->holenPosition()->holenY();
    double fahrtwunsch = 0;
    for (int j=0; j<QuelleZielListe->size(); j++) {
      CQuelleZielListeElement * QuelleZielElement = QuelleZielListe->contents(QuelleZielListe->get_item(j));
      CPunkt * Position = QuelleZielElement->holenPunkt();
      double x2 = Position->holenX(), y2 = Position->holenY();
      double xd = x2-x1, yd = y2-y1;
      double entfernung = sqrt(xd*xd+yd*yd);
      double wert = 0;
      if (entfernung<=Parameter->holenMaximalesEinzugsgebiet()) { // Innerhalb des Einzugsgebietes?
//        Debug(9,"im minimalen Einzugsgebiet");
        double faktor = 1-(entfernung/Parameter->holenMaximalesEinzugsgebiet());
        for (int k=0; k<Parameter->holenQuelleZielMatrix()->dim1(); k++) {
          if (QuelleZielElement->holenID()!=k) {
            if ((*Parameter->holenQuelleZielMatrix())(k,QuelleZielElement->holenID())>0)
              wert += (*Parameter->holenQuelleZielMatrix())(k,QuelleZielElement->holenID())*faktor;
            if ((*Parameter->holenQuelleZielMatrix())(QuelleZielElement->holenID(),k)>0)
              wert += (*Parameter->holenQuelleZielMatrix())(QuelleZielElement->holenID(),k)*faktor;
          }
        }
        wert /= (Parameter->holenQuelleZielMatrix()->dim1()-1);
      }
      fahrtwunsch += wert;
    }
//    Debug(8,"Fahrtwunsch = " << fahrtwunsch);
    for (int j=0; j<AnzahlHaltestellen; j++) {
      VerkehrsBedarfsMatrix[j*AnzahlHaltestellen+i] += fahrtwunsch;
      VerkehrsBedarfsMatrix[i*AnzahlHaltestellen+j] += fahrtwunsch;
    }
  } // for Haltestellen
//    wartenTaste();
  // Diagonale korrigieren...
  for (int i=0; i<AnzahlHaltestellen; i++) {
    VerkehrsBedarfsMatrix[i*AnzahlHaltestellen+i] = -1;
  }
  // und zuweisen...
  this->Verkehrsbedarfsmatrix = new matrix(AnzahlHaltestellen,AnzahlHaltestellen,VerkehrsBedarfsMatrix);
  // Aufraeumen nicht vergessen!
  delete VerkehrsBedarfsMatrix;
//  Debug(DEBUG_Verkehrsbedarfsmatrix,"Verkehrsbedarfsmatrix:\n" << *(this->Verkehrsbedarfsmatrix));
  Guetemasse->setzenQuelleZielMatrix(Verkehrsbedarfsmatrix);
} // erzeugenVerkehrsbedarfsmatrix

//------------------------------------------------------------------------------
// Funktionsname: 	erzeugenStrassennetzGraph()	
// Beschreibung:	ruft fuer alle Strassen die Methode berechnenKreuzungen auf
// Parameter:	        -
// Rueckgabe:	        -
// Besonderheiten:
// Autor:		Marc Pompl
//------------------------------------------------------------------------------

void CStrassennetz::erzeugenStrassennetzGraph()
{
//  Debug(2, "CStrassennetz::erzeugenStrassennetzGraph()");
  CPunkt * P1, * P2;
  double xp1, yp1, xp2, yp2;
  list<CPunkt *> * Strasse;
  list<rat_segment> * Liste = new list<rat_segment>;
  GRAPH<rat_point,rat_segment> * G = new GRAPH<rat_point,rat_segment>;
  rat_segment * Segment;

  for (int i=0; i<Parameter->holenStrassennetzliste()->size(); i++) {
    Strasse = Parameter->holenStrassennetzliste()->contents(Parameter->holenStrassennetzliste()->get_item(i));
    for(int j=0; j<Strasse->size()-1; j++) {
      P1 = Strasse->contents(Strasse->get_item(j));
      P2 = Strasse->contents(Strasse->get_item(j+1));
      P1->holen(&xp1,&yp1);
      P2->holen(&xp2,&yp2);
      Segment = new rat_segment(xp1, yp1, xp2, yp2);
      Liste->append(*Segment);
    }
  }
//  Parameter->holenStrassennetzliste()->clear();
//  delete Parameter->holenStrassennetzliste();
  SWEEP_SEGMENTS(*Liste, *G);
  delete Liste;
  Strassennetz = G;
}  // erzeugenStrassennetzGraph

//------------------------------------------------------------------------------
// Funktionsname:	ausgebenStrassennetzGraph	
// Beschreibung:	gibt den Strassennetz-Graphen aus
// Parameter:	
// Rueckgabe:	
// Besonderheiten:	
// Autor:		Jrg Draeger, Marc Pompl
//------------------------------------------------------------------------------

void CStrassennetz::ausgebenStrassennetzGraph(void)
{
//   Debug(2,"CStrassennetz::ausgebenStrassennetzGraph()");
   node * AusgabeKnoten = new node();
   edge * AusgabeKante = new edge();

   //cout << Strassennetz->number_of_nodes() << "Knoten\n";
   // Knoten ausgeben
   //forall_nodes(*AusgabeKnoten, *Strassennetz)
   //{
   //   cout << *AusgabeKnoten << ": " << Strassennetz->inf(*AusgabeKnoten) << "\n";
   //}

   //cout << Strassennetz->number_of_edges() << "Kanten\n";
   // Kanten ausgeben
   //forall_edges(*AusgabeKante, *Strassennetz)
   //{
   //   cout << *AusgabeKante << ": " << Strassennetz->inf(*AusgabeKante) << "\n";
   //}

}  // ausgebenStrassennetzGraph


//------------------------------------------------------------------------------
// Funktionsname: umrechnenMeterGRASS
// Beschreibung:  Berechnet Meter in GRASS-Einheiten (double) um.
// Parameter:	  double meter
// Rueckgabe:	  double (in GRASS-Einheiten)
// Besonderheiten:	
//------------------------------------------------------------------------------

double CStrassennetz::umrechnenMeterGRASS(double meter) {
// implementiert
//  Debug(4, "CStrassennetz::umrechnenMeterGRASS()");
  return (meter*UmrechnungMeterGRASS);
} // umrechnenMeterGRASS


//------------------------------------------------------------------------------
// Funktionsname: umrechnenGRASSMeter
// Beschreibung:  Berechnet GRASS-Einheiten (double) in Meter um/
// Parameter:	  double grass
// Rueckgabe:	  double (in Metern)
// Besonderheiten:	
//------------------------------------------------------------------------------

double CStrassennetz::umrechnenGRASSMeter(double grass) {
// implementiert
//  Debug(4, "CStrassennetz::umrechnenGRASSMeter()");
  return (grass/UmrechnungMeterGRASS);
} // umrechnenGRASSMeter


//------------------------------------------------------------------------------
// Funktionsname: ermittelnLaenge
// Beschreibung:  Liefert die Laenge eines Wegstuecks
// Parameter:	  list<CPunkt*>* Weg
// Rueckgabe:	  double
// Besonderheiten:
//------------------------------------------------------------------------------

double CStrassennetz::ermittelnLaenge(list<CPunkt*> * Weg, unsigned int bisZuPosition = 0) {
// implementiert
  double laenge;
	
  CPunkt * Punkt1, * Punkt2;
//  Debug(3, "CStrassennetz::ermittelnLaenge()");
//  Debug(7,"Anzahl der Punkte: " << Weg->size());
  if ((Weg==NULL) || (Weg->size()<2))
    return 0;
  laenge = 0;
  if (bisZuPosition>0) {
//    Debug(9,"bisZuPosition");
    for (unsigned int k=0; k<bisZuPosition-1; k++) {
//      cout << k << "\n";
      Punkt1 = Weg->contents(Weg->get_item(k));
      Punkt2 = Weg->contents(Weg->get_item(k+1));
      laenge += ermittelnEntfernung(Punkt1,Punkt2);
    }
  } else {
    for (int k=0; k<Weg->size()-1; k++) {
      Punkt1 = Weg->contents(Weg->get_item(k));
      Punkt2 = Weg->contents(Weg->get_item(k+1));
      laenge += ermittelnEntfernung(Punkt1,Punkt2);
    }
  }
//  Debug(6,"Laenge           : " << laenge);
  return laenge;
} // ermittelnLaenge

//------------------------------------------------------------------------------
// Funktionsname: ermittelnEntfernung
// Beschreibung:  Berechnet die Laenge der Luftlinie zweier CPunkte.
// Parameter:	  CPunkt *, CPunkt *
// Rueckgabe:	  double
// Besonderheiten:
//------------------------------------------------------------------------------

double CStrassennetz::ermittelnEntfernung(CPunkt * startpunkt, CPunkt * zielpunkt) {
// implementiert
  double x1, x2, y1, y2, a, b;
  double entfernung;
//  Debug(4, "CStrassennetz::ermittelnEntfernung()");
  startpunkt->holen(&x1,&y1);
  zielpunkt->holen(&x2,&y2);
//  Debug(9,"Punkt 1: " << " [" << x1 << "/" << y1 << "]");
//  Debug(8,"Punkt 2: " << " [" << x2 << "/" << y2 << "]");
  a = x2-x1;
  b = y2-y1;
  entfernung = sqrt(a*a+b*b);
//  Debug(6,"Entfernung: " << entfernung);
  return entfernung;
} // ermittelnEntfernung

//------------------------------------------------------------------------------
// Funktionsname:	rasternBevoelkerung
// Beschreibung:	Legt die vorhandenen Bevoelkerungsdaten in ein Raster
// Parameter:		keine
// Rueckgabe:		Feld von double's welche das Bevoielkerungsraster darstellt.
// Verwendet:		BevoelkerungsrasterEinheiten
// Besonderheiten:	
//------------------------------------------------------------------------------

double * CStrassennetz::rasternBevoelkerung(list<CBevoelkerungsdichteElement *> * Bevoelkerungsdichtenliste) {
// implementiert
  double * raster;
  CBevoelkerungsdichteElement * BevoelkerungsdichteElement;
  int anzahlUeberlappung;
  double x_step, y_step;
//  Debug(3, "CStrassennetz::rasternBevoelkerung()");
  // erstmal alles auf Null setzen...
  raster = new double[Parameter->holenBevoelkerungsrasterEinheiten()*Parameter->holenBevoelkerungsrasterEinheiten()];
  for (unsigned int i=0; i<Parameter->holenBevoelkerungsrasterEinheiten()*Parameter->holenBevoelkerungsrasterEinheiten(); i++) {
    // Wir setzen ungleich Null, um unschoene Seiteneffekte zu vermeiden.
    raster[i]=1;
  }
  // schrittweite in GRASS-Einheiten berechnen...
  x_step = (begrenzungRechts-begrenzungLinks)/Parameter->holenBevoelkerungsrasterEinheiten();
  y_step = (begrenzungOben-begrenzungUnten)/Parameter->holenBevoelkerungsrasterEinheiten();
//  Debug(6,"Begrenzungen: " << x_step << "/" << y_step);
  // zeilenweise mit werten belegen...
  for (unsigned int y=0; y<Parameter->holenBevoelkerungsrasterEinheiten(); y++) {
    Fortschritt->anzeigenFortschritt(y,Parameter->holenBevoelkerungsrasterEinheiten()-1);
    for (unsigned int x=0; x<Parameter->holenBevoelkerungsrasterEinheiten(); x++) {
//      Debug(8,"Position     : [" << x << "/" << y << "]");
//      Debug(8,"[" << begrenzungLinks+(x*x_step)-(x_step/2) << "/" << begrenzungOben+(y*y_step)-(y_step/2) << "]");
      anzahlUeberlappung=0;
      // mit den Bevoelkerungsdichten vergleichen...
      for (int k=0; k<Bevoelkerungsdichtenliste->size(); k++) {
        BevoelkerungsdichteElement = Bevoelkerungsdichtenliste->contents(Bevoelkerungsdichtenliste->get_item(k));
//        Debug(8,"Element: " << *(BevoelkerungsdichteElement->holenPunkt()) << " " << BevoelkerungsdichteElement->holenRadius() << " " << BevoelkerungsdichteElement->holenDichte());
        // ... und eintragen...
        if (BevoelkerungsdichteElement->holenRadius()>=ermittelnEntfernung(BevoelkerungsdichteElement->holenPunkt(),new CPunkt(begrenzungLinks+((x+0.5)*x_step),begrenzungUnten+((Parameter->holenBevoelkerungsrasterEinheiten()-y-0.5)*y_step)))) {
          anzahlUeberlappung++;
//          Debug(9,"Dichte       : " << BevoelkerungsdichteElement->holenDichte()*x_step*y_step/(BevoelkerungsdichteElement->holenRadius()*BevoelkerungsdichteElement->holenRadius()*PI));
          raster[y*Parameter->holenBevoelkerungsrasterEinheiten()+x] += BevoelkerungsdichteElement->holenDichte()*x_step*y_step/(BevoelkerungsdichteElement->holenRadius()*BevoelkerungsdichteElement->holenRadius()*PI);
        }
      } // for k
      if (anzahlUeberlappung>1)
        raster[y*(Parameter->holenBevoelkerungsrasterEinheiten())+x] /= anzahlUeberlappung;
//        Debug(8,"Raster-Dichte: " << raster[y*Parameter->holenBevoelkerungsrasterEinheiten()+x]);
//    Debug(5,"" << raster[y*Parameter->holenBevoelkerungsrasterEinheiten()+x] << " ");
    } // for x
  } // for y
  return raster;
} //rasternBevoelkerung


//------------------------------------------------------------------------------
// Funktionsname:	rasternFlaeche
// Beschreibung:	Legt die vorhandene Flaeche in ein Raster
// Parameter:		keine
// Rueckgabe:		Feld von double's welche das Flaechenraster darstellt.
// Verwendet:		BevoelkerungsrasterEinheiten
// Besonderheiten:	
//------------------------------------------------------------------------------

double * CStrassennetz::rasternFlaeche(void) {
// implementiert
  double * raster;
//  Debug(3, "CStrassennetz::rasternFlaeche()");
  // erstmal alles auf Null setzen...
  raster = new double[Parameter->holenBevoelkerungsrasterEinheiten()*Parameter->holenBevoelkerungsrasterEinheiten()];
  for (unsigned int i=0; i<Parameter->holenBevoelkerungsrasterEinheiten()*Parameter->holenBevoelkerungsrasterEinheiten(); i++) {
    raster[i]=0;
  }
  // schrittweite in GRASS-Einheiten berechnen...
  MaximumFlaeche = fabs((begrenzungRechts-begrenzungLinks)*(begrenzungOben-begrenzungUnten)/(Parameter->holenBevoelkerungsrasterEinheiten()*Parameter->holenBevoelkerungsrasterEinheiten()));
//  Debug(6,"Begrenzungen: " << x_step << "/" << y_step);
  // zeilenweise mit werten belegen...
  for (unsigned int y=0; y<Parameter->holenBevoelkerungsrasterEinheiten(); y++) {
    Fortschritt->anzeigenFortschritt(y,Parameter->holenBevoelkerungsrasterEinheiten()-1);
    for (unsigned int x=0; x<Parameter->holenBevoelkerungsrasterEinheiten(); x++) {
      raster[y*Parameter->holenBevoelkerungsrasterEinheiten()+x] = MaximumFlaeche;
//      Debug(8,"Position     : [" << x << "/" << y << "]");
//    Debug(5,"Wert: " << raster[y*Parameter->holenBevoelkerungsrasterEinheiten()+x] << " ");
    } // for x
  } // for y
  return raster;
} //rasternFlaeche


//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:	
// Rueckgabe:	
// Besonderheiten:	
//------------------------------------------------------------------------------

void CStrassennetz::rasternFahrtwuensche() {
  Debug(3, "CStrassennetz::rasternFahrtwuensche()");
} //rasternFahrtwuensche

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:	
// Rueckgabe:	
// Besonderheiten:	
//------------------------------------------------------------------------------

void CStrassennetz::berechnenWegenetzgraph(void)
{
  Wegenetzgraph = berechnenWegenetzgraph(Strassennetz,HaltestellenKnoten);
} // berechnenWegenetzgraph

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:	
// Rueckgabe:	
// Besonderheiten:	
//------------------------------------------------------------------------------

GRAPH<CWegenetzKnoten *, CWegenetzKante * > * CStrassennetz::berechnenWegenetzgraph(GRAPH<rat_point,rat_segment> *Strassennetz, list<CWegenetzKnoten*> *Haltestellen)
{
//Debug(2, "CStrassennetz::berechnenWegenetzgraph()");

 GRAPH<CWegenetzKnoten *, CWegenetzKante * > * WegenetzGraph; // Das ist der Wegenetzgraph
 WegenetzGraph = new GRAPH<CWegenetzKnoten * ,CWegenetzKante *>;
 map2<int, int, double > * WegeMap = new map2<int, int, double >;
  list<CPunkt *> * verbindung;
  node * knoten = new node();
  node * hilfsknoten = new node();
  CWegenetzKante * HaltestellenVerbindung;
  edge * WegenetzKante = new edge();
  node * WegenetzKnoten = new node();
  CWegenetzKnoten * haltestelle;
  node * Start = new node();
  node * Ziel = new node();
  double x1, y1, x2, y2;
  verbindungsListe = new list<CVerbindung * >;
  double laenge = 0;

//  CWegenetzKante*  kante;
//  CPunkt* haltestellenposition = new CPunkt();
  for(int i=0; i<Haltestellen->size(); i++) {
    // Jede Haltestelle...
    haltestelle = Haltestellen->contents(Haltestellen->get_item(i));
    Start = HaltestellenImStrassennetz->contents(HaltestellenImStrassennetz->get_item(i));
    x1 = fabs(Strassennetz->inf(*Start).xcoordD());
    y1 = fabs(Strassennetz->inf(*Start).ycoordD());
    haltestelle->setzenPosition(x1,y1);
//    WegenetzKnoten = new node();
    *WegenetzKnoten = WegenetzGraph->new_node(haltestelle);
//    Debug(7,"Neuer Knoten " << i);
    Fortschritt->anzeigenFortschrittSteigenderAufwand(i,Haltestellen->size()-1);
    for(int j=0; j<i; j++) {
//    forall_nodes(*knoten,*WegenetzGraph) {
      // mit jeder anderen...
      Fortschritt->anzeigenAktivitaet();

      Ziel = HaltestellenImStrassennetz->contents(HaltestellenImStrassennetz->get_item(j));
//      Debug(9,"1");
//      verbindung = suchenVerbindung(haltestelle->holenPosition(),WegenetzGraph->inf(*knoten)->holenPosition());
      x2 = fabs(Strassennetz->inf(*Ziel).xcoordD());
      y2 = fabs(Strassennetz->inf(*Ziel).ycoordD());

      if ((Parameter->holenRadiustyp()==luftlinie) && (sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1))>Parameter->holenVerbindungsradius())) {
        verbindung = new list<CPunkt *>;
        verbindung->append(new CPunkt(x2,y2));
        verbindung->append(new CPunkt(x1,y1));
        UeberHaltestellenGelaufen = false;
      } else {
        verbindung = suchenVerbindung(Start,Ziel,true);
      }
      laenge = ermittelnLaenge(verbindung);
      // Guetemasse: Weg von HS zu HS
      (*WegeMap)(i,j) = laenge;
      (*WegeMap)(j,i) = laenge;
      if (!UeberHaltestellenGelaufen) {
        if ((laenge>0) && (laenge<=Parameter->holenVerbindungsradius())) {
          // verbinden
          HaltestellenVerbindung = new CWegenetzKante();
//          verbindung->head()->holen(&x1,&y1);
          forall_nodes(*hilfsknoten, *WegenetzGraph) {
            WegenetzGraph->inf(*hilfsknoten)->holenPosition()->holen(&x1,&y1);
            if ((x2==fabs(x1)) && (y2==fabs(y1))) {
//            if (sqrt((x2-x1)*(x2-x1)+(y2-y1)+(y2-y1))<Parameter->holenVerbindungsradius()) {
              *knoten = *hilfsknoten;
//              Debug(8,WegenetzGraph->inf(*WegenetzKnoten)->holenKnotenId() << " <-> " << WegenetzGraph->inf(*hilfsknoten)->holenKnotenId());
            }
          }
//          Debug(9,".1");
          HaltestellenVerbindung->setzenEntfernung(laenge);
//          Debug(9,".2");
          HaltestellenVerbindung->setzenKantenListe(verbindung);
//          Debug(9,".3");
          *WegenetzKante = WegenetzGraph->new_edge(*WegenetzKnoten,*knoten,HaltestellenVerbindung);
//          Debug(8,WegenetzGraph->inf(*WegenetzKnoten)->holenKnotenId() << " -> " << WegenetzGraph->inf(*knoten)->holenKnotenId());
//          Debug(8,"   -> Verbindung");
          HaltestellenVerbindung = new CWegenetzKante();
//          Debug(9,".1");
          HaltestellenVerbindung->setzenEntfernung(laenge);
//          Debug(9,".2");
          HaltestellenVerbindung->setzenKantenListe(verbindung);
//          Debug(9,".3");
          *WegenetzKante = WegenetzGraph->new_edge(*knoten,*WegenetzKnoten,HaltestellenVerbindung);
//          Debug(8,WegenetzGraph->inf(*WegenetzKnoten)->holenKnotenId() << " <- " << WegenetzGraph->inf(*knoten)->holenKnotenId());
//          Debug(8,"   <- Verbindung");
        } else {
          // Wir merken uns alle zu lange Verbindungen
          if (verbindung!=NULL) {
//            if (laenge>=Parameter->holenVerbindungsradius()) {
//              verbindung->head()->holen(&x1,&y1);
              forall_nodes(*hilfsknoten, *WegenetzGraph) {
                WegenetzGraph->inf(*hilfsknoten)->holenPosition()->holen(&x1,&y1);
                if ((x2==fabs(x1)) && (y2==fabs(y1))) {
//                if (sqrt((x2-x1)*(x2-x1)+(y2-y1)+(y2-y1))<Parameter->holenVerbindungsradius()) {
                  *knoten = *hilfsknoten;
  //                Debug(8,WegenetzGraph->inf(*WegenetzKnoten)->holenKnotenId() << " <-> " << WegenetzGraph->inf(*hilfsknoten)->holenKnotenId());
                }
              }
              CVerbindung * NeueVerbindung = new CVerbindung();
              NeueVerbindung->setzenStart(new node(*WegenetzKnoten));
              NeueVerbindung->setzenZiel(new node(*knoten));
              NeueVerbindung->setzenVerbindung(verbindung);
              if (Parameter->holenRadiustyp()==luftlinie) {
                NeueVerbindung->setzenLaenge(laenge/EntfernungsFaktor);
              } else {
                NeueVerbindung->setzenLaenge(laenge);
              }
              verbindungsListe->append(NeueVerbindung);
//            }
          }
        }
      } // !UeberHaltestellenGelaufen
      else {
        Debug(8,"Ueber Haltestelle(n) gelaufen!");
      }
    }
  }

//  wartenTaste();
  Fortschritt->meldenLaufzeitAusgabe("Guetemasse [Reiseweg Haltestelle -> Haltestelle]");
  Guetemasse->setzenReisezeitHS2HSAuto(WegeMap);
  return WegenetzGraph;
} // berechnenWegenetzgraph

//------------------------------------------------------------------------------
// Funktionsname:	holenKnoten()
// Beschreibung:	Gibt die Inhalte der zu einer Kante inzidenten Knoten aus
// Parameter:	Die Kante AktuelleKante, die Punkte Start und Ziel
// Rueckgabe:	Die Punkte Start und ZIel
// Besonderheiten:	Rueckgabe ueber die Parameter
// Autor:		Jrg Draeger
//------------------------------------------------------------------------------

void CStrassennetz::holeKnoten(edge *  AktuelleKante, CPunkt * Start, CPunkt * Ziel)
{
//    Debug(3,"CStrassennetz::holeKnoten");

  /**
   * LEDA bietet die GRAPH-Methoden G.source(edge e) und G.target(edge e)
   * an, um den Anfangs- bzw. Endknoten einer Kante herauszufinden.
   */
  node anfangsKnoten, endKnoten;
  // Knoten holen
  anfangsKnoten = Strassennetz->source(*AktuelleKante);
  endKnoten = Strassennetz->target(*AktuelleKante);

  //Knoteninformation (Punkte) ermitteln
  Start = new CPunkt(Strassennetz->inf(anfangsKnoten).xcoordD(),Strassennetz->inf(anfangsKnoten).ycoordD());
  Ziel = new CPunkt(Strassennetz->inf(anfangsKnoten).xcoordD(),Strassennetz->inf(anfangsKnoten).ycoordD());
} // holenKnoten

//------------------------------------------------------------------------------
// Funktionsname:	bewerten()
// Beschreibung:	
// Parameter:	
// Rueckgabe:	
// Besonderheiten:	
// Autor:		Marc Pompl
//------------------------------------------------------------------------------

double CStrassennetz::bewerten(list<CWegenetzKnoten*> * HaltestellenKnoten)
{
  // ist aktuell von Marc in Arbeit!!!
	long double wert;
	long double a1 = 0 , a2 = 0;
	long double b1 = 0, b2 = 0;
	matrix * datenmatrix;
	double * werte;
	int xSize, ySize;
	double xStep, yStep;
	double xPos, yPos;
	CPunkt * Punkt;
	wert = 0;
//	Debug(2,"CStrassennetz::bewerten()");	
	// schrittweite in GRASS-Einheiten berechnen...
	xStep = (begrenzungRechts-begrenzungLinks)/Parameter->holenBevoelkerungsrasterEinheiten();
	yStep = (begrenzungUnten-begrenzungOben)/Parameter->holenBevoelkerungsrasterEinheiten();
	// Bevoelkerungsabdeckung
	datenmatrix = Bevoelkerungsraster;
	ySize = datenmatrix->dim1();
	xSize = datenmatrix->dim2();
	werte = new double[ySize*Parameter->holenBevoelkerungsrasterEinheiten()+xSize];
//	Debug(6,"Bewertungsraster vorbereiten");
	long double GesamtBevoelkerung = 0;
	for(int y=0; y<ySize; y++) {
		for(int x=0; x<xSize; x++) {
			werte[y*Parameter->holenBevoelkerungsrasterEinheiten()+x] = (*datenmatrix)(y,x);
			GesamtBevoelkerung += (*datenmatrix)(y,x);
//			cout << werte[y*BevoelkerungsrasterEinheiten+x] << " ";
		}
//		cout << "\n";
	}
//	wartenTaste();
//	Debug(6,"Haltestellen = " << HaltestellenKnoten->size());
	// Fuer jede Haltestelle
	for (int i=0; i<HaltestellenKnoten->size();i++) {
//		Debug(7,"Haltestelle: " << *(HaltestellenKnoten->contents(HaltestellenKnoten->get_item(i))));
		if (Parameter->holenKoeffizientStrassenanpassung()>0) {
/*****************
 * NOCH FALSCH!!!
 *****************/
			// Pruefe jedes Rasterfeld
			// TODO: Nicht jedes Rasterfeld pruefen, sondern nur die, welche im maximalen Einzugsgebiet liegen! => Kreisfunktion
			for(int y=0; y<ySize; y++) {
				yPos = y*yStep+begrenzungOben;
				for(int x=0; x<xSize; x++) {
//					Debug(9,"Rasterposition : [" << x << "/" << y << "]");
					xPos = x*xStep+begrenzungLinks;
					Punkt = new CPunkt(xPos,yPos);
					// Im inneren Einzugsgebiet abziehen
					if (ermittelnEntfernung(Punkt, (HaltestellenKnoten->contents(HaltestellenKnoten->get_item(i)))->holenPosition())<=Parameter->holenMinimalesEinzugsgebiet()) {
						werte[y*xSize+x] -= ((*datenmatrix)(y,x)/2);
						//werte[y*Parameter->holenBevoelkerungsrasterEinheiten()+x] *= 0.8;
					}
					// Im aeusseren Einzugsgebiet abziehen ... und inneres noch einmal....
					if (ermittelnEntfernung(Punkt, (HaltestellenKnoten->contents(HaltestellenKnoten->get_item(i)))->holenPosition())<=Parameter->holenMaximalesEinzugsgebiet()) {
						werte[y*xSize+x] -= ((*datenmatrix)(y,x)/2);
						//werte[y*Parameter->holenBevoelkerungsrasterEinheiten()+x] *= 0.9;
					}
					delete Punkt;
				} // for x
			} // for y
		} // switch
	} // for HaltestellenKnoten
        if (Parameter->pruefenAnzeigenBevoelkerung()) BevoelkerungsversorgungVisualisierung->zeigenMatrixRelativ(new matrix(Parameter->holenBevoelkerungsrasterEinheiten(),Parameter->holenBevoelkerungsrasterEinheiten(),werte),MaximumBevoelkerung);

//	Debug(6,"b> und b< ermitteln");
	a1 = 0;
	a2 = 0;
	for(int y=0; y<ySize; y++) {
		for(int x=0; x<xSize; x++) {
//			Debug(9,"Rasterposition : [" << x << "/" << y << "]");
			if (werte[y*xSize+x]>0) {
				a1 += werte[y*xSize+x];
			} else
			if (werte[y*xSize+x]<0) {
				a2 += werte[y*xSize+x];
			}
		}
	}
	a2 = fabs(a2);
	delete[] werte;
	a1 *= Parameter->holenKoeffizientBevoelkerungsunterversorgung();
	a2 *= Parameter->holenKoeffizientBevoelkerungsueberversorgung();
//	Debug(6,"b>   : " << a1);
//	Debug(6,"b<   : " << a2);
	wert = a1+a2;
	Guetemasse->speichernBevoelkerungsUeberversorgung(a2);
	Guetemasse->speichernBevoelkerungsUnterversorgung(a1);
	int BevoelkerungsVersorgung = (int)(100-((100*a1)/GesamtBevoelkerung));
//	Debug(8,"b%   : " << BevoelkerungsVersorgung);
	Guetemasse->speichernBevoelkerungsVersorgunginProzent(BevoelkerungsVersorgung);
	
	datenmatrix = Flaechenraster;
	ySize = datenmatrix->dim1();
	xSize = datenmatrix->dim2();
	werte = new double[ySize*Parameter->holenBevoelkerungsrasterEinheiten()+xSize];
//	Debug(6,"Flaechenraster vorbereiten");
	for(int y=0; y<ySize; y++) {
		for(int x=0; x<xSize; x++) {
			werte[y*Parameter->holenBevoelkerungsrasterEinheiten()+x] = (*datenmatrix)(x,y);
//			cout << werte[y*BevoelkerungsrasterEinheiten+x] << " ";
		}
//		cout << "\n";
	}
//	wartenTaste();


/* Flaechenabdeckung */

	// Fuer jede Haltestelle
	for (int i=0; i<HaltestellenKnoten->size();i++) {
//		Debug(7,"Haltestelle: " << *(HaltestellenKnoten->contents(HaltestellenKnoten->get_item(i))));
		if (Parameter->holenKoeffizientStrassenanpassung()>0) {
/*****************
 * NOCH FALSCH!!!
 *****************/
			// Pruefe jedes Rasterfeld
			// TODO: Nicht jedes Rasterfeld pruefen, sondern nur die, welche im maximalen Einzugsgebiet liegen! => Kreisfunktion
			for(int y=0; y<ySize; y++) {
				yPos = y*yStep+begrenzungOben;
				for(int x=0; x<xSize; x++) {
//					Debug(9,"Rasterposition : [" << x << "/" << y << "]");
					xPos = x*xStep+begrenzungLinks;
					Punkt = new CPunkt(xPos,yPos);
					// Im inneren Einzugsgebiet abziehen
					if (ermittelnEntfernung(Punkt, (HaltestellenKnoten->contents(HaltestellenKnoten->get_item(i)))->holenPosition())<=Parameter->holenMinimalesEinzugsgebiet()) {
						werte[y*xSize+x] -= (MaximumFlaeche/2);
//						werte[y*Parameter->holenBevoelkerungsrasterEinheiten()+x] *= 0.8;
					}
					// Im aeusseren Einzugsgebiet abziehen ... und inneres noch einmal....
					if (ermittelnEntfernung(Punkt, (HaltestellenKnoten->contents(HaltestellenKnoten->get_item(i)))->holenPosition())<=Parameter->holenMaximalesEinzugsgebiet()) {
						werte[y*xSize+x] -= (MaximumFlaeche/2);
//						werte[y*Parameter->holenBevoelkerungsrasterEinheiten()+x] *= 0.9;
					}
					delete Punkt;
				} // for x
			} // for y
		} // switch
	} // for HaltestellenKnoten
        if (Parameter->pruefenAnzeigenFlaeche()) FlaechendeckungVisualisierung->zeigenMatrixRelativ(new matrix(Parameter->holenBevoelkerungsrasterEinheiten(),Parameter->holenBevoelkerungsrasterEinheiten(),werte),MaximumFlaeche);
	
//	Debug(6,"a> und a< ermitteln");
	for(int y=0; y<ySize; y++) {
		for(int x=0; x<xSize; x++) {
//			Debug(9,"Rasterposition : [" << x << "/" << y << "]");
			if (werte[y*xSize+x]>0) {
				b1 += werte[y*xSize+x];
			} else
			if (werte[y*xSize+x]<0) {
				b2 += werte[y*xSize+x];
			}
		}
	}
	b1 /= 1000000;
	b2 /= 1000000;
	b2 = fabs(b2);
	delete[] werte;
	b1 *= Parameter->holenKoeffizientFlaechenunterversorgung();
	b2 *= Parameter->holenKoeffizientFlaechenueberversorgung();
//	Debug(9,"a>   : " << b1);
//	Debug(9,"a<   : " << b2);
	wert += b1+b2;
	Guetemasse->speichernFlaechenUeberversorgung(b2);
	Guetemasse->speichernFlaechenUnterversorgung(b1);
	double FlaechenVersorgung = (double)(100-((100*b1)/fabs(((begrenzungRechts-begrenzungLinks)*(begrenzungOben-begrenzungUnten)))));
//	Debug(8,"a%   : " << FlaechenVersorgung);
	Guetemasse->speichernFlaechenVersorgunginProzent(FlaechenVersorgung);
//	Debug(5,"Summe: " << wert);
	return wert;
} // bewerten

//------------------------------------------------------------------------------
// Funktionsname:	suchenBegrenzungen()
// Beschreibung:	Bestimmt die Ausdehnung des uebergebenen
//			Strassennetzes und traegt die vorgefundenen
//			Werte als Begrenzungen ein.
// Parameter:		Strassennetzliste - Eine Liste von Listen aus Punkten, welche das Strassennetz repraesentiert.
// Rueckgabe:		-
// Besonderheiten:	-
// Autor:		Marc Pompl
//------------------------------------------------------------------------------

void CStrassennetz::suchenBegrenzungen(list<list<CPunkt*>* > * Strassennetzliste)
{
  // ist aktuell von Marc in Arbeit!!!
  list<CPunkt *> * Strasse;
  CPunkt * Punkt;
  double x, y;
//  Debug(2, "CStrassennetz::suchenBegrenzungen()");
  begrenzungLinks = MAX_DOUBLE;
  begrenzungRechts = MIN_DOUBLE;
  begrenzungOben = MIN_DOUBLE;
  begrenzungUnten = MAX_DOUBLE;
  for (int i=0;i<Strassennetzliste->size();i++) {
    // Alle Strassenzuege durchlaufen...
    Strasse = Strassennetzliste->contents(Strassennetzliste->get_item(i));
    for (int j=0;j<Strasse->size();j++) {
      // Alle Punkte durchlaufen
      Punkt = Strasse->contents(Strasse->get_item(j));
      Punkt->holen(&x,&y);
      if (begrenzungLinks>x)
        begrenzungLinks=x;
      if (begrenzungRechts<x)
        begrenzungRechts=x;
      if (begrenzungOben<y)
        begrenzungOben=y;
      if (begrenzungUnten>y)
        begrenzungUnten=y;
    } // for j
  } // for i
  Debug(5,"Begrenzungen: [" << begrenzungLinks << "/"<< begrenzungOben << "/"<< begrenzungRechts << "/"<< begrenzungUnten << "]");
//  wartenTatse();
} // suchenBegrenzungen

//------------------------------------------------------------------------------
// Funktionsname:	suchenVerbindung()
// Beschreibung:	Sucht auf dem strassennetz die kuerzeste Verbindung
//			vom StartPunkt zum EndPunkt. Wird dabei ueber
//			eine Haltestelle gelaufen, so wird kein Pfad zurueckgeben,
//			ansonsten enthaelt der Graph eine Liste der Punkte,
//			welchen den abzufahrenden Linienzug einschliesslich
//			StartPunkt und EndPunkt, enthaelt.
// Parameter:		StartPunkt - Punkt, von welchem die Verbindung aufgebaut werden soll.
//			EndPunkt - Punkt, zu welchem die Verbindung aufgebaut werden soll.
// Rueckgabe:		Liste mit dem Linienzug oder NULL.
// Besonderheiten:	-
// Autor:		Marc Pompl
//------------------------------------------------------------------------------

list<CPunkt *> * CStrassennetz::suchenVerbindung(CPunkt * StartPunkt, CPunkt * EndPunkt, bool AufHaltestellenPruefen = true)
{
  // ist aktuell von Marc in Arbeit!!!
  node knoten;
  list<CPunkt * > * liste;
  node start, ziel;
  bool laufen1 = false, laufen2 = false;
//  Debug(3,"suchenVerbindung()");
  // Wir bilden das Problem auf suchenVerbindung(node *, node *) ab.
  // Dazu ermitteln wir die korrespondierenden Knoten im Strassennetz.
  forall_nodes(knoten, *Strassennetz) {
    if (((Strassennetz->inf(knoten).xcoordD())==(StartPunkt->holenX())) && ((Strassennetz->inf(knoten).ycoordD())==(StartPunkt->holenY()))) {
      laufen1 = true;
      start = knoten;
    }
    if ((Strassennetz->inf(knoten).xcoordD()==EndPunkt->holenX()) && (Strassennetz->inf(knoten).ycoordD()==EndPunkt->holenY())) {
      laufen2 = true;
      ziel = knoten;
    }
  }
  // und suchen nun die Verbindung.
  if (laufen1 && laufen2) {
    // Aber nur, wenn beide Punkte im Strassennetz vorhanden sind!
    liste = suchenVerbindung(&start,&ziel,AufHaltestellenPruefen);
  } else {
    // Ansonsten nehmen wir die Luftlinie!
    liste = new list<CPunkt *>;
    liste->append(new CPunkt(*StartPunkt));
    liste->append(new CPunkt(*EndPunkt));
  }
  return liste;
} // suchenVerbindung

//------------------------------------------------------------------------------

list<CPunkt *> * CStrassennetz::suchenVerbindung(node * Start, node * Ziel, bool AufHaltestellenPruefen = true)
{
  // ist aktuell von Marc in Arbeit!!!
//  Debug(3,"suchenVerbindung()");
  node * hilfszeiger = new node();
  list<CPunkt * > * liste;
  node_array<edge>  * dijkstraErgebnis = new node_array<edge>(*Strassennetz);
  edge * hilfskante = new edge();
  double x, y;
  //edge_array mit den Entfernungen fuellen
  if (dijkstraKanten==NULL) {
//    Debug(5,"Kostenfeld aufbauen");
    // STEFAN_HIER
    //    dijkstraKanten = new edge_array<int>(*Strassennetz,0);
    dijkstraKanten = new edge_array<double>(*Strassennetz,0);
    forall_edges(*hilfskante,*Strassennetz){
      // STEFAN_HIER
      //      int &arrayInhalt = (*dijkstraKanten)[*hilfskante];
      double &arrayInhalt = (*dijkstraKanten)[*hilfskante];
      x = fabs(Strassennetz->inf(Strassennetz->source(*hilfskante)).xcoordD())-fabs(Strassennetz->inf(Strassennetz->source(*hilfskante)).xcoordD());
      y = fabs(Strassennetz->inf(Strassennetz->source(*hilfskante)).ycoordD())-fabs(Strassennetz->inf(Strassennetz->source(*hilfskante)).ycoordD());
      arrayInhalt = sqrt((x*x)+(y*y))+0.0001;
//      Debug(9,*hilfskante << " = " << arrayInhalt);
//      Debug(9,*hilfskante << " = " << (*dijkstraKanten)[*hilfskante]);
    } //Ende forall_edges
  }

//  Debug(8,"Dijkstra von " << *Start << " nach " << *Ziel);
  bool ergebnis = DIJKSTRA_T(*Strassennetz,*Start,*Ziel,*dijkstraKanten,*dijkstraErgebnis);

  if (ergebnis == false){
    string meldung("Dijkstra gibt Fehler zurueck!");
    throw CHaltestelleExceptions(meldung);
  }

//  Debug(7,"Ergebnis aufbauen");
  liste = new list<CPunkt *>;
  *hilfszeiger = *Ziel;
  UeberHaltestellenGelaufen = false;
  while (*hilfszeiger != *Start) {
//    cout << << " ";
    if (AufHaltestellenPruefen) { // Soll beim Lauf auf Haltestellen geprueft werden?
      if ((*hilfszeiger != *Start) && (*hilfszeiger != *Ziel) && ((Strassennetz->inf(*hilfszeiger).xcoordD()<0) || (Strassennetz->inf(*hilfszeiger).ycoordD()<0))) { // Handelt es sich um eine Haltestelle?
//        Debug(9,"Liste enthaelt Haltestelle!");
        delete liste;
        liste = NULL;
        UeberHaltestellenGelaufen = true;
        break;
      }
    } else {
      if ((*hilfszeiger != *Start) && (*hilfszeiger != *Ziel) && ((Strassennetz->inf(*hilfszeiger).xcoordD()<0) || (Strassennetz->inf(*hilfszeiger).ycoordD()<0))) { // Handelt es sich um eine Haltestelle?
//        Debug(9,"Liste enthaelt Haltestelle!");
        UeberHaltestellenGelaufen = true;
      }
    }
    // Liste um CPunkt erweitern
    liste->append(new CPunkt(fabs(Strassennetz->inf(*hilfszeiger).xcoordD()),fabs(Strassennetz->inf(*hilfszeiger).ycoordD())));
    *hilfszeiger = Strassennetz->source((*dijkstraErgebnis)[*hilfszeiger]);
  }
  if (liste!=NULL) { // Macht ja sonst keinen Sinn!
    liste->append(new CPunkt(fabs(Strassennetz->inf(*hilfszeiger).xcoordD()),fabs(Strassennetz->inf(*hilfszeiger).ycoordD())));
  }
  delete dijkstraErgebnis;
  delete hilfskante;
  delete hilfszeiger;
  return liste;
} // suchenVerbindung

//___________________________________________________________________________

void CStrassennetz::ausgebenWegenetzGraph(GRAPH<CWegenetzKnoten *, CWegenetzKante *> * Wegenetzgraph) {
//  Debug(2,"ausgebenWegenetzGraph()");
  node * knoten = new node(), * quelle = new node(), * ziel = new node();
  edge * kante = new edge();
//  cout << "Wegenetzgraph:\n\n";
//  cout << Wegenetzgraph->number_of_nodes() << " Knoten\n";
//  forall_nodes(*knoten,*Wegenetzgraph) {
//    cout << *(Wegenetzgraph->inf(*knoten)) << "\n";
//  };
//  cout << Wegenetzgraph->number_of_edges() << " Kanten\n";
  forall_edges(*kante,*Wegenetzgraph) {
    *quelle = Wegenetzgraph->source(*kante);
    *ziel = Wegenetzgraph->target(*kante);
//    cout << Wegenetzgraph->inf(*quelle)->holenKnotenId() << " -> " << Wegenetzgraph->inf(*ziel)->holenKnotenId() << "\n";
//    cout << Wegenetzgraph->inf(*quelle)->holenKnotenId() << " -> " << Wegenetzgraph->inf(*ziel)->holenKnotenId() << ": " << *(Wegenetzgraph->inf(*kante)) << "\n";
//    wartenTaste();
  };
//  cout <<  "\n";
  delete knoten;
  delete kante;
} // ausgebenWegenetzGraph

//___________________________________________________________________________

void CStrassennetz::nummerierenHaltestellen(void) {
//  Debug(2,"nummerierenHaltestellen()");
  for(int nummer=0; nummer<HaltestellenKnoten->size(); nummer++) {
    HaltestellenKnoten->contents(HaltestellenKnoten->get_item(nummer))->setzenKnotenId(nummer);
  }
} // nummerierenHaltestellen


//------------------------------------------------------------------------------
// Funktionsname:	ermittelnInzidenteKnoten()
// Beschreibung:	
// Parameter:	
// Rueckgabe:	
// Besonderheiten:	-
// Autor:		Jrg Draeger
//------------------------------------------------------------------------------
void CStrassennetz::ermittelnInzidenteKnoten(edge * Kante, node *& linkerKnoten, node *& rechterKnoten)
{
    /**
     * Kreuzungen zeichnen sich dadurch aus,dass sie eine outgrad > 2 haben (mindestens drei) oder einen Outgrad von 1 bei Strassenanfaengen
     */

    /**
     * Ablauf:
     * Zu Beginn werden die inzidenten Knoten der uebergeben Kanten ermittelt
     * Mittels einer while - Schleife werden die Kreuzungen ermittelt:
     *   	Solange kein Knoten gefunden wurde, der eine Kreuzung darstellt, wird nach links gegangen.
     *	Wurde eine Kreuzung gefunde, wird zur Ausgangsposition zurueckgekehrt und die Suche
     *	nach einer Kreuzung in die rechte Richtung gestartet
     */

//    Debug(1,"ermittelnInzidenteKnoten()");      	

    /*  Variablendeklaration */
    node * StartKnoten = new node();
    node * EndKnoten = new node();
    node * aktuellerKnoten = new node();
    node * potentiellerNeuerKnoten = new node();
    edge * aktuelleKante = new edge();
    edge * alteKante = new edge();
    linkerKnoten = new node();
    rechterKnoten = new node();
    list<edge> * KantenListe = new list<edge>;
    list<edge> * Hilfsliste = new list<edge>;
    bool linksfertig, rechtsfertig;
    linksfertig = false;
    rechtsfertig = false;


    /* Die Knoten, die inzident mit der Eingabe-Kante sind */
    *StartKnoten = Strassennetz->source(*Kante);
    *EndKnoten = Strassennetz->target(*Kante);

    /* Iterationsknoten bzw. ~kanten */
    *aktuellerKnoten = *StartKnoten;
    *aktuelleKante = *Kante;
    *alteKante = *aktuelleKante;

    /* Solange der linke  und der rechte Strang ausgehend von der Eingabe-Kante nicht abgearbeitet sind
        d.h. Kreuzungsknoten gefunden wurden 							*/
    while (!(linksfertig && rechtsfertig))
    {
                	/* Bedingung fuer einen Kreuzungsknoten: Der Grad ist groesser 2, oder genau 1, bei Start - und Endpunkten einer Strasse */
    	if ((Strassennetz->degree(*aktuellerKnoten)>2) || (Strassennetz->degree(*aktuellerKnoten) == 1))
    	{
    		/* Ist eine Kreuzung */
       		
    		/* Falls ein Knoten gefunden wurde, ueberpruefen, ob der linke Strang schon fertig ist */
    		if (linksfertig)
    		{ 	rechtsfertig = true;
    			*rechterKnoten = *aktuellerKnoten;        }
    		else
    		{  	linksfertig = true;
    		 	*linkerKnoten = *aktuellerKnoten;
    		 	/* Zu den Eingabe-Werten zurueckkehren */
    			*aktuelleKante = *Kante; 		
    			*aktuellerKnoten = *EndKnoten;    };
         	}
    	else
    	{
    		//Weiter nach links oder rechts gehen
    		*KantenListe = Strassennetz->out_edges(*aktuellerKnoten);
    		*Hilfsliste = Strassennetz->in_edges(*aktuellerKnoten);
    		KantenListe->conc(*Hilfsliste,LEDA::after);
    		*alteKante = *aktuelleKante;
    		*aktuelleKante = KantenListe->head();
    		
    		if ((*aktuelleKante) == (*alteKante))
    		{
    			//aktuelleKante ist in diesem Fall die schon betrachtete alte Kante
    			// also die andere Kante nehmen
    			*aktuelleKante = KantenListe->tail();
    		};
    		
    		/* aktuellen Knoten bestimmen
   		   Dabei darauf achten, dass man nicht wieder den alten Knoten nimmt  */    		
	   	*potentiellerNeuerKnoten = Strassennetz->source(*aktuelleKante);

    		if ((*aktuellerKnoten) == (*potentiellerNeuerKnoten))
    		{	*aktuellerKnoten = Strassennetz->target(*aktuelleKante);     }
    		else
    		{	*aktuellerKnoten = Strassennetz->source(*aktuelleKante);       };
    	};
    }

} // ermittelnInzidenteKnoten


//___________________________________________________________________________

void CStrassennetz::erstellenZusammenhangWegenetzgraph() {
//  Debug(2,"erstellenZusammenhangWegenetzgraph()");

  // Liste mit den Verbindungen einmal sortieren
  sortierenVerbindungsListe();

  // TODO: Wird spaeter noch richtig gemacht. Dies ist ein uebles Fake.
  //  CWegenetzKnoten * links, * rechts;
  //  CWegenetzKante * HaltestellenVerbindung;
  //  list<CPunkt *> * verbindung;
  edge * kante = new edge();
  node * knoten = new node();
//  if (false) {

  node_array<int> Comp(*Wegenetzgraph);

  int c = COMPONENTS(*Wegenetzgraph, Comp);
  int maximaleAnzahlKomponenten = c;

  //  Debug(0, "COMPONENTS liefert:   ///// " << c);

  // verbindungsListe
  for (int i=0; i<verbindungsListe->size();i++)
    {
      //      cout << "#";
      CVerbindung * myVerbindung = verbindungsListe->contents(verbindungsListe->get_item(i));
      node * start = myVerbindung->holenStart();
      node * ziel = myVerbindung->holenZiel();
      //      Verbindung = new CWegenetzKante();
      //      cout << "Start " << start << " Ziel " << ziel << "\n";
      // start und ziel liegen nicht im Graphen?
      edge TmpEdge = Wegenetzgraph->new_edge(*start, *ziel);
      Fortschritt->anzeigenFortschritt(maximaleAnzahlKomponenten-c+i,maximaleAnzahlKomponenten+verbindungsListe->size());
      if (COMPONENTS(*Wegenetzgraph, Comp)<c)
	{
	  c = COMPONENTS(*Wegenetzgraph, Comp);
	  Debug(0, "\nHabe nun noch " << c << " einzelne Komponenten.");
	  // Gegenrichtung einfuegen
          CWegenetzKante * TmpVerbindung = new CWegenetzKante();
          TmpVerbindung->setzenKantenListe(myVerbindung->holenVerbindung());
          TmpVerbindung->setzenEntfernung(myVerbindung->holenLaenge());
	  Wegenetzgraph->assign(TmpEdge,TmpVerbindung);
          TmpVerbindung = new CWegenetzKante();
          TmpVerbindung->setzenKantenListe(myVerbindung->holenVerbindung());
          TmpVerbindung->setzenEntfernung(myVerbindung->holenLaenge());
	  TmpEdge = Wegenetzgraph->new_edge(*ziel, *start, TmpVerbindung);
	}
      else
	{
	  //	  cout << "-";
	  Wegenetzgraph->del_edge(TmpEdge);
	}
      if (c == 1)
	{
	  Debug(0, "\nNur noch eine Komponente, beende.");
	  break;
	}
      // Abort when c=1.
    }

  delete knoten;
  delete kante;
  Fortschritt->anzeigenFortschritt(maximaleAnzahlKomponenten+verbindungsListe->size(),maximaleAnzahlKomponenten+verbindungsListe->size());
} // erstellenZusammenhangWegenetzgraph

//___________________________________________________________________________

void CStrassennetz::aufbauenSektoren(void) {
  edge * kante = new edge();
//  Debug(2,"aufbauenSektoren()");
  unsigned int i = 0, anzahl = Strassennetz->number_of_edges()-1;
  forall_edges(*kante,*Strassennetz) {
    i++;
    if (i%100==0) {
      Fortschritt->anzeigenFortschritt(i,anzahl);
    }
    einfuegenStrassensegmentSektor(*kante);
  }
  delete kante;
} // aufbauenSektoren

//___________________________________________________________________________

int CStrassennetz::pruefenSektor(rat_point p) {
  double xStep, yStep;
  int x, y;
//  Debug(4,"pruefenSektor()");
  // schrittweite in GRASS-Einheiten berechnen...
  xStep = (begrenzungRechts-begrenzungLinks)/SektorAnzahl;
  yStep = (begrenzungOben-begrenzungUnten)/SektorAnzahl;
  x = (int) ((p.xcoordD() - begrenzungLinks)/xStep-0.5);
  if (x<0) {
//    Debug(9,"x<begrenzungLinks : [" << p.xcoordD() << "/" << p.ycoordD() << "]");
    return x;
  }
  if (x>=(int)SektorAnzahl) {
//    Debug(9,"x>begrenzungRechts : [" << p.xcoordD() << "/" << p.ycoordD() << "]");
    return SektorAnzahl*SektorAnzahl;
  }
  y = (int) ((p.ycoordD() - begrenzungUnten)/yStep-0.5);
//  x = (int) ((p.xcoordD() - begrenzungLinks)/xStep);
//  y = (int) ((p.ycoordD() - begrenzungUnten)/yStep);
//  Debug(8,"Sektor: " << y*SektorAnzahl+x);
  return y*SektorAnzahl+x;
} // pruefenSektor

//___________________________________________________________________________

void CStrassennetz::einfuegenStrassensegmentSektor(edge Kante) {
  double x1, y1, x2, y2;
  double x1sektor, y1sektor, x2sektor, y2sektor;
  int sektor1, sektor2;
//  Debug(3,"einfuegenStrassensegmentSektor()");
  int xstart, ystart, xende, yende;
  bool schnitt = false;
  // Generelle Vorarbeit: Endpunkte holen
  x1 = Strassennetz->inf(Kante).xcoord1D();
  y1 = Strassennetz->inf(Kante).ycoord1D();
  x2  = Strassennetz->inf(Kante).xcoord2D();
  y2  = Strassennetz->inf(Kante).ycoord2D();
//  cout << "Segment: [" << x1 << "/" <<y1 << "] - [" << x2 << "/" << y2 << "]\n";
  rat_point p1(x1,y1);
  rat_point p2(x2,y2);
  // Wir ermitteln die Sektoren, welche ueberhaupt nur in Frage kommen
  sektor1 = pruefenSektor(p1);
  sektor2 = pruefenSektor(p2);
  // und ordnen links/rechts
  if (sektor1%SektorAnzahl<=sektor2%SektorAnzahl) {
    xstart = sektor1%SektorAnzahl;
    xende = sektor2%SektorAnzahl;
  } else {
    xstart = sektor2%SektorAnzahl;
    xende = sektor1%SektorAnzahl;
  }
  // und oben/unten
  if (sektor1/SektorAnzahl<=sektor2/SektorAnzahl) {
    ystart = (int)(sektor1/SektorAnzahl-0.5);
    yende = (int)(sektor2/SektorAnzahl-0.5);
//    ystart = (int)(sektor1/SektorAnzahl);
//    yende = (int)(sektor2/SektorAnzahl);
  } else {
    ystart = (int)(sektor2/SektorAnzahl-0.5);
    yende = (int)(sektor1/SektorAnzahl-0.5);
//    ystart = (int)(sektor2/SektorAnzahl);
//    yende = (int)(sektor1/SektorAnzahl);
  }
  // Wir pruefen jeden Sektor, ob er mit dem Segment schneidet
  for (int y=ystart; y<=yende; y++) {
    y1sektor = begrenzungUnten + (y*(begrenzungOben-begrenzungUnten)/SektorAnzahl);
    y2sektor = begrenzungUnten + ((y+1)*(begrenzungOben-begrenzungUnten)/SektorAnzahl);
    for (int x=xstart; x<=xende; x++) {
      x1sektor = begrenzungLinks + (x*(begrenzungRechts-begrenzungLinks)/SektorAnzahl);
      x2sektor = begrenzungLinks + ((x+1)*(begrenzungRechts-begrenzungLinks)/SektorAnzahl);
//      cout << "Sektor: [" << x1sektor << "/" <<y1sektor << "] - [" << x2sektor << "/" << y2sektor << "]\n";
      if (Strassennetz->inf(Kante).intersection(rat_segment(x1sektor,y1sektor,x2sektor,y1sektor))) {
        Sektor[y*SektorAnzahl+x]->append(Kante);
        schnitt = true;
      } else {
        if (Strassennetz->inf(Kante).intersection(rat_segment(x2sektor,y1sektor,x2sektor,y2sektor))) {
          Sektor[y*SektorAnzahl+x]->append(Kante);
          schnitt = true;
        } else {
          if (Strassennetz->inf(Kante).intersection(rat_segment(x2sektor,y2sektor,x1sektor,y2sektor))) {
            Sektor[y*SektorAnzahl+x]->append(Kante);
            schnitt = true;
          } else {
            if (Strassennetz->inf(Kante).intersection(rat_segment(x1sektor,y2sektor,x1sektor,y1sektor))) {
              Sektor[y*SektorAnzahl+x]->append(Kante);
              schnitt = true;
            }
          }
        }
      }
//      if (schnitt) Debug(9,"Schnitt!");
    }
  }
  if (!schnitt) { // Wenn vorher ein schnitt war, brauchen wir nicht mehr einfuegen.
    // Hier also nur einfuegen, wenn Segment innerhalb eines Sektors liegt.
    Sektor[sektor1]->append(Kante);
    if (sektor1!=sektor2) { // Ueberpruefung eigentlich sinnlos...
      Sektor[sektor2]->append(Kante);
    }
/*    if (sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2))>300) {
      Debug(9,"Laenge = " << sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2)));
    }*/
  }
} //  einfuegenStrassensegmentSektor

//___________________________________________________________________________

list<edge> * CStrassennetz::sammelnStrassenAusSektoren(int sektor) {
  list<edge> * kanten = new list<edge>;
  edge * kante = new edge();
  int hsektor, position;
//  Debug(3,"sammelnStrassenAusSektoren()");
  // Durchlaufen aller Sektoren um den zentralen Sektor...
  for (int y=-1; y<=1; y++) {
    for (int x=-1; x<=1; x++) {
      hsektor = sektor+x+(y*SektorAnzahl);
//      Debug(8,"Sektor " << hsektor);
      if ((hsektor>=0) && (hsektor<(int)(SektorAnzahl*SektorAnzahl))) { // Sektornummer nicht ausserhalb des Definitionsbereiches?
        for(int i=0; i<Sektor[hsektor]->size(); i++) {
          *kante = Sektor[hsektor]->contents(Sektor[hsektor]->get_item(i));
          position = kanten->rank(*kante);
          if (position==0) { // Noch nicht vorhanden?
            // Dann einfuegen...
            kanten->append(*kante);
//            Debug(9,"eingefuegt");
          } else {
//            Debug(9,"nicht eingefuegt");
          }
        }
      }
    }
  }
  delete kante;
  return kanten;
} // sammelnStrassenAusSektoren

//___________________________________________________________________________

void CStrassennetz::ausgebenHaltestellen() {
//  cout << "Haltestellen:\n";
//  for(int i=0; i<HaltestellenKnoten->size(); i++) {
//    cout << *HaltestellenKnoten->contents(HaltestellenKnoten->get_item(i)) << "\n";
//  }
//  cout << "\n";
} // ausgebenHaltestellen


//___________________________________________________________________________

//node * CStrassennetz::einfuegenHaltestelleStrassennetz(GRAPH<rat_point,rat_segment> * Strassennetz, CWegenetzKnoten * Haltestelle) {
//} // einfuegenHaltestelleStrassennetz

//___________________________________________________________________________

list<node*> * CStrassennetz::einfuegenHaltestellenStrassennetz(GRAPH<rat_point,rat_segment> * Strassennetz, list<CWegenetzKnoten*> * Haltestellen) {
  list<node*> * knotenliste = new list<node*>;
  double x, y;
  int sektor;
  rat_point * position, * punkt;
  edge * kante = new edge();
  node * knoten = new node();
  double x1,y1;
  bool istKnoten;
  edge * zielkante = new edge();
  node * links = new node();
  node * rechts = new node();
  rat_segment * seg;
  list<edge> * Strassen = NULL;
  // Durchlaufen aller Haltestellen...
//  for (int i=0; i<Haltestellen->size(); i++) { Nach while umgewandelt...
  int i = 0;
  while(i<Haltestellen->size()) {
//    Debug(7,"Haltestelle " << i << *(Haltestellen->contents(Haltestellen->get_item(i))->holenPosition()));
    Fortschritt->anzeigenFortschritt(i,Haltestellen->size()-1);
    punkt = NULL;
    istKnoten = false;
    Haltestellen->contents(Haltestellen->get_item(i))->holenPosition()->holen(&x,&y);
//    Debug(9,"x: [" << x << "/" << y << "]");
    position = new rat_point(x,y);
    // Zugehoeriges Segment holen...
    sektor = pruefenSektor(*position);
//    Debug(9,"Sektor = " << sektor);
    if ((sektor>=0) && (sektor<(int)(SektorAnzahl*SektorAnzahl))) {
      Strassen = sammelnStrassenAusSektoren(sektor);
      for(int j=0; j<Strassen->size(); j++) {
        *kante = Strassen->contents(Strassen->get_item(j));
//      forall_edges(*kante,*Strassennetz) {
	double entfernung = sqrt((Strassennetz->inf(*kante).sqr_dist(*position)).to_double());
//        Debug(9, "Entfernung: " << entfernung);
        if (entfernung<Parameter->holenToleranzgrenze()) { // Position Teil des Segments?
          if (punkt!=NULL) {
            delete punkt;
          }
          istKnoten = false;
          punkt = new rat_point(x,y);
          if (!istKnoten) {
            // Mitten auf einer Kante
            *zielkante = *kante;
          }
          break; // Wir haben den Punkt schon gefunden!
        }
          if ((Strassennetz->inf(*kante).xcoord1D()==x) && (Strassennetz->inf(*kante).ycoord1D()==y)) {
            // identisch mit "linkem" Knoten
            knoten = new node();
            istKnoten = true;
            *knoten = Strassennetz->source(*kante);
            punkt = new rat_point(x,y);
            break; // Wir haben den Punkt schon gefunden!
          }
          if ((Strassennetz->inf(*kante).xcoord2D()==x) && (Strassennetz->inf(*kante).ycoord2D()==y)) {
            // identisch mit "rechtem" Knoten
            knoten = new node();
            istKnoten = true;
            *knoten = Strassennetz->target(*kante);
            punkt = new rat_point(x,y);
            break; // Wir haben den Punkt schon gefunden!
          }

      } // for Strassen in sektor
    }
    if (punkt!=NULL) {
//        Debug(9,"Zuweisung fuer " << *position);
        x1 = fabs(punkt->xcoordD());
        y1 = fabs(punkt->ycoordD());
        if (istKnoten) { // Haltestelle ist Knoten?
//          Debug(9,"Haltestelle ist Knoten");
          // Knoten korrigieren...
          punkt = new rat_point(-x1,-y1);
//          Debug(9, "[" << x1 << "/" << y1 << "] -> " << *punkt);
          Strassennetz->assign(*knoten,*punkt);
        } else {
//          Debug(9,"Haltestelle ist kein Knoten");
          // Segment loeschen...
          *links = Strassennetz->source(*zielkante);
          *rechts = Strassennetz->target(*zielkante);
          Strassennetz->del_edge(*zielkante);
          // Haltestelle einfuegen...
          knoten = new node();
          *knoten = Strassennetz->new_node(*punkt);
          // und verbinden..
          // nach links...
          kante = new edge();
          seg = new rat_segment(fabs(Strassennetz->inf(*links).xcoordD()),fabs(Strassennetz->inf(*links).ycoordD()),x1,y1);
          *kante = Strassennetz->new_edge(*links,*knoten,*seg);
          // nach rechts...
          seg = new rat_segment(x1,y1,fabs(Strassennetz->inf(*rechts).xcoordD()),fabs(Strassennetz->inf(*rechts).ycoordD()));
          *kante = Strassennetz->new_edge(*knoten,*rechts,*seg);
//          delete kante;
//          delete knoten;
        }
        knotenliste->append(knoten);
    } else {
      // Fehlendes Segment!
      Debug(0,"Position " << *position << " in Sektor " << sektor << " von " << SektorAnzahl*SektorAnzahl << ".");
      string meldung("Kein passendes Segment gefunden!");
      Error(meldung);
      // Also, Haltestelle mal rigoros entfernen!
      Haltestellen->erase(Haltestellen->get_item(i));
      //HaltestellenKnoten->erase(HaltestellenKnoten->get_item(i));
      i--;
      Debug(7,"... und Haltestelle entfernt!");
//      throw CHaltestelleExceptions(meldung);
    }
//  wartenTaste();
    // Weiter geht es...
    i++;
  } // for all Haltestellen
//  delete zielkante;
//  delete links;
//  delete rechts;
//  delete kante;
//  Debug(7,"Knoten: " << knotenliste->size());
  Strassen->clear();
  delete Strassen;
  return knotenliste;
} // einfuegenHaltestellenStrassennetz

//___________________________________________________________________________

void CStrassennetz::kuerzenKoordinaten(GRAPH<CWegenetzKnoten*,CWegenetzKante*> * Wegenetzgraph) {
  double x, y;
  node * knoten = new node();
  forall_nodes(*knoten, *Wegenetzgraph) {
    Wegenetzgraph->inf(*knoten)->holenPosition()->holen(&x,&y);
    x = x *100;
    x = round(x).to_double();
    x = x / 100;
    y = y *100;
    y = round(y).to_double();
    y = y / 100;
    Wegenetzgraph->inf(*knoten)->holenPosition()->setzen(x,y);
  }
  delete knoten;
} // kuerzenKoordinaten

//___________________________________________________________________________

void CStrassennetz::anfordernSektoren(double Ausdehnung) {
  double Dimension, xDimension, yDimension;
  xDimension = fabs(begrenzungLinks-begrenzungRechts);
  yDimension = fabs(begrenzungOben-begrenzungUnten);
  if (xDimension>yDimension) {
    Dimension = yDimension;
  } else {
    Dimension = xDimension;
  }
  SektorAnzahl = (unsigned int)(Dimension/Ausdehnung);
  if (SektorAnzahl==0) {
    SektorAnzahl=1;
  }
//  Debug(9,"Angeforderte Sektoren: " << SektorAnzahl << "^2");
  Sektor = new (list<edge> *)[SektorAnzahl*SektorAnzahl];
  for(unsigned int i=0; i<SektorAnzahl*SektorAnzahl; i++) {
    Sektor[i] = new list<edge>;
  }
} // anfordernSektoren

//___________________________________________________________________________

//------------------------------------------------------------------------------
// Funktionsname:	berechnenRealwegumgebung
// Beschreibung:	Berechnet das Polygon, welches die Realwegdistanz
//                      um eine Haltestelle herum beschreibt
// Parameter:	GRAPH<rat_point,rat_segment> * G, node * Haltestelle
// Rueckgabe:	-
// Besonderheiten:	
//------------------------------------------------------------------------------

void CStrassennetz::berechnenRealwegumgebung(GRAPH<rat_point,rat_segment> * G, node * Haltestelle) {
  // Ist aktuell von Stefan in Arbeit

  /***
   * Vorgehensweise
   ***

   Von einer vorgegebenen HS aus werden nacheinander alle Wege verfolgt.
   Wobei eine Wegverfolgung wie folgt (*g*) funktioniert:

   1.) Pruefe, ob an einer Kreuzung (dies ist auch die HS selbst)
   1.a) Wenn ja:
        Fuer alle ausgehenden Kanten
        Laufe aktuelle Kante bis zum naechsten Knoten
	Wenn aktuelle Weglaenge>Radius und keine weiteren Kanten, setze
	  aktuellen (nicht den naechsten!) Knoten als "Randpunkt".
        sonst verfolge naechste Kante fuer diesen Knoten, von vorne.
   1.b) Wenn nein: Fuege Strecke hinzu, wenn Weglaenge>Radius, brich diese
          Verfolgung ab.
   */

  Debug(0, "WARNUNG: Override aktiviert, Stefan's Realwegumgebungsberechung!");
  BesuchteKnotenListe = new list<node *>;
  testobKreuzung(G, Haltestelle, 0);


/***
 * Pseudocode - Funktionen
 ***

CStrassennetz::testobKreuzung(dieserKnoten) {
  if (Outgrad>1)
    {
      // ist Kreuzung (oder Teilstueck)
      forall (edges.out)
        {
	  if (!(aktuelle_edge_knoten in besuchte_knoten))
	    {
	      pruefeLaenge(dieserKnoten, aktuelle_edge_knoten);
	    }
	}
      einfuegen(dieserKnoten, besuchte_knoten);
    }
  else
    {
      // ist Sackgasse
      einfuegen(dieserKnoten, besuchte_knoten); // Laufe bis zur letzten Kreuzung zurueck
      MarkiereAlsEndKnoten(dieserKnoten);
    }
}

CStrassennetz::pruefeLaenge(Knoten1, Knoten2) {
  if (bisherigerRealweg+dist(Knoten1, Knoten2) > maximalerRadius)
    {
      MarkiereAlsEndKnoten(Knoten1);
      return; // Laufe bis zur letzten Kreuzung zurueck
    }
  else
    {
      bisherigerRealweg = bisherigerRealweg+dist(Knoten1, Knoten2);
      testobKreuzung(Knoten2);
      // Iteriere neu fuer diesen Knoten
    }
}

  */

}
  
//------------------------------------------------------------------------------
// Funktionsname:	testobKreuzung
// Beschreibung:	Wird von berechnenRealwegumgebung() benoetigt
// Parameter:   GRAPH<rat_point,rat_segment> * G, node * dieserKnoten, double aktuelleLaenge
// Rueckgabe:	double
// Besonderheiten:	Ruft pruefeLaenge() auf.
//------------------------------------------------------------------------------

double CStrassennetz::testobKreuzung(GRAPH<rat_point,rat_segment> * G, node * dieserKnoten, double aktuelleLaenge) { 

  //  cout << "Anzahl ausgehender Kanten von diesem Knoten: " << G->outdeg(* dieserKnoten) << "\n";
  //  cout.flush();

  node * v = new node();
  node * c;// = new node(); // Comparison node
  bool is_in_list = new bool(false);

  if (G->outdeg(* dieserKnoten) > 1)
    {
      //      cout << "Keine Sackgasse.\n";
      forall_adj_nodes(*v, *dieserKnoten)
	{
	  //	  cout << "Ueberpruefe Laenge der Knotenverbindung...\n";
	  forall(c, *BesuchteKnotenListe)
	    {
	      if (c==v) { is_in_list=true; }
	    }

	  if (!(is_in_list))
	    {
	      aktuelleLaenge = pruefeLaenge(G, dieserKnoten, v, aktuelleLaenge);
	    }
	}
    }
  else
    {
      //      cout << "Sackgasse.\n";
      /* Markiere diesen Knoten als Randknoten */
      CPunkt * pl = new CPunkt(G->inf(*dieserKnoten).xcoordD(),G->inf(*dieserKnoten).ycoordD());
//      cout << "Dies ist ein Endknoten weil Sackgasse: " << *pl << "\n";
      /* Trage diesen Knoten in die Liste der besuchten Knoten ein */
    }

  return aktuelleLaenge;

}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:	
// Rueckgabe:	
// Besonderheiten:	
//------------------------------------------------------------------------------

double CStrassennetz::pruefeLaenge(GRAPH<rat_point,rat_segment> * G, node * Knoten1, node * Knoten2, double aktuelleLaenge) {

  list<CPunkt*> * Templiste = new list<CPunkt *>;
  double laenge;
  CPunkt * p = new CPunkt(G->inf(*Knoten1).xcoordD(),G->inf(*Knoten1).ycoordD());
  CPunkt * p2 = new CPunkt(G->inf(*Knoten2).xcoordD(),G->inf(*Knoten2).ycoordD());

  Templiste->append(p);
  Templiste->append(p2);

  //  cout << "Ueberpruefe Laenge der Knotenverbindung...\n";
  //  cout << *p << "  " << *p2 << "\n";

  laenge = ermittelnLaenge(Templiste);

  //  cout << "Laenge ist: " << laenge << "\n";

  aktuelleLaenge += laenge;

  //  cout << "Gesamtlaenge ist: " << aktuelleLaenge << "\n";


  BesuchteKnotenListe->append(Knoten2); // Knoten wurde besucht

  if (aktuelleLaenge < Parameter->holenMaximalesEinzugsgebiet())
    {
      aktuelleLaenge = testobKreuzung(G, Knoten2, aktuelleLaenge);
    }
  else
    {
      // FEHLT NOCH: Als Endknoten markieren
//      cout << "Dies ist ein Endknoten: " << *p << " Laenge war: " << (aktuelleLaenge-laenge) << "\n";
      return aktuelleLaenge;
      //      return 0;
    }

return aktuelleLaenge;

}

//___________________________________________________________________________



 void CStrassennetz::ermittelnInzidenteKnoten(edge * Kante, node * linkerKnoten, node * rechterKnoten, list<node *> * linkeKnotenfolge, list<node *> * rechteKnotenfolge)
 {
//     Debug(2,"ermittelnInzidenteKnoten()");      	

    /*  Variablendeklaration */
    node * StartKnoten = new node();
    node * EndKnoten = new node();
    node * aktuellerKnoten = new node();
    node * potentiellerNeuerKnoten = new node();
    node * knotenZumZwischenspeichern;
    edge * aktuelleKante = new edge();
    edge * alteKante = new edge();
//    linkerKnoten = new node();
//    rechterKnoten = new node();
    list<edge> * KantenListe = new list<edge>;
    list<edge> * Hilfsliste = new list<edge>;
    bool linksfertig, rechtsfertig;
    linksfertig = false;
    rechtsfertig = false;

    // Die Knoten, die inzident mit der Eingabe-Kante sind
    *StartKnoten = Strassennetz->source(*Kante);
    *EndKnoten = Strassennetz->target(*Kante);

    // Iterationsknoten bzw. ~kanten
    *aktuellerKnoten = *StartKnoten;
    *aktuelleKante = *Kante;
    *alteKante = *aktuelleKante;
    /* Solange der linke  und der rechte Strang ausgehend von der Eingabe-Kante nicht abgearbeitet sind
        d.h. Kreuzungsknoten gefunden wurden 							*/
    while (!(linksfertig && rechtsfertig))
    {
      //Die Listen von Knoten aus dem Weg links und rechts zu den Kreuzungen anlegen bzw. loeschen
//      linkeKnotenfolge = new list<node * >;
//      rechteKnotenfolge = new list<node *  >;
      
      // Bedingung fuer einen Kreuzungsknoten: Der Grad ist groesser 2, oder genau 1, bei Start - und Endpunkten einer Strasse
      if ((Strassennetz->degree(*aktuellerKnoten)>2) || (Strassennetz->degree(*aktuellerKnoten) == 1))
    	{
	  // Ist eine Kreuzung
	  
	  // Falls ein Knoten gefunden wurde, ueberpruefen, ob der linke Strang schon fertig ist
	  if (linksfertig)
	    { 	rechtsfertig = true;
	    *rechterKnoten = *aktuellerKnoten;        }
	  else
	    {  	linksfertig = true;
	    *linkerKnoten = *aktuellerKnoten;
	    // Zu den Eingabe-Werten zurueckkehren
	    *aktuelleKante = *Kante; 		
	    *aktuellerKnoten = *EndKnoten;    };
	}
      else
    	{
	  //Den Knoten in der Liste entsprechenden Liste speichern
	  knotenZumZwischenspeichern = new node();
	  if (linksfertig)
	    { 	 //in rechte Knotenliste merken
	      *knotenZumZwischenspeichern = *aktuellerKnoten;
	      rechteKnotenfolge->append(knotenZumZwischenspeichern);
//	      Debug(9,"rechts angefuegt");
	    }
	  else
	    { 	//in linker Knotenliste merken
	      *knotenZumZwischenspeichern = *aktuellerKnoten;
	      linkeKnotenfolge->append(knotenZumZwischenspeichern);    			
//	      Debug(9,"links angefuegt");
	    }
	  
	  //Weiter nach links oder rechts gehen
	  *KantenListe = Strassennetz->out_edges(*aktuellerKnoten);
	  *Hilfsliste = Strassennetz->in_edges(*aktuellerKnoten);
	  KantenListe->conc(*Hilfsliste,LEDA::after);
	  *alteKante = *aktuelleKante;
	  *aktuelleKante = KantenListe->head();
	  
	  if ((*aktuelleKante) == (*alteKante))
	    {
	      //aktuelleKante ist in diesem Fall die schon betrachtete alte Kante
	      // also die andere Kante nehmen
	      *aktuelleKante = KantenListe->tail();
	    };
	  
	  /* aktuellen Knoten bestimmen
	     Dabei darauf achten, dass man nicht wieder den alten Knoten nimmt  */    		
	  *potentiellerNeuerKnoten = Strassennetz->source(*aktuelleKante);
	  
	  if ((*aktuellerKnoten) == (*potentiellerNeuerKnoten))
	    {	*aktuellerKnoten = Strassennetz->target(*aktuelleKante);     }
	  else
	    {	*aktuellerKnoten = Strassennetz->source(*aktuelleKante);       };
    	};
    }
} //ermittelnInzidenteKnoten()

//___________________________________________________________________________

int cmpVerbindungsListe(CVerbindung * const & V1, CVerbindung * const & V2) {
  if (((CVerbindung *)V1)->holenLaenge()>((CVerbindung *)V2)->holenLaenge()) return 1;
  if (((CVerbindung *)V1)->holenLaenge()<((CVerbindung *)V2)->holenLaenge()) return -1;
  return 0;
} // cmpVerbindungsListe

//____________________________________

void CStrassennetz::sortierenVerbindungsListe(void) {
  if (verbindungsListe->length()>0) { // Liste muss Elemente enthalten!
    // Liste nach den Entfernungen aufsteigend sortieren
    verbindungsListe->sort(&cmpVerbindungsListe);
    // Und zuletzt noch Verbindungen mit einer Entfernung von Null entfernen
    while ((verbindungsListe->length()>0) && (((CVerbindung *)verbindungsListe->head())->holenLaenge()==0)) {
      verbindungsListe->pop();
    }
  } // length > 0
/*  cerr << "Liste mit den Verbindungen:\n";
  for (int i=0; i<verbindungsListe->size(); i++) {
    CVerbindung * verbindung = verbindungsListe->contents(verbindungsListe->get_item(i));
    cerr << verbindung->holenLaenge() << "\t" << *(verbindung->holenStart()) << " -> " << *(verbindung->holenZiel()) << "\n";
  }
  cerr.flush();*/
} // sortierenVerbindungsListe

//___________________________________________________________________________

void CStrassennetz::kuerzenStrassennetz(void) {
  node_array<int> compnum(*Strassennetz);
  unsigned int comps = COMPONENTS(*Strassennetz, compnum);
//  Debug(6,"Komponenten des Strassennetzes: " << comps);
  unsigned int comp[comps];
  for (unsigned int i=0; i<comps; i++) {
    comp[i] = 0;
  }
  node knoten;
  forall_nodes(knoten,*Strassennetz) {
    unsigned int c = compnum[knoten];
    comp[c]++;
  }
  unsigned int compMax = 0;
  for (unsigned int i=0; i<comps; i++) {
    if (comp[i]>comp[compMax]) compMax = i;
  }
//  Debug(7,"Maximale Komponente im Strassennetz: " << comp[compMax]);
  list<node> knotenListe;
  forall_nodes (knoten,*Strassennetz) {
    if (compnum[knoten]!=(int)compMax) {
      knotenListe.append(knoten);
    }
  }
  while (knotenListe.size()>0) {
    knoten = knotenListe.pop_front();
    list<edge> kantenListe = Strassennetz->out_edges(knoten);
    for (int j=0; j<kantenListe.size(); j++) {
      Strassennetz->del_edge(kantenListe.contents(kantenListe.get_item(j)));
    }
    kantenListe = Strassennetz->in_edges(knoten);
    for (int j=0; j<kantenListe.size(); j++) {
      Strassennetz->del_edge(kantenListe.contents(kantenListe.get_item(j)));
    }
    Strassennetz->del_node(knoten);
  }
} // kuerzenStrassennetz

//___________________________________________________________________________

double CStrassennetz::berechnenModifizierterKoeffizientHaltestellenLage(double Anteil){
  return Anteil*Parameter->holenKoeffizientStrassenanpassung()+((1-Anteil)*pow(Parameter->holenKoeffizientStrassenanpassung(),2));
} // berechnenModifizierterKoeffizientHaltestellenLage

//___________________________________________________________________________


//___________________________________________________________________________
