
//------------------------------------------------------------------------------
// Projektname:		
// Dateiname:		$RCSfile: CStrassennetzES.h,v $
// Beschreibung:	
// Version:	        $Revision: 1.3 $
// Gendert von:	$Author: pompl $
// Gendert am:		$Date: 2001/07/11 15:02:44 $
// Zustand:	        $State: Exp $
//------------------------------------------------------------------------------


#ifndef CSTRASSENNETZES_H
#define CSTRASSENNETZES_H

#include <LEDA/graph.h>
#include <LEDA/list.h>
#include <LEDA/matrix.h>
#include <LEDA/tuple.h>
#include "CStrassennetz.h"
#include "./../Datenstruktur/CPunkt.h"
#include "./../Datenstruktur/CWegenetzKnoten.h"

#include "teaCESVector.h"
#include "teaISimple.h"
#include "teaPES.h"
#include "teaOperator.h"
#include "teaLottery.h"

class CPunkt;
class CHaltestelle;
class CStrassennetz;

/**
 * Dies ist eine Spezialisierung von CStrassennetz. Hierin werden
 * die Haltestellen mittels einer ES ueber das Planquadrat
 * verteilt. Ansonsten wird der in CStrassennetz definierte Durchlauf
 * unveraendert uebernommen.
 * @see Haltestelle.CStrassennetz
 * @see Haltestelle.CStrassennetz#starten(void)
 * @see Haltestelle.CStrassennetz#HaltestellenKnoten
 */
class CStrassennetzES: public CStrassennetz, public teaCalcFitness<teaIndividual> {
public:
    CStrassennetzES();

    CStrassennetzES(bool * abbrechen, CHSSchnittstelle * lnkSchnittstelle, CParameterHaltestelle * Parameter, CFortschritt * Fortschritt = NULL);

    /**
     * Berechnet die Haltestellen, wobei selbige zufaellig im Planquadrat
     * verteilt werden. Verwendet setzenHaltestelleStochastisch(CPunkt * DerPunkt).
     * @see void setzenHaltestelleStochastisch(CPunkt * DerPunkt)
     * @see Haltestelle.CStrassennetz#HaltestellenKnoten
     * @postcondition Die Liste aus HaltestellenKnoten ist erzeugt.
     */
    void berechnenHaltestellen();

    /**
     */
    void starten(void);

    /**
     * Ermittelt genau eine Haltestelle nach dem Zufallsprinzip.
     */
    void setzenHaltestelleES(CPunkt * DerPunkt);

public:
  virtual teaValue* getValuePrototype();
  virtual teaValue* calcFitness(teaIndividual *it, teaValue *itsValue);
  virtual teaValue* getConstraintsValuePrototype();
  virtual teaValue* checkConstraints(teaIndividual *it, teaValue* itsValue);
};

inline teaValue* CStrassennetzES::getValuePrototype()
{
  return new teaDoubleValue();
};

inline teaValue* CStrassennetzES::getConstraintsValuePrototype()
{
  return new teaDoubleValue();
}

#endif //CSTRASSENNETZES_H
