class CStrassennetzGraph {
private:
	final unsigned int PlanquadratGroesse = 4; // Quadratic structure!
	CPlanquadrat * Planquadrat[PlanquadratGroesse*PlanquadratGroesse];
private:
	/**
	 * Fuegt eine Strasse in alle beruehrten Planquadrate ein.
	 */
	void einfuegenStrasseInPlanquadrate(CStrasse * Strasse);
	
	/**
	 * Entfernt eine Strasse aus allen beruehrten Planquadraten.
	 */
	void entfernenStrasseAusPlanquadrate(CStrasse * Strasse);
	
	list<CPlanquadrat> * ermittelnPlanquadrate(CStrasse); // lists all Planquadrate which are touched by Strasse.
	void aufbrechenStrasse(CStrasse * aufzubrechendeStrasse); // Delete Strasse, insert new ones.
		// Both according Graph and Planquadrat.
		// The Strasse has to be split into separated lists,
		// given by the cross points.
		// Crossed streets have to be deleted and inserted as two new lists.
	void pruefenStrassen(CStrasse * ersteStrasse, CStrasse * zweiteStrasse); // tests if a schnitt exists.
		// tests iterative for all segments of Strasse with all
		// segments of the Strassen.
		// if a segment has more than one Schnitt, sort them by distance.
		// for each schnitt call aufbrechenStrasse(Strasse of Planquadrat).
	void einfuegen(CStrasse * einzufuegendeStrasse); // inserts the new Strasse into the graph.
		// call ermittelnStrassenAusPlanquadraten(all Planquadrate of Strasse).
		// for all Strassen call
		// pruefenStrassen(Strasse, Strassen of Planquadrat).
		// insert new parts of Strasse in Planquadrat and Graph.
	list<CStrasse *>* ermittelnStrassenAusPlanquadraten(Planquadrate); // collects all Strassen of all given Planquadrate
		// but doesn't return doublettes.
public:
	void erzeugen(void); // For all Strassen call einfuegen(Strasse).
		// Marc
	
};