
//------------------------------------------------------------------------------
// Projektname:		
// Dateiname:		$RCSfile: CStrassennetzStochastisch.h,v $
// Beschreibung:	
// Version:	        $Revision: 1.9 $
// Gendert von:	$Author: pompl $
// Gendert am:		$Date: 2001/06/08 09:12:42 $
// Zustand:	        $State: Exp $
//------------------------------------------------------------------------------


/* Generated by Together */

#ifndef CSTRASSENNETZSTOCHASTISCH_H
#define CSTRASSENNETZSTOCHASTISCH_H

#include <LEDA/graph.h>
#include <LEDA/list.h>
#include <LEDA/matrix.h>
#include <LEDA/tuple.h>
#include "CStrassennetz.h"
#include "./../Datenstruktur/CPunkt.h"
#include "./../Datenstruktur/CWegenetzKnoten.h"

class CPunkt;
class CHaltestelle;
class CStrassennetz;

/**
 * Dies ist eine Spezialisierung von CStrassennetz. Hierin werden
 * die Haltestellen nach dem Zufallsprinzip ueber das Planquadrat
 * verteilt. Ansonsten wird der in CStrassennetz definierte Durchlauf
 * unveraendert uebernommen.
 * @see Haltestelle.CStrassennetz
 * @see Haltestelle.CStrassennetz#starten(void)
 * @see Haltestelle.CStrassennetz#HaltestellenKnoten
 */
class CStrassennetzStochastisch: public CStrassennetz {
public:
    CStrassennetzStochastisch();

    CStrassennetzStochastisch(bool * abbrechen, CHSSchnittstelle * lnkSchnittstelle, CParameterHaltestelle * Parameter, CFortschritt * Fortschritt = NULL);

    /**
     * Berechnet die Haltestellen, wobei selbige zufaellig im Planquadrat
     * verteilt werden. Verwendet setzenHaltestelleStochastisch(CPunkt * DerPunkt).
     * @see void setzenHaltestelleStochastisch(CPunkt * DerPunkt)
     * @see Haltestelle.CStrassennetz#HaltestellenKnoten
     * @postcondition Die Liste aus HaltestellenKnoten ist erzeugt.
     */
    void berechnenHaltestellen();

    /**
     * Ermittelt genau eine Haltestelle nach dem Zufallsprinzip.
     */
    void setzenHaltestelleStochastisch(CPunkt * DerPunkt);

};
#endif //CSTRASSENNETZSTOCHASTISCH_H
