
//------------------------------------------------------------------------------
// Projektname:		
// Dateiname:		$RCSfile: CStrassennetzStochastischUmgebung.h,v $
// Beschreibung:	
// Version:	        $Revision: 1.3 $
// Gendert von:	$Author: pompl $
// Gendert am:		$Date: 2001/06/08 09:12:44 $
// Zustand:	        $State: Exp $
//------------------------------------------------------------------------------


/* Generated by Together */

#ifndef CSTRASSENNETZSTOCHASTISCHUMGEBUNG_H
#define CSTRASSENNETZSTOCHASTISCHUMGEBUNG_H

#include <LEDA/graph.h>
#include <LEDA/list.h>
#include <LEDA/matrix.h>
#include <LEDA/tuple.h>
#include "CStrassennetz.h"
#include "./../Datenstruktur/CPunkt.h"
#include "./../Datenstruktur/CWegenetzKnoten.h"

class CPunkt;
class CHaltestelle;
class CStrassennetz;

/**
 * Dies ist eine Spezialisierung von CStrassennetz. Hierin werden
 * die Haltestellen nach dem Zufallsprinzip ueber das Planquadrat
 * verteilt.  Ist dabei in einer Umgebung schon eine Haltestelle vorhanden,
 * so wird keine gesetzt. Ansonsten wird der in CStrassennetz definierte
 * Durchlauf unveraendert uebernommen.
 * @see Haltestelle.CStrassennetz
 * @see Haltestelle.CStrassennetz#starten(void)
 * @see Haltestelle.CStrassennetz#HaltestellenKnoten
 */
class CStrassennetzStochastischUmgebung: public CStrassennetz {
public:
    CStrassennetzStochastischUmgebung();

    CStrassennetzStochastischUmgebung(bool * abbrechen, CHSSchnittstelle * lnkSchnittstelle, CParameterHaltestelle * Parameter, CFortschritt * Fortschritt = NULL);

    /**
     * Berechnet die Haltestellen, wobei selbige zufaellig im Planquadrat
     * verteilt werden. Ist dabei in einer Umgebung schon eine Haltestelle vorhanden,
     * so wird keine gesetzt.
     * Verwendet setzenHaltestelleStochastisch(CPunkt * DerPunkt).
     * @see void setzenHaltestelleStochastisch(CPunkt * DerPunkt)
     * @see Haltestelle.CStrassennetz#HaltestellenKnoten
     * @postcondition Die Liste aus HaltestellenKnoten ist erzeugt.
     */
    void berechnenHaltestellen();

    /**
     * Ermittelt genau eine Haltestelle nach dem Zufallsprinzip.
     */
    void setzenHaltestelleStochastisch(CPunkt * DerPunkt);

};
#endif //CSTRASSENNETZSTOCHASTISCHUMGEBUNG_H
