/* Generated by Together */

#include "CAufbereitungsphase.h"

CAufbereitungsphase::~CAufbereitungsphase(){
Debug(1, "[CAufbereitungsphase:Destruktor] Destruktor, nichts zu tun hier");
  /**
   * Netzplan
   * Wegenetzgraph
   * Verkehrsbedarfsmatrix
   * werden nicht geloescht, weil sie von anderen Klassen noch benutzt werden koennten
   */

}  

CAufbereitungsphase::CAufbereitungsphase(CNetzplan * meinNetzplan, UGRAPH<CWegenetzKnoten*,CWegenetzKante*> * wegenetz, matrix * qzmatrix){
Debug(1, "[CAufbereitungsphase:Konstruktor] Konstruktor");
Debug(9, "[CAufbereitungsphase:Konstruktor] Ubergebenen Netzplan, Wegenetz und Quelle-/Zielmatrix zuweisen");
  netzplan = meinNetzplan;
  wegenetzgraph = wegenetz;
  quellezielmatrix = qzmatrix;
  netzplanKante = 0;
  netzplanKnoten = 0;
  wegenetzKante = 0;
  wegenetzKnoten = 0;
  
  // Pruefen, ob Wegenetzgraph leer
  if (wegenetzgraph->empty()){
    Debug(9,"[FEHLER!!!]Wegenetzgraph ist leer");
    netzplan->setzenStop(true);
    return;
  }//Ende if wegenetzgraph->empty

  // Pruefen, ob Graph zusammenhaengend
  node startknoten = wegenetzgraph->choose_node();
  node_array<bool> pruefarray(*wegenetzgraph);
  
  list<node> pruefliste = DFS(*wegenetzgraph,startknoten,pruefarray);
  if (pruefliste.length() == wegenetzgraph->number_of_nodes()) Debug(9," [CAufbereitungsphase:Konstruktor]Wegenetzgraph ist zusammenhaengend]");
  
  fortschritt = netzplan->holenFortschritt();
}

void CAufbereitungsphase::umlegen(){
Debug(5, "[CAufbereitungsphase:Umlegen()] Start von Umlegen()");
  edge_map<int>* kantenListe;
  edge netzplanhilfskante;
  node netzplanhilfsknoten1;
  node netzplanhilfsknoten2;
  int strom;
  int id1;
  int id2;
  int anzKnoten = netzplangraph->number_of_nodes();
  int anzKanten = netzplangraph->number_of_edges();

  netzplangraph->make_directed();
  list<edge> rueckkanten = netzplangraph->insert_reverse_edges();
  Debug(9,"Anzahl der Rueckkanten: " << rueckkanten.length());

  /**
   * Zusammenhangspruefung des Netzplangraphen per DFS
   */

  node_array<bool> dummyarray(*netzplangraph,false);
  list<node> erreichteKnoten = DFS(*netzplangraph,(netzplangraph->choose_node()),dummyarray);
  Debug(9,"DFS gibt aus: " << erreichteKnoten.size());
  if ((erreichteKnoten.size()) != (netzplangraph->number_of_nodes())){
    Debug(9,"[FEHLER!!!] Graph ist nicht zusammenhaengend!");
    netzplan->setzenStop(true);
    return;
  }//Ende if erreichteKnoten != ntzplangraph->number of nodes

  //netzplangraph->print(cout);

   /**
   * kuerzeste Wege ermitteln & Verkehrsbedarfe an die kuerzesten Wege legen
   */

  double dimension = static_cast<double>(netzplangraph->number_of_nodes());
  double verbindungen = static_cast<double>((dimension*dimension)-dimension);
  int maximum = (static_cast<int>(verbindungen))/2;
  int aktuell = 0;

  int mindestreisezeit = 0;
  /* edge array aufbauen fuer Dijkstra */
  netzplan->vorbereitenDijkstra();
  /* doppelte node-Schleife, um alle Knotenpaare zu kriegen */
  Debug(8, "[CAufbereitungsphase:Umlegen()] doppelte forall_nodes-Schleife, um Dijkstra mit allen Knotenpaaren zu fuettern");
  forall_nodes(netzplanhilfsknoten1,*netzplangraph){
    
    netzplanKnoten = netzplangraph->inf(netzplanhilfsknoten1);
    id1 = netzplanKnoten->holenID();
    //Debug(9,"[CAufbereitungsphase:Umlegen()] Dijkstra von Knoten " << id1 << " aus.");
    char text[50];
    sprintf(text,"Aufbereitungsphase: Betrachte Knoten %d",id1);
    fortschritt->meldenLaufzeitAusgabe(text);
    
    node_array<edge> dijkstraErgebnis = netzplan->machenDijkstra(netzplanhilfsknoten1);
     
    forall_nodes(netzplanhilfsknoten2,*netzplangraph){

      if ((netzplan->holenStop())==true) return;     
 
      netzplanKnoten = netzplangraph->inf(netzplanhilfsknoten2);
      id2 = netzplanKnoten->holenID();
      //Debug(9,"[umlegen] ...nach Knoten " << id2);
       
      /* sicherstellen, dass die beiden Knoten nicht gleich sind */
      if ((netzplanhilfsknoten1!=netzplanhilfsknoten2) && (id1<id2)){

	aktuell++;
	fortschritt->anzeigenFortschritt(aktuell,maximum);

	/* verkehrsstrom von Knoten1 nach Knoten2 rauskriegen */
	/* Matrix gibt double zurueck, casten auf int */
	strom = static_cast<int>((*quellezielmatrix)(id1,id2));
	/* Ergebniskanten durchlaufen und an alle Kanten den strom addieren */
	/* dijkstraErgebnis(Knoten) gibt die Kante aus, die in den Knoten hineinlaeuft */

	/* !! an die Knoten eine Liste anfuegen mit KantenID und versackendem/entstehendem Strom */

	node u = netzplanhilfsknoten2;
	/* im Zielknoten den Strom in der edge_map eintragen */
	edge netzplanhilfskante2 = dijkstraErgebnis[u];
	netzplanKnoten = netzplangraph->inf(netzplanhilfsknoten2);
	kantenListe = netzplanKnoten->holenKantenListe();

	int* hilfstrom = &(*kantenListe)[netzplanhilfskante2];
	*hilfstrom = (*hilfstrom) + strom;

	while (u != netzplanhilfsknoten1){
	  netzplanhilfskante = dijkstraErgebnis[u];
	  netzplanKante = netzplangraph->inf(netzplanhilfskante);
	  int hilfstrom2 = netzplanKante->holenVerkehrsstrom();
	  hilfstrom2 = hilfstrom2 + strom;
	  netzplanKante->setzenVerkehrsstrom(hilfstrom2);
	  int entfernung = netzplanKante->holenEntfernung();
	  int entfernungsteiler = netzplan->holenEntfernungsteiler();
	  int fahrzeit = static_cast<int>(entfernung/entfernungsteiler);
	  if ((entfernung%entfernungsteiler)>0) fahrzeit++;
	  mindestreisezeit = mindestreisezeit + fahrzeit;
	  u = netzplangraph->source(netzplanhilfskante);
	}
	
	/* im Anfangsknoten den Strom in der edge_map eintragen */
	/* Annahme: u ist jetzt der Anfangsknoten und netzplanhilfskante ist die Kante daraus */
	netzplanKnoten = netzplangraph->inf(netzplanhilfsknoten1);
	kantenListe = netzplanKnoten->holenKantenListe();
	int* hilfstrom3 = &(*kantenListe)[netzplanhilfskante];
	*hilfstrom3 = (*hilfstrom3) + strom;
	
	//Debug(6, "[CAufbereitungsphase:Umlegen()] In Knoten "<< id1 <<" in der Kantenliste den Strom zuordnen");
	//Debug(9, "[CAufbereitungsphase:Umlegen()] Knoten: "<<  netzplanKnoten->holenID() << "; Strom " << strom << " wird in der Kantenliste zu Kante " << (netzplangraph->inf(netzplanhilfskante))->holenID() <<" zugeordnet. Neuer Strom ist nun "<< (*kantenListe)[netzplanhilfskante]);
	//Debug(9, "[CAufbereitungsphase:Umlegen()] Knotenarray fuer dijkstra-Ergebnis zuruecksetzen");
      }
    }// Ende inneres Forall_nodes
    //Debug(9,"[umlegen] Zeile 178:Anzahl Knoten: " << netzplangraph->number_of_nodes());
    //Debug(9,"[umlegen] Nachfolger zeigt auf: " << netzplangraph->succ_node(netzplanhilfsknoten1));

  }//Ende auesseres forallnodes

  int mittleremindestreisezeit = static_cast<int>((static_cast<double>(mindestreisezeit))/verbindungen);
  netzplan->setzenMittlereMindestreisezeit(mittleremindestreisezeit);
  cout << "Mindestreisezeit ist: " << mittleremindestreisezeit << "\n";

  /**
   * Kanten mit Verkehrsstrom 0 loeschen !GESTORBEN!
   */
  //Debug(8, "[CAufbereitungsphase:Umlegen()] Kanten mit Verkehrsstrom 0 loeschen");
  //  forall_edges(netzplanhilfskante,*netzplangraph){
  //    netzplanKante = netzplangraph->inf(netzplanhilfskante);
//Debug(9, "[CAufbereitungsphase:Umlegen()] Betrachte Kante " << netzplanKante->holenID() << ";Strom ist " <<  netzplanKante->holenVerkehrsstrom());
  //    if (netzplanKante->holenVerkehrsstrom() == 0){
  //Debug(9, "[CAufbereitungsphase:Umlegen()] Loesche Kante " << netzplanKante->holenID());
//netzplangraph->del_edge(netzplanhilfskante);
  //    }//Ende if verkehrsstrom == 0
  // }// Ende forall_edges

  // Pruefen, ob komischerweise keine Kanten mehr da sind
  if ((netzplangraph->all_edges()).empty()){
    Debug(9,"[FEHLER!!!] Alle Kanten sind geloescht worden! Irgendwas ist schief gelaufen");
    netzplan->setzenStop(true);
    return;
  }

  // Pruefen, ob durch das Loeschen von Kanten Knoten ohne Kanten existieren
  node npiterator;
  forall_nodes(npiterator,*netzplangraph){
    if ((netzplangraph->degree(npiterator)) == 0){
      Debug(9,"[FEHLER!!!!] Knoten ohne Kanten existieren. Abbruch!");
      netzplan->setzenStop(true);
      return;
    }
  }//Ende forall_nodes npiterator

  netzplangraph->del_edges(rueckkanten);
  netzplangraph->make_undirected();

  int gesamtstreckenkilometer = 0;
  int kanten =0;
  edge npit;
  forall_edges(npit,*netzplangraph){
    CNetzplanKante* nphilf = netzplangraph->inf(npit);
    int entfernung = nphilf->holenEntfernung();
    gesamtstreckenkilometer = gesamtstreckenkilometer + entfernung;
    kanten++;
    //Debug(9,"Gesamtstreckenkilometer: " << gesamtstreckenkilometer);
  }
  Debug(9,"gezaehlte Kanten: " << kanten);
  netzplan->setzenGesamteStreckenkilometer(gesamtstreckenkilometer);
  cout << "Gesamtstreckenkilometer: " << gesamtstreckenkilometer << "\n";

if (netzplangraph->empty()){
 Debug(9,"[FEHLER!!!!] Netzplangraph ist leer");
 netzplan->setzenStop(true);
 return;
}

/** Da die Verkehrsstroeme komischerweise doppelt so gross sind, halbieren
 *  edge npkanteniterator;
 * forall_edges(npkanteniterator,*netzplangraph){
 *   int tempstrom = (netzplangraph->inf(npkanteniterator))->holenVerkehrsstrom();
 *   tempstrom = tempstrom/2;
 *   (netzplangraph->inf(npkanteniterator))->setzenVerkehrsstrom(tempstrom);
 * }  Ende forall_edges 
 */

Debug(9,"Netzplangraph hat " << netzplangraph->number_of_nodes() << " Knoten und " << netzplangraph->number_of_edges() << " Kanten");
 Debug(9,"Zum Vergleich : vorher " << anzKnoten << " Knoten und " << anzKanten << " Kanten");
 //netzplangraph->print(cout);
 netzplan->setzenNetzplan(netzplangraph);
}

void CAufbereitungsphase::reduzieren(){
Debug(2, "[CAufbereitungsphase:Reduzieren()] Wie um alles in der Welt kommst Du hierher??? Die Methode wird doch noch nicht benutzt!");
  /**
   * wird nicht benutzt, deswegen Kopfzerbrechen spaeter...
   */
}

void CAufbereitungsphase::starten(){
Debug(2, " [CAufbereitungsphase:starten()] Start der Methode");
  /**
   * aus dem Wegenetzgraph den Netzplan bilden:
   */
  node wegenetzhilfsknoten;
  node wegenetzAnfang;
  node wegenetzEnde;
  edge wegenetzhilfskante;
  node netzplanAnfang;
  node netzplanEnde;
  node netzplanhilfsknoten;
  list<node> knotenListe;
  edge_map<int>* kantenListe;
  int i;
  int Anfang;
  int Ende;

  i = 1; /* Laufvariable, um die Kanten zu nummerieren */
  netzplangraph = netzplan->holenNetzplan();
  if (wegenetzgraph!=0){
    //if (wegenetzgraph->is_directed()) wegenetzgraph->make_undirected();
 Debug(9,"Wegenetzgraph hat " << wegenetzgraph->number_of_nodes() << " Knoten und " << wegenetzgraph->number_of_edges() << " Kanten");

// Check, ob alle Entfernungen okay sind
edge wgKante;
forall_edges(wgKante,*wegenetzgraph){
  CWegenetzKante* wegenetzkante = wegenetzgraph->inf(wgKante);
  if (wegenetzkante->holenEntfernung() == 0){
    Debug(9,"[starten()] FEHLER!!! Entfernung ist 0!");
    return;
  }
}
  Debug(9,"[starten()] Entfernungen sind okay");
 /**
  * doppelte Kanten eliminieren
  */
  fortschritt->meldenLaufzeitAusgabe("Aufbereitungsphase: Netzplangraph aufbauen");
  int ziel = (wegenetzgraph->number_of_nodes())+(wegenetzgraph->number_of_edges());
  int aktuell = 0;

Debug(8, "[CAufbereitungsphase:Starten()] Durchlaufen alle Knoten des Wegenetzgraphen");
    forall_nodes(wegenetzhilfsknoten, *wegenetzgraph){ /* alle Knoten des Wegenetzgraphen durchgehen */

      aktuell++;
      fortschritt->anzeigenFortschritt(aktuell,ziel);

       /* aus dem Knoten die CWegenetzKnoten-Klasse holen */
      wegenetzKnoten = wegenetzgraph->inf(wegenetzhilfsknoten);
      //Debug(9, "[CAufbereitungsphase:Starten()] Betrachte Wegenetzknoten " << wegenetzKnoten->holenKnotenId());

      /* neue CNetzplanKnoten-Klasse erzeugen und die Daten kopieren */
      netzplanKnoten = new CNetzplanKnoten;
      netzplanKnoten->setzenID(wegenetzKnoten->holenKnotenId());
      netzplanKnoten->setzenPrioritaet(wegenetzKnoten->holenPrioritaet());

      /* neuen Knoten im Netzplan erzeugen mit Parameter netzplanKnoten */
      netzplangraph->new_node(netzplanKnoten);
      //Debug(9, "[CAufbereitungsphase:Starten()] Neuen Netzplanknoten erstellt: Knotennr: " << netzplanKnoten->holenID() << ";Prioritaet " << netzplanKnoten->holenPrioritaet());

    } /* forall_nodes schluss */
  
    /* node_list vom netzplangraph holen und knotenListe zuweisen */
    //knotenListe = netzplangraph->all_nodes();
   
    // Auf loops testen und diese eliminieren
    if (Is_Loopfree(*wegenetzgraph) != true){
      Delete_Loops(*wegenetzgraph);
    }
 
    /* knotenListe nach IDs aufsteigend sortieren */
    //knotenListe.sort();
    Debug(6, "[CAufbereitungsphase:Starten()] Jetzt alle Kanten des Wegenetzgraphen durchlaufen");

    forall_edges(wegenetzhilfskante, *wegenetzgraph){ /* alle Kanten des Wegenetzgraphen durchgehen */

      aktuell++;
      fortschritt->anzeigenFortschritt(aktuell,ziel);

      /* aus der Kante die CWegenetzKante-Klasse holen */
      wegenetzKante = wegenetzgraph->inf(wegenetzhilfskante);

      /* Anfang und Ende von wegenetzhilfskante ermitteln */
      wegenetzAnfang = wegenetzgraph->source(wegenetzhilfskante);
      wegenetzEnde = wegenetzgraph->opposite(wegenetzAnfang,wegenetzhilfskante);

      /* CWegenetzKnoten-Klasse aus dem Anfangsknoten holen */
      wegenetzKnoten = wegenetzgraph->inf(wegenetzAnfang);
      Anfang = wegenetzKnoten->holenKnotenId();
      /* CWegenetzKnoten-Klasse aus dem Endknoten holen */
      wegenetzKnoten = wegenetzgraph->inf(wegenetzEnde);
      Ende = wegenetzKnoten->holenKnotenId();
      //Debug(9, "[CAufbereitungsphase:Starten()] Wegenetzkante laeuft von " << Anfang << " zu " << Ende);

      node suchKnoten;

      /*Anfangs- und Endknoten aus der Liste holen */
	//netzplanAnfang = knotenListe.inf(knotenListe.get_item(Anfang));
      /* get_item = gebe Listenelement, inf = gebe Listenelementinhalt */
	//netzplanEnde = knotenListe.inf(knotenListe.get_item(Ende));

      forall_nodes(suchKnoten,*netzplangraph){
	int suchID = (netzplangraph->inf(suchKnoten))->holenID();
	if (suchID == Anfang) netzplanAnfang = suchKnoten;
	if (suchID == Ende) netzplanEnde = suchKnoten;
      }

      // Pruefen, ob schon eine Kante existiert
//Debug(9,"[CAufbereitungsphase:Starten()] Pruefen, ob schone eine Kante existiert");
      bool gefunden = false;
      edge npsuche;
      forall_adj_edges(npsuche,netzplanAnfang){
	if ((netzplangraph->opposite(netzplanAnfang,npsuche)) == netzplanEnde) gefunden = true;
      }//Ende forall_adj_edges

      // Wenn nicht schon eine Kante gefunden worden ist, machen
      if (gefunden == false){	
//Debug(9,"[CAufbereitungsphase:Starten()] Keine Kante gefunden, lege neue an");	
        /* neue CNetzplanKante-Klasse erzeugen und Daten kopieren */
        netzplanKante = new CNetzplanKante;
        netzplanKante->setzenID(i);
        netzplanKante->setzenAnzBasislinien(0);
        netzplanKante->setzenVerkehrsstrom(0);
        netzplanKante->setzenEntfernung(wegenetzKante->holenEntfernung());
        i++;

 //     Debug(9, "[CAufbereitungsphase:Starten()] Setze Netzplankante in Graphen: von Knoten " << (netzplangraph->inf(netzplanAnfang))->holenID() << " zu Knoten " <<(netzplangraph->inf(netzplanEnde))->holenID());
        /* Kante in netzplan einfuegen */
        netzplangraph->new_edge(netzplanAnfang,netzplanEnde,netzplanKante);
        /* nicht sehr zeiteffektiv, weil get_Item lineare Zeit braucht, aber was solls */
      } //Ende if gefunden=false
    } /* forall_edges schluss */

Debug(9, "[CAufbereitungsphase:Starten()] Durchlaufe alle Knoten und initialisiere die Edge_Maps");
    /* in allen Knoten die edge_maps mit dem Graphen initialisieren */
    forall_nodes(netzplanhilfsknoten, *netzplangraph){
      netzplanKnoten = netzplangraph->inf(netzplanhilfsknoten);
      kantenListe = netzplanKnoten->holenKantenListe();
      kantenListe->init(*netzplangraph,0);
    } /* forall_edges schluss */
  } /* if schluss */

  //Debug(9,"Netzplangraph soweit:");
  //netzplangraph->print(cout);

if (netzplangraph->empty()){
  Debug(9,"[FEHLER!!!!] netzplangraph ist leer");
  netzplan->setzenStop(true);
  return;
} // Ende if netzplangraph->empty

 if (netzplan->pruefenZusammenhang(netzplangraph->choose_node()) == true) {Debug(9,"Netzplangraph zusammenhaengend")} else Debug(9,"Netzplangraph nicht zusammenhaengend");

 Debug(9,"Wegenetzgraph hat " << wegenetzgraph->number_of_nodes() << " Knoten und " << wegenetzgraph->number_of_edges() << " Kanten");
 Debug(9,"Netzplangraph hat " << netzplangraph->number_of_nodes() << " Knoten und " << netzplangraph->number_of_edges() << " Kanten");

 //netzplangraph->print(cout);
 netzplan->setzenNetzplan(netzplangraph);
}






