/* Generated by Together */

#ifndef BASISLINIE_H
#define BASISLINIE_H

#include "CNetzplanKnoten.h"
#include "CNetzplanKante.h"
#include <iostream.h>

/**
 * Eine Basislinie ist ein Weg von genau zwei Kanten an einer
 * Haltestelle im Wegenetz. 
 */
class CBasislinie {

public:

   /**
    * Default Konstruktor
    */
    CBasislinie();

   /**
    * Default Destruktor
    */
    ~CBasislinie();
    
   /**
    * Kopier Konstruktor
    */
    CBasislinie(const CBasislinie&);

   /**
    * = Operator
    */
    CBasislinie& operator= (const CBasislinie&);

   /**
    * >> Operator
    */
    friend istream& operator>> (istream&, CBasislinie&);

   /**
    * << Operator
    */
    friend ostream& operator<< (ostream&, const CBasislinie&);

   /**
    * Vergleichoperator um von gross nach klein zu sortieren
    */
    friend int compare(const CBasislinie*, const CBasislinie*);

   /**
    * gebe eine Kante zurueck
    */
    CNetzplanKante* holenKante(int nummer);

    /**
     * setze eine Kante
     */
    void setzenKante(int nummer, CNetzplanKante* Kante);

    /**
     * gebe einen Knoten zurueck
     */
    CNetzplanKnoten* holenKnoten(int nummer);

    /**
     * setze einen Knoten
     */
    void setzenKnoten(int nummer, CNetzplanKnoten* knoten);

    /**
     * gebe den Strom zurueck
     */
    int holenStrom();

    /**
     * setze den Strom
     */
    void setzenStrom(int strom);

    LEDA_MEMORY(CBasislinie);

private:    

    /**
     * @supplierCardinality 0..1 
     */
    CNetzplanKante * kante[2];

    /**
     * @supplierCardinality 0..2 
     */
    CNetzplanKnoten * knoten[3];
    int strom;
};
#endif //BASISLINIE_H
