/* FIXME: Header erneuern, Ersteller und copyright */
/* Generated by Together */

#include "CLinienplan.h"
#include "../Datenstruktur/define.h"

// Wenn wir mit Dummydaten arbeiten sollen, dann geht es hier lang :)
#ifdef LINIENPLANDUMMYDATEN
#include "linienplandummydaten.cpp"
#else
/* Der Konstruktor */
CLinienplan::CLinienplan(CLPSchnittstelle* programmSchnittstelle){
        Debug(1, "[CLASS::] CLinienplan()");
	// Den uebergebenen Zeiger sichern
	lPSchnittstelle = programmSchnittstelle;
	lPSchnittstelleTest = 0;
	// Einen Netzplan erzeugen
	netzplan = new CNetzplan(lPSchnittstelle->pruefenBatchModus());
	// Attributen einen Initialwert geben
	aufbereitungsphase = 0;
	verknuepfungsphase = 0;
	bewertungsphase = 0;
	quellezielmatrix_lp = 0;
	// Ab jetzt kann es losgehen. Also den Status setzen
	status = unbenutzt;
}

/* Der Konstruktor fuer die Testumgebung*/
CLinienplan::CLinienplan(CLPSchnittstelleTest* programmSchnittstelle){
        Debug(1, "[CLASS::] CLinienplan()");
	// Den uebergebenen Zeiger sichern
	lPSchnittstelle = 0;
	lPSchnittstelleTest = programmSchnittstelle;
	// Einen Netzplan erzeugen
	netzplan = new CNetzplan(true);
	// Attributen einen Initialwert geben
	aufbereitungsphase = 0;
	verknuepfungsphase = 0;
	bewertungsphase = 0;
	quellezielmatrix_lp = 0;
	// Ab jetzt kann es losgehen. Also den Status setzen
	status = unbenutzt;
}
/* Der Destruktor */
CLinienplan::~CLinienplan(){

	Debug(1, "[CLASS::~] CLinienplan()");
	// Erstmal muessen wir schauen, ob noch ein Thread bei uns laeuft
	// und bei Bedarf dann stoppen
	stoppen();
	// Jetzt muessen wir nur noch alle Objekte loeschen die wir vielleicht
	// erzeugt haben...
	Debug(1, "[CLASS::~] CLinienplan() aufb");
	if (aufbereitungsphase != 0) delete aufbereitungsphase;
	Debug(1, "[CLASS::~] CLinienplan() verkn");
	if (verknuepfungsphase != 0) delete verknuepfungsphase;
	Debug(1, "[CLASS::~] CLinienplan() bewert");
	if (bewertungsphase != 0) delete bewertungsphase;
	Debug(1, "[CLASS::~] CLinienplan() netzpl");
	if (netzplan != 0) delete netzplan;
	// Und jetzt sterben wir....
	Debug(1, "[CLASS::~] CLinienplan() fertig");
}

GraphWin* CLinienplan::zeigenWegenetzgraph(UGRAPH<CWegenetzKnoten*,CWegenetzKante*> *wegenetzgraph){

	int ID;
	char hilfe[10];
	node wgKnoten;
	edge wgKante;

	color blau(4);
	color rot(2);

	GraphWin* winWegenetzgraph = new GraphWin(*wegenetzgraph, "Wegenetzgraph");
	winWegenetzgraph->set_flush(false);
	winWegenetzgraph->display();
	winWegenetzgraph->set_animation_steps(0);
	gw_center_graph(*winWegenetzgraph);
	gw_zoom_down(*winWegenetzgraph);
	gw_circle_embed(*winWegenetzgraph);
	gw_spring_embed(*winWegenetzgraph);

	//Knoten mit den ID beschriften
	forall_nodes(wgKnoten,*wegenetzgraph){
		ID = (wegenetzgraph->inf(wgKnoten))->holenKnotenId();
		sprintf(hilfe, "%d", ID);
		string s(hilfe);
		winWegenetzgraph->set_label_color(wgKnoten,blau);
		winWegenetzgraph->set_user_label(wgKnoten,s);
	}
	forall_edges(wgKante,*wegenetzgraph){
		ID = (wegenetzgraph->inf(wgKante))->holenEntfernung();
		sprintf(hilfe, "%d", ID);
		string s(hilfe);
		winWegenetzgraph->set_label_color(wgKante,rot);
		winWegenetzgraph->set_user_label(wgKante,s);
	}
	winWegenetzgraph->set_flush(true);
	winWegenetzgraph->redraw();
	//winWegenetzgraph->edit();
	return(winWegenetzgraph);
}

GraphWin* CLinienplan::zeigenNetzgraph(){

	UGRAPH<CNetzplanKnoten*,CNetzplanKante*>* netzplangraph = netzplan->holenNetzplan();

	if (netzplangraph != 0) {
		int ID;
		char hilfe[10];
		node npKnoten;
		edge npKante;

		color blau(4);
		color rot(2);

		GraphWin* winNetzplangraph = new GraphWin(*netzplangraph,"Netzplangraph");
		winNetzplangraph->set_flush(false);
		winNetzplangraph->display();
		//winNetzplangraph->edit();
		winNetzplangraph->set_animation_steps(0);
		gw_center_graph(*winNetzplangraph);
		gw_zoom_down(*winNetzplangraph);
		gw_circle_embed(*winNetzplangraph);
		gw_spring_embed(*winNetzplangraph);
		forall_nodes(npKnoten,*netzplangraph){
	  		ID = (netzplangraph->inf(npKnoten))->holenID();
	  		sprintf(hilfe, "%d", ID);
	  		string s(hilfe);
	  		winNetzplangraph->set_label_color(npKnoten,blau);
	  		winNetzplangraph->set_user_label(npKnoten,s);
	  	}
		forall_edges(npKante,*netzplangraph){
			ID = (netzplangraph->inf(npKante))->holenID();
			sprintf(hilfe, "%d", ID);
			string s(hilfe);
			winNetzplangraph->set_label_color(npKante,rot);
			winNetzplangraph->set_user_label(npKante, s);
		}
		winNetzplangraph->set_flush(true);
		winNetzplangraph->redraw();
		return(winNetzplangraph);
	} else
		return(0);
}

GraphWin* CLinienplan::zeigenLinienplanGraph(GRAPH<CFPlanGraphKnoten*,CFPlanGraphKante*>* fertigerLinienplanGraph){

	int ID;
	char hilfe[10];
	node fpKnoten;
	edge fpKante;

	color blau(4);
	color rot(2);

	GraphWin* winFahrplangraph = new GraphWin(*fertigerLinienplanGraph,"Fahrplangraph");
	winFahrplangraph->set_flush(false);
	winFahrplangraph->display();
	winFahrplangraph->set_animation_steps(0);
      	gw_center_graph(*winFahrplangraph);
	gw_zoom_down(*winFahrplangraph);
	gw_circle_embed(*winFahrplangraph);
	gw_spring_embed(*winFahrplangraph);
	forall_nodes(fpKnoten,*fertigerLinienplanGraph){
		ID = (fertigerLinienplanGraph->inf(fpKnoten))->holenID();
		sprintf(hilfe, "%d", ID);
		string s(hilfe);
		winFahrplangraph->set_label_color(fpKnoten,blau);
		winFahrplangraph->set_user_label(fpKnoten,s);
		//winFahrplangraph->adjust_node_to_label(fpKnoten);
	}
	forall_edges(fpKante,*fertigerLinienplanGraph){
		ID = (fertigerLinienplanGraph->inf(fpKante))->holenLinienID();
		sprintf(hilfe, "%d", ID);
		string s(hilfe);
		winFahrplangraph->set_label_color(fpKante,rot);
		winFahrplangraph->set_user_label(fpKante,s);
	}
	winFahrplangraph->set_flush(true);
	winFahrplangraph->redraw();
	winFahrplangraph->acknowledge("Wenn alles ueberprueft ist \"done\" druecken");
	winFahrplangraph->edit();
	return(winFahrplangraph);
}


void CLinienplan::starten(){
        Debug(2, "CLinienplan::starten");
	UGRAPH<CWegenetzKnoten*,CWegenetzKante*>* wegenetzgraph;
	list<CLinie*> * linienplan;
	Startart art;

	netzplan->holenFortschritt()->meldenLaufzeitAusgabe("LP: Linienplan ohne Pflichtlinien gestartet");
	if (lPSchnittstelle!=0){
		wegenetzgraph = lPSchnittstelle->holenLinienplanWegenetzgraph();
		linienplan = lPSchnittstelle->holenLinienplanVorgegebeneLinien();
		if (linienplan->length()!=0){
			art = startMitL;
		}else{
			art = startOhneL;
		}
	}

	// Alles weitere macht metastarten :)
	metastarten(art, wegenetzgraph,
                 linienplan);
}

void CLinienplan::rueckkoppeln(){
        Debug(2, "CLinienplan::rueckkoppeln");
	list<CLinie*> * linienplan;
	Startart art;

	netzplan->holenFortschritt()->meldenLaufzeitAusgabe("LP: Rueckkopplung ohne Pflichtlinien gestartet");
	if (lPSchnittstelle!=0){
		linienplan = lPSchnittstelle->holenLinienplanVorgegebeneLinien();
		if (linienplan->length()!=0){
			art = rueckMitL;
		}else{
			art = rueckOhneL;
		}
	}
	
        // Alles weitere macht metastarten :)
        metastarten(art, (UGRAPH<CWegenetzKnoten*,CWegenetzKante*>*) 0,
                  linienplan);
}

void CLinienplan::metastarten(Startart art, UGRAPH<CWegenetzKnoten*,CWegenetzKante*> * wegenetzgraph,
                 list<CLinie*> * linienplan){

	Debug(2, "CLinienplan::metastarten");

        GRAPH<CFPlanGraphKnoten*,CFPlanGraphKante*>* fertigerLinienplanGraph;
	matrix* quellezielmatrix;
	list<CLinie*>* linienliste;
	int gesamtLinienlaenge;
	int maxAnzahlvonLinien;
	int maxLinienlaenge;
	int anzeigen;
	GraphWin *winWegenetzgraph = 0;
	GraphWin *winNetzplangraph = 0;
	GraphWin *winFahrplangraph = 0;
	float zeit = used_time();

	char* teilschritte[] = {"Daten einlesen", "Aufbereitungsphase","Umlage", "Basislinienwahl",
				"Eindeutige Linienwahl",
				"Mehrdeutige Linienwahl", "Aufbruchsverknuepfung", "Linienendverknuepfung",
				"Bewertungsphase", "Daten speichern"};
	netzplan->holenFortschritt()->setzenTeilschritte(10,teilschritte);

	netzplan->holenFortschritt()->setzenNaechstenSchritt(0);

	if (lPSchnittstelle!=0){
		quellezielmatrix = lPSchnittstelle->holenLinienplanQuelleZielMatrix();
		gesamtLinienlaenge = lPSchnittstelle->holenLinienplanGesamtlaenge();
		maxAnzahlvonLinien = lPSchnittstelle->holenLinienplanMaxLinienAnzahl();
		maxLinienlaenge = lPSchnittstelle->holenLinienplanLinienLaenge();
		anzeigen = lPSchnittstelle->holenAnzeigenGraphen();
		netzplan->setzenGeschwindigkeit(lPSchnittstelle->holenGeschwindigkeit());
	}

	linienliste = netzplan->holenLinienliste();
	if (linienliste != 0) delete linienliste;
	if (linienplan != 0) {
		netzplan->setzenLinienliste(linienplan);
	} else {
		netzplan->setzenLinienliste(new list<CLinie*>);
	}

	if (anzeigen && (wegenetzgraph != 0))
		winWegenetzgraph = zeigenWegenetzgraph(wegenetzgraph);

	// Wurde start schon mal aufgerufen. Start darf aber nur einmal aufgerufen werden
	if ((art==startOhneL)||(art==startMitL)){
		if (status > unbenutzt){
			Debug(1,"Linienplan.start: wurde ein zweites Mal aufgerufen (oder stop vor start erhalten)");
			throw "doppelstart";
		}
		// Nun wollen wir was tun und kuendigen es an
		status = gestartet;
		// Spezielle start Parameter sichern
		quellezielmatrix_lp = quellezielmatrix;
	}
	// Mit der Rueckkopplung darf erst angefangen werden, wenn wir uns im Status "fertiggestartet" befinden
	if ((art==rueckOhneL)||(art==rueckMitL)){
	        if (status != fertiggestartet) {
	                Debug(1,"Linienplan.rueckkoppeln: Kann nicht ausgefuehrt werden, da wir uns im falschem Status befinden");
	                return;
	        }
	        // Nun wollen wir was tun und kuendigen es an
       		status = rueckkopplung;
	}

	// Die Eingabeparameter muessen gerettet werden. Die schreiben wir in den Netzplan
	netzplan->setzenMaxLinienlaenge(maxLinienlaenge);
	netzplan->setzenMaxLinienanzahl(maxAnzahlvonLinien);
	netzplan->setzenGesamtlinienLaenge(gesamtLinienlaenge);

	// Aufbereitungsphase wird nur beim ersten Start benoetigt
	if ((art==startOhneL)||(art==startMitL)){
		netzplan->holenFortschritt()->setzenNaechstenSchritt(1);
		netzplan->holenFortschritt()->meldenLaufzeitAusgabe("LP: Aufbereitungsphase wird gestartet");
	
		// Jetzt wird es ernst. Zuerst muessen die Daten aufbereitet werden.
		aufbereitungsphase = new CAufbereitungsphase(netzplan, wegenetzgraph, quellezielmatrix);
		aufbereitungsphase->starten();
		if (netzplan->holenStop()){
			status=stop;
			Debug(1, "Linienplan.start.1: wurde gestoppt");
			throw "gestoppt";
		}
		netzplan->holenFortschritt()->setzenNaechstenSchritt(2);
		aufbereitungsphase->umlegen();
		if (netzplan->holenStop()){
			status=stop;
			Debug(1,"Linienplan.start.2: wurde gestoppt");
			throw "gestoppt";
		}
		delete aufbereitungsphase;
		aufbereitungsphase = 0;
		// Aufbereitung abgeschlossen

		netzplan->holenFortschritt()->meldenLaufzeitAusgabe("LP: Aufbereitungsphase beendet");
	}

	if (anzeigen)
		winNetzplangraph = zeigenNetzgraph();

	netzplan->holenFortschritt()->meldenLaufzeitAusgabe("LP: Verknuepfungsphase wird gestartet");

	// Jetzt wird mit der Verknuepfungsphase begonnen
	verknuepfungsphase = new CVerknuepfungsphase(netzplan, quellezielmatrix, lPSchnittstelle);
	verknuepfungsphase->berechnenVerknuepfung();
	if (netzplan->holenStop()){
		status=stop;
		Debug(1,"Linienplan.start: wurde gestoppt");
		return;
	}
	delete verknuepfungsphase;
	verknuepfungsphase = 0;
	// Verknuepfungsphase abgeschlossen

	if (netzplan->testeLinienListe()==false) {
		Debug(1,"Linienplan nach Verknuepfungsphase: LinienListe enthaelt Fehler!");
	}

	netzplan->holenFortschritt()->meldenLaufzeitAusgabe("LP: Verknuepfungsphase beendet");
	netzplan->holenFortschritt()->meldenLaufzeitAusgabe("LP: Bewertungsphase wird gestartet");

	// Linien werden neu nummeriert
	linienliste = netzplan->holenLinienliste();
	if (linienliste!=0) {
		int linienummernzaehler=1;
		list_item itemLinie;
		Debug(9, "Linien werden neu nummeriert");
		forall_items(itemLinie, *linienliste) {
			linienliste->contents(itemLinie)->setzenID(linienummernzaehler++);
		}
	}

	// Zum Schluss noch die Bewertungsphase
	netzplan->holenFortschritt()->setzenNaechstenSchritt(8);
	bewertungsphase = new CBewertungsphase(netzplan, quellezielmatrix);
	CGuetemasse* guetemass;
	if (lPSchnittstelle!=0){
                guetemass = lPSchnittstelle->holenGuetemasse();
	}
	fertigerLinienplanGraph = bewertungsphase->umlegenVerkehrsbedarfAufLinienplan(guetemass);
	
	delete bewertungsphase;
	bewertungsphase = 0;
	// Bewertungphase abgeschlossen

	// Teste, ob der Fahrplangraph dem uebergeben bekommenem Wegenetzgraphen "gleich" ist
	netzplan->pruefenFahrplangraph(wegenetzgraph, fertigerLinienplanGraph);

	if (anzeigen && (fertigerLinienplanGraph != 0))
		winFahrplangraph = zeigenLinienplanGraph(fertigerLinienplanGraph);

	Debug(9, "Linienplan ende");
	netzplan->holenFortschritt()->meldenLaufzeitAusgabe("LP: Ergebnisse speichern");
	// Der fertige Linienplangraph wird dem Programmpaket uebergeben:
	if (lPSchnittstelle!=0){
		netzplan->holenFortschritt()->setzenNaechstenSchritt(9);
		lPSchnittstelle->linienplanungErgebnisrueckgabe(fertigerLinienplanGraph, netzplan->holenLinienliste());
		lPSchnittstelle->speichernGuetemasse(guetemass);
	}
	netzplan->holenFortschritt()->meldenLaufzeitAusgabe("LP: Linienplan fertiggestellt");

	if (lPSchnittstelleTest!=0) lPSchnittstelleTest->linienplanungErgebnisrueckgabe(fertigerLinienplanGraph);

	// Der Status muss noch angepasst werden.
	status = fertiggestartet;

	if (winWegenetzgraph != 0){
	  winWegenetzgraph->close();
	  delete winWegenetzgraph;
	}
	if (winNetzplangraph != 0){
	  winNetzplangraph->close();
	  delete winNetzplangraph;
	}
	if (winFahrplangraph != 0){
	  winFahrplangraph->close();
	  delete winFahrplangraph;
	}

	float vergangenezeit = used_time(zeit);
	char text[30];
	sprintf(text,"Linienplan abgeschlossen. Gebrauchte CPU-Zeit: %.2f",vergangenezeit);
	netzplan->holenFortschritt()->meldenLaufzeitAusgabe(text);

}

void CLinienplan::stoppen(){
        Debug(2, "CLinienplan::stoppen");
	// Allen Threads mitteilen, dass wir gestoppt wurden.
	if (netzplan!=0) {
		netzplan->setzenStop(true);
		// Erstmal muessen wir schauen, ob noch ein Thread bei uns laeuft:
		while ((status==gestartet) || (status==rueckkopplung)) {
			// wenn ja, warten wir ne Sekunde und fragen nochmal nach...
			leda_wait(1.0);
		}
		// Und jetzt wollen wir auch nicht mehr gestoert werden.
	}
	status = stop;
        Debug(2, "CLinienplan::stoppen fertig");
}
#endif
