/* Generated by Together */

#include "CNetzplan.h"

CNetzplan::CNetzplan(bool batchmodus){
Debug(2, "[CNetzplan:Konstruktor] alle Variablen auf 0 bzw. false, new linienListe, new netzplan");
  stop = false;
  gesamtlinienLaenge = 0;
  maxLinienanzahl = 0;
  maxLinienlaenge = 0;
  linienListe = new list<CLinie*>;
  netzplan = new UGRAPH<CNetzplanKnoten*, CNetzplanKante*>;
  gesamteStreckenkilometer = 0;
  mittlereMindestreisezeit = 0;  
  entfernungsteiler = 250; 
  vergleichnummer = 0;
  fortschritt = new CFortschritt("Modul Linienplan", batchmodus);
  fortschritt->meldenLaufzeitAusgabe("Warte auf Daten");
}

CNetzplan::~CNetzplan(){
Debug(2, "[CNetzplan:Destruktor] netzplan loeschen");
  if (netzplan!=0){
    netzplan->clear(); /* noetig? */
    delete netzplan;
    delete fortschritt;
  }
}

bool CNetzplan::holenStop(){
  //Debug(5, "[CNetzplan:holenStop] "<<stop);
	return stop;
}

void CNetzplan::setzenStop(bool einstop){
  stop = einstop;
  //Debug(5, "[CNetzplan:setzenStop] "<<stop);
}

list<CLinie*>* CNetzplan::holenLinienliste(){
  //Debug(5, "[CNetzplan:holenLinienliste] guess...");
	return linienListe;
}
void CNetzplan::setzenLinienliste(list<CLinie*>* eineLinienliste){
  linienListe = eineLinienliste;
  //Debug(5, "[CNetzplan:setzenLinienliste] gesetzt");
}

UGRAPH<CNetzplanKnoten*, CNetzplanKante*>* CNetzplan::holenNetzplan(){
  //Debug(5, "[CNetzplan:holenNetzplan] guess...");
	return netzplan;
}

void CNetzplan::setzenNetzplan(UGRAPH<CNetzplanKnoten*, CNetzplanKante*>* netzgraph){
  /* nicht noetig bis jetzt daher leer */
//Debug(5, "[CNetzplan:setzenNetzplan] Wie kommst Du hierher??? Wird doch gar nicht benoetigt!");
     netzplan = netzgraph;
}

int CNetzplan::holenGesamtlinienLaenge(){
  //Debug(5, "[CNetzplan:holenGesamtlinienLaenge] "<<gesamtlinienLaenge);
	return gesamtlinienLaenge;
}

void CNetzplan::setzenGesamtlinienLaenge(int gesLaenge){
  gesamtlinienLaenge = gesLaenge;
  //Debug(5, "[CNetzplan:setzenGesamtlinienLaenge] "<<gesamtlinienLaenge);
}

int CNetzplan::holenMaxLinienanzahl(){
  //Debug(5, "[CNetzplan:holenMaxLinienanzahl] "<<maxLinienanzahl);
	return maxLinienanzahl;
}

void CNetzplan::setzenMaxLinienanzahl(int maxLinien){
  maxLinienanzahl = maxLinien;
  //Debug(5, "[CNetzplan:setzenMaxLinienanzahl] "<<maxLinienanzahl);
}

int CNetzplan::holenMaxLinienlaenge(){
  //Debug(5, "[CNetzplan:holenMaxLinienlaenge] "<<maxLinienlaenge);
	return maxLinienlaenge;
}

void CNetzplan::setzenMaxLinienlaenge(int maxlaenge){
  maxLinienlaenge = maxlaenge;
  //Debug(5, "[CNetzplan:setzenMaxLinienlaenge] "<<maxLinienlaenge);
}

bool CNetzplan::pruefenZusammenhang(node startknoten){
//        Debug(2, "CNetzplan::pruefenZusammenhang");
  node_array<bool> pruefarray(*netzplan);
  list<node> pruefliste;
  bool rueckgabe;

  /**
   * 
   * Test, ob ein uebergebener Graph Zusammenhaengend ist
   * 
   * Gibt TRUE zurueck, wenn zusammenhaengend
   *
   */

  pruefliste = DFS(*netzplan,startknoten,pruefarray);
  if (pruefliste.length() == netzplan->number_of_nodes()){
    rueckgabe = true;
  }else{
    rueckgabe = false;
  }

  //Debug(9,"[CNetzplan:pruefenZusammenhang] Laenge der Liste : " << pruefliste.length());
  //Debug(9,"[CNetzplan:pruefenZusammenhang] Anzahl der Knoten: " << netzplan->number_of_nodes());

  return rueckgabe;
}


node_array<edge> CNetzplan::machenDijkstra(node Start){
//        Debug(2, "CNetzplan::machenDijkstra");

  node_array<edge> dijkstraErgebnis(*netzplan);
  node_array<int> dijkstraEntf(*netzplan,0);

  SHORTEST_PATH_T(*netzplan,Start,dijkstraKosten,dijkstraEntf,dijkstraErgebnis);
  
  return dijkstraErgebnis;
}

void CNetzplan::vorbereitenDijkstra(){
  dijkstraKosten.init(*netzplan,0);
  edge netzplanhilfskante;
  forall_edges(netzplanhilfskante,*netzplan){
    int &arrayInhalt = dijkstraKosten[netzplanhilfskante];
    CNetzplanKante* netzplanKante = netzplan->inf(netzplanhilfskante);
    arrayInhalt = netzplanKante->holenEntfernung();
    //Debug(9,"Entfernung: " << netzplanKante->holenEntfernung());
    //Debug(9,"Kantenwert: " << dijkstraKosten[netzplanhilfskante]);
  } //Ende forall_edges

}

node* CNetzplan::umwandelnHaltestelleZuKnoten(UGRAPH<CNetzplanKnoten*,CNetzplanKante*>* wegenetzgraph, int haltestelle){
//        Debug(2, "CNetzplan::umwandelnHaltestelleZuKnoten");
        node* knoten=0;
        node aktKnoten;

        forall_nodes(aktKnoten, *wegenetzgraph){
                if ((wegenetzgraph->inf(aktKnoten))->holenID() == haltestelle){
                        knoten = new node(aktKnoten);
                        return knoten;
                }
        }
        // Nichts gefunden
        return 0;
} 

edge * CNetzplan::suchenKanteZwischenKnoten(UGRAPH<CNetzplanKnoten*,CNetzplanKante*>* wegenetzgraph, node* startKnoten, node* endKnoten){
//        Debug(2, "CNetzplan::suchenKanteZwischenKnoten");
        edge* kante=0;
        edge startKante;
        edge endKante;

        forall_adj_edges(startKante, *startKnoten){
                forall_adj_edges(endKante, *endKnoten){
                        if (((wegenetzgraph->inf(startKante))->holenID())==((wegenetzgraph->inf(endKante))->holenID())
){
                                kante = new edge(startKante);
                                return kante;
                        }
                }
        }
        // Nichts gefunden
        return 0;
}

void CNetzplan::hinzufuegenLinie(CLinie* linie){
        Debug(2, "CNetzplan:hinzufuegenLinie:");
        list<CLinie*>* linienListe;

        linienListe = holenLinienliste();
        linienListe->append(linie);
}

bool CNetzplan::testeLinienListe(){
        Debug(2, "CNetzplan::testeLinienListe()");

	if (linienListe!=0) {
		list_item itemLinie;
		// Es sollen alle getestet werden
		forall_items(itemLinie, *linienListe) {
			list<int>* hListe;
			hListe = linienListe->inf(itemLinie)->holenhListe();
			// Enthaelt die Linienliste ueberhaupt eine Linie?
			if (hListe->length()>1) {
				node *startKnoten, *endKnoten;

				// Schon mal ersten Haltestellenknoten besorgen
				endKnoten = umwandelnHaltestelleZuKnoten(netzplan, hListe->inf(hListe->get_item(0)));
				// Ueber alle Haltestellen iterieren. Wobei i-1 Durchlaeufe gemacht werden, da nur so viele
				// Kanten existieren und der erste Knoten schon eingelesen wurde.
				for(int i=1; i<hListe->length(); i++){
					edge* kante=0;

                			startKnoten = endKnoten;
                			endKnoten = umwandelnHaltestelleZuKnoten(netzplan, hListe->inf(hListe->get_item(i)));
                			kante = suchenKanteZwischenKnoten(netzplan, startKnoten, endKnoten);
					delete startKnoten;
					// Wenn dort keine Kante existiert, Fehlermeldung ausgeben und abbrechen. Duerfte Nie vorkommen!
					if (kante==0) {
						Debug(9, "Linienplan.CNetzplan::testeLinienListe(): Fehler in Linie: " <<
							 *linienListe->contents(itemLinie) << "zwischen Haltestelle (von 1 gezaehlt): " <<
							 i << " und " << i+1); 
						return false;
					}
				}
				delete endKnoten;
			}
		}

	}
	return true;
}

void CNetzplan::pruefenFahrplangraph(UGRAPH<CWegenetzKnoten*,CWegenetzKante*> * wegenetzgraph, GRAPH<CFPlanGraphKnoten*,CFPlanGraphKante*>* fahrplangraph){

  Debug(5,"[pruefenFahrplangraph] Start der Methode");

  /**
   * Knoten pruefen
   */
  int groesse = 0; //Fuer die Groesse des Arrays unten

  //groesste ID rauskriegen und groesse zuweisen
  node wgraphknoten2;
  forall_nodes(wgraphknoten2,*wegenetzgraph){
    int wgraphid = (wegenetzgraph->inf(wgraphknoten2))->holenKnotenId();
    if (groesse < wgraphid) groesse = wgraphid;
  }
  groesse++; //da das array von 0 bis n-1 geht

  array<int> pruefarray(groesse);
  /* Zweck des Arrays: schneller testen, ob Knoten existieren
   * Konvention der Zellen (jede Zelle ist eine ID im Graphen):
   * - 0 : ID existiert in keiner der Graphen
   * - 1 : ID existiert im Wegenetzgraph
   * - 2 : ID existiert im Fahrplangraph
   */

  // Initialsierung des arrays mit nullen
  for (int i=0; i<groesse; i++) pruefarray.set(i,0);

  // Wegenetzgraph durchlaufen
  node wgraphknoten;
  forall_nodes(wgraphknoten,*wegenetzgraph){
    int wgraphid = (wegenetzgraph->inf(wgraphknoten))->holenKnotenId();
    pruefarray.set(wgraphid,1);
  }//Ende forall_nodes(wgraphknoten,wegenetzgraph)

  // Fahrplangraph durchlaufen
  node fgraphknoten;
  forall_nodes(fgraphknoten,*fahrplangraph){
    int fgraphid = (fahrplangraph->inf(fgraphknoten))->holenID();
    if (fgraphid >= groesse){
      // Fall: zu grosse ID, die es gar nicth geben darf
      fortschritt->meldenLaufzeitAusgabe("[pruefenFahrplangraph] FEHLER!!! Zu grosse ID im Fahrplangraph");
      setzenStop(true);
      return;
    }else{
      //Fall: ID ist kleiner als die anzahl der Knoten, also alles in Ordnung
      int arrayinhalt = pruefarray.get(fgraphid);
      switch (arrayinhalt){
      case 0 : fortschritt->meldenLaufzeitAusgabe("[prufenFahrplangraph] FEHLER!!! ID im Fahrplangraph, die nicht im Wegenetz existiert");
	setzenStop(true);
	return;
	break;
      case 1 : pruefarray.set(fgraphid,2); break;
      default: Debug(9,"[pruefenFahrplangraph] Hmm... hier darfst Du gar nicht sein!"); break;
      }//Ende switch
    }//Ende Else
  }//Ende forall_nodes(fgraphknoten,fahrplangraph)

  for (int i=0; i<groesse; i++){
    int arrayinhalt = pruefarray.get(i);
    if (arrayinhalt == 1){
      fortschritt->meldenLaufzeitAusgabe("[pruefenFahrplangraph] FEHLER!!! Knoten aus dem Wegenetz existiert nicht im Fahrplangraph");
      setzenStop(true);
      return;
    }//Ende if
  }//Ende for
   
  /**
   * Kanten pruefen
   */
  edge fgraphit;
  forall_edges(fgraphit,*fahrplangraph){
      int fpAnfang = (fahrplangraph->inf(fahrplangraph->source(fgraphit)))->holenID();
      int fpEnde = (fahrplangraph->inf(fahrplangraph->target(fgraphit)))->holenID();
      bool gefunden = false;
      // AnfangsKnoten im Wegenetzgraph finden
      node wgraphknoten3;
      forall_nodes(wgraphknoten3,*wegenetzgraph){
	int wgraphAnfang = (wegenetzgraph->inf(wgraphknoten3))->holenKnotenId();
	if (fpAnfang == wgraphAnfang){
	  // Jetzt Kante suchen mit ID von fpEnde als Ziel
	  edge wgraphit;
	  forall_inout_edges(wgraphit,wgraphknoten3){
	    int wgraphEnde = (wegenetzgraph->inf(wegenetzgraph->opposite(wgraphknoten3,wgraphit)))->holenKnotenId();
	    if (fpEnde == wgraphEnde){
	      gefunden = true;
	    }//Ende if (fpEnde == wgraphEnde)
	  }//Ende forall_inout_edges
	}//Ende if (fpAnfang == wgraphAnfang)
      }//Ende forall_nodes(wegenetzgraph)
      if (gefunden == false){
	fortschritt->meldenLaufzeitAusgabe("[pruefenFahrplangraph] FEHLER!!! Eine Kante des Fahrplangraphen existiert nicht im Wegenetzgraphen");
	setzenStop(true);
	return;
      }
  }// Ende forall_edges(fahrplangraph)
  Debug(9,"[pruefenFahrplangraph] Scheint alles in Ordnung zu sein...");
}


int CNetzplan::testenAufZyklusfreiheit(list<int> *linkeHListe,list<int> *rechteHListe){
//	Debug(8, "CAbschlussverknuepfung::zyklusfrei()");

	// statischer Zaehler, der auch nach dem Verlassen der Methode erhalten
	// bleibt
	list_item lItem;
	int doppelt=0;

	// Wenn wir das erste Mal aufgerufen werden, erzeugen wir das Array mit der richtigen
	// Groesse und setzen alle Eintraege auf 0
	if (vergleichnummer == 0){
		vergleichsFeld.resize(netzplan->number_of_nodes());
		vergleichsFeld.init (0);
	}

	// Den statischen Zaehler muessen wir noch erhoehen
	vergleichnummer++;

	// Die Haltestellen der ersten Linie tragen wir in das Array ein
	lItem = linkeHListe->first();
	while (lItem != NULL) {
		vergleichsFeld[linkeHListe->contents(lItem)] = vergleichnummer;
		lItem = linkeHListe->succ(lItem);
	}

	// und testen dann, ob die Haltestellen der zweiten Linie im Array eingetrgen sind
	lItem = rechteHListe->first();
	while (lItem != NULL) {
		if (vergleichsFeld[rechteHListe->contents(lItem)] == vergleichnummer)
			doppelt++;
		lItem = rechteHListe->succ(lItem);
	}

	// und die Anzahl der doppelten Haltestellen zurueckliefern
	return doppelt;
}

void CNetzplan::setzenGesamteStreckenkilometer(int gesamteStreckenkm)
{
        gesamteStreckenkilometer=gesamteStreckenkm;
}
int CNetzplan::holenGesamteStreckenkilometer()
{
	return gesamteStreckenkilometer;
}

void CNetzplan::setzenMittlereMindestreisezeit(int mittleremindestreisezt)
{
        mittlereMindestreisezeit=mittleremindestreisezt;
}
int CNetzplan::holenMittlereMindestreisezeit()
{
	return mittlereMindestreisezeit;
}

int CNetzplan::holenEntfernungsteiler()
{
  return entfernungsteiler;
}

void CNetzplan::setzenGeschwindigkeit(int geschwindigkeit){
  entfernungsteiler = (geschwindigkeit*1000)/60;
  Debug(9,"[setzenGeschwindigkeit] Aus " << geschwindigkeit << " km/h werden " << entfernungsteiler << " m/sec");
}

CFortschritt* CNetzplan::holenFortschritt(){
  return fortschritt;
}
