/* Generated by Together */

#ifndef NETZPLAN_H
#define NETZPLAN_H

class CNetzplan;

#include "CNetzplanKnoten.h"
#include "CNetzplanKante.h"
#include "../Datenstruktur/CLinie.h"
#include <LEDA/ugraph.h>
#include <LEDA/list.h>
#include <LEDA/graph_alg.h>
#include "Debug.h"
#include "../Datenstruktur/CWegenetzKnoten.h"
#include "../Datenstruktur/CWegenetzKante.h"
#include "../Datenstruktur/CFPlanGraphKnoten.h"
#include "../Datenstruktur/CFPlanGraphKante.h"
#include "../Datenstruktur/CFortschritt.h"

/**
 * Modulglobale Datenstruktur
 * Enthaelt Netzplan (LEDA::UGRAPH) und Linienliste (LEDA::list)
 * Enthaelt die begrenzenden Parameter max. Linienlaenge, max Linienanz.
 *    und ges. Linienlaenge (uebergeben von CLinienplan)
 * 
 * Aussehen des Netzplans:
 *    - Knoten: ID, Prioritaet
 *    - Kanten: Fahrzeit, Verkehrsstrom, Anzahl Basislinien
 * 
 * Aussehen der Linienliste:
 *    Liste von Clinie(n) 
 */
class CNetzplan {
public:

    CNetzplan(bool batchmodus);

    ~CNetzplan();

    void setzenMaxLinienlaenge(int maxLaenge);

    int holenMaxLinienlaenge();

    void setzenMaxLinienanzahl(int maxLinien);

    int holenMaxLinienanzahl();

    void setzenGesamtlinienLaenge(int gesLaenge);

    int holenGesamtlinienLaenge();

    void setzenNetzplan(UGRAPH<CNetzplanKnoten*, CNetzplanKante*>* netzgraph);

    UGRAPH<CNetzplanKnoten*, CNetzplanKante*>* holenNetzplan();

    void setzenLinienliste(list<CLinie*>* eineLinienliste);

    list<CLinie*>* holenLinienliste();

    void setzenStop(bool einstop);

    bool holenStop();

    /**
     * FIXME: Kommentar fehlt
     */
    bool pruefenZusammenhang(node Startknoten);

    /**
     * FIXME: Kommentar fehlt
     */
    node_array<edge> machenDijkstra(node Start);

    void vorbereitenDijkstra();

    /**
     * FIXME: Kommentar fehlt
     */
    node* umwandelnHaltestelleZuKnoten(UGRAPH<CNetzplanKnoten*,CNetzplanKante*>* wegenetzgraph, int haltestelle);        

    /**
     * FIXME: Kommentar fehlt
     */
    edge * suchenKanteZwischenKnoten(UGRAPH<CNetzplanKnoten*,CNetzplanKante*>* wegenetzgraph, node* startKnoten, node* endKnoten);

    /**
     * FIXME: Kommentar fehlt
     */
    void hinzufuegenLinie(CLinie* linie);

    /**
     * FIXME: Kommentar fehlt
     */
    bool testeLinienListe();

    /**
     * FIXME: Kommentar fehlt
     */
    void pruefenFahrplangraph(UGRAPH<CWegenetzKnoten*,CWegenetzKante*> * wegenetzgraph, GRAPH<CFPlanGraphKnoten*,CFPlanGraphKante*>* fahrplangraph);

    /**
     * FIXME: Kommentar fehlt
     * 
     * Rueckgabe: Anzahl der gleichen Haltestellen
     */
    int testenAufZyklusfreiheit(list<int> *linkeHListe,list<int> *rechteHListe);

    
    void setzenGesamteStreckenkilometer(int gesamteStreckenkm);
    int holenGesamteStreckenkilometer();
    
    void setzenMittlereMindestreisezeit(int mittleremindestreisezt);
    int holenMittlereMindestreisezeit();

    int holenEntfernungsteiler();
    void setzenGeschwindigkeit(int geschwindigkeit);

    CFortschritt* holenFortschritt();


private:    

    int gesamteStreckenkilometer;
    int mittlereMindestreisezeit;
     
    int entfernungsteiler;
    int maxLinienlaenge;
    int maxLinienanzahl;
    int gesamtlinienLaenge;
    list<CLinie*>* linienListe;
    UGRAPH<CNetzplanKnoten*, CNetzplanKante*>* netzplan;
    bool stop;
    CFortschritt* fortschritt;
    edge_array<int> dijkstraKosten;

    /**
     * benoetigt zyklusfrei
     */
    array<int> vergleichsFeld;
    int vergleichnummer;
};
#endif //NETZPLAN_H


