/* Generated by Together */

#include "CVerknuepfungsphase.h"

CVerknuepfungsphase::CVerknuepfungsphase(CNetzplan* meinNetzplan, matrix* bedarf, CLPSchnittstelle* progSchnittstelle){
        Debug(1, "[CLASS::] CVerknuepfungsphase()");
	// Netzplan wird spaeter gebraucht und deshalb gesichert.
	netzplan = meinNetzplan;
	bedarfsmatrix = bedarf;
	lPSchnittstelle = progSchnittstelle;
	// Die restlichen Attribute werde auf 0 gesetzt
	startverknuepfung = 0;
	abschlussverknuepfung = 0;
	// Und jetzt kann es los gehen
}

CVerknuepfungsphase::~CVerknuepfungsphase(){
        Debug(1, "[CLASS::~] CVerknuepfungsphase()");
	// Hier gibt es nichts zu tun
}

void CVerknuepfungsphase::berechnenVerknuepfung(){
        Debug(2, "CVerknuepfungsphase::berechnenVerknuepfung()");
	// Als erstes machen wir die Startverknuepfung
	Debug(9, "Erstelle Startverknuepfung\n");
	startverknuepfung = new CStartverknuepfung(netzplan);

	// Es muessen die die Linen eingefuegt werden (wenn es Pflichtlinien gibt)
	if (netzplan->holenLinienliste()->length()){
		startverknuepfung->erstellenLinien();
	}
	// Die Basislinien werden erzeugt
	if (lPSchnittstelle->holenBasislinienwahl()){
		netzplan->holenFortschritt()->setzenNaechstenSchritt(3);
		startverknuepfung->waehlenBasislinie(lPSchnittstelle->holenAlgorithmus());
	}
	// Wurden wir in der Zwischenzeit vom Programm zum Stoppen aufgefordert?
	if (netzplan->holenStop()){
		Debug(1,"Startverknuepfung.berechnenVerknuepfung: wurde gestoppt");
		return;
	}
	// Eindeutige Linienverknuepfungen werden erstellt
	if (lPSchnittstelle->holenEindeutigeLinienverknuepfung()){
		netzplan->holenFortschritt()->setzenNaechstenSchritt(4);
		startverknuepfung->bildenEindeutigeLinienverknuepfung();
	}
	// Wurden wir in der Zwischenzeit vom Programm zum Stoppen aufgefordert?
	if (netzplan->holenStop()){
		Debug(1,"Startverknuepfung.berechnenVerknuepfung: wurde gestoppt");
		return;
	}
	// Startverknuepfung wird nicht mehr gebraucht
	delete startverknuepfung;
	startverknuepfung = 0;

	Debug(9, "Erstelle Abschlussverknuepfung\n");
	// Jetzt kommt die Abschlussverknuepfung
	abschlussverknuepfung = new CAbschlussverknuepfung(netzplan, bedarfsmatrix);
	// Mehrdeutige Linien werden verknuepft
	if (lPSchnittstelle->holenMehrdeutigeLinienverknuepfung()){
		netzplan->holenFortschritt()->setzenNaechstenSchritt(5);
		abschlussverknuepfung->bildenMehrdeutigeLinienverknuepfung();
	}
	// Wurden wir in der Zwischenzeit vom Programm zum Stoppen aufgefordert?
	if (netzplan->holenStop()){
		Debug(1,"Startverknuepfung.berechnenVerknuepfung: wurde gestoppt");
		return;
	}
	// Zum Schluss noch die Aufbruchsverknuepfung nach Sonntag
	if (lPSchnittstelle->holenAufbruchsverknuepfung()){
		netzplan->holenFortschritt()->setzenNaechstenSchritt(6);
	//			abschlussverknuepfung->durchfuehrenAufbruchsverknuepfung();
		abschlussverknuepfung->loeschedoppelteBasislinien();
	}

	if (lPSchnittstelle->holenLinienendverknuepfung()){
		netzplan->holenFortschritt()->setzenNaechstenSchritt(7);
		abschlussverknuepfung->bildenLinienendverknuepfung();
	}

	// Abschlussverknuepfung wird nicht mehr gebraucht
	delete abschlussverknuepfung;
	abschlussverknuepfung = 0;
	// Jetzt sind wir fertig
}

