/* Generated by Together */

#ifndef VERKNUEPFUNGSPHASE_H
#define VERKNUEPFUNGSPHASE_H

#include "CAbschlussverknuepfung.h"
#include "CStartverknuepfung.h"
#include "CBasislinie.h"
#include "CNetzplan.h"
#include "Debug.h"
#include "LEDA/list.h"
#include "../Programm/CLPSchnittstelle.h"

/**
 * Die Verknuepfung zu einem Linienplan entwickelt sich in mehreren Stufen. 
 * In jeder Stufe wird solange die jeweils beste Verknuepfung im aktualisieretem
 * CNetzplan bestimmt und realisiert, bis keine weitere Verknuepfung in der Stufe
 * mehr moeglich ist.
 * 
 * Realisiert nach Sonntag Seite 97
 *
 * Weitere Verfahren koennen hier Problemlos integriert werden.
 */
class CVerknuepfungsphase {


public:

    /**
     * Der Konstruktor der Klasse. Er wird beim generieren der Klasse
     * aufgerufen und sorgt fuer die Initialisierung der Klasse.
     * 
     * Eingabe:
     * - Ein Zeiger auf ein Objekt der Klasse CNetzplan.
     *   Dieses Objekt enthaelt die fuer die Linienplanung noetigen
     *   Daten bereit.
     * - Eine Zeiger auf die Bedarfsmatrix, die die CAbschlussverknuepfung
     *   benoetigt.
     *
     * Rueckgabe:
     * - nichts
     */
    CVerknuepfungsphase(CNetzplan* meinNetzplan, matrix* bedarf, CLPSchnittstelle* progSchnittstelle);

    /**
     * Der Destruktor wird aufgerufen, wenn die Klasse geloescht werden soll. In
     * CVerkuepfungsphase fuehrt sie momentan noch nichts aus. 
     */
    ~CVerknuepfungsphase();

    /**
     * Es wird die Verknuepfungsphase wie sie von Sonntag ab Seite 97 beschrieben wird
     * komplett abgearbeitet. Dazu werden die Methoden in den Klassen CStartverknuepfung
     * und CAnschlusverknuepfung aufgerufen.
     * Nach der Abarbeitung befindet sich eine Liste mit Linien im CNetzplan. 
     */
    void berechnenVerknuepfung();

private:    

    /**
     * @supplierCardinality 1 
     */
    CNetzplan * netzplan;

    matrix* bedarfsmatrix;

    /**
     * @supplierCardinality 1 
     */
    CStartverknuepfung * startverknuepfung;

    CLPSchnittstelle* lPSchnittstelle;
    /**
     * @supplierCardinality 1 
     */
    CAbschlussverknuepfung * abschlussverknuepfung;
};
#endif //VERKNUEPFUNGSPHASE_H
