/*
 * Hier werden die Dummydaten erzeugt, die an das Programm zurueckgegeben werden, um zu testen, ob
 * Programm und Fahrplan mit diesen Daten arbeiten koennen. Ausserdem koennen diese Module sich
 * testen ohne sie durch Fehler aus der Linienplangruppe unterbrochen werden.
 *
 * Erstellt von Michael Schlueter (13. und 14. Februar 2001)
 * Aenderungen:
 *		23.02.2001: Michael Schlueter
			    - Die Rueckfahrt einer Linie wird durch eine negative ID gekennzeichnet.
 *              20.02.2001: Michael Schlueter
 *                          - Knotenarray wird jetzt von 0 an benutzt (macht es aber nicht
 *                            uebersichtlicher, aber Fahrplan wollte es so...).
 *                          - Fahrzeit ist jetzt in Minuten und nicht mehr in Sekunden
 */

#include "linienplandummydaten.h"

// Hier werden Dummydaten erzeugt
void linienplandummydaten(CLPSchnittstelle* programmSchnittstelle, CLPSchnittstelleTest* programmSchnittstelleTest){
        Debug(2, "CLinienplan::linienplandummydaten gestartet");
	node knotenArray[9];
	GRAPH<CFPlanGraphKnoten*,CFPlanGraphKante*>* linienplan = new GRAPH<CFPlanGraphKnoten*,CFPlanGraphKante*>();
	list <CLinie*>* linienListe = new list<CLinie*>;
	
	CFPlanGraphKante* neKante;
        Debug(2, "CLinienplan::linienplandummydaten Variablen fertig");

	// Erzeuge die Knoten und beschrifte sie
	for(int i=0; i<9; i++){
		CFPlanGraphKnoten* nenKnoten = new CFPlanGraphKnoten();
		nenKnoten->setzenID(i+1);
		knotenArray[i] = linienplan->new_node(nenKnoten);
	}
        Debug(2, "CLinienplan::linienplandummydaten Knoten erstellt");

	// Erzeuge die Kanten und fuelle sie mit Leben
	// Aufbau der Linienbeschreibung: (vonKnoten,zuKnoten)/Fahrgaststrom(Kantenlaenge, Kantenzeit in Sekunden)
	// Kantenzeit in Sec = Kantenlaenge/4.17 (entspricht 15Km/h)
        // Fahrzeit ist jetzt aufgerundet in Minuten 
	// Linie 1: (1,2)/305(150,35) (2,3)/301(350,84) (3,5)/468(83,20) (5,6)/359(323,77)

      CLinie* NLinie;
      list<int>* halteListe;

      NLinie = new CLinie();
      NLinie->setzenID(1);
      halteListe = NLinie->holenhListe();
      halteListe->append (0);
      halteListe->append (1);
      halteListe->append (2);
      halteListe->append (4);
      halteListe->append (5);
	linienListe->append (NLinie);

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(1);
	neKante->setzenVerkehrsstrom(305);
	neKante->setzenLinienID(1);
	linienplan->new_edge(knotenArray[0], knotenArray[1], neKante);

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(2);
	neKante->setzenVerkehrsstrom(301);
	neKante->setzenLinienID(1);
	linienplan->new_edge(knotenArray[1], knotenArray[2], neKante);

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(1);
	neKante->setzenVerkehrsstrom(468);
	neKante->setzenLinienID(1);
	linienplan->new_edge(knotenArray[2], knotenArray[4], neKante);

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(2);
	neKante->setzenVerkehrsstrom(359);
	neKante->setzenLinienID(1);
	linienplan->new_edge(knotenArray[4], knotenArray[5], neKante);

	// und wieder zurueck (ID sind dann negativ)
	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(2);
	neKante->setzenVerkehrsstrom(359);
	neKante->setzenLinienID(-1);
	linienplan->new_edge(knotenArray[5], knotenArray[4], neKante);

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(1);
	neKante->setzenVerkehrsstrom(468);
	neKante->setzenLinienID(-1);
	linienplan->new_edge(knotenArray[4], knotenArray[2], neKante);

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(2);
	neKante->setzenVerkehrsstrom(301);
	neKante->setzenLinienID(-1);
	linienplan->new_edge(knotenArray[2], knotenArray[1], neKante);

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(1);
	neKante->setzenVerkehrsstrom(305);
	neKante->setzenLinienID(-1);
	linienplan->new_edge(knotenArray[1], knotenArray[0], neKante);

	// Linie 2: (2,3)/179(350,84) (3,4)/328(50,12) (4,8)/311(580.139)
	NLinie = new CLinie();
      NLinie->setzenID(2);
      halteListe = NLinie->holenhListe();
      halteListe->append (1);
      halteListe->append (2);
      halteListe->append (3);
      halteListe->append (7);
	linienListe->append (NLinie);
	
	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(2);
	neKante->setzenVerkehrsstrom(179);
	neKante->setzenLinienID(2);
	linienplan->new_edge(knotenArray[1], knotenArray[2], neKante);

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(1);
	neKante->setzenVerkehrsstrom(328);
	neKante->setzenLinienID(2);
	linienplan->new_edge(knotenArray[2], knotenArray[3], neKante);

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(3);
	neKante->setzenVerkehrsstrom(311);
	neKante->setzenLinienID(2);
	linienplan->new_edge(knotenArray[3], knotenArray[7], neKante);

	// und zurueck
	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(3);
	neKante->setzenVerkehrsstrom(311);
	neKante->setzenLinienID(-2);
	linienplan->new_edge(knotenArray[7], knotenArray[3], neKante);

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(1);
	neKante->setzenVerkehrsstrom(328);
	neKante->setzenLinienID(-2);
	linienplan->new_edge(knotenArray[3], knotenArray[2], neKante);

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(2);
	neKante->setzenVerkehrsstrom(179);
	neKante->setzenLinienID(-2);
	linienplan->new_edge(knotenArray[2], knotenArray[1], neKante);

	// Linie 3: (9,4)/303(487,117) (4,5)/286(110,26) (5,7)/359(599,144)
	NLinie = new CLinie();
      NLinie->setzenID(3);
      halteListe = NLinie->holenhListe();
      halteListe->append (8);
      halteListe->append (3);
      halteListe->append (4);
      halteListe->append (6);
	linienListe->append (NLinie);

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(2);
	neKante->setzenVerkehrsstrom(303);
	neKante->setzenLinienID(3);
	linienplan->new_edge(knotenArray[8], knotenArray[3], neKante);

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(1);
	neKante->setzenVerkehrsstrom(286);
	neKante->setzenLinienID(3);
	linienplan->new_edge(knotenArray[3], knotenArray[4], neKante);

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(3);
	neKante->setzenVerkehrsstrom(359);
	neKante->setzenLinienID(3);
	linienplan->new_edge(knotenArray[4], knotenArray[6], neKante);

	// und wieder zurueck
	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(3);
	neKante->setzenVerkehrsstrom(359);
	neKante->setzenLinienID(-3);
	linienplan->new_edge(knotenArray[6], knotenArray[4], neKante);

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(1);
	neKante->setzenVerkehrsstrom(286);
	neKante->setzenLinienID(-3);
	linienplan->new_edge(knotenArray[4], knotenArray[3], neKante);

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(2);
	neKante->setzenVerkehrsstrom(303);
	neKante->setzenLinienID(-3);
	linienplan->new_edge(knotenArray[3], knotenArray[8], neKante);

	// Das war es (hoffentlich ist das alles richtig) ohne Gewaehr

	forall (NLinie, *linienListe) {
	   cout << "id von Linie " << NLinie->holenID();

	};
	
        Debug(2, "CLinienplan::linienplandummydaten Kanten erstellt");

	if (programmSchnittstelle!=0) programmSchnittstelle->linienplanungErgebnisrueckgabe(linienplan, linienListe);
	if (programmSchnittstelleTest!=0) programmSchnittstelleTest->linienplanungErgebnisrueckgabe(linienplan);
        Debug(2, "CLinienplan::linienplandummydaten beendet");
}


CLinienplan::CLinienplan(CLPSchnittstelle* programmSchnittstelle){
        Debug(1, "[CLASS::] CLinienplan()");

	// Den uebergebenen Zeiger sichern
        lPSchnittstelle = programmSchnittstelle;
        lPSchnittstelleTest = 0;
}

CLinienplan::CLinienplan(CLPSchnittstelleTest* programmSchnittstelle){
        Debug(1, "[CLASS::] CLinienplan()");

	// Den uebergebenen Zeiger sichern
        lPSchnittstelle = 0;
        lPSchnittstelleTest = programmSchnittstelle;
}

/* Der Destruktor */
CLinienplan::~CLinienplan(){
	Debug(1, "[CLASS::~] CLinienplan()");

}

void CLinienplan::starten(UGRAPH<CWegenetzKnoten*,CWegenetzKante*>* wegenetzgraph,\
                          matrix* quellezielmatrix, int maxLinienlaenge,\
                          int maxAnzahlvonLinien, int gesamtLinienlaenge){

        Debug(2, "CLinienplan::starten(ohne linienliste)");

	if (lPSchnittstelle!=0) linienplandummydaten(lPSchnittstelle,0);
	if (lPSchnittstelleTest!=0) linienplandummydaten(0,lPSchnittstelleTest);
}

void CLinienplan::starten(UGRAPH<CWegenetzKnoten*,CWegenetzKante*>* wegenetzgraph, matrix* quellezielmatrix, int maxLinienlaenge, int maxAnzahlvonLinien, int gesamtLinienlaenge, list<CLinie*> * linienplan){

        Debug(2, "CLinienplan::starten(mit Linienliste)");

	if (lPSchnittstelle!=0) linienplandummydaten(lPSchnittstelle,0);
	if (lPSchnittstelleTest!=0) linienplandummydaten(0,lPSchnittstelleTest);
}

void CLinienplan::rueckkoppeln(int maxLinienlaenge, int maxAnzahlvonLinien, int gesamtLinienlaenge){
        Debug(2, "CLinienplan::rueckkoppeln(ohne liste)");

	if (lPSchnittstelle!=0) linienplandummydaten(lPSchnittstelle,0);
	if (lPSchnittstelleTest!=0) linienplandummydaten(0,lPSchnittstelleTest);
}

void CLinienplan::rueckkoppeln(int maxLinienlaenge, int maxAnzahlvonLinien, int gesamtLinienlaenge, list<CLinie*>* linienplan){
        Debug(2, "CLinienplan::rueckkoppeln(mit liste)");

	if (lPSchnittstelle!=0) linienplandummydaten(lPSchnittstelle,0);
	if (lPSchnittstelleTest!=0) linienplandummydaten(0,lPSchnittstelleTest);
}

void CLinienplan::metastarten(Startart art, UGRAPH<CWegenetzKnoten*,CWegenetzKante*> * wegenetzgraph, 
                 matrix* quellezielmatrix, int maxLinienlaenge, int maxAnzahlvonLinien, 
                 int gesamtLinienlaenge, list<CLinie*> * linienplan){
        Debug(2, "CLinienplan::metastarten");

}

void CLinienplan::stoppen(){
        Debug(2, "CLinienplan::stoppen");
}
