/* Generated by Together */

#ifndef CDBSCHNITTSTELLE_H
#define CDBSCHNITTSTELLE_H

#include <stdio.h>
#include <iostream.h>

#include "LEDA/list.h"
#include "LEDA/matrix.h"
#include "LEDA/integer_matrix.h"
#include "LEDA/tuple.h"
#include "LEDA/array.h"
#include "LEDA/h_array.h"
#include "LEDA/ugraph.h"

#include "CPunkt.h"
#include "CBevoelkerungsdichteElement.h"
#include "CFahrplanElement.h"
#include "CQuelleZielListeElement.h"
#include "CPendlerListeElement.h"
#include "CLinie.h"
#include "CFPlanGraphKnoten.h"
#include "CFPlanGraphKante.h"
#include "CWegenetzKnoten.h"
#include "CWegenetzKante.h"
#include "CGuetemasse.h"
#include "CFortschritt.h"

#include <new>	// Exceptions von new werden hier definiert

/**
 * stellt die Schnittstelle zur Oracle-Datenbank her 
 */
class CDBSchnittstelle {
public:
  CDBSchnittstelle(char*, bool bbetrieb=false);
  ~CDBSchnittstelle();


  /* die folgenden Funktionen stellen eine entsprechenden Anfrage an
   * die Datenbank und geben die erhaltenen Werte zurueck
   */
  

  // Abfragefunktionen fuer die GUI: ------------------------------------------------------------------------
  int holenKnotenID(double, double);
  CPunkt* holenKnotenKoordinaten(int);
  list<int>* holenLinienID(int);
  list<int>* holenMoeglicheZielHaltestellen(int);
  int holenZusammenhangsKomponentenID(int,int); //Parameter: Haltestelle, Linie1, Linie2
  list<int>* holenEingehendeLinien(int); // holt alle eingehenden Linien in eine Haltestelle (als ID uebergeben)
  list<int>* holenAusgehendeLinien(int);	// hole alle ausgehenden Linien aus einer Haltestelle (als ID uebergeben)
  list<int>* holenLinienHaltestellen(int linienid); // holt alle Haltestellen, ueber die die Linie mit der linienid fuehrt



  // Versionierungsfunktionen: ------------------------------------------------------------------------------
  void setzenAktuelleProjektID(int id); // hiermit wird ein Projekt ausgewaehlt
  int holenAktuelleProjektID(); // gibt die ID des aktuellen Projektes zurueck
  void setztenPhase(int phase); // speichert den Schritt ab, indem sich der Benutzer im aktuellen Projekt gerade befindet
  int holenPhase();	// liefert den Schritt, indem sich der Benutzer gerade befindet.
  int anlegenNeuesProjekt(int id, char* beschreibung, int phase); // legt ein neues Projekt an, liefert die gespeicherte ID zurueck
  void holenProjektInformationen(int id, char*& beschreibung, int& phase); // holt die Informationen des Projektes mit der ID "id"
  list<two_tuple<int,char*>*>* holenAlleProjektInformationen(); // liefert die Informationen aller Projekte zurueck (gibt die ganze Projekttabelle aus)
  int holenAnzahlProjekte(); // gibt die Anzahl der in Oracle gespeicherten Projekte zurueck
  int holenErsteFreieProjektID(); // holt die erste Projekt-ID, die noch von keinem Projekt belegt wurde
  void loeschenProjekt(int id); // loescht das Projekt mit der ID "id"
  int kopierenProjekt(int quellid, int zielid, char* beschreibung=0); // kopiert das Projekt mit der ID "quellid" in das Projekt mit der ID "zielid", liefert die ID des Zielprojektes zuerueck
	// Datenaustausch-User Funktionen (mit ihnen koennen Daten Gruppenuebergreifend ausgetauscht werden)
  int anlegenNeuesProjektPG369(int id, char* beschreibung, int phase); // legt ein neues Projekt im Datenaustausch-Users an, liefert die gespeicherte ID zurueck
  void holenProjektInformationenPG369(int id, char*& beschreibung, int& phase); // holt die Informationen des Projektes mit der ID "id" des Datenaustausch-Users
  list<two_tuple<int,char*>*>* holenAlleProjektInformationenPG369(); // liefert die Informationen aller Projekte des Datenaustausch-Users zurueck (gibt die ganze Projekttabelle aus)
  int holenErsteFreieProjektIDPG369(); // holt die erste Projekt-ID, die noch von keinem Projekt belegt wurde im Datenaustausch-User
  void loeschenProjektPG369(int id); // loescht das Projekt mit der ID "id" im Datenaustausch-Users
  int kopierenProjektVonPG369(int quellid, int zielid, char* beschreibung=0); // kopiert das Projekt mit der ID "quellid" des Datenaustausch-Users pg369 in das Projekt mit der ID "zielid", liefert die ID des Zielprojektes zuerueck
  int kopierenProjektNachPG369(int quellid, int zielid, char* beschreibung=0); // kopiert das Projekt mit der ID "quellid" in das Projekt mit der ID "zielid" des Datenaustauschusers pg369, liefert die ID des Zielprojektes zuerueck

  void speichernPflichthaltestellen(list<CPunkt*>* pflichthaltestellen); // speichert die Koordinaten der Pflichthaltestellen in Oracle  
  list<CPunkt*>* holenPflichthaltestellen(); // holt die Pflichthaltestellen wieder aus der DB
  void speichernAusschnitt(double links, double oben, double rechts, double unten); // speichert die Abmessungen des zu beruecksichtigenden Ausschnitts
  void holenAusschnitt(double& links, double& oben, double& rechts, double& unten); // holt die Abmessungen des zu beruecksichtigendesn Ausschnitts



  // Allgemeine (von mehreren Modulen benutzt): -------------------------------------------------------------
  matrix* holenQuelleZielMatrix();
  void speichernQuelleZielMatrix(matrix*);
  matrix* holenUrsprungsQZMatrix();
  void speichernUrsprungsQZMatrix(matrix*);

  list<CQuelleZielListeElement*>* holenQuelleZielListe();
  void speichernQuelleZielListe(list<CQuelleZielListeElement*>*);
  list<CQuelleZielListeElement*>* holenUrsprungsQZListe();
  void speichernUrsprungsQZListe(list<CQuelleZielListeElement*>*);

       // Wegenetzplan der Haltestellen:
  list<CWegenetzKnoten*>* holenWegenetzKnoten();
  void speichernWegenetzKnoten(GRAPH<CWegenetzKnoten*, CWegenetzKante*>*); // Ergebnis der Haltestellen

  void holenWegenetzKanten(GRAPH<CWegenetzKnoten*, CWegenetzKante*>* wegenetzgraph=0); // gehoert zum Wegenetzgraphen des Haltestellenmoduls
  void speichernWegenetzKanten(GRAPH<CWegenetzKnoten*, CWegenetzKante*>*); // gehoert zum Wegenetzgraphen

  list<CPunkt*>* holenKantenStrasse(int kantenid); // gehoert zum Wegenetzgraphen
  void speichernKantenStrasse(list<CPunkt*>*, int); // gehoert zum Wegenetzgraphen

  	// Wegenetzplan des Linien und Fahrplans:
  list<CLinie*>* holenBusLinien(int plannummer=0); // gehoert zum Wegenetzgraphen: liefert die Knoten des Graphen, der fuer LP und FP als Input dient
  void speichernBusLinien(GRAPH<CFPlanGraphKnoten*, CFPlanGraphKante*>* fpgraph=0,list<CLinie*>* buslinien=0, int planid=0); // gehoert zum Wegenetzgraphen: speichert die Knoten des Graphen, der vom LP zurueck gegeben wird; der GRAPH wird einfach nur weitergeleitet
  GRAPH<CFPlanGraphKnoten*, CFPlanGraphKante*>* holenFahrplanGraph(int planid=0); // Dummy, wird erst fuer die Rueckkopplung gebraucht: erzeugt aus den Buslienen ein entsprechendes Busnetz

  	// Guetemasse
  void speichernGuetemasse(CGuetemasse * );
  CGuetemasse* holenGuetemasse();




  // Haltestellen: ------------------------------------------------------------------------------------------
  // Eingaben:
  void holenHaltestellenModulParameter(int aufruf, int& algorithmus, int& zufallsgeneratorInitialisierung,
							double& minRadius, double& maxRadius, double& verbindungsRadiusStadt,
							double& verbindungsRadiusLand, int& radiustyp, double& haltestellenLage,
							double& toleranzgrenze, int& bevoelkerungsRaster, double& koeffizientBevoelkerungsueberversorgung,
							double& koeffizientBevoelkerungsunterversorgung, double& koeffizientFlaechenueberversorgung,
							double& koeffizientFlaechenunterversorgung, double& koeffizientFahrtwunscheinbeziehung,
							double& koeffizientStrassenanpassung,
							int& AnzahlHaltestellen, bool& AnzStrassenkarte,
							bool& AnzBevoelkerungsversorgung, bool& AnzFlaechenversorgung, bool& Anzkomplettunterdruecken,
							int& Strategie, int& AnzahlEltern, int& AnzahlKinder, int& Generationen, 
							bool& AbbruchGueteunterschreitung, double& GrenzwGueteunterschreitung);
  void speichernHaltestellenModulParameter(int aufruf, int algorithmus, int zufallsgeneratorInitialisierung,
							double minRadius, double maxRadius, double verbindungsRadiusStadt,
							double verbindungsRadiusLand, int radiustyp, double haltestellenLage,
							double toleranzgrenze, int bevoelkerungsRaster, double koeffizientBevoelkerungsueberversorgung,
							double koeffizientBevoelkerungsunterversorgung, double koeffizientFlaechenueberversorgung,
							double koeffizientFlaechenunterversorgung, double koeffizientFahrtwunscheinbeziehung,
							double koeffizientStrassenanpassung,
							int AnzahlHaltestellen, bool AnzStrassenkarte,
							bool AnzBevoelkerungsversorgung, bool AnzFlaechenversorgung, bool Anzkomplettunterdruecken,
							int Strategie, int AnzahlEltern, int AnzahlKinder, int Generationen, 
							bool AbbruchGueteunterschreitung, double GrenzwGueteunterschreitung);

  list<CBevoelkerungsdichteElement*>* holenBevoelkerungsDichte();
  void speichernBevoelkerungsDichte(list<CBevoelkerungsdichteElement*>*);
	
  matrix* holenPendlermatrix();
  void speichernPendlermatrix(matrix*);

  list<CPendlerListeElement*>* holenPendlerliste();
  void speichernPendlerliste(list<CPendlerListeElement*>*);



  // Linienplan: --------------------------------------------------------------------------------------------
  // Eingaben:
  void holenLinienplanModulParameter(int aufruf, int& gesamtlaenge, int& maxLinienLaenge, 
							int& maxLinienAnzahl, double& linienplanID, 
							int& geschwindigkeit, int& algorithmus, int& anzeigegraphen,
							bool& EindeutigeLinienverkn, bool& MehrdeutigeLinienverkn, 
							bool& Aufbruchsverknuepfung, bool& Linienendverknuepfung,
							bool& Basislinienwahl);
  void speichernLinienplanModulParameter(int aufruf, int gesamtlaenge, int maxLinienLaenge, 
							int maxLinienAnzahl, double linienplanID,
							int geschwindigkeit=15, int algorithmus=0, int anzeigegraphen=0,
							bool EindeutigeLinienverkn=false, bool MehrdeutigeLinienverkn=false, 
							bool Aufbruchsverknuepfung=false, bool Linienendverknuepfung=false,
							bool Basislinienwahl=false);

  CLinie* holenLinienweg(int id);     // wird von holenLinienplan verwendet
  void speichernLinienweg(CLinie*); // wird von speichernLinienplan verwendet

  list<CLinie*>* holenLinienplan();
  void speichernLinienplan(list<CLinie*>*);

  list<CLinie*>* holenPflichtlinien();				// holt die Pflichtlinien aus der Datenbank
  CLinie* holenPflichtlinie(int linienid);			// holt EINE Pflichtlinie, wird von holenPflichtlinien aufgerufen
  void speichernPflichtlinien(list<CLinie*>* pflichtlinien);    // speichert die Pflichtlinien in der Datenbank
  

  

  // Fahrplan: ----------------------------------------------------------------------------------------------
  /**
   * Diese Methode holt alle Knotenwerte aus der Datenbank
   */
  h_array<int,two_tuple<int,int>* >* holenKnotenWerte(); // Fertig

  /**
   * Diese Methode speichert alle Knotenwerte in der Datenbank
   */
  void speichernKnotenWerte(h_array<int,two_tuple<int,int>* >* ); // Fertig
   
  /**
   * Diese Methode loescht die Eintraege der Tabelle KnotenWerte
   */
  void loeschenKnotenWerte(); // Fertig
     
  /**
   * Diese Methode holt alle Linienwerte aus der Datenbank
   */
  h_array<int,three_tuple<int,int,bool>* >* holenLinienwerte(); // Fertig

  /**
   * Diese Methode speichert alle Linenwerte in der Datenbank
   */
  void speichernLinienwerte(h_array<int,three_tuple<int,int,bool>* >*); // Fertig
   
  /**
   * Diese Methode loescht die Eintraege der Tabelle LinienWerte
   */
  void loeschenLinienwerte(); // Fertig
   
  /**
   * Diese Methode holt alle direkten Anschluesse aus der Datenbank
   */
  list<three_tuple<int,int,int>* >* holenAnschluss(); // Fertig

  /**
   * Diese Methode speichert alle direkten Anschluesse in der Datenbank
   */
  void speichernAnschluss(list<three_tuple<int,int,int>* >*); // Fertig

  /**
   * Diese Methode loescht die Eintraege der Tabelle Anschluss
   */
  void loeschenAnschluss(); // Fertig
   
  /**
   * Diese Methode gibt eine Liste des Fahrplans aus
   * Die Liste ist geordnet nach: HaltestellenID, LinienID, AbfahrtszeitStd, AbfahrtszeitMin
   */
  list<CFahrplanElement*>* holenFahrplanHaltestellen(); // Fertig

  /**
   * Diese Methode gibt eine Liste des Fahrplans aus
   * Die Liste ist geordnet nach: LinienID, HaltestellenID, AbfahrtszeitStd, AbfahrtszeitMin
   */
  list<CFahrplanElement*>* holenFahrplanLinien(); // Fertig

  /**
   * Diese Methode loescht den fahrplan aus der Datenbank
   */
  void loeschenFahrplan(); // Fertig

  /**
   * Diese Methode speichert den Fahrplan in der Datenbank
   */
  void speichernFahrplan(list<CFahrplanElement*>*); // Fertig
    
  /**
   * Diese Methode holt alle Zusamenhangskomponenten aus der Datenbank
   */
  array<list<three_tuple<int,int,int>* >* >* holenZusammenhangskomponenten(); // Fertig

  /**
   * Mit dieser Methode werden die Zusammenhangskomponenten in der datenbank gespeichert
   */
  void speichernZusammenhangskomponenten(array<list<three_tuple<int,int,int>* >* >*); // Fertig

  /**
   * Diese Methode loescht die Zusammenhangskomponenten
   */
  void loeschenZusammenhangskomponenten(); // Fertig

  /**
   * Diese Methode holt die Werte einer Ausgangsloesung aus der Tabelle Ausgangsloesung
   * die Werte sind LoesungsID, Wartezeitaufwand in Min, Mindestwartezeitaufwand in Min und
   * Gesamtwartezeitaufwand in Min
   */
  void holenAusgangsloesung(int,double&,double&,double&,int&); // Fertig

  /**
   * Diese Methode speichert eine Ausgangsloesung in die Tabelle Ausgangsloesung
   * die Werte sind LoesungsID, Wartezeitaufwand in Min, Mindestwartezeitaufwand in Min und
   * Gesamtwartezeitaufwand in Min
   */
  void speichernAusgangsloesung(int,double,double,double,int); // Fertig

  /**
   * Diese Methode loescht die Eintraege einer Ausgangsloesung aus der Tabelle Ausgangsloesung
   */
  void loeschenAusgangsloesung(int); // Fertig
  
  /**
   * Diese Methode holt aus der Tabelle AusgangsloesungHaltestelle die Liste
   * der Haltestellenwerte die zur uebergebenen LoesungsID gehoeren
   */
  list<three_tuple<int,int,int>* >* holenAusgangsloesungHaltestelle(int); // Fertig
  
  /**
   * Diese Methode speichert fuer eine Ausgangsloesung die Werte
   * HaltestellenID, netzbedingte Wartezeit und Wartezeitaufwand
   */
  void speichernAusgangsloesungHaltestelle(int,list<three_tuple<int,int,int>*>*); // Fertig

  /**
   * Diese Methode loescht die Eintraege einer Ausgangsloesung aus der tabelle AusgangsloesungHaltestelle
   */
  void loeschenAusgangsloesungHaltestelle(int); // Fertig
  
  /**
   * Es werden die Werte mittlere Reisezeit und Direktfahreranteil fuer einen Linienplan
   * aus der Tabelle LinienplanBewertung geholt
   */
  void holenLinienplanBewertung(int,int&,int&); // Fertig

  /**
   * Es werden die Werte Linienplan ID, mittlere Reisezeit und Direktfahreranteil
   * in der Tabelle LinienplanBewertung gespeichert
   */
  void speichernLinienplanBewertung(int,int,int); // Fertig

  /**
   * Es werden die Eintraege der Tabelle LinienplanBewertung gesloescht
   */
  void loeschenLinienplanBewertung(); // Fertig
    
  /**
   * Speichern die Mindestumsteigezeiten: Parameter bedeuten: HaltestellenID, Linienr1, Liniennr2, Mindestumsteigezeit
   */
  void speichernMindestumsteigezeit(h_array<int,list<three_tuple<int,int,int>* >*>*);
  h_array<int,list<three_tuple<int,int,int>* >*>* holenMindestumsteigezeit();

  /**
   * Speichern der Mindesthaltezeiten: Parameter bedeuten: HaltestelleID, Haltezeit (in Minuten)
   */
  void speichernMindesthaltezeiten(h_array<int,int>*);
  h_array<int,int>* holenMindesthaltezeiten();
  /** speichert die Wartezeiten in der Datenbanktabelle Ausgangsloesung
   */
  void fahrplanerstellungWartezeiten (double summeNetzbedingteWartezeiten, double wartezeitAufwand, double mindestWartezeitAufwand, double gesamtWarteaufwand);
  /** speichert die Anzahl benoetigter Fahrzeuge in der Datenbanktabelle Ausgangsloesung
   */
  void fahrplanerstellungAnzahlBenoetigterFahrzeuge (int fahrzeugAnzahl);
  /* speichert alle Parameter von der GUI
  */
  void speichernFahrplanModulParameter(int maxfahrzeuganzahl, int allgemeinertakt, int mindesthaltezeit, int mindestumsteigezeit);
  /* holt alle Parameter aus der Datenbank
  */
  void holenFahrplanModulParameter(int& maxfahrzeuganzahl, int& allgemeinertakt, int& mindesthaltezeit, int& mindestumsteigezeit);

  
private:
  /**
   * Mit dieser Methode wird eine Verbindung zur Datenbank mit der Kennung
   * prguser und dem Passwort prguser hergestellt.
   */
  void aufbauenVerbindung(char *);
  
  void anlegenUserInDatenbank(char*);

  /**
   * Mit dieser Methode wird aus der Datenbank der benoetigte Speicherstand geholt
   */
  int holenSpeicherstand(char*);

  /**
   * Mit dieser Methode wird die unter aufbauenVerbindung hergestellte Verbindung
   *wieder aufgeloest.
   */
  void beendenVerbindung();

  void ausgebenSQLFehler(char *);
 
  int speicherstand;

  bool batchbetrieb; // zeigt an, ob eine GUI ausgegeben werden soll.

  char* benutzername; // speichert den Namen des Users ab (wird gebraucht fuer die loeschen Funktion des pg369-Users
};
#endif // CDBSCHNITTSTELLE_H













