/* Generated by Together */

#include "CDatenbank.h"

CDatenbank::CDatenbank(char* db_username, bool bbetrieb=false)
{
	batchbetrieb=bbetrieb;

	try{lnkCGRASSSchnittstelle=new CGRASSSchnittstelle(batchbetrieb);}
	catch(...)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: GRASSSchnittstelle konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}
	try{lnkCDBSchnittstelle=new CDBSchnittstelle(db_username, batchbetrieb);}
	catch(...)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: Datenbank Schnittstelle konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}

	temporaere_guetemasse=0;
	temporaerer_wegenetzgraph=0;

	derFahrplan=0;
     	summeNetzbedingteWartezeiten=0.0;
	wartezeitAufwand=0.0;
	mindestWartezeitAufwand=0.0;
	gesamtWarteaufwand=0.0;
	anzahlFahrzeuge=0;


}
CDatenbank::~CDatenbank()
{
	if(lnkCGRASSSchnittstelle!=0) delete lnkCGRASSSchnittstelle;
	lnkCGRASSSchnittstelle=0;
	if(lnkCDBSchnittstelle!=0) delete lnkCDBSchnittstelle;
	lnkCDBSchnittstelle=0;
	
	if(temporaere_guetemasse!=0) delete temporaere_guetemasse;
	temporaere_guetemasse=0;
}

bool CDatenbank::seinInRechteck(double xKoord_grenzeLO, double yKoord_grenzeLO,
			             double xKoord_grenzeRU, double yKoord_grenzeRU, CPunkt * testPunkt)
{
	/**
	 * Testet einen Punkt, ob dieser in einem durch die Grenzpunkte definierten Rechteck liegt
	 */
	//Debug(2, "seinInRechteck()");
	double xKoord_testPunkt = testPunkt->holenX();
	double yKoord_testPunkt = testPunkt->holenY();
		
	//Ueberpruefung, ob ein Punkt in den von den Grenzpunkten definiertem Rechteck liegt	
	if ((xKoord_grenzeLO <= xKoord_testPunkt) && (xKoord_testPunkt<= xKoord_grenzeRU))
	{
		if ((yKoord_grenzeRU <= yKoord_testPunkt) && (yKoord_testPunkt<= yKoord_grenzeLO))
		return true;
		else
		return false;
	}
	else
	return false;
}

list<list<CPunkt* >*>* CDatenbank::clippenStrassennetz(list<list<CPunkt* > * > * strassennetz,
						 double grenzeLinksOben_X, double grenzeLinksOben_Y,
 						 double grenzeRechtsUnten_X, double grenzeRechtsUnten_Y)
{
	/**
	 * Diese Methode schneidet alle Strassen, die in dem durch die Grenzpunkte definierten Rechteck liegen, ab.
	 */
	//Debug(2, "clippenStrassennetz()");
	bool schnittpunktVorhanden;
	//Die Strasse aus dem Strassennetz
	list<CPunkt * >* strasse =0;
	try{strasse= new list<CPunkt *>;}
	catch(...)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: beim Abschneiden des Strassennetzes konnte die urspruengliche Strasse nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}
	//Die geclippte Strasse
	list<CPunkt * > * geclippteStrasse =0;
	try{geclippteStrasse= new list<CPunkt * >;}
	catch(...)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: beim Abschneiden des Strassenentzes konnte das abgeschnittene Strassenteilstueck nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}
	
	CPunkt * merkPunkt;
	list<list<CPunkt* >*>* geclipptesStrassennetz =0;
	try{ geclipptesStrassennetz = new   list<list<CPunkt* >*>;}
	catch(...)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: der Strassennetzausschnittt konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}
	
	
	//Fuer alle Strassen, die sich im Strassennetz befinden
	forall (strasse, * strassennetz)
	{
		schnittpunktVorhanden=false;
		try{geclippteStrasse = new list<CPunkt * >;}
		catch(...)
		{
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Abgeschnittene Strasse konnte nicht angelegt werden. Speichermangel?"<<endl;
			cerr.flush();
		}
		
		forall(merkPunkt, *strasse)
		{
			if (seinInRechteck(grenzeLinksOben_X, grenzeLinksOben_Y, grenzeRechtsUnten_X, grenzeRechtsUnten_Y, merkPunkt))
			{
				schnittpunktVorhanden=true;
				geclippteStrasse->append(merkPunkt);		
			}
		};
		if(schnittpunktVorhanden)
		geclipptesStrassennetz->append(geclippteStrasse);
	   	
	}       // Ende for ueber alle Strassen des Strassennetzes
	
//	cout << geclipptesStrassennetz->size()<< " Strassen\n";

	return geclipptesStrassennetz;
} 



// -------------------- Allgemein: --------------------------------------------------------------------------
// die folgende Funktion speichert die Guetemasse in der Datenbank
void CDatenbank::speichernGuetemasse(CGuetemasse * guetemasse)
{
//	temporaere_guetemasse=new CGuetemasse(*guetemasse);
	temporaere_guetemasse=guetemasse;
	lnkCDBSchnittstelle->speichernGuetemasse(guetemasse);
	
	// gib mal einfach alles aus:
/*	map2<int, int, CReisebewertung > * reisebewertung=guetemasse->holenReisebewertung();
	for(int x=0; x<=guetemasse->holenAnzahlHaltestellen(); x++)
	{
		for(int y=0; y<=guetemasse->holenAnzahlHaltestellen(); y++)
		{
			if(reisebewertung->defined(x,y)==true)
			{
				cout<<x<<" "<<y;
				cout<<((*reisebewertung)(x,y)).gebenFahrzeit();
				cout<<((*reisebewertung)(x,y)).gebenWartezeit();
				cout<<((*reisebewertung)(x,y)).gebenAnzahlDerUmstiege();
				cout<<((*reisebewertung)(x,y)).gebenIdealeFahrzeit();
		
				three_tuple<int,int,int> element;
				forall(element, ((*reisebewertung)(x,y)).gebenReiseweg())
				{
					cout<<element.first();
					cout<<element.second();
					cout<<element.third();
				}
			}
		}
	}
*/
}

// die folgende Funktion holt bereits gefuellte Guetemassklasse aus der Datenbank
CGuetemasse* CDatenbank::holenGuetemasse()
{
	if(temporaere_guetemasse==0) temporaere_guetemasse=lnkCDBSchnittstelle->holenGuetemasse();
	return temporaere_guetemasse;
}





// -------------------- Haltestellen: -----------------------------------------------------------------------
// speichert die vom Benutzer eingegebenen Startwerte  
void CDatenbank::speichernHaltestellenModulParameter(int aufruf, int algorithmus, int zufallsgeneratorInitialisierung,
							double minRadius, double maxRadius, double verbindungsRadiusStadt,
							double verbindungsRadiusLand, int radiustyp, double haltestellenLage,
							double toleranzgrenze, int bevoelkerungsRaster, double koeffizientBevoelkerungsueberversorgung,
							double koeffizientBevoelkerungsunterversorgung, double koeffizientFlaechenueberversorgung,
							double koeffizientFlaechenunterversorgung, double koeffizientFahrtwunscheinbeziehung,
							double koeffizientStrassenanpassung,
							int AnzahlHaltestellen, bool AnzStrassenkarte,
							bool AnzBevoelkerungsversorgung, bool AnzFlaechenversorgung, bool Anzkomplettunterdruecken,
							int Strategie, int AnzahlEltern, int AnzahlKinder, int Generationen, 
							bool AbbruchGueteunterschreitung, double GrenzwGueteunterschreitung)
{
	lnkCDBSchnittstelle->speichernHaltestellenModulParameter(aufruf, algorithmus, zufallsgeneratorInitialisierung, minRadius, maxRadius, verbindungsRadiusStadt,
							verbindungsRadiusLand, radiustyp,haltestellenLage, toleranzgrenze, bevoelkerungsRaster,koeffizientBevoelkerungsueberversorgung,
							koeffizientBevoelkerungsunterversorgung, koeffizientFlaechenueberversorgung,
							koeffizientFlaechenunterversorgung, koeffizientFahrtwunscheinbeziehung,
							koeffizientStrassenanpassung,
							AnzahlHaltestellen,AnzStrassenkarte,
							AnzBevoelkerungsversorgung,AnzFlaechenversorgung, Anzkomplettunterdruecken,
							Strategie, AnzahlEltern, AnzahlKinder, Generationen, 
							AbbruchGueteunterschreitung, GrenzwGueteunterschreitung);
}
// holt die Startwerte der Haltestellen:
void CDatenbank::holenHaltestellenModulParameter(int aufruf, int& algorithmus, int& zufallsgeneratorInitialisierung,
							double& minRadius, double& maxRadius, double& verbindungsRadiusStadt,
							double& verbindungsRadiusLand, int& radiustyp, double& haltestellenLage,
							double& toleranzgrenze, int& bevoelkerungsRaster, double& koeffizientBevoelkerungsueberversorgung,
							double& koeffizientBevoelkerungsunterversorgung, double& koeffizientFlaechenueberversorgung,
							double& koeffizientFlaechenunterversorgung, double& koeffizientFahrtwunscheinbeziehung,
							double& koeffizientStrassenanpassung,
							int& AnzahlHaltestellen, bool& AnzStrassenkarte,
							bool& AnzBevoelkerungsversorgung, bool& AnzFlaechenversorgung, bool& Anzkomplettunterdruecken,
							int& Strategie, int& AnzahlEltern, int& AnzahlKinder, int& Generationen, 
							bool& AbbruchGueteunterschreitung, double& GrenzwGueteunterschreitung)
{
	lnkCDBSchnittstelle->holenHaltestellenModulParameter(aufruf, algorithmus, zufallsgeneratorInitialisierung, minRadius, maxRadius, verbindungsRadiusStadt,
							verbindungsRadiusLand, radiustyp,haltestellenLage, toleranzgrenze, bevoelkerungsRaster,koeffizientBevoelkerungsueberversorgung,
							koeffizientBevoelkerungsunterversorgung, koeffizientFlaechenueberversorgung,
							koeffizientFlaechenunterversorgung, koeffizientFahrtwunscheinbeziehung,
							koeffizientStrassenanpassung,
							AnzahlHaltestellen,AnzStrassenkarte,
							AnzBevoelkerungsversorgung,AnzFlaechenversorgung, Anzkomplettunterdruecken,
							Strategie, AnzahlEltern, AnzahlKinder, Generationen, 
							AbbruchGueteunterschreitung, GrenzwGueteunterschreitung);
}
// Haltestellen:
void CDatenbank::holenDaten(list<CPunkt*>*& pflichthaltestellen, 
			    list<list<CPunkt*>*>*& strassennetz, 
			    list<list<CPunkt*>*>*& wege,
			    list<CBevoelkerungsdichteElement*>*& bevoelkerungsdichte, 
			    matrix*& quellezielmatrix, 
			    list<CQuelleZielListeElement*>*& quellezielliste, 
			    matrix*& pendlermatrix, 
			    list<CPendlerListeElement*>*& pendlerliste,
			    list<list<CPunkt*>*>*& gebaeude)
{

	// erstmal Testen: es kann sein, dass bereits ein temporaerer Wegenetzgraph existiert. Wenn dem so ist,
	// muessen wir den killen, da ein neuer berechnet wird:
	if(temporaere_guetemasse!=0) delete temporaere_guetemasse;
	temporaere_guetemasse=0;

	//CNetzplangenerator::holenDaten(pflichthaltestellen,strassennetz, bevoelkerungsdichte, quellezielmatrix, quellezielliste, pendlermatrix, pendlerliste, gebaeude);

	// Bevoelkerungsdichte NOCH DUMMY-DATEN!!!!!!!!!!!
//	bevoelkerungsdichte = new list<CBevoelkerungsdichteElement*>;
//	bevoelkerungsdichte->append (new CBevoelkerungsdichteElement(new CPunkt(2577500,5717150),200000,100000));
		
	// pflichthaltestellen kommen aus GRASS
	pflichthaltestellen=lnkCGRASSSchnittstelle->holenPflichthaltestellen();
	// strassennetz kommt aus GRASS
	strassennetz=lnkCGRASSSchnittstelle->holenStadtplan();
	gebaeude=lnkCGRASSSchnittstelle->holenGebaeude();
	// ebenso alle Wege
	wege=lnkCGRASSSchnittstelle->holenWege();


	// jetzt noch clippen, sofern Daten zum Clippen vorliegen:
        double links, oben, rechts, unten;
	lnkCDBSchnittstelle->holenAusschnitt(links, oben,rechts,unten);
        if((links==0) && (rechts==0) && (oben==0) && (unten==0))
	{
		// dann steht nichts in der DB
		Debug(2, "es wird nichts abgeschnitten");
	}else
	{
		// ansonsten muessen wir clippen:
		Debug(2, "Das Strassennetz wird abgeschnitten an:"<<links<<","<<oben<<" | "<<rechts<<","<<unten);
		list<list<CPunkt*>*>* temp=strassennetz;
		strassennetz=clippenStrassennetz(temp, links, oben, rechts, unten);
		// und noch die Wege clippen:
		temp=wege;
		wege=clippenStrassennetz(temp, links, oben, rechts, unten);
	}

	// Der Rest: Bevoelkerungsdichte, QuelleZielMatrix, QuelleZielListe, PendlerMatrix, PendlerListe
	// kommmt z.Zt. noch aus der GUI und braucht hier nicht angelegt zu werden
        // ANSONSTEN:
	// bevoelkerungsdichte kommt aus Oracle
	bevoelkerungsdichte=lnkCDBSchnittstelle->holenBevoelkerungsDichte();
	// Quelle-Ziel-Matrix kommt aus Oracle:
	quellezielmatrix=lnkCDBSchnittstelle->holenUrsprungsQZMatrix();
	quellezielliste=lnkCDBSchnittstelle->holenUrsprungsQZListe();
	// Pendlermatrix kommt aus Oracle:
	pendlermatrix=lnkCDBSchnittstelle->holenPendlermatrix();
	pendlerliste=lnkCDBSchnittstelle->holenPendlerliste();
}

void CDatenbank::speichernDaten(GRAPH<CWegenetzKnoten*, CWegenetzKante*>* wgraph, matrix* qzmatrix) // Ergebnisse des Haltestellenmoduls
{

	//cout<<"CDatenbank: speichernDaten der Haltestellen"<<endl;
	// zuerst die Haltestellen zur Anzeige in GRASS schieben:
	// wichtig: das muss vor dem Speichern in der DB passieren, da die DB das uebergebene
	// Objekt nach der allg. Regel zerstoert.
	// dazu Knoten in Liste stecken:
	list<CPunkt*>* haltestellenliste=0;
	try{haltestellenliste=new list<CPunkt*>;}
	catch(...)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: Die Liste der Haltestellen zur Speicherung in GRASS konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}
	CWegenetzKnoten* wegenetzknoten=0;
	node knoten;
	forall_nodes(knoten, *wgraph)
	{
		wegenetzknoten=wgraph->inf(knoten);
		haltestellenliste->append(wegenetzknoten->holenPosition());
	}
	Debug(2, "Anzahl Haltestellen: "<<haltestellenliste->length());
        lnkCGRASSSchnittstelle->speichernHaltestellen(haltestellenliste);
	// jetzt den Strassenplan zur Anzeige speichern:
	// wichtig: das muss vor dem Speichern in der DB passieren, da die DB das uebergebene
	// Objekt nach der allg. Regel zerstoert.
	if(lnkCGRASSSchnittstelle==0) cerr<<"GRASSSChnittstelle ist NULL!"<<endl;
	lnkCGRASSSchnittstelle->speichernStrassenplan(wgraph);
	
	// jetzt die Daten in die Datenbank reinschieben
	lnkCDBSchnittstelle->speichernWegenetzKnoten(wgraph);    // das sind nur die erzeugten Haltestellen
	lnkCDBSchnittstelle->speichernWegenetzKanten(wgraph);    // und das sind nur die Kanten

	if(wgraph!=0) {			         // graphen hier Zerstoeren, da dies in speichernGrunddaten und speichernKanten nicht passiert
		CWegenetzKnoten *nodeterminator;
		CWegenetzKante *edgeterminator;
		edge morituruskante;
		node moriturusknoten;
		list <CPunkt*> *moriturusliste;
		CPunkt *pointterminator;

		forall_edges(morituruskante, *wgraph) {
			edgeterminator=wgraph->inf(morituruskante);
			moriturusliste=edgeterminator->holenKantenListe();
			forall (pointterminator, *moriturusliste) {
				delete pointterminator;
			}
			delete moriturusliste;
			delete edgeterminator;
		}
		forall_nodes(moriturusknoten, *wgraph) {
			nodeterminator=wgraph->inf(moriturusknoten);
			pointterminator=nodeterminator->holenPosition();
			delete pointterminator;
		}
		wgraph->del_all_edges();
		wgraph->del_all_nodes();
		delete wgraph;
	}

	lnkCDBSchnittstelle->speichernQuelleZielMatrix(qzmatrix);// QuelleZielmatrix speichern

        


	// TEST: hole Knoten des Strassenplans raus und pruefe, ob das Speichern korrekt war:
	/*Debug(2, "!!!!!!!!!!!!!!!!!!!!!Test 1");
	GRAPH<CWegenetzKnoten*, CWegenetzKante*>* wgraph2=new GRAPH<CWegenetzKnoten*, CWegenetzKante*>;

	list<CWegenetzKnoten*>* knotenliste=lnkCDBSchnittstelle->holenWegenetzKnoten();
	CWegenetzKnoten* wknoten;
	forall(wknoten, *knotenliste)
	{
		double x,y;
		(wknoten->holenPosition())->holen(&x,&y);
		cout<<"Knoten: "<<x<<", "<<y<<" Prio:"<<wknoten->holenPrioritaet()<<" id:"<<wknoten->holenKnotenId()<<endl;
		wgraph2->new_node(wknoten);
	}
	*/
	/*Debug(2, "!!!!!!!!!!!!!!!!!!!!!Test 2");        
	// TEST: hole Kanten des Strassenplans raus und pruefe, ob das Speichern korrekt war:
	lnkCDBSchnittstelle->holenWegenetzKanten(wgraph2);
	edge kante;
        forall_edges(kante, *wgraph2)
	{
		CWegenetzKante* wkante=wgraph->inf(kante);
		CPunkt* einpunkt=0;
		forall(einpunkt, *(wkante->holenKantenListe()))
		{
			double x,y;
			einpunkt->holen(&x,&y);
			cout<<"Kante: "<<x<<", "<<y<<" Entfernung:"<<wkante->holenEntfernung()<<endl;
		}
	}
	
        delete knotenliste;
	Debug(2, "!!!!!!!!!!!!!!!!!!!!!Test ENDE");
	*/
        // TEST ENDE
			
}





// -------------------- Linienplan: -------------------------------------------------------------------------
// speichert die vom Benutzer eingegebenen Startwerte:
void CDatenbank::speichernLinienplanModulParameter(int aufruf, int gesamtlaenge, int maxLinienLaenge, 
							int maxLinienAnzahl, double linienplanID,
							int geschwindigkeit=15, int algorithmus=0, int anzeigegraphen=0,
							bool EindeutigeLinienverkn=false, bool MehrdeutigeLinienverkn=false, 
							bool Aufbruchsverknuepfung=false, bool Linienendverknuepfung=false,
							bool Basislinienwahl=false)
{
	lnkCDBSchnittstelle->speichernLinienplanModulParameter(aufruf, gesamtlaenge, maxLinienLaenge, maxLinienAnzahl, linienplanID, geschwindigkeit, algorithmus, anzeigegraphen, EindeutigeLinienverkn, MehrdeutigeLinienverkn, Aufbruchsverknuepfung, Linienendverknuepfung, Basislinienwahl);
}
// holt die Startwerte des Linienplans:
void CDatenbank::holenLinienplanModulParameter(int aufruf, int& gesamtlaenge, int& maxLinienLaenge, 
							int& maxLinienAnzahl, double& linienplanID,
							int& geschwindigkeit, int& algorithmus, int& anzeigegraphen,
							bool& EindeutigeLinienverkn, bool& MehrdeutigeLinienverkn, 
							bool& Aufbruchsverknuepfung, bool& Linienendverknuepfung,
							bool& Basislinienwahl)
{
	lnkCDBSchnittstelle->holenLinienplanModulParameter(aufruf, gesamtlaenge, maxLinienLaenge, maxLinienAnzahl, linienplanID, geschwindigkeit, algorithmus, anzeigegraphen, EindeutigeLinienverkn, MehrdeutigeLinienverkn, Aufbruchsverknuepfung, Linienendverknuepfung, Basislinienwahl);
}
// Linienplan:
void CDatenbank::holenDaten(matrix*& quellezielmatrix, list<CLinie*>*& vorgegebeneLinien,
		UGRAPH<CWegenetzKnoten*,CWegenetzKante*>*& wegenetzGraph)
{
	Debug(2, "holenDaten fuer den Linienplan start");
	// quellezielmatrix kommt aus Oracle:
	quellezielmatrix=lnkCDBSchnittstelle->holenQuelleZielMatrix();
/*	Debug(2, "gebe QuelleZielmatrix aus:");
	for( int x=0; x<quellezielmatrix->dim1(); x++)
	{
		for(int y=0; y<quellezielmatrix->dim2(); y++)
		{
			// Werte zuweisen:
			Debug(2, "Eintrag: "<<x<<","<<y<<" Wert: "<<(*quellezielmatrix)(x,y));
             	}
	} 
*/

	// voegegebene Linien kommen aus Oracle:
	//lnkCDBSchnittstelle.holenLinienweg();	
	//lnkCDBSchnittstelle.holenLinienplan();
	Debug(2, "QuelleZielMatrix geholt");
	vorgegebeneLinien= holenPflichtlinien();
	// wegenetzgraph kommt aus Oracle:
	// jetzt den Wegenetzplan aufbauen, indem zuerst die Knoten geholt werden und dann der
	// Graph mit den Kanten vervollstaendigt wird:
	GRAPH<CWegenetzKnoten*, CWegenetzKante*>* wgraph=0;
	try{wgraph=new GRAPH<CWegenetzKnoten*, CWegenetzKante*>;}
	catch(...)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: Der Wegenetzgraph als Eingabe des Linienplans konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}
	list<CWegenetzKnoten*>* knotenliste=lnkCDBSchnittstelle->holenWegenetzKnoten();
	Debug(2, "Anzahl Knoten im Graph: "<<knotenliste->length());


	CWegenetzKnoten* wknoten;
	forall(wknoten, *knotenliste)
	{
		wgraph->new_node(wknoten);
	}
	
	lnkCDBSchnittstelle->holenWegenetzKanten(wgraph);
	wegenetzGraph=(UGRAPH<CWegenetzKnoten*,CWegenetzKante*>*)wgraph;		

	Debug(2, "holenDaten fuer den Linienplan ende");
}
matrix* CDatenbank::holenLinienplanQuelleZielMatrix()
{
	Debug(2, "hole QuelleZielMatrix fuer den Linienplan");
	return lnkCDBSchnittstelle->holenQuelleZielMatrix();
}
UGRAPH<CWegenetzKnoten*,CWegenetzKante*>* CDatenbank::holenLinienplanWegenetzgraph()
{
	Debug(2, "hole Wegenetzgraph fuer den Linienplan");
	// wegenetzgraph kommt aus Oracle:
	// jetzt den Wegenetzplan aufbauen, indem zuerst die Knoten geholt werden und dann der
	// Graph mit den Kanten vervollstaendigt wird:
	GRAPH<CWegenetzKnoten*, CWegenetzKante*>* wgraph=0;
	try{wgraph=new GRAPH<CWegenetzKnoten*, CWegenetzKante*>;}
	catch(...)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: Der Wegenetzgraph konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}
	list<CWegenetzKnoten*>* knotenliste=lnkCDBSchnittstelle->holenWegenetzKnoten();
	Debug(2, "Anzahl Knoten im Graph: "<<knotenliste->length());


	CWegenetzKnoten* wknoten;
	forall(wknoten, *knotenliste)
	{
		wgraph->new_node(wknoten);
	}
	
	lnkCDBSchnittstelle->holenWegenetzKanten(wgraph);
	return (UGRAPH<CWegenetzKnoten*,CWegenetzKante*>*)wgraph;
}

// Ergebnisse des Linienplans:
void CDatenbank::speichernDaten(GRAPH<CFPlanGraphKnoten*, CFPlanGraphKante*>* fpgraph=0, list<CLinie*>* buslinien=0)
{
	Debug(2, "speichernDaten des Linienplans");
	lnkCDBSchnittstelle->speichernBusLinien(fpgraph, buslinien);

        
	
        /* TESTS: */
	/*// fpgraph einfach weiterleiten:
	// zu Testzwecken einfach nur loeschen:
	delete fpgraph;
	
	// TEST: hole die Daten des Plans 0 einfach wieder raus:
	list<CLinie*>* testlinien=lnkCDBSchnittstelle->holenBusLinien(0);
	delete testlinien;
	*/


	
	// schiebe jetzt die Daten in GRASS zur Anzeige. Die entsprechende Funktion benoetigt
	// den Wegenetzgraph und die Liste mit den Buslinien:
	list<CLinie*>* linien=lnkCDBSchnittstelle->holenBusLinien(0);
	// jetzt den Wegenetzplan aufbauen, indem zuerst die Knoten geholt werden und dann der
	// Graph mit den Kanten vervollstaendigt wird:
	GRAPH<CWegenetzKnoten*, CWegenetzKante*>* wegenetzgraph=0;
	try{wegenetzgraph=new GRAPH<CWegenetzKnoten*, CWegenetzKante*>;}
	catch(...)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: Der Wegenetzgraph konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}
	list<CWegenetzKnoten*>* knotenliste=lnkCDBSchnittstelle->holenWegenetzKnoten();
	CWegenetzKnoten* wknoten;
	forall(wknoten, *knotenliste)
	{
		wegenetzgraph->new_node(wknoten);
	}
	
	lnkCDBSchnittstelle->holenWegenetzKanten(wegenetzgraph);
	// jetzt die ganze Sosse in GRASS reinschieben:
	lnkCGRASSSchnittstelle->speichernLinienplan(wegenetzgraph, linien);

	Debug(2, "Eliminiere Graphen:");
	// und wieder aufraeumen:

	CWegenetzKnoten *nodeterminator; //wegenetzgraph ordentlich zerstoeren
	CWegenetzKante *edgeterminator;
	edge morituruskante;
	node moriturusknoten;
	list <CPunkt*> *moriturusliste;
	CPunkt *pointterminator;

	forall_edges(morituruskante, *wegenetzgraph) {
		edgeterminator=wegenetzgraph->inf(morituruskante);
		moriturusliste=edgeterminator->holenKantenListe();
		forall (pointterminator, *moriturusliste) {
			delete pointterminator;
		}
		delete moriturusliste;
		delete edgeterminator;
	}
	forall_nodes(moriturusknoten, *wegenetzgraph) {
		nodeterminator=wegenetzgraph->inf(moriturusknoten);
		pointterminator=nodeterminator->holenPosition();
		delete pointterminator;
	}
	wegenetzgraph->del_all_edges();
	wegenetzgraph->del_all_nodes();
	delete wegenetzgraph;
	
	CLinie* terminator=0; // Linien ordentlich zerstoeren
	list<int> *terminator2=0;
	forall(terminator, *linien) {
		terminator2=terminator->holenhListe();
		delete terminator2;
	}
	delete linien;
	Debug(2, "Ende speichernDaten des Linienplans");
} 

void CDatenbank::speichernPflichtlinienDatenbank(list<CLinie*>* pflichtlinien) // speichert die Pflichtlinien in Oracle 
{
	lnkCDBSchnittstelle->speichernPflichtlinien(pflichtlinien);
}
void CDatenbank::speichernPflichtlinienGRASS(list<CLinie*>* pflichtlinien) // speichert die Pflichtlinien in Oracle und GRASS
{
	// Wegenetzgraph als Basis holen:
	// sofern es einen temporaeren gibt, nimm den, ansonsten erzeuge einen neuen:
	GRAPH<CWegenetzKnoten*, CWegenetzKante*>* wgraph=0;
	if(temporaerer_wegenetzgraph!=0)
	{
		wgraph=temporaerer_wegenetzgraph;
		temporaerer_wegenetzgraph=0;
	}
	else
	{
		try{wgraph=new GRAPH<CWegenetzKnoten*, CWegenetzKante*>;}
		catch(...)
		{
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: Der Wegenetzgraph konnte fuer das Speichern der Pflichtlinien in GRASS nicht angelegt werden. Speichermangel?"<<endl;
			cerr.flush();
		}
		list<CWegenetzKnoten*>* knotenliste=lnkCDBSchnittstelle->holenWegenetzKnoten();
		Debug(2, "Anzahl Knoten im Graph: "<<knotenliste->length());
        	
		CWegenetzKnoten* wknoten;
		forall(wknoten, *knotenliste)
		{
			wgraph->new_node(wknoten);
		}
		lnkCDBSchnittstelle->holenWegenetzKanten(wgraph);

		// und jetzt die Pflichtlinien in GRASS schieben:
		lnkCGRASSSchnittstelle->speichernPflichtlinien(wgraph, pflichtlinien);
	}

	// aufraeumen:
	delete wgraph;
}
void CDatenbank::speichernEinePflichtlinie(list<int>* pflichtlinie=0, int id=0)  // speichert genau eine Pflichtlinie mit der ID "id" in GRASS
{
	if(pflichtlinie!=0)
	{
		if(temporaerer_wegenetzgraph==0)
		{
			// sollte kein temporaerer Wegenetzgraph existieren, legen wir einen neuen an
			try{temporaerer_wegenetzgraph=new GRAPH<CWegenetzKnoten*, CWegenetzKante*>;}
			catch(...)
			{
				cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: Der Wegenetzgraph konnte fuer das Speichern einer Pflichtlinie nicht angelegt werden. Speichermangel?"<<endl;
				cerr.flush();
			}
			list<CWegenetzKnoten*>* knotenliste=lnkCDBSchnittstelle->holenWegenetzKnoten();
			Debug(2, "Anzahl Knoten im Graph: "<<knotenliste->length());
        	
			CWegenetzKnoten* wknoten;
			forall(wknoten, *knotenliste)
			{
				temporaerer_wegenetzgraph->new_node(wknoten);
			}
			lnkCDBSchnittstelle->holenWegenetzKanten(temporaerer_wegenetzgraph);
        	
		}
		// hier existiert auf jeden Fall ein Wegenetzgraph:
		lnkCGRASSSchnittstelle->speichernEinePflichtlinie(temporaerer_wegenetzgraph, pflichtlinie, id);
	} 
}
list<CLinie*>* CDatenbank::holenPflichtlinien() // holt die Pflichtlinien aus Oracle
{
	return lnkCDBSchnittstelle->holenPflichtlinien();
}
	





// -------------------- Fahrplan: ---------------------------------------------------------------------------
// Fahrplan:
GRAPH<CFPlanGraphKnoten*, CFPlanGraphKante*>* CDatenbank::fahrplanLinienplan() // holt Ergebnis des Linienplans
{
	// Als erstes die Guetemassetabelle auf -1 setzten (initialisieren):
	lnkCDBSchnittstelle->loeschenAusgangsloesung(0);
        Debug(2, "Ausgangsloesungstabelle initialisiert, hole Daten fuer den Fahrplan:");
	// und jetzt die Daten fuer die Eingabe holen:
	return lnkCDBSchnittstelle->holenFahrplanGraph(0); // Parameter= ID des Planes (=Rueckkopplung)
}
/** holt Mindestumsteigezeit
  * @return Zeiger auf das LEDA-h_array mit der Mindestumsteigezeit
*/
h_array<int,list<three_tuple<int,int,int>* >*>* CDatenbank::fahrplanMindestumsteigezeit()
{
	return lnkCDBSchnittstelle->holenMindestumsteigezeit();
} 
/** holt die Mindesthaltezeit
 * @return Zeiger auf das LEDA-h_array mit den Mindesthaltezeiten
 */
h_array<int,int>* CDatenbank::fahrplanMindesthaltezeit()
{
	return lnkCDBSchnittstelle->holenMindesthaltezeiten();
}

// Ergebnis des Fahrplans: Zusammenhangskomponenten:
void CDatenbank::speichernDaten(array<list<three_tuple<int,int,int>* >* >* zusammenhangskomponenten=0)
{
  	if(zusammenhangskomponenten!=0)
	{
	  //		int speicherID;
	    int komponente;
	    int lfdNummer;
	    int haltestelleVon;
	    int haltestelleNach;
	    int linienNummer;
		list<three_tuple<int,int,int>* >* zusammenhangskomponentenListe;
		  three_tuple<int,int,int>* werte;
		for (int i = 0;i<(zusammenhangskomponenten->size());i++){
    			zusammenhangskomponentenListe = (*zusammenhangskomponenten)[i];
			komponente = i;
			lfdNummer = 0;
		    // Und die einzelnen Werte gespeichert werden.
			forall(werte,*zusammenhangskomponentenListe){
			      lfdNummer++;
			      haltestelleVon = werte->first();
			      haltestelleNach = werte->second();
			      linienNummer = werte->third();
			      
                                cout<<komponente<<" "<<lfdNummer<<" "<<haltestelleVon<<" "<<haltestelleNach<<" "<<linienNummer<<endl;

			    }
		  }



		Debug(2, "SpeichernZusammenhangskomponenten");
		// Zunaechst schieben wir die Zusammenhangskomponenten in GRASS:
		// dazu ist der Wegenetzgraph notwendig:
		GRAPH<CWegenetzKnoten*, CWegenetzKante*>* wgraph=0;
		try{wgraph=new GRAPH<CWegenetzKnoten*, CWegenetzKante*>;}
		catch(...)
		{
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: Der Wegenetzgraph konnte fuer das Speichern der Zusammenhangskomponenten nicht angelegt werden. Speichermangel?"<<endl;
			cerr.flush();
		}
		list<CWegenetzKnoten*>* knotenliste=lnkCDBSchnittstelle->holenWegenetzKnoten();
		if(knotenliste->empty()==false)
		{
			CWegenetzKnoten* wknoten;
			forall(wknoten, *knotenliste)
			{
				wgraph->new_node(wknoten);
			}
			lnkCDBSchnittstelle->holenWegenetzKanten(wgraph);
			Debug(2, "Wegenetzgraph geholt, speichere in GRASS");
			// und jetzt in GRASS reinschieben:
			lnkCGRASSSchnittstelle->speichernZusammenhangskomponenten(wgraph, zusammenhangskomponenten);	
                	
			//delete wgraph; // TODO: noch die Dinger hinter wgraph loeschen.
			Debug(2, "GRASS-Daten gespeichert, speichere in Oracle");       	
			// Die Daten werden einfach an die Datenbank uebergeben
			lnkCDBSchnittstelle->speichernZusammenhangskomponenten(zusammenhangskomponenten);	
		}
		else cerr<<"Datenbank: Anzeige der Zusammenhangskomponenten nicht moeglich, da Wegenetzgraph nicht vorhanden"<<endl;
		
		CWegenetzKnoten *nodeterminator;
		CWegenetzKante *edgeterminator;
		edge morituruskante;
		node moriturusknoten;
		list <CPunkt*> *moriturusliste;
		CPunkt *pointterminator;
		
		forall_edges(morituruskante, *wgraph) {
			edgeterminator=wgraph->inf(morituruskante);
			moriturusliste=edgeterminator->holenKantenListe();
			forall (pointterminator, *moriturusliste) {
				delete pointterminator;
			}
			delete moriturusliste;
			delete edgeterminator;
		}
		forall_nodes(moriturusknoten, *wgraph) {
			nodeterminator=wgraph->inf(moriturusknoten);
			pointterminator=nodeterminator->holenPosition();
			delete pointterminator;
		}
		wgraph->del_all_edges();
		wgraph->del_all_nodes();
		delete wgraph;
	}else
	{
		cerr<<"Datenbank: Fehler! Der Fahrplan liefert keine Zusammenhangskomponenten!"<<endl;
	}
} 

// Ergebnis des Fahrplans: Fahrplan
void CDatenbank::speichernDaten(list<CFahrplanElement*>* fahrplan=0)
{
  //lnkCDBSchnittstelle->speichernFahrplan(fahrplan);

   // falls ein Fahrplan schon besteht, erst loeschen:
  if(derFahrplan!=0)
  {
        CFahrplanElement* terminator;
	
	forall(terminator, *derFahrplan)
	{
		delete terminator;
	}
	delete derFahrplan;
	derFahrplan=0;
  }

  if(fahrplan==0) cerr<<"CDatenbank: uebergebener Fahrplan ist NULL"<<endl;
  else
  {
  	Debug(2, "VERSUCHE FAHRPLAN AUSZUGEBEN");
	// TEST: hier nur auf cout ausgeben:
	  CFahrplanElement* element;
	  forall(element, *fahrplan){
        	cout << "\n" << *element;
	  }
	

	try{derFahrplan=new list<CFahrplanElement*>;}
	catch(...)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: Der Fahrplan konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}
	CFahrplanElement* einelement;
	CFahrplanElement* dummyelement;	
	forall(einelement, *fahrplan)
	{
		try{dummyelement=new CFahrplanElement(einelement->gebenHaltestelle(), einelement->gebenLinie(), einelement->gebenLinienStartHaltestelle(), einelement->gebenAbfahrtszeitStunde(), einelement->gebenAbfahrtszeitMinute());}
		catch(...)
		{
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: Ein Element des Fahrplans konnte nicht angelegt werden. Speichermangel?"<<endl;
			cerr.flush();
		}
		derFahrplan->append(einelement);
	}
       	
	//derFahrplan=fahrplan;
	//lnkCDBSchnittstelle->speichernFahrplan(fahrplan);
  }
  

} 
/** speichert die Mindestumsteigezeit
 *  @return Zeiger auf das LEDA-h_array mit der Mindestumsteigezeit
 */
void CDatenbank::speichernFahrplanMindestumsteigezeit(h_array<int,list<three_tuple<int,int,int>* >*>* mu)
{
	lnkCDBSchnittstelle->speichernMindestumsteigezeit(mu);
}
void CDatenbank::speichernFahrplanMindesthaltezeiten(h_array<int,int>* mh)
{
	lnkCDBSchnittstelle->speichernMindesthaltezeiten(mh);	
}
// erzeugt die Liste direkter Anschluesse fuer die Testdaten
list<four_tuple<int,int,int,int>* >* CDatenbank::fahrplanDirekterAnschluss()
{
 	return 0;
}
// gibt die maximale Fahrzeuganzahl fuer die Testdaten zurueck
int CDatenbank::fahrplanMaximaleFahrzeuganzahl() 
{
	return 0;
}
// gibt die Abfahrtszeiten aus den Testdaten zurueck
array<three_tuple<int,int,int>* >* CDatenbank::fahrplanAbfahrtszeiten()
{
	// Test-DummyDaten
  array<three_tuple<int,int,int>* >* abfahrtszeiten = new array<three_tuple<int,int,int>* >(2);
  three_tuple<int,int,int>* haltestelle = new three_tuple<int,int,int>(1,1,13);
  cout << "Waehle Abfahrtszeit in 1. Zusammenhangskomponente (1,1,13)\n";
  abfahrtszeiten->set(0,haltestelle);
  haltestelle = new three_tuple<int,int,int>(8,2,47);
  cout << "Waehle Abfahrtszeit in 2. Zusammenhangskomponente (8,2,47)\n";
  abfahrtszeiten->set(1,haltestelle);
  return abfahrtszeiten;
}
// gibt das Fahrplanintervall aus den Testdaten zurueck
four_tuple<int,int,int,int>* CDatenbank::fahrplanIntervall()
{
	// Dummy-Werte!!!!!
	
	four_tuple<int,int,int,int>* intervall = new four_tuple<int,int,int,int>(8,0,10,0);
  cout << "Der Fahrplan soll fuer den Zeitraum von 8.00 Uhr bis 10.00 Uhr erstellt werden !\n";
  return intervall;
}
/** speichert die Wartezeiten in der Datenbanktabelle Ausgangsloesung
 */
void CDatenbank::fahrplanerstellungWartezeiten (double input_summeNetzbedingteWartezeiten, double input_wartezeitAufwand,
						 double input_mindestWartezeitAufwand, double input_gesamtWarteaufwand)
{
	//lnkCDBSchnittstelle->fahrplanerstellungWartezeiten(summeNetzbedingteWartezeiten,wartezeitAufwand,mindestWartezeitAufwand,gesamtWarteaufwand);   
	summeNetzbedingteWartezeiten=input_summeNetzbedingteWartezeiten;
	wartezeitAufwand=input_wartezeitAufwand;
	mindestWartezeitAufwand=input_mindestWartezeitAufwand;
	gesamtWarteaufwand=input_gesamtWarteaufwand;
}
/** speichert die Anzahl benoetigter Fahrzeuge in der Datenbanktabelle Ausgangsloesung
 */
void CDatenbank::fahrplanerstellungAnzahlBenoetigterFahrzeuge(int input_fahrzeugAnzahl)
{
	//lnkCDBSchnittstelle->fahrplanerstellungAnzahlBenoetigterFahrzeuge(fahrzeugAnzahl);
	anzahlFahrzeuge=input_fahrzeugAnzahl;
}
/** diese Funktion holt die Ausgangsloesung (= Guetemasse des Fahrplans)
 */
void CDatenbank::holenAusgangsloesung(double& input_summeNetzbedingteWartezeiten, double& input_wartezeitAufwand,
	   					double& input_mindestWartezeitAufwand, double& input_gesamtWarteaufwand)
{
	// lnkCDBSchnittstelle->holenAusgangsloesung(0,wartezeitAufwand,mindestWartezeitAufwand,summeNetzbedingteWartezeiten,anzahlFahrzeuge);
	input_summeNetzbedingteWartezeiten=summeNetzbedingteWartezeiten;
	input_wartezeitAufwand=wartezeitAufwand;
	input_mindestWartezeitAufwand=mindestWartezeitAufwand;
	input_gesamtWarteaufwand=mindestWartezeitAufwand+wartezeitAufwand; // laut Michael W. ist der gesamtwarteaufwand = summe aus mindestWA und wartezeitAuf
}
/** diese Funktion holt die Anzahl der benoetigten Fahrzeuge
 */
void CDatenbank::holenAnzahlFahrzeuge(int& input_anzahlFahrzeuge)
{
	input_anzahlFahrzeuge=anzahlFahrzeuge;
}
/**
  * Diese Methode gibt eine Liste des Fahrplans aus
  * Die Liste ist geordnet nach: HaltestellenID, LinienID, AbfahrtszeitStd, AbfahrtszeitMin
  */
list<CFahrplanElement*>* CDatenbank::holenFahrplanHaltestellen()
{
	//return lnkCDBSchnittstelle->holenFahrplanHaltestellen();
	return derFahrplan;
}
/**
  * Diese Methode gibt eine Liste des Fahrplans aus
  * Die Liste ist geordnet nach: LinienID, HaltestellenID, AbfahrtszeitStd, AbfahrtszeitMin
  */
list<CFahrplanElement*>* CDatenbank::holenFahrplanLinien()
{
	//return lnkCDBSchnittstelle->holenFahrplanLinien();
	return derFahrplan;
}
/* speichert alle Parameter von der GUI
*/
void CDatenbank::speichernFahrplanModulParameter(int maxfahrzeuganzahl, int allgemeinertakt, int mindesthaltezeit, int mindestumsteigezeit)
{
	lnkCDBSchnittstelle->speichernFahrplanModulParameter(maxfahrzeuganzahl, allgemeinertakt, mindesthaltezeit, mindestumsteigezeit);
}
/* holt alle Parameter aus der Datenbank
*/
void CDatenbank::holenFahrplanModulParameter(int& maxfahrzeuganzahl, int& allgemeinertakt, int& mindesthaltezeit, int& mindestumsteigezeit)
{
	lnkCDBSchnittstelle->holenFahrplanModulParameter(maxfahrzeuganzahl, allgemeinertakt, mindesthaltezeit, mindestumsteigezeit);
}






// -------------------- GUI: --------------------------------------------------------------------------------
// speichert die von der GUI importierte Bevoelkerungsdichte
void CDatenbank::speichernBevoelkerungsDichte(list<CBevoelkerungsdichteElement*>* bd)
{
	lnkCDBSchnittstelle->speichernBevoelkerungsDichte(bd);
}
// Speichert die von der GUI importierte Quelle-Ziel-Matrix plus die dazugehoerige Liste
void CDatenbank::speichernUrsprungsQZMatrix(matrix* quelleZielMatrix, list<CQuelleZielListeElement*>* quelleZielListe)
{
	 // Im ersten Prototypen kommen diese Daten noch aus der GUI:
	lnkCDBSchnittstelle->speichernUrsprungsQZMatrix(quelleZielMatrix);
	lnkCDBSchnittstelle->speichernUrsprungsQZListe(quelleZielListe);
}
// Speichert die von der GUI importierte Pendlermatrix plus die dazugehoerige Liste
void CDatenbank::speichernPendlermatrix(matrix* pendlerMatrix, list<CPendlerListeElement*>* pendlerListe)
{
	// Im ersten Prototypen kommen diese Daten noch aus der GUI
	lnkCDBSchnittstelle->speichernPendlermatrix(pendlerMatrix);
	lnkCDBSchnittstelle->speichernPendlerliste(pendlerListe);
}

// speichere die vorgegebenen Linien:
void CDatenbank::speichernVorgegebeneLinien()
{
}

// holt die Haltestellen ID zu den Koordinaten der Haltestelle
int CDatenbank::holenKnotenID(double x, double y)
{
	return lnkCDBSchnittstelle->holenKnotenID(x,y);	
}   
// holt die Koordinaten zu einer Haltestellen ID (leifert NULL, wenn ID nicht exisitiert)
CPunkt* CDatenbank::holenKnotenKoordinaten(int id)
{
	return lnkCDBSchnittstelle->holenKnotenKoordinaten(id);	
}
// holt die LinienIDs, die ueber eine Haltestelle laufen
list<int>* CDatenbank::holenLinienID(int id)
{
	return lnkCDBSchnittstelle->holenLinienID(id);
}
// liefert zu einer Haltestellen ID alle anderen Haltestellen, die von der uebergebenen
// Haltestelle im Wegenetzgraphen erreichbar sind
list<int>* CDatenbank::holenMoeglicheZielHaltestellen(int id)
{
	return lnkCDBSchnittstelle->holenMoeglicheZielHaltestellen(id);
}
// holt eine Zusammenhangskomponente zu einer Haltestelle und zwei Linien
int CDatenbank::holenZusammenhangsKomponentenID(int h,int l1) //Parameter: Haltestelle, Linie1
{
	return lnkCDBSchnittstelle->holenZusammenhangsKomponentenID(h,l1);
}
// holt alle eingehenden Linien in eine Haltestelle (als ID uebergeben)
list<int>* CDatenbank::holenEingehendeLinien(int id)
{
	return lnkCDBSchnittstelle->holenEingehendeLinien(id);
}
// hole alle ausgehenden Linien aus einer Haltestelle (als ID uebergeben)
list<int>* CDatenbank::holenAusgehendeLinien(int id)
{
	return lnkCDBSchnittstelle->holenAusgehendeLinien(id);
}
// holt alle Haltestellen, ueber die die Linie mit der linienid fuehrt
list<int>* CDatenbank::holenLinienHaltestellen(int linienid)
{
	return lnkCDBSchnittstelle->holenLinienHaltestellen(linienid);
}
void CDatenbank::speichernAusschnittStrassennetz()
{
	// erstmal schauen, ob wir ueberhaupt clippen duerfen (alle Werte sind in der DB 0)
	double links, oben, rechts, unten;
	lnkCDBSchnittstelle->holenAusschnitt(links,oben,rechts,unten);	

	if((links==0) && (rechts==0) && (oben==0) && (unten==0))
	{  
		// in diesem Fall duerfen wir nichts tun
		Debug(2, "es wird nichts abgeschnitten");
	}
	else
	{
		/**
		 * Das Strassennetz clippen!
		 */
		Debug(2, "Das Strassennetz wird abgeschnitten an:"<<links<<","<<oben<<" | "<<rechts<<","<<unten);
		list<list<CPunkt* >*>*  strassennetz=lnkCGRASSSchnittstelle->holenStadtplan();
			                                                                      	
		strassennetz = clippenStrassennetz(strassennetz, links, oben, rechts, unten);
	
	 	lnkCGRASSSchnittstelle->speichernAusschnittStrassennetz(strassennetz);

		// und aufraeumen:
		list<CPunkt* >* terminatorliste;
		forall(terminatorliste, *strassennetz)
		{
			CPunkt* terminator;
			forall(terminator, *terminatorliste)
			{
				delete terminator;
			}
			delete terminatorliste;
		}
		delete strassennetz;
	}
}
// loescht eine Linie
void CDatenbank::loeschenLinie(int id)
{
	Debug(2, "loeschenLinie start");
	// als erstes den Fahrplangraphen und die Linienliste holen:
	list<CLinie*>* allebuslinien=lnkCDBSchnittstelle->holenBusLinien(0);
        GRAPH<CFPlanGraphKnoten*, CFPlanGraphKante*>* fahrplangraph=lnkCDBSchnittstelle->holenFahrplanGraph(0);
	Debug(2, "Fahrplangraph angelegt");

	// wenn alles in Ordnung ist... 
	if((allebuslinien!=NULL) && (fahrplangraph!=0))
	{
                //... jetzt alle Buslinien durchlaufen und das CLinien-Element kappen, dass die ID id hat
		// gleichzeitig werden die IDs der verbleibenden Linien angepasst:
		Debug(2, "durchlaufe alle Linien");
		CLinie* einelinie=0;
		int position=0;
			
		// erstmal die Linie loeschen:
		list<CLinie*>* neuebuslinien=new list<CLinie*>;
		
		// jetzt die restlichen Linien anpassen:
		forall(einelinie, *allebuslinien)
		{
			// Liniennummer anpassen:
			if(einelinie==NULL) {Debug(2, "Die Linie ist NULL");}
			else
			{
				Debug(2, "Passe Linien id der Linie "<<einelinie->holenID()<<" an");
				if(einelinie->holenID()>id)
				{
					CLinie* neuelinie=new CLinie(*einelinie); //erst nur kopeieren

					// nur wenn die ID groesser als die uebergebene ID ist, muessen wir diese ID um ein verringern:
					int neueid=(einelinie->holenID());//-1;
					neueid--;
					neuelinie->setzenID(neueid);

					Debug(2, "neue ID:"<<neuelinie->holenID());
					neuebuslinien->append(neuelinie);
				}
				if(einelinie->holenID()<id)
				{
					// einfach nur kopieren:
					CLinie* neuelinie=new CLinie(*einelinie);
					neuebuslinien->append(neuelinie);
					Debug(2, "neue ID:"<<neuelinie->holenID());
				}
				if(einelinie->holenID()==id) 
				{
					// wenn es sich um die Linie handelt:
					// tue nichts

					//allebuslinien->del_item(allebuslinien->get_item(position));
					//delete einelinie; // und noch komplett wegwerfen
				}
			}
			position++;
		}
		// Liste ist hier wieder OK.
		Debug(2," Linienliste durchlaufen");		

		// jetzt den Fahrplangraphen durchlaufen:
		edge kante;
		CFPlanGraphKante* fahrplankante=0;
		Debug(2, "Durchlaufe alle Kanten des FP Graphen");

		Debug(2, "Loesche die Kanten");		
		forall_edges(kante, *fahrplangraph)
		{
			fahrplankante=fahrplangraph->inf(kante);
			if(fahrplankante->holenLinienID()==id)
			{
				fahrplangraph->del_edge(kante);
				delete fahrplankante; // und noch komplett wegwerfen
			}
			if(fahrplankante->holenLinienID()==(id*(-1))) // die Rueckkante
			{
				fahrplangraph->del_edge(kante);
				delete fahrplankante; // und noch komplett wegwerfen
			}
			
		}

		Debug(2, "passe Nummern des Fahrplangraphen an:");
		forall_edges(kante, *fahrplangraph)
		{
			fahrplankante=fahrplangraph->inf(kante);
			Debug(2, "--> Kante hat ID: "<<fahrplankante->holenLinienID());

			if(fahrplankante->holenLinienID()<0)
			{
				// Falls wir eine Kante mit negativer Beschriftung haben:
				// hier muessen wir die Rueckrichtung beachten!!!
				int invert=id*(-1);
				if(fahrplankante->holenLinienID()<invert)
				{
					int neueid=(fahrplankante->holenLinienID())+1;
					fahrplankante->setzenLinienID(neueid);
					Debug(2, "----> neue ID: "<<fahrplankante->holenLinienID());
				}
			}
			else if(fahrplankante->holenLinienID()>id)
			{
				int neueid=(fahrplankante->holenLinienID())-1;
				fahrplankante->setzenLinienID(neueid);
				Debug(2, "----> neue ID: "<<fahrplankante->holenLinienID());
			}
		}		
		Debug(2, "speichere manipulierte Daten");
		// Graph hier wieder OK.
		// Also: einfach alles wier abspeichern:

		speichernDaten(fahrplangraph, neuebuslinien);

	}
	else
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: Eine Linie konnte nicht geloescht werden, da der hierzu entweder der Fahrplangraph oder die Liste der Buslinien nicht vorhanden ist"<<endl;
		cerr.flush();
	}
	Debug(2, "Ende loeschen einer Linie");
}
// gibt die kuerzeste Verbindung zw. zwei HS aus; WICHTIG: prueft nicht, ob FP schon durchgelaufen ist!
CReisebewertung* CDatenbank::routenplanung(int starths, int endhs)
{
	CReisebewertung* ausgabe=new CReisebewertung;

	// als erstes die Guetemasse holen
	CGuetemasse* guetemasse=holenGuetemasse();
	
	// Reisebewertung holen, um den kuerzesten Weg zu bestimmen:
	map2<int,int,CReisebewertung>* bewertung = guetemasse->holenReisebewertung();
	
        
        CReisebewertung reise;
	list<three_tuple<int,int,int> > reiseweg;
		
        reise = (*bewertung)(starths,endhs);
	
	// OK. hier haben wir die Reisebewertung, die wir zurueckgeben muessen:
	// also: ausfuellen der Rueckgabestruktur
	ausgabe->setzenFahrzeit(reise.gebenFahrzeit());
	Debug(2, "urspruengliche Fahrtzeit:"<<reise.gebenFahrzeit());
	ausgabe->setzenWartezeit(reise.gebenWartezeit()); 
	Debug(2, "urspruengliche Wartezeit:"<<reise.gebenWartezeit());
	ausgabe->setzenAnzahlDerUmstiege(reise.gebenAnzahlDerUmstiege());
	Debug(2, "urspruengliche AnzahlUmstiege:"<<reise.gebenAnzahlDerUmstiege());
	

	map2<int,int,double>* autos;
	autos=guetemasse->holenReisezeitHS2HSAuto();
	double idealefz=(*autos)(starths,endhs);
	idealefz=idealefz/466.67;
	ausgabe->setzenIdealeFahrzeit(idealefz);

	Debug(2, "urspruengliche ideale Fahrzeit:"<<(*autos)(starths,endhs));
	reiseweg = reise.gebenReiseweg();
	
	// jetzt die Route auslesen und eine neue list<int> fuer GRASS anlegen:
	list<int>* grassliste=new list<int>;


	list<three_tuple<int,int,int> > neuerReiseweg;

	three_tuple<int,int,int> knoten;
	forall(knoten,reiseweg) {
	
			//knoten.first(); Linie von
			//knoten.second(); Haltestelle
			//knoten.third();  Linie nach

			// erst die GRASS-Liste erweitern:
			grassliste->append(knoten.second());

			// und jetzt die "ausgabe" vervollstaendigen:
			three_tuple<int,int,int> eintupel;
			eintupel.first()=knoten.first();
			eintupel.second()=knoten.second();
			eintupel.third()=knoten.third();
			neuerReiseweg.append(eintupel);
			
        }

	// neuerReiseweg in die Ausgabe scheiben:
	ausgabe->setzenReiseweg(neuerReiseweg);
        
	if(temporaerer_wegenetzgraph==0)
	{
		// und die Ausgabe in GRASS schieben:
		// Dazu: erstmal den Wegenetzgraphen erzeugen:
		GRAPH<CWegenetzKnoten*, CWegenetzKante*>* wgraph=0;
		try{wgraph=new GRAPH<CWegenetzKnoten*, CWegenetzKante*>;}
		catch(...)
		{
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: Der Wegenetzgraph konnte fuer das Speichern einer Route in GRASS nicht angelegt werden. Speichermangel?"<<endl;
			cerr.flush();
		}
		list<CWegenetzKnoten*>* knotenliste=lnkCDBSchnittstelle->holenWegenetzKnoten();
        	
		CWegenetzKnoten* wknoten;
		forall(wknoten, *knotenliste)
		{
			wgraph->new_node(wknoten);
		}
		lnkCDBSchnittstelle->holenWegenetzKanten(wgraph);  
		temporaerer_wegenetzgraph=wgraph;
	}
	
        
	// und reinschieben
	lnkCGRASSSchnittstelle->speichernRoute(temporaerer_wegenetzgraph, grassliste);


	// aufraeumen:
	//delete wgraph;

	// und das Ergebnis auswerfen
	return ausgabe;
}




// -------------------- Versionierung: ----------------------------------------------------------------------
void CDatenbank::setzenAktuelleProjektID(int id) // hiermit wird ein Projekt ausgewaehlt
{
	lnkCDBSchnittstelle->setzenAktuelleProjektID(id);
	// da das Projekt gewechselt wurde, muessen wir die aktuelle Guetemasseklasse zerstoeren
	if(temporaere_guetemasse!=0) delete temporaere_guetemasse; 
	temporaere_guetemasse=0;
	// erstmal Testen: es kann sein, dass bereits ein temporaerer Wegenetzgraph existiert. Wenn dem so ist,
	// muessen wir den killen, da ein neuer berechnet wird:
	if(temporaere_guetemasse!=0) delete temporaere_guetemasse;
	temporaere_guetemasse=0;
}
int CDatenbank::holenAktuelleProjektID() // gibt die ID des aktuellen Projektes zurueck
{
	return lnkCDBSchnittstelle->holenAktuelleProjektID();
}
void CDatenbank::setztenPhase(int phase) // speichert den Schritt ab, indem sich der Benutzer im aktuellen Projekt gerade befindet
{
	// erstmal Testen: es kann sein, dass bereits ein temporaerer Wegenetzgraph existiert. Wenn dem so ist,
	// muessen wir den killen, da ein neuer existiert:
	//if(temporaere_guetemasse!=0) delete temporaere_guetemasse;
	//temporaere_guetemasse=0;

	lnkCDBSchnittstelle->setztenPhase(phase);
}
int CDatenbank::holenPhase()	// liefert den Schritt, indem sich der Benutzer gerade befindet.
{
	return lnkCDBSchnittstelle->holenPhase();
}
int CDatenbank::anlegenNeuesProjekt(int id, char* beschreibung=0, int phase=0) // legt ein neues Projekt an, liefert die gespeicherte ID zurueck
{
	return lnkCDBSchnittstelle->anlegenNeuesProjekt(id, beschreibung, phase);
}
void CDatenbank::holenProjektInformationen(int id, char*& beschreibung, int& phase) // holt die Informationen des Projektes mit der ID "id"
{
	lnkCDBSchnittstelle->holenProjektInformationen(id, beschreibung, phase);
}
list<two_tuple<int,char*>*>* CDatenbank::holenAlleProjektInformationen() // liefert die Informationen aller Projekte zurueck (gibt die ganze Projekttabelle aus)
{
	return lnkCDBSchnittstelle->holenAlleProjektInformationen();
}
int CDatenbank::holenAnzahlProjekte() // gibt die Anzahl der in Oracle gespeicherten Projekte zurueck
{
	return lnkCDBSchnittstelle->holenAnzahlProjekte();
}
int CDatenbank::holenErsteFreieProjektID() // holt die erste Projekt-ID, die noch von keinem Projekt belegt wurde
{
	return lnkCDBSchnittstelle->holenErsteFreieProjektID();
}
void CDatenbank::loeschenProjekt(int id) // loescht das Projekt mit der ID "id"
{
	lnkCDBSchnittstelle->loeschenProjekt(id);
}
int CDatenbank::kopierenProjekt(int quellid, int zielid, char* beschreibung=0) // kopiert das Projekt mit der ID "quellid" in das Projekt mit der ID "zielid", liefert die ID des Zielprojektes zuerueck
{
	return lnkCDBSchnittstelle->kopierenProjekt(quellid, zielid, beschreibung);
}

// Datenaustauschfunktionen:
int CDatenbank::anlegenNeuesProjektPG369(int id, char* beschreibung, int phase) // legt ein neues Projekt im Datenaustausch-Users an, liefert die gespeicherte ID zurueck
{
	return lnkCDBSchnittstelle->anlegenNeuesProjektPG369(id, beschreibung, phase);
}
void CDatenbank::holenProjektInformationenPG369(int id, char*& beschreibung, int& phase) // holt die Informationen des Projektes mit der ID "id" des Datenaustausch-Users
{
	lnkCDBSchnittstelle->holenProjektInformationenPG369(id, beschreibung, phase);
}
list<two_tuple<int,char*>*>* CDatenbank::holenAlleProjektInformationenPG369() // liefert die Informationen aller Projekte des Datenaustausch-Users zurueck (gibt die ganze Projekttabelle aus)
{
	return lnkCDBSchnittstelle->holenAlleProjektInformationenPG369();
}
void CDatenbank::loeschenProjektPG369(int id) // loescht das Projekt mit der ID "id" im Datenaustausch-Users
{
	lnkCDBSchnittstelle->loeschenProjektPG369(id);
}
int CDatenbank::holenErsteFreieProjektIDPG369() // holt die erste Projekt-ID, die noch von keinem Projekt belegt wurde beim Datenaustausch-User
{
	return lnkCDBSchnittstelle->holenErsteFreieProjektIDPG369();
}
int CDatenbank::kopierenProjektVonPG369(int quellid, int zielid, char* beschreibung=0) // kopiert das Projekt mit der ID "quellid" des Datenaustausch-Users pg369 in das Projekt mit der ID "zielid", liefert die ID des Zielprojektes zuerueck
{
	lnkCDBSchnittstelle->kopierenProjektVonPG369(quellid, zielid, beschreibung);
	return 0; // Hide warning
}
int CDatenbank::kopierenProjektNachPG369(int quellid, int zielid, char* beschreibung=0) // kopiert das Projekt mit der ID "quellid" in das Projekt mit der ID "zielid" des Datenaustauschusers pg369, liefert die ID des Zielprojektes zuerueck
{
	lnkCDBSchnittstelle->kopierenProjektNachPG369(quellid, zielid, beschreibung);
	return 0; // Hide warning
}

void CDatenbank::speichernPflichthaltestellen() // speichert die Koordinaten der Pflichthaltestellen in Oracle  
{
	//list<CPunkt*>* pflichthaltestellen
	lnkCDBSchnittstelle->speichernPflichthaltestellen(lnkCGRASSSchnittstelle->holenPflichthaltestellen());
}
void CDatenbank::holenPflichthaltestellen() // holt die Pflichthaltestellen wieder aus der DB und schreibt sie in GRASS
{
	list<CPunkt*>* phs=lnkCDBSchnittstelle->holenPflichthaltestellen();
	// und jetzt in GRASS reinschieben:
	lnkCGRASSSchnittstelle->speichernPflichthaltestellen(phs);
	// und wieder aufraeumen:
	CPunkt* terminator;
	forall(terminator, *phs)
	{
		delete terminator;
	}
	delete phs; // TODO: richtig killen
}
void CDatenbank::speichernAusschnitt(double links, double oben, double rechts, double unten) // speichert die Abmessungen des zu beruecksichtigenden Ausschnitts
{
	lnkCDBSchnittstelle->speichernAusschnitt(links, oben, rechts, unten);
}
void CDatenbank::holenAusschnitt(double& links, double& oben, double& rechts, double& unten) // holt die Abmessungen des zu beruecksichtigendesn Ausschnitts
{
	lnkCDBSchnittstelle->holenAusschnitt(links, oben, rechts, unten);
}
void CDatenbank::aktuallisierenAnzeigen(int phase) // nach dem Wechsel eines Projektes stellt dies wieder alle Anzeigen in GRASS her
{
	if(phase>=0)
	{
		// die Haltestellen stehen vor dem Start:
		holenPflichthaltestellen();
	}	
	if(phase>=50)
	{
		// die Haltestellen sind gerade durchgelaufen:
		
		// Wegenetzgraph schreiben:
		GRAPH<CWegenetzKnoten*, CWegenetzKante*>* wgraph=0;
		try{wgraph=new GRAPH<CWegenetzKnoten*, CWegenetzKante*>;}
		catch(...)
		{
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: Der Wegenetzgraph zur Wiederherstellung der Anzeige konnte nicht angelegt werden. Speichermangel?"<<endl;
			cerr.flush();
		}
		list<CWegenetzKnoten*>* knotenliste=lnkCDBSchnittstelle->holenWegenetzKnoten();
		Debug(2, "Anzahl Knoten im Graph: "<<knotenliste->length());


		CWegenetzKnoten* wknoten;
		forall(wknoten, *knotenliste)
		{
			wgraph->new_node(wknoten);
		}
	
		lnkCDBSchnittstelle->holenWegenetzKanten(wgraph);
		// hier habe ich den Wegenetzgraph, in GRASS schieben:
		lnkCGRASSSchnittstelle->speichernStrassenplan(wgraph);

		// Haltestellen speichern:
		list<CPunkt*>* haltestellenliste=0;
		try{haltestellenliste=new list<CPunkt*>;}
		catch(...)
		{
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: Die Haltestellenliste zur Wiederherstellung der Anzeige konnte nicht angelegt werden. Speichermangel?"<<endl;
			cerr.flush();
		}
		CWegenetzKnoten* wegenetzknoten=0;
		node knoten;
		forall_nodes(knoten, *wgraph)
		{
			wegenetzknoten=wgraph->inf(knoten);
			haltestellenliste->append(wegenetzknoten->holenPosition());
		}
		Debug(2, "Anzahl Haltestellen: "<<haltestellenliste->length());
	        lnkCGRASSSchnittstelle->speichernHaltestellen(haltestellenliste);


		if(phase>=100)
		{
			// der Linienplan ist gerade durchgelaufen:
			list<CLinie*>* meinebuslinien=lnkCDBSchnittstelle->holenBusLinien(0);
			lnkCGRASSSchnittstelle->speichernLinienplan(wgraph, meinebuslinien);
		}
		
		// und wieder aufraeumen:
		delete wgraph; // TODO: noch richtig aufraeumen
		delete haltestellenliste; // TODO: noch richtig aufraeumen

	}
}

