/* Generated by Together */

#include "CGRASSSchnittstelle.h"

#include "stdio.h"

CGRASSSchnittstelle::CGRASSSchnittstelle(bool bbetrieb=false)
{
	//Damit GRASS nur auf Wunsch benutzt wird
#ifdef MIT_GRASS
	G_gisinit("Programm");
#endif

	batchbetrieb=bbetrieb;
}
CGRASSSchnittstelle::~CGRASSSchnittstelle()
{
	
}


// -------------------------  Hilfs-Funktionen -----------------------------------------------------------
int CGRASSSchnittstelle::speichernVectorlayer(char* dateiname, list<list<CPunkt*>*>* listevonarcs=0)
{
        if(listevonarcs!=0)
	{
		struct Map_info map;		// Zugriff auf die Karte
		struct line_pnts* Points;	// Zugriff auf die einzelenen Linien (hier sind das die Arcs!!!)

	        //if (0>Vect_open_old(&map, dateiname, "PERMANENT"))
		if (0>Vect_open_new(&map, dateiname))
		  G_fatal_error("Cannot open vector file");

		list<CPunkt*>* arc=0;
		forall(arc, *listevonarcs)
		{

		        Points = Vect_new_line_struct();     // dies ist eine GRASS-Arc, in die wir die Punkte reinwerfen muessen
			int anzahl_punkte=arc->length(); // Anzahl der Punkte auf der Linie
//			Debug(2, "Laenge der arc ist: "<<anzahl_punkte);
			if(anzahl_punkte>0) // nur wenn auch wirklich Knoten exisitieren, schiebe die in GRASS:
			{
				double* x=0;
				try{x=new double[anzahl_punkte];} // dass GRASS-Aequivalent zur LEDA-Liste
				catch(...)
				{
					cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte die x-Werte einer Arc nicht anlegen. Speichermangel?"<<endl;
					cerr.flush();
				}
				double* y=0;
				try{y=new double[anzahl_punkte];}
				catch(...)
				{
					cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte die y-Werte einer Arc nicht anlegen. Speichermangel?"<<endl;
					cerr.flush();
				}
				int zaehler=0;
				CPunkt* einpunkt=0;
				forall(einpunkt, *arc)
				{
					// jetzt habe ich einen Punkt, den ich in GRASS werfen muss
					// diese kommt in eine neue Arc-Linie
					//einpunkt->holen(&x[zaehler], &y[zaehler]);
					x[zaehler]=einpunkt->holenX();
					y[zaehler]=einpunkt->holenY();
					zaehler++;
				}
//				Debug(2, "Nach Schleife: Kopiere Points");
				Vect_copy_xy_to_pnts(Points, x, y, anzahl_punkte); // die Punkte in eine Arc-Struktur konvertieren
        
				// ... und Ergebnis reinschreiben:
				if(0>Vect_write_line(&map, LINE, Points))
				{
				        char* errorstring;
					try{errorstring=new char[strlen(dateiname)+strlen("GRASS: Linie konnte nicht in  gespeichert werden")+1];}
					catch(...)
					{
						cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte einen Fehlerstring nicht anlegen. Speichermangel?"<<endl;
						cerr.flush();
					}
					sprintf(errorstring, "GRASS: Linie konnte nicht in %s gespeichert werden", dateiname);
					G_fatal_error(errorstring);
					delete[] errorstring;
				}
				Vect_destroy_line_struct(Points); // und die Linie aus dem Speicher entfernen
//				Debug(2, "Loesche Knoten");
				delete[] x;
				delete[] y;
			}  // durchlaufe alle Punkte einer Linie
		} // durchlaufe alle Linien
		Vect_close(&map);
	} // endif: wurde ueberhaupt eine Liste uebergeben?
	return 0;
}

int CGRASSSchnittstelle::speichernSiteslayer(char* dateiname, list<CPunkt*>* haltestellenliste)
{
//	Debug(2, "speichernHaltestellen start");

	CFortschritt* fortschritt=0;
	if(batchbetrieb==false) 
	{	
		try{fortschritt=new CFortschritt("Speichern Haltestellen");}
		catch(...)
		{
			cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte die Fortschrittsanzeige fuer das Speichern eines Haltestellenlayers nicht anlegen. Speichermangel?"<<endl;
			cerr.flush();
		}
	}
	if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Speichere Haltestellen in GRASS...");

	// Haltestellen-Datei oeffnen, Dateihandle dabei in "datei" festhalten
	FILE* datei=G_sites_open_old(dateiname, "PERMANENT");
	if(datei==NULL) 
	{
		cout<<"Fehler: CGRASSSchnittstelle: speichernSiteslayer(): konnte Sites-Datei nicht oeffnen um Format zu bestimmen"<<endl;
	}

//	Debug(2, "neue Site anlegen");
	int dims, cat, strs, dbls;
	Site* punkte;
	if(G_site_describe(datei, &dims, &cat, &strs, &dbls)!=0)  // finde das Speicherformat heraus
		G_fatal_error("CGRASSSchnittstelle: speichernSiteslayer(): Konnte Format nicht feststellen");
	punkte=G_site_new_struct(cat, dims, strs, dbls);
//	Debug(2, "neue Site wurde erfolgreich angelegt");        


	
	// Haltestellen-Datei UEBERSCHREIBEN, Dateihandle dabei in "datei" festhalten
	datei=G_sites_open_new(dateiname);
	if(datei==NULL) 
	{
		cout<<"Fehler: CGRASSSchnittstelle: speichernSiteslayer(): konnte Sites-Datei nicht erzeugen"<<endl;
	}
//	Debug(2, "GRASSSchnittstelle: speichernPflichthaltestellen(): haltestellen-Layer ueberschrieben");

//	int dims, cat, strs, dbls;
//	Site* punkte;
//	punkte=G_site_new_struct(-1, 2, 0, 0);

	// Jetzt die uebergebene Liste durchlaufen und Sites ausfuellen:
//	Debug(2, "speichernPflichtaltestelle: Schleife start");
	
	CPunkt* haltestelle;
	double x,y;
	int durchlauf=0;
	forall(haltestelle, (*haltestellenliste))
	{
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(++durchlauf, haltestellenliste->length());
		haltestelle->holen(&x, &y);
		punkte->east=x;
		punkte->north=y;
		G_site_put(datei, punkte);
	}
	if(fortschritt!=0) fortschritt->anzeigenFortschritt(haltestellenliste->length(), haltestellenliste->length());
        if(fortschritt!=0) delete fortschritt;

	// Brutales Schliessen, da GRASS sonst ein Fehler wirft
	fclose(datei);

//	Debug(2, "speichernHaltestellen beendet");
}

list<CPunkt*>* CGRASSSchnittstelle::holenSiteslayer(char* dateiname)
{
	Debug(2, "holenSiteslayer");
        
	// Globale Liste anlegen, in der die Punkte (= "Sites") gespeichert werden
	list<CPunkt*>* haltestellenliste=0;
	try{haltestellenliste=new list<CPunkt*>;}
	catch(...)
	{
		cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte die Haltestellenliste nicht anlegen. Speichermangel?"<<endl;
		cerr.flush();
	}

	// Haltestellen-Datei oeffnen, Dateihandle dabei in "datei" festhalten
	FILE* datei=G_sites_open_old(dateiname, "PERMANENT");
//	Debug(2, "holenHaltestellen: Datei erfolgreich geoeffnet");
	if(datei!=NULL) 
	{
		// jetzt neue Site anlegen, die wir spaeter fuellen werden:
//		Debug(2, "neue Site anlegen");
		int dims, cat, strs, dbls;
		Site* punkte;
		if(G_site_describe(datei, &dims, &cat, &strs, &dbls)!=0)  // finde das Speicherformat heraus
			G_fatal_error("CGRASSSchnittstelle: holenSiteslayer(): Konnte Format nicht feststellen");
		punkte=G_site_new_struct(cat, dims, strs, dbls);
//		Debug(2, "neue Site wurde erfolgreich angelegt");        
	
		// Jetzt das gesamte File durchlaufen und jede Site in punkte holen. Dann die Daten extrahieren und
		// in die haltestellenliste haengen.
//		Debug(2, "holenHaltestelle: Schleife start");
		while(G_site_get(datei,punkte )==0)
		{
			if((punkte->east!=0)||(punkte->north!=0))
			{
				// sollte es einen Dummypunkt mit Koordinaten 0,0 geben, muss er ueberlesen
				// werden. Hierin ist dies nicht der Fall, also kann der Punkt uebernommen werden:
				try{haltestellenliste->append(new CPunkt(punkte->east, punkte->north));}
				catch(...)
				{
					cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte ein Element der Haltestellenliste nicht anlegen. Speichermangel?"<<endl;
					cerr.flush();
				}
			}
		
		}


		// totales aufraeumen:
		G_site_free_struct(punkte);
	
	}
	else
	{
		cout<<"Fehler: CGRASSSchnittstelle: holenSiteslayer(): konnte Sites-Datei nicht oeffnen"<<endl;
	}


//	Debug(2, "holenHaltestellen beendet");	

	return haltestellenliste;
}

node* CGRASSSchnittstelle::holeNodezuHaltestellenID(int id, GRAPH<CWegenetzKnoten*, CWegenetzKante*>* wegenetzgraph=0)
{
	node* rueckgabenode=0;
	if(wegenetzgraph!=0)
	{
		node knoten;
		forall_nodes(knoten, *wegenetzgraph)
		{
			if( (wegenetzgraph->inf(knoten))->holenKnotenId() == id ) 
			{
				try{rueckgabenode=new node(knoten);}
				catch(...)
				{
					cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte einen Knoten nicht anlegen. Speichermangel?"<<endl;
					cerr.flush();
				}
			}
		}
	}
	return rueckgabenode;	
}




// -------------------------  Holen-Funktionen -----------------------------------------------------------


list<list<CPunkt*>*>* CGRASSSchnittstelle::holenStadtplan(void)
{
	Debug(2, "holenStadtplan");
	// ersteinmal ein paar Strukturen anlegen, um auf GRASS zugreifen zu koennen
	struct Map_info map;		// Zugriff auf die Karte
	struct line_pnts* Points;	// Zugriff auf die einzelenen Linien (hier sind das die Arcs!!!)
	

	// Globale Liste anlegen, in die die einzelnen Arcs eingehangen werden (das was zurueckgegeben wird):
	list<list<CPunkt*>*>* strassennetz=0;
	try{strassennetz=new list<list<CPunkt*>*>;}
	catch(...)
	{
		cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte das Strassennetz nicht anlegen. Speichermangel?"<<endl;
		cerr.flush();
	}

 
	// HAUPTSTRASSEN einlesen:

       if (0>Vect_open_old(&map, "hau_stra", "PERMANENT"))
	  G_fatal_error("Cannot open vector file");
	Points = Vect_new_line_struct();

        // Jetzt durchlaufe alle Linien, die in Hauptstrassen sind und mache
	// etwas mit ihnen
	
	list<CPunkt*>* arc=0;
	while (0<Vect_read_next_line(&map, Points))
	  {
	    // mache hier was fuer jede Linie
	    // erstmal eine neue Liste anlegen, die die einzelnen Punkte aufnimmt:
	    try{arc=new list<CPunkt*>;}
	    catch(...)
	    {
		cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte eine Arc fuer das Strassennetz nicht anlegen. Speichermangel?"<<endl;
		cerr.flush();
	    }
	    CPunkt* punkt=0;
	    // jetzt alle Punkte auslesen und in die Liste ("arc") einhaengen:
	    for(unsigned long int i=0; i<Points->n_points; i++)
	    {
        	// neuen Punkt anlegen
		try{punkt=new CPunkt(Points->x[i], Points->y[i]);}
		catch(...)
	  	{
			cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte einen Punkt des Strassennetzes nicht anlegen. Speichermangel?"<<endl;
			cerr.flush();
		}
		// und ab in die Liste ("arc")
		arc->append(punkt);
            }

	    // Zum Abschluss noch die Liste ("arc") in die endgueltige Liste einhaengen:
	    strassennetz->append(arc);

	    // Vect_copy_pnts_to_xy(Points,
	  }

	// kurz aufraeumen fuer den naechsten Durchgang:
	delete Points;

//	Debug(2, "holeStadtplan: Halbzeit: hole sonstige Strassen");


        // SONSTIGE STRASSEN einlesen:
   	if (0>Vect_open_old(&map, "son_stra", "PERMANENT"))
	  G_fatal_error("Cannot open vector file");
	Points = Vect_new_line_struct();
        // Jetzt durchlaufe alle Linien, die in sonstige Strassen sind und mache
	// etwas mit ihnen
        while (0<Vect_read_next_line(&map, Points))
	  {
	    // mache hier was fuer jede Linie
	    // erstmal eine neue Liste anlegen, die die einzelnen Punkte aufnimmt:
	    try{arc=new list<CPunkt*>;}
	    catch(...)
	    {
		cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte eine Arc fuer die sonstigen Strassen nicht anlegen. Speichermangel?"<<endl;
		cerr.flush();
	    }
	    CPunkt* punkt=0;
	    // jetzt alle Punkte auslesen und in die Liste ("arc") einhaengen:
	    for(unsigned long int i=0; i<Points->n_points; i++)
	    {
        	// neuen Punkt anlegen
		try{punkt=new CPunkt(Points->x[i], Points->y[i]);}
		catch(...)
		{
			cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte einen Punkt aus den sonstigen Strassen nicht anlegen. Speichermangel?"<<endl;
			cerr.flush();
		}
		// und ab in die Liste ("arc")
		arc->append(punkt);
            }

	    // Zum Abschluss noch die Liste ("arc") in die endgueltige Liste einhaengen:
	    strassennetz->append(arc);

	    // Vect_copy_pnts_to_xy(Points,
	  }
	


	// totales aufraeumen
	Vect_destroy_line_struct(Points);
	Vect_close(&map);

//	Debug(2, "holenStadtplan beendet");

	return strassennetz;
}

list<list<CPunkt*>*>* CGRASSSchnittstelle::holenGebaeude(void)
{
	Debug(2, "holenGebaeude");
	// ersteinmal ein paar Strukturen anlegen, um auf GRASS zugreifen zu koennen
	struct Map_info map;		// Zugriff auf die Karte
	struct line_pnts* Points;	// Zugriff auf die einzelenen Linien (hier sind das die Arcs!!!)
	

	// Globale Liste anlegen, in die die einzelnen Arcs eingehangen werden (das was zurueckgegeben wird):
	list<list<CPunkt*>*>* gebaeude=0;
	try{gebaeude=new list<list<CPunkt*>*>;}
	catch(...)
	{
		cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte die Liste aller Gebauede nicht anlegen. Speichermangel?"<<endl;
		cerr.flush();
	}
	
 
	// HAUPTSTRASSEN einlesen:

       if (0>Vect_open_old(&map, "gebaude", "PERMANENT"))
	  G_fatal_error("Cannot open vector file");
	Points = Vect_new_line_struct();

        // Jetzt durchlaufe alle Linien, die in Hauptstrassen sind und mache
	// etwas mit ihnen
	
	list<CPunkt*>* arc=0;
	while (0<Vect_read_next_line(&map, Points))
	  {
	    // mache hier was fuer jede Linie
	    // erstmal eine neue Liste anlegen, die die einzelnen Punkte aufnimmt:
	    try{arc=new list<CPunkt*>;}
	    catch(...)
	   {
		cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte eine Arc der Gebaeude nicht anlegen. Speichermangel?"<<endl;
		cerr.flush();
	   }
	    CPunkt* punkt=0;
	    // jetzt alle Punkte auslesen und in die Liste ("arc") einhaengen:
	    for(unsigned long int i=0; i<Points->n_points; i++)
	    {
        	// neuen Punkt anlegen
		try{punkt=new CPunkt(Points->x[i], Points->y[i]);}
		catch(...)
		{
			cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte einen Punkt der Gebauede nicht anlegen. Speichermangel?"<<endl;
			cerr.flush();
		}
		// und ab in die Liste ("arc")
		arc->append(punkt);
            }

	    // Zum Abschluss noch die Liste ("arc") in die endgueltige Liste einhaengen:
	    gebaeude->append(arc);

	    // Vect_copy_pnts_to_xy(Points,
	  }

	// kurz aufraeumen fuer den naechsten Durchgang:
	delete Points;

	// totales aufraeumen
	Vect_destroy_line_struct(Points);
	Vect_close(&map);

//	Debug(2, "holenGebaeude beendet");

	return gebaeude;
}

list<list<CPunkt*>*>* CGRASSSchnittstelle::holenWege(void)
{
	Debug(2, "holenWege");
	// ersteinmal ein paar Strukturen anlegen, um auf GRASS zugreifen zu koennen
	struct Map_info map;		// Zugriff auf die Karte
	struct line_pnts* Points;	// Zugriff auf die einzelenen Linien (hier sind das die Arcs!!!)
	

	// Globale Liste anlegen, in die die einzelnen Arcs eingehangen werden (das was zurueckgegeben wird):
	list<list<CPunkt*>*>* wege=0;
	try{wege=new list<list<CPunkt*>*>;}
	catch(...)
	{
		cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte die Liste aller Wege nicht anlegen. Speichermangel?"<<endl;
		cerr.flush();
	}

 
	// HAUPTSTRASSEN einlesen:

       if (0>Vect_open_old(&map, "weg", "PERMANENT"))
	  G_fatal_error("Cannot open vector file");
	Points = Vect_new_line_struct();

        // Jetzt durchlaufe alle Linien, die in Hauptstrassen sind und mache
	// etwas mit ihnen
	
	list<CPunkt*>* arc=0;
	while (0<Vect_read_next_line(&map, Points))
	  {
	    // mache hier was fuer jede Linie
	    // erstmal eine neue Liste anlegen, die die einzelnen Punkte aufnimmt:
	    try{arc=new list<CPunkt*>;}
	    catch(...)
	    {
		cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte eine Arc der Hauptstrassen nicht anlegen. Speichermangel?"<<endl;
		cerr.flush();
	    }
	    CPunkt* punkt=0;
	    // jetzt alle Punkte auslesen und in die Liste ("arc") einhaengen:
	    for(unsigned long int i=0; i<Points->n_points; i++)
	    {
        	// neuen Punkt anlegen
		try{punkt=new CPunkt(Points->x[i], Points->y[i]);}
		catch(...)
		{
			cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte einen Punkt der Hauptstrassen nicht anlegen. Speichermangel?"<<endl;
			cerr.flush();
		}
		// und ab in die Liste ("arc")
		arc->append(punkt);
            }

	    // Zum Abschluss noch die Liste ("arc") in die endgueltige Liste einhaengen:
	    wege->append(arc);

	    // Vect_copy_pnts_to_xy(Points,
	  }

	// kurz aufraeumen fuer den naechsten Durchgang:
	delete Points;

	// totales aufraeumen
	Vect_destroy_line_struct(Points);
	Vect_close(&map);

//	Debug(2, "holenGebaeude beendet");

	return wege;
}

list<CPunkt*>* CGRASSSchnittstelle::holenHaltestellen()
{
	Debug(2, "holenHaltestellen");

	return holenSiteslayer("haltestellen");
}
	
list<CPunkt*>* CGRASSSchnittstelle::holenPflichthaltestellen()
{
	Debug(2, "holenPflichthaltestellen");
	
	return holenSiteslayer("pflichthaltestellen"); 
}


// -------------------------  Speichern-Funktionen -----------------------------------------------------------

void CGRASSSchnittstelle::speichernHaltestellen(list<CPunkt*>* haltestellenliste)
{
	Debug(2, "speichernHaltestellen start");
	try{haltestellenliste->append(new CPunkt(0.0,0.0));}
	catch(...)
	{
		cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte den Punk 0,0 der Haltestellen nicht anlegen. Speichermangel?"<<endl;
		cerr.flush();
	}
	speichernSiteslayer("haltestellen", haltestellenliste);
}

void CGRASSSchnittstelle::speichernPflichthaltestellen(list<CPunkt*>* haltestellenliste)
{
	Debug(2, "speichernPflichthaltestellen start");
	try{haltestellenliste->append(new CPunkt(0.0,0.0));}
	catch(...)
	{
		cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte einen Punkt 0,0 der Pflichthaltestellen nicht anlegen. Speichermangel?"<<endl;
		cerr.flush();
	}
	speichernSiteslayer("pflichthaltestellen", haltestellenliste);
}


void CGRASSSchnittstelle::speichernStrassenplan(GRAPH<CWegenetzKnoten*, CWegenetzKante*>* wegenetzgraph=0)
{
        // ersteinmal ein paar Strukturen anlegen, um auf GRASS zugreifen zu koennen
	struct Map_info map;		// Zugriff auf die Karte
	struct line_pnts* Points;	// Zugriff auf die einzelenen Linien (hier sind das die Arcs!!!)

	Debug(2, "speichernStrassenplan");

	// als erstes einen neuen Layer anlegen, der die Strassen alle aufnimmt
	if (0>Vect_open_new(&map, "reduzierter_strassenplan"))
	        G_fatal_error("Cannot create vector file reduzierter_strassenplan");
	
//	Debug(2, "neue Karte erzeugt");
	list<CPunkt*>* einearc=0;
	edge kante;
	// Durchlaufe jetzt alle Kanten

	CFortschritt* fortschritt=0;
	if(batchbetrieb==false) 
	{	
		try{fortschritt=new CFortschritt("Speichern Strassenplan");}
		catch(...)
		{
			cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte die Fortschrittsanzeige fuer das Speichern des Strassneplans nicht anlegen. Speichermangel?"<<endl;
			cerr.flush();
		}
	}
	if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Speichere den Strassenplan in GRASS...");
	int durchlauf=0;

	forall_edges(kante, *wegenetzgraph)
	{	
//		Debug(2, "nehme eine Kante aus dem Graph");

                if(fortschritt!=0) fortschritt->anzeigenFortschritt(++durchlauf, wegenetzgraph->number_of_edges());
		
		// hole jetzt die arc von der Kante:
		einearc=(wegenetzgraph->inf(kante))->holenKantenListe();
		// jetzt die Kantenliste durchlaufen und jeden Punkt in GRASS wefen:
		CPunkt* einpunkt=0;
		Points = Vect_new_line_struct();     // dies ist eine GRASS-Arc, in die wir die Punkte reinwerfen muessen
		int anzahl_punkte=einearc->length(); // Anzahl der Punkte auf der Linie
//		Debug(2, "Laenge der arc ist: "<<anzahl_punkte);
		double* x=0;
		try{x=new double[anzahl_punkte];}
		catch(...)
		{
			cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte den x-Wert einer Arc nicht anlegen. Speichermangel?"<<endl;
			cerr.flush();
		}
		double* y=0;
		try{y=new double[anzahl_punkte];}
		catch(...)
		{
			cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte den y-Wert einer Arc nicht anlegen. Speichermangel?"<<endl;
			cerr.flush();
		}
		int zaehler=0;
		forall(einpunkt, *einearc)
		{
//			Debug(2, "Punkt aus Arc geholt");
			// jetzt habe ich einen Punkt, den ich in GRASS werfen muss
			// diese kommt in eine neue Arc-Linie
			einpunkt->holen(&x[zaehler], &y[zaehler]);
			zaehler++;
		}
//		Debug(2, "Nach Schleife: Kopiere Points");
		Vect_copy_xy_to_pnts(Points, x, y, anzahl_punkte); // die Punkte in eine Arc-Struktur konvertieren
		// und ab mit der Linie in GRASS:
//		Debug(2, "Schreibe Arc in die Karte");
		if(0>Vect_write_line(&map, LINE, Points))
		     G_fatal_error("GRASS: Linie konnte nicht in reduzierter_strassenplan gespeichert werden");

	        
                // Zur Kontrolle alle punkte ausgeben:
/*	        for(unsigned long int i=0; i<Points->n_points; i++)
    	        { 
        	    Debug(2, "Koordinaten: "<<Points->x[i]<<", "<<Points->y[i]);
                }
*/
	    
		Vect_destroy_line_struct(Points); // und die Linie aus dem Speicher entfernen
		delete[] x;
		delete[] y;
        }

        if(fortschritt!=0) delete fortschritt;
	// totales aufraeumen
	Vect_close(&map);
//	Debug(2, "speichernStrassenplan beendet");
}

void CGRASSSchnittstelle::speichernLinienplan(GRAPH<CWegenetzKnoten*, CWegenetzKante*>* wegenetzgraph=0, list<CLinie*>* buslinien=0)
{
	
        Debug(2, "speichernLinienplan");
	if((wegenetzgraph!=0)&&(buslinien!=0))
	{
		list<list<CPunkt*>*>* arcsallerbuslinien=0;
		try{arcsallerbuslinien=new list<list<CPunkt*>*>;} // Hierin speichern wir alle Arcs fuer den globalen Linienlayer
		catch(...)
		{
			cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte die Liste aller Buslinien nicht anlegen. Speichermangel?"<<endl;
			cerr.flush();
		}

		CFortschritt* fortschritt=0;
		if(batchbetrieb==false) 
		{
			try{fortschritt=new CFortschritt("Speichern Linienplan");}
			catch(...)
			{
				cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte die Fortschrittsanzeige fuer das Speichern des Linienplans nicht anlegen. Speichermangel?"<<endl;
				cerr.flush();
			}
		}
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Speichere den Linienplan in GRASS...");
		int durchlauf=0;

		// durchlaufe die Buslinien:
		CLinie* einelinie=0;
		forall(einelinie, *buslinien)
		{
			if(fortschritt!=0) fortschritt->anzeigenFortschritt(++durchlauf, buslinien->length());

			// Neue Liste anlegen, in der alle Arcs des Layers gespeichert werden 
			// (entspricht alle Kanten einer Linie)
			list<list<CPunkt*>*>* listevonarcs=0;
			try{listevonarcs=new list<list<CPunkt*>*>;}
			catch(...)
			{
				cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte die Liste von Arcs beim Speichern des Linienplans nicht anlegen. Speichermangel?"<<endl;
				cerr.flush();
			}

			// hier haben wir jetzt eine Linie, durchlaufe alle Knoten:
			int einehaltestelle=-1;
			node* startknoten=0;
			forall(einehaltestelle, *(einelinie->holenhListe()) )
			{
                                list<CPunkt*>* arc=0;
				try{arc=new list<CPunkt*>;}
				catch(...)
				{
					cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte ein Teilstueck einer Arc beim Speichern des Linienplans nicht anlegen. Speichermangel?"<<endl;
					cerr.flush();
				}

				 // hole den Knoten der Haltestelle:
				node* endknoten=startknoten;
				startknoten=holeNodezuHaltestellenID(einehaltestelle, wegenetzgraph);
				// suche im Graphen die Kante dazu:
				if((startknoten!=0)&&(endknoten!=0))
				{
					edge* kante=holenKnotenverbindung((GRAPH<void*, void*>*) wegenetzgraph, startknoten, endknoten);
					if(kante==0) kante=holenKnotenverbindung((GRAPH<void*, void*>*) wegenetzgraph, endknoten, startknoten);
					if(kante!=0)
					{
						// Kante gefunden, jetzt die Linie an der kante durchlaufen...
						CPunkt* punktderlinie=0;
						forall(punktderlinie, *((wegenetzgraph->inf(*kante))->holenKantenListe()))
						{
							// ... und jeden Punkt in die Arc reinwerfen
							double x=punktderlinie->holenX();
							double y=punktderlinie->holenY();
							CPunkt* koordinaten=0;
							try{koordinaten=new CPunkt(x,y);}
							catch(...)
							{
								cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte einen Punkt einer Arc beim Speichern des Linienplans nicht anlegen. Speichermangel?"<<endl;
								cerr.flush();
							}
							arc->append(koordinaten);	
						}
					}		
				}
	
				// die Linien zwischen den beiden Punkten als neue Arc in die Liste aller Arcs einfuegen:
				listevonarcs->append(arc);       // fuer den einzelnen Layer
				arcsallerbuslinien->append(arc); // fuer den globalen Layer

			}  // ENDE: alle Knoten einer Linie durchlaufen

        		// Alle Linien die zu der arc gehoeren auf Layer speichern
			char ll[50]; 
			sprintf(ll, "linie_%d", einelinie->holenID()); // TODO: hier die +1 wegnehmen, ist nur dazu da, um BUG zu fixen
			speichernVectorlayer(ll, listevonarcs);
			delete listevonarcs;

		} // ENDE: alle Linien durchlaufen

		// Alle gesammelten Linien auf den globalen Layer schreiben:
		speichernVectorlayer("linienplan", arcsallerbuslinien);
		delete arcsallerbuslinien; // TODO: auch die Linien dahinter loeschen!
                if(fortschritt!=0) delete fortschritt;
	} // ENDIF: Abfrage, ob reinkommende Werte OK
	else cerr<<"Fehler: Konnte Linienplan nicht speichern, da kein Objekt uebergeben wurde"<<endl;
}

void CGRASSSchnittstelle::speichernPflichtlinien(GRAPH<CWegenetzKnoten*, CWegenetzKante*>* wegenetzgraph=0, list<CLinie*>* buslinien=0)
{
	
        Debug(2, "speichernPflichtlinien");
	if((wegenetzgraph!=0)&&(buslinien!=0))
	{
		list<list<CPunkt*>*>* arcsallerbuslinien=0;
		try{arcsallerbuslinien=new list<list<CPunkt*>*>;} // Hierin speichern wir alle Arcs fuer den globalen Linienlayer
		catch(...)
		{
			cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte die Liste aller Pflichtlinien nicht anlegen. Speichermangel?"<<endl;
			cerr.flush();
		}

		CFortschritt* fortschritt=0;
		if(batchbetrieb==false) 
		{
			try{fortschritt=new CFortschritt("Speichern Pflichtlinien");}
			catch(...)
			{
				cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte die Fortschrittsanzeige beim Speichern der Pflichtlinien nicht anlegen. Speichermangel?"<<endl;
				cerr.flush();
			}
		}
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Speichere alle Pflichtlinien in GRASS...");
		int durchlauf=0;

		// durchlaufe die Buslinien:
		CLinie* einelinie=0;
		forall(einelinie, *buslinien)
		{
			if(fortschritt!=0) fortschritt->anzeigenFortschritt(++durchlauf, buslinien->length());

			// Neue Liste anlegen, in der alle Arcs des Layers gespeichert werden 
			// (entspricht alle Kanten einer Linie)
			list<list<CPunkt*>*>* listevonarcs=0;
			try{ listevonarcs=new list<list<CPunkt*>*>;}
			catch(...)
			{
				cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte die Liste aller Arcs beim Speichern der Pflichtlinien nicht anlegen. Speichermangel?"<<endl;
				cerr.flush();
			}

			// hier haben wir jetzt eine Linie, durchlaufe alle Knoten:
			int einehaltestelle=-1;
			node* startknoten=0;
			forall(einehaltestelle, *(einelinie->holenhListe()) )
			{
                                list<CPunkt*>* arc=0;
				try{arc=new list<CPunkt*>;}
				catch(...)
				{
					cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte eine Arc beim Speichern der Pflichelinien nicht anlegen. Speichermangel?"<<endl;
					cerr.flush();
				}

				 // hole den Knoten der Haltestelle:
				node* endknoten=startknoten;
				startknoten=holeNodezuHaltestellenID(einehaltestelle, wegenetzgraph);
				// suche im Graphen die Kante dazu:
				if((startknoten!=0)&&(endknoten!=0))
				{
					edge* kante=holenKnotenverbindung((GRAPH<void*, void*>*) wegenetzgraph, startknoten, endknoten);
					if(kante==0) kante=holenKnotenverbindung((GRAPH<void*, void*>*) wegenetzgraph, endknoten, startknoten);
					if(kante!=0)
					{
						// Kante gefunden, jetzt die Linie an der kante durchlaufen...
						CPunkt* punktderlinie=0;
						forall(punktderlinie, *((wegenetzgraph->inf(*kante))->holenKantenListe()))
						{
							// ... und jeden Punkt in die Arc reinwerfen
							double x=punktderlinie->holenX();
							double y=punktderlinie->holenY();
							CPunkt* koordinaten=0;
							try{koordinaten=new CPunkt(x,y);}
							catch(...)
							{
								cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte einen Punkt beim Speichern der Pflichelinien nicht anlegen. Speichermangel?"<<endl;
								cerr.flush();
							}
							arc->append(koordinaten);	
						}
					}		
				}
	
				// die Linien zwischen den beiden Punkten als neue Arc in die Liste aller Arcs einfuegen:
				listevonarcs->append(arc);       // fuer den einzelnen Layer
				arcsallerbuslinien->append(arc); // fuer den globalen Layer

			}  // ENDE: alle Knoten einer Linie durchlaufen

        		// Alle Linien die zu der arc gehoeren auf Layer speichern
			char ll[50]; 
			sprintf(ll, "pflichtlinie_%d", einelinie->holenID()); // TODO: hier die +1 wegnehmen, ist nur dazu da, um BUG zu fixen
			speichernVectorlayer(ll, listevonarcs);
			delete listevonarcs;

		} // ENDE: alle Linien durchlaufen

		// Alle gesammelten Linien auf den globalen Layer schreiben:
		speichernVectorlayer("pflichtlinien", arcsallerbuslinien);
		delete arcsallerbuslinien; // TODO: auch die Linien dahinter loeschen!
                if(fortschritt!=0) delete fortschritt;
	} // ENDIF: Abfrage, ob reinkommende Werte OK
	else cerr<<"Fehler: Konnte Pflichtlinien nicht speichern, da kein Objekt uebergeben wurde"<<endl;
}

void CGRASSSchnittstelle::speichernEinePflichtlinie(GRAPH<CWegenetzKnoten*, CWegenetzKante*>* wegenetzgraph=0, list<int>* buslinie=0, int nummer=0)
{
	
        Debug(2, "speichernEinePflichtlinie");
	if((wegenetzgraph!=0)&&(buslinie!=0))
	{
		list<list<CPunkt*>*>* arcsallerbuslinien=0;
		try{arcsallerbuslinien=new list<list<CPunkt*>*>;} // Hierin speichern wir alle Arcs fuer den globalen Linienlayer
		catch(...)
		{
			cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte die Liste aller Buslinien beim Speichern einer Pflichtlinie nicht anlegen. Speichermangel?"<<endl;
			cerr.flush();
		}

		int durchlauf=0;

		list<list<CPunkt*>*>* listevonarcs=0;
		try{listevonarcs=new list<list<CPunkt*>*>;}
		catch(...)
		{
			cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte die Liste aller Arcs beim Speichern einer Pflichtlinie nicht anlegen. Speichermangel?"<<endl;
			cerr.flush();
		}

		// hier haben wir jetzt eine Linie, durchlaufe alle Knoten:
		int einehaltestelle=-1;
		node* startknoten=0;
		forall(einehaltestelle, *buslinie)
		{
                	list<CPunkt*>* arc=0;
			try{arc=new list<CPunkt*>;}
			catch(...)
			{
				cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte eine Arc beim Speichern einer Pflichtlinie nicht anlegen. Speichermangel?"<<endl;
				cerr.flush();
			}

			// hole den Knoten der Haltestelle:
			node* endknoten=startknoten;
			startknoten=holeNodezuHaltestellenID(einehaltestelle, wegenetzgraph);
			// suche im Graphen die Kante dazu:
			if((startknoten!=0)&&(endknoten!=0))
			{
				edge* kante=holenKnotenverbindung((GRAPH<void*, void*>*) wegenetzgraph, startknoten, endknoten);
				if(kante==0) kante=holenKnotenverbindung((GRAPH<void*, void*>*) wegenetzgraph, endknoten, startknoten);
				if(kante!=0)
				{
					// Kante gefunden, jetzt die Linie an der kante durchlaufen...
					CPunkt* punktderlinie=0;
					forall(punktderlinie, *((wegenetzgraph->inf(*kante))->holenKantenListe()))
					{
						// ... und jeden Punkt in die Arc reinwerfen
						double x=punktderlinie->holenX();
						double y=punktderlinie->holenY();
						CPunkt* koordinaten=0;
						try{koordinaten=new CPunkt(x,y);}
						catch(...)
						{
							cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte einen Punkt beim Speichern einer Pflichtlinie nicht anlegen. Speichermangel?"<<endl;
							cerr.flush();
						}
						arc->append(koordinaten);	
					}
				}		
			}
	                // die Linien zwischen den beiden Punkten als neue Arc in die Liste aller Arcs einfuegen:
			listevonarcs->append(arc);       // fuer den einzelnen Layer
		}  // ENDE: alle Knoten einer Linie durchlaufen

        	// Linie die zu der arc gehoeren auf Layer speichern
		char ll[50]; 
		sprintf(ll, "pflichtlinie_%d", nummer);
		speichernVectorlayer(ll, listevonarcs);
		
		// aufraeumen:
		list<CPunkt*>* aussen;
		forall(aussen, *listevonarcs)
		{
			CPunkt* innen;
			forall(innen, *aussen)
			{
				delete innen;
			}
			delete aussen;
		}
		delete listevonarcs;

	} // ENDIF: Abfrage, ob reinkommende Werte OK
	else cerr<<"Fehler: Konnte Pflichtlinien nicht speichern, da kein Objekt uebergeben wurde"<<endl;
}

void CGRASSSchnittstelle::speichernRoute(GRAPH<CWegenetzKnoten*, CWegenetzKante*>* wegenetzgraph=0, list<int>* buslinie=0)
{
	
        Debug(2, "speichernRoute");
	if((wegenetzgraph!=0)&&(buslinie!=0))
	{
		list<list<CPunkt*>*>* arcsallerbuslinien=0;
		try{arcsallerbuslinien=new list<list<CPunkt*>*>;} // Hierin speichern wir alle Arcs fuer den globalen Linienlayer
		catch(...)
		{
			cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte die Liste aller Buslinien beim Speichern einer Route nicht anlegen. Speichermangel?"<<endl;
			cerr.flush();
		}

		int durchlauf=0;

		list<list<CPunkt*>*>* listevonarcs=0;
		try{listevonarcs=new list<list<CPunkt*>*>;}
		catch(...)
		{
			cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte die Liste aller Arcs beim Speichern einer Route nicht anlegen. Speichermangel?"<<endl;
			cerr.flush();
		}

		// hier haben wir jetzt eine Linie, durchlaufe alle Knoten:
		int einehaltestelle=-1;
		node* startknoten=0;
		forall(einehaltestelle, *buslinie)
		{
                	list<CPunkt*>* arc=0;
			try{arc=new list<CPunkt*>;}
			catch(...)
			{
				cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte eine Arc beim Speichern einer Route nicht anlegen. Speichermangel?"<<endl;
				cerr.flush();
			}

			// hole den Knoten der Haltestelle:
			node* endknoten=startknoten;
			startknoten=holeNodezuHaltestellenID(einehaltestelle, wegenetzgraph);
			// suche im Graphen die Kante dazu:
			if((startknoten!=0)&&(endknoten!=0))
			{
				edge* kante=holenKnotenverbindung((GRAPH<void*, void*>*) wegenetzgraph, startknoten, endknoten);
				if(kante==0) kante=holenKnotenverbindung((GRAPH<void*, void*>*) wegenetzgraph, endknoten, startknoten);
				if(kante!=0)
				{
					// Kante gefunden, jetzt die Linie an der kante durchlaufen...
					CPunkt* punktderlinie=0;
					forall(punktderlinie, *((wegenetzgraph->inf(*kante))->holenKantenListe()))
					{
						// ... und jeden Punkt in die Arc reinwerfen
						double x=punktderlinie->holenX();
						double y=punktderlinie->holenY();
						CPunkt* koordinaten=0;
						try{koordinaten=new CPunkt(x,y);}
						catch(...)
						{
							cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte einen Punkt beim Speichern einer Route nicht anlegen. Speichermangel?"<<endl;
							cerr.flush();
						}
						arc->append(koordinaten);	
					}
				}		
			}
	                // die Linien zwischen den beiden Punkten als neue Arc in die Liste aller Arcs einfuegen:
			listevonarcs->append(arc);       // fuer den einzelnen Layer
		}  // ENDE: alle Knoten einer Linie durchlaufen

        	// Linie die zu der arc gehoeren auf Layer speichern
		speichernVectorlayer("route", listevonarcs);
		
		// aufraeumen:
		list<CPunkt*>* aussen;
		forall(aussen, *listevonarcs)
		{
			CPunkt* innen;
			forall(innen, *aussen)
			{
				delete innen;
			}
			delete aussen;
		}
		delete listevonarcs;

	} // ENDIF: Abfrage, ob reinkommende Werte OK
	else cerr<<"Fehler: Konnte Route nicht speichern, da kein Objekt uebergeben wurde"<<endl;
}

// Zusammenhangskomponenten-array: 1.HS, 2.HS, Linien ID
void CGRASSSchnittstelle::speichernZusammenhangskomponenten(GRAPH<CWegenetzKnoten*, CWegenetzKante*>* wegenetzgraph, array<list<three_tuple<int,int,int>* >* >* zusammenhangskomponenten)
{
	Debug(2, "speichernZusammenhangskomponenten");
	if((wegenetzgraph!=0)&&(zusammenhangskomponenten!=0))
	{
        	// ersteinmal ein paar Strukturen anlegen, um auf GRASS zugreifen zu koennen
//		struct Map_info map;		// Zugriff auf die Karte
		struct line_pnts* Points;	// Zugriff auf die einzelenen Linien (hier sind das die Arcs!!!)

                // Fuer jede Zusammenhangskomponente: durchlaufe alle Kanten, hole die Kante aus den Wegenetzgraphen,
		// hole alles, was an der Kante steht, wandle dies in eine Arc um und schiebe die auf den entsprechenden
		// Layer
//		Debug(2, "Anzahl Zusammenhangskomponenten: "<<zusammenhangskomponenten->size());

		CFortschritt* fortschritt=0;
		if(batchbetrieb==false) 
		{
			try{fortschritt=new CFortschritt("Speichern Zusammenhangskomponenten");}
			catch(...)
			{
				cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte die Fortschrittsanzeige beim Speichern der Zusammenhangskomponenten nicht anlegen. Speichermangel?"<<endl;
				cerr.flush();
			}
		}
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Speichere die Zusammenhangskomponenten in GRASS...");
		int durchlauf=0;

                for(int i=0; i<zusammenhangskomponenten->size(); i++)
		{
//                      Debug(2, "Durchlauf: "<<i);
			
			if(fortschritt!=0) fortschritt->anzeigenFortschritt(i, zusammenhangskomponenten->size());
			
			char ll[100]; // ersatz fuer linienlayer
			sprintf(ll, "zusammenhangskomponente_%d", i);
			// Karte

			list<list<CPunkt*>*>* allearcs=0;
			try{allearcs=new list<list<CPunkt*>*>;} // speichert alle Lineinzuege einer Zusammenhangskomponente
			catch(...)
			{
				cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte die Liste aller Linienzuege einer Zusammenhangskomponente nicht anlegen. Speichermangel?"<<endl;
				cerr.flush();
			}
			

//			Debug(2, "Durchlaufe alle Knotenverbindungen der Zusammenahngskomponente:");
			// hole eine Liste:
			list<three_tuple<int,int,int>*>* komponente=(*zusammenhangskomponenten)[i];
			three_tuple<int,int,int>* ein_eintrag;
                        forall(ein_eintrag, *komponente)
			{
				list<CPunkt*>* arc=0;
				try{arc=new list<CPunkt*>;}   // Temporaere Arc, wird spaeter in eine GRASS-Arc umgebaut
				catch(...)
				{
					cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte eine Arc beim Speichern der Zusammenhangskomponenten nicht anlegen. Speichermangel?"<<endl;
					cerr.flush();
				}

//                              Debug(2, "Innere For-Schleife");
				// hole jetzt die beiden Knoten
				int starths, endhs;
                                starths=ein_eintrag->first();
				endhs=ein_eintrag->second();
				// Jetzt im Graphen nach der entsprechenden Kante suchen:
				// dazu erstmal die Knoten aus dem Graph selektieren:
				node knoten;
				node* startKnoten=0;
				node* endKnoten=0;
				forall_nodes(knoten, *wegenetzgraph)
				{
					if( (wegenetzgraph->inf(knoten))->holenKnotenId() == starths ) 
					{
						try{startKnoten=new node(knoten);}
						catch(...)
						{
							cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte einen Startknoten beim Speichern einer Zusammenhangskomponente nicht anlegen. Speichermangel?"<<endl;
							cerr.flush();
						}
					}
					if( (wegenetzgraph->inf(knoten))->holenKnotenId() == endhs ) 
					{
						try{endKnoten=new node(knoten);}
						catch(...)
						{
							cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte einen Endknoten beim Speichern einer Zusammenhangskompoennte nicht anlegen. Speichermangel?"<<endl;
							cerr.flush();
						}
					}
				}
				// jetzt die Kante aus dem Graph selektieren:
                                edge* kante=0;
				if((startKnoten!=0)&&(endKnoten!=0)) 
				{
					// hier wissen wir: der Start- und Endknoten existiert im Wegenetzgraph

					kante=holenKnotenverbindung((GRAPH<void*, void*>*) wegenetzgraph, startKnoten, endKnoten);
                	                if(kante!=0)
					{
//						Debug(2, "----> An der Kante stehen: "<<(wegenetzgraph->inf(wegenetzgraph->source(*kante)))->holenKnotenId()<<", "<<(wegenetzgraph->inf(wegenetzgraph->target(*kante)))->holenKnotenId());
						// hier haben wir alle Punkte, die an der Kante stehen, also koennen
						// wir die in unsere Arc schieben:	
						CPunkt* einknotenpunkt=0;
						try{einknotenpunkt=new CPunkt();}
						catch(...)
						{
							cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte einen Punkt beim Speichern einer Zusammenhangskomponente nicht anlegen. Speichermangel?"<<endl;							
							cerr.flush();
						}
						list<CPunkt*>* eineknotenpunktliste=(wegenetzgraph->inf(*kante))->holenKantenListe();
						forall(einknotenpunkt, *eineknotenpunktliste)
						{
							arc->append(einknotenpunkt);
						}
					}
					else 
					{
						// Da holenKnotenverbindung auf einem GRAPH arbeitet, versuchen
						// wir einfach nochmal die andere Richtung:
				        	kante= holenKnotenverbindung((GRAPH<void*, void*>*) wegenetzgraph, endKnoten, startKnoten);
	                                	if(kante!=0)
						{
//							Debug(2, "----> An der Kante stehen: "<<(wegenetzgraph->inf(wegenetzgraph->source(*kante)))->holenKnotenId()<<", "<<(wegenetzgraph->inf(wegenetzgraph->target(*kante)))->holenKnotenId());
							// Schiebe alle Punkte, die auf der Kante liegen raus:
							CPunkt* einknotenpunkt=0;
							try{einknotenpunkt=new CPunkt();}
							catch(...)
							{
								cerr<<"GRASS: "<<__LINE__<<": "<<"FEHLER: Konnte einen Punkt beim Speichern einer Zusammenhangskomponente nicht anlegen. Speichermangel?"<<endl;
								cerr.flush();
							}
							list<CPunkt*>* eineknotenpunktliste=(wegenetzgraph->inf(*kante))->holenKantenListe();
							eineknotenpunktliste->reverse();
							forall(einknotenpunkt, *eineknotenpunktliste)
							{
								arc->append(einknotenpunkt);
							}
						 	eineknotenpunktliste->reverse();
						}
						else
						{
							// Jetzt existiert die Kante wirklich nicht
							cerr<<"CGRASSSchnittstelle: Zusammenhangskomponenten: FEHLER: Es existiert keine physische Verbindung zwischen zwei Haltestellen"<<endl;
							cerr<<"Dies sind die Knoten:"<<(wegenetzgraph->inf(*startKnoten))->holenKnotenId()<<", "<<(wegenetzgraph->inf(*endKnoten))->holenKnotenId()<<endl;
						}
					}

				}// endif: pruefe, ob Knoten im Graphen exisiteren
				else 
				{
					if(startKnoten==0) cerr<<"CGRASSSchnittstelle: Zusammenhangskomponenten: FEHLER: Der Knoten "<<starths<<" existiert nicht!"<<endl;
					if(endKnoten==0) cerr<<"CGRASSSchnittstelle: Zusammenhangskomponenten: FEHLER: Der Knoten "<<endhs<<" existiert nicht!"<<endl;									
				}
				
//				Debug(2, "ENDE Eintrag");

				allearcs->append(arc);
			}
			speichernVectorlayer(ll, allearcs);

			// und aufraeumen:
			list<CPunkt*>* listterminator;
			forall(listterminator, *allearcs)
			{
				CPunkt* terminator;
				forall(terminator, *listterminator)
				{
					delete terminator;
				}
				delete listterminator;
			}
			delete allearcs; 
		}
                if(fortschritt!=0) delete fortschritt;
        } // if
	else cerr<<"GRASS: Fehler: Konnte Zusammenhangskomponente nicht speichern, da kein Objekt uebergeben wurde"<<endl;
//        Debug(2, "ENDE SpeichernZusammenhangskomponenten");
}

void CGRASSSchnittstelle::speichernAusschnittStrassennetz(list<list<CPunkt*>*>* listevonarcs=0)
{
	speichernVectorlayer("ausschnitt_strassennetz", listevonarcs);
}
