/* Generated by Together */

#ifndef CGRASSSCHNITTSTELLE_H
#define CGRASSSCHNITTSTELLE_H

#include "../Datenstruktur/define.h"

#include "CFortschritt.h"

#include "LEDA/list.h"
#include "LEDA/matrix.h"
#include "LEDA/integer_matrix.h"
#include "LEDA/tuple.h"
#include "LEDA/array.h"
#include "LEDA/h_array.h"
#include "LEDA/ugraph.h"

#include "CPunkt.h"
#include "CKnoten.h"
#include "../Datenstruktur/Debug.h"

// GRASS-Kram reinholen
#include <stdio.h>
#include <stdlib.h>
#include "gis.h"
#include "Vect.h"
#include "site.h"


#include "../Datenstruktur/CFPlanGraphKnoten.h"
#include "../Datenstruktur/CFPlanGraphKante.h"
#include "../Datenstruktur/CWegenetzKnoten.h"
#include "../Datenstruktur/CWegenetzKante.h"
#include "../Datenstruktur/CLinie.h"
#include "../Datenstruktur/CLeda.h"


/**
 * Stellt NUR die Verbindung von den Schnittstellen zu GRASS her. Alle anderen Zugriffe auf GRASS erfolgen direkt ueber die GUI.
 */
class CGRASSSchnittstelle {
    protected:
        	bool batchbetrieb; // gibt an, ob Fenster hochgepoppt werden duerfen
	
		// Hilfsmethode: speichert einen VectorLayer mit namen "dasteiname" und dem Inhalt "arc"
		// Rueckgabewert: Fehlercode
		int speichernVectorlayer(char* , list<list<CPunkt*>*>* );
		// Hilfsmethode: speichert einen SitesLayer mit namen "dasteiname" und dem Inhalt "haltestellen"
		// Rueckgabewert: Fehlercode
		int speichernSiteslayer(char*, list<CPunkt*>*);
		// Hilfsmethode: holt einen SitesLayer mit namen "dasteiname" und gibt eine Liste mit den Punkten wieder raus
		list<CPunkt*>* holenSiteslayer(char*);
		// Hilfsmethode: holt aus dem wegenetzgraph den Knoten, der die ID "id" traegt
		// Rucekgabewert: Zieger auf den entsprechenden Knoten
		node* holeNodezuHaltestellenID(int id, GRAPH<CWegenetzKnoten*, CWegenetzKante*>* wegenetzgraph);
    public:
            /**
	     *  Konstruktor, Destruktor
	     */
	    CGRASSSchnittstelle(bool bbetrieb=false);
	    ~CGRASSSchnittstelle();


	    list<list<CPunkt*>*>* holenStadtplan(void );
	    list<list<CPunkt*>*>* holenGebaeude(void);
	    list<list<CPunkt*>*>* holenWege(void);
            list<CPunkt*>* holenHaltestellen(); // wird zum zusammenbauen der Graphen benoetigt
	    list<CPunkt*>* holenPflichthaltestellen();

	    /**
	     * die folgende Funktion ist dafuer zustaendig, die Testdaten
             * bzw. die Ausgangsdaten des Haltestellen-Moduls in GRASS zu speichern
             */
            void speichernAusschnittStrassennetz(list<list<CPunkt*>*>*);

            /**
	     * die folgende Funktion ist dafuer zustaendig, die vom
             * Haltestellen-Modul zurueckgegebenen Haltestellen in GRASS
             */
            void speichernHaltestellen(list<CPunkt*>*);

	    /**
	     * die folgende Funktion ist dafuer zustaendig, die Pflichthaltestellen
             * aus der DB wieder auf den zugehoerigen Layer zu schieben
             */
            void speichernPflichthaltestellen(list<CPunkt*>*);
        

            /**
	     * die folgende Funktion ist dafuer zustaendig, den vom
             * Haltestellen-Modul zurueckgegebenen Strassenplan in GRASS
             * zu speichern. Der Strassenplan enthaellt die Strassen, ueber
             * die die Busse spaeter fahren koennen.
             */
            void speichernStrassenplan(GRAPH<CWegenetzKnoten*, CWegenetzKante*>*);

	    /**
	     * die folgende Funktion ist dafuer zustaendig, den vom
             * Linienplan-Modul zurueckgegebenen Linienplan in GRASS
             * zu speichern. Der Linienplan enthaellt alle Buslinien
	     * Eingabe: den Wegenetzgraph um die Linienwege zu bekommen mit ihren
	     *          Koordinaten, sowie eine Liste mit den Buslinien
             */
	    void speichernLinienplan(GRAPH<CWegenetzKnoten*, CWegenetzKante*>*, list<CLinie*>*);

	   /**
	     * die folgende Funktion ist dafuer zustaendig, die von der GUI durchgereichten Pflichtlinien
             * in GRASS zu speichern. Der Linienplan erhaellt dann alle diese Pflichtlinien als Eingabe
	     * Eingabe: den Wegenetzgraph um die Linienwege zu bekommen mit ihren
	     *          Koordinaten, sowie eine Liste mit den Pflicht-Buslinien
             */
	    void speichernPflichtlinien(GRAPH<CWegenetzKnoten*, CWegenetzKante*>*, list<CLinie*>*);
	    /**
	     * die folgende Funktion ist dafuer zustaendig, EINE von der GUI durchgereichte Pflichtlinie
             * in GRASS zu speichern. 
	     * Eingabe: den Wegenetzgraph um die Linienwege zu bekommen mit ihren
	     *          Koordinaten, sowie eine Liste mit den Haltestellen der Pflicht-Buslinie nebst Nummer dieser Linie
             */
	    void speichernEinePflichtlinie(GRAPH<CWegenetzKnoten*, CWegenetzKante*>*, list<int>*, int);
	   /**
	     * die folgende Funktion ist dafuer zustaendig, eine Route, die von der GUI kommt zu speichern
             * in GRASS zu speichern. 
	     * Eingabe: den Wegenetzgraph um die Linienwege zu bekommen mit ihren
	     *          Koordinaten, sowie eine Liste mit den Haltestellen der Route
             */
	    void speichernRoute(GRAPH<CWegenetzKnoten*, CWegenetzKante*>*, list<int>*);

	   /**
	    * die folgende Funktion ist dafuer Zustaendig, die vom
	    * Fahrplan zurueck gegebenen Zusammenhangskomponenten anzuzeigen
	    * Eingabe: der Wegenetzgraph, um die Koordinaten heraus zu finden
	    *          Ein Array, in dem in jeder Liste eine Zusammenhangskomponente liegt.
	    */
	   void speichernZusammenhangskomponenten(GRAPH<CWegenetzKnoten*, CWegenetzKante*>*, array<list<three_tuple<int,int,int>* >* >*);
};
#endif //CGRASSSCHNITTSTELLE_H