/* Generated by Together */

// Implementierung: Tim Schuermann

#ifndef CGUISCHNITTSTELLE_H
#define CGUISCHNITTSTELLE_H

#include "LEDA/graph.h"
#include "LEDA/list.h"
#include "LEDA/matrix.h"
#include "LEDA/integer_matrix.h"
#include "LEDA/tuple.h"
#include "LEDA/array.h"
#include "LEDA/h_array.h"
#include "LEDA/ugraph.h"

#include "CSchnittstelle.h"
#include "CDatenbank.h"
#include "CGuetemasse.h"
//#include "CGuetemasseLinienplan.h"


/**
 * Diese Schnittstelle ermoeglicht der GUI den Zugriff auf die Datenbank und die Kontrolle (z.B: Stop von Threads) . 
 */
class CGUISchnittstelle : public CSchnittstelle {
    public:

	  CGUISchnittstelle(CDatenbank*);

        // die folgende Funktion holt die aktuelle Guetemassklasse aus der Datenbank
	CGuetemasse* holenGuetemasse();
	void speichernGuetemasse(CGuetemasse* guetemasse);


	// Haltestellen: ------------------------------------------------------------------------------------------------------
	// speichert die vom Benutzer eingegebenen Startwerte  
	void speichernHaltestellenModulParameter(int aufruf, int algorithmus, int zufallsgeneratorInitialisierung,
							double minRadius, double maxRadius, double verbindungsRadiusStadt,
							double verbindungsRadiusLand, int radiustyp, double haltestellenLage,
							double toleranzgrenze, int bevoelkerungsRaster, double koeffizientBevoelkerungsueberversorgung,
							double koeffizientBevoelkerungsunterversorgung, double koeffizientFlaechenueberversorgung,
							double koeffizientFlaechenunterversorgung, double koeffizientFahrtwunscheinbeziehung,
							double koeffizientStrassenanpassung,
							int AnzahlHaltestellen, bool AnzStrassenkarte,
							bool AnzBevoelkerungsversorgung, bool AnzFlaechenversorgung, bool Anzkomplettunterdruecken,
							int Strategie, int AnzahlEltern, int AnzahlKinder, int Generationen, 
							bool AbbruchGueteunterschreitung, double GrenzwGueteunterschreitung);
	// holt die Startwerte der Haltestellen:
	void holenHaltestellenModulParameter(int aufruf, int& algorithmus, int& zufallsgeneratorInitialisierung,
							double& minRadius, double& maxRadius, double& verbindungsRadiusStadt,
							double& verbindungsRadiusLand, int& radiustyp, double& haltestellenLage,
							double& toleranzgrenze, int& bevoelkerungsRaster, double& koeffizientBevoelkerungsueberversorgung,
							double& koeffizientBevoelkerungsunterversorgung, double& koeffizientFlaechenueberversorgung,
							double& koeffizientFlaechenunterversorgung, double& koeffizientFahrtwunscheinbeziehung,
							double& koeffizientStrassenanpassung,
							int& AnzahlHaltestellen, bool& AnzStrassenkarte,
							bool& AnzBevoelkerungsversorgung, bool& AnzFlaechenversorgung, bool& Anzkomplettunterdruecken,
							int& Strategie, int& AnzahlEltern, int& AnzahlKinder, int& Generationen, 
							bool& AbbruchGueteunterschreitung, double& GrenzwGueteunterschreitung);
        // speichert die von der GUI importierte Bevoelkerungsdichte
	void speichernBevoelkerungsDichte(list<CBevoelkerungsdichteElement*>*);
	// Speichert die von der GUI importierte Quelle-Ziel-Matrix plus deren zugehoerige Liste
	void speichernUrsprungsQZMatrix(matrix* quelleZielMatrix, list<CQuelleZielListeElement*>* quelleZielListe);
	// Speichert die von der GUI importierte Pendlermatrix plus deren zugehoerige Liste
	void speichernPendlermatrix(matrix* pendlerMatrix, list<CPendlerListeElement*>* pendlerListe);

         

        // Linienplan: --------------------------------------------------------------------------------------------------------
        // speichert die vom Benutzer eingegebenen Startwerte:
	void speichernLinienplanModulParameter(int aufruf, int gesamtlaenge, int maxLinienLaenge, 
							int maxLinienAnzahl, double linienplanID,
							int geschwindigkeit=15, int algorithmus=0, int anzeigegraphen=0,
							bool EindeutigeLinienverkn=false, bool MehrdeutigeLinienverkn=false, 
							bool Aufbruchsverknuepfung=false, bool Linienendverknuepfung=false,
							bool Basislinienwahl=false);
	// holt die Startwerte des Linienplans:
	void holenLinienplanModulParameter(int aufruf, int& gesamtlaenge, int& maxLinienLaenge, 
							int& maxLinienAnzahl, double& linienplanID,
							int& geschwindigkeit, int& algorithmus, int& anzeigegraphen,
							bool& EindeutigeLinienverkn, bool& MehrdeutigeLinienverkn, 
							bool& Aufbruchsverknuepfung, bool& Linienendverknuepfung,
							bool& Basislinienwahl);

	// vorgegebenen Linien:
	void speichernPflichtlinienDatenbank(list<CLinie*>* pflichtlinien); // speichert alle Pflichtlinien in Oracle 
	void speichernPflichtlinienGRASS(list<CLinie*>* pflichtlinien); // speichert alle Pflichtlinien in GRASS
	void speichernEinePflichtlinie(list<int>* pflichtlinie, int id);  // speichert genau eine Pflichtlinie mit der ID "id" in GRASS
	list<CLinie*>* holenPflichtlinien(); // holt die Pflichtlinien aus Oracle
	
	

        // Fahrplan: --------------------------------------------------------------------------------------------------------
	four_tuple<int,int,int,int>* fahrplanIntervall(); // holt aus der Datenbank das Fahrplanintervall
	// holt aus der Datenbank die Mindestumsteigezeit
   	h_array<int,list<three_tuple<int,int,int>* >*>* fahrplanMindestumsteigezeit(); 
	// holt aus der Datenbank die Mindesthaltezeit
	h_array<int,int>* fahrplanMindesthaltezeit(); 
	// speichert die Mindestumsteigezeit
        void speichernFahrplanMindestumsteigezeit(h_array<int,list<three_tuple<int,int,int>* >*>*); 
	// speichert die Mindesthaltezeit:
	void speichernFahrplanMindesthaltezeit(h_array<int,int>*);
	array<three_tuple<int,int,int>* >* fahrplanAbfahrtszeiten(); // holt aus der Datenbank die Abfahrtszeiten
	int fahrplanMaximaleFahrzeuganzahl(); // holt aus der Datenbank die max. Fahrzeuganzahl
        list<four_tuple<int,int,int,int>* >* fahrplanDirekterAnschluss(); // holt aus der Datenbank den direkten Anschluss
	// holt aus der Datenbank die Guetemasse des Fahrplans (Ausgangsloesung)
	void holenAusgangsloesung(double& summeNetzbedingteWartezeiten, double& wartezeitAufwand,
	   					double& mindestWartezeitAufwand, double& gesamtWarteaufwand);
	// holt aus der Datenbank die Anzahl der benoetigten Fahrzeuge (Fahrplanergebnis)
	void holenAnzahlFahrzeuge(int& anzahlFahrzeuge);
	// Diese Methode gibt eine Liste des Fahrplans aus, 
	// Liste ist geordnet nach: HaltestellenID, LinienID, AbfahrtszeitStd, AbfahrtszeitMin
	list<CFahrplanElement*>* holenFahrplanHaltestellen();
	// Diese Methode gibt eine Liste des Fahrplans aus,
	// Die Liste ist geordnet nach: LinienID, HaltestellenID, AbfahrtszeitStd, AbfahrtszeitMin
	list<CFahrplanElement*>* holenFahrplanLinien();
	// speichert alle Parameter von der GUI
	void speichernFahrplanModulParameter(int maxfahrzeuganzahl, int allgemeinertakt, int mindesthaltezeit, int mindestumsteigezeit);
        // holt alle Parameter aus der Datenbank
        void holenFahrplanModulParameter(int& maxfahrzeuganzahl, int& allgemeinertakt, int& mindesthaltezeit, int& mindestumsteigezeit);
	

        
	// GUI: -------------------------------------------------------------------------------------------------------------
	// holt die Haltestellen ID zu den Koordinaten der Haltestelle
	int holenKnotenID(double, double);
	// holt die Koordinten zu einer Haltestellen ID (liefert NULL, wenn ID nicht existiert)
	CPunkt* holenKnotenKoordinaten(int);
	// holt die LinienIDs, die ueber eine Haltestelle laufen
  	list<int>* holenLinienID(int);
	// liefert zu einer Haltestellen ID alle anderen Haltestellen, die von der uebergebenen
	// Haltestelle im Wegenetzgraphen erreichbar sind
	list<int>* holenMoeglicheZielHaltestellen(int);
	// holt eine Zusammenhangskomponente zu einer Haltestelle und zwei Linien
	int holenZusammenhangsKomponentenID(int,int); //Parameter: Haltestelle, Linie1, Linie2
        // holt alle eingehenden Linien in eine Haltestelle (als ID uebergeben)
	list<int>* holenEingehendeLinien(int); 
	// hole alle ausgehenden Linien aus einer Haltestelle (als ID uebergeben)
  	list<int>* holenAusgehendeLinien(int);
	// holt alle Haltestellen, ueber die die Linie mit der linienid fuehrt
	list<int>* holenLinienHaltestellen(int linienid); 	
	// diese Funktion speichert einen Teil des Strassennetzes in einem eigenen Layer
	// hiermit wird der Strassenplan in den einzelnen Testfaellen zu Anzeige abgespeichert
        void speichernAusschnittStrassennetz();
	// loesche die Buslinie mit der ID id:
	void loeschenLinie(int id);
	// gibt die kuerzeste Verbindung zw. zwei HS aus; WICHTIG: prueft nicht, ob FP schon durchgelaufen ist!
	CReisebewertung* routenplanung(int starths, int endhs);
        

	// Versionierung: ---------------------------------------------------------------------------------------------------
	void setzenAktuelleProjektID(int id); // hiermit wird ein Projekt ausgewaehlt
	int holenAktuelleProjektID(); // gibt die ID des aktuellen Projektes zurueck
	void setztenPhase(int phase); // speichert den Schritt ab, indem sich der Benutzer im aktuellen Projekt gerade befindet
	int holenPhase();	// liefert den Schritt, indem sich der Benutzer gerade befindet.
	int anlegenNeuesProjekt(int id, char* beschreibung, int phase); // legt ein neues Projekt an, liefert die gespeicherte ID zurueck
	void holenProjektInformationen(int id, char*& beschreibung, int& phase); // holt die Informationen des Projektes mit der ID "id"
	list<two_tuple<int,char*>*>* holenAlleProjektInformationen(); // liefert die Informationen aller Projekte zurueck (gibt die ganze Projekttabelle aus)
	int holenAnzahlProjekte(); // gibt die Anzahl der in Oracle gespeicherten Projekte zurueck
	int holenErsteFreieProjektID(); // holt die erste Projekt-ID, die noch von keinem Projekt belegt wurde
	void loeschenProjekt(int id); // loescht das Projekt mit der ID "id"
	int kopierenProjekt(int quellid, int zielid, char* beschreibung=0); // kopiert das Projekt mit der ID "quellid" in das Projekt mit der ID "zielid", liefert die ID des Zielprojektes zuerueck
        	// Datenaustausch-User Funktionen (mit ihnen koennen Daten Gruppenuebergreifend ausgetauscht werden)
  	int anlegenNeuesProjektPG369(int id, char* beschreibung, int phase); // legt ein neues Projekt im Datenaustausch-Users an, liefert die gespeicherte ID zurueck
	void holenProjektInformationenPG369(int id, char*& beschreibung, int& phase); // holt die Informationen des Projektes mit der ID "id" des Datenaustausch-Users
  	list<two_tuple<int,char*>*>* holenAlleProjektInformationenPG369(); // liefert die Informationen aller Projekte des Datenaustausch-Users zurueck (gibt die ganze Projekttabelle aus)
  	void loeschenProjektPG369(int id); // loescht das Projekt mit der ID "id" im Datenaustausch-Users
	int holenErsteFreieProjektIDPG369(); // holt die erste Projekt-ID, die noch von keinem Projekt belegt wurde bim Datenaustausch-User
  	int kopierenProjektVonPG369(int quellid, int zielid, char* beschreibung=0); // kopiert das Projekt mit der ID "quellid" des Datenaustausch-Users pg369 in das Projekt mit der ID "zielid", liefert die ID des Zielprojektes zuerueck
  	int kopierenProjektNachPG369(int quellid, int zielid, char* beschreibung=0); // kopiert das Projekt mit der ID "quellid" in das Projekt mit der ID "zielid" des Datenaustauschusers pg369, liefert die ID des Zielprojektes zuerueck

	void speichernPflichthaltestellen(); // speichert die Koordinaten der Pflichthaltestellen in Oracle  
	void holenPflichthaltestellen(); // holt die Pflichthaltestellen wieder aus der DB und schreibt sie in GRASS
	void speichernAusschnitt(double links, double oben, double rechts, double unten); // speichert die Abmessungen des zu beruecksichtigenden Ausschnitts
	void holenAusschnitt(double& links, double& oben, double& rechts, double& unten); // holt die Abmessungen des zu beruecksichtigendesn Ausschnitts
        void aktuallisierenAnzeigen(int phase); // nach dem Wechsel eines Projektes stellt dies wieder alle Anzeigen in GRASS her


	// sonstige Aufrufe (nicht mehr benoetigt?): ------------------------------------------------------------------------
	/**
	  * Diese Funktion wird vom verbundenen GUIObjekt aufgerufen,
          * das seine berechneten Werte in der entsprechenden Datenstruktur
          * zurueckgibt. Diese Funktion leitet die ihr uebergebenen Werte an
          * die entsprechenden Stellen zur Speicherung bzw. zur Anzeige weiter
          */
        void guiErgebnisrueckgabe();
};
#endif //CGUISCHNITTSTELLE_H
