/* Generated by Together */

#include <fstream.h>
#include "CHSSchnittstelle.h"
#include "CGUI.h"

CHSSchnittstelle::CHSSchnittstelle(CDatenbank* datenbank, CGUI* gui) : CSchnittstelleMitGUI(datenbank, gui)
{}

void CHSSchnittstelle::haltestellenErgebnisrueckgabe(GRAPH<CWegenetzKnoten *, CWegenetzKante * >* wgraph, matrix* verkehrsBedarfsMatrix)
{
	lnkCDatenbank->speichernDaten(wgraph, verkehrsBedarfsMatrix);
	//if(lnkCGUI!=0) lnkCGUI->beendenHaltestellenberechnung(0);
}


CParameterHaltestelle * CHSSchnittstelle::anfordernWerte(void) {
	CParameterHaltestelle * Parameter;
	
	CFortschritt* fortschritt=0;
	if(lnkCGUI!=0)
	{
		try{fortschritt=new CFortschritt("Holen Haltestellendaten");}
		catch(...)
		{
			cerr<<"Schnittstelle: "<<__LINE__<<": "<<"FEHLER: Konnte die Fortschrittsanzeige fuer das Holen der Haltestellendaten nicht anlegen. Speichermangel?"<<endl;
			cerr.flush();
		}
	}
	if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Hole Daten aus der Datenbank... bitte etwas Geduld...");

	int algorithmus, zufallsgeneratorInitialisierung, radiustyp, bevoelkerungsRaster;
	double minRadius, maxRadius,verbindungsRadiusStadt, verbindungsRadiusLand, haltestellenLage, toleranzgrenze;
	double koeffizientBevoelkerungsueberversorgung, koeffizientBevoelkerungsunterversorgung;
	double koeffizientFlaechenueberversorgung, koeffizientFlaechenunterversorgung;
	double koeffizientFahrtwunscheinbeziehung, koeffizientStrassenanpassung;
	int AnzahlHaltestellen;
	bool AnzStrassenkarte, AnzBevoelkerungsversorgung, AnzFlaechenversorgung, Anzkomplettunterdruecken;
	int Strategie, AnzahlEltern, AnzahlKinder, Generationen;
	bool AbbruchGueteunterschreitung; 
	double GrenzwGueteunterschreitung;
        int aufruf=0;                   // ohne Rueckkopplung zum Wegwerfen...
	list<CPunkt*>* pflichtHS;
	list<list<CPunkt*>*>* strassennetz;
	list<list<CPunkt*>*>* wege;
	list<CBevoelkerungsdichteElement*>* dichte;
	matrix* quelleZielMatrix;
	list<CQuelleZielListeElement*>* quelleZielListe;
	matrix* pendlerMatrix;
	list<CPendlerListeElement*>* pendlerListe;
	list<list<CPunkt*>*>* gebaeude;
	
        // Initialisiere die Matrizen mit NULL (noetig um zwischen Testdaten und realen Daten
	// zu unterscheiden):
	quelleZielMatrix=NULL;
	pendlerMatrix=NULL;	
	
	

	// Hole die Parameter aus der Datenbank
	lnkCDatenbank->holenHaltestellenModulParameter(aufruf, algorithmus, zufallsgeneratorInitialisierung, minRadius, maxRadius, verbindungsRadiusStadt,
							verbindungsRadiusLand, radiustyp,haltestellenLage, toleranzgrenze, bevoelkerungsRaster,koeffizientBevoelkerungsueberversorgung,
							koeffizientBevoelkerungsunterversorgung, koeffizientFlaechenueberversorgung,
							koeffizientFlaechenunterversorgung, koeffizientFahrtwunscheinbeziehung,
							koeffizientStrassenanpassung,
							AnzahlHaltestellen,AnzStrassenkarte,
							AnzBevoelkerungsversorgung,AnzFlaechenversorgung, Anzkomplettunterdruecken,
							Strategie, AnzahlEltern, AnzahlKinder, Generationen, 
							AbbruchGueteunterschreitung, GrenzwGueteunterschreitung);

	if(fortschritt!=0) fortschritt->anzeigenFortschritt(1, 2);

	//Alles aus der Datenbank
	lnkCDatenbank->holenDaten(pflichtHS, strassennetz, wege, dichte, quelleZielMatrix,
		quelleZielListe, pendlerMatrix, pendlerListe, gebaeude);

	if(fortschritt!=0) fortschritt->anzeigenFortschritt(2, 2);

	//und die QuelleZielMatrix und die QuelleZielListe kommen aus der GUI:
	if((quelleZielMatrix==0)&&(lnkCGUI!=NULL)) lnkCGUI->holenDaten(quelleZielMatrix, quelleZielListe);

	//und die PendlerMatrix und die Pendlerliste kommen aus der GUI:
	if((pendlerMatrix==0)&&(lnkCGUI!=NULL)) lnkCGUI->holenDaten(pendlerMatrix,pendlerListe);
//	cout << strassennetz << endl;cout.flush();
	try{Parameter = new CParameterHaltestelle(strassennetz,pflichtHS,wege, dichte,quelleZielMatrix,quelleZielListe,pendlerMatrix,pendlerListe, gebaeude);}
	catch(...)
	{
		cerr<<"Schnittstelle: "<<__LINE__<<": "<<"FEHLER: Die Parameter der Haltestellen konnten nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}
	Parameter->setzenMinimalesEinzugsgebiet(minRadius);
	Parameter->setzenMaximalesEinzugsgebiet(maxRadius);
	Parameter->setzenToleranzgrenze(toleranzgrenze);
	Parameter->setzenVerbindungsradius(verbindungsRadiusStadt);
	Parameter->setzenAlgorithmustyp(TAlgorithmus(algorithmus));
	Parameter->setzenZufallszahlengeneratorinitialisierung(zufallsgeneratorInitialisierung);
	Parameter->setzenRadiustyp(TRadius(radiustyp));
	Parameter->setzenHaltestellenlage(haltestellenLage);
	Parameter->setzenToleranzgrenze(toleranzgrenze);
	Parameter->setzenBevoelkerungsrasterEinheiten(bevoelkerungsRaster);
	Parameter->setzenKoeffizientBevoelkerungsueberversorgung(koeffizientBevoelkerungsueberversorgung);
	Parameter->setzenKoeffizientBevoelkerungsunterversorgung(koeffizientBevoelkerungsunterversorgung);
	Parameter->setzenKoeffizientFlaechenueberversorgung(koeffizientFlaechenueberversorgung);
	Parameter->setzenKoeffizientFlaechenunterversorgung(koeffizientFlaechenunterversorgung);
	Parameter->setzenKoeffizientFahrtwunscheinbeziehung(koeffizientFahrtwunscheinbeziehung);
	Parameter->setzenKoeffizientStrassenanpassung(koeffizientStrassenanpassung);
	Parameter->setzenAnzahlHaltestellen(AnzahlHaltestellen);
	Parameter->setzenAnzeigenStrassennetz(AnzStrassenkarte);
	Parameter->setzenAnzeigenBevoelkerung(AnzBevoelkerungsversorgung);
	Parameter->setzenAnzeigenFlaeche(AnzFlaechenversorgung);
	Parameter->setzenBatchModus(Anzkomplettunterdruecken);
	Parameter->setzenStrategie(TStrategie(Strategie));
	Parameter->setzenAnzahlEltern(AnzahlEltern);
	Parameter->setzenAnzahlKinder(AnzahlKinder);
	Parameter->setzenAnzahlGenerationen(Generationen);
	Parameter->setzenWerteunterschreitung(AbbruchGueteunterschreitung);
	Parameter->setzenGrenzwert(GrenzwGueteunterschreitung);

	if(lnkCGUI==NULL) Parameter->setzenBatchModus(true);

	if(fortschritt!=0) delete fortschritt;

	return Parameter;
} // anfordernWerte


// die Folgenden beiden Funktionen schieben die vom Haltestellenmodul
// berechneten Guetemasse in die Datenbank
void CHSSchnittstelle::speichernGuetemasse(CGuetemasse * guetemasse)
{
	lnkCDatenbank->speichernGuetemasse(guetemasse);
}

// die folgende Funktion holt eine bereits teilweise gefuellte
// Guetemassklasse, die die Haltestellen ausfuellen
CGuetemasse* CHSSchnittstelle::holenGuetemasse()
{
	return lnkCDatenbank->holenGuetemasse();
}