/* Generated by Together */

#ifndef CHSSCHNITTSTELLE_H
#define CHSSCHNITTSTELLE_H
#include "CSchnittstelleMitGUI.h"

#include "LEDA/matrix.h"
#include "LEDA/list.h"
#include "LEDA/graph.h"

#include "../Datenstruktur/CPunkt.h"
#include "../Datenstruktur/CBevoelkerungsdichteElement.h"
#include "../Datenstruktur/CQuelleZielListeElement.h"
#include "../Datenstruktur/CPendlerListeElement.h"
#include "../Datenstruktur/CWegenetzKnoten.h"
#include "../Datenstruktur/CParameterHaltestelle.h"
#include "../Datenstruktur/CGuetemasse.h"
#include "../Datenstruktur/CFortschritt.h"

//#include "CGUI.h"
#include "CDatenbank.h"

/**
 * Diese Klasse bildet die Schnittstelle zwischen dem Haltestellenmodul, 
 * der GUI und der Datenbank. Sie leitet Anforderungen und Daten zwischen 
 * den anfragenden und den antwortenden Klassen weiter. Diese Klasse 
 * reagiert nur auf Anfrage des Haltestellenmoduls und arbeitet nicht selbststaendig. 
 */
class CHSSchnittstelle : public CSchnittstelleMitGUI {
public:    

   CHSSchnittstelle(CDatenbank*, CGUI*);

   CParameterHaltestelle * anfordernWerte(void);

   /** Diese Funktion wird vom verbundenen Haltestellenmodul aufgerufen,
    * das seine berechneten Werte in der entsprechenden Datenstruktur
    * zurueckgibt. Diese Funktion leitet die ihr uebergebenen Werte an
    * die entsprechenden Stellen zur Speicherung bzw. zur Anzeige weiter
    * 
    * Der zweite Parameter entspricht der Kantenbeschriftung, was hier
    * der Entfernung entspricht
    */
    void haltestellenErgebnisrueckgabe(GRAPH<CWegenetzKnoten*, CWegenetzKante*>*, matrix*);

    // die folgende Funktion schieben die vom Haltestellenmodul
    // berechneten Guetemasse in die Datenbank
    void speichernGuetemasse(CGuetemasse * );

    // die folgende Funktion holt eine bereits teilweise gefuellte
    // Guetemassklasse, die die Haltestellen ausfuellen
    CGuetemasse* holenGuetemasse();
};
#endif //CHSSCHNITTSTELLE_H
