	/* Generated by Together */

// Implementierung: Tim Schuerrmann

#include "../Datenstruktur/Debug.h"

#include "CKontrolle.h"

#include <unistd.h>



CKontrolle::~CKontrolle()
{
	// Schnittstellen lschen
	delete lnkHaltestelle.lnkCHSSchnittstelle;
	delete lnkLinienplan.lnkCLPSchnittstelle;
	delete lnkFahrplan.lnkCFPSchnittstelle;
	delete lnkCGUISchnittstelle;

	// Vorsorglich alle Zeiger auf NULL setzten (wer weiss, was noch alles so passieren kann :-)):
	lnkCGUISchnittstelle=0;
	lnkHaltestelle.lnkCHSSchnittstelle=0;
	lnkLinienplan.lnkCLPSchnittstelle=0;
	lnkFahrplan.lnkCFPSchnittstelle=0;
	Debug(1,"Destruktor: saemtliche Schnittstellen wurden eliminiert");

	delete lnkCDatenbank;
	lnkCDatenbank=0;
	Debug(1, "Destruktor: Datenbankschnittstelle wurde eliminiert");

}
CKontrolle::CKontrolle(CGUISchnittstelle*& argGUISchnittstelle, CGUI* gui, int itv, char* db_benutzername=0)
{
	// zunaechst die GUI sichern:
	lnkCGUI=gui;
		
	// Alle Zeiger in den Strukturen auf NULL setzen:
	// Haltestelle:
	lnkHaltestelle.lnkCHSSchnittstelle=0;
	lnkHaltestelle.lnkHS=0; 
	// Linienplan:
	lnkLinienplan.lnkCLPSchnittstelle=0;
	lnkLinienplan.lnkLP=0;  
//	lnkLinienplan.graph=0;
//	lnkLinienplan.vorgegebeneLinien=0;
//	lnkLinienplan.verkehrsbedarfsmatrix=0;
	//Fahrplan:
	lnkFahrplan.lnkCFPSchnittstelle=0;
	lnkFahrplan.lnkFP=0;
	lnkFahrplan.linienplan=0;
        isttestversion=itv;
   
   // erzeuge SCHNITTSTELLEN

	// DATENBANKSCHNITTSTELLE
	// neue Datenbankschnittstelle anlegen
	lnkCDatenbank=0;
	switch(isttestversion)
	{
		case 1: 
		{
			Debug(2, "CKontrolle: verwende TESTFALL 1");
			try{lnkCDatenbank=new CTestklasse1(db_benutzername);}
			catch(...)
			{
				cerr<<"CKontrolle: "<<__LINE__<<": "<<"new loeste unbekannten Fehler aus (Testfall 1)"<<endl;
				exit(1);		
			}	
			break;
		}
		case 2: 
		{
			Debug(2, "CKontrolle: verwende TESTFALL 2");
			try{lnkCDatenbank=new CTestklasse2(db_benutzername);}
			catch(...)
			{
				cerr<<"CKontrolle: "<<__LINE__<<": "<<"new loeste unbekannten Fehler aus (Testfall 2)"<<endl;
				exit(1);		
			}	
			break;
		}
		case 3: 
		{
			Debug(2, "CKontrolle: verwende TESTFALL 3");
			try{lnkCDatenbank=new CTestklasse3(db_benutzername);}
			catch(...)
			{
				cerr<<"CKontrolle: "<<__LINE__<<": "<<"new loeste unbekannten Fehler aus (Testfall 3)"<<endl;
				exit(1);		
			}	
			break;
		}
		case 4: 
		{
			Debug(2, "CKontrolle: verwende TESTFALL 4");
			try{lnkCDatenbank=new CTestklasse4(db_benutzername);}
			catch(...)
			{
				cerr<<"CKontrolle: "<<__LINE__<<": "<<"new loeste unbekannten Fehler aus (Testfall 3)"<<endl;
				exit(1);		
			}	
			break;
		}
		case 5: 
		{
			Debug(2, "CKontrolle: verwende TESTFALL 3");
			try{lnkCDatenbank=new CTestklasse5(db_benutzername);}
			catch(...)
			{
				cerr<<"CKontrolle: "<<__LINE__<<": "<<"new loeste unbekannten Fehler aus (Testfall 3)"<<endl;
				exit(1);		
			}	
			break;
		}
		case 0:
		{
			Debug(2, "CKontrolle: verwende CTestklasse0");
			try{lnkCDatenbank=new CTestklasse0(db_benutzername);}
			catch(...)
			{
				cerr<<"CKontrolle: "<<__LINE__<<": "<<"new loeste unbekannten Fehler aus (Testfall)"<<endl;
				exit(1);		
			}	
			break;
		}
		default:
		{
			Debug(2, "CKontrolle: verwende CDatenbank");
			try{
				// sofern keine GUI da ist, laufen wir im Batchmodus:
				if(lnkCGUI==0) lnkCDatenbank=new CDatenbank(db_benutzername, true);
				else lnkCDatenbank=new CDatenbank(db_benutzername);
			}
			catch(...)
			{
				cerr<<"CKontrolle: "<<__LINE__<<": "<<"new loeste unbekannten Fehler aus"<<endl;
				exit(1);		
			}
			break;
		}
		
	}

        /*
	if(isttestversion==0)
	{		
		Debug(2, "CKontrolle: verwende CDatenbank");
		try{lnkCDatenbank=new CDatenbank(db_benutzername);}
		catch(...)
		{
			cerr<<"CKontrolle: "<<__LINE__<<": "<<"new loeste unbekannten Fehler aus"<<endl;
			exit(1);		
		}
	}
	else
	{
		Debug(2, "CKontrolle: verwende CTestklasse0");
		try{lnkCDatenbank=new CTestklasse0(db_benutzername);}
		catch(...)
		{
			cerr<<"CKontrolle: "<<__LINE__<<": "<<"new loeste unbekannten Fehler aus (Testfall)"<<endl;
			exit(1);		
		}
	} */
	

        // SCHNITTSTELLEN:
	lnkCGUISchnittstelle=0;
	
	Debug(1, "Lege GUI-Schnittstelle an");
	
	try{
		lnkCGUISchnittstelle = new CGUISchnittstelle(lnkCDatenbank);	
	}
	catch(std::bad_alloc)
	{
		cerr<<"CKontrolle: "<<__LINE__<<": "<<"GUISchnittstelle konnte nicht angelegt werden, Speichermangel"<<endl;
		exit(1);
	}
	catch(...)
	{
		cerr<<"CKontrolle: "<<__LINE__<<": "<<"new loeste unbekannten Fehler aus"<<endl;
		exit(1);
	}

	argGUISchnittstelle= lnkCGUISchnittstelle;
	Debug(1, "GUISchnittstelle konnte erfolgreich angelegt werden");


	// Lege jetzt alle weiteren Schnittstellena an:
	try{ lnkHaltestelle.lnkCHSSchnittstelle = new CHSSchnittstelle(lnkCDatenbank, gui); }
	catch(std::bad_alloc)
	{
		cerr<<"CKontrolle: "<<__LINE__<<": "<<"Haltestellen-Schnittstelle konnte nicht angelegt werden, Speichermangel"<<endl;
		exit(1);
	}
	catch(...)
	{
		cerr<<"CKontrolle: "<<__LINE__<<": "<<"new loeste unbekannten Fehler aus"<<endl;
		exit(1);
	}

	try{ lnkLinienplan.lnkCLPSchnittstelle = new CLPSchnittstelle(lnkCDatenbank, gui); }
	catch(std::bad_alloc)
	{
		cerr<<"CKontrolle: "<<__LINE__<<": "<<"Linienplan-Schnittstelle konnte nicht angelegt werden, Speichermangel"<<endl;
		exit(1);
	}
	catch(...)
	{
		cerr<<"CKontrolle: "<<__LINE__<<": "<<"new loeste unbekannten Fehler aus"<<endl;
		exit(1);
	}

	try{ lnkFahrplan.lnkCFPSchnittstelle = new CFPSchnittstelle(lnkCDatenbank, gui); }
	catch(std::bad_alloc)
	{
		cerr<<"CKontrolle: "<<__LINE__<<": "<<"Fahrplan-Schnittstelle konnte nicht angelegt werden, Speichermangel"<<endl;
		exit(1);
	}
	catch(...)
	{
		cerr<<"CKontrolle: "<<__LINE__<<": "<<"new loeste unbekannten Fehler aus"<<endl;
		exit(1);
	}
	
	Debug(1, "Restliche Schnittstellen (HS, LP, FP) konnten erfolgreich angelegt werden");
}




// Die Thread-Methoden ----------------------------------------------------------------------------------------------------------
void* CKontrolle::threadHaltestelle(void* arg)
{
	Debug(2,"threadHaltestelle wurde aufgerufen");
	
	// neues Haltestellenobjekt STARTEN:
	try{((haltestelleStruct*)arg)->lnkHS->starten();}
	catch(UnsinnigeErzeugung)
	{
		cout<<"CKontrolle: MODUL HALTESTELLEN warf UnsinnigeErzeugung"<<endl;
		((CGUI*)((haltestelleStruct*)arg)->lnkCGUI)->beendenHaltestellenberechnung(-1, "Die Haltestellenberechnung konnte nicht durchgefuehrt werden. Grund: Der Fehler 'unsinnige Erzeugung' trat auf.");
		return 0;
	}
	catch(NichtInstanzierteParameter)
	{
		cout<<"CKontrolle: MODUL HALTESTELLEN warf NichtInstanziierterParameter"<<endl;
		((CGUI*)((haltestelleStruct*)arg)->lnkCGUI)->beendenHaltestellenberechnung(-1, "Die Haltestellenberechnung konnte nicht durchgefuehrt werden. Grund: Der Fehler 'NichtInstanziierterParameter' trat auf.");
		return 0;
	}
	catch(AusserhalbWertebereich)
	{
		cout<<"CKontrolle: MODUL HALTESTELLEN warf AusserhalbWertebereich"<<endl;
		((CGUI*)((haltestelleStruct*)arg)->lnkCGUI)->beendenHaltestellenberechnung(-1, "Die Haltestellenberechnung konnte nicht durchgefuehrt werden. Grund: Der Fehler 'AusserhalbWertebereich' trat auf.");
		return 0;
	}
	catch(WohldefinierterAbbruch)
	{
		cout<<"CKontrolle: MODUL HALTESTELLEN warf WohldefinierterAbbruch"<<endl;
		((CGUI*)((haltestelleStruct*)arg)->lnkCGUI)->beendenHaltestellenberechnung(-1, "Die Haltestellenberechnung konnte nicht durchgefuehrt werden. Grund: Der Fehler 'WohldefinierterAbbruch' trat auf.");
		return 0;
	}
	catch(...)
	{
		cout<<"CKontrolle: MODUL HALTESTELLEN hat waehrend Laufzeit UNBEKANNTEN FEHLER GEWORFEN!!!!!!"<<endl;	
		((CGUI*)((haltestelleStruct*)arg)->lnkCGUI)->beendenHaltestellenberechnung(-1, "Die Haltestellenberechnung konnte nicht durchgefuehrt werden, da ein unbekannter Fehler auftrat");
		return 0;
	} 

	//pthread_exit((void*) "gruss von threadHaltestelle, die sich beendet\n");
	cout<<"Haltestelle beendet."<<endl;

	((CGUI*)((haltestelleStruct*)arg)->lnkCGUI)->beendenHaltestellenberechnung(0, "Die Haltestellenberechnung wurde erfolgreich abgeschlossen");

	return 0;
}


void *CKontrolle::threadLinienplan(void* arg)
{
        Debug(2,"threadLinienplan wurde aufgerufen");
        // neues Linienplanobjekt STARTEN:
	try{((linienplanStruct*)arg)->lnkLP->starten();} 
	catch(UnsinnigeErzeugung)
	{
		cout<<"CKontrolle: MODUL LINIENPLAN warf UnsinnigeErzeugung"<<endl;
		((CGUI*)((linienplanStruct*)arg)->lnkCGUI)->beendenLinienplanberechnung(-1, "Die Linienplanberechnung konnte nicht durchefuehrt werden. Grund: Der Fehler 'unsinnige Erzeugung' trat auf.");
		return 0;
	}
	catch(NichtInstanzierteParameter)
	{
		cout<<"CKontrolle: MODUL LINIENPLAN warf NichtInstanziierterParameter"<<endl;
		((CGUI*)((linienplanStruct*)arg)->lnkCGUI)->beendenLinienplanberechnung(-1, "Die Linienplanberechnung konnte nicht durchefuehrt werden. Grund: Der Fehler 'NichtInstanziierterParameter' trat auf.");
		return 0;
	}
	catch(AusserhalbWertebereich)
	{
		cout<<"CKontrolle: MODUL LINIENPLAN warf AusserhalbWertebereich"<<endl;
		((CGUI*)((linienplanStruct*)arg)->lnkCGUI)->beendenLinienplanberechnung(-1, "Die Linienplanberechnung konnte nicht durchefuehrt werden. Grund: Der Fehler 'AusserhalbWertebereich' trat auf.");
		return 0;
	}
	catch(WohldefinierterAbbruch)
	{
		cout<<"CKontrolle: MODUL LINIENPLAN warf WohldefinierterAbbruch"<<endl;
		((CGUI*)((linienplanStruct*)arg)->lnkCGUI)->beendenLinienplanberechnung(-1, "Die Linienplanberechnung konnte nicht durchefuehrt werden. Grund: Der Fehler 'WohldefinierterAbbruch' trat auf.");
		return 0;
	}
	catch(...)
	{
		cout<<"CKontrolle: MODUL LINIENPLAN hat waehrend Laufzeit UNBEKANNTEN FEHLER GEWORFEN!"<<endl;	
		((CGUI*)((linienplanStruct*)arg)->lnkCGUI)->beendenLinienplanberechnung(-1, "Die Linienplanberechnung konnte nicht durchefuehrt werden, da ein unbekannter Fehler auftrat.");
		return 0;
	} 
       	
	//pthread_exit((void*) "gruss von threadLinienplan, die sich beendet\n");
	cout<<"Linienplan beendet."<<endl;
	
	((CGUI*)((linienplanStruct*)arg)->lnkCGUI)->beendenLinienplanberechnung(0, "Die Linienplanberechnung wurde erfolgreich abgeschlossen");
	return 0;
}

void *CKontrolle::threadFahrplan(void* arg)
{

	CFahrplan* lnkFP;
	Debug(2,"threadFahrplan wurde aufgerufen");
	
        // neues Modul ANLEGEN:	
	
	//lnkFP= new CFahrplan((CFPSchnittstelle*)((fahrplanStruct*)arg)->lnkCFPSchnittstelle, (GRAPH<CFPlanGraphKnoten*, CFPlanGraphKante*>*)((fahrplanStruct*)arg)->linienplan);
	lnkFP=(CFahrplan*)((fahrplanStruct*)arg)->lnkFP;
	//((fahrplanStruct*)arg)->lnkFP=lnkFP;
	Debug(2,"FahrplanMODUL erzeugt");

	bool fehleraufgetreten=false;

	// neues Fahrplanobjekt STARTEN:
	try{lnkFP->starten();}
	catch(CFahrplanExceptions& e)
	{
		cout<<"CKontrolle: MODUL FAHRPLAN warf eine Exception: "<<e.gebenMeldung()<<endl;
		fehleraufgetreten=true;
		char* test=new char[strlen(e.gebenMeldung())+1];
		strcpy(test, e.gebenMeldung());
		((CGUI*)((fahrplanStruct*)arg)->lnkCGUI)->beendenFahrplaninit(-1, test);
		return 0;
	}
	catch(...)
	{
		cout<<"CKontrolle: MODUL FAHRPLAN hat waehrend Laufzeit UNBEKANNTEN FEHLER GEWORFEN!!!!!!"<<endl;fehleraufgetreten=true;
		((CGUI*)((fahrplanStruct*)arg)->lnkCGUI)->beendenFahrplaninit(-1, "Die Initialisierung des Fahrplans schlug fehl. Grund: ein unbekannter Fehler trat auf.");
		return 0;	
	} 


	// Ablauf des Fahrplanmoduls:
	// 1. Fahrplan errechnet Zusammenhangskomponenten, die er ueber die FPSchnittstelle in die DB schiebt
	// 2. Fahplan wird mit der von User gewaehlten Zusammenhangskomponente aufgerufen
	// 3. ...
	
	// Folgendes nur zum TEST:, muss noch in die Rueckkopplung:
	/*if(fehleraufgetreten==false)
	{
		try{lnkFP->berechnenHeuristischeFahrplanerstellung(0);}
		catch(CFahrplanExceptions& e)
		{
			cout<<"CKontrolle: MODUL FAHRPLAN warf eine Exception: "<<e.gebenMeldung()<<endl;
			fehleraufgetreten=true;
		}
		catch(...)
		{
			cout<<"CKontrolle: MODUL FAHRPLAN hat waehrend Laufzeit UNBEKANNTEN FEHLER GEWORFEN!!!!!!"<<endl;fehleraufgetreten=true;	
		} 
		
		if(fehleraufgetreten==false)
		{
			Debug(2, "Gebe Fahrplan aus:");
			try{lnkFP->ausgebenFahrplan();}
			catch(CFahrplanExceptions& e)
			{ 	
				cout<<"CKontrolle: MODUL FAHRPLAN warf eine Exception: "<<e.gebenMeldung()<<endl;
			}
			catch(...)
			{
				cout<<"CKontrolle: MODUL FAHRPLAN hat waehrend Laufzeit UNBEKANNTEN FEHLER GEWORFEN!!!!!!"<<endl;fehleraufgetreten=true;	
			} 
			Debug(2, "Fahrplanberechnung fertig");
			cout<<"Fahrplan beendet."<<endl;
		}
	}
   */
	
	Debug(2, "[Fahrplaninit BEENDET}");
	// Thread darf hier nicht beendet werden, da sonst keine Interaktion moeglich
	//pthread_exit((void*) "Gruss von threadFahrplan, der sich beendet\n");

	
	((CGUI*)((fahrplanStruct*)arg)->lnkCGUI)->beendenFahrplaninit(0, "Die Initialisierung des Fahrplans wurde erfolgreich durchgefuehrt.");
	

	return 0;
}
void* CKontrolle::threadFahrplanBerechnenHeuristischeFahrplanerstellung(void* arg)
{
	
        CFahrplan* lnkFP;
	Debug(2,"threadFahrplanBerechneHeuristischeFahrplanerstellung wurde aufgerufen");
	lnkFP=(CFahrplan*)((fahrplanStruct*)arg)->lnkFP;

	try{lnkFP->berechnenHeuristischeFahrplanerstellung((int)((fahrplanStruct*)arg)->zusammenhangskomponente);}
	catch(CFahrplanExceptions& e)
	{
		cout<<"CKontrolle: MODUL FAHRPLAN warf eine Exception: "<<e.gebenMeldung()<<endl;
		char* test=new char[strlen(e.gebenMeldung())+1];
		strcpy(test, e.gebenMeldung());
		((CGUI*)((fahrplanStruct*)arg)->lnkCGUI)->beendenFahrplanberechnung(-1, test);
		return 0;
	}
	catch(...)
	{
		cout<<"CKontrolle: MODUL FAHRPLAN hat waehrend Laufzeit UNBEKANNTEN FEHLER GEWORFEN!!!!!!"<<endl;
		((CGUI*)((fahrplanStruct*)arg)->lnkCGUI)->beendenFahrplanberechnung(-1, "Die heuristische Fahrplanerstellung konnte nicht durchgefuehrt werden. Grund: ein unbekannter Fehler ist aufgetreten");
		return 0;	
	} 
	
	Debug(2, "[FahrplanBerechnenHeuritstischeFahrplanerstellung BEENDET}");
	((CGUI*)((fahrplanStruct*)arg)->lnkCGUI)->beendenFahrplanberechnung(0, "Die heuristische Fahrplanerstellung wurde erfolgreich durchgefuehrt.");
	
	return 0;
}
void* CKontrolle::threadFahrplanSukzessiveLoesungsverbesserung(void* arg)
{
	CFahrplan* lnkFP;
	Debug(2,"threadFahrplanSukzessiveLoesungsverbesserung wurde aufgerufen");
	lnkFP=(CFahrplan*)((fahrplanStruct*)arg)->lnkFP;

	try{lnkFP->berechnenSukzessiveLoesungsverbesserung((int)((fahrplanStruct*)arg)->zusammenhangskomponente);}
	catch(CFahrplanExceptions& e)
	{
		cout<<"CKontrolle: MODUL FAHRPLAN warf eine Exception: "<<e.gebenMeldung()<<endl;
		char* test=new char[strlen(e.gebenMeldung())+1];
		strcpy(test, e.gebenMeldung());
		((CGUI*)((fahrplanStruct*)arg)->lnkCGUI)->beendenFahrplanberechnung(-1, test);
		return 0;
	}
	catch(...)
	{
		cout<<"CKontrolle: MODUL FAHRPLAN hat waehrend Laufzeit UNBEKANNTEN FEHLER GEWORFEN!!!!!!"<<endl;
		((CGUI*)((fahrplanStruct*)arg)->lnkCGUI)->beendenFahrplanberechnung(-1, "Die sukzessive Loesungsverbesserung konnte nicht durchgefuehrt werden. Grund: ein unbekannter Fehler ist aufgetreten.");
		return 0;	
	} 
	
	Debug(2, "[FahrplanSukzessiveLoesungsverbesserung BEENDET}");
	((CGUI*)((fahrplanStruct*)arg)->lnkCGUI)->beendenFahrplanberechnung(0, "Die sukzessive Loesungsverbesserung konnte erfolgreich durchgefuehrt werden.");

	return 0;
}
void* CKontrolle::threadFahrplanEntscheidungsbaumverfahren(void* arg)
{
	CFahrplan* lnkFP;
	Debug(2,"threadFahrplanEntscheidungsbaumverfahren wurde aufgerufen");
	lnkFP=(CFahrplan*)((fahrplanStruct*)arg)->lnkFP;

	try{lnkFP->berechnenEntscheidungsbaumverfahren((int)((fahrplanStruct*)arg)->zusammenhangskomponente, (int)((fahrplanStruct*)arg)->entscheidungsbaumtiefe);}
	catch(CFahrplanExceptions& e)
	{
		cout<<"CKontrolle: MODUL FAHRPLAN warf eine Exception: "<<e.gebenMeldung()<<endl;
		char* test=new char[strlen(e.gebenMeldung())+1];
		strcpy(test, e.gebenMeldung());
		((CGUI*)((fahrplanStruct*)arg)->lnkCGUI)->beendenFahrplanberechnung(-1, test);
		return 0;
	}
	catch(...)
	{
		cout<<"CKontrolle: MODUL FAHRPLAN hat waehrend Laufzeit UNBEKANNTEN FEHLER GEWORFEN!!!!!!"<<endl;
		((CGUI*)((fahrplanStruct*)arg)->lnkCGUI)->beendenFahrplanberechnung(-1, "Das Entscheidungsbaumverfahren konnte nicht durchgefuehrt werden. Grund: ein unbekannter Fehler ist aufgetreten.");
		return 0;	
	} 
	
	Debug(2, "[FahrplanEntscheidungsbaumverfahren BEENDET}");
	((CGUI*)((fahrplanStruct*)arg)->lnkCGUI)->beendenFahrplanberechnung(0, "Das Entscheidungsbaumverfahren konnte erfolgreich durchgefuehrt werden.");

	return 0;
}


void* CKontrolle::threadFahrplanAusgebenFahrplan(void* arg)
{
	CFahrplan* lnkFP;
	Debug(2,"threadFahrplanAusgebenFahrplan wurde aufgerufen");
	lnkFP=(CFahrplan*)((fahrplanStruct*)arg)->lnkFP;

	Debug(2, "Gebe Fahrplan aus:");
	try{lnkFP->ausgebenFahrplan();}
	catch(CFahrplanExceptions& e)
	{ 	
		cout<<"CKontrolle: MODUL FAHRPLAN warf eine Exception: "<<e.gebenMeldung()<<endl;
		char* test=new char[strlen(e.gebenMeldung())+1];
		strcpy(test, e.gebenMeldung());
		((CGUI*)((fahrplanStruct*)arg)->lnkCGUI)->beendenFahrplanfertigstellen(-1, test);
		return 0;
	}
	catch(...)
	{
		cout<<"CKontrolle: MODUL FAHRPLAN hat waehrend Laufzeit UNBEKANNTEN FEHLER GEWORFEN!!!!!!"<<endl;
		((CGUI*)((fahrplanStruct*)arg)->lnkCGUI)->beendenFahrplanfertigstellen(-1, "Der Fahrplan konnte nicht fertiggestellt werden. Grund: ein unbekannter Fehler ist aufgetreten.");
		return 0;	
	} 
	Debug(2, "[Fahrplanberechnung fertig]");
	((CGUI*)((fahrplanStruct*)arg)->lnkCGUI)->beendenFahrplanfertigstellen(0, "Der Fahrplan konnte erfolgreich ausgegeben werden");

	return 0;
}

void* CKontrolle::threadFahrplanAusgebenBewertung(void* arg)
{
	CFahrplan* lnkFP;
	Debug(2,"threadFahrplanAusgebenBewerung wurde aufgerufen");
	lnkFP=(CFahrplan*)((fahrplanStruct*)arg)->lnkFP;

	Debug(2, "Gebe Fahrplan aus:");
	try{lnkFP->ausgebenBewertung();}
	catch(CFahrplanExceptions& e)
	{ 	
		cout<<"CKontrolle: MODUL FAHRPLAN warf eine Exception: "<<e.gebenMeldung()<<endl;
		char* test=new char[strlen(e.gebenMeldung())+1];
		strcpy(test, e.gebenMeldung());
		((CGUI*)((fahrplanStruct*)arg)->lnkCGUI)->beendenFahrplanausgebenBewertung(-1, test);
		return 0;
	}
	catch(...)
	{
		cout<<"CKontrolle: MODUL FAHRPLAN hat waehrend Laufzeit UNBEKANNTEN FEHLER GEWORFEN!!!!!!"<<endl;	
		((CGUI*)((fahrplanStruct*)arg)->lnkCGUI)->beendenFahrplanausgebenBewertung(-1, "Die Bewertung des Fahrplans konnte nicht ausgegeben werden. Grund: ein unbekannter Fehler ist aufgetreten.");
		return 0;
	} 
	Debug(2, "[Fahrplanberechnung fertig]");
	((CGUI*)((fahrplanStruct*)arg)->lnkCGUI)->beendenFahrplanausgebenBewertung(0, "Die Fahrplan-Guetemasse wurden erfolgreich berechnet.");

	return 0;
}





// Methoden, um die Threads anzuwerfen --------------------------------------------------------------------------------------
void CKontrolle::startenHaltestellenModul()
{ 	 	
	// neues Modul ANLEGEN:	
	lnkHaltestelle.lnkHS= new CHaltestelle(lnkHaltestelle.lnkCHSSchnittstelle);
	Debug(2, "HaltestellenMODUL erzeugt");	

	if(lnkCGUI!=NULL)
	{
		// KEIN Batchbetrieb:
		lnkHaltestelle.lnkCGUI=lnkCGUI;

		// lege erst fest, dass Thread sich automatisch mit Hauptthread wieder verbindet (join):
		pthread_attr_t attr;
		pthread_attr_init(&attr);                               
		pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
		
		// und los geht's
		Debug(2,"CKontrolle: Starte Haltestellen Thread:");
		cout<<"Haltestellen gestartet..."<<endl;
		if(pthread_create(&haltestellen_thread, &attr, CKontrolle::threadHaltestelle, &lnkHaltestelle)!=0) 
		{ 		
	        	cerr<<"CKontrolle.cpp:"<<__LINE__<<": "<<" startenHaltestellenModul: threadcreate schlug fehl"<<endl; 			
			exit(EXIT_FAILURE); 	
		}
		Debug(2,"CKontrolle: Haltestellen-Thread wurde gestartet");
	}
	else
	{
		Debug(2,"lege Haltestellenklasse an:");
	
	        // neues Modul ANLEGEN:	
//		lnkHaltestelle.lnkHS= new CHaltestelle(lnkHaltestelle.lnkCHSSchnittstelle);
//		Debug(2, "HaltestellenMODUL erzeugt");

		// neues Haltestellenobjekt STARTEN:
		try{lnkHaltestelle.lnkHS->starten();}
		catch(UnsinnigeErzeugung){cout<<"CKontrolle: MODUL HALTESTELLEN warf UnsinnigeErzeugung"<<endl;}
		catch(NichtInstanzierteParameter){cout<<"CKontrolle: MODUL HALTESTELLEN warf NichtInstanziierterParameter"<<endl;}
		catch(AusserhalbWertebereich){cout<<"CKontrolle: MODUL HALTESTELLEN warf AusserhalbWertebereich"<<endl;}
		catch(WohldefinierterAbbruch){cout<<"CKontrolle: MODUL HALTESTELLEN warf WohldefinierterAbbruch"<<endl;}
		catch(...)
		{
			cout<<"CKontrolle: MODUL HALTESTELLEN hat waehrend Laufzeit UNBEKANNTEN FEHLER GEWORFEN!!!!!!"<<endl;	
		} 
        	
		cout<<"Haltestelle beendet."<<endl;
	}

  
}


void CKontrolle::startenLinienplanModul()
{
	// Zunaechst Parameter der Startfunktion in die entsprechende Struktur werfen:
/*	try{lnkCDatenbank->holenDaten(lnkLinienplan.verkehrsbedarfsmatrix, lnkLinienplan.vorgegebeneLinien, lnkLinienplan.graph);}
	catch(...)
	{
		cout<<"CKontrolle: Die Datenbank konnte die Linienplan-Daten nicht liefern"<<endl;
		exit(1);
	} 
	double linienplanID; // dummy zum wegwerfen: id des Linienplans ist hier von keiner Bedeutung
	try{lnkCDatenbank->holenLinienplanModulParameter(0, lnkLinienplan.gesamtlaenge, lnkLinienplan.maxLinienLaenge, lnkLinienplan.maxLinienAnzahl, linienplanID);}
	catch(...)
	{
		cout<<"CKontrolle: Die Datenbank konnte die Linienplan-Daten nicht liefern"<<endl;
		exit(1);
	}
*/	

	// neues Modul ANLEGEN:	
	lnkLinienplan.lnkLP= new CLinienplan(lnkLinienplan.lnkCLPSchnittstelle);
	Debug(2,"LinienplanMODUL erzeugt");
        
        // Jetzt starten

	if(lnkCGUI!=NULL)
	{
		// KEIN Batchbetrieb:
                lnkLinienplan.lnkCGUI=lnkCGUI;

		// lege erst fest, dass Thread sich automatisch mit Hauptthread wieder verbindet (join):
		pthread_attr_t attr;
		pthread_attr_init(&attr);                               
		pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);

		// und los geht's:
		Debug(2,"CKontrolle: Starte Linienplan Thread:");
		cout<<"Linienplan gestartet..."<<endl;
		if(pthread_create(&linienplan_thread, &attr, CKontrolle::threadLinienplan, &lnkLinienplan)!=0) 
		{ 		
	        	cerr<<"CKontrolle.cpp:"<<__LINE__<<": "<<" startenLinienplanModul: threadcreate schlug fehl"<<endl; 	
			exit(EXIT_FAILURE); 	
		}
		Debug(2, "CKontrolle: Linienplan-Thread wurde gestartet");
	        
	}
	else
	{
//		Debug(2,"lege Linienplanklasse an:");
	
	        // neues Modul ANLEGEN:	
//		lnkLinienplan.lnkLP= new CLinienplan(lnkLinienplan.lnkCLPSchnittstelle);
//		Debug(2, "LinienplanMODUL erzeugt");

		// neues Haltestellenobjekt STARTEN:
		try{lnkLinienplan.lnkLP->starten();}
		catch(UnsinnigeErzeugung){cout<<"CKontrolle: MODUL LINIENPLAN warf UnsinnigeErzeugung"<<endl;}
		catch(NichtInstanzierteParameter){cout<<"CKontrolle: MODUL LINIENPLAN warf NichtInstanziierterParameter"<<endl;}
		catch(AusserhalbWertebereich){cout<<"CKontrolle: MODUL LINIENPLAN warf AusserhalbWertebereich"<<endl;}
		catch(WohldefinierterAbbruch){cout<<"CKontrolle: MODUL LINIENPLAN warf WohldefinierterAbbruch"<<endl;}
		catch(...)
		{
			cout<<"CKontrolle: MODUL LINIENPLAN hat waehrend Laufzeit UNBEKANNTEN FEHLER GEWORFEN!"<<endl;	
		} 
		
		cout<<"Linienplan beendet."<<endl;
	}

}


void CKontrolle::startenFahrplanModul()
{
	lnkFahrplan.linienplan=lnkCDatenbank->fahrplanLinienplan();
	lnkFahrplan.lnkCGUI=lnkCGUI;

	// Debug-Ausgabe: testet, ob der Fahrplangraph korrekt aufgebaut wurde:
/*	cout<<"Knoten des Linienplans:"<<endl;
	node knoten;
	int zaehler=0;
	forall_nodes(knoten, *(lnkFahrplan.linienplan))
	{
		CFPlanGraphKnoten* fpknoten=lnkFahrplan.linienplan->inf(knoten);
		cout<<"Knoten-ID: "<<fpknoten->holenID()<<endl;
		zaehler++;
	}
	cout<<"Anzahl Knoten gesamt: "<<zaehler<<endl;
	// Durchlaufe alle Kanten:
	edge kante;
	zaehler=0;
	forall_edges(kante, *(lnkFahrplan.linienplan))
	{
		CFPlanGraphKante* fpkante=lnkFahrplan.linienplan->inf(kante);
		cout<<"Kante: LinienID: "<<fpkante->holenLinienID()<<" Fahrtzeit: "<<fpkante->holenFahrtzeit()<<" Strom: "<<fpkante->holenVerkehrsstrom()<<endl;
		zaehler++;
	}
	cout<<"Anzahl Kanten gesamt: "<<zaehler<<endl;
	// Debug-Ausgabe ende
*/	

        // lege erst fest, dass Thread sich automatisch mit Hauptthread wieder verbindet (join):
	pthread_attr_t attr;
	pthread_attr_init(&attr);                               
	pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
		
	// und los geht's
        lnkFahrplan.lnkFP= new CFahrplan(lnkFahrplan.lnkCFPSchnittstelle, lnkFahrplan.linienplan);
	Debug(2,"CKontrolle: Starte Fahrplan Thread:");
	cout<<"Fahrplan gestartet..."<<endl;
	if(pthread_create(&fahrplan_thread, &attr, CKontrolle::threadFahrplan, &lnkFahrplan)!=0) 
	{ 		
	        cerr<<"CKontrolle.cpp:"<<__LINE__<<": "<<" startenFahrplanModul: threadcreate schlug fehl"<<endl; 	
		exit(EXIT_FAILURE); 	
	}
	Debug(2,"CKontrolle: Fahrplan-Thread wurde gestartet");


}
void CKontrolle::startenFahrplanBerechnenHeuristischeFahrplanerstellung(int zusammenhangskomponente)
{
	// lege erst fest, dass Thread sich automatisch mit Hauptthread wieder verbindet (join):
	pthread_attr_t attr;
	pthread_attr_init(&attr);                               
	pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
		
	// und los geht's
	Debug(2,"CKontrolle: Starte FahrplanBerechnenHeuristischeFahrplanerstellung:");
	lnkFahrplan.zusammenhangskomponente=zusammenhangskomponente;
	if(pthread_create(&fahrplan_thread, &attr, CKontrolle::threadFahrplanBerechnenHeuristischeFahrplanerstellung, &lnkFahrplan)!=0) 
	{ 		
	        cerr<<"CKontrolle.cpp:"<<__LINE__<<": "<<" startenFahrplanBerechnenHeuristischeFahrplanerstellung: threadcreate schlug fehl"<<endl; 	
		exit(EXIT_FAILURE); 	
	}
	Debug(2,"CKontrolle: Fahrplan-Thread wurde gestartet");
}
void CKontrolle::startenFahrplanSukzessiveLoesungsverbesserung(int zusammenhangskomponente)
{
	// lege erst fest, dass Thread sich automatisch mit Hauptthread wieder verbindet (join):
	pthread_attr_t attr;
	pthread_attr_init(&attr);                               
	pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
		
	// und los geht's
	Debug(2,"CKontrolle: Starte FahrplanSukzessiveLoesungsverbesserung:");
	lnkFahrplan.zusammenhangskomponente=zusammenhangskomponente;
	if(pthread_create(&fahrplan_thread, &attr, CKontrolle::threadFahrplanSukzessiveLoesungsverbesserung, &lnkFahrplan)!=0) 
	{ 		
	        cerr<<"CKontrolle.cpp:"<<__LINE__<<": "<<" startenFahrplanBerechnenHeuristischeFahrplanerstellung: threadcreate schlug fehl"<<endl; 	
		exit(EXIT_FAILURE); 	
	}
	Debug(2,"CKontrolle: Fahrplan-Thread wurde gestartet");
}
void CKontrolle::startenFahrplanEntscheidungsbaumverfahren(int zusammenhangskomponente, int entscheidungsbaumtiefe=10)
{
	// lege erst fest, dass Thread sich automatisch mit Hauptthread wieder verbindet (join):
	pthread_attr_t attr;
	pthread_attr_init(&attr);                               
	pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
		
	// und los geht's
	Debug(2,"CKontrolle: Starte FahrplanEntscheidungsbaumverfahren:");
	lnkFahrplan.zusammenhangskomponente=zusammenhangskomponente;
	lnkFahrplan.entscheidungsbaumtiefe=entscheidungsbaumtiefe;
	if(pthread_create(&fahrplan_thread, &attr, CKontrolle::threadFahrplanEntscheidungsbaumverfahren, &lnkFahrplan)!=0) 
	{ 		
	        cerr<<"CKontrolle.cpp:"<<__LINE__<<": "<<" startenFahrplanBerechnenHeuristischeFahrplanerstellung: threadcreate schlug fehl"<<endl; 	
		exit(EXIT_FAILURE); 	
	}
	Debug(2,"CKontrolle: Fahrplan-Thread wurde gestartet");
}
void CKontrolle::startenFahrplanAusgebenFahrplan()
{
	// lege erst fest, dass Thread sich automatisch mit Hauptthread wieder verbindet (join):
	pthread_attr_t attr;
	pthread_attr_init(&attr);                               
	pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
		
	// und los geht's
	Debug(2,"CKontrolle: Starte FahrplanBerechnenHeuristischeFahrplanerstellung:");
	cout<<"FahrplanBerechnenHeuristischeFahrplanerstellung gestartet..."<<endl;
	if(pthread_create(&fahrplan_thread, &attr, CKontrolle::threadFahrplanAusgebenFahrplan, &lnkFahrplan)!=0) 
	{ 		
	        cerr<<"CKontrolle.cpp:"<<__LINE__<<": "<<" FahrplanBerechnenHeuristischeFahrplanerstellung: threadcreate schlug fehl"<<endl; 	
		exit(EXIT_FAILURE); 	
	}
	Debug(2,"CKontrolle: Fahrplan-Thread wurde gestartet");
}
void CKontrolle::startenFahrplanAusgebenBewertung()
{
	// lege erst fest, dass Thread sich automatisch mit Hauptthread wieder verbindet (join):
	pthread_attr_t attr;
	pthread_attr_init(&attr);                               
	pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
		
	// und los geht's
	Debug(2,"CKontrolle: Starte FahrplanAusgebenBewertung:");
	cout<<"startenFahrplanAusgebenBewertung gestartet..."<<endl;
	if(pthread_create(&fahrplan_thread, &attr, CKontrolle::threadFahrplanAusgebenBewertung, &lnkFahrplan)!=0) 
	{ 		
	        cerr<<"CKontrolle.cpp:"<<__LINE__<<": "<<" FahrplanAusgebenBewertung: threadcreate schlug fehl"<<endl; 	
		exit(EXIT_FAILURE); 	
	}
	Debug(2,"CKontrolle: Fahrplan-Thread wurde gestartet");
}



// Methoden um die Threads anzuhalten --------------------------------------------------------------------------------------
void CKontrolle::stoppenHaltestellenModul()
{
	Debug(2, "Veranlasse die Haltestellen zu stoppen");
	lnkHaltestelle.lnkHS->stoppen();	
	Debug(2, "gestoppt.");
	// der GUI den Abbruch melden!
}
void CKontrolle::zerstoerenHaltestellenModul()
{
	
/*	if(pthread_join(haltestellen_thread, &thread_result)!=0)
	{
		cerr<<"CKontrolle.cpp:"<<__LINE__<<": "<<"stoppenHaltestellenModul: Thread join schlug fehl\n"; 		
		exit(EXIT_FAILURE);	
	}
	Debug(2,"CKontrolle: Haltestellen-Thread wurde gestoppt");
*/

	// Jetzt die Haltestelle ELIMINIEREN:
	if(lnkHaltestelle.lnkHS!=0) delete lnkHaltestelle.lnkHS;
	lnkHaltestelle.lnkHS=0;
	Debug(2,"Haltestellen-MODUL eliminiert");
//	cout<<"Haltestellen-Modul beendet."<<endl;

}
void CKontrolle::stoppenLinienplanModul()
{
	Debug(2, "Veranlasse den Linienplan zu stoppen");
	lnkLinienplan.lnkLP->stoppen();	
	Debug(2, "gestoppt.");
}
void CKontrolle::zerstoerenLinienplanModul()
{
/*	if(pthread_join(linienplan_thread, &thread_result)!=0)
	{
		cerr<<"CKontrolle.cpp:"<<__LINE__<<": "<<"stoppenLinienplanModul: Thread join schlug fehl\n"; 		
		exit(EXIT_FAILURE);	
	}
	Debug(2,"CKontrolle: Linienplan-Thread wurde gestoppt");
*/

	// Jetzt den Linienplan ELIMINIEREN:
	if(lnkLinienplan.lnkLP!=0) delete lnkLinienplan.lnkLP;
	lnkLinienplan.lnkLP=0;
	Debug(2,"Linienplan-MODUL eliminiert");
//	cout<<"Linienplan-Thread eingesammelt."<<endl;
}
void CKontrolle::stoppenFahrplanModul()
{
/*	if(pthread_join(fahrplan_thread, &thread_result)!=0)
	{
		cerr<<"CKontrolle.cpp:"<<__LINE__<<": "<<"stoppenFahrplanModul: Thread join schlug fehl\n"; 		
		exit(EXIT_FAILURE);	
	}
	Debug(2,"CKontrolle: Fahrplan-Thread wurde gestoppt [1/5]");

	// Jetzt den Fahrplan ELIMINIEREN:
	Debug(2,"Fahrplan-MODUL eliminiert");
	cout<<"Fahrplan-Thread eingesammelt."<<endl;
*/
	Debug(2, "Veranlasse den Fahrplan zu stoppen");
	lnkFahrplan.lnkFP->stoppen();	
	Debug(2, "gestoppt.");
}
void CKontrolle::stoppenFahrplanBerechnenHeuristischeFahrplanerstellung()
{
/*	if(pthread_join(fahrplan_thread, &thread_result)!=0)
	{
		cerr<<"CKontrolle.cpp:"<<__LINE__<<": "<<"stoppenFahrplanBerechnenHeuristischeFahrplanerstellung: Thread join schlug fehl\n"; 		
		exit(EXIT_FAILURE);	
	}
	Debug(2,"CKontrolle: Fahrplan-Thread wurde gestoppt [2/5]");

	// Jetzt den Fahrplan ELIMINIEREN:
	Debug(2,"Fahrplan-MODUL eliminiert");
	cout<<"Fahrplan-Thread eingesammelt."<<endl;
*/
	Debug(2, "Veranlasse den Fahrplan zu stoppen");
	lnkFahrplan.lnkFP->stoppen();	
	Debug(2, "gestoppt.");
}
void CKontrolle::stoppenFahrplanSukzessiveLoesungsverbesserung()
{
/*f(pthread_join(fahrplan_thread, &thread_result)!=0)
	{
		cerr<<"CKontrolle.cpp:"<<__LINE__<<": "<<"stoppenFahrplanSukzessiveLoesungsverbesserung: Thread join schlug fehl\n"; 		
		exit(EXIT_FAILURE);	
	}
	Debug(2,"CKontrolle: Fahrplan-Thread wurde gestoppt [3/5]");

	// Jetzt den Fahrplan ELIMINIEREN:
	Debug(2,"Fahrplan-MODUL eliminiert");
	cout<<"Fahrplan-Thread eingesammelt."<<endl;
*/
	Debug(2, "Veranlasse den Fahrplan zu stoppen");
	lnkFahrplan.lnkFP->stoppen();	
	Debug(2, "gestoppt.");
}
void CKontrolle::stoppenFahrplanEntscheidungsbaumverfahren()
{
/*	if(pthread_join(fahrplan_thread, &thread_result)!=0)
	{
		cerr<<"CKontrolle.cpp:"<<__LINE__<<": "<<"stoppenFahrplanntscheidungsbaumverfahren: Thread join schlug fehl\n"; 		
		exit(EXIT_FAILURE);	
	}
	Debug(2,"CKontrolle: Fahrplan-Thread wurde gestoppt [4/5]");

	// Jetzt den Fahrplan ELIMINIEREN:
	Debug(2,"Fahrplan-MODUL eliminiert");
	cout<<"Fahrplan-Thread eingesammelt."<<endl;
*/
	Debug(2, "Veranlasse den Fahrplan zu stoppen");
	lnkFahrplan.lnkFP->stoppen();	
	Debug(2, "gestoppt.");
}
void CKontrolle::stoppenFahrplanAusgebenFahrplan()
{
/*	if(pthread_join(fahrplan_thread, &thread_result)!=0)
	{
		cerr<<"CKontrolle.cpp:"<<__LINE__<<": "<<"stoppenFahrplanAusgebenFahrplan: Thread join schlug fehl\n"; 		
		exit(EXIT_FAILURE);	
	}
	Debug(2,"CKontrolle: Fahrplan-Thread wurde gestoppt [5/5]");

	cout<<"Fahrplan-Thread eingesammelt."<<endl;
*/
	Debug(2, "Veranlasse den Fahrplan zu stoppen");
	lnkFahrplan.lnkFP->stoppen();	
	Debug(2, "gestoppt.");
}
void CKontrolle::stoppenFahrplanAusgebenBewertung()
{
/*	if(pthread_join(fahrplan_thread, &thread_result)!=0)
	{
		cerr<<"CKontrolle.cpp:"<<__LINE__<<": "<<"stoppenFahrplanAusgebenBewertung: Thread join schlug fehl\n"; 		
		exit(EXIT_FAILURE);	
	}
	Debug(2,"CKontrolle: Fahrplan-Thread wurde gestoppt [5/5]");

	cout<<"Fahrplan-Thread eingesammelt."<<endl;
*/
	Debug(2, "Veranlasse den Fahrplan zu stoppen");
	lnkFahrplan.lnkFP->stoppen();	
	Debug(2, "gestoppt.");
}
void CKontrolle::ausgebenWartezeiten()
{
	if(lnkFahrplan.lnkFP!=0)
	{
		(lnkFahrplan.lnkFP)->ausgebenWartezeiten();
	}
}
void CKontrolle::ausgebenAnzahlFahrzeuge()
{
	if(lnkFahrplan.lnkFP!=0)
	{
		(lnkFahrplan.lnkFP)->ausgebenFahrzeugAnzahl();	
	}
}
void CKontrolle::zerstoerenFahrplanModul()
{
	// zerstoert das FahrplanModul:
	// Jetzt den Fahrplan ELIMINIEREN:
	if(lnkFahrplan.lnkFP!=0) delete lnkFahrplan.lnkFP;
	lnkFahrplan.lnkFP=0;

	Debug(2,"Fahrplan-MODUL zerstoert");
}




void CKontrolle::setzenPhaseBatchModus(int phase)
{
	lnkCDatenbank->setztenPhase(phase);
}
