/* Generated by Together */

// Implementierung: Tim Schuermann

#ifndef CLPSCHNITTSTELLE_H
#define CLPSCHNITTSTELLE_H

#include "LEDA/graph.h"

#include "CSchnittstelleMitGUI.h"
#include "../Datenstruktur/CFPlanGraphKnoten.h"
#include "../Datenstruktur/CFPlanGraphKante.h"
#include "../Datenstruktur/CLinie.h"
//#include "../Datenstruktur/CGuetemasseLinienplan.h"
#include "../Datenstruktur/CGuetemasse.h"

#include "CDatenbank.h"

/**
 * Diese Klasse bildet die Schnittstelle zwischen dem Linienplanmodul, der GUI und der Datenbank. Sie leitet Anforderungen und Daten zwischen den anfragenden und den antwortenden Klassen weiter. Diese Klasse reagiert nur auf Anfrage des Linienplanmoduls und arbeitet nicht selbststaendig. 
 */
class CLPSchnittstelle : public CSchnittstelleMitGUI {
public:    

    CLPSchnittstelle(CDatenbank*, CGUI*);
    
    /**
    * Diese Funktionen werden vom verbundenen Linienplanmodul aufgerufen,
    * um die entsprechenden Werte von der Datenbank anzufordern
    */
    matrix* holenLinienplanQuelleZielMatrix();
    list<CLinie*>* holenLinienplanVorgegebeneLinien();
    UGRAPH<CWegenetzKnoten*,CWegenetzKante*>* holenLinienplanWegenetzgraph();
    
   /**
    * Diese Funktionen werden vom verbundenen Linienplanmodul aufgerufen,
    * um die entsprechenden ModulParameter von der Datenbank anzufordern
    */

    int holenLinienplanGesamtlaenge();
    int holenLinienplanLinienLaenge();
    int holenLinienplanMaxLinienAnzahl();
    int holenGeschwindigkeit();
    int holenAlgorithmus();
    int holenAnzeigenGraphen();
    bool holenEindeutigeLinienverknuepfung();
    bool holenMehrdeutigeLinienverknuepfung();
    bool holenAufbruchsverknuepfung();
    bool holenLinienendverknuepfung();
    bool holenBasislinienwahl();

    bool pruefenBatchModus(void); // schaut, ob das Programm im Batchmodus laeuft


   /**
    * Diese Funktion wird vom verbundenen Linienplanmodul aufgerufen,
    * das seine berechneten Werte in der entsprechenden Datenstruktur
    * zurueckgibt. Diese Funktion leitet die ihr uebergebenen Werte an
    * die entsprechenden Stellen zur Speicherung bzw. zur Anzeige weiter
    */
    void linienplanungErgebnisrueckgabe(GRAPH<CFPlanGraphKnoten*, CFPlanGraphKante*>*, list<CLinie*>*);

   // die Folgenden beiden Funktionen schieben die vom Haltestellenmodul
    // berechneten Guetemasse in die Datenbank
//    void speichernGuetemasse(CGuetemasseLinienplan* );


   // die folgende Funktion schieben die vom Linienplanmodul
    // berechneten Guetemasse in die Datenbank
    void speichernGuetemasse(CGuetemasse * );

    // die folgende Funktion holt eine bereits teilweise gefuellte
    // Guetemassklasse, die der Linienplan ausfuellt
    CGuetemasse* holenGuetemasse();

};
#endif //CLPSCHNITTSTELLE_H