// Testklasse fuer CGRASSSchnittstelle
// Implementierung: Tim Schuermann


/*
 * Testmethode: Kontrollfluss (jede Methode wird mindestens einmal
 * ueberdeckt)
 * 
 *
 */
 

#include "CGUI.h"
#include "CKontrolle.h"
#include "CGUISchnittstelle.h"
#include "CGRASSSchnittstelle.h"
#include <iostream>
#include <unistd.h> // fuer die Sleep-Funktion
#include <cstdlib>
#include <limits.h>

#include "LEDA/graph.h"
#include "LEDA/list.h"



int main ( int argc, char ** argv ) {

	cout<<"HaLiFa Version 1.0"<<endl;
	cout<<"(C) 2000/2001 Projektgruppe 369, Universitaet Dortmund"<<endl;	
	cout.flush();
       	if((argc>1)&&(strcmp(argv[1], "-batchmodus")==0))
	{
		// KOMMANDOZEILEN-Variante
		cout<<"Kommandozeilenversion..."<<endl<<endl;
                if(argc>2)
		{
			cout<<"Verwende Ausgangsdaten, die unter Projekt 0 gespeichert sind"<<endl;

			char* username=getenv("USER");
			cout<<"Username ist: "<<username<<endl<<endl;
			
			char* location=new char[PATH_MAX];
			sprintf(location, "LOCATION=%s/spearfish/PERMANENT", argv[2]);
			putenv(location);
			char* gisdbase=new char[PATH_MAX];
			sprintf(gisdbase, "GISDBASE=%s", argv[2]);
			putenv(gisdbase);
			putenv("MAPSET=PERMANENT");
			putenv("SHLVL=3");
			char* pfad=getenv("PATH");
			char* path_env=new char[strlen(pfad)+strlen("PATH=/home/pg369/share/grass5/bin:/home/pg369/share/grass5/scripts:")+5];
			sprintf(path_env, "PATH=/home/pg369/share/grass5/bin:/home/pg369/share/grass5/scripts:%s", pfad);
			putenv(path_env);
			char* heim=getenv("HOME");
			char* home_env=new char[strlen(heim)+strlen("GISRC=$HOME/.grassrc5")+5];
			sprintf(home_env, "GISRC=%s/.grassrc5", heim);
			putenv("GISBASE=/home/pg369/share/grass5");
			putenv(home_env);
			putenv("LOCATION_NAME=spearfish");
			
                        if(argc>3)
			{
				if((strcmp(argv[3], "hs")==0)||(strcmp(argv[3], "HS")==0))
				{
					cout<<"Berechne NUR die Haltestellen"<<endl<<endl;
					
					CGUISchnittstelle* dummyguischnittstelle=0; // wird zwar gefuellt, wird hier aber nicht benoetigt
					CKontrolle kontrolle(dummyguischnittstelle, NULL, -1, username);
					kontrolle.startenHaltestellenModul();
					kontrolle.setzenPhaseBatchModus(50);

					if(dummyguischnittstelle!=0) delete dummyguischnittstelle;
				}
				else if((strcmp(argv[3], "lp")==0)||(strcmp(argv[3], "LP")==0))
				{
					cout<<"Berechne NUR den Linienplan"<<endl;
					cout<<"Hinweis: Es findet im Batchmodus KEINE Pruefung statt, ob korrekte Eingabewerte exisiteren"<<endl<<endl;

					CGUISchnittstelle* dummyguischnittstelle=0; // wird zwar gefuellt, wird hier aber nicht benoetigt
					CKontrolle kontrolle(dummyguischnittstelle, NULL, -1, username);

					// und jetzt der Linienplan:
					kontrolle.startenLinienplanModul();
        		
					// jetzt noch die Phase anpassen, damit die grafische Anzeige klappt:
					kontrolle.setzenPhaseBatchModus(100);

					if(dummyguischnittstelle!=0) delete dummyguischnittstelle;
				}
				else
				{
					cout<<"Fehler: Letzter Parameter nicht korrekt."<<endl;
					cout<<"Syntax:"<<endl<<endl;
					cout<<"Programm -batchmodus <Verzeichnis, indem spearfish-Verzeichnis liegt> [hs oder lp]"<<endl;
					cout<<endl;
				}
			}
			else
			{

				// Als erstes die Haltestellen laufen lassen:
				CGUISchnittstelle* dummyguischnittstelle=0; // wird zwar gefuellt, wird hier aber nicht benoetigt
				CKontrolle kontrolle(dummyguischnittstelle, NULL, -1, username);
				kontrolle.startenHaltestellenModul();
                        	
				// jetzt noch die Phase anpassen, damit die grafische Anzeige klappt:
				kontrolle.setzenPhaseBatchModus(50);
				
				// und jetzt der Linienplan:
				kontrolle.startenLinienplanModul();
        	
				// jetzt noch die Phase anpassen, damit die grafische Anzeige klappt:
				kontrolle.setzenPhaseBatchModus(100);

				if(dummyguischnittstelle!=0) delete dummyguischnittstelle;
			}

		}
		else
		{
			cout<<"Fehler: Zu wenige Parameter fuer einen Aufruf."<<endl;
			cout<<"Syntax:"<<endl<<endl;
			cout<<"Programm -batchmodus <Verzeichnis, indem spearfish-Verzeichnis liegt>"<<endl;
			cout<<endl;
		}
		cout<<"HaLiFa wurde beendet"<<endl;
	}else
	{
		// NORMALE GUI-Variante	
		CGUI gui(argc, argv);
		gui.laufen();
	}

	
} // main