/* Generated by Together */

#include "CTestklasse0.h"
#include "Testkoordinaten.h"
#include "../Datenstruktur/Debug.h"
#include <stdlib.h>

CTestklasse0::CTestklasse0(char* db_username):CDatenbank(db_username)
{
	
}
CTestklasse0::~CTestklasse0()
{
	delete lnkCGRASSSchnittstelle;
	lnkCGRASSSchnittstelle=0;
	delete lnkCDBSchnittstelle;
	lnkCDBSchnittstelle=0;
}





// ------------------------------------  holen - Methoden --------------------------------------------------
//------------------------------------------------------------------------------
// Funktionsname: holenDaten
// Beschreibung: Haltestellen Variante, erzeugt und uebergibt die Testdaten
// Parameter: Pflichthaltestellen, Strassennetz, Bevoelkerungsdichte, QuelleZielMatrix
// 				QuelleZielListe, Pendlermatrix, Pendlerliste
//				Alles als Referenzen auf Zeiger, welche im Idealfall leer sein sollten
// Rueckgabe: Die Referenzen sind mit den Testdaten gefuellt
// Besonderheiten: keine
//------------------------------------------------------------------------------
void CTestklasse0::holenDaten(list<CPunkt*>*& pflichtHS, list<list<CPunkt*>*>*& strassennetz, list<list<CPunkt*>*>*& wege,
	list<CBevoelkerungsdichteElement*>*& dichte, matrix*& quelleZielMatrix, 
	list<CQuelleZielListeElement*>*& quelleZielListe, 
	matrix*& pendlerMatrix, list<CPendlerListeElement*>*& pendlerListe,
	list<list<CPunkt*>*>*& gebaeude)
{
	wege = new list<list<CPunkt*>*>;

	Debug(2,"Erzeuge Testdaten fuer Haltestellen");
	//die Pendlermatrix
	Debug(3,"Lege Pendlermatrix an");
	//pendlerMatrix = new matrix (4,4);
	/*ifstream pendler("/home/pg369/share/pendlermatrix.txt", ios::in|ios::nocreate);
	pendler >> *pendlerMatrix;
	pendler.close(); */
	double p[]={10, 23, 17, 21, 15, 9,  4, 11, 7, 12, 20, 5, 13,  7, 13, 8};
	pendlerMatrix = new matrix (4,4,p); 

	Debug(3,"Lege Pendlerliste an");
	//die Pendlerliste
	pendlerListe = new list<CPendlerListeElement*>;
	pendlerListe->append (new CPendlerListeElement(new CPunkt(P13),1,500));
	pendlerListe->append (new CPendlerListeElement(new CPunkt(P29),2,600));
	pendlerListe->append (new CPendlerListeElement(new CPunkt(P10),3,400));
	pendlerListe->append (new CPendlerListeElement(new CPunkt(P34),4,600));

	// die Quelle-Ziel-Matrix
	Debug(3,"Lege Quelle-Ziel-Matrix an");
	//quelleZielMatrix = new matrix (11,11);
	/*ifstream qz("/home/pg369/share/fahrtwunschmatrix.txt", ios::in|ios::nocreate);
	qz >> *quelleZielMatrix;
	qz.close(); */
    double qz[121];
	int i,j;
	srand(1);
    for (i=0;i<11;i++) {
        for (j=0;j<11;j++) {
                qz[i*11+j] = (rand() >> 10);
        }
    }
	quelleZielMatrix = new matrix(11,11,qz);
  

	//die Quelle-Ziel-Liste
	Debug(3,"Lege Quelle-Ziel-Liste an");
	quelleZielListe = new list <CQuelleZielListeElement*>;
	quelleZielListe->append (new CQuelleZielListeElement(new CPunkt(P02),1));
	quelleZielListe->append (new CQuelleZielListeElement(new CPunkt(P12),2));
	quelleZielListe->append (new CQuelleZielListeElement(new CPunkt(P15),3));
	quelleZielListe->append (new CQuelleZielListeElement(new CPunkt(P30),4));
	quelleZielListe->append (new CQuelleZielListeElement(new CPunkt(P28),5));
	quelleZielListe->append (new CQuelleZielListeElement(new CPunkt(P33),6));
	quelleZielListe->append (new CQuelleZielListeElement(new CPunkt(P22),7));
	quelleZielListe->append (new CQuelleZielListeElement(new CPunkt(P05),8));
	quelleZielListe->append (new CQuelleZielListeElement(new CPunkt(P09),9));
	quelleZielListe->append (new CQuelleZielListeElement(new CPunkt(P24),10));
	quelleZielListe->append (new CQuelleZielListeElement(new CPunkt(P07),11));


	//die Pflichthaltestellen
	Debug(3,"Lege Pflichthaltestellen-Liste an");
	pflichtHS = new list<CPunkt*>;
	pflichtHS->append (new CPunkt(P06));
	pflichtHS->append (new CPunkt(P15));
	pflichtHS->append (new CPunkt(P18));
	pflichtHS->append (new CPunkt(P22));
	pflichtHS->append (new CPunkt(P33));


	//die Bevoelkerungsdichte
	Debug(3,"Lege Bevoelkerungsdichtenliste an");
	dichte = new list<CBevoelkerungsdichteElement*>;
	dichte->append (new CBevoelkerungsdichteElement(new CPunkt(P13),23,500));
	dichte->append (new CBevoelkerungsdichteElement(new CPunkt(P29),70,600));
	dichte->append (new CBevoelkerungsdichteElement(new CPunkt(P10),48,400));
	dichte->append (new CBevoelkerungsdichteElement(new CPunkt(P34),101,600));


	//das Strassennetz
	Debug(3,"Lege Strassennetz an");
	strassennetz = new list<list<CPunkt*>*>;
	list <CPunkt *> *strasse=new list <CPunkt *>;
	strasse->append(new CPunkt(P01));
	strasse->append(new CPunkt(P04));
	strasse->append(new CPunkt(P06));
	strasse->append(new CPunkt(P08));
	strassennetz->append(strasse);

	strasse=new list <CPunkt *>;
	strasse->append(new CPunkt(P14));
	strasse->append(new CPunkt(P15));
	strasse->append(new CPunkt(P16));
	strasse->append(new CPunkt(P17));
	strasse->append(new CPunkt(P18));
	strasse->append(new CPunkt(P19));
	strasse->append(new CPunkt(P20));
	strasse->append(new CPunkt(P22));
	strasse->append(new CPunkt(P23));
	strasse->append(new CPunkt(P24));
	strasse->append(new CPunkt(P25));
	strassennetz->append(strasse);

	strasse=new list <CPunkt *>;
	strasse->append(new CPunkt(P31));
	strasse->append(new CPunkt(P30));
	strasse->append(new CPunkt(P33));
	strasse->append(new CPunkt(P35));
	strassennetz->append(strasse);

	strasse=new list <CPunkt *>;
	strasse->append(new CPunkt(P03));
	strasse->append(new CPunkt(P04));
	strasse->append(new CPunkt(P12));
	strasse->append(new CPunkt(P18));
	strasse->append(new CPunkt(P26));
	strasse->append(new CPunkt(P28));
	strasse->append(new CPunkt(P33));
	strassennetz->append(strasse);

	strasse=new list <CPunkt *>;
	strasse->append(new CPunkt(P06));
	strasse->append(new CPunkt(P09));
	strasse->append(new CPunkt(P11));
	strasse->append(new CPunkt(P22));
	strasse->append(new CPunkt(P21));
	strasse->append(new CPunkt(P26));
	strasse->append(new CPunkt(P27));
	strasse->append(new CPunkt(P30));
	strasse->append(new CPunkt(P32));
	strassennetz->append(strasse);

	// einfach eine leere Liste:
	gebaeude=new list<list<CPunkt*>*>;

	// Schiebe das Strassennetz in GRASS:
	lnkCGRASSSchnittstelle->speichernAusschnittStrassennetz(strassennetz);

	Debug(2,"HS-Testdaten erzeugt");
}
	

//------------------------------------------------------------------------------
// Funktionsname: holenDaten
// Beschreibung: Linienplanvariante, erzeugt die Testdaten
// Parameter: Referenzen auf Zeiger auf:
//				Verkehrsbedarfsmatrix, vorgegebene Linien, Wegenetzgraph
// Rueckgabe: Die Referenzen sind mit den Testdaten gefuellt
// Besonderheiten: keine
//------------------------------------------------------------------------------
void CTestklasse0::holenDaten(matrix*& verkehrsbedarfsmatrix, list<CLinie*>*& vorgegebeneLinien,
		UGRAPH<CWegenetzKnoten*,CWegenetzKante*>*& wegenetzGraph)
{
	node ka[9];
	CWegenetzKante *kante;
	
	Debug (2,"Erzeuge Testdaten fuer Linienplan");
	
	//Verkehrsbedarfmatrix
	Debug (3,"Lege Verkehrsbedarfmatrix an");
	//verkehrsbedarfsmatrix = new matrix (9,9);
	/*ifstream vb("/home/pg369/share/verkehrsbedarfmatrix.txt", ios::in|ios::nocreate);
	vb >> *verkehrsbedarfsmatrix;
	vb.close(); */
	double vb[100];
	int i,j;
	srand(2);
	for (i=0;i<10;i++) {
		for (j=0;j<10;j++) {
			if ((i == 0) || (j == 0)) vb[i*10+j] = 0;
		else
			vb[i*10+j] = ((int)(rand()*1.2) >> 10);
		}
	}

	verkehrsbedarfsmatrix = new matrix(10,10,vb);
        
	Debug (3,"Lege Liste vorgegebener Linien an");
	vorgegebeneLinien = new list<CLinie*>;
	
	
// Damit der Linienplan mit dem Ergebnis der Haltestellen arbeitet, Quellcode ab hier einfach auskommentieren:

	Debug (3,"Lege Wegenetzgraph an");
	wegenetzGraph = new UGRAPH<CWegenetzKnoten*,CWegenetzKante*>;

        CWegenetzKnoten* beschriftung = new CWegenetzKnoten(0,8, new CPunkt(P33)); 	//Alle Knoten kriegen Prioritaet 10
	ka[0]=wegenetzGraph->new_node(beschriftung);
        beschriftung = new CWegenetzKnoten(1,10, new CPunkt(P30)); 	//Alle Knoten kriegen Prioritaet 10
	ka[1]=wegenetzGraph->new_node(beschriftung);
	beschriftung = new CWegenetzKnoten(2,10, new CPunkt(P26)); 	//Alle Knoten kriegen Prioritaet 10
	ka[2]=wegenetzGraph->new_node(beschriftung);
	beschriftung = new CWegenetzKnoten(3,5, new CPunkt(P22)); 	//Alle Knoten kriegen Prioritaet 10
	ka[3]=wegenetzGraph->new_node(beschriftung);
	beschriftung = new CWegenetzKnoten(4,5, new CPunkt(P18)); 	//Alle Knoten kriegen Prioritaet 10
	ka[4]=wegenetzGraph->new_node(beschriftung);
	beschriftung = new CWegenetzKnoten(5,8, new CPunkt(P15)); 	//Alle Knoten kriegen Prioritaet 10
	ka[5]=wegenetzGraph->new_node(beschriftung);
	beschriftung = new CWegenetzKnoten(6,10, new CPunkt(P04)); 	//Alle Knoten kriegen Prioritaet 10
	ka[6]=wegenetzGraph->new_node(beschriftung);
	beschriftung = new CWegenetzKnoten(7,7, new CPunkt(P06)); 	//Alle Knoten kriegen Prioritaet 10
	ka[7]=wegenetzGraph->new_node(beschriftung);
	beschriftung = new CWegenetzKnoten(8,10, new CPunkt(P24)); 	//Alle Knoten kriegen Prioritaet 10
	ka[8]=wegenetzGraph->new_node(beschriftung);

        list<CPunkt*>* dummyliste=NULL;

	kante=new CWegenetzKante(150);
	dummyliste=new list<CPunkt*>;
	dummyliste->append(new CPunkt(P33));
	dummyliste->append(new CPunkt(P30));
	kante->setzenKantenListe(dummyliste);
	wegenetzGraph->new_edge(ka[0],ka[1],kante);
	kante=new CWegenetzKante(350);
	dummyliste=new list<CPunkt*>;
	dummyliste->append(new CPunkt(P30));
	dummyliste->append(new CPunkt(P26));
	kante->setzenKantenListe(dummyliste);
	wegenetzGraph->new_edge(ka[1],ka[2],kante);
	kante=new CWegenetzKante(50);
	dummyliste=new list<CPunkt*>;
	dummyliste->append(new CPunkt(P26));
	dummyliste->append(new CPunkt(P22));
	kante->setzenKantenListe(dummyliste);
	wegenetzGraph->new_edge(ka[2],ka[3],kante);
	kante=new CWegenetzKante(83);
	dummyliste=new list<CPunkt*>;
	dummyliste->append(new CPunkt(P26));
	dummyliste->append(new CPunkt(P18));
	kante->setzenKantenListe(dummyliste);
	wegenetzGraph->new_edge(ka[2],ka[4],kante);
	kante=new CWegenetzKante(487);
	dummyliste=new list<CPunkt*>;
	dummyliste->append(new CPunkt(P22));
	dummyliste->append(new CPunkt(P24));
	kante->setzenKantenListe(dummyliste);
	wegenetzGraph->new_edge(ka[3],ka[8],kante);
	kante=new CWegenetzKante(580);
	dummyliste=new list<CPunkt*>;
	dummyliste->append(new CPunkt(P22));
	dummyliste->append(new CPunkt(P06));
	kante->setzenKantenListe(dummyliste);
	wegenetzGraph->new_edge(ka[3],ka[7],kante);
	kante=new CWegenetzKante(110);
	dummyliste=new list<CPunkt*>;
	dummyliste->append(new CPunkt(P22));
	dummyliste->append(new CPunkt(P18));
	kante->setzenKantenListe(dummyliste);
	wegenetzGraph->new_edge(ka[3],ka[4],kante);
	kante=new CWegenetzKante(323);
	dummyliste=new list<CPunkt*>;
	dummyliste->append(new CPunkt(P18));
	dummyliste->append(new CPunkt(P15));
	kante->setzenKantenListe(dummyliste);
	wegenetzGraph->new_edge(ka[4],ka[5],kante);
	kante=new CWegenetzKante(599);
	dummyliste=new list<CPunkt*>;
	dummyliste->append(new CPunkt(P18));
	dummyliste->append(new CPunkt(P04));
	kante->setzenKantenListe(dummyliste);
	wegenetzGraph->new_edge(ka[4],ka[6],kante);
	
	
        // Ausgangsdaten in der DB speichern:
	Debug(2, "Testdaten von den Haltestellen werden als Grundlage des Linienplans gespeichert");
	speichernDaten(wegenetzGraph, verkehrsbedarfsmatrix );
	Debug(2, "Testdaten von den Haltestellen als Grundlage des Linienplans gespeichert");

// Damit der Linienplan mit dem Ergebnis der Haltestellen arbeitet, Quellcode BIS HIER auskommentieren, was folgt sind
// die Lebensnotwendigen Eingaben:
    

	// Da die DB loescht, alles noch einmal anlegen:
        verkehrsbedarfsmatrix = new matrix(10,10,vb);
        wegenetzGraph = new UGRAPH<CWegenetzKnoten*,CWegenetzKante*>;
	for (int i = 0 ; i<9 ; i++){
		CWegenetzKnoten* beschriftung = new CWegenetzKnoten(i,10); //Alle Knoten kriegen Pri 10
		switch (i) { //Ausser ein paar, die sind anders
			case 0:
			case 5:
				beschriftung->setzenPrioritaet(8);
				break;
			case 3:
			case 4:
				beschriftung->setzenPrioritaet(5);
				break;
			case 7:
				beschriftung->setzenPrioritaet(7);
				break;
			}
		ka[i]=wegenetzGraph->new_node(beschriftung);
	}
	kante=new CWegenetzKante(150);
	wegenetzGraph->new_edge(ka[0],ka[1],kante);
	kante=new CWegenetzKante(350);
	wegenetzGraph->new_edge(ka[1],ka[2],kante);
	kante=new CWegenetzKante(50);
	wegenetzGraph->new_edge(ka[2],ka[3],kante);
	kante=new CWegenetzKante(83);
	wegenetzGraph->new_edge(ka[2],ka[4],kante);
	kante=new CWegenetzKante(487);
	wegenetzGraph->new_edge(ka[3],ka[8],kante);
	kante=new CWegenetzKante(580);
	wegenetzGraph->new_edge(ka[3],ka[7],kante);
	kante=new CWegenetzKante(110);
	wegenetzGraph->new_edge(ka[3],ka[4],kante);
	kante=new CWegenetzKante(323);
	wegenetzGraph->new_edge(ka[4],ka[5],kante);
	kante=new CWegenetzKante(599);
	wegenetzGraph->new_edge(ka[4],ka[6],kante);

	Debug (2,"LP-Testdaten erzeugt");
}
matrix* CTestklasse0::holenLinienplanQuelleZielMatrix()
{
	Debug(2, "hole QuelleZielMatrix fuer den Linienplan");
	//Verkehrsbedarfmatrix
	Debug (3,"Lege Verkehrsbedarfmatrix an");
	//verkehrsbedarfsmatrix = new matrix (9,9);
	/*ifstream vb("/home/pg369/share/verkehrsbedarfmatrix.txt", ios::in|ios::nocreate);
	vb >> *verkehrsbedarfsmatrix;
	vb.close(); */
	double vb[100];
	int i,j;
	srand(2);
	for (i=0;i<10;i++) {
		for (j=0;j<10;j++) {
			if ((i == 0) || (j == 0)) vb[i*10+j] = 0;
		else
			vb[i*10+j] = ((int)(rand()*1.2) >> 10);
		}
	}

	return new matrix(10,10,vb);
}
list<CLinie*>* CTestklasse0::holenLinienplanVorgegebeneLinien()
{
	// NOCH DUMMY!!!
	return new list<CLinie*>;
}
UGRAPH<CWegenetzKnoten*,CWegenetzKante*>* CTestklasse0::holenLinienplanWegenetzgraph()
{
	Debug(2, "hole Wegenetzgraph fuer den Linienplan");
	

	matrix* quellezielmatrix; 
	UGRAPH<CWegenetzKnoten*,CWegenetzKante*>* wegenetzGraph;
	list<CLinie*>* vorgebeneLinien;

	holenDaten(quellezielmatrix,vorgebeneLinien, wegenetzGraph);

	delete quellezielmatrix;
	delete vorgebeneLinien;

	Debug (2,"LP-Testdaten erzeugt");
	return wegenetzGraph;
}


//------------------------------------------------------------------------------
// Funktionsname: fahrplanLinienplan
// Beschreibung: Fahrplanvariante, erzeugt die Testdaten
// Parameter: keine
// Rueckgabe: Zeiger auf den Linienplan aus den Testdaten
// Besonderheiten: Grosse Teile stammen aus Linienplan/linienplandummydaten.cpp
//------------------------------------------------------------------------------
GRAPH<CFPlanGraphKnoten*, CFPlanGraphKante*>* CTestklasse0::fahrplanLinienplan()
{
	node ka[9];
	CWegenetzKante *kante;
	
	Debug (2,"Erzeuge Testdaten fuer Linienplan");
	
	//Verkehrsbedarfmatrix
	Debug (3,"Lege Verkehrsbedarfmatrix an");
	//verkehrsbedarfsmatrix = new matrix (9,9);
	/*ifstream vb("/home/pg369/share/verkehrsbedarfmatrix.txt", ios::in|ios::nocreate);
	vb >> *verkehrsbedarfsmatrix;
	vb.close(); */
	double vb[100];
	int i,j;
	srand(2);
	for (i=0;i<10;i++) {
		for (j=0;j<10;j++) {
			if ((i == 0) || (j == 0)) vb[i*10+j] = 0;
		else
			vb[i*10+j] = ((int)(rand()*1.2) >> 10);
		}
	}

	matrix* verkehrsbedarfsmatrix = new matrix(10,10,vb);
        

	Debug (3,"Lege Wegenetzgraph an");
	UGRAPH<CWegenetzKnoten*,CWegenetzKante*>* wegenetzGraph = new UGRAPH<CWegenetzKnoten*,CWegenetzKante*>;

        CWegenetzKnoten* beschriftung = new CWegenetzKnoten(0,8, new CPunkt(P33)); 	//Alle Knoten kriegen Prioritaet 10
	ka[0]=wegenetzGraph->new_node(beschriftung);
        beschriftung = new CWegenetzKnoten(1,10, new CPunkt(P30)); 	//Alle Knoten kriegen Prioritaet 10
	ka[1]=wegenetzGraph->new_node(beschriftung);
	beschriftung = new CWegenetzKnoten(2,10, new CPunkt(P26)); 	//Alle Knoten kriegen Prioritaet 10
	ka[2]=wegenetzGraph->new_node(beschriftung);
	beschriftung = new CWegenetzKnoten(3,5, new CPunkt(P22)); 	//Alle Knoten kriegen Prioritaet 10
	ka[3]=wegenetzGraph->new_node(beschriftung);
	beschriftung = new CWegenetzKnoten(4,5, new CPunkt(P18)); 	//Alle Knoten kriegen Prioritaet 10
	ka[4]=wegenetzGraph->new_node(beschriftung);
	beschriftung = new CWegenetzKnoten(5,8, new CPunkt(P15)); 	//Alle Knoten kriegen Prioritaet 10
	ka[5]=wegenetzGraph->new_node(beschriftung);
	beschriftung = new CWegenetzKnoten(6,10, new CPunkt(P04)); 	//Alle Knoten kriegen Prioritaet 10
	ka[6]=wegenetzGraph->new_node(beschriftung);
	beschriftung = new CWegenetzKnoten(7,7, new CPunkt(P06)); 	//Alle Knoten kriegen Prioritaet 10
	ka[7]=wegenetzGraph->new_node(beschriftung);
	beschriftung = new CWegenetzKnoten(8,10, new CPunkt(P24)); 	//Alle Knoten kriegen Prioritaet 10
	ka[8]=wegenetzGraph->new_node(beschriftung);

        list<CPunkt*>* dummyliste=NULL;

	kante=new CWegenetzKante(150);
	dummyliste=new list<CPunkt*>;
	dummyliste->append(new CPunkt(P33));
	dummyliste->append(new CPunkt(P30));
	kante->setzenKantenListe(dummyliste);
	wegenetzGraph->new_edge(ka[0],ka[1],kante);
	kante=new CWegenetzKante(350);
	dummyliste=new list<CPunkt*>;
	dummyliste->append(new CPunkt(P30));
	dummyliste->append(new CPunkt(P26));
	kante->setzenKantenListe(dummyliste);
	wegenetzGraph->new_edge(ka[1],ka[2],kante);
	kante=new CWegenetzKante(50);
	dummyliste=new list<CPunkt*>;
	dummyliste->append(new CPunkt(P26));
	dummyliste->append(new CPunkt(P22));
	kante->setzenKantenListe(dummyliste);
	wegenetzGraph->new_edge(ka[2],ka[3],kante);
	kante=new CWegenetzKante(83);
	dummyliste=new list<CPunkt*>;
	dummyliste->append(new CPunkt(P26));
	dummyliste->append(new CPunkt(P18));
	kante->setzenKantenListe(dummyliste);
	wegenetzGraph->new_edge(ka[2],ka[4],kante);
	kante=new CWegenetzKante(487);
	dummyliste=new list<CPunkt*>;
	dummyliste->append(new CPunkt(P22));
	dummyliste->append(new CPunkt(P24));
	kante->setzenKantenListe(dummyliste);
	wegenetzGraph->new_edge(ka[3],ka[8],kante);
	kante=new CWegenetzKante(580);
	dummyliste=new list<CPunkt*>;
	dummyliste->append(new CPunkt(P22));
	dummyliste->append(new CPunkt(P06));
	kante->setzenKantenListe(dummyliste);
	wegenetzGraph->new_edge(ka[3],ka[7],kante);
	kante=new CWegenetzKante(110);
	dummyliste=new list<CPunkt*>;
	dummyliste->append(new CPunkt(P22));
	dummyliste->append(new CPunkt(P18));
	kante->setzenKantenListe(dummyliste);
	wegenetzGraph->new_edge(ka[3],ka[4],kante);
	kante=new CWegenetzKante(323);
	dummyliste=new list<CPunkt*>;
	dummyliste->append(new CPunkt(P18));
	dummyliste->append(new CPunkt(P15));
	kante->setzenKantenListe(dummyliste);
	wegenetzGraph->new_edge(ka[4],ka[5],kante);
	kante=new CWegenetzKante(599);
	dummyliste=new list<CPunkt*>;
	dummyliste->append(new CPunkt(P18));
	dummyliste->append(new CPunkt(P04));
	kante->setzenKantenListe(dummyliste);
	wegenetzGraph->new_edge(ka[4],ka[6],kante);
	
	
        // Ausgangsdaten in der DB speichern:
	Debug(2, "Testdaten von den Haltestellen werden als Grundlage des Linienplans gespeichert");
	speichernDaten(wegenetzGraph, verkehrsbedarfsmatrix );
	Debug(2, "Testdaten von den Haltestellen als Grundlage des Linienplans gespeichert");






	node knotenArray[9];
        GRAPH<CFPlanGraphKnoten*,CFPlanGraphKante*>* linienplan = new GRAPH<CFPlanGraphKnoten*,CFPlanGraphKante*>();
	CFPlanGraphKante* neKante;

	// Erzeuge die Knoten und beschrifte sie
	//Debug(3, "linienplandummydaten Knoten werden erzeugt");
	for(int i=0; i<9; i++){
		CFPlanGraphKnoten* nenKnoten = new CFPlanGraphKnoten();
		nenKnoten->setzenID(i);
		knotenArray[i] = linienplan->new_node(nenKnoten);
	}

	// Erzeuge die Kanten und fuelle sie mit Leben
	// Aufbau der Linienbeschreibung: (vonKnoten,zuKnoten)/Fahrgaststrom(Kantenlaenge, Kantenzeit in Sekunden)
	// Kantenzeit in Sec = Kantenlaenge/4.17 (entspricht 15Km/h)
	// Linie 1: (1,2)/305(150,35) (2,3)/301(350,84) (3,5)/468(83,20) (5,6)/359(323,77)

		
	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(1);
	neKante->setzenVerkehrsstrom(305);
	neKante->setzenLinienID(1);
	linienplan->new_edge(knotenArray[0], knotenArray[1], neKante);

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(2);
	neKante->setzenVerkehrsstrom(301);
	neKante->setzenLinienID(1);
	linienplan->new_edge(knotenArray[1], knotenArray[2], neKante);

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(1);
	neKante->setzenVerkehrsstrom(468);
	neKante->setzenLinienID(1);
	linienplan->new_edge(knotenArray[2], knotenArray[4], neKante);

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(2);
	neKante->setzenVerkehrsstrom(359);
	neKante->setzenLinienID(1);
	linienplan->new_edge(knotenArray[4], knotenArray[5], neKante);
	
	

	// und wieder zurueck
	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(2);
	neKante->setzenVerkehrsstrom(359);
	neKante->setzenLinienID(-1);
	linienplan->new_edge(knotenArray[5], knotenArray[4], neKante);

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(1);
	neKante->setzenVerkehrsstrom(468);
	neKante->setzenLinienID(-1);
	linienplan->new_edge(knotenArray[4], knotenArray[2], neKante);
        
	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(2);
	neKante->setzenVerkehrsstrom(301);
	neKante->setzenLinienID(-1);
	linienplan->new_edge(knotenArray[2], knotenArray[1], neKante);

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(2);
	neKante->setzenVerkehrsstrom(305);
	neKante->setzenLinienID(-1);
	linienplan->new_edge(knotenArray[1], knotenArray[0], neKante);

	
	
	// Linie 2: (2,3)/179(350,84) (3,4)/328(50,12) (4,8)/311(580.139)

	
	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(2);
	neKante->setzenVerkehrsstrom(179);
	neKante->setzenLinienID(2);
	linienplan->new_edge(knotenArray[1], knotenArray[2], neKante);

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(1);
	neKante->setzenVerkehrsstrom(328);
	neKante->setzenLinienID(2);
	linienplan->new_edge(knotenArray[2], knotenArray[3], neKante);

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(3);
	neKante->setzenVerkehrsstrom(311);
	neKante->setzenLinienID(2);
	linienplan->new_edge(knotenArray[3], knotenArray[7], neKante);
	
	// und zurueck
	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(3);
	neKante->setzenVerkehrsstrom(311);
	neKante->setzenLinienID(-2);
	linienplan->new_edge(knotenArray[7], knotenArray[3], neKante);
	
	

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(1);
	neKante->setzenVerkehrsstrom(328);
	neKante->setzenLinienID(-2);
	linienplan->new_edge(knotenArray[3], knotenArray[2], neKante);

       

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(2);
	neKante->setzenVerkehrsstrom(179);
	neKante->setzenLinienID(-2);
	linienplan->new_edge(knotenArray[2], knotenArray[1], neKante);
	
	
		

	// Linie 3: (9,4)/303(487,117) (4,5)/286(110,26) (5,7)/359(599,144)
	
	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(2);
	neKante->setzenVerkehrsstrom(303);
	neKante->setzenLinienID(3);
	linienplan->new_edge(knotenArray[8], knotenArray[3], neKante);

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(1);
	neKante->setzenVerkehrsstrom(286);
	neKante->setzenLinienID(3);
	linienplan->new_edge(knotenArray[3], knotenArray[4], neKante);

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(3);
	neKante->setzenVerkehrsstrom(359);
	neKante->setzenLinienID(3);
	linienplan->new_edge(knotenArray[4], knotenArray[6], neKante);

	
	
	// und wieder zurueck
	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(3);
	neKante->setzenVerkehrsstrom(359);
	neKante->setzenLinienID(-3);
	linienplan->new_edge(knotenArray[6], knotenArray[4], neKante);

	

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(1);
	neKante->setzenVerkehrsstrom(286);
	neKante->setzenLinienID(-3);
	linienplan->new_edge(knotenArray[4], knotenArray[3], neKante);
	

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(2);
	neKante->setzenVerkehrsstrom(303);
	neKante->setzenLinienID(-3);
	linienplan->new_edge(knotenArray[3], knotenArray[8], neKante);



        list<CLinie*>* buslinien=new list<CLinie*>;
	CLinie* eineLinie=new CLinie();
	list<int>* lisths=new list<int>; // Linie 1: 
	lisths->append(0);
	lisths->append(1);
	lisths->append(2);
	lisths->append(4);
	lisths->append(5);
	eineLinie->setzenID(1);
	eineLinie->setzenhListe(lisths);
	buslinien->append(eineLinie); 

	//Linie 2:1,2,3,7
        eineLinie=new CLinie();
	lisths=new list<int>;
	lisths->append(1);
	lisths->append(2);
	lisths->append(3);
	lisths->append(7);
	eineLinie->setzenID(2);
	eineLinie->setzenhListe(lisths);
	buslinien->append(eineLinie); 

	// Linie 3: 8,3,4,6
	eineLinie=new CLinie();
	lisths=new list<int>;
	lisths->append(8);
	lisths->append(3);
	lisths->append(4);
	lisths->append(6);
	eineLinie->setzenID(3);
	eineLinie->setzenhListe(lisths);
	buslinien->append(eineLinie); 
	Debug(2, "Vor speichern in DB");

	speichernDaten(linienplan, buslinien);

	// Da in der Datenbank alle Daten geloescht werden, muessen wir nochmal alles fuer den Fahrplan anlegen:





        Debug(2, "Neu erzeugen");
        linienplan = new GRAPH<CFPlanGraphKnoten*,CFPlanGraphKante*>();

	// Erzeuge die Knoten und beschrifte sie
	//Debug(3, "linienplandummydaten Knoten werden erzeugt");
	for(int i=0; i<9; i++){
		CFPlanGraphKnoten* nenKnoten = new CFPlanGraphKnoten();
		nenKnoten->setzenID(i);
		knotenArray[i] = linienplan->new_node(nenKnoten);
	}

	// Erzeuge die Kanten und fuelle sie mit Leben
	// Aufbau der Linienbeschreibung: (vonKnoten,zuKnoten)/Fahrgaststrom(Kantenlaenge, Kantenzeit in Sekunden)
	// Kantenzeit in Sec = Kantenlaenge/4.17 (entspricht 15Km/h)
	// Linie 1: (1,2)/305(150,35) (2,3)/301(350,84) (3,5)/468(83,20) (5,6)/359(323,77)

		
	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(1);
	neKante->setzenVerkehrsstrom(305);
	neKante->setzenLinienID(1);
	linienplan->new_edge(knotenArray[0], knotenArray[1], neKante);

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(2);
	neKante->setzenVerkehrsstrom(301);
	neKante->setzenLinienID(1);
	linienplan->new_edge(knotenArray[1], knotenArray[2], neKante);

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(1);
	neKante->setzenVerkehrsstrom(468);
	neKante->setzenLinienID(1);
	linienplan->new_edge(knotenArray[2], knotenArray[4], neKante);

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(2);
	neKante->setzenVerkehrsstrom(359);
	neKante->setzenLinienID(1);
	linienplan->new_edge(knotenArray[4], knotenArray[5], neKante);
	
	

	// und wieder zurueck
	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(2);
	neKante->setzenVerkehrsstrom(359);
	neKante->setzenLinienID(-1);
	linienplan->new_edge(knotenArray[5], knotenArray[4], neKante);

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(1);
	neKante->setzenVerkehrsstrom(468);
	neKante->setzenLinienID(-1);
	linienplan->new_edge(knotenArray[4], knotenArray[2], neKante);
        
	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(2);
	neKante->setzenVerkehrsstrom(301);
	neKante->setzenLinienID(-1);
	linienplan->new_edge(knotenArray[2], knotenArray[1], neKante);

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(2);
	neKante->setzenVerkehrsstrom(305);
	neKante->setzenLinienID(-1);
	linienplan->new_edge(knotenArray[1], knotenArray[0], neKante);

	
	
	// Linie 2: (2,3)/179(350,84) (3,4)/328(50,12) (4,8)/311(580.139)

	
	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(2);
	neKante->setzenVerkehrsstrom(179);
	neKante->setzenLinienID(2);
	linienplan->new_edge(knotenArray[1], knotenArray[2], neKante);

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(1);
	neKante->setzenVerkehrsstrom(328);
	neKante->setzenLinienID(2);
	linienplan->new_edge(knotenArray[2], knotenArray[3], neKante);

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(3);
	neKante->setzenVerkehrsstrom(311);
	neKante->setzenLinienID(2);
	linienplan->new_edge(knotenArray[3], knotenArray[7], neKante);
	
	// und zurueck
	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(3);
	neKante->setzenVerkehrsstrom(311);
	neKante->setzenLinienID(-2);
	linienplan->new_edge(knotenArray[7], knotenArray[3], neKante);
	
	

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(1);
	neKante->setzenVerkehrsstrom(328);
	neKante->setzenLinienID(-2);
	linienplan->new_edge(knotenArray[3], knotenArray[2], neKante);

       

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(2);
	neKante->setzenVerkehrsstrom(179);
	neKante->setzenLinienID(-2);
	linienplan->new_edge(knotenArray[2], knotenArray[1], neKante);
	
	
		

	// Linie 3: (9,4)/303(487,117) (4,5)/286(110,26) (5,7)/359(599,144)
	
	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(2);
	neKante->setzenVerkehrsstrom(303);
	neKante->setzenLinienID(3);
	linienplan->new_edge(knotenArray[8], knotenArray[3], neKante);

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(1);
	neKante->setzenVerkehrsstrom(286);
	neKante->setzenLinienID(3);
	linienplan->new_edge(knotenArray[3], knotenArray[4], neKante);

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(3);
	neKante->setzenVerkehrsstrom(359);
	neKante->setzenLinienID(3);
	linienplan->new_edge(knotenArray[4], knotenArray[6], neKante);

	
	
	// und wieder zurueck
	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(3);
	neKante->setzenVerkehrsstrom(359);
	neKante->setzenLinienID(-3);
	linienplan->new_edge(knotenArray[6], knotenArray[4], neKante);

	

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(1);
	neKante->setzenVerkehrsstrom(286);
	neKante->setzenLinienID(-3);
	linienplan->new_edge(knotenArray[4], knotenArray[3], neKante);
	

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(2);
	neKante->setzenVerkehrsstrom(303);
	neKante->setzenLinienID(-3);
	linienplan->new_edge(knotenArray[3], knotenArray[8], neKante);


	return linienplan;
}

//------------------------------------------------------------------------------
// Funktionsname: fahrplanFesteVerbindungen
// Beschreibung: Erzeugt die festen Verbindungen aus den Testdaten
// Parameter: keine
// Rueckgabe: Zeiger auf die festen Verbindungen 
// Besonderheiten: keine
//------------------------------------------------------------------------------
list<four_tuple<int,int,int,int>*>* CTestklasse0::fahrplanFesteVerbindungen()
{
	Debug(2, "FesteVerbindungen");
	/*list<four_tuple<int,int,int,int>*>* myList = new list<four_tuple<int, int, int, int>* >;
	four_tuple<int, int, int, int>* currentTuple;
  
	// erste bindung
	currentTuple = new four_tuple <int, int, int, int> (0, 1, 1, 1);
	myList->append (currentTuple);

	// erste bindung
	currentTuple = new four_tuple <int, int, int, int> (0, 1, 3, 1);
	myList->append (currentTuple);

	// erste bindung
	currentTuple = new four_tuple <int, int, int, int> (0, 1, 1, 2);
	myList->append (currentTuple);
	
	return myList;
	*/
	
	list<four_tuple<int, int, int, int>* >* newList = new list<four_tuple<int, int, int, int>* >;
        four_tuple<int, int, int, int>* currentTuple;
  
        // erste bindung
        currentTuple = new four_tuple <int, int, int, int> (0, 1, 1, 1);
        newList->append (currentTuple);

        // erste bindung
        currentTuple = new four_tuple <int, int, int, int> (0, 1, 3, 1);
        newList->append (currentTuple);

        // erste bindung
        currentTuple = new four_tuple <int, int, int, int> (0, 1, 1, 2);
        newList->append (currentTuple);



         return newList;
}

//------------------------------------------------------------------------------
// Funktionsname: fahrplanZusammenhangskomponenten
// Beschreibung: erzeugt die Liste der Zusammenhangskomponenten aus den Testdaten:
// 				 Zusammenhangskomponente (Haltest. A, Haltest. B, Liniennummer)
// Parameter: keine
// Rueckgabe: Zeiger auf die Liste
// Besonderheiten: Gibt einen Nullzeiger zurueck
//------------------------------------------------------------------------------
array<list<three_tuple<int,int,int>*> >* CTestklasse0::fahrplanZusammenhangskomponenten()
{
	return 0;
}

//------------------------------------------------------------------------------
// Funktionsname: holenFahrplan
// Beschreibung: erzeugt den Fahrplan aus den Testdaten
// Parameter: keine
// Rueckgabe: Zeiger auf den Fahrplan
// Besonderheiten: Gibt einen Nullzeiger zurueck
//------------------------------------------------------------------------------
list<CFahrplanElement*>* CTestklasse0::holenFahrplan()
{
	return 0;
}

//------------------------------------------------------------------------------
// Funktionsname: fahrplanDirekterAnschluss
// Beschreibung: erzeugt die Liste direkter Anschluesse fuer die Testdaten
// Parameter: keine
// Rueckgabe: Zeiger auf die Liste
// Besonderheiten: Gibt einen Nullzeiger zurueck
//------------------------------------------------------------------------------
list<four_tuple<int,int,int,int>* >* CTestklasse0::fahrplanDirekterAnschluss()
{
 	return 0;
}


//------------------------------------------------------------------------------
// Funktionsname: fahrplanMaximaleFahrzeuganzahl
// Beschreibung: gibt die maximale Fahrzeuganzahl fuer die Testdaten zurueck
// Parameter: keine
// Rueckgabe: Maximale Fahrzeuganzahl (int)
// Besonderheiten: Gibt Null zurueck, wird nicht verwendet, der richtige Wert
// 					in der GUI gesetzt
//------------------------------------------------------------------------------
int CTestklasse0::fahrplanMaximaleFahrzeuganzahl()
{
	return 0;
}


//------------------------------------------------------------------------------
// Funktionsname: fahrplanAbfahrtszeiten
// Beschreibung: gibt die Abfahrtszeiten aus den Testdaten zurueck
// Parameter: keine
// Rueckgabe: Zeiger auf das LEDA-Array mit den Abfahrtszeiten
// Besonderheiten: keine
//------------------------------------------------------------------------------
array<three_tuple<int,int,int>* >* CTestklasse0::fahrplanAbfahrtszeiten()
{
  array<three_tuple<int,int,int>* >* abfahrtszeiten = new array<three_tuple<int,int,int>* >(2);
  three_tuple<int,int,int>* haltestelle = new three_tuple<int,int,int>(1,1,13);
  cout << "Waehle Abfahrtszeit in 1. Zusammenhangskomponente (1,1,13)\n";
  abfahrtszeiten->set(0,haltestelle);
  haltestelle = new three_tuple<int,int,int>(8,2,47);
  cout << "Waehle Abfahrtszeit in 2. Zusammenhangskomponente (8,2,47)\n";
  abfahrtszeiten->set(1,haltestelle);
  return abfahrtszeiten;
}

//------------------------------------------------------------------------------
// Funktionsname: fahrplanMindesthaltezeit
// Beschreibung: gibt die Mindesthaltezeit aus den Testdaten zurueck
// Parameter: keine
// Rueckgabe: Zeiger auf das LEDA-h_array mit den Mindesthaltezeiten
// Besonderheiten: keine
//------------------------------------------------------------------------------
h_array<int,int>* CTestklasse0::fahrplanMindesthaltezeit()
{
  h_array<int, int>* mindestHaltezeit = new h_array<int,int>;
  
  (*mindestHaltezeit)[0] = 0;
  (*mindestHaltezeit)[1] = 0; 

  return mindestHaltezeit;
}

//------------------------------------------------------------------------------
// Funktionsname: fahrplanMindestumsteigezeit
// Beschreibung: gibt Mindestumsteigezeit aus den Testdaten zurueck
// Parameter: keine
// Rueckgabe: Zeiger auf das LEDA-h_array mit der Mindestumsteigezeit
// Besonderheiten: keine
//------------------------------------------------------------------------------
h_array<int,list<three_tuple<int,int,int>* >*>* CTestklasse0::fahrplanMindestumsteigezeit()
{
   h_array<int, list<three_tuple<int, int, int>* >* >*  mindestUmsteigezeit = 
    new h_array<int, list<three_tuple<int, int, int>* > *>;
  
  // tripel: liniennr1, liniennr2, mindestumsteigezeit
  three_tuple<int, int, int>* neuesTripel;
  list<three_tuple<int,int,int>*>* neueListe;

  // fuer 2. haltestelle
  neuesTripel = new three_tuple<int, int, int> (4, 1, 13);
  neueListe = new list<three_tuple<int, int, int>*>;
  neueListe->append (neuesTripel);
  (*mindestUmsteigezeit)[2] = neueListe;

   // fuer 5. haltestelle
  neuesTripel = new three_tuple<int, int, int> (3, 2, 7);
  neueListe = new list<three_tuple<int, int, int>*>;
  neueListe->append (neuesTripel);
  (*mindestUmsteigezeit)[4] = neueListe;

 // fuer 1. haltestelle
  neuesTripel = new three_tuple<int, int, int> (1, 3, 3);
  neueListe = new list<three_tuple<int, int, int>*>;
  neueListe->append (neuesTripel);
  (*mindestUmsteigezeit)[1] = neueListe;

  return mindestUmsteigezeit;
}

//------------------------------------------------------------------------------
// Funktionsname: fahrplanIntervall
// Beschreibung: gibt das Fahrplanintervall aus den Testdaten zurueck
// Parameter: keine
// Rueckgabe: Zeiger auf das Fahrplanintervall
// Besonderheiten: keine
//------------------------------------------------------------------------------
four_tuple<int,int,int,int>* CTestklasse0::fahrplanIntervall()
{
	// Dummy-Werte!!!!!
	
	four_tuple<int,int,int,int>* intervall = new four_tuple<int,int,int,int>(8,0,10,0);
  cout << "Der Fahrplan soll fuer den Zeitraum von 8.00 Uhr bis 10.00 Uhr erstellt werden !\n";
  return intervall;
}


// ----------------------------------------- Funktionen fuer die GUI ---------------------------------------------------


// holt die Startwerte der Haltestellen:
void CTestklasse0::holenHaltestellenModulParameter(int aufruf, int& algorithmus, int& zufallsgeneratorInitialisierung,
							double& minRadius, double& maxRadius, double& verbindungsRadiusStadt,
							double& verbindungsRadiusLand, int& radiustyp, double& haltestellenLage,
							double& toleranzgrenze, int& bevoelkerungsRaster, double& koeffizientBevoelkerungsueberversorgung,
							double& koeffizientBevoelkerungsunterversorgung, double& koeffizientFlaechenueberversorgung,
							double& koeffizientFlaechenunterversorgung, double& koeffizientFahrtwunscheinbeziehung,
							double& koeffizientStrassenanpassung)
{

	// default-werte fuer die Testklassen
	aufruf=0;
	zufallsgeneratorInitialisierung = 0;
	maxRadius = 450;
	minRadius = 200;
	verbindungsRadiusStadt = 1000;
	verbindungsRadiusLand = 1000;
	toleranzgrenze = 0.5;
	bevoelkerungsRaster=5;
	algorithmus=0;
	koeffizientBevoelkerungsueberversorgung=0.5;
	koeffizientBevoelkerungsunterversorgung=0.5;
	koeffizientFlaechenueberversorgung=0.5;
	koeffizientFlaechenunterversorgung=0.5; 
	koeffizientFahrtwunscheinbeziehung=0.5;
	koeffizientStrassenanpassung=0.5;
}


// holt die Startwerte des Linienplans:
void CTestklasse0::holenLinienplanModulParameter(int aufruf, int& gesamtlaenge, int& maxLinienLaenge,
							int& maxLinienAnzahl, double& linienplanID,
							int& geschwindigkeit, int& algorithmus, int& anzeigegraphen,
							bool& EindeutigeLinienverkn, bool& MehrdeutigeLinienverkn, 
							bool& Aufbruchsverknuepfung, bool& Linienendverknuepfung,
							bool& Basislinienwahl)
{
	linienplanID=0;
	gesamtlaenge=8000;
	maxLinienLaenge=3000;
	maxLinienAnzahl=4;
	geschwindigkeit=15;
	algorithmus=0;
	anzeigegraphen=0;
	EindeutigeLinienverkn=true;
	MehrdeutigeLinienverkn=true; 
	Aufbruchsverknuepfung=true; 
	Linienendverknuepfung=true;
	Basislinienwahl=true;
}


//------------------------------------------------------------------------------
// Funktionsname: holenDaten
// Beschreibung: Haltestellen Variante, erzeugt und uebergibt die Testdaten
// Parameter: Pflichthaltestellen, Strassennetz, Bevoelkerungsdichte, QuelleZielMatrix
// 				QuelleZielListe, Pendlermatrix, Pendlerliste
//				Alles als Referenzen auf Zeiger, welche im Idealfall leer sein sollten
// Rueckgabe: Die Referenzen sind mit den Testdaten gefuellt
// Besonderheiten: keine
//------------------------------------------------------------------------------
void CTestklasse0::speichernAusschnittStrassennetz()
{
	//das Strassennetz
	Debug(3,"Lege Strassennetz an");
	list<list<CPunkt*>*>* strassennetz = new list<list<CPunkt*>*>;
	list <CPunkt *> *strasse=new list <CPunkt *>;
	strasse->append(new CPunkt(P01));
	strasse->append(new CPunkt(P04));
	strasse->append(new CPunkt(P06));
	strasse->append(new CPunkt(P08));
	strassennetz->append(strasse);

	strasse=new list <CPunkt *>;
	strasse->append(new CPunkt(P14));
	strasse->append(new CPunkt(P15));
	strasse->append(new CPunkt(P16));
	strasse->append(new CPunkt(P17));
	strasse->append(new CPunkt(P18));
	strasse->append(new CPunkt(P19));
	strasse->append(new CPunkt(P20));
	strasse->append(new CPunkt(P22));
	strasse->append(new CPunkt(P23));
	strasse->append(new CPunkt(P24));
	strasse->append(new CPunkt(P25));
	strassennetz->append(strasse);

	strasse=new list <CPunkt *>;
	strasse->append(new CPunkt(P31));
	strasse->append(new CPunkt(P30));
	strasse->append(new CPunkt(P33));
	strasse->append(new CPunkt(P35));
	strassennetz->append(strasse);

	strasse=new list <CPunkt *>;
	strasse->append(new CPunkt(P03));
	strasse->append(new CPunkt(P04));
	strasse->append(new CPunkt(P12));
	strasse->append(new CPunkt(P18));
	strasse->append(new CPunkt(P26));
	strasse->append(new CPunkt(P28));
	strasse->append(new CPunkt(P33));
	strassennetz->append(strasse);

	strasse=new list <CPunkt *>;
	strasse->append(new CPunkt(P06));
	strasse->append(new CPunkt(P09));
	strasse->append(new CPunkt(P11));
	strasse->append(new CPunkt(P22));
	strasse->append(new CPunkt(P21));
	strasse->append(new CPunkt(P26));
	strasse->append(new CPunkt(P27));
	strasse->append(new CPunkt(P30));
	strasse->append(new CPunkt(P32));
	strassennetz->append(strasse);

	// Schiebe das Strassennetz in GRASS:
	lnkCGRASSSchnittstelle->speichernAusschnittStrassennetz(strassennetz);
	
	// und aufraeumen:
	delete strassennetz;
}