/* Generated by Together */

#ifndef CTESTKLASSE0_H
#define CTESTKLASSE0_H

#include "CDatenbank.h"

class CImport;


//class CDatenbank;
class CGUI;

/**
 * Testdatenlieferant. Enthaelt einen kleinen uebersichtlichen Satz Testdaten.
 *
 * Liefert solange Testdaten, bis die entsprechenden Funktionen aus der Datenbank 
 * implementiert (d.h. dort ueberschrieben) wurden.
 *
 *
 */
class CTestklasse0 : public CDatenbank{

public:
        // Konstruktor
	CTestklasse0(char*);
	~CTestklasse0();

	
    /**
	 * Eine ueberladene Funktion. Liefert die angeforderten
     * Werte an die aufrufende Schnittstelle zurueck. Benoetigte
     * Datenstrukturen werden dabei automatisch erzeugt. Daten aus
     * den Datenbanken muessen dabei vor einer Uebergabe an die Module
     * kopiert werden.
     * 
     * Wichtig: Werte, die von der GUI kommen sollen, werden hier NICHT
     * zurueckgegeben
	 *
	 * hole Daten fuer die Haltestellen: 
     *
     * @param pflichtHS Pflichthaltestellen
     * @param strassennetz Strassennetz
     * @param dichte Bevoelkerungsdichte
     * @param quelleZielMatrix Quelle-Ziel-Matrix
     * @param quelleZielListe Quelle-Ziel-Liste
     * @param pendlerMatrix Pendlermatrix
     * @param pendlerListe Pendlerliste
     */
    void holenDaten(list<CPunkt*>*&, list<list<CPunkt*>*>*&, list<list<CPunkt*>*>*& wege,
	list<CBevoelkerungsdichteElement*>*&, matrix*&,
	list<CQuelleZielListeElement*>*&, matrix*&,
	list<CPendlerListeElement*>*&, list<list<CPunkt*>*>*&);

    /** 
	 * hole Daten fuer den Linienplan: 
     *
     * Parameter bedeuten dabei von links nach rechts:
     * @param verkehrsbedarfmatrix QuelleZielMatrix
     * @param vorgegebeneLinien vorgegebene Linien
     * @param wegenetzGraph Wegenetzgraph
     */
	void holenDaten(matrix*&, list<CLinie*>*&, UGRAPH<CWegenetzKnoten*,CWegenetzKante*>*&);
        matrix* holenLinienplanQuelleZielMatrix();
	list<CLinie*>* holenLinienplanVorgegebeneLinien();
	UGRAPH<CWegenetzKnoten*,CWegenetzKante*>* holenLinienplanWegenetzgraph();

    /** hole den Linienplan
	 * @return Zeiger auf den Linienplan aus den Testdaten
	 */
	GRAPH<CFPlanGraphKnoten*, CFPlanGraphKante*>* fahrplanLinienplan();	
        
	/** Liefert Feste Verbindungen (Hst-ID, Liniennr.1, Liniennr.2, Hst-ID):
	 * @return Zeiger auf die festen Verbindungen
	 */
	list<four_tuple<int,int,int,int>*>* fahrplanFesteVerbindungen(); 
	
	/** Liefert Zusammenhangskomponente (Haltest. A, Haltest. B, Liniennummer):
	 * @return Zeiger auf die Liste der Zusammenhangskomponenten
	 */
	array<list<three_tuple<int,int,int>*> >* fahrplanZusammenhangskomponenten();
	
	/** liefert einen Fahrplan:
	 * @return Zeiger auf den Fahrplan
	 */
	list<CFahrplanElement*>* holenFahrplan();

	/** liefert den direkten Anschluss
	 * @return Zeiger auf die Liste direkter Anschluesse fuer die Testdaten
	 */
	list<four_tuple<int,int,int,int>* >* fahrplanDirekterAnschluss(); 
	
	/** liefert die maximale Fahrzeuganzahl
	 * @return Maximale Fahrzeuganzahl
	 */
	int fahrplanMaximaleFahrzeuganzahl(); 
	
	
	/** holt die Abfahrtszeiten
	 * @return Zeiger auf das LEDA-Array mit den Abfahrtszeiten
	 */
	array<three_tuple<int,int,int>* >* fahrplanAbfahrtszeiten(); 
	
	/** holt die Mindesthaltezeit
	 * @return Zeiger auf das LEDA-h_array mit den Mindesthaltezeiten
	 */
	h_array<int,int>* fahrplanMindesthaltezeit(); 
	
	/** holt Mindestumsteigezeit
	 * @return Zeiger auf das LEDA-h_array mit der Mindestumsteigezeit
	 */
	h_array<int,list<three_tuple<int,int,int>* >*>* fahrplanMindestumsteigezeit(); 
	
	/** holt das Fahrplanintervall
	 * @return Zeiger auf das Fahrplanintervall
	 */
	four_tuple<int,int,int,int>* fahrplanIntervall(); 


	/**
	 * Folgende Funktionen dienen der GUI:
     * sie kann auf diese Weise Daten in die Datenbank schieben und
	 * auch wieder herausholen
	 */
	
	// holt die Startwerte der Haltestellen:
	void holenHaltestellenModulParameter(int aufruf, int& algorithmus, int& zufallsgeneratorInitialisierung,
							double& minRadius, double& maxRadius, double& verbindungsRadiusStadt,
							double& verbindungsRadiusLand, int& radiustyp, double& haltestellenLage,
							double& toleranzgrenze, int& bevoelkerungsRaster, double& koeffizientBevoelkerungsueberversorgung,
							double& koeffizientBevoelkerungsunterversorgung, double& koeffizientFlaechenueberversorgung,
							double& koeffizientFlaechenunterversorgung, double& koeffizientFahrtwunscheinbeziehung,
							double& koeffizientStrassenanpassung);
	
	
	// holt die Startwerte des Linienplans:
	void holenLinienplanModulParameter(int aufruf, int& gesamtlaenge, int& maxLinienLaenge, 
							int& maxLinienAnzahl, double& linienplanID,
							int& geschwindigkeit, int& algorithmus, int& anzeigegraphen,
							bool& EindeutigeLinienverkn, bool& MehrdeutigeLinienverkn, 
							bool& Aufbruchsverknuepfung, bool& Linienendverknuepfung,
							bool& Basislinienwahl);
        // diese Funktion speichert einen Teil des Strassennetzes in einem eigenen Layer
	// hiermit wird der Strassenplan in den einzelnen Testfaellen zu Anzeige abgespeichert
	// wird u.a. von der GUI aufgerufen
        void speichernAusschnittStrassennetz();
	

};
#endif //CTESTKLASSE0_H
