/* Generated by Together */

#include "CTestklasse4.h"


CTestklasse4::CTestklasse4(char* db_username) : CDatenbank(db_username)
{
}
CTestklasse4::~CTestklasse4()
{
	if(lnkCGRASSSchnittstelle!=0) delete lnkCGRASSSchnittstelle;
	lnkCGRASSSchnittstelle=0;
	if(lnkCDBSchnittstelle!=0) delete lnkCDBSchnittstelle;
	lnkCDBSchnittstelle=0;
}

// -------------------- Haltestellen: -----------------------------------------------------------------------
// Haltestellen:
void CTestklasse4::holenDaten(list<CPunkt*>*& pflichthaltestellen, 
			    list<list<CPunkt*>*>*& strassennetz, 
			    list<list<CPunkt*>*>*& wege,
			    list<CBevoelkerungsdichteElement*>*& bevoelkerungsdichte, 
			    matrix*& quellezielmatrix, 
			    list<CQuelleZielListeElement*>*& quellezielliste, 
			    matrix*& pendlermatrix, 
			    list<CPendlerListeElement*>*& pendlerliste,
			    list<list<CPunkt*>*>*& gebaeude)
{

	// Bevoelkerungsdichte.
	//ToDo: Bevoelkerungsdichte von ganz Herne aus der Datenbank holen
	bevoelkerungsdichte = new list<CBevoelkerungsdichteElement*>;
	bevoelkerungsdichte->append (new CBevoelkerungsdichteElement(new CPunkt(2577500,5717150),200000,100000));
		
	// pflichthaltestellen kommen aus GRASS
	pflichthaltestellen=lnkCGRASSSchnittstelle->holenPflichthaltestellen();
	
	// strassennetz kommt aus GRASS
	strassennetz=lnkCGRASSSchnittstelle->holenStadtplan();
	gebaeude=lnkCGRASSSchnittstelle->holenGebaeude();

	wege=lnkCGRASSSchnittstelle->holenWege();
	
	cout <<"Strassennetz clippen\n";
	/**
	 * Das Strassennetz clippen!
	 * Das Rechteck hat die Koordinanten:
	 *
	 *	Links oben:   	2580380.82,  5717341.92
	 *	Rechts unten:          2586076.12,  5714814.63
	 */
	strassennetz = clippenStrassennetz(strassennetz, 2580380.82,  5717341.92,  2586076.12,  5714814.63);
	wege = clippenStrassennetz(wege, 2580380.82,  5717341.92,  2586076.12,  5714814.63);
	
	cout <<"Clipping beendet\n";
	lnkCGRASSSchnittstelle->speichernAusschnittStrassennetz(strassennetz);
		
}


bool CTestklasse4::seinInRechteck(double xKoord_grenzeLO, double yKoord_grenzeLO,
			             double xKoord_grenzeRU, double yKoord_grenzeRU, CPunkt * testPunkt)
{
	/**
	 * Testet einen Punkt, ob dieser in einem durch die Grenzpunkte definierten Rechteck liegt
	 */
	//Debug(2, "seinInRechteck()");
	double xKoord_testPunkt = testPunkt->holenX();
	double yKoord_testPunkt = testPunkt->holenY();
		
	//Ueberpruefung, ob ein Punkt in den von den Grenzpunkten definiertem Rechteck liegt	
	if ((xKoord_grenzeLO <= xKoord_testPunkt) && (xKoord_testPunkt<= xKoord_grenzeRU))
	{
		if ((yKoord_grenzeRU <= yKoord_testPunkt) && (yKoord_testPunkt<= yKoord_grenzeLO))
		return true;
		else
		return false;
	}
	else
	return false;
}



list<list<CPunkt* >*>* CTestklasse4::clippenStrassennetz(list<list<CPunkt* > * > * strassennetz,
						 double grenzeLinksOben_X, double grenzeLinksOben_Y,
						 double grenzeRechtsUnten_X, double grenzeRechtsUnten_Y)
{
                 //Debug(2, "clippenStrassennetz()");
	bool schnittpunktVorhanden;
	//Die Strasse aus dem Strassennetz
	list<CPunkt * >* strasse = new list<CPunkt *>; 		
	//Die geclippte Strasse
	list<CPunkt * > * geclippteStrasse = new list<CPunkt * >;
	
	CPunkt * merkPunkt;
	list<list<CPunkt* >*>* geclipptesStrassennetz = new   list<list<CPunkt* >*>;
	
	
	//Fuer alle Strassen, die sich im Strassennetz befinden
	forall (strasse, * strassennetz)
	{
		schnittpunktVorhanden=false;
		geclippteStrasse = new list<CPunkt * >;
		
		forall(merkPunkt, *strasse)
		{
			if (seinInRechteck(grenzeLinksOben_X, grenzeLinksOben_Y, grenzeRechtsUnten_X, grenzeRechtsUnten_Y, merkPunkt))
			{
				schnittpunktVorhanden=true;
				geclippteStrasse->append(merkPunkt);		
			}
		};
		if(schnittpunktVorhanden)
		geclipptesStrassennetz->append(geclippteStrasse);
	   	
	}       // Ende for ueber alle Strassen des Strassennetzes

	return geclipptesStrassennetz;
}


// -------------------- GUI: --------------------------------------------------------------------------------
void CTestklasse4::speichernAusschnittStrassennetz()
{
	list<list<CPunkt* >*>* strassennetz=lnkCGRASSSchnittstelle->holenStadtplan();
	
	cout <<"Strassennetz clippen\n";
	/**
	 * Das Strassennetz clippen!
	 * Das Rechteck hat die Koordinanten:
	 *
	 *	Links oben:   	2580380.82,  5717341.92
	 *	Rechts unten:          2586076.12,  5714814.63
	 */
	strassennetz = clippenStrassennetz(strassennetz, 2580380.82,  5717341.92,  2586076.12,  5714814.63);
	
	cout <<"Clipping beendet\n";
	
 	lnkCGRASSSchnittstelle->speichernAusschnittStrassennetz(strassennetz);
}

