/* Generated by Together */

#include "CTestklasse5.h"

CTestklasse5::CTestklasse5(char* db_username) : CDatenbank(db_username)
{
}
CTestklasse5::~CTestklasse5()
{
	if(lnkCGRASSSchnittstelle!=0) delete lnkCGRASSSchnittstelle;
	lnkCGRASSSchnittstelle=0;
	if(lnkCDBSchnittstelle!=0) delete lnkCDBSchnittstelle;
	lnkCDBSchnittstelle=0;
}

// -------------------- Haltestellen: -----------------------------------------------------------------------
// Haltestellen:
void CTestklasse5::holenDaten(list<CPunkt*>*& pflichthaltestellen, 
			    list<list<CPunkt*>*>*& strassennetz, 
			    list<list<CPunkt*>*>*& wege,
			    list<CBevoelkerungsdichteElement*>*& bevoelkerungsdichte, 
			    matrix*& quellezielmatrix, 
			    list<CQuelleZielListeElement*>*& quellezielliste, 
			    matrix*& pendlermatrix, 
			    list<CPendlerListeElement*>*& pendlerliste,
			    list<list<CPunkt*>*>*& gebaeude)
{


	// Bevoelkerungsdichte NOCH DUMMY-DATEN!!!!!!!!!!!
	bevoelkerungsdichte = new list<CBevoelkerungsdichteElement*>;
	bevoelkerungsdichte->append (new CBevoelkerungsdichteElement(new CPunkt(2577500,5717150),200000,100000));
		
	// pflichthaltestellen kommen aus GRASS
	pflichthaltestellen=lnkCGRASSSchnittstelle->holenPflichthaltestellen();
	// strassennetz kommt aus GRASS
	strassennetz=lnkCGRASSSchnittstelle->holenStadtplan();
	wege=lnkCGRASSSchnittstelle->holenWege();
	
	/**
	 * Das Strassennetz clippen!
	 * Das Rechteck hat die Koordinanten:
	 *
	 *	Links oben:   	2589511.09,  5716985.97
	 *	Rechts unten:          2592162.96,  5713675.58
	 */
	 strassennetz = clippenStrassennetz(strassennetz, 2589511.09,  5716985.97, 2592162.96,  5713675.58);
	 wege = clippenStrassennetz(wege,2589511.09,  5716985.97, 2592162.96,  5713675.58); 
	
	 cout <<"Clipping beendet\n";
	 cout <<"Visualisierung starten.\n";
	 lnkCGRASSSchnittstelle->speichernAusschnittStrassennetz(strassennetz);
	
	 gebaeude=lnkCGRASSSchnittstelle->holenGebaeude();
	
	
}



bool CTestklasse5::seinInRechteck(double xKoord_grenzeLO, double yKoord_grenzeLO,
			             double xKoord_grenzeRU, double yKoord_grenzeRU, CPunkt * testPunkt)
{
	
	/**
	 * Testet einen Punkt, ob dieser in einem durch die Grenzpunkte definierten Rechteck liegt
	 */
	//Debug(2, "seinInRechteck()");
	double xKoord_testPunkt = testPunkt->holenX();
	double yKoord_testPunkt = testPunkt->holenY();
		
	//Ueberpruefung, ob ein Punkt in den von den Grenzpunkten definiertem Rechteck liegt	
	if ((xKoord_grenzeLO <= xKoord_testPunkt) && (xKoord_testPunkt<= xKoord_grenzeRU))
	{
		if ((yKoord_grenzeRU <= yKoord_testPunkt) && (yKoord_testPunkt<= yKoord_grenzeLO))
		return true;
		else
		return false;
	}
	else
	return false;
}

list<list<CPunkt* >*>* CTestklasse5::clippenStrassennetz(list<list<CPunkt* > * > * strassennetz,
						 double grenzeLinksOben_X, double grenzeLinksOben_Y,
 						 double grenzeRechtsUnten_X, double grenzeRechtsUnten_Y)
{

	/**
	 * Diese Methode schneidet alle Strassen, die in dem durch die Grenzpunkte definierten Rechteck liegen, ab.
	 */
	//Debug(2, "clippenStrassennetz()");
	bool schnittpunktVorhanden;
	
	//Die Strasse aus dem Strassennetz
	list<CPunkt * >* strasse = new list<CPunkt *>; 		
	
	//Die geclippte Strasse
	list<CPunkt * > * geclippteStrasse = new list<CPunkt * >;
	
	CPunkt * merkPunkt;
	
	//Die Liste der Strassen, die zurueckgegeben wird.
	list<list<CPunkt* >*>* geclipptesStrassennetz = new   list<list<CPunkt* >*>;
	
	
	//Fuer alle Strassen, die sich im Strassennetz befinden
	forall (strasse, * strassennetz)
	{
		schnittpunktVorhanden=false;
		geclippteStrasse = new list<CPunkt * >;
		
		forall(merkPunkt, *strasse)
		{
			if (seinInRechteck(grenzeLinksOben_X, grenzeLinksOben_Y, grenzeRechtsUnten_X, grenzeRechtsUnten_Y, merkPunkt))
			{
				schnittpunktVorhanden=true;
				geclippteStrasse->append(merkPunkt);
			}
		};
		if(schnittpunktVorhanden)
		geclipptesStrassennetz->append(geclippteStrasse);
	   	
	} // Ende Iteration ueber alle Strassen des Strassennetzes

	return geclipptesStrassennetz;
} 						
 						
// -------------------- GUI: --------------------------------------------------------------------------------
void CTestklasse5::speichernAusschnittStrassennetz()
{

	list<list<CPunkt* >*>*  strassennetz=lnkCGRASSSchnittstelle->holenStadtplan();
		
	/**
	 * Das Strassennetz clippen!
	 * Das Rechteck hat die Koordinanten:
	 *
	 *	Links oben:   	2589511.09,  5716985.97
	 *	Rechts unten:          2592162.96,  5713675.58
	 */
	strassennetz = clippenStrassennetz(strassennetz, 2589511.09,  5716985.97, 2592162.96,  5713675.58);
	
 	lnkCGRASSSchnittstelle->speichernAusschnittStrassennetz(strassennetz);
}
