/* Generated by Together */

#ifndef CTESTKLASSE5_H
#define CTESTKLASSE5_H

#include "CDatenbank.h"


//#include "CNetzplangenerator.h"

class CImport;


/**
 * Schnittstelle zur Datenbank 
 * verarbeitet Datenzugriffe und vermitelt diese auf die Datenquellen (DB, GRASS) 
 *
 *
 *
 * Das Vorgehen ist dabei Folgendes: solange diese einzelnen Funktionen noch nicht implementiert
 * sind, werden automatisch die gleichnamigen Funktionen aus der Basisklasse verwendet, die dann
 * entsprechend ihre Testdaten absondern.
 * 
 * Immer wenn die entsprechenden Punkte implementiert wurden, braucht man sie hier nur zu ueberschreiben
 *
 *
 *
 */

class CTestklasse5 : public CDatenbank {


public:

	CTestklasse5(char*);
	~CTestklasse5();

        

        // -------------------- Haltestellen: -----------------------------------------------------------------------
        /**
	 * hole Daten fuer die Haltestellen: 
         *
         * Parameter bedeuten dabei von links nach rechts:
         * @param Pflichthaltestellen
         * @param Strassennetz
         * @param Bevoelkerungsdichte
         * @param Quelle-Ziel-Matrix
         * @param Quelle-Ziel-Liste
         * @param Pendlermatrix
         * @param Pendlerliste
         */
        void holenDaten(list<CPunkt*>*&, list<list<CPunkt*>*>*&, list<list<CPunkt*>*>*& wege,
		list<CBevoelkerungsdichteElement*>*&, matrix*&,
		list<CQuelleZielListeElement*>*&, matrix*&,
		list<CPendlerListeElement*>*&,
		list<list<CPunkt*>*>*&);
		
	// -------------------- GUI: --------------------------------------------------------------------------------
	// diese Funktion speichert einen Teil des Strassennetzes in einem eigenen Layer
	// hiermit wird der Strassenplan in den einzelnen Testfaellen zu Anzeige abgespeichert
	// wird u.a. von der GUI aufgerufen
       void speichernAusschnittStrassennetz();


private:

         /**
          * Testet einen Punkt, ob dieser in einem durch die Grenzpunkte definierten Rechteck liegt
          */
         bool seinInRechteck(double xKoord_grenzeLO, double yKoord_grenzeLO,
		             double xKoord_grenzeRU, double yKoord_grenzeRU, CPunkt * testPunkt);

         /**
          * Diese Methode clippt alle Strassen, die in dem durch die Grenzpunkte definierten Rechteck liegen
          */
         list<list<CPunkt* >*>* clippenStrassennetz(list<list<CPunkt* > * > * strassennetz, double grenzeLinksOben_X, double grenzeLinksOben_Y, double grenzeRechtsUnten_X, double grenzeRechtsUnten_Y );

};
#endif //CTESTKLASSE5_H
