/* Generated by Together */

#include "CTestklasse6.h"
#include "Testkoordinaten.h"
#include "../Datenstruktur/Debug.h"
#include <stdlib.h>

CTestklasse6::CTestklasse6(char* db_username):CDatenbank(db_username)
{
}
CTestklasse6::~CTestklasse6()
{
	if(lnkCGRASSSchnittstelle!=0) delete lnkCGRASSSchnittstelle;
	lnkCGRASSSchnittstelle=0;
	if(lnkCDBSchnittstelle!=0) delete lnkCDBSchnittstelle;
	lnkCDBSchnittstelle=0;
}



// -------------------- Fahrplan: ---------------------------------------------------------------------------
// Fahrplan:
GRAPH<CFPlanGraphKnoten*, CFPlanGraphKante*>* CTestklasse6::fahrplanLinienplan() // holt Ergebnis des Linienplans
{
	Debug (3,"Lege QuelleZielMatrix (5 x 5) an");
	
	/* Array anlegen, das in die Matrix eingehangen wird */
	double qzArray[35] =   { 	00, 30, 20, 30, 40,
				30, 00, 20, 40, 30,
				20, 20, 00, 20, 40,
				30, 40, 20, 00, 20,
				40, 30, 40, 20, 00 };
				
	matrix* quellezielmatrix = new matrix(5,5,qzArray);

	Debug (3,"Lege Wegenetzgraph an");
	UGRAPH<CWegenetzKnoten*,CWegenetzKante*>* wegenetzGraph = new UGRAPH<CWegenetzKnoten*,CWegenetzKante*>;
	node ka[5];
	CWegenetzKante *kante;

	CWegenetzKnoten* beschriftung = new CWegenetzKnoten(0,10, new CPunkt(2585115.04,5715134.99)); 	//Alle Knoten kriegen Prioritaet 10
	ka[0]=wegenetzGraph->new_node(beschriftung);
        	beschriftung = new CWegenetzKnoten(1,10, new CPunkt(2585115.04, 5715154.99)); 	
	ka[1]=wegenetzGraph->new_node(beschriftung);
	beschriftung = new CWegenetzKnoten(2,10, new CPunkt(2585115.04,5715174.99)); 	
	ka[2]=wegenetzGraph->new_node(beschriftung);
	beschriftung = new CWegenetzKnoten(3,10, new CPunkt(2585115.04,5715194.99)); 	
	ka[3]=wegenetzGraph->new_node(beschriftung);
	beschriftung = new CWegenetzKnoten(4,10, new CPunkt(2585115.04,5715214.99)); 	
	ka[4]=wegenetzGraph->new_node(beschriftung);

	list<CPunkt*>* dummyliste=NULL;

	kante=new CWegenetzKante(300);
	dummyliste=new list<CPunkt*>;
	dummyliste->append(new CPunkt(2585115.04,5715134.99));
	dummyliste->append(new CPunkt(2585115.04,5715154.99));
	kante->setzenKantenListe(dummyliste);
	wegenetzGraph->new_edge(ka[0],ka[1],kante);
	kante=new CWegenetzKante(100);
	dummyliste=new list<CPunkt*>;
	dummyliste->append(new CPunkt(2585115.04,5715154.99));
	dummyliste->append(new CPunkt(2585115.04,5715174.99));
	kante->setzenKantenListe(dummyliste);
	wegenetzGraph->new_edge(ka[1],ka[2],kante);
	kante=new CWegenetzKante(1000);
	dummyliste=new list<CPunkt*>;
	dummyliste->append(new CPunkt(2585115.04,5715174.99));
	dummyliste->append(new CPunkt(2585115.04,5715194.99));
	kante->setzenKantenListe(dummyliste);
	wegenetzGraph->new_edge(ka[2],ka[3],kante);
	kante=new CWegenetzKante(200);
	dummyliste=new list<CPunkt*>;
	dummyliste->append(new CPunkt(2585115.04,5715194.99));
	dummyliste->append(new CPunkt(2585115.04,5715214.99));
	kante->setzenKantenListe(dummyliste);
	wegenetzGraph->new_edge(ka[3],ka[4],kante);
	
	
	Debug (2,"LP-Testdaten erzeugt");

	// Ausgangsdaten in der DB speichern:
	Debug(2, "Testdaten von den Haltestellen werden als Grundlage des Linienplans gespeichert");
	speichernDaten(wegenetzGraph, quellezielmatrix );







	node knotenArray[5];
        	GRAPH<CFPlanGraphKnoten*,CFPlanGraphKante*>* linienplan = new GRAPH<CFPlanGraphKnoten*,CFPlanGraphKante*>();
	CFPlanGraphKante* neKante;

	// Erzeuge die Knoten und beschrifte sie
	//Debug(3, "linienplandummydaten Knoten werden erzeugt");
	for(int i=0; i<5; i++){
		CFPlanGraphKnoten* nenKnoten = new CFPlanGraphKnoten();
		nenKnoten->setzenID(i);
		knotenArray[i] = linienplan->new_node(nenKnoten);
	}

	// Erzeuge die Kanten und fuelle sie mit Leben
	// Aufbau der Linienbeschreibung: (vonKnoten,zuKnoten)/Fahrgaststrom(Kantenlaenge, Kantenzeit in Sekunden)
	// Kantenzeit in Sec = Kantenlaenge/4.17 (entspricht 15Km/h)
	// Linie 1: (1,2)/305(150,35) (2,3)/301(350,84) (3,5)/468(83,20) (5,6)/359(323,77)


	//Linie1: 0,1,2-----------------------------------------------------------------		
	
	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(3);
	neKante->setzenVerkehrsstrom(285);
	neKante->setzenLinienID(1);
	linienplan->new_edge(knotenArray[0], knotenArray[1], neKante);
	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(3);
	neKante->setzenVerkehrsstrom(285);
	neKante->setzenLinienID(-1);
	linienplan->new_edge(knotenArray[1], knotenArray[0], neKante);
	
	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(5);
	neKante->setzenVerkehrsstrom(240);
	neKante->setzenLinienID(1);
	linienplan->new_edge(knotenArray[1], knotenArray[2], neKante);
	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(5);
	neKante->setzenVerkehrsstrom(240);
	neKante->setzenLinienID(-1);
	linienplan->new_edge(knotenArray[2], knotenArray[1], neKante);
	                 	
	
	// Linie 2: 2,3,4--------------------------------------------------------------

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(1);
	neKante->setzenVerkehrsstrom(160);
	neKante->setzenLinienID(2);
	linienplan->new_edge(knotenArray[2], knotenArray[3], neKante);
	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(1);
	neKante->setzenVerkehrsstrom(160);
	neKante->setzenLinienID(-2);
	linienplan->new_edge(knotenArray[3], knotenArray[2], neKante);
	
	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(7);
	neKante->setzenVerkehrsstrom(285);
	neKante->setzenLinienID(2);
	linienplan->new_edge(knotenArray[3], knotenArray[4], neKante);
	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(7);
	neKante->setzenVerkehrsstrom(285);
	neKante->setzenLinienID(-2);
	linienplan->new_edge(knotenArray[4], knotenArray[3], neKante);
	

			
	list<CLinie*>* buslinien=new list<CLinie*>;
	CLinie* eineLinie=new CLinie();
	list<int>* lisths=new list<int>; // Linie 1: 0,1,2
	lisths->append(0);
	lisths->append(1);
	lisths->append(2);
	eineLinie->setzenID(1);
	eineLinie->setzenhListe(lisths);
	buslinien->append(eineLinie); 

	//Linie 2: 2,3,4
        	eineLinie=new CLinie();
	lisths=new list<int>;
	lisths->append(2);
	lisths->append(3);
	lisths->append(4);
	eineLinie->setzenID(2);
	eineLinie->setzenhListe(lisths);
	buslinien->append(eineLinie); 

	
	Debug(2, "Vor speichern in DB");

	speichernDaten(linienplan, buslinien);

	// Da in der Datenbank alle Daten geloescht werden, muessen wir nochmal alles fuer den Fahrplan anlegen:





        Debug(2, "Neu erzeugen");

	//node knotenArray[12];
        	linienplan = new GRAPH<CFPlanGraphKnoten*,CFPlanGraphKante*>();

	// Erzeuge die Knoten und beschrifte sie
	//Debug(3, "linienplandummydaten Knoten werden erzeugt");
	for(int i=0; i<5; i++){
		CFPlanGraphKnoten* nenKnoten = new CFPlanGraphKnoten();
		nenKnoten->setzenID(i);
		knotenArray[i] = linienplan->new_node(nenKnoten);
	}

	// Erzeuge die Kanten und fuelle sie mit Leben
	// Aufbau der Linienbeschreibung: (vonKnoten,zuKnoten)/Fahrgaststrom(Kantenlaenge, Kantenzeit in Sekunden)
	// Kantenzeit in Sec = Kantenlaenge/4.17 (entspricht 15Km/h)
	


	//Linie1: 0,1,2-----------------------------------------------------------------		
	
	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(3);
	neKante->setzenVerkehrsstrom(285);
	neKante->setzenLinienID(1);
	linienplan->new_edge(knotenArray[0], knotenArray[1], neKante);
	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(3);
	neKante->setzenVerkehrsstrom(285);
	neKante->setzenLinienID(-1);
	linienplan->new_edge(knotenArray[1], knotenArray[0], neKante);
	
	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(5);
	neKante->setzenVerkehrsstrom(240);
	neKante->setzenLinienID(1);
	linienplan->new_edge(knotenArray[1], knotenArray[2], neKante);
	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(5);
	neKante->setzenVerkehrsstrom(240);
	neKante->setzenLinienID(-1);
	linienplan->new_edge(knotenArray[2], knotenArray[1], neKante);
	                 	
	
	// Linie 2: 2,3,4--------------------------------------------------------------

	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(1);
	neKante->setzenVerkehrsstrom(160);
	neKante->setzenLinienID(2);
	linienplan->new_edge(knotenArray[2], knotenArray[3], neKante);
	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(1);
	neKante->setzenVerkehrsstrom(160);
	neKante->setzenLinienID(-2);
	linienplan->new_edge(knotenArray[3], knotenArray[2], neKante);
	
	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(7);
	neKante->setzenVerkehrsstrom(285);
	neKante->setzenLinienID(2);
	linienplan->new_edge(knotenArray[3], knotenArray[4], neKante);
	neKante = new CFPlanGraphKante();
	neKante->setzenFahrtzeit(7);
	neKante->setzenVerkehrsstrom(285);
	neKante->setzenLinienID(-2);
	linienplan->new_edge(knotenArray[4], knotenArray[3], neKante);

	return linienplan;
}
/** holt Mindestumsteigezeit
  * @return Zeiger auf das LEDA-h_array mit der Mindestumsteigezeit
*/
h_array<int,list<three_tuple<int,int,int>* >*>* CTestklasse6::fahrplanMindestumsteigezeit()
{
	h_array<int, list<three_tuple<int, int, int>* >* >*  mindestUmsteigezeit = 
    	new h_array<int, list<three_tuple<int, int, int>* > *>;
  
	// tripel: liniennr1, liniennr2, mindestumsteigezeit
  	three_tuple<int, int, int>* neuesTripel;
  	list<three_tuple<int,int,int>*>* neueListe;

  	// fuer 2. haltestelle
  	neuesTripel = new three_tuple<int, int, int> (4, 1, 13);
  	neueListe = new list<three_tuple<int, int, int>*>;
  	neueListe->append (neuesTripel);
  	(*mindestUmsteigezeit)[2] = neueListe;

   	// fuer 5. haltestelle
  	neuesTripel = new three_tuple<int, int, int> (3, 2, 7);
  	neueListe = new list<three_tuple<int, int, int>*>;
  	neueListe->append (neuesTripel);
  	(*mindestUmsteigezeit)[4] = neueListe;

 	// fuer 1. haltestelle
  	neuesTripel = new three_tuple<int, int, int> (1, 3, 3);
  	neueListe = new list<three_tuple<int, int, int>*>;
  	neueListe->append (neuesTripel);
  	(*mindestUmsteigezeit)[1] = neueListe;

  	return mindestUmsteigezeit;
} 
/** holt die Mindesthaltezeit
 * @return Zeiger auf das LEDA-h_array mit den Mindesthaltezeiten
 */
h_array<int,int>* CTestklasse6::fahrplanMindesthaltezeit()
{
	h_array<int, int>* mindestHaltezeit = new h_array<int,int>;
  
  	(*mindestHaltezeit)[0] = 0;
  	(*mindestHaltezeit)[1] = 0; 

  	return mindestHaltezeit;
}

// erzeugt die Liste direkter Anschluesse fuer die Testdaten
list<four_tuple<int,int,int,int>* >* CTestklasse6::fahrplanDirekterAnschluss()
{
 	return 0;
}
// gibt die maximale Fahrzeuganzahl fuer die Testdaten zurueck
int CTestklasse6::fahrplanMaximaleFahrzeuganzahl()
{
	return 0;
}

// gibt die Abfahrtszeiten aus den Testdaten zurueck
array<three_tuple<int,int,int>* >* CTestklasse6::fahrplanAbfahrtszeiten()
{
  	array<three_tuple<int,int,int>* >* abfahrtszeiten = new array<three_tuple<int,int,int>* >(2);
  	three_tuple<int,int,int>* haltestelle = new three_tuple<int,int,int>(1,6,13);
  	cout << "Waehle Abfahrtszeit in 1. Zusammenhangskomponente (1,6,13)\n";
  	abfahrtszeiten->set(0,haltestelle);
  	haltestelle = new three_tuple<int,int,int>(8,2,47);
  	cout << "Waehle Abfahrtszeit in 2. Zusammenhangskomponente (8,2,47)\n";
  	abfahrtszeiten->set(1,haltestelle);
  	return abfahrtszeiten;
}
// gibt das Fahrplanintervall aus den Testdaten zurueck
four_tuple<int,int,int,int>* CTestklasse6::fahrplanIntervall()
{
	// Dummy-Werte!!!!!
	
	four_tuple<int,int,int,int>* intervall = new four_tuple<int,int,int,int>(8,0,10,0);
  	cout << "Der Fahrplan soll fuer den Zeitraum von 8.00 Uhr bis 10.00 Uhr erstellt werden !\n";
  	return intervall;
}

CGuetemasse * CTestklasse6::holenGuetemasse()
{
                 Debug (3,"Guetemasse-Objekt anlegen und uebergeben");

                 //Objekt anlegen
                 CGuetemasse * testGuetemasse = new CGuetemasse();

                 //Objekt mit Werten fuellen
                 testGuetemasse->speichernAnzahlHaltestellen(11);

                 double qzArray[25] =   { 	00, 30, 20, 30, 40,
				30, 00, 20, 40, 30,
				20, 20, 00, 20, 40,
				30, 40, 20, 00, 20,
				40, 30, 40, 20, 00	};
	qzMatrix = new matrix(5,5,qzArray);
                 testGuetemasse->setzenQuelleZielMatrix(qzMatrix);

                 testGuetemasse->setzenLinienanzahl(7);

                 return testGuetemasse;
}



