
/* Result Sets Interface */
#ifndef SQL_CRSR
#  define SQL_CRSR
  struct sql_cursor
  {
    unsigned int curocn;
    void *ptr1;
    void *ptr2;
    unsigned long magic;
  };
  typedef struct sql_cursor sql_cursor;
  typedef struct sql_cursor SQL_CURSOR;
#endif /* SQL_CRSR */

/* Thread Safety */
typedef void * sql_context;
typedef void * SQL_CONTEXT;

/* File name & Package Name */
struct sqlcxp
{
  unsigned short fillen;
           char  filnam[20];
};
static const struct sqlcxp sqlfpn =
{
    19,
    "CDBSchnittstelle.pc"
};


static unsigned long sqlctx = 35848259;


static struct sqlexd {
   unsigned int   sqlvsn;
   unsigned int   arrsiz;
   unsigned int   iters;
   unsigned int   offset;
   unsigned short selerr;
   unsigned short sqlety;
   unsigned int   unused;
      const short *cud;
   unsigned char  *sqlest;
      const char  *stmt;
   unsigned char  **sqphsv;
   unsigned int   *sqphsl;
            short **sqpind;
   unsigned int   *sqparm;
   unsigned int   **sqparc;
   unsigned char  *sqhstv[35];
   unsigned int   sqhstl[35];
            short *sqindv[35];
   unsigned int   sqharm[35];
   unsigned int   *sqharc[35];
} sqlstm = {8,35};

// Prototypes
extern "C" {
  void sqlcxt (void **, unsigned long *,
               struct sqlexd *, const struct sqlcxp *);
  void sqlcx2t(void **, unsigned long *,
               struct sqlexd *, const struct sqlcxp *);
  void sqlbuft(void **, char *);
  void sqlgs2t(void **, char *);
  void sqlorat(void **, unsigned long *, void *);
};

// Forms Interface
static const int IAPSUCC = 0;
static const int IAPFAIL = 1403;
static const int IAPFTL  = 535;
extern "C" { void sqliem(char *, int *); };

 static const char *sq0001 = 
"select HaltestellenID ,Name ,XKoordinate ,YKoordinate ,Prioritaet ,Pflicht  \
from Knoten where ((SpeicherID=:b0 and XKoordinate=:b1) and YKoordinate=:b2)  \
         ";
 static const char *sq0002 = 
"select HaltestellenID ,Name ,XKoordinate ,YKoordinate ,Prioritaet ,Pflicht  \
from Knoten where (SpeicherID=:b0 and HaltestellenID=:b1)           ";
 static const char *sq0003 = 
"select LinienID ,LfdNr ,HaltestellenID  from LinienWeg where (SpeicherID=:b0\
 and HaltestellenID=:b1)           ";
 static const char *sq0004 = 
"select KantenID ,StartHaltestelle ,EndHaltestelle  from Kanten where (Speich\
erID=:b0 and (StartHaltestelle=:b1 or EndHaltestelle=:b1))           ";
 static const char *sq0005 = 
"select KomponentenID ,HaltestellenIDVon ,HaltestellenIDNach ,LinienID  from \
Zusammenhangskomponente where ((SpeicherID=:b0 and (HaltestellenIDVon=:b1 or H\
altestellenIDNach=:b1)) and LinienID=:b3)           ";
 static const char *sq0006 = 
"select LfdNr ,PlanID ,LinienID ,VonHaltestelle ,NachHaltestelle ,Reisezeit ,\
Verkehrsstrom  from LinienWerte where (SpeicherID=:b0 and NachHaltestelle=:b1)\
           ";
 static const char *sq0007 = 
"select LfdNr ,PlanID ,LinienID ,VonHaltestelle ,NachHaltestelle ,Reisezeit ,\
Verkehrsstrom  from LinienWerte where (SpeicherID=:b0 and VonHaltestelle=:b1) \
          ";
 static const char *sq0008 = 
"select PlanID ,LinienID ,LfdNr ,HaltestellenID  from LinienWeg where (Speich\
erID=:b0 and LinienID=:b1)           ";
 static const char *sq0009 = 
"select id ,Bezeichnung ,Zustand  from Speicherstand where id=:b0           ";
 static const char *sq0012 = 
"select id ,Bezeichnung ,Zustand  from pg369.Speicherstand where id=:b0      \
     ";
 static const char *sq0017 = 
"select id ,Bezeichnung  from Speicherstand            ";
 static const char *sq0018 = 
"select id ,Bezeichnung  from pg369.Speicherstand            ";
 static const char *sq0019 = 
"select id ,Bezeichnung ,Zustand  from Speicherstand            ";
 static const char *sq0025 = 
"select id ,Bezeichnung  from Speicherstand where id=:b0           ";
 static const char *sq0026 = 
"select id ,Bezeichnung  from pg369.Speicherstand where id=:b0           ";
 static const char *sq0151 = 
"select id ,Bezeichnung ,Zustand  from Speicherstand where id=:b0           ";
 static const char *sq0333 = 
"select id ,Bezeichnung ,Zustand  from Speicherstand where id=:b0           ";
 static const char *sq0515 = 
"select id  from pg369.Speicherstand where id=:b0           ";
 static const char *sq0703 = 
"select XKoordinate ,YKoordinate  from Pflichthaltestellen where SpeicherID=:\
b0           ";
 static const char *sq0707 = 
"select SpeicherID ,Links ,Oben ,Rechts ,Unten  from Ausschnitt where Speiche\
rID=:b0           ";
 static const char *sq0708 = 
"select VonHaltestelle ,NachHaltestelle ,Reiseaufkommen  from QuelleZielMatri\
x where (VonHaltestelle like 1 and SpeicherID=:b0)           ";
 static const char *sq0709 = 
"select VonHaltestelle ,NachHaltestelle ,Reiseaufkommen  from QuelleZielMatri\
x where SpeicherID=:b0           ";
 static const char *sq0710 = 
"select VonHaltestelle ,NachHaltestelle ,Reiseaufkommen  from UrsprungsQZMatr\
ix where (VonHaltestelle like 1 and SpeicherID=:b0)           ";
 static const char *sq0711 = 
"select VonHaltestelle ,NachHaltestelle ,Reiseaufkommen  from UrsprungsQZMatr\
ix where SpeicherID=:b0           ";
 static const char *sq0724 = 
"select XKoordinate ,YKoordinate ,ElementID  from UrsprungsQZListe where Spei\
cherID=:b0           ";
 static const char *sq0737 = 
"select HaltestellenID ,Name ,XKoordinate ,YKoordinate ,Prioritaet ,Pflicht  \
from Knoten where SpeicherID=:b0           ";
 static const char *sq0744 = 
"select KantenID ,StartHaltestelle ,EndHaltestelle ,ReisezeitMinuten ,Laenge \
,ReiseFluss ,StrassenID  from Kanten where SpeicherID=:b0           ";
 static const char *sq0751 = 
"select StrassenID ,LfdNr ,XKoordinaten ,YKoordinaten  from KantenStrassen wh\
ere (SpeicherID=:b0 and StrassenID=:b1)           ";
 static const char *sq0756 = 
"select PlanID ,Beschreibung ,LinienID  from LinienPlan where (SpeicherID=:b0\
 and PlanID=:b1)           ";
 static const char *sq0757 = 
"select LinienID ,LfdNr ,HaltestellenID  from LinienWeg where (SpeicherID=:b0\
 and LinienID=:b1)           ";
 static const char *sq0767 = 
"select SpeicherID ,LfdNr ,PlanID ,LinienID ,VonHaltestelle ,NachHaltestelle \
,Reisezeit ,Verkehrsstrom  from LinienWerte where (SpeicherID=:b0 and PlanID=:\
b1)           ";
 static const char *sq0772 = 
"select *  from GuetemassReisezeitAuto where SpeicherID=:b0           ";
 static const char *sq0780 = 
"select *  from GuetemassReisezeitAuto where SpeicherID=:b0           ";
 static const char *sq0781 = 
"select Aufruf ,Algorithmus ,ZufiInitialisierung ,MinRadius ,MaxRadius ,Verbi\
ndungsRadiusStadt ,VerbindungsRadiusLand ,Radiustyp ,HaltestellenLage ,Toleran\
zgrenze ,BevoelkerungsRaster ,Bevoelkerungsueberversorgung ,Bevoelkerungsunter\
versorgung ,Flaechenueberversorgung ,Flaechenunterversorgung ,Fahrtwunscheinbe\
ziehung ,Strassenanpassung ,AnzahlHaltestellen ,AnzStrassenkarte ,AnzBevoelker\
ungsversorgung ,AnzFlaechenversorgung ,Anzkomplettunterdruecken ,Strategie ,An\
zahlEltern ,AnzahlKinder ,Generationen ,AbbruchGueteunterschreitung ,GrenzwGue\
teunterschreitung  from HaltestellenModulParameter where (SpeicherID=:b0 and A\
ufruf=:b1)           ";
 static const char *sq0785 = 
"select XKoordinate ,YKoordinate ,Radius ,Dichte  from Bevoelkerungsdichte wh\
ere SpeicherID=:b0           ";
 static const char *sq0790 = 
"select StadtteilVon ,StadtteilNach ,Dichte  from Pendlermatrix where (Stadtt\
eilVon like 1 and SpeicherID=:b0)           ";
 static const char *sq0791 = 
"select StadtteilVon ,StadtteilNach ,Dichte  from Pendlermatrix where Speiche\
rID=:b0           ";
 static const char *sq0796 = 
"select xKoordinate ,yKoordinate ,ElementID ,Radius  from Pendlerliste where \
SpeicherID=:b0           ";
 static const char *sq0805 = 
"select LinienID ,LfdNr ,HaltestellenID  from LinienWeg where (LinienID=:b0 a\
nd SpeicherID=:b1)           ";
 static const char *sq0809 = 
"select PlanID ,Beschreibung ,LinienID  from LinienPlan where SpeicherID=:b0 \
          ";
 static const char *sq0815 = 
"select LinienID ,LfNr ,HaltestellenID  from Pflichtlinien where SpeicherID=:\
b0           ";
 static const char *sq0816 = 
"select LinienID ,LfNr ,HaltestellenID  from Pflichtlinien where (SpeicherID=\
:b0 and LinienID=:b1)           ";
 static const char *sq0825 = 
"select HaltestellenID ,UmsteigezeitMinuten ,MindesthaltezeitMinuten  from Kn\
otenWerte where SpeicherID=:b0           ";
 static const char *sq0837 = 
"select HaltestellenID ,LinienID ,AbfahrtszeitStd ,AbfahrtszeitMin into :s1 ,\
:s2 ,:s3 ,:s4   from Fahrplan where SpeicherID=:b1 order by HaltestellenID,Lin\
ienID,AbfahrtszeitStd,AbfahrtszeitMin           ";
 static const char *sq0842 = 
"select KomponentenID  from Zusammenhangskomponente where SpeicherID=:b0 grou\
p by KomponentenID           ";
 static const char *sq0869 = 
"select HaltestellenID ,LinieA ,LinieB ,Umsteigezeit  from Mindestumsteigezei\
t where SpeicherID=:b0           ";
 static const char *sq0874 = 
"select HaltestellenID ,Haltezeit  from Mindesthaltezeit where SpeicherID=:b0\
           ";
typedef struct { unsigned short len; unsigned char arr[1]; } VARCHAR;
typedef struct { unsigned short len; unsigned char arr[1]; } varchar;

/* cud (compilation unit data) array */
static const short sqlcud0[] =
{8,4130,
2,0,0,1,163,0,9,99,0,3,3,0,1,0,1,3,0,0,1,4,0,0,1,4,0,0,
28,0,0,1,0,0,13,105,0,6,0,0,1,0,2,3,0,0,2,9,0,0,2,4,0,0,2,4,0,0,2,3,0,0,2,3,0,
0,
66,0,0,1,0,0,15,110,0,0,0,0,1,0,
80,0,0,2,144,0,9,151,0,2,2,0,1,0,1,3,0,0,1,3,0,0,
102,0,0,2,0,0,13,157,0,6,0,0,1,0,2,3,0,0,2,9,0,0,2,4,0,0,2,4,0,0,2,3,0,0,2,3,0,
0,
140,0,0,2,0,0,15,167,0,0,0,0,1,0,
154,0,0,3,111,0,9,211,0,2,2,0,1,0,1,3,0,0,1,3,0,0,
176,0,0,3,0,0,13,217,0,3,0,0,1,0,2,3,0,0,2,3,0,0,2,3,0,0,
202,0,0,3,0,0,15,222,0,0,0,0,1,0,
216,0,0,4,145,0,9,266,0,3,3,0,1,0,1,3,0,0,1,3,0,0,1,3,0,0,
242,0,0,4,0,0,13,273,0,3,0,0,1,0,2,3,0,0,2,3,0,0,2,3,0,0,
268,0,0,4,0,0,15,287,0,0,0,0,1,0,
282,0,0,5,206,0,9,333,0,4,4,0,1,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,
312,0,0,5,0,0,13,339,0,4,0,0,1,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,0,
342,0,0,5,0,0,15,344,0,0,0,0,1,0,
356,0,0,6,165,0,9,394,0,2,2,0,1,0,1,3,0,0,1,3,0,0,
378,0,0,6,0,0,13,400,0,7,0,0,1,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,
0,2,3,0,0,
420,0,0,6,0,0,15,405,0,0,0,0,1,0,
434,0,0,7,164,0,9,453,0,2,2,0,1,0,1,3,0,0,1,3,0,0,
456,0,0,7,0,0,13,459,0,7,0,0,1,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,
0,2,3,0,0,
498,0,0,7,0,0,15,465,0,0,0,0,1,0,
512,0,0,8,113,0,9,517,0,2,2,0,1,0,1,3,0,0,1,3,0,0,
534,0,0,8,0,0,13,523,0,4,0,0,1,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,0,
564,0,0,8,0,0,15,528,0,0,0,0,1,0,
578,0,0,9,75,0,9,602,0,1,1,0,1,0,1,3,0,0,
596,0,0,9,0,0,13,608,0,3,0,0,1,0,2,3,0,0,2,9,0,0,2,3,0,0,
622,0,0,9,0,0,15,613,0,0,0,0,1,0,
636,0,0,10,49,0,3,625,0,3,3,0,1,0,1,3,0,0,1,9,0,0,1,3,0,0,
662,0,0,11,0,0,29,627,0,0,0,0,1,0,
676,0,0,12,81,0,9,675,0,1,1,0,1,0,1,3,0,0,
694,0,0,12,0,0,13,681,0,3,0,0,1,0,2,3,0,0,2,9,0,0,2,3,0,0,
720,0,0,12,0,0,15,686,0,0,0,0,1,0,
734,0,0,13,55,0,3,698,0,3,3,0,1,0,1,3,0,0,1,9,0,0,1,3,0,0,
760,0,0,14,0,0,29,700,0,0,0,0,1,0,
774,0,0,15,84,0,4,731,0,4,1,0,1,0,2,3,0,0,2,9,0,0,2,3,0,0,1,3,0,0,
804,0,0,16,90,0,4,770,0,4,1,0,1,0,2,3,0,0,2,9,0,0,2,3,0,0,1,3,0,0,
834,0,0,17,54,0,9,825,0,0,0,0,1,0,
848,0,0,17,0,0,13,831,0,2,0,0,1,0,2,3,0,0,2,9,0,0,
870,0,0,17,0,0,15,857,0,0,0,0,1,0,
884,0,0,18,60,0,9,901,0,0,0,0,1,0,
898,0,0,18,0,0,13,907,0,2,0,0,1,0,2,3,0,0,2,9,0,0,
920,0,0,18,0,0,15,933,0,0,0,0,1,0,
934,0,0,19,63,0,9,970,0,0,0,0,1,0,
948,0,0,19,0,0,13,976,0,3,0,0,1,0,2,3,0,0,2,9,0,0,2,3,0,0,
974,0,0,19,0,0,15,981,0,0,0,0,1,0,
988,0,0,20,56,0,2,1008,0,1,1,0,1,0,1,3,0,0,
1006,0,0,21,0,0,29,1009,0,0,0,0,1,0,
1020,0,0,22,50,0,5,1012,0,2,2,0,1,0,1,3,0,0,1,3,0,0,
1042,0,0,23,0,0,29,1014,0,0,0,0,1,0,
1056,0,0,24,112,0,4,1043,0,4,1,0,1,0,2,3,0,0,2,9,0,0,2,3,0,0,1,3,0,0,
1086,0,0,25,66,0,9,1087,0,1,1,0,1,0,1,3,0,0,
1104,0,0,25,0,0,13,1093,0,2,0,0,1,0,2,3,0,0,2,9,0,0,
1126,0,0,25,0,0,15,1098,0,0,0,0,1,0,
1140,0,0,26,72,0,9,1141,0,1,1,0,1,0,1,3,0,0,
1158,0,0,26,0,0,13,1147,0,2,0,0,1,0,2,3,0,0,2,9,0,0,
1180,0,0,26,0,0,15,1152,0,0,0,0,1,0,
1194,0,0,27,40,0,2,1194,0,1,1,0,1,0,1,3,0,0,
1212,0,0,28,0,0,29,1195,0,0,0,0,1,0,
1226,0,0,29,45,0,2,1197,0,1,1,0,1,0,1,3,0,0,
1244,0,0,30,0,0,29,1198,0,0,0,0,1,0,
1258,0,0,31,48,0,2,1200,0,1,1,0,1,0,1,3,0,0,
1276,0,0,32,0,0,29,1201,0,0,0,0,1,0,
1290,0,0,33,40,0,2,1203,0,1,1,0,1,0,1,3,0,0,
1308,0,0,34,0,0,29,1204,0,0,0,0,1,0,
1322,0,0,35,44,0,2,1206,0,1,1,0,1,0,1,3,0,0,
1340,0,0,36,0,0,29,1207,0,0,0,0,1,0,
1354,0,0,37,43,0,2,1209,0,1,1,0,1,0,1,3,0,0,
1372,0,0,38,0,0,29,1210,0,0,0,0,1,0,
1386,0,0,39,45,0,2,1212,0,1,1,0,1,0,1,3,0,0,
1404,0,0,40,0,0,29,1213,0,0,0,0,1,0,
1418,0,0,41,43,0,2,1215,0,1,1,0,1,0,1,3,0,0,
1436,0,0,42,0,0,29,1216,0,0,0,0,1,0,
1450,0,0,43,42,0,2,1218,0,1,1,0,1,0,1,3,0,0,
1468,0,0,44,0,0,29,1219,0,0,0,0,1,0,
1482,0,0,45,50,0,2,1221,0,1,1,0,1,0,1,3,0,0,
1500,0,0,46,0,0,29,1222,0,0,0,0,1,0,
1514,0,0,47,49,0,2,1224,0,1,1,0,1,0,1,3,0,0,
1532,0,0,48,0,0,29,1225,0,0,0,0,1,0,
1546,0,0,49,51,0,2,1227,0,1,1,0,1,0,1,3,0,0,
1564,0,0,50,0,0,29,1228,0,0,0,0,1,0,
1578,0,0,51,50,0,2,1230,0,1,1,0,1,0,1,3,0,0,
1596,0,0,52,0,0,29,1231,0,0,0,0,1,0,
1610,0,0,53,47,0,2,1233,0,1,1,0,1,0,1,3,0,0,
1628,0,0,54,0,0,29,1234,0,0,0,0,1,0,
1642,0,0,55,46,0,2,1236,0,1,1,0,1,0,1,3,0,0,
1660,0,0,56,0,0,29,1237,0,0,0,0,1,0,
1674,0,0,57,57,0,2,1239,0,1,1,0,1,0,1,3,0,0,
1692,0,0,58,0,0,29,1240,0,0,0,0,1,0,
1706,0,0,59,49,0,2,1242,0,1,1,0,1,0,1,3,0,0,
1724,0,0,60,0,0,29,1243,0,0,0,0,1,0,
1738,0,0,61,60,0,2,1245,0,1,1,0,1,0,1,3,0,0,
1756,0,0,62,0,0,29,1246,0,0,0,0,1,0,
1770,0,0,63,53,0,2,1248,0,1,1,0,1,0,1,3,0,0,
1788,0,0,64,0,0,29,1249,0,0,0,0,1,0,
1802,0,0,65,60,0,2,1251,0,1,1,0,1,0,1,3,0,0,
1820,0,0,66,0,0,29,1252,0,0,0,0,1,0,
1834,0,0,67,58,0,2,1254,0,1,1,0,1,0,1,3,0,0,
1852,0,0,68,0,0,29,1255,0,0,0,0,1,0,
1866,0,0,69,56,0,2,1257,0,1,1,0,1,0,1,3,0,0,
1884,0,0,70,0,0,29,1258,0,0,0,0,1,0,
1898,0,0,71,53,0,2,1260,0,1,1,0,1,0,1,3,0,0,
1916,0,0,72,0,0,29,1261,0,0,0,0,1,0,
1930,0,0,73,53,0,2,1263,0,1,1,0,1,0,1,3,0,0,
1948,0,0,74,0,0,29,1264,0,0,0,0,1,0,
1962,0,0,75,50,0,2,1266,0,1,1,0,1,0,1,3,0,0,
1980,0,0,76,0,0,29,1267,0,0,0,0,1,0,
1994,0,0,77,53,0,2,1269,0,1,1,0,1,0,1,3,0,0,
2012,0,0,78,0,0,29,1270,0,0,0,0,1,0,
2026,0,0,79,44,0,2,1272,0,1,1,0,1,0,1,3,0,0,
2044,0,0,80,0,0,29,1273,0,0,0,0,1,0,
2058,0,0,81,44,0,2,1275,0,1,1,0,1,0,1,3,0,0,
2076,0,0,82,0,0,29,1276,0,0,0,0,1,0,
2090,0,0,83,56,0,2,1278,0,1,1,0,1,0,1,3,0,0,
2108,0,0,84,0,0,29,1279,0,0,0,0,1,0,
2122,0,0,85,47,0,2,1281,0,1,1,0,1,0,1,3,0,0,
2140,0,0,86,0,0,29,1282,0,0,0,0,1,0,
2154,0,0,87,39,0,2,1285,0,1,1,0,1,0,1,3,0,0,
2172,0,0,88,0,0,29,1286,0,0,0,0,1,0,
2186,0,0,89,46,0,2,1334,0,1,1,0,1,0,1,3,0,0,
2204,0,0,90,0,0,29,1335,0,0,0,0,1,0,
2218,0,0,91,51,0,2,1337,0,1,1,0,1,0,1,3,0,0,
2236,0,0,92,0,0,29,1338,0,0,0,0,1,0,
2250,0,0,93,54,0,2,1340,0,1,1,0,1,0,1,3,0,0,
2268,0,0,94,0,0,29,1341,0,0,0,0,1,0,
2282,0,0,95,46,0,2,1343,0,1,1,0,1,0,1,3,0,0,
2300,0,0,96,0,0,29,1344,0,0,0,0,1,0,
2314,0,0,97,50,0,2,1346,0,1,1,0,1,0,1,3,0,0,
2332,0,0,98,0,0,29,1347,0,0,0,0,1,0,
2346,0,0,99,49,0,2,1349,0,1,1,0,1,0,1,3,0,0,
2364,0,0,100,0,0,29,1350,0,0,0,0,1,0,
2378,0,0,101,51,0,2,1352,0,1,1,0,1,0,1,3,0,0,
2396,0,0,102,0,0,29,1353,0,0,0,0,1,0,
2410,0,0,103,49,0,2,1355,0,1,1,0,1,0,1,3,0,0,
2428,0,0,104,0,0,29,1356,0,0,0,0,1,0,
2442,0,0,105,48,0,2,1358,0,1,1,0,1,0,1,3,0,0,
2460,0,0,106,0,0,29,1359,0,0,0,0,1,0,
2474,0,0,107,56,0,2,1361,0,1,1,0,1,0,1,3,0,0,
2492,0,0,108,0,0,29,1362,0,0,0,0,1,0,
2506,0,0,109,55,0,2,1364,0,1,1,0,1,0,1,3,0,0,
2524,0,0,110,0,0,29,1365,0,0,0,0,1,0,
2538,0,0,111,57,0,2,1367,0,1,1,0,1,0,1,3,0,0,
2556,0,0,112,0,0,29,1368,0,0,0,0,1,0,
2570,0,0,113,56,0,2,1370,0,1,1,0,1,0,1,3,0,0,
2588,0,0,114,0,0,29,1371,0,0,0,0,1,0,
2602,0,0,115,53,0,2,1373,0,1,1,0,1,0,1,3,0,0,
2620,0,0,116,0,0,29,1374,0,0,0,0,1,0,
2634,0,0,117,52,0,2,1376,0,1,1,0,1,0,1,3,0,0,
2652,0,0,118,0,0,29,1377,0,0,0,0,1,0,
2666,0,0,119,63,0,2,1379,0,1,1,0,1,0,1,3,0,0,
2684,0,0,120,0,0,29,1380,0,0,0,0,1,0,
2698,0,0,121,55,0,2,1382,0,1,1,0,1,0,1,3,0,0,
2716,0,0,122,0,0,29,1383,0,0,0,0,1,0,
2730,0,0,123,66,0,2,1385,0,1,1,0,1,0,1,3,0,0,
2748,0,0,124,0,0,29,1386,0,0,0,0,1,0,
2762,0,0,125,59,0,2,1388,0,1,1,0,1,0,1,3,0,0,
2780,0,0,126,0,0,29,1389,0,0,0,0,1,0,
2794,0,0,127,66,0,2,1391,0,1,1,0,1,0,1,3,0,0,
2812,0,0,128,0,0,29,1392,0,0,0,0,1,0,
2826,0,0,129,64,0,2,1394,0,1,1,0,1,0,1,3,0,0,
2844,0,0,130,0,0,29,1395,0,0,0,0,1,0,
2858,0,0,131,62,0,2,1397,0,1,1,0,1,0,1,3,0,0,
2876,0,0,132,0,0,29,1398,0,0,0,0,1,0,
2890,0,0,133,59,0,2,1400,0,1,1,0,1,0,1,3,0,0,
2908,0,0,134,0,0,29,1401,0,0,0,0,1,0,
2922,0,0,135,59,0,2,1403,0,1,1,0,1,0,1,3,0,0,
2940,0,0,136,0,0,29,1404,0,0,0,0,1,0,
2954,0,0,137,56,0,2,1406,0,1,1,0,1,0,1,3,0,0,
2972,0,0,138,0,0,29,1407,0,0,0,0,1,0,
2986,0,0,139,59,0,2,1409,0,1,1,0,1,0,1,3,0,0,
3004,0,0,140,0,0,29,1410,0,0,0,0,1,0,
3018,0,0,141,50,0,2,1412,0,1,1,0,1,0,1,3,0,0,
3036,0,0,142,0,0,29,1413,0,0,0,0,1,0,
3050,0,0,143,50,0,2,1415,0,1,1,0,1,0,1,3,0,0,
3068,0,0,144,0,0,29,1416,0,0,0,0,1,0,
3082,0,0,145,62,0,2,1418,0,1,1,0,1,0,1,3,0,0,
3100,0,0,146,0,0,29,1419,0,0,0,0,1,0,
3114,0,0,147,53,0,2,1421,0,1,1,0,1,0,1,3,0,0,
3132,0,0,148,0,0,29,1422,0,0,0,0,1,0,
3146,0,0,149,45,0,2,1425,0,1,1,0,1,0,1,3,0,0,
3164,0,0,150,0,0,29,1426,0,0,0,0,1,0,
3178,0,0,151,75,0,9,1489,0,1,1,0,1,0,1,3,0,0,
3196,0,0,151,0,0,13,1495,0,3,0,0,1,0,2,3,0,0,2,9,0,0,2,3,0,0,
3222,0,0,151,0,0,15,1500,0,0,0,0,1,0,
3236,0,0,152,84,0,4,1505,0,4,1,0,1,0,2,3,0,0,2,9,0,0,2,3,0,0,1,3,0,0,
3266,0,0,153,282,0,44,1520,0,0,0,0,1,0,
3280,0,0,154,62,0,3,1523,0,1,1,0,1,0,1,3,0,0,
3298,0,0,155,34,0,5,1526,0,1,1,0,1,0,1,3,0,0,
3316,0,0,156,42,0,3,1529,0,0,0,0,1,0,
3330,0,0,157,18,0,1,1532,0,0,0,0,1,0,
3344,0,0,158,0,0,29,1534,0,0,0,0,1,0,
3358,0,0,159,216,0,44,1541,0,0,0,0,1,0,
3372,0,0,160,67,0,3,1544,0,1,1,0,1,0,1,3,0,0,
3390,0,0,161,34,0,5,1546,0,1,1,0,1,0,1,3,0,0,
3408,0,0,162,47,0,3,1548,0,0,0,0,1,0,
3422,0,0,163,18,0,1,1550,0,0,0,0,1,0,
3436,0,0,164,0,0,29,1551,0,0,0,0,1,0,
3450,0,0,165,222,0,44,1557,0,0,0,0,1,0,
3464,0,0,166,70,0,3,1560,0,1,1,0,1,0,1,3,0,0,
3482,0,0,167,34,0,5,1562,0,1,1,0,1,0,1,3,0,0,
3500,0,0,168,50,0,3,1564,0,0,0,0,1,0,
3514,0,0,169,18,0,1,1566,0,0,0,0,1,0,
3528,0,0,170,0,0,29,1567,0,0,0,0,1,0,
3542,0,0,171,312,0,44,1573,0,0,0,0,1,0,
3556,0,0,172,62,0,3,1577,0,1,1,0,1,0,1,3,0,0,
3574,0,0,173,34,0,5,1579,0,1,1,0,1,0,1,3,0,0,
3592,0,0,174,42,0,3,1581,0,0,0,0,1,0,
3606,0,0,175,18,0,1,1583,0,0,0,0,1,0,
3620,0,0,176,0,0,29,1584,0,0,0,0,1,0,
3634,0,0,177,194,0,44,1590,0,0,0,0,1,0,
3648,0,0,178,66,0,3,1592,0,1,1,0,1,0,1,3,0,0,
3666,0,0,179,34,0,5,1594,0,1,1,0,1,0,1,3,0,0,
3684,0,0,180,46,0,3,1596,0,0,0,0,1,0,
3698,0,0,181,18,0,1,1598,0,0,0,0,1,0,
3712,0,0,182,0,0,29,1599,0,0,0,0,1,0,
3726,0,0,183,214,0,44,1605,0,0,0,0,1,0,
3740,0,0,184,65,0,3,1607,0,1,1,0,1,0,1,3,0,0,
3758,0,0,185,34,0,5,1609,0,1,1,0,1,0,1,3,0,0,
3776,0,0,186,45,0,3,1611,0,0,0,0,1,0,
3790,0,0,187,18,0,1,1613,0,0,0,0,1,0,
3804,0,0,188,0,0,29,1614,0,0,0,0,1,0,
3818,0,0,189,317,0,44,1620,0,0,0,0,1,0,
3832,0,0,190,67,0,3,1624,0,1,1,0,1,0,1,3,0,0,
3850,0,0,191,34,0,5,1626,0,1,1,0,1,0,1,3,0,0,
3868,0,0,192,47,0,3,1628,0,0,0,0,1,0,
3882,0,0,193,18,0,1,1630,0,0,0,0,1,0,
3896,0,0,194,0,0,29,1631,0,0,0,0,1,0,
3910,0,0,195,208,0,44,1637,0,0,0,0,1,0,
3924,0,0,196,65,0,3,1639,0,1,1,0,1,0,1,3,0,0,
3942,0,0,197,34,0,5,1641,0,1,1,0,1,0,1,3,0,0,
3960,0,0,198,45,0,3,1643,0,0,0,0,1,0,
3974,0,0,199,18,0,1,1645,0,0,0,0,1,0,
3988,0,0,200,0,0,29,1646,0,0,0,0,1,0,
4002,0,0,201,254,0,44,1652,0,0,0,0,1,0,
4016,0,0,202,64,0,3,1655,0,1,1,0,1,0,1,3,0,0,
4034,0,0,203,34,0,5,1657,0,1,1,0,1,0,1,3,0,0,
4052,0,0,204,44,0,3,1659,0,0,0,0,1,0,
4066,0,0,205,18,0,1,1661,0,0,0,0,1,0,
4080,0,0,206,0,0,29,1662,0,0,0,0,1,0,
4094,0,0,207,221,0,44,1668,0,0,0,0,1,0,
4108,0,0,208,72,0,3,1671,0,1,1,0,1,0,1,3,0,0,
4126,0,0,209,34,0,5,1673,0,1,1,0,1,0,1,3,0,0,
4144,0,0,210,52,0,3,1675,0,0,0,0,1,0,
4158,0,0,211,18,0,1,1677,0,0,0,0,1,0,
4172,0,0,212,0,0,29,1678,0,0,0,0,1,0,
4186,0,0,213,202,0,44,1684,0,0,0,0,1,0,
4200,0,0,214,71,0,3,1687,0,1,1,0,1,0,1,3,0,0,
4218,0,0,215,34,0,5,1689,0,1,1,0,1,0,1,3,0,0,
4236,0,0,216,51,0,3,1691,0,0,0,0,1,0,
4250,0,0,217,18,0,1,1693,0,0,0,0,1,0,
4264,0,0,218,0,0,29,1694,0,0,0,0,1,0,
4278,0,0,219,221,0,44,1700,0,0,0,0,1,0,
4292,0,0,220,73,0,3,1703,0,1,1,0,1,0,1,3,0,0,
4310,0,0,221,34,0,5,1705,0,1,1,0,1,0,1,3,0,0,
4328,0,0,222,53,0,3,1707,0,0,0,0,1,0,
4342,0,0,223,18,0,1,1709,0,0,0,0,1,0,
4356,0,0,224,0,0,29,1710,0,0,0,0,1,0,
4370,0,0,225,202,0,44,1716,0,0,0,0,1,0,
4384,0,0,226,72,0,3,1718,0,1,1,0,1,0,1,3,0,0,
4402,0,0,227,34,0,5,1720,0,1,1,0,1,0,1,3,0,0,
4420,0,0,228,52,0,3,1722,0,0,0,0,1,0,
4434,0,0,229,18,0,1,1724,0,0,0,0,1,0,
4448,0,0,230,0,0,29,1725,0,0,0,0,1,0,
4462,0,0,231,205,0,44,1731,0,0,0,0,1,0,
4476,0,0,232,69,0,3,1733,0,1,1,0,1,0,1,3,0,0,
4494,0,0,233,34,0,5,1735,0,1,1,0,1,0,1,3,0,0,
4512,0,0,234,49,0,3,1737,0,0,0,0,1,0,
4526,0,0,235,18,0,1,1739,0,0,0,0,1,0,
4540,0,0,236,0,0,29,1740,0,0,0,0,1,0,
4554,0,0,237,227,0,44,1746,0,0,0,0,1,0,
4568,0,0,238,68,0,3,1749,0,1,1,0,1,0,1,3,0,0,
4586,0,0,239,34,0,5,1751,0,1,1,0,1,0,1,3,0,0,
4604,0,0,240,48,0,3,1753,0,0,0,0,1,0,
4618,0,0,241,18,0,1,1755,0,0,0,0,1,0,
4632,0,0,242,0,0,29,1756,0,0,0,0,1,0,
4646,0,0,243,274,0,44,1762,0,0,0,0,1,0,
4660,0,0,244,79,0,3,1766,0,1,1,0,1,0,1,3,0,0,
4678,0,0,245,34,0,5,1768,0,1,1,0,1,0,1,3,0,0,
4696,0,0,246,59,0,3,1770,0,0,0,0,1,0,
4710,0,0,247,18,0,1,1772,0,0,0,0,1,0,
4724,0,0,248,0,0,29,1773,0,0,0,0,1,0,
4738,0,0,249,298,0,44,1779,0,0,0,0,1,0,
4752,0,0,250,71,0,3,1783,0,1,1,0,1,0,1,3,0,0,
4770,0,0,251,34,0,5,1785,0,1,1,0,1,0,1,3,0,0,
4788,0,0,252,51,0,3,1787,0,0,0,0,1,0,
4802,0,0,253,18,0,1,1789,0,0,0,0,1,0,
4816,0,0,254,0,0,29,1790,0,0,0,0,1,0,
4830,0,0,255,259,0,44,1796,0,0,0,0,1,0,
4844,0,0,256,82,0,3,1799,0,1,1,0,1,0,1,3,0,0,
4862,0,0,257,34,0,5,1801,0,1,1,0,1,0,1,3,0,0,
4880,0,0,258,62,0,3,1803,0,0,0,0,1,0,
4894,0,0,259,18,0,1,1805,0,0,0,0,1,0,
4908,0,0,260,0,0,29,1806,0,0,0,0,1,0,
4922,0,0,261,205,0,44,1812,0,0,0,0,1,0,
4936,0,0,262,75,0,3,1815,0,1,1,0,1,0,1,3,0,0,
4954,0,0,263,34,0,5,1817,0,1,1,0,1,0,1,3,0,0,
4972,0,0,264,55,0,3,1819,0,0,0,0,1,0,
4986,0,0,265,18,0,1,1821,0,0,0,0,1,0,
5000,0,0,266,0,0,29,1822,0,0,0,0,1,0,
5014,0,0,267,1127,0,44,1828,0,0,0,0,1,0,
5028,0,0,268,82,0,3,1841,0,1,1,0,1,0,1,3,0,0,
5046,0,0,269,34,0,5,1843,0,1,1,0,1,0,1,3,0,0,
5064,0,0,270,62,0,3,1845,0,0,0,0,1,0,
5078,0,0,271,18,0,1,1847,0,0,0,0,1,0,
5092,0,0,272,0,0,29,1848,0,0,0,0,1,0,
5106,0,0,273,518,0,44,1854,0,0,0,0,1,0,
5120,0,0,274,80,0,3,1861,0,1,1,0,1,0,1,3,0,0,
5138,0,0,275,34,0,5,1863,0,1,1,0,1,0,1,3,0,0,
5156,0,0,276,60,0,3,1865,0,0,0,0,1,0,
5170,0,0,277,18,0,1,1867,0,0,0,0,1,0,
5184,0,0,278,0,0,29,1868,0,0,0,0,1,0,
5198,0,0,279,269,0,44,1874,0,0,0,0,1,0,
5212,0,0,280,78,0,3,1878,0,1,1,0,1,0,1,3,0,0,
5230,0,0,281,34,0,5,1880,0,1,1,0,1,0,1,3,0,0,
5248,0,0,282,58,0,3,1882,0,0,0,0,1,0,
5262,0,0,283,18,0,1,1884,0,0,0,0,1,0,
5276,0,0,284,0,0,29,1885,0,0,0,0,1,0,
5290,0,0,285,224,0,44,1891,0,0,0,0,1,0,
5304,0,0,286,75,0,3,1894,0,1,1,0,1,0,1,3,0,0,
5322,0,0,287,34,0,5,1896,0,1,1,0,1,0,1,3,0,0,
5340,0,0,288,55,0,3,1898,0,0,0,0,1,0,
5354,0,0,289,18,0,1,1900,0,0,0,0,1,0,
5368,0,0,290,0,0,29,1901,0,0,0,0,1,0,
5382,0,0,291,217,0,44,1907,0,0,0,0,1,0,
5396,0,0,292,75,0,3,1910,0,1,1,0,1,0,1,3,0,0,
5414,0,0,293,34,0,5,1912,0,1,1,0,1,0,1,3,0,0,
5432,0,0,294,55,0,3,1914,0,0,0,0,1,0,
5446,0,0,295,18,0,1,1916,0,0,0,0,1,0,
5460,0,0,296,0,0,29,1917,0,0,0,0,1,0,
5474,0,0,297,164,0,44,1923,0,0,0,0,1,0,
5488,0,0,298,72,0,3,1925,0,1,1,0,1,0,1,3,0,0,
5506,0,0,299,34,0,5,1927,0,1,1,0,1,0,1,3,0,0,
5524,0,0,300,52,0,3,1929,0,0,0,0,1,0,
5538,0,0,301,18,0,1,1931,0,0,0,0,1,0,
5552,0,0,302,0,0,29,1932,0,0,0,0,1,0,
5566,0,0,303,160,0,44,1938,0,0,0,0,1,0,
5580,0,0,304,75,0,3,1940,0,1,1,0,1,0,1,3,0,0,
5598,0,0,305,34,0,5,1942,0,1,1,0,1,0,1,3,0,0,
5616,0,0,306,55,0,3,1944,0,0,0,0,1,0,
5630,0,0,307,18,0,1,1946,0,0,0,0,1,0,
5644,0,0,308,0,0,29,1947,0,0,0,0,1,0,
5658,0,0,309,190,0,44,1953,0,0,0,0,1,0,
5672,0,0,310,66,0,3,1955,0,1,1,0,1,0,1,3,0,0,
5690,0,0,311,34,0,5,1957,0,1,1,0,1,0,1,3,0,0,
5708,0,0,312,46,0,3,1959,0,0,0,0,1,0,
5722,0,0,313,18,0,1,1961,0,0,0,0,1,0,
5736,0,0,314,0,0,29,1962,0,0,0,0,1,0,
5750,0,0,315,1413,0,44,1968,0,0,0,0,1,0,
5764,0,0,316,66,0,3,1986,0,1,1,0,1,0,1,3,0,0,
5782,0,0,317,34,0,5,1988,0,1,1,0,1,0,1,3,0,0,
5800,0,0,318,46,0,3,1990,0,0,0,0,1,0,
5814,0,0,319,18,0,1,1992,0,0,0,0,1,0,
5828,0,0,320,0,0,29,1993,0,0,0,0,1,0,
5842,0,0,321,206,0,44,1999,0,0,0,0,1,0,
5856,0,0,322,78,0,3,2002,0,1,1,0,1,0,1,3,0,0,
5874,0,0,323,34,0,5,2004,0,1,1,0,1,0,1,3,0,0,
5892,0,0,324,58,0,3,2006,0,0,0,0,1,0,
5906,0,0,325,18,0,1,2008,0,0,0,0,1,0,
5920,0,0,326,0,0,29,2009,0,0,0,0,1,0,
5934,0,0,327,187,0,44,2015,0,0,0,0,1,0,
5948,0,0,328,69,0,3,2017,0,1,1,0,1,0,1,3,0,0,
5966,0,0,329,34,0,5,2019,0,1,1,0,1,0,1,3,0,0,
5984,0,0,330,49,0,3,2021,0,0,0,0,1,0,
5998,0,0,331,18,0,1,2023,0,0,0,0,1,0,
6012,0,0,332,0,0,29,2024,0,0,0,0,1,0,
6026,0,0,333,75,0,9,2081,0,1,1,0,1,0,1,3,0,0,
6044,0,0,333,0,0,13,2087,0,3,0,0,1,0,2,3,0,0,2,9,0,0,2,3,0,0,
6070,0,0,333,0,0,15,2092,0,0,0,0,1,0,
6084,0,0,334,90,0,4,2101,0,4,1,0,1,0,2,3,0,0,2,9,0,0,2,3,0,0,1,3,0,0,
6114,0,0,335,282,0,44,2111,0,0,0,0,1,0,
6128,0,0,336,68,0,3,2113,0,1,1,0,1,0,1,3,0,0,
6146,0,0,337,34,0,5,2115,0,1,1,0,1,0,1,3,0,0,
6164,0,0,338,42,0,3,2117,0,0,0,0,1,0,
6178,0,0,339,18,0,1,2119,0,0,0,0,1,0,
6192,0,0,340,0,0,29,2120,0,0,0,0,1,0,
6206,0,0,341,216,0,44,2125,0,0,0,0,1,0,
6220,0,0,342,73,0,3,2128,0,1,1,0,1,0,1,3,0,0,
6238,0,0,343,34,0,5,2130,0,1,1,0,1,0,1,3,0,0,
6256,0,0,344,47,0,3,2132,0,0,0,0,1,0,
6270,0,0,345,18,0,1,2134,0,0,0,0,1,0,
6284,0,0,346,0,0,29,2135,0,0,0,0,1,0,
6298,0,0,347,222,0,44,2140,0,0,0,0,1,0,
6312,0,0,348,76,0,3,2143,0,1,1,0,1,0,1,3,0,0,
6330,0,0,349,34,0,5,2145,0,1,1,0,1,0,1,3,0,0,
6348,0,0,350,50,0,3,2147,0,0,0,0,1,0,
6362,0,0,351,18,0,1,2149,0,0,0,0,1,0,
6376,0,0,352,0,0,29,2150,0,0,0,0,1,0,
6390,0,0,353,312,0,44,2156,0,0,0,0,1,0,
6404,0,0,354,68,0,3,2160,0,1,1,0,1,0,1,3,0,0,
6422,0,0,355,34,0,5,2162,0,1,1,0,1,0,1,3,0,0,
6440,0,0,356,42,0,3,2164,0,0,0,0,1,0,
6454,0,0,357,18,0,1,2166,0,0,0,0,1,0,
6468,0,0,358,0,0,29,2167,0,0,0,0,1,0,
6482,0,0,359,194,0,44,2173,0,0,0,0,1,0,
6496,0,0,360,72,0,3,2175,0,1,1,0,1,0,1,3,0,0,
6514,0,0,361,34,0,5,2177,0,1,1,0,1,0,1,3,0,0,
6532,0,0,362,46,0,3,2179,0,0,0,0,1,0,
6546,0,0,363,18,0,1,2181,0,0,0,0,1,0,
6560,0,0,364,0,0,29,2182,0,0,0,0,1,0,
6574,0,0,365,214,0,44,2188,0,0,0,0,1,0,
6588,0,0,366,71,0,3,2190,0,1,1,0,1,0,1,3,0,0,
6606,0,0,367,34,0,5,2192,0,1,1,0,1,0,1,3,0,0,
6624,0,0,368,45,0,3,2194,0,0,0,0,1,0,
6638,0,0,369,18,0,1,2196,0,0,0,0,1,0,
6652,0,0,370,0,0,29,2197,0,0,0,0,1,0,
6666,0,0,371,317,0,44,2203,0,0,0,0,1,0,
6680,0,0,372,73,0,3,2207,0,1,1,0,1,0,1,3,0,0,
6698,0,0,373,34,0,5,2209,0,1,1,0,1,0,1,3,0,0,
6716,0,0,374,47,0,3,2211,0,0,0,0,1,0,
6730,0,0,375,18,0,1,2213,0,0,0,0,1,0,
6744,0,0,376,0,0,29,2214,0,0,0,0,1,0,
6758,0,0,377,208,0,44,2220,0,0,0,0,1,0,
6772,0,0,378,71,0,3,2222,0,1,1,0,1,0,1,3,0,0,
6790,0,0,379,34,0,5,2224,0,1,1,0,1,0,1,3,0,0,
6808,0,0,380,45,0,3,2226,0,0,0,0,1,0,
6822,0,0,381,18,0,1,2228,0,0,0,0,1,0,
6836,0,0,382,0,0,29,2229,0,0,0,0,1,0,
6850,0,0,383,254,0,44,2235,0,0,0,0,1,0,
6864,0,0,384,70,0,3,2238,0,1,1,0,1,0,1,3,0,0,
6882,0,0,385,34,0,5,2240,0,1,1,0,1,0,1,3,0,0,
6900,0,0,386,44,0,3,2242,0,0,0,0,1,0,
6914,0,0,387,18,0,1,2244,0,0,0,0,1,0,
6928,0,0,388,0,0,29,2245,0,0,0,0,1,0,
6942,0,0,389,221,0,44,2251,0,0,0,0,1,0,
6956,0,0,390,78,0,3,2254,0,1,1,0,1,0,1,3,0,0,
6974,0,0,391,34,0,5,2256,0,1,1,0,1,0,1,3,0,0,
6992,0,0,392,52,0,3,2258,0,0,0,0,1,0,
7006,0,0,393,18,0,1,2260,0,0,0,0,1,0,
7020,0,0,394,0,0,29,2261,0,0,0,0,1,0,
7034,0,0,395,202,0,44,2267,0,0,0,0,1,0,
7048,0,0,396,77,0,3,2270,0,1,1,0,1,0,1,3,0,0,
7066,0,0,397,34,0,5,2272,0,1,1,0,1,0,1,3,0,0,
7084,0,0,398,51,0,3,2274,0,0,0,0,1,0,
7098,0,0,399,18,0,1,2276,0,0,0,0,1,0,
7112,0,0,400,0,0,29,2277,0,0,0,0,1,0,
7126,0,0,401,221,0,44,2283,0,0,0,0,1,0,
7140,0,0,402,79,0,3,2286,0,1,1,0,1,0,1,3,0,0,
7158,0,0,403,34,0,5,2288,0,1,1,0,1,0,1,3,0,0,
7176,0,0,404,53,0,3,2290,0,0,0,0,1,0,
7190,0,0,405,18,0,1,2292,0,0,0,0,1,0,
7204,0,0,406,0,0,29,2293,0,0,0,0,1,0,
7218,0,0,407,202,0,44,2299,0,0,0,0,1,0,
7232,0,0,408,78,0,3,2301,0,1,1,0,1,0,1,3,0,0,
7250,0,0,409,34,0,5,2303,0,1,1,0,1,0,1,3,0,0,
7268,0,0,410,52,0,3,2305,0,0,0,0,1,0,
7282,0,0,411,18,0,1,2307,0,0,0,0,1,0,
7296,0,0,412,0,0,29,2308,0,0,0,0,1,0,
7310,0,0,413,205,0,44,2314,0,0,0,0,1,0,
7324,0,0,414,75,0,3,2316,0,1,1,0,1,0,1,3,0,0,
7342,0,0,415,34,0,5,2318,0,1,1,0,1,0,1,3,0,0,
7360,0,0,416,49,0,3,2320,0,0,0,0,1,0,
7374,0,0,417,18,0,1,2322,0,0,0,0,1,0,
7388,0,0,418,0,0,29,2323,0,0,0,0,1,0,
7402,0,0,419,227,0,44,2329,0,0,0,0,1,0,
7416,0,0,420,74,0,3,2332,0,1,1,0,1,0,1,3,0,0,
7434,0,0,421,34,0,5,2334,0,1,1,0,1,0,1,3,0,0,
7452,0,0,422,48,0,3,2336,0,0,0,0,1,0,
7466,0,0,423,18,0,1,2338,0,0,0,0,1,0,
7480,0,0,424,0,0,29,2339,0,0,0,0,1,0,
7494,0,0,425,274,0,44,2345,0,0,0,0,1,0,
7508,0,0,426,85,0,3,2349,0,1,1,0,1,0,1,3,0,0,
7526,0,0,427,34,0,5,2351,0,1,1,0,1,0,1,3,0,0,
7544,0,0,428,59,0,3,2353,0,0,0,0,1,0,
7558,0,0,429,18,0,1,2355,0,0,0,0,1,0,
7572,0,0,430,0,0,29,2356,0,0,0,0,1,0,
7586,0,0,431,298,0,44,2362,0,0,0,0,1,0,
7600,0,0,432,77,0,3,2366,0,1,1,0,1,0,1,3,0,0,
7618,0,0,433,34,0,5,2368,0,1,1,0,1,0,1,3,0,0,
7636,0,0,434,51,0,3,2370,0,0,0,0,1,0,
7650,0,0,435,18,0,1,2372,0,0,0,0,1,0,
7664,0,0,436,0,0,29,2373,0,0,0,0,1,0,
7678,0,0,437,259,0,44,2379,0,0,0,0,1,0,
7692,0,0,438,88,0,3,2382,0,1,1,0,1,0,1,3,0,0,
7710,0,0,439,34,0,5,2384,0,1,1,0,1,0,1,3,0,0,
7728,0,0,440,62,0,3,2386,0,0,0,0,1,0,
7742,0,0,441,18,0,1,2388,0,0,0,0,1,0,
7756,0,0,442,0,0,29,2389,0,0,0,0,1,0,
7770,0,0,443,205,0,44,2395,0,0,0,0,1,0,
7784,0,0,444,81,0,3,2398,0,1,1,0,1,0,1,3,0,0,
7802,0,0,445,34,0,5,2400,0,1,1,0,1,0,1,3,0,0,
7820,0,0,446,55,0,3,2402,0,0,0,0,1,0,
7834,0,0,447,18,0,1,2404,0,0,0,0,1,0,
7848,0,0,448,0,0,29,2405,0,0,0,0,1,0,
7862,0,0,449,1127,0,44,2411,0,0,0,0,1,0,
7876,0,0,450,88,0,3,2424,0,1,1,0,1,0,1,3,0,0,
7894,0,0,451,34,0,5,2426,0,1,1,0,1,0,1,3,0,0,
7912,0,0,452,62,0,3,2428,0,0,0,0,1,0,
7926,0,0,453,18,0,1,2430,0,0,0,0,1,0,
7940,0,0,454,0,0,29,2431,0,0,0,0,1,0,
7954,0,0,455,518,0,44,2437,0,0,0,0,1,0,
7968,0,0,456,86,0,3,2444,0,1,1,0,1,0,1,3,0,0,
7986,0,0,457,34,0,5,2446,0,1,1,0,1,0,1,3,0,0,
8004,0,0,458,60,0,3,2448,0,0,0,0,1,0,
8018,0,0,459,18,0,1,2450,0,0,0,0,1,0,
8032,0,0,460,0,0,29,2451,0,0,0,0,1,0,
8046,0,0,461,269,0,44,2457,0,0,0,0,1,0,
8060,0,0,462,84,0,3,2461,0,1,1,0,1,0,1,3,0,0,
8078,0,0,463,34,0,5,2463,0,1,1,0,1,0,1,3,0,0,
8096,0,0,464,58,0,3,2465,0,0,0,0,1,0,
8110,0,0,465,18,0,1,2467,0,0,0,0,1,0,
8124,0,0,466,0,0,29,2468,0,0,0,0,1,0,
8138,0,0,467,224,0,44,2474,0,0,0,0,1,0,
8152,0,0,468,81,0,3,2477,0,1,1,0,1,0,1,3,0,0,
8170,0,0,469,34,0,5,2479,0,1,1,0,1,0,1,3,0,0,
8188,0,0,470,55,0,3,2481,0,0,0,0,1,0,
10,1,0,471,18,0,1,2483,0,0,0,0,1,0,
24,1,0,472,0,0,29,2484,0,0,0,0,1,0,
38,1,0,473,217,0,44,2490,0,0,0,0,1,0,
52,1,0,474,81,0,3,2493,0,1,1,0,1,0,1,3,0,0,
70,1,0,475,34,0,5,2495,0,1,1,0,1,0,1,3,0,0,
88,1,0,476,55,0,3,2497,0,0,0,0,1,0,
102,1,0,477,18,0,1,2499,0,0,0,0,1,0,
116,1,0,478,0,0,29,2500,0,0,0,0,1,0,
130,1,0,479,164,0,44,2506,0,0,0,0,1,0,
144,1,0,480,78,0,3,2508,0,1,1,0,1,0,1,3,0,0,
162,1,0,481,34,0,5,2510,0,1,1,0,1,0,1,3,0,0,
180,1,0,482,52,0,3,2512,0,0,0,0,1,0,
194,1,0,483,18,0,1,2514,0,0,0,0,1,0,
208,1,0,484,0,0,29,2515,0,0,0,0,1,0,
222,1,0,485,160,0,44,2521,0,0,0,0,1,0,
236,1,0,486,81,0,3,2523,0,1,1,0,1,0,1,3,0,0,
254,1,0,487,34,0,5,2525,0,1,1,0,1,0,1,3,0,0,
272,1,0,488,55,0,3,2527,0,0,0,0,1,0,
286,1,0,489,18,0,1,2529,0,0,0,0,1,0,
300,1,0,490,0,0,29,2530,0,0,0,0,1,0,
314,1,0,491,190,0,44,2536,0,0,0,0,1,0,
328,1,0,492,72,0,3,2538,0,1,1,0,1,0,1,3,0,0,
346,1,0,493,34,0,5,2540,0,1,1,0,1,0,1,3,0,0,
364,1,0,494,46,0,3,2542,0,0,0,0,1,0,
378,1,0,495,18,0,1,2544,0,0,0,0,1,0,
392,1,0,496,0,0,29,2545,0,0,0,0,1,0,
406,1,0,497,1413,0,44,2551,0,0,0,0,1,0,
420,1,0,498,72,0,3,2569,0,1,1,0,1,0,1,3,0,0,
438,1,0,499,34,0,5,2571,0,1,1,0,1,0,1,3,0,0,
456,1,0,500,46,0,3,2573,0,0,0,0,1,0,
470,1,0,501,18,0,1,2575,0,0,0,0,1,0,
484,1,0,502,0,0,29,2576,0,0,0,0,1,0,
498,1,0,503,206,0,44,2582,0,0,0,0,1,0,
512,1,0,504,84,0,3,2585,0,1,1,0,1,0,1,3,0,0,
530,1,0,505,34,0,5,2587,0,1,1,0,1,0,1,3,0,0,
548,1,0,506,58,0,3,2589,0,0,0,0,1,0,
562,1,0,507,18,0,1,2591,0,0,0,0,1,0,
576,1,0,508,0,0,29,2592,0,0,0,0,1,0,
590,1,0,509,187,0,44,2598,0,0,0,0,1,0,
604,1,0,510,75,0,3,2600,0,1,1,0,1,0,1,3,0,0,
622,1,0,511,34,0,5,2602,0,1,1,0,1,0,1,3,0,0,
640,1,0,512,49,0,3,2604,0,0,0,0,1,0,
654,1,0,513,18,0,1,2606,0,0,0,0,1,0,
668,1,0,514,0,0,29,2607,0,0,0,0,1,0,
682,1,0,515,59,0,9,2667,0,1,1,0,1,0,1,3,0,0,
700,1,0,515,0,0,13,2673,0,1,0,0,1,0,2,3,0,0,
718,1,0,515,0,0,15,2678,0,0,0,0,1,0,
732,1,0,516,56,0,4,2689,0,2,1,0,1,0,2,3,0,0,1,3,0,0,
754,1,0,517,282,0,44,2700,0,0,0,0,1,0,
768,1,0,518,62,0,3,2702,0,1,1,0,1,0,1,3,0,0,
786,1,0,519,34,0,5,2704,0,1,1,0,1,0,1,3,0,0,
804,1,0,520,48,0,3,2706,0,0,0,0,1,0,
818,1,0,521,18,0,1,2708,0,0,0,0,1,0,
832,1,0,522,0,0,29,2709,0,0,0,0,1,0,
846,1,0,523,216,0,44,2714,0,0,0,0,1,0,
860,1,0,524,67,0,3,2717,0,1,1,0,1,0,1,3,0,0,
878,1,0,525,34,0,5,2719,0,1,1,0,1,0,1,3,0,0,
896,1,0,526,53,0,3,2721,0,0,0,0,1,0,
910,1,0,527,18,0,1,2723,0,0,0,0,1,0,
924,1,0,528,0,0,29,2724,0,0,0,0,1,0,
938,1,0,529,222,0,44,2729,0,0,0,0,1,0,
952,1,0,530,70,0,3,2732,0,1,1,0,1,0,1,3,0,0,
970,1,0,531,34,0,5,2734,0,1,1,0,1,0,1,3,0,0,
988,1,0,532,56,0,3,2736,0,0,0,0,1,0,
1002,1,0,533,18,0,1,2738,0,0,0,0,1,0,
1016,1,0,534,0,0,29,2739,0,0,0,0,1,0,
1030,1,0,535,312,0,44,2745,0,0,0,0,1,0,
1044,1,0,536,62,0,3,2749,0,1,1,0,1,0,1,3,0,0,
1062,1,0,537,34,0,5,2751,0,1,1,0,1,0,1,3,0,0,
1080,1,0,538,48,0,3,2753,0,0,0,0,1,0,
1094,1,0,539,18,0,1,2755,0,0,0,0,1,0,
1108,1,0,540,0,0,29,2756,0,0,0,0,1,0,
1122,1,0,541,194,0,44,2762,0,0,0,0,1,0,
1136,1,0,542,66,0,3,2764,0,1,1,0,1,0,1,3,0,0,
1154,1,0,543,34,0,5,2766,0,1,1,0,1,0,1,3,0,0,
1172,1,0,544,52,0,3,2768,0,0,0,0,1,0,
1186,1,0,545,18,0,1,2770,0,0,0,0,1,0,
1200,1,0,546,0,0,29,2771,0,0,0,0,1,0,
1214,1,0,547,214,0,44,2777,0,0,0,0,1,0,
1228,1,0,548,65,0,3,2779,0,1,1,0,1,0,1,3,0,0,
1246,1,0,549,34,0,5,2781,0,1,1,0,1,0,1,3,0,0,
1264,1,0,550,51,0,3,2783,0,0,0,0,1,0,
1278,1,0,551,18,0,1,2785,0,0,0,0,1,0,
1292,1,0,552,0,0,29,2786,0,0,0,0,1,0,
1306,1,0,553,317,0,44,2792,0,0,0,0,1,0,
1320,1,0,554,67,0,3,2796,0,1,1,0,1,0,1,3,0,0,
1338,1,0,555,34,0,5,2798,0,1,1,0,1,0,1,3,0,0,
1356,1,0,556,53,0,3,2800,0,0,0,0,1,0,
1370,1,0,557,18,0,1,2802,0,0,0,0,1,0,
1384,1,0,558,0,0,29,2803,0,0,0,0,1,0,
1398,1,0,559,208,0,44,2809,0,0,0,0,1,0,
1412,1,0,560,65,0,3,2811,0,1,1,0,1,0,1,3,0,0,
1430,1,0,561,34,0,5,2813,0,1,1,0,1,0,1,3,0,0,
1448,1,0,562,51,0,3,2815,0,0,0,0,1,0,
1462,1,0,563,18,0,1,2817,0,0,0,0,1,0,
1476,1,0,564,0,0,29,2818,0,0,0,0,1,0,
1490,1,0,565,254,0,44,2824,0,0,0,0,1,0,
1504,1,0,566,64,0,3,2827,0,1,1,0,1,0,1,3,0,0,
1522,1,0,567,34,0,5,2829,0,1,1,0,1,0,1,3,0,0,
1540,1,0,568,50,0,3,2831,0,0,0,0,1,0,
1554,1,0,569,18,0,1,2833,0,0,0,0,1,0,
1568,1,0,570,0,0,29,2834,0,0,0,0,1,0,
1582,1,0,571,221,0,44,2840,0,0,0,0,1,0,
1596,1,0,572,72,0,3,2843,0,1,1,0,1,0,1,3,0,0,
1614,1,0,573,34,0,5,2845,0,1,1,0,1,0,1,3,0,0,
1632,1,0,574,58,0,3,2847,0,0,0,0,1,0,
1646,1,0,575,18,0,1,2849,0,0,0,0,1,0,
1660,1,0,576,0,0,29,2850,0,0,0,0,1,0,
1674,1,0,577,202,0,44,2856,0,0,0,0,1,0,
1688,1,0,578,71,0,3,2859,0,1,1,0,1,0,1,3,0,0,
1706,1,0,579,34,0,5,2861,0,1,1,0,1,0,1,3,0,0,
1724,1,0,580,57,0,3,2863,0,0,0,0,1,0,
1738,1,0,581,18,0,1,2865,0,0,0,0,1,0,
1752,1,0,582,0,0,29,2866,0,0,0,0,1,0,
1766,1,0,583,221,0,44,2872,0,0,0,0,1,0,
1780,1,0,584,73,0,3,2875,0,1,1,0,1,0,1,3,0,0,
1798,1,0,585,34,0,5,2877,0,1,1,0,1,0,1,3,0,0,
1816,1,0,586,59,0,3,2879,0,0,0,0,1,0,
1830,1,0,587,18,0,1,2881,0,0,0,0,1,0,
1844,1,0,588,0,0,29,2882,0,0,0,0,1,0,
1858,1,0,589,202,0,44,2888,0,0,0,0,1,0,
1872,1,0,590,72,0,3,2890,0,1,1,0,1,0,1,3,0,0,
1890,1,0,591,34,0,5,2892,0,1,1,0,1,0,1,3,0,0,
1908,1,0,592,58,0,3,2894,0,0,0,0,1,0,
1922,1,0,593,18,0,1,2896,0,0,0,0,1,0,
1936,1,0,594,0,0,29,2897,0,0,0,0,1,0,
1950,1,0,595,205,0,44,2903,0,0,0,0,1,0,
1964,1,0,596,69,0,3,2905,0,1,1,0,1,0,1,3,0,0,
1982,1,0,597,34,0,5,2907,0,1,1,0,1,0,1,3,0,0,
2000,1,0,598,55,0,3,2909,0,0,0,0,1,0,
2014,1,0,599,18,0,1,2911,0,0,0,0,1,0,
2028,1,0,600,0,0,29,2912,0,0,0,0,1,0,
2042,1,0,601,227,0,44,2918,0,0,0,0,1,0,
2056,1,0,602,68,0,3,2921,0,1,1,0,1,0,1,3,0,0,
2074,1,0,603,34,0,5,2923,0,1,1,0,1,0,1,3,0,0,
2092,1,0,604,54,0,3,2925,0,0,0,0,1,0,
2106,1,0,605,18,0,1,2927,0,0,0,0,1,0,
2120,1,0,606,0,0,29,2928,0,0,0,0,1,0,
2134,1,0,607,274,0,44,2934,0,0,0,0,1,0,
2148,1,0,608,79,0,3,2938,0,1,1,0,1,0,1,3,0,0,
2166,1,0,609,34,0,5,2940,0,1,1,0,1,0,1,3,0,0,
2184,1,0,610,65,0,3,2942,0,0,0,0,1,0,
2198,1,0,611,18,0,1,2944,0,0,0,0,1,0,
2212,1,0,612,0,0,29,2945,0,0,0,0,1,0,
2226,1,0,613,298,0,44,2951,0,0,0,0,1,0,
2240,1,0,614,71,0,3,2955,0,1,1,0,1,0,1,3,0,0,
2258,1,0,615,34,0,5,2957,0,1,1,0,1,0,1,3,0,0,
2276,1,0,616,57,0,3,2959,0,0,0,0,1,0,
2290,1,0,617,18,0,1,2961,0,0,0,0,1,0,
2304,1,0,618,0,0,29,2962,0,0,0,0,1,0,
2318,1,0,619,259,0,44,2968,0,0,0,0,1,0,
2332,1,0,620,82,0,3,2971,0,1,1,0,1,0,1,3,0,0,
2350,1,0,621,34,0,5,2973,0,1,1,0,1,0,1,3,0,0,
2368,1,0,622,68,0,3,2975,0,0,0,0,1,0,
2382,1,0,623,18,0,1,2977,0,0,0,0,1,0,
2396,1,0,624,0,0,29,2978,0,0,0,0,1,0,
2410,1,0,625,205,0,44,2984,0,0,0,0,1,0,
2424,1,0,626,75,0,3,2987,0,1,1,0,1,0,1,3,0,0,
2442,1,0,627,34,0,5,2989,0,1,1,0,1,0,1,3,0,0,
2460,1,0,628,61,0,3,2991,0,0,0,0,1,0,
2474,1,0,629,18,0,1,2993,0,0,0,0,1,0,
2488,1,0,630,0,0,29,2994,0,0,0,0,1,0,
2502,1,0,631,1127,0,44,3000,0,0,0,0,1,0,
2516,1,0,632,82,0,3,3013,0,1,1,0,1,0,1,3,0,0,
2534,1,0,633,34,0,5,3015,0,1,1,0,1,0,1,3,0,0,
2552,1,0,634,68,0,3,3017,0,0,0,0,1,0,
2566,1,0,635,18,0,1,3019,0,0,0,0,1,0,
2580,1,0,636,0,0,29,3020,0,0,0,0,1,0,
2594,1,0,637,518,0,44,3026,0,0,0,0,1,0,
2608,1,0,638,80,0,3,3033,0,1,1,0,1,0,1,3,0,0,
2626,1,0,639,34,0,5,3035,0,1,1,0,1,0,1,3,0,0,
2644,1,0,640,66,0,3,3037,0,0,0,0,1,0,
2658,1,0,641,18,0,1,3039,0,0,0,0,1,0,
2672,1,0,642,0,0,29,3040,0,0,0,0,1,0,
2686,1,0,643,269,0,44,3046,0,0,0,0,1,0,
2700,1,0,644,78,0,3,3050,0,1,1,0,1,0,1,3,0,0,
2718,1,0,645,34,0,5,3052,0,1,1,0,1,0,1,3,0,0,
2736,1,0,646,64,0,3,3054,0,0,0,0,1,0,
2750,1,0,647,18,0,1,3056,0,0,0,0,1,0,
2764,1,0,648,0,0,29,3057,0,0,0,0,1,0,
2778,1,0,649,224,0,44,3063,0,0,0,0,1,0,
2792,1,0,650,75,0,3,3066,0,1,1,0,1,0,1,3,0,0,
2810,1,0,651,34,0,5,3068,0,1,1,0,1,0,1,3,0,0,
2828,1,0,652,61,0,3,3070,0,0,0,0,1,0,
2842,1,0,653,18,0,1,3072,0,0,0,0,1,0,
2856,1,0,654,0,0,29,3073,0,0,0,0,1,0,
2870,1,0,655,217,0,44,3080,0,0,0,0,1,0,
2884,1,0,656,75,0,3,3083,0,1,1,0,1,0,1,3,0,0,
2902,1,0,657,34,0,5,3085,0,1,1,0,1,0,1,3,0,0,
2920,1,0,658,61,0,3,3087,0,0,0,0,1,0,
2934,1,0,659,18,0,1,3089,0,0,0,0,1,0,
2948,1,0,660,0,0,29,3090,0,0,0,0,1,0,
2962,1,0,661,164,0,44,3096,0,0,0,0,1,0,
2976,1,0,662,72,0,3,3098,0,1,1,0,1,0,1,3,0,0,
2994,1,0,663,34,0,5,3100,0,1,1,0,1,0,1,3,0,0,
3012,1,0,664,58,0,3,3102,0,0,0,0,1,0,
3026,1,0,665,18,0,1,3104,0,0,0,0,1,0,
3040,1,0,666,0,0,29,3105,0,0,0,0,1,0,
3054,1,0,667,160,0,44,3111,0,0,0,0,1,0,
3068,1,0,668,75,0,3,3113,0,1,1,0,1,0,1,3,0,0,
3086,1,0,669,34,0,5,3115,0,1,1,0,1,0,1,3,0,0,
3104,1,0,670,61,0,3,3117,0,0,0,0,1,0,
3118,1,0,671,18,0,1,3119,0,0,0,0,1,0,
3132,1,0,672,0,0,29,3120,0,0,0,0,1,0,
3146,1,0,673,190,0,44,3126,0,0,0,0,1,0,
3160,1,0,674,66,0,3,3128,0,1,1,0,1,0,1,3,0,0,
3178,1,0,675,34,0,5,3130,0,1,1,0,1,0,1,3,0,0,
3196,1,0,676,52,0,3,3132,0,0,0,0,1,0,
3210,1,0,677,18,0,1,3134,0,0,0,0,1,0,
3224,1,0,678,0,0,29,3135,0,0,0,0,1,0,
3238,1,0,679,1413,0,44,3141,0,0,0,0,1,0,
3252,1,0,680,66,0,3,3159,0,1,1,0,1,0,1,3,0,0,
3270,1,0,681,34,0,5,3161,0,1,1,0,1,0,1,3,0,0,
3288,1,0,682,52,0,3,3163,0,0,0,0,1,0,
3302,1,0,683,18,0,1,3165,0,0,0,0,1,0,
3316,1,0,684,0,0,29,3166,0,0,0,0,1,0,
3330,1,0,685,206,0,44,3172,0,0,0,0,1,0,
3344,1,0,686,78,0,3,3175,0,1,1,0,1,0,1,3,0,0,
3362,1,0,687,34,0,5,3177,0,1,1,0,1,0,1,3,0,0,
3380,1,0,688,64,0,3,3179,0,0,0,0,1,0,
3394,1,0,689,18,0,1,3181,0,0,0,0,1,0,
3408,1,0,690,0,0,29,3182,0,0,0,0,1,0,
3422,1,0,691,187,0,44,3188,0,0,0,0,1,0,
3436,1,0,692,69,0,3,3190,0,1,1,0,1,0,1,3,0,0,
3454,1,0,693,34,0,5,3192,0,1,1,0,1,0,1,3,0,0,
3472,1,0,694,55,0,3,3194,0,0,0,0,1,0,
3486,1,0,695,18,0,1,3196,0,0,0,0,1,0,
3500,1,0,696,0,0,29,3197,0,0,0,0,1,0,
3514,1,0,697,53,0,2,3232,0,1,1,0,1,0,1,3,0,0,
3532,1,0,698,0,0,29,3233,0,0,0,0,1,0,
3546,1,0,699,52,0,3,3250,0,3,3,0,1,0,1,4,0,0,1,4,0,0,1,4,0,0,
3572,1,0,700,0,0,29,3252,0,0,0,0,1,0,
3586,1,0,701,52,0,3,3257,0,3,3,0,1,0,1,4,0,0,1,4,0,0,1,4,0,0,
3612,1,0,702,0,0,29,3260,0,0,0,0,1,0,
3626,1,0,703,89,0,9,3304,0,1,1,0,1,0,1,3,0,0,
3644,1,0,703,0,0,13,3310,0,2,0,0,1,0,2,4,0,0,2,4,0,0,
3666,1,0,703,0,0,15,3322,0,0,0,0,1,0,
3680,1,0,704,44,0,2,3357,0,1,1,0,1,0,1,3,0,0,
3698,1,0,705,56,0,3,3359,0,5,5,0,1,0,1,3,0,0,1,4,0,0,1,4,0,0,1,4,0,0,1,4,0,0,
3732,1,0,706,0,0,29,3361,0,0,0,0,1,0,
3746,1,0,707,94,0,9,3402,0,1,1,0,1,0,1,3,0,0,
3764,1,0,707,0,0,13,3408,0,5,0,0,1,0,2,3,0,0,2,4,0,0,2,4,0,0,2,4,0,0,2,4,0,0,
3798,1,0,707,0,0,15,3412,0,0,0,0,1,0,
3812,1,0,708,137,0,9,3471,0,1,1,0,1,0,1,3,0,0,
3830,1,0,708,0,0,13,3479,0,3,0,0,1,0,2,3,0,0,2,3,0,0,2,3,0,0,
3856,1,0,708,0,0,15,3485,0,0,0,0,1,0,
3870,1,0,709,109,0,9,3509,0,1,1,0,1,0,1,3,0,0,
3888,1,0,709,0,0,13,3516,0,3,0,0,1,0,2,3,0,0,2,3,0,0,2,3,0,0,
3914,1,0,709,0,0,15,3522,0,0,0,0,1,0,
3928,1,0,710,138,0,9,3581,0,1,1,0,1,0,1,3,0,0,
3946,1,0,710,0,0,13,3589,0,3,0,0,1,0,2,3,0,0,2,3,0,0,2,3,0,0,
3972,1,0,710,0,0,15,3595,0,0,0,0,1,0,
3986,1,0,711,110,0,9,3619,0,1,1,0,1,0,1,3,0,0,
4004,1,0,711,0,0,13,3626,0,3,0,0,1,0,2,3,0,0,2,3,0,0,2,3,0,0,
4030,1,0,711,0,0,15,3632,0,0,0,0,1,0,
4044,1,0,712,50,0,2,3688,0,1,1,0,1,0,1,3,0,0,
4062,1,0,713,0,0,29,3689,0,0,0,0,1,0,
4076,1,0,714,53,0,3,3712,0,4,4,0,1,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,
4106,1,0,715,0,0,29,3713,0,0,0,0,1,0,
4120,1,0,716,53,0,3,3724,0,4,4,0,1,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,
4150,1,0,717,0,0,29,3726,0,0,0,0,1,0,
4164,1,0,718,51,0,2,3778,0,1,1,0,1,0,1,3,0,0,
4182,1,0,719,0,0,29,3779,0,0,0,0,1,0,
4196,1,0,720,54,0,3,3803,0,4,4,0,1,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,
4226,1,0,721,0,0,29,3804,0,0,0,0,1,0,
4240,1,0,722,54,0,3,3815,0,4,4,0,1,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,
4270,1,0,723,0,0,29,3817,0,0,0,0,1,0,
4284,1,0,708,137,0,9,3866,0,1,1,0,1,0,1,3,0,0,
4302,1,0,708,0,0,13,3872,0,3,0,0,1,0,2,4,0,0,2,4,0,0,2,3,0,0,
4328,1,0,708,0,0,15,3884,0,0,0,0,1,0,
4342,1,0,724,97,0,9,3927,0,1,1,0,1,0,1,3,0,0,
4360,1,0,724,0,0,13,3933,0,3,0,0,1,0,2,4,0,0,2,4,0,0,2,3,0,0,
4386,1,0,724,0,0,15,3945,0,0,0,0,1,0,
4400,1,0,725,49,0,2,3990,0,1,1,0,1,0,1,3,0,0,
4418,1,0,726,0,0,29,3991,0,0,0,0,1,0,
4432,1,0,727,52,0,3,4015,0,4,4,0,1,0,1,4,0,0,1,4,0,0,1,4,0,0,1,3,0,0,
4462,1,0,728,0,0,29,4017,0,0,0,0,1,0,
4476,1,0,729,52,0,3,4026,0,4,4,0,1,0,1,4,0,0,1,4,0,0,1,4,0,0,1,3,0,0,
4506,1,0,730,0,0,29,4029,0,0,0,0,1,0,
4520,1,0,731,50,0,2,4075,0,1,1,0,1,0,1,3,0,0,
4538,1,0,732,0,0,29,4076,0,0,0,0,1,0,
4552,1,0,733,53,0,3,4099,0,4,4,0,1,0,1,4,0,0,1,4,0,0,1,4,0,0,1,3,0,0,
4582,1,0,734,0,0,29,4101,0,0,0,0,1,0,
4596,1,0,735,53,0,3,4109,0,4,4,0,1,0,1,4,0,0,1,4,0,0,1,4,0,0,1,3,0,0,
4626,1,0,736,0,0,29,4112,0,0,0,0,1,0,
4640,1,0,737,119,0,9,4162,0,1,1,0,1,0,1,3,0,0,
4658,1,0,737,0,0,13,4169,0,6,0,0,1,0,2,3,0,0,2,9,0,0,2,4,0,0,2,4,0,0,2,3,0,0,2,
3,0,0,
4696,1,0,737,0,0,15,4182,0,0,0,0,1,0,
4710,1,0,738,40,0,2,4228,0,1,1,0,1,0,1,3,0,0,
4728,1,0,739,0,0,29,4229,0,0,0,0,1,0,
4742,1,0,740,55,0,3,4259,0,7,7,0,1,0,1,3,0,0,1,3,0,0,1,9,0,0,1,4,0,0,1,4,0,0,1,
3,0,0,1,3,0,0,
4784,1,0,741,0,0,29,4261,0,0,0,0,1,0,
4798,1,0,742,55,0,3,4271,0,7,7,0,1,0,1,3,0,0,1,3,0,0,1,9,0,0,1,4,0,0,1,4,0,0,1,
3,0,0,1,3,0,0,
4840,1,0,743,0,0,29,4273,0,0,0,0,1,0,
4854,1,0,744,144,0,9,4318,0,1,1,0,1,0,1,3,0,0,
4872,1,0,744,0,0,13,4325,0,7,0,0,1,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,0,2,
3,0,0,2,3,0,0,
4914,1,0,744,0,0,15,4352,0,0,0,0,1,0,
4928,1,0,745,40,0,2,4400,0,1,1,0,1,0,1,3,0,0,
4946,1,0,746,48,0,2,4401,0,1,1,0,1,0,1,3,0,0,
4964,1,0,747,59,0,3,4441,0,8,8,0,1,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,
3,0,0,1,3,0,0,1,3,0,0,
5010,1,0,748,0,0,29,4444,0,0,0,0,1,0,
5024,1,0,749,59,0,3,4456,0,8,8,0,1,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,
3,0,0,1,3,0,0,1,3,0,0,
5070,1,0,750,0,0,29,4459,0,0,0,0,1,0,
5084,1,0,751,126,0,9,4517,0,2,2,0,1,0,1,3,0,0,1,3,0,0,
5106,1,0,751,0,0,13,4523,0,4,0,0,1,0,2,4,0,0,2,4,0,0,2,4,0,0,2,4,0,0,
5136,1,0,751,0,0,15,4535,0,0,0,0,1,0,
5150,1,0,752,55,0,3,4579,0,5,5,0,1,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,
5184,1,0,753,0,0,29,4581,0,0,0,0,1,0,
5198,1,0,754,55,0,3,4587,0,5,5,0,1,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,
5232,1,0,755,0,0,29,4589,0,0,0,0,1,0,
5246,1,0,756,103,0,9,4649,0,2,2,0,1,0,1,3,0,0,1,3,0,0,
5268,1,0,756,0,0,13,4655,0,3,0,0,1,0,2,3,0,0,2,9,0,0,2,3,0,0,
5294,1,0,757,105,0,9,4682,0,2,2,0,1,0,1,3,0,0,1,3,0,0,
5316,1,0,757,0,0,13,4685,0,3,0,0,1,0,2,3,0,0,2,3,0,0,2,3,0,0,
5342,1,0,757,0,0,15,4689,0,0,0,0,1,0,
5356,1,0,756,0,0,15,4701,0,0,0,0,1,0,
5370,1,0,758,44,0,2,4780,0,1,1,0,1,0,1,4,0,0,
5388,1,0,759,43,0,2,4781,0,1,1,0,1,0,1,4,0,0,
5406,1,0,760,45,0,2,4782,0,1,1,0,1,0,1,4,0,0,
5424,1,0,761,51,0,3,4798,0,4,4,0,1,0,1,4,0,0,1,3,0,0,1,9,0,0,1,3,0,0,
5454,1,0,762,55,0,3,4814,0,5,5,0,1,0,1,4,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,
5488,1,0,763,0,0,29,4819,0,0,0,0,1,0,
5502,1,0,764,72,0,3,4852,0,8,8,0,1,0,1,4,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,
3,0,0,1,3,0,0,1,3,0,0,
5548,1,0,765,0,0,29,4855,0,0,0,0,1,0,
5562,1,0,766,0,0,29,4861,0,0,0,0,1,0,
5576,1,0,767,168,0,9,4921,0,2,2,0,1,0,1,3,0,0,1,3,0,0,
5598,1,0,767,0,0,13,4926,0,8,0,0,1,0,2,4,0,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,0,2,
3,0,0,2,3,0,0,2,3,0,0,
5644,1,0,767,0,0,15,5017,0,0,0,0,1,0,
5658,1,0,768,44,0,2,5218,0,1,1,0,1,0,1,3,0,0,
5676,1,0,769,0,0,29,5219,0,0,0,0,1,0,
5690,1,0,770,226,0,3,5224,0,34,34,0,1,0,1,3,0,0,1,3,0,0,1,4,0,0,1,4,0,0,1,4,0,
0,1,4,0,0,1,4,0,0,1,4,0,0,1,4,0,0,1,3,0,0,1,3,0,0,1,4,0,0,1,3,0,0,1,3,0,0,1,3,
0,0,1,4,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,4,0,0,1,3,0,0,1,4,0,0,1,4,0,0,1,4,0,0,1,
4,0,0,1,4,0,0,1,4,0,0,1,4,0,0,1,4,0,0,1,4,0,0,1,4,0,0,1,4,0,0,1,4,0,0,1,4,0,0,
5840,1,0,771,0,0,29,5226,0,0,0,0,1,0,
5854,1,0,772,69,0,9,5239,0,1,1,0,1,0,1,3,0,0,
5872,1,0,772,0,0,13,5245,0,4,0,0,1,0,2,3,0,0,2,3,0,0,2,3,0,0,2,4,0,0,
5902,1,0,772,0,0,15,5251,0,0,0,0,1,0,
5916,1,0,773,56,0,2,5256,0,1,1,0,1,0,1,3,0,0,
5934,1,0,774,0,0,29,5257,0,0,0,0,1,0,
5948,1,0,775,59,0,3,5289,0,4,4,0,1,0,1,4,0,0,1,3,0,0,1,3,0,0,1,4,0,0,
5978,1,0,776,0,0,29,5291,0,0,0,0,1,0,
5992,1,0,777,59,0,3,5303,0,4,4,0,1,0,1,4,0,0,1,3,0,0,1,3,0,0,1,4,0,0,
6022,1,0,778,0,0,29,5306,0,0,0,0,1,0,
6036,1,0,779,246,0,4,5429,0,35,1,0,1,0,2,3,0,0,2,3,0,0,2,4,0,0,2,4,0,0,2,4,0,0,
2,4,0,0,2,4,0,0,2,4,0,0,2,4,0,0,2,3,0,0,2,3,0,0,2,4,0,0,2,3,0,0,2,3,0,0,2,3,0,
0,2,4,0,0,2,3,0,0,2,3,0,0,2,3,0,0,2,4,0,0,2,3,0,0,2,4,0,0,2,4,0,0,2,4,0,0,2,4,
0,0,2,4,0,0,2,4,0,0,2,4,0,0,2,4,0,0,2,4,0,0,2,4,0,0,2,4,0,0,2,4,0,0,2,4,0,0,1,
3,0,0,
6190,1,0,780,69,0,9,5497,0,1,1,0,1,0,1,3,0,0,
6208,1,0,780,0,0,13,5503,0,4,0,0,1,0,2,3,0,0,2,3,0,0,2,3,0,0,2,4,0,0,
6238,1,0,780,0,0,15,5508,0,0,0,0,1,0,
6252,1,0,781,643,0,9,5625,0,2,2,0,1,0,1,3,0,0,1,3,0,0,
6274,1,0,781,0,0,13,5629,0,28,0,0,1,0,2,3,0,0,2,3,0,0,2,3,0,0,2,4,0,0,2,4,0,0,
2,4,0,0,2,4,0,0,2,3,0,0,2,4,0,0,2,4,0,0,2,3,0,0,2,4,0,0,2,4,0,0,2,4,0,0,2,4,0,
0,2,4,0,0,2,4,0,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,
0,0,2,3,0,0,2,3,0,0,2,4,0,0,
6400,1,0,781,0,0,15,5633,0,0,0,0,1,0,
6414,1,0,782,60,0,2,5798,0,1,1,0,1,0,1,3,0,0,
6432,1,0,783,212,0,3,5800,0,29,29,0,1,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,4,0,
0,1,4,0,0,1,4,0,0,1,4,0,0,1,3,0,0,1,4,0,0,1,4,0,0,1,3,0,0,1,4,0,0,1,4,0,0,1,4,
0,0,1,4,0,0,1,4,0,0,1,4,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,
3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,4,0,0,
6562,1,0,784,0,0,29,5804,0,0,0,0,1,0,
6576,1,0,785,105,0,9,5844,0,1,1,0,1,0,1,3,0,0,
6594,1,0,785,0,0,13,5859,0,4,0,0,1,0,2,4,0,0,2,4,0,0,2,4,0,0,2,4,0,0,
6624,1,0,785,0,0,15,5869,0,0,0,0,1,0,
6638,1,0,786,53,0,2,5916,0,1,1,0,1,0,1,3,0,0,
6656,1,0,787,65,0,3,5941,0,5,5,0,1,0,1,3,0,0,1,4,0,0,1,4,0,0,1,4,0,0,1,4,0,0,
6690,1,0,788,0,0,29,5945,0,0,0,0,1,0,
6704,1,0,789,0,0,29,5954,0,0,0,0,1,0,
6718,1,0,790,120,0,9,6010,0,1,1,0,1,0,1,3,0,0,
6736,1,0,790,0,0,13,6018,0,3,0,0,1,0,2,3,0,0,2,3,0,0,2,4,0,0,
6762,1,0,790,0,0,15,6024,0,0,0,0,1,0,
6776,1,0,791,94,0,9,6041,0,1,1,0,1,0,1,3,0,0,
6794,1,0,791,0,0,13,6048,0,3,0,0,1,0,2,3,0,0,2,3,0,0,2,4,0,0,
6820,1,0,791,0,0,15,6054,0,0,0,0,1,0,
6834,1,0,792,26,0,2,6098,0,0,0,0,1,0,
6848,1,0,793,54,0,3,6129,0,4,4,0,1,0,1,3,0,0,1,3,0,0,1,3,0,0,1,4,0,0,
6878,1,0,794,0,0,29,6134,0,0,0,0,1,0,
6892,1,0,795,0,0,29,6143,0,0,0,0,1,0,
6906,1,0,796,101,0,9,6184,0,1,1,0,1,0,1,3,0,0,
6924,1,0,796,0,0,13,6199,0,4,0,0,1,0,2,4,0,0,2,4,0,0,2,3,0,0,2,4,0,0,
6954,1,0,796,0,0,15,6209,0,0,0,0,1,0,
6968,1,0,797,46,0,2,6256,0,1,1,0,1,0,1,3,0,0,
6986,1,0,798,58,0,3,6281,0,5,5,0,1,0,1,3,0,0,1,4,0,0,1,4,0,0,1,3,0,0,1,4,0,0,
7020,1,0,799,0,0,29,6292,0,0,0,0,1,0,
7034,1,0,800,0,0,29,6294,0,0,0,0,1,0,
7048,1,0,801,377,0,4,6374,0,15,2,0,1,0,2,4,0,0,2,3,0,0,2,3,0,0,2,3,0,0,2,4,0,0,
2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,0,1,3,0,0,1,4,0,
0,
7122,1,0,802,58,0,2,6461,0,1,1,0,1,0,1,3,0,0,
7140,1,0,803,120,0,3,6463,0,14,14,0,1,0,1,3,0,0,1,4,0,0,1,3,0,0,1,3,0,0,1,3,0,
0,1,4,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,
7210,1,0,804,0,0,29,6466,0,0,0,0,1,0,
7224,1,0,805,105,0,9,6503,0,2,2,0,1,0,1,3,0,0,1,3,0,0,
7246,1,0,805,0,0,13,6527,0,3,0,0,1,0,2,3,0,0,2,3,0,0,2,3,0,0,
7272,1,0,805,0,0,15,6538,0,0,0,0,1,0,
7286,1,0,806,50,0,3,6581,0,4,4,0,1,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,
7316,1,0,807,0,0,29,6586,0,0,0,0,1,0,
7330,1,0,808,0,0,29,6595,0,0,0,0,1,0,
7344,1,0,809,86,0,9,6633,0,1,1,0,1,0,1,3,0,0,
7362,1,0,809,0,0,13,6650,0,3,0,0,1,0,2,4,0,0,2,9,0,0,2,3,0,0,
7388,1,0,809,0,0,15,6656,0,0,0,0,1,0,
7402,1,0,810,44,0,2,6699,0,1,1,0,1,0,1,3,0,0,
7420,1,0,811,43,0,2,6701,0,1,1,0,1,0,1,3,0,0,
7438,1,0,812,51,0,3,6721,0,4,4,0,1,0,1,3,0,0,1,4,0,0,1,9,0,0,1,3,0,0,
7468,1,0,813,0,0,29,6727,0,0,0,0,1,0,
7482,1,0,814,0,0,29,6739,0,0,0,0,1,0,
7496,1,0,815,89,0,9,6790,0,1,1,0,1,0,1,3,0,0,
7514,1,0,815,0,0,13,6797,0,3,0,0,1,0,2,3,0,0,2,3,0,0,2,3,0,0,
7540,1,0,815,0,0,15,6810,0,0,0,0,1,0,
7554,1,0,816,108,0,9,6856,0,2,2,0,1,0,1,3,0,0,1,3,0,0,
7576,1,0,816,0,0,13,6883,0,3,0,0,1,0,2,3,0,0,2,3,0,0,2,3,0,0,
7602,1,0,816,0,0,15,6897,0,0,0,0,1,0,
7616,1,0,817,47,0,2,6941,0,1,1,0,1,0,1,3,0,0,
7634,1,0,818,54,0,3,6967,0,4,4,0,1,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,
7664,1,0,819,0,0,29,6974,0,0,0,0,1,0,
7678,1,0,820,0,0,29,6985,0,0,0,0,1,0,
7692,1,0,821,168,0,4,7034,0,6,1,0,1,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,0,
1,3,0,0,
7730,1,0,822,56,0,2,7079,0,1,1,0,1,0,1,3,0,0,
7748,1,0,823,73,0,3,7081,0,6,6,0,1,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,
3,0,0,
7786,1,0,824,0,0,29,7084,0,0,0,0,1,0,
7800,1,0,825,117,0,9,7123,0,1,1,0,1,0,1,3,0,0,
7818,1,0,825,0,0,13,7126,0,3,0,0,1,0,2,3,0,0,2,3,0,0,2,3,0,0,
7844,1,0,825,0,0,15,7137,0,0,0,0,1,0,
7858,1,0,826,52,0,3,7178,0,4,4,0,1,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,
7888,1,0,827,0,0,29,7180,0,0,0,0,1,0,
7902,1,0,828,50,0,2,7202,0,1,1,0,1,0,1,3,0,0,
7920,1,0,825,117,0,9,7242,0,1,1,0,1,0,1,3,0,0,
7938,1,0,825,0,0,13,7245,0,4,0,0,1,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,0,
7968,1,0,825,0,0,15,7261,0,0,0,0,1,0,
7982,1,0,829,57,0,3,7304,0,5,5,0,1,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,
8016,1,0,830,0,0,29,7306,0,0,0,0,1,0,
8030,1,0,831,0,0,29,7308,0,0,0,0,1,0,
8044,1,0,832,50,0,2,7330,0,1,1,0,1,0,1,3,0,0,
8062,1,0,825,117,0,9,7369,0,1,1,0,1,0,1,3,0,0,
8080,1,0,825,0,0,13,7372,0,3,0,0,1,0,2,3,0,0,2,3,0,0,2,3,0,0,
8106,1,0,825,0,0,15,7383,0,0,0,0,1,0,
8120,1,0,833,50,0,3,7418,0,4,4,0,1,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,
8150,1,0,834,0,0,29,7419,0,0,0,0,1,0,
8164,1,0,835,0,0,29,7421,0,0,0,0,1,0,
8178,1,0,836,48,0,2,7443,0,1,1,0,1,0,1,3,0,0,
4,2,0,837,202,0,9,7478,0,5,1,0,1,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,0,1,3,0,0,
38,2,0,837,0,0,13,7489,0,4,0,0,1,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,0,
68,2,0,837,0,0,15,7507,0,0,0,0,1,0,
82,2,0,837,202,0,9,7543,0,5,1,0,1,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,0,1,3,0,0,
116,2,0,837,0,0,13,7554,0,4,0,0,1,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,0,
146,2,0,837,0,0,15,7572,0,0,0,0,1,0,
160,2,0,838,42,0,2,7596,0,1,1,0,1,0,1,3,0,0,
178,2,0,839,49,0,3,7633,0,5,5,0,1,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,
212,2,0,840,0,0,29,7634,0,0,0,0,1,0,
226,2,0,841,0,0,29,7636,0,0,0,0,1,0,
240,2,0,842,105,0,9,7675,0,1,1,0,1,0,1,3,0,0,
258,2,0,842,0,0,13,7678,0,1,0,0,1,0,2,3,0,0,
276,2,0,842,0,0,15,7682,0,0,0,0,1,0,
290,2,0,825,117,0,9,7715,0,1,1,0,1,0,1,3,0,0,
308,2,0,825,0,0,13,7718,0,4,0,0,1,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,0,
338,2,0,825,0,0,15,7744,0,0,0,0,1,0,
352,2,0,843,68,0,3,7790,0,6,6,0,1,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,
3,0,0,
390,2,0,844,0,0,29,7793,0,0,0,0,1,0,
404,2,0,845,0,0,29,7796,0,0,0,0,1,0,
418,2,0,846,57,0,2,7815,0,1,1,0,1,0,1,3,0,0,
436,2,0,847,169,0,4,7849,0,6,2,0,1,0,2,4,0,0,2,4,0,0,2,4,0,0,2,3,0,0,1,3,0,0,1,
3,0,0,
474,2,0,848,160,0,3,7890,0,6,6,0,1,0,1,3,0,0,1,3,0,0,1,4,0,0,1,4,0,0,1,4,0,0,1,
3,0,0,
512,2,0,849,0,0,29,7892,0,0,0,0,1,0,
526,2,0,850,192,0,5,7923,0,0,0,0,1,0,
540,2,0,851,0,0,29,7929,0,0,0,0,1,0,
554,2,0,852,102,0,5,7953,0,0,0,0,1,0,
568,2,0,853,0,0,29,7957,0,0,0,0,1,0,
582,2,0,854,49,0,2,7989,0,1,1,0,1,0,1,3,0,0,
600,2,0,855,160,0,3,8000,0,6,6,0,1,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,
3,0,0,
638,2,0,856,0,0,29,8002,0,0,0,0,1,0,
652,2,0,825,117,0,9,8042,0,1,1,0,1,0,1,3,0,0,
670,2,0,825,0,0,13,8045,0,3,0,0,1,0,2,3,0,0,2,3,0,0,2,3,0,0,
696,2,0,825,0,0,15,8056,0,0,0,0,1,0,
710,2,0,857,72,0,3,8096,0,5,5,0,1,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,
744,2,0,858,0,0,29,8097,0,0,0,0,1,0,
758,2,0,859,0,0,29,8099,0,0,0,0,1,0,
772,2,0,860,81,0,2,8120,0,2,2,0,1,0,1,3,0,0,1,3,0,0,
794,2,0,861,143,0,4,8150,0,4,2,0,1,0,2,3,0,0,2,3,0,0,1,3,0,0,1,3,0,0,
824,2,0,862,60,0,3,8185,0,4,4,0,1,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,
854,2,0,863,0,0,29,8186,0,0,0,0,1,0,
868,2,0,864,53,0,2,13,1,1,1,0,1,0,1,3,0,0,
886,2,0,865,53,0,2,45,1,1,1,0,1,0,1,4,0,0,
904,2,0,866,65,0,3,68,1,5,5,0,1,0,1,4,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,
938,2,0,867,0,0,29,70,1,0,0,0,1,0,
952,2,0,868,0,0,29,80,1,0,0,0,1,0,
966,2,0,869,109,0,9,126,1,1,1,0,1,0,1,3,0,0,
984,2,0,869,0,0,13,139,1,4,0,0,1,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,0,
1014,2,0,869,0,0,15,180,1,0,0,0,1,0,
1028,2,0,870,52,0,2,214,1,1,1,0,1,0,1,4,0,0,
1046,2,0,871,52,0,3,226,1,3,3,0,1,0,1,4,0,0,1,3,0,0,1,3,0,0,
1072,2,0,872,0,0,29,234,1,0,0,0,1,0,
1086,2,0,873,0,0,29,236,1,0,0,0,1,0,
1100,2,0,874,87,0,9,279,1,1,1,0,1,0,1,3,0,0,
1118,2,0,874,0,0,13,286,1,2,0,0,1,0,2,3,0,0,2,3,0,0,
1140,2,0,874,0,0,15,293,1,0,0,0,1,0,
1154,2,0,875,0,0,27,318,1,3,3,0,1,0,1,9,0,0,1,9,0,0,1,10,0,0,
1180,2,0,876,0,0,29,319,1,0,0,0,1,0,
1194,2,0,877,0,0,27,342,1,3,3,0,1,0,1,9,0,0,1,9,0,0,1,10,0,0,
1220,2,0,878,0,0,17,351,1,1,1,0,1,0,1,9,0,0,
1238,2,0,878,0,0,21,352,1,0,0,0,1,0,
1252,2,0,879,0,0,29,354,1,0,0,0,1,0,
1266,2,0,880,0,0,31,356,1,0,0,0,1,0,
1280,2,0,881,0,0,27,360,1,3,3,0,1,0,1,9,0,0,1,9,0,0,1,10,0,0,
1306,2,0,882,0,0,29,435,1,0,0,0,1,0,
1320,2,0,883,0,0,32,436,1,0,0,0,1,0,
1334,2,0,884,0,0,32,453,1,0,0,0,1,0,
};


//------------------------------------------------------------------------------
// Projektname:		Programm
// Dateiname:		CDBSchnittstelle.pc
// Beschreibung:	Datenbank Schnittstelle
// Autor(en):		Mike Sarnowski, Tim Schuermann
// Version:		0.9
// Gendert von:	Mike Sarnowski
// Gendert am:		15.5.2001
// Zustand:		Optimierung
//------------------------------------------------------------------------------


#include "CDBSchnittstelle.h"
#include <sqlca.h>
#include <oraca.h>
#include <sqlda.h>
#include <string.h>

//------------------------------------------------------------------------------
// Funktionsname:       CBDSchnittstelle
// Beschreibung:        Konstruktor
// Parameter:		db_username
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
CDBSchnittstelle::CDBSchnittstelle(char* db_username, bool bbetrieb=false){
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in CDBSchnittstelle"); */ 


  cout<<"Ihr Username ist:"<<db_username<<" Warte auf Datenbank..."<<endl;

  /* EXEC ORACLE OPTION (ORACA=YES); */ 

  aufbauenVerbindung(db_username);
  this->speicherstand = holenSpeicherstand(db_username);
  speicherstand=0; // Speicherstand default-maessig auf 0 setzen
  batchbetrieb=bbetrieb;

  try{benutzername=new char[strlen(db_username)+1];}
  catch(...)
  {
	cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: der Benutzername konnte nicht angelegt werden. Speichermangel?"<<endl;
	cerr.flush();
  }
  strcpy(benutzername, db_username);
  Debug(2, "Username lautet:"<<benutzername);

}

//------------------------------------------------------------------------------
// Funktionsname:	~CDBSchnittstelle
// Beschreibung:	Destructor
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
CDBSchnittstelle::~CDBSchnittstelle(){
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in ~CDBSchnittstelle"); */ 


  beendenVerbindung();
}


// Funktionen fuer die GUI: ------------------------------------------------------------------------
//------------------------------------------------------------------------------
// Funktionsname:	holenKnotenID
// Beschreibung:	Mit dieser Methode kann die GUI die ID einer Haltestelle abfragen
// Parameter:		die Koordinaten der Haltestelle
// Rueckgabe:		die Knoten-ID als Integerwert
// Besonderheiten:	
//------------------------------------------------------------------------------
int CDBSchnittstelle::holenKnotenID(double x_eingabe, double y_eingabe)
{
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenKnotenID"); */ 


	int rueckgabe=-1;
        /* EXEC SQL BEGIN DECLARE SECTION; */ 
	
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	typedef struct
	{
		int HaltestellenID;
 		/* VARCHAR Name[30]; */ 
struct { unsigned short len; unsigned char arr[30]; } Name;

 		double XKoordinate;
		double YKoordinate;
		int Prioritaet;
		int Pflicht;
	} wegenetzelement;
	wegenetzelement element;
	double x=x_eingabe;
	double y=y_eingabe;
	int speicherid=speicherstand;
	/* EXEC SQL END DECLARE SECTION; */ 
	

        // erzeuge den Cursor, mit dem Daten durchlaufen werden:
	/* EXEC SQL DECLARE abfrage_cursor CURSOR FOR
		SELECT HaltestellenID, Name, XKoordinate, YKoordinate, Prioritaet, Pflicht
			FROM Knoten
			WHERE SpeicherID = :speicherid AND XKoordinate = :x AND YKoordinate = :y; */ 


	// jetzt den Cursor oeffnen
	/* EXEC SQL OPEN abfrage_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 3;
 sqlstm.stmt = sq0001;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqhstv[1] = (unsigned char  *)&x;
 sqlstm.sqhstl[1] = (unsigned int  )8;
 sqlstm.sqindv[1] = (         short *)0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqhstv[2] = (unsigned char  *)&y;
 sqlstm.sqhstl[2] = (unsigned int  )8;
 sqlstm.sqindv[2] = (         short *)0;
 sqlstm.sqharm[2] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenKnotenID");
}



        // und jetzt in Schleife alle Dinger holen:
	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

	for(;;)
	{
		/* EXEC SQL FETCH abfrage_cursor INTO :element; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 6;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )28;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&element.HaltestellenID;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&element.Name;
  sqlstm.sqhstl[1] = (unsigned int  )32;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&element.XKoordinate;
  sqlstm.sqhstl[2] = (unsigned int  )8;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqhstv[3] = (unsigned char  *)&element.YKoordinate;
  sqlstm.sqhstl[3] = (unsigned int  )8;
  sqlstm.sqindv[3] = (         short *)0;
  sqlstm.sqharm[3] = (unsigned int  )0;
  sqlstm.sqhstv[4] = (unsigned char  *)&element.Prioritaet;
  sqlstm.sqhstl[4] = (unsigned int  )4;
  sqlstm.sqindv[4] = (         short *)0;
  sqlstm.sqharm[4] = (unsigned int  )0;
  sqlstm.sqhstv[5] = (unsigned char  *)&element.Pflicht;
  sqlstm.sqhstl[5] = (unsigned int  )4;
  sqlstm.sqindv[5] = (         short *)0;
  sqlstm.sqharm[5] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenKnotenID");
}


		rueckgabe=element.HaltestellenID;
	}
        /* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	// und nach getaner arbeit Cursor wieder schliessen:
	/* EXEC SQL CLOSE abfrage_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 6;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )66;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenKnotenID");
}



//	Debug(2, "holenKnotenID Input: "<<x_eingabe<<", "<<y_eingabe<<" Rueckgabe: "<<rueckgabe);

	return rueckgabe;	
}
//------------------------------------------------------------------------------
// Funktionsname:	holenKnotenKoordinaten
// Beschreibung:	Mit dieser Methode kann die GUI zu einer ID die Koordinaten einer Haltestelle ermitteln
// Parameter:		die Knoten-ID als Integerwert
// Rueckgabe:		die Koordinaten der Haltestelle als CPunkt, NULL wenn ID nicht existiert
// Besonderheiten:	
//------------------------------------------------------------------------------
CPunkt* CDBSchnittstelle::holenKnotenKoordinaten(int id_eingabe)
{
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenKnotenKoordinaten"); */ 


	CPunkt* rueckgabe=0;
        /* EXEC SQL BEGIN DECLARE SECTION; */ 
	
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	typedef struct
	{
		int HaltestellenID;
 		/* VARCHAR Name[30]; */ 
struct { unsigned short len; unsigned char arr[30]; } Name;

 		double XKoordinate;
		double YKoordinate;
		int Prioritaet;
		int Pflicht;
	} wegenetzelement;
	wegenetzelement element;
	int id=id_eingabe;
	int speicherid=speicherstand;
	/* EXEC SQL END DECLARE SECTION; */ 
	

        // erzeuge den Cursor, mit dem Daten durchlaufen werden:
	/* EXEC SQL DECLARE abfrage_koordinaten_cursor CURSOR FOR
		SELECT HaltestellenID, Name, XKoordinate, YKoordinate, Prioritaet, Pflicht
			FROM Knoten
			WHERE SpeicherID = :speicherid AND HaltestellenID = :id; */ 


	// jetzt den Cursor oeffnen
	/* EXEC SQL OPEN abfrage_koordinaten_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 6;
 sqlstm.stmt = sq0002;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )80;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqhstv[1] = (unsigned char  *)&id;
 sqlstm.sqhstl[1] = (unsigned int  )4;
 sqlstm.sqindv[1] = (         short *)0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenKnotenKoordinaten");
}



        // und jetzt in Schleife alle Dinger holen:
	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

	for(;;)
	{
		/* EXEC SQL FETCH abfrage_koordinaten_cursor INTO :element; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 6;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )102;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&element.HaltestellenID;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&element.Name;
  sqlstm.sqhstl[1] = (unsigned int  )32;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&element.XKoordinate;
  sqlstm.sqhstl[2] = (unsigned int  )8;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqhstv[3] = (unsigned char  *)&element.YKoordinate;
  sqlstm.sqhstl[3] = (unsigned int  )8;
  sqlstm.sqindv[3] = (         short *)0;
  sqlstm.sqharm[3] = (unsigned int  )0;
  sqlstm.sqhstv[4] = (unsigned char  *)&element.Prioritaet;
  sqlstm.sqhstl[4] = (unsigned int  )4;
  sqlstm.sqindv[4] = (         short *)0;
  sqlstm.sqharm[4] = (unsigned int  )0;
  sqlstm.sqhstv[5] = (unsigned char  *)&element.Pflicht;
  sqlstm.sqhstl[5] = (unsigned int  )4;
  sqlstm.sqindv[5] = (         short *)0;
  sqlstm.sqharm[5] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenKnotenKoordinaten");
}


		try{rueckgabe=new CPunkt(element.XKoordinate, element.YKoordinate);}
		catch(...)
		{	
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die KnotenKoordinaten konnte nicht angelegt werden. Speichermangel?"<<endl;
			cerr.flush();
		}
	}
        /* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	// und nach getaner arbeit Cursor wieder schliessen:
	/* EXEC SQL CLOSE abfrage_koordinaten_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 6;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )140;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenKnotenKoordinaten");
}



	return rueckgabe;	
}
//------------------------------------------------------------------------------
// Funktionsname:	holenLinienID
// Beschreibung:	Mit dieser Methode kann die GUI die IDs der Linien abfragen, die ueber diese Haltestelle laufen
// Parameter:		die ID der Haltestelle
// Rueckgabe:		eine Liste mit den IDs der Linien, ueber die der Knoten geht
// Besonderheiten:	Liefert eine leere Liste, wenn die Haltestelle nicht vorhanden ist
//------------------------------------------------------------------------------
list<int>* CDBSchnittstelle::holenLinienID(int hs_input)
{
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenLinienID"); */ 


	// Rueckgabeliste anlegen:
	list<int>* buslinien=0;
	try{buslinien=new list<int>;}
	catch(...)
  	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Liste der Buslinien-IDs konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}
        /* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
	
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	typedef struct	// eine Buslinie -> LinienWeg
	{
		int LinienID;
		int LfdNr;
		int HaltestellenID;
	} buslinienelement;
	buslinienelement element;
	int speicherid=speicherstand;
	int h=hs_input;
	/* EXEC SQL END DECLARE SECTION; */ 
	
	
	// erzeuge die Cursor, mit dem Daten durchlaufen werden:
	/* EXEC SQL DECLARE a_cursor CURSOR FOR
		SELECT LinienID, LfdNr, HaltestellenID
			FROM LinienWeg
			WHERE SpeicherID = :speicherid AND HaltestellenID = :h; */ 

        
	// jetzt den Cursor oeffnen
	/* EXEC SQL OPEN a_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 6;
 sqlstm.stmt = sq0003;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )154;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqhstv[1] = (unsigned char  *)&h;
 sqlstm.sqhstl[1] = (unsigned int  )4;
 sqlstm.sqindv[1] = (         short *)0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenLinienID");
}



        // und jetzt in Schleife alle Dinger holen:
	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

	for(;;)
	{
		/* EXEC SQL FETCH a_cursor INTO :element; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 6;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )176;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&element.LinienID;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&element.LfdNr;
  sqlstm.sqhstl[1] = (unsigned int  )4;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&element.HaltestellenID;
  sqlstm.sqhstl[2] = (unsigned int  )4;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenLinienID");
}


		buslinien->append(element.LinienID);
	}
        /* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	// und nach getaner arbeit Cursor wieder schliessen:
	/* EXEC SQL CLOSE a_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 6;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )202;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenLinienID");
}



	return buslinien;
}
//------------------------------------------------------------------------------
// Funktionsname:	holenMoeglicheZielHaltestellen
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
list<int>* CDBSchnittstelle::holenMoeglicheZielHaltestellen(int input_id)
{
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenMoeglicheZielHaltestellen"); */ 

      
	// Rueckgabeliste anlegen:
	list<int>* knotenliste=0;
	try{knotenliste=new list<int>;}
	catch(...)
  	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: der Die Liste mit den moeglichen Zielhaltestellen konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
  	}
        /* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
	
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	typedef struct	// eine Buslinie -> LinienWeg
	{
		int KantenID;
		int StartHaltestelle;
		int EndHaltestelle;
	} knotenelement;
	knotenelement element;
	int speicherid=speicherstand;
	int id=input_id;
	/* EXEC SQL END DECLARE SECTION; */ 
	
	
	// erzeuge die Cursor, mit dem Daten durchlaufen werden:
	/* EXEC SQL DECLARE zielhs_cursor CURSOR FOR
		SELECT KantenID, StartHaltestelle, EndHaltestelle
			FROM Kanten
			WHERE SpeicherID = :speicherid AND (StartHaltestelle = :id OR EndHaltestelle= :id); */ 

        
	// jetzt den Cursor oeffnen
	/* EXEC SQL OPEN zielhs_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 6;
 sqlstm.stmt = sq0004;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )216;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqhstv[1] = (unsigned char  *)&id;
 sqlstm.sqhstl[1] = (unsigned int  )4;
 sqlstm.sqindv[1] = (         short *)0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqhstv[2] = (unsigned char  *)&id;
 sqlstm.sqhstl[2] = (unsigned int  )4;
 sqlstm.sqindv[2] = (         short *)0;
 sqlstm.sqharm[2] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenMoeglicheZielHaltestellen");
}



        // und jetzt in Schleife alle Dinger holen:
	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

	for(;;)
	{
//		Debug(2, "Durchlauf");
		/* EXEC SQL FETCH zielhs_cursor INTO :element; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 6;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )242;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&element.KantenID;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&element.StartHaltestelle;
  sqlstm.sqhstl[1] = (unsigned int  )4;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&element.EndHaltestelle;
  sqlstm.sqhstl[2] = (unsigned int  )4;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenMoeglicheZielHaltestellen");
}


		if(element.StartHaltestelle==id) 
		{
			knotenliste->append(element.EndHaltestelle);	
//			Debug(2, "holenMoeglicheZielHaltestellen: fuege ID "<<element.NachHaltestelle<<" ein");
		}
		else if(element.EndHaltestelle==id) 
		{
			knotenliste->append(element.StartHaltestelle);	
//			Debug(2, "holenMoeglicheZielHaltestellen: fuege ID "<<element.VonHaltestelle<<" ein");
		}
	}
        /* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	// und nach getaner arbeit Cursor wieder schliessen:
	/* EXEC SQL CLOSE zielhs_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 6;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )268;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenMoeglicheZielHaltestellen");
}


        
	// Vor der Rueckgabe noch doppelte Eintraege eliminieren:
	knotenliste->sort();
	knotenliste->unique();
//	Debug(2, "Ende holenMoeglicheZielHaltestellen");


	return knotenliste;	
}
//------------------------------------------------------------------------------
// Funktionsname:	holenZusammenhangsKomponentenID
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
int CDBSchnittstelle::holenZusammenhangsKomponentenID(int hst_eingabe,int Linie1_eingabe) 
{
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenZusammenhangsKomponentenID"); */ 


	int rueckgabe=-1; // der Rueckgabewert
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	
	
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	typedef struct	// eine Buslinie -> LinienWeg
	{
		int KomponentenID;
//		int LfdNummer;
		int HaltestellenIDVon;
		int HaltestellenIDNach;
		int LinienID;
	} komponentenelement;
	komponentenelement element;
	int speicherid=speicherstand;
	int hs=hst_eingabe;
	int Linie1=Linie1_eingabe;
	/* EXEC SQL END DECLARE SECTION; */ 
	
	
	// erzeuge die Cursor, mit dem Daten durchlaufen werden:
	/* EXEC SQL DECLARE komponenten_linie_cursor CURSOR FOR
		SELECT KomponentenID, HaltestellenIDVon, HaltestellenIDNach, LinienID
			FROM Zusammenhangskomponente
			WHERE SpeicherID = :speicherid AND (HaltestellenIDVon = :hs OR HaltestellenIDNach = :hs) AND LinienID = :Linie1; */ 

	
	// jetzt den Cursor oeffnen
	/* EXEC SQL OPEN komponenten_linie_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 6;
 sqlstm.stmt = sq0005;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )282;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqhstv[1] = (unsigned char  *)&hs;
 sqlstm.sqhstl[1] = (unsigned int  )4;
 sqlstm.sqindv[1] = (         short *)0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqhstv[2] = (unsigned char  *)&hs;
 sqlstm.sqhstl[2] = (unsigned int  )4;
 sqlstm.sqindv[2] = (         short *)0;
 sqlstm.sqharm[2] = (unsigned int  )0;
 sqlstm.sqhstv[3] = (unsigned char  *)&Linie1;
 sqlstm.sqhstl[3] = (unsigned int  )4;
 sqlstm.sqindv[3] = (         short *)0;
 sqlstm.sqharm[3] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenZusammenhangsKomponentenID");
}



        // und jetzt in Schleife alle Dinger holen:
	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

	for(;;)
	{
		/* EXEC SQL FETCH komponenten_linie_cursor INTO :element; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 6;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )312;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&element.KomponentenID;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&element.HaltestellenIDVon;
  sqlstm.sqhstl[1] = (unsigned int  )4;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&element.HaltestellenIDNach;
  sqlstm.sqhstl[2] = (unsigned int  )4;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqhstv[3] = (unsigned char  *)&element.LinienID;
  sqlstm.sqhstl[3] = (unsigned int  )4;
  sqlstm.sqindv[3] = (         short *)0;
  sqlstm.sqharm[3] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenZusammenhangsKomponentenID");
}


		rueckgabe=element.KomponentenID;
	}
        /* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	// und nach getaner arbeit Cursor wieder schliessen:
	/* EXEC SQL CLOSE komponenten_linie_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 6;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )342;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenZusammenhangsKomponentenID");
}



	Debug(2, "holenZusammenhangskomponentenID: "<<rueckgabe);
	
	return rueckgabe;
}
//------------------------------------------------------------------------------
// Funktionsname:	holenEingehendeLinien
// Beschreibung:	Mit dieser Methode kann die GUI die IDs der Linien abfragen, die in diese Haltestelle hinein laufen
// Parameter:		die ID der Haltestelle
// Rueckgabe:		eine Liste mit den IDs der Linien, die in den Knoten gehen
// Besonderheiten:	Liefert eine leere Liste, wenn die Haltestelle nicht vorhanden ist oder keine Kanten in sie hineinlaufen
//------------------------------------------------------------------------------
list<int>* CDBSchnittstelle::holenEingehendeLinien(int hs_input) // holt alle eingehenden Linien in eine Haltestelle (als ID uebergeben)
{
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenEingehendeLinien"); */ 


	// Rueckgabeliste anlegen:
	list<int>* buslinien=0;
	try{buslinien=new list<int>;}
	catch(...)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Liste der eingehenden Linien konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}
        /* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
	
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	typedef struct	// eine Buslinie -> LinienWeg
	{
		int LfdNr; 
 		int PlanID;
 		int LinienID;
 		int VonHaltestelle;
 		int NachHaltestelle; 
 		int Reisezeit;
 		int Verkehrsstrom;	
	} buslinienelement;
	buslinienelement element;
	int speicherid=speicherstand;
	int h=hs_input;
	/* EXEC SQL END DECLARE SECTION; */ 
	
	
	// erzeuge die Cursor, mit dem Daten durchlaufen werden:
	/* EXEC SQL DECLARE eingehende_linien_cursor CURSOR FOR
		SELECT LfdNr, PlanID, LinienID, VonHaltestelle, NachHaltestelle, Reisezeit, Verkehrsstrom
			FROM LinienWerte
			WHERE SpeicherID = :speicherid AND NachHaltestelle = :h; */ 

        
	// jetzt den Cursor oeffnen
	/* EXEC SQL OPEN eingehende_linien_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 6;
 sqlstm.stmt = sq0006;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )356;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqhstv[1] = (unsigned char  *)&h;
 sqlstm.sqhstl[1] = (unsigned int  )4;
 sqlstm.sqindv[1] = (         short *)0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenEingehendeLinien");
}



        // und jetzt in Schleife alle Dinger holen:
	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

	for(;;)
	{
		/* EXEC SQL FETCH eingehende_linien_cursor INTO :element; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )378;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&element.LfdNr;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&element.PlanID;
  sqlstm.sqhstl[1] = (unsigned int  )4;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&element.LinienID;
  sqlstm.sqhstl[2] = (unsigned int  )4;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqhstv[3] = (unsigned char  *)&element.VonHaltestelle;
  sqlstm.sqhstl[3] = (unsigned int  )4;
  sqlstm.sqindv[3] = (         short *)0;
  sqlstm.sqharm[3] = (unsigned int  )0;
  sqlstm.sqhstv[4] = (unsigned char  *)&element.NachHaltestelle;
  sqlstm.sqhstl[4] = (unsigned int  )4;
  sqlstm.sqindv[4] = (         short *)0;
  sqlstm.sqharm[4] = (unsigned int  )0;
  sqlstm.sqhstv[5] = (unsigned char  *)&element.Reisezeit;
  sqlstm.sqhstl[5] = (unsigned int  )4;
  sqlstm.sqindv[5] = (         short *)0;
  sqlstm.sqharm[5] = (unsigned int  )0;
  sqlstm.sqhstv[6] = (unsigned char  *)&element.Verkehrsstrom;
  sqlstm.sqhstl[6] = (unsigned int  )4;
  sqlstm.sqindv[6] = (         short *)0;
  sqlstm.sqharm[6] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenEingehendeLinien");
}


		buslinien->append(element.LinienID);
	}
        /* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	// und nach getaner arbeit Cursor wieder schliessen:
	/* EXEC SQL CLOSE eingehende_linien_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )420;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenEingehendeLinien");
}



	return buslinien;
}
//------------------------------------------------------------------------------
// Funktionsname:	holenAusgehendeLinien
// Beschreibung:	Mit dieser Methode kann die GUI die IDs der Linien abfragen, die in diese Haltestelle hinaus laufen
// Parameter:		die ID der Haltestelle
// Rueckgabe:		eine Liste mit den IDs der Linien, aus dem Knoten gehen
// Besonderheiten:	Liefert eine leere Liste, wenn die Haltestelle nicht vorhanden ist oder keine Kanten aus ihr hinauslaufen
//------------------------------------------------------------------------------
list<int>* CDBSchnittstelle::holenAusgehendeLinien(int hs_input)	// hole alle ausgehenden Linien aus einer Haltestelle (als ID uebergeben)
{
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenAusgehendeLinien"); */ 


	// Rueckgabeliste anlegen:
	list<int>* buslinien=0;
	try{buslinien=new list<int>;}
	catch(...)
	{	
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Liste der ausgehenden Linien konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}
        /* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
	
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	typedef struct	// eine Buslinie -> LinienWeg
	{
		int LfdNr; 
 		int PlanID;
 		int LinienID;
 		int VonHaltestelle;
 		int NachHaltestelle; 
 		int Reisezeit;
 		int Verkehrsstrom;	
	} buslinienelement;
	buslinienelement element;
	int speicherid=speicherstand;
	int h=hs_input;
	/* EXEC SQL END DECLARE SECTION; */ 
	
	
	// erzeuge die Cursor, mit dem Daten durchlaufen werden:
	/* EXEC SQL DECLARE ausgehende_linien_cursor CURSOR FOR
		SELECT LfdNr, PlanID, LinienID, VonHaltestelle, NachHaltestelle, Reisezeit, Verkehrsstrom
			FROM LinienWerte
			WHERE SpeicherID = :speicherid AND VonHaltestelle = :h; */ 

        
	// jetzt den Cursor oeffnen
	/* EXEC SQL OPEN ausgehende_linien_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = sq0007;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )434;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqhstv[1] = (unsigned char  *)&h;
 sqlstm.sqhstl[1] = (unsigned int  )4;
 sqlstm.sqindv[1] = (         short *)0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenAusgehendeLinien");
}



        // und jetzt in Schleife alle Dinger holen:
	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

	for(;;)
	{
		/* EXEC SQL FETCH ausgehende_linien_cursor INTO :element; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )456;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&element.LfdNr;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&element.PlanID;
  sqlstm.sqhstl[1] = (unsigned int  )4;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&element.LinienID;
  sqlstm.sqhstl[2] = (unsigned int  )4;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqhstv[3] = (unsigned char  *)&element.VonHaltestelle;
  sqlstm.sqhstl[3] = (unsigned int  )4;
  sqlstm.sqindv[3] = (         short *)0;
  sqlstm.sqharm[3] = (unsigned int  )0;
  sqlstm.sqhstv[4] = (unsigned char  *)&element.NachHaltestelle;
  sqlstm.sqhstl[4] = (unsigned int  )4;
  sqlstm.sqindv[4] = (         short *)0;
  sqlstm.sqharm[4] = (unsigned int  )0;
  sqlstm.sqhstv[5] = (unsigned char  *)&element.Reisezeit;
  sqlstm.sqhstl[5] = (unsigned int  )4;
  sqlstm.sqindv[5] = (         short *)0;
  sqlstm.sqharm[5] = (unsigned int  )0;
  sqlstm.sqhstv[6] = (unsigned char  *)&element.Verkehrsstrom;
  sqlstm.sqhstl[6] = (unsigned int  )4;
  sqlstm.sqindv[6] = (         short *)0;
  sqlstm.sqharm[6] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenAusgehendeLinien");
}


		buslinien->append(element.LinienID);
		element.LinienID=0;
	}
        /* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	// und nach getaner arbeit Cursor wieder schliessen:
	/* EXEC SQL CLOSE ausgehende_linien_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )498;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenAusgehendeLinien");
}


	
	int einwert=-1;
/*	cout<<"holenAusgehendeLinien: gebe Liste aus:"<<endl;
	forall(einwert, *buslinien)
	{
		cout<<"Wert: "<<einwert<<endl;
	}
*/
	return buslinien;
}
//------------------------------------------------------------------------------
// Funktionsname:	holenLinienHaltestellen
// Beschreibung:	holt alle Haltestellen, ueber die die Linie mit der linienid fuehrt
// Parameter:		die ID der Linie
// Rueckgabe:		eine Liste mit den IDs der Haltestellen, die ueber diese Linien fuehren
// Besonderheiten:	
//------------------------------------------------------------------------------
list<int>* CDBSchnittstelle::holenLinienHaltestellen(int linienid) // holt alle Haltestellen, ueber die die Linie mit der linienid fuehrt
{
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenLinienHaltestellen"); */ 


	// Rueckgabeliste anlegen:
	list<int>* buslinien=0;
	try{buslinien=new list<int>;}
	catch(...)
	{	
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Liste der Haltestellen, die ueber eine Linie fuehren konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}
        /* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
	
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	typedef struct	// eine Buslinie -> LinienWeg
	{
 		int PlanID;
 		int LinienID;
 		int LfdNr;
 		int HaltestellenID; 
	} buslinienelement;
	buslinienelement element;
	int speicherid=speicherstand;
	int ld=linienid;
	/* EXEC SQL END DECLARE SECTION; */ 
	
	
	// erzeuge die Cursor, mit dem Daten durchlaufen werden:
	/* EXEC SQL DECLARE linien_haltestellen_cursor CURSOR FOR
		SELECT PlanID, LinienID, LfdNr, HaltestellenID
			FROM LinienWeg
			WHERE SpeicherID = :speicherid AND LinienID = :ld; */ 

        
	// jetzt den Cursor oeffnen
	/* EXEC SQL OPEN linien_haltestellen_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = sq0008;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )512;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqhstv[1] = (unsigned char  *)&ld;
 sqlstm.sqhstl[1] = (unsigned int  )4;
 sqlstm.sqindv[1] = (         short *)0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenLinienHaltestellen");
}



        // und jetzt in Schleife alle Dinger holen:
	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

	for(;;)
	{
		/* EXEC SQL FETCH linien_haltestellen_cursor INTO :element; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )534;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&element.PlanID;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&element.LinienID;
  sqlstm.sqhstl[1] = (unsigned int  )4;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&element.LfdNr;
  sqlstm.sqhstl[2] = (unsigned int  )4;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqhstv[3] = (unsigned char  *)&element.HaltestellenID;
  sqlstm.sqhstl[3] = (unsigned int  )4;
  sqlstm.sqindv[3] = (         short *)0;
  sqlstm.sqharm[3] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenLinienHaltestellen");
}


		buslinien->append(element.HaltestellenID);
	}
        /* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	// und nach getaner arbeit Cursor wieder schliessen:
	/* EXEC SQL CLOSE linien_haltestellen_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )564;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenLinienHaltestellen");
}



	return buslinien;
}





// Versionierungsfunktionen: ------------------------------------------------------------------------------
//------------------------------------------------------------------------------
// Funktionsname:	setzenAktuelleProjektID
// Beschreibung:	hiermit wird ein Projekt ausgewaehlt
// Parameter:		die ID des Projektes
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::setzenAktuelleProjektID(int id=0) 
{
	// Relativ simpel: es reicht aus, die Variable speicherstand auf die neue ID zu setzen
	speicherstand=id;
}
//------------------------------------------------------------------------------
// Funktionsname:	holenAktuelleProjektID
// Beschreibung:	gibt die ID des aktuellen Projektes zurueck
// Parameter:		
// Rueckgabe:		die ID des Projektes
// Besonderheiten:	
//------------------------------------------------------------------------------
int CDBSchnittstelle::holenAktuelleProjektID() 
{
	// auch dies ist relativ simple: es reicht aus, den Inhalt von speicherstand rauszugeben:
	return speicherstand;
}
//------------------------------------------------------------------------------
// Funktionsname:	anlegenNeuesProjekt
// Beschreibung:	legt ein neues Projekt an
// Parameter:		die ID des Projektes, eine Beschreibung und die Phase, in der gestartet werden soll
// Rueckgabe:		die ID, die tatsaechlich gespeichert wurde
// Besonderheiten:	
//------------------------------------------------------------------------------
int CDBSchnittstelle::anlegenNeuesProjekt(int id, char* beschreibung=NULL, int phase=0) 
{
	// fuegt einfach in die Tabelle Speicherstand einen neuen Eintrag ein.
	// sollte ID schon vergeben sein, waehle einfach eine neue, noch nicht vergebene
	if(beschreibung==0) { Debug(2, "anlegenNeuesProjekt: Die Beschreibung des Projektes ist NULL"); }
	else { Debug(2, "anlegenNeuesProjekt: Die Beschreibung des Projektes lautet: |"<<beschreibung<<"|"); }

	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in anlegenNeuesProjekt"); */ 

    
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	typedef struct	
	{
 		int id;
		/* VARCHAR Bezeichnung[30]; */ 
struct { unsigned short len; unsigned char arr[30]; } Bezeichnung;

		int Zustand;
	} projektelement;
	projektelement element;
	int testid=id;
	/* EXEC SQL END DECLARE SECTION; */ 
	

	// Testen ,ob ID schon vergeben:	
	// sollte ID bereits vergeben sein, nimm die naechste ID und teste wieder, usw...
	do{
		element.id=-1;
		// erzeuge die Cursor, mit dem Daten durchlaufen werden:
		/* EXEC SQL DECLARE projekt_test_id_cursor CURSOR FOR
			SELECT id, Bezeichnung, Zustand
				FROM Speicherstand
				WHERE id = :testid; */ 

        
	
		// jetzt den Cursor oeffnen
		/* EXEC SQL OPEN projekt_test_id_cursor; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = sq0009;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )578;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&testid;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in anlegenNeuesProjekt");
}


        	
	        // und jetzt in Schleife alle Dinger holen:
		/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

		for(;;)
		{
			/* EXEC SQL FETCH projekt_test_id_cursor INTO :element; */ 

{
   struct sqlexd sqlstm;

   sqlorat((void **)0, &sqlctx, &oraca);
   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 7;
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )596;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlstm.sqhstv[0] = (unsigned char  *)&element.id;
   sqlstm.sqhstl[0] = (unsigned int  )4;
   sqlstm.sqindv[0] = (         short *)0;
   sqlstm.sqharm[0] = (unsigned int  )0;
   sqlstm.sqhstv[1] = (unsigned char  *)&element.Bezeichnung;
   sqlstm.sqhstl[1] = (unsigned int  )32;
   sqlstm.sqindv[1] = (         short *)0;
   sqlstm.sqharm[1] = (unsigned int  )0;
   sqlstm.sqhstv[2] = (unsigned char  *)&element.Zustand;
   sqlstm.sqhstl[2] = (unsigned int  )4;
   sqlstm.sqindv[2] = (         short *)0;
   sqlstm.sqharm[2] = (unsigned int  )0;
   sqlstm.sqphsv = sqlstm.sqhstv;
   sqlstm.sqphsl = sqlstm.sqhstl;
   sqlstm.sqpind = sqlstm.sqindv;
   sqlstm.sqparm = sqlstm.sqharm;
   sqlstm.sqparc = sqlstm.sqharc;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
   if (sqlca.sqlcode == 1403) break;
   if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in anlegenNeuesProjekt");
}


			testid++; // hier testid um eins erhoehen => nimm naechste moegliche ID
		}
        	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

		// und nach getaner arbeit Cursor wieder schliessen:
		/* EXEC SQL CLOSE projekt_test_id_cursor; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )622;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in anlegenNeuesProjekt");
}


		
	}while(element.id!=-1);
	// hier steht jetzt in testid, genau die id, die unser neues Projekt erhalten darf.

	
	// alle Daten in die Struktur uebertragen:
	element.id=testid;
	element.Zustand=phase;
	if(beschreibung!=0) element.Bezeichnung.len = strlen(strcpy((char *)element.Bezeichnung.arr, beschreibung));
	else element.Bezeichnung.len = strlen(strcpy((char *)element.Bezeichnung.arr, "unbenannt"));

	/* EXEC SQL INSERT INTO Speicherstand
		VALUES (:element); */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "insert into Speicherstand values (:s1 ,:s2 ,:s3 )";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )636;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&element.id;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqhstv[1] = (unsigned char  *)&element.Bezeichnung;
 sqlstm.sqhstl[1] = (unsigned int  )32;
 sqlstm.sqindv[1] = (         short *)0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqhstv[2] = (unsigned char  *)&element.Zustand;
 sqlstm.sqhstl[2] = (unsigned int  )4;
 sqlstm.sqindv[2] = (         short *)0;
 sqlstm.sqharm[2] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in anlegenNeuesProjekt");
}


	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )662;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in anlegenNeuesProjekt");
}



	// zum schluss noch das neue Projekt als aktuelles setzten
	setzenAktuelleProjektID(element.id);

	// und die gespeicherte ID zurueckgeben
	return element.id;
}
//------------------------------------------------------------------------------
// Funktionsname:	anlegenNeuesProjektPG369
// Beschreibung:	legt ein neues Projekt beim Datenaustausch-User an
// Parameter:		die ID des Projektes, eine Beschreibung und die Phase, in der gestartet werden soll
// Rueckgabe:		die ID, die tatsaechlich gespeichert wurde
// Besonderheiten:	
//------------------------------------------------------------------------------
int CDBSchnittstelle::anlegenNeuesProjektPG369(int id, char* beschreibung=NULL, int phase=0) 
{
	// fuegt einfach in die Tabelle Speicherstand einen neuen Eintrag ein.
	// sollte ID schon vergeben sein, waehle einfach eine neue, noch nicht vergebene
	if(beschreibung==0) { Debug(2, "anlegenNeuesProjektPG369: Die Beschreibung des Projektes ist NULL"); }
	else { Debug(2, "anlegenNeuesProjektPG369: Die Beschreibung des Projektes lautet: |"<<beschreibung<<"|"); }

	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in anlegenNeuesProjektPG369"); */ 

    
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	typedef struct	
	{
 		int id;
		/* VARCHAR Bezeichnung[30]; */ 
struct { unsigned short len; unsigned char arr[30]; } Bezeichnung;

		int Zustand;
	} projektelement;
	projektelement element;
	int testid=id;
	/* EXEC SQL END DECLARE SECTION; */ 
	

	// Testen ,ob ID schon vergeben:	
	// sollte ID bereits vergeben sein, nimm die naechste ID und teste wieder, usw...
	do{
		element.id=-1;
		// erzeuge die Cursor, mit dem Daten durchlaufen werden:
		/* EXEC SQL DECLARE projekt_test_id_cursor_pg369 CURSOR FOR
			SELECT id, Bezeichnung, Zustand
				FROM pg369.Speicherstand
				WHERE id = :testid; */ 

        
	
		// jetzt den Cursor oeffnen
		/* EXEC SQL OPEN projekt_test_id_cursor_pg369; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = sq0012;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )676;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&testid;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in anlegenNeuesProjektPG369");
}


        	
	        // und jetzt in Schleife alle Dinger holen:
		/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

		for(;;)
		{
			/* EXEC SQL FETCH projekt_test_id_cursor_pg369 INTO :element; */ 

{
   struct sqlexd sqlstm;

   sqlorat((void **)0, &sqlctx, &oraca);
   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 7;
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )694;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlstm.sqhstv[0] = (unsigned char  *)&element.id;
   sqlstm.sqhstl[0] = (unsigned int  )4;
   sqlstm.sqindv[0] = (         short *)0;
   sqlstm.sqharm[0] = (unsigned int  )0;
   sqlstm.sqhstv[1] = (unsigned char  *)&element.Bezeichnung;
   sqlstm.sqhstl[1] = (unsigned int  )32;
   sqlstm.sqindv[1] = (         short *)0;
   sqlstm.sqharm[1] = (unsigned int  )0;
   sqlstm.sqhstv[2] = (unsigned char  *)&element.Zustand;
   sqlstm.sqhstl[2] = (unsigned int  )4;
   sqlstm.sqindv[2] = (         short *)0;
   sqlstm.sqharm[2] = (unsigned int  )0;
   sqlstm.sqphsv = sqlstm.sqhstv;
   sqlstm.sqphsl = sqlstm.sqhstl;
   sqlstm.sqpind = sqlstm.sqindv;
   sqlstm.sqparm = sqlstm.sqharm;
   sqlstm.sqparc = sqlstm.sqharc;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
   if (sqlca.sqlcode == 1403) break;
   if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in anlegenNeuesProjektPG369");
}


			testid++; // hier testid um eins erhoehen => nimm naechste moegliche ID
		}
        	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

		// und nach getaner arbeit Cursor wieder schliessen:
		/* EXEC SQL CLOSE projekt_test_id_cursor_pg369; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )720;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in anlegenNeuesProjektPG369");
}


		
	}while(element.id!=-1);
	// hier steht jetzt in testid, genau die id, die unser neues Projekt erhalten darf.

	
	// alle Daten in die Struktur uebertragen:
	element.id=testid;
	element.Zustand=phase;
	if(beschreibung!=0) element.Bezeichnung.len = strlen(strcpy((char *)element.Bezeichnung.arr, beschreibung));
	else element.Bezeichnung.len = strlen(strcpy((char *)element.Bezeichnung.arr, "unbenannt"));

	/* EXEC SQL INSERT INTO pg369.Speicherstand
		VALUES (:element); */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "insert into pg369.Speicherstand values (:s1 ,:s2 ,:s3 )";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )734;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&element.id;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqhstv[1] = (unsigned char  *)&element.Bezeichnung;
 sqlstm.sqhstl[1] = (unsigned int  )32;
 sqlstm.sqindv[1] = (         short *)0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqhstv[2] = (unsigned char  *)&element.Zustand;
 sqlstm.sqhstl[2] = (unsigned int  )4;
 sqlstm.sqindv[2] = (         short *)0;
 sqlstm.sqharm[2] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in anlegenNeuesProjektPG369");
}


	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )760;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in anlegenNeuesProjektPG369");
}



	// zum schluss noch das neue Projekt als aktuelles setzten
	//setzenAktuelleProjektID(element.id);

	// und die gespeicherte ID zurueckgeben
	return element.id;
}
//------------------------------------------------------------------------------
// Funktionsname:	holenProjektInformationen
// Beschreibung:	holt die Informationen des Projektes mit der ID "id"
// Parameter:		die ID des Projektes, eine Beschreibung und die Phase, in der gestartet werden soll
// Rueckgabe:		die ID, die tatsaechlich gespeichert wurde
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::holenProjektInformationen(int id, char*& beschreibung, int& phase) 
{                        
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenProjektInformationen"); */ 

    
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	typedef struct	
	{
 		int id;
		/* VARCHAR Bezeichnung[30]; */ 
struct { unsigned short len; unsigned char arr[30]; } Bezeichnung;

		int Zustand;
	} projektelement;
	projektelement element;
	int testid=id;
	/* EXEC SQL END DECLARE SECTION; */ 
	

	/* EXEC SQL SELECT id, Bezeichnung, Zustand
		INTO :element
		FROM Speicherstand
		WHERE id = :testid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "select id ,Bezeichnung ,Zustand into :s1 ,:s2 ,:s3   from Sp\
eicherstand where id=:b1";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )774;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&element.id;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqhstv[1] = (unsigned char  *)&element.Bezeichnung;
 sqlstm.sqhstl[1] = (unsigned int  )32;
 sqlstm.sqindv[1] = (         short *)0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqhstv[2] = (unsigned char  *)&element.Zustand;
 sqlstm.sqhstl[2] = (unsigned int  )4;
 sqlstm.sqindv[2] = (         short *)0;
 sqlstm.sqharm[2] = (unsigned int  )0;
 sqlstm.sqhstv[3] = (unsigned char  *)&testid;
 sqlstm.sqhstl[3] = (unsigned int  )4;
 sqlstm.sqindv[3] = (         short *)0;
 sqlstm.sqharm[3] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenProjektInformationen");
}



	// und jetzt rueberkopieren:
	try{beschreibung=new char[30];}
	catch(...)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Beschreibung eines Projektes konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}
	strcpy(beschreibung, (char*)element.Bezeichnung.arr);
	phase=element.Zustand;

}
//------------------------------------------------------------------------------
// Funktionsname:	holenProjektInformationenPG369
// Beschreibung:	holt die Informationen des Projektes mit der ID "id" des Datenaustausch-Users
// Parameter:		die ID des Projektes, eine Beschreibung und die Phase, in der gestartet werden soll
// Rueckgabe:		die ID, die tatsaechlich gespeichert wurde
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::holenProjektInformationenPG369(int id, char*& beschreibung, int& phase) 
{                        
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenProjektInformationen PG369"); */ 

    
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	typedef struct	
	{
 		int id;
		/* VARCHAR Bezeichnung[30]; */ 
struct { unsigned short len; unsigned char arr[30]; } Bezeichnung;

		int Zustand;
	} projektelement;
	projektelement element;
	int testid=id;
	/* EXEC SQL END DECLARE SECTION; */ 
	

	/* EXEC SQL SELECT id, Bezeichnung, Zustand
		INTO :element
		FROM pg369.Speicherstand
		WHERE id = :testid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "select id ,Bezeichnung ,Zustand into :s1 ,:s2 ,:s3   from pg\
369.Speicherstand where id=:b1";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )804;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&element.id;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqhstv[1] = (unsigned char  *)&element.Bezeichnung;
 sqlstm.sqhstl[1] = (unsigned int  )32;
 sqlstm.sqindv[1] = (         short *)0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqhstv[2] = (unsigned char  *)&element.Zustand;
 sqlstm.sqhstl[2] = (unsigned int  )4;
 sqlstm.sqindv[2] = (         short *)0;
 sqlstm.sqharm[2] = (unsigned int  )0;
 sqlstm.sqhstv[3] = (unsigned char  *)&testid;
 sqlstm.sqhstl[3] = (unsigned int  )4;
 sqlstm.sqindv[3] = (         short *)0;
 sqlstm.sqharm[3] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenProjektInformationen PG369");
}



	// und jetzt rueberkopieren:
	try{beschreibung=new char[30];}
	catch(...)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Beschreibung eines Projektes im Austauschpool konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}
	strcpy(beschreibung, (char*)element.Bezeichnung.arr);
	phase=element.Zustand;

}
//------------------------------------------------------------------------------
// Funktionsname:	holenAlleProjektInformationen
// Beschreibung:	liefert die Informationen aller Projekte zurueck (gibt die ganze Projekttabelle aus)
// Parameter:		
// Rueckgabe:		eine liste mit Dreitupeln, die jeweils die drei Informationen der Tabelle aufnehmen
// Besonderheiten:	
//------------------------------------------------------------------------------
list<two_tuple<int,char*>*>* CDBSchnittstelle::holenAlleProjektInformationen()
{
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenAlleProjektInformationen"); */ 

    
	// erstmal sicherstellen, dass auch eine Rueckgabe existiert:
	list<two_tuple<int,char*>*>* rueckgabe=0;
	try{rueckgabe=new list<two_tuple<int,char*>*>;}
	catch(...)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Liste mit allen Projektinformationen konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}

	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	typedef struct	
	{
 		int id;
		/* VARCHAR Bezeichnung[30]; */ 
struct { unsigned short len; unsigned char arr[30]; } Bezeichnung;

//		int Zustand;
	} projektelement;
	projektelement element;
	/* EXEC SQL END DECLARE SECTION; */ 
	

	// alle Elmente durchlaufen:
	element.id=-1;
	// erzeuge die Cursor, mit dem Daten durchlaufen werden:
	/* EXEC SQL DECLARE projekt_holenalle_cursor CURSOR FOR
		SELECT id, Bezeichnung
		FROM Speicherstand; */ 

        
	// jetzt den Cursor oeffnen
	/* EXEC SQL OPEN projekt_holenalle_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = sq0017;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )834;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenAlleProjektInformationen");
}


        	
        // und jetzt in Schleife alle Dinger holen:
	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

	for(;;)
	{
		/* EXEC SQL FETCH projekt_holenalle_cursor INTO :element; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )848;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&element.id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&element.Bezeichnung;
  sqlstm.sqhstl[1] = (unsigned int  )32;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenAlleProjektInformationen");
}


		two_tuple<int,char*>* temptupel=0;
		try{temptupel=new two_tuple<int,char*>;}
		catch(...)
		{
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: ein Elemente der Liste aller Projekte konnte nicht angelegt werden. Speichermangel?"<<endl;
			cerr.flush();
		}
		temptupel->first() = element.id;
                
		char* tempchar=0;
		try{tempchar=new char[element.Bezeichnung.len+1];}
		catch(...)
		{
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Beschriebung eines Projektes in der Liste aller Projektinformationen konnte nicht angelegt werden. Speichermangel?"<<endl;
			cerr.flush();
		}
		tempchar[element.Bezeichnung.len]='\0';
		strncpy(tempchar, (char*)element.Bezeichnung.arr, element.Bezeichnung.len);
		
		temptupel->second() = tempchar;
//		temptupel->third() = element.Zustand;
		rueckgabe->append(temptupel);
	}
       	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	// und nach getaner arbeit Cursor wieder schliessen:
	/* EXEC SQL CLOSE projekt_holenalle_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )870;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenAlleProjektInformationen");
}



	// und Ergebnis rauswerfen:
	return rueckgabe;
}
//------------------------------------------------------------------------------
// Funktionsname:	holenAlleProjektInformationenPG369
// Beschreibung:	liefert die Informationen aller Projekte des Datenaustausch-Users zurueck (gibt die ganze Projekttabelle aus)
// Parameter:		
// Rueckgabe:		eine liste mit Dreitupeln, die jeweils die drei Informationen der Tabelle aufnehmen
// Besonderheiten:	
//------------------------------------------------------------------------------
list<two_tuple<int,char*>*>* CDBSchnittstelle::holenAlleProjektInformationenPG369()
{
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenAlleProjektInformationenPG369"); */ 

    
	// erstmal sicherstellen, dass auch eine Rueckgabe existiert:
	list<two_tuple<int,char*>*>* rueckgabe=0;
	try{rueckgabe=new list<two_tuple<int,char*>*>;}
	catch(...)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Liste aller Projektinformationen des Austauschpools konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}

	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	typedef struct	
	{
 		int id;
		/* VARCHAR Bezeichnung[30]; */ 
struct { unsigned short len; unsigned char arr[30]; } Bezeichnung;

//		int Zustand;
	} projektelement;
	projektelement element;
	/* EXEC SQL END DECLARE SECTION; */ 
	

	// alle Elmente durchlaufen:
	element.id=-1;
	// erzeuge die Cursor, mit dem Daten durchlaufen werden:
	/* EXEC SQL DECLARE projekt_holenalle_cursor_pg369 CURSOR FOR
		SELECT id, Bezeichnung
		FROM pg369.Speicherstand; */ 

        
	// jetzt den Cursor oeffnen
	/* EXEC SQL OPEN projekt_holenalle_cursor_pg369; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = sq0018;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )884;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenAlleProjektInformationenPG369");
}


        	
        // und jetzt in Schleife alle Dinger holen:
	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

	for(;;)
	{
		/* EXEC SQL FETCH projekt_holenalle_cursor_pg369 INTO :element; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )898;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&element.id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&element.Bezeichnung;
  sqlstm.sqhstl[1] = (unsigned int  )32;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenAlleProjektInformationenPG369");
}


		two_tuple<int,char*>* temptupel=0;
		try{temptupel=new two_tuple<int,char*>;}
		catch(...)
		{
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: ein Element alles Projektinformationen des Austauschpools konnte nicht angelegt werden. Speichermangel?"<<endl;
			cerr.flush();
		}
		temptupel->first() = element.id;

		char* tempchar=0;
		try{tempchar=new char[element.Bezeichnung.len+1];}
		catch(...)
		{
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Beschreibung eines Projektes in der Liste aller Projektinformationen im Austauschpool konnte nicht angelegt werden. Speichermangel?"<<endl;
			cerr.flush();
		}
		tempchar[element.Bezeichnung.len]='\0';
		strncpy(tempchar, (char*)element.Bezeichnung.arr, element.Bezeichnung.len);
		
		temptupel->second() = tempchar;
//		temptupel->third() = element.Zustand;
		rueckgabe->append(temptupel);
	}
       	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	// und nach getaner arbeit Cursor wieder schliessen:
	/* EXEC SQL CLOSE projekt_holenalle_cursor_pg369; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )920;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenAlleProjektInformationenPG369");
}



	// und Ergebnis rauswerfen:
	return rueckgabe;
}
//------------------------------------------------------------------------------
// Funktionsname:	holenAnzahlProjekte
// Beschreibung:	gibt die Anzahl der in Oracle gespeicherten Projekte zurueck
// Parameter:		
// Rueckgabe:		die Anzahl der in Oracle gespeicherten Projekte
// Besonderheiten:	
//------------------------------------------------------------------------------
int CDBSchnittstelle::holenAnzahlProjekte() 
{
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenAlleProjektInformationen"); */ 

    
	// erstmal sicherstellen, dass auch eine Rueckgabe existiert:
	int rueckgabe=0;

	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	typedef struct	
	{
 		int id;
		/* VARCHAR Bezeichnung[30]; */ 
struct { unsigned short len; unsigned char arr[30]; } Bezeichnung;

		int Zustand;
	} projektelement;
	projektelement element;
	/* EXEC SQL END DECLARE SECTION; */ 
	

	// alle Elmente durchlaufen:
	// erzeuge die Cursor, mit dem Daten durchlaufen werden:
	/* EXEC SQL DECLARE projekt_anzahlprojekte_cursor CURSOR FOR
		SELECT id, Bezeichnung, Zustand
		FROM Speicherstand; */ 

        
	// jetzt den Cursor oeffnen
	/* EXEC SQL OPEN projekt_anzahlprojekte_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = sq0019;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )934;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenAlleProjektInformationen");
}


        	
        // und jetzt in Schleife alle Dinger holen:
	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

	for(;;)
	{
		/* EXEC SQL FETCH projekt_anzahlprojekte_cursor INTO :element; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )948;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&element.id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&element.Bezeichnung;
  sqlstm.sqhstl[1] = (unsigned int  )32;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&element.Zustand;
  sqlstm.sqhstl[2] = (unsigned int  )4;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenAlleProjektInformationen");
}


		rueckgabe++;  // es existiert ein weiterer Eintrag, also: Zaehler um eins erhoehen
	}
       	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	// und nach getaner arbeit Cursor wieder schliessen:
	/* EXEC SQL CLOSE projekt_anzahlprojekte_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )974;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenAlleProjektInformationen");
}



	// und Ergebnis rauswerfen:
	return rueckgabe;	
}
//------------------------------------------------------------------------------
// Funktionsname:	setztenPhase
// Beschreibung:	speichert den Schritt ab, indem sich der Benutzer im aktuellen Projekt gerade befindet
// Parameter:		Den Schritt als Integerwert
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::setztenPhase(int phase) 
{
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in setztenPhase"); */ 

    
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	int input_phase; 
	int speicherid; 
	/* EXEC SQL END DECLARE SECTION; */ 
	
	input_phase=phase;
	speicherid=speicherstand;

	if(phase<=25)
	{
		Debug(2, "Loesche Autoreisezeittabelle...");
		/* EXEC SQL DELETE FROM GuetemassReisezeitAuto WHERE SpeicherID = :speicherid; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "delete from GuetemassReisezeitAuto  where SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )988;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in setztenPhase");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )1006;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in setztenPhase");
}


	}

	/* EXEC SQL UPDATE Speicherstand SET Zustand = :input_phase WHERE ID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "update Speicherstand  set Zustand=:b0 where ID=:b1";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1020;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&input_phase;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqhstv[1] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[1] = (unsigned int  )4;
 sqlstm.sqindv[1] = (         short *)0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in setztenPhase");
}



	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1042;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in setztenPhase");
}


}
//------------------------------------------------------------------------------
// Funktionsname:	holenPhase
// Beschreibung:	holt den Schritt, in der sich das aktuelle Projekt gerade befindet
// Parameter:		
// Rueckgabe:		Der Schritt als integer-Wert
// Besonderheiten:	
//------------------------------------------------------------------------------
int CDBSchnittstelle::holenPhase()	
{
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenPhase"); */ 

    
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	typedef struct	
	{
 		int id;
		/* VARCHAR Bezeichnung[30]; */ 
struct { unsigned short len; unsigned char arr[30]; } Bezeichnung;

		int Zustand;
	} projektelement;
	projektelement element;
	int speicherid=speicherstand;
	/* EXEC SQL END DECLARE SECTION; */ 
	

	element.Zustand = 0;

	// hole den, zum aktuellen speicherstand gehoerende Eintrag

	/* EXEC SQL SELECT id, Bezeichnung, Zustand
		INTO :element
		FROM Speicherstand
		WHERE id = :speicherid AND Zustand IS NOT NULL; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "select id ,Bezeichnung ,Zustand into :s1 ,:s2 ,:s3   from Sp\
eicherstand where (id=:b1 and Zustand is  not null )";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1056;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&element.id;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqhstv[1] = (unsigned char  *)&element.Bezeichnung;
 sqlstm.sqhstl[1] = (unsigned int  )32;
 sqlstm.sqindv[1] = (         short *)0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqhstv[2] = (unsigned char  *)&element.Zustand;
 sqlstm.sqhstl[2] = (unsigned int  )4;
 sqlstm.sqindv[2] = (         short *)0;
 sqlstm.sqharm[2] = (unsigned int  )0;
 sqlstm.sqhstv[3] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[3] = (unsigned int  )4;
 sqlstm.sqindv[3] = (         short *)0;
 sqlstm.sqharm[3] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenPhase");
}



	// und jetzt das entsprechende Feld rauswerfen:
	return element.Zustand;
}
//------------------------------------------------------------------------------
// Funktionsname:	holenErsteFreieProjektID
// Beschreibung:	holt die erste Projekt-ID, die noch von keinem Projekt belegt wurde
// Parameter:		
// Rueckgabe:		Die ID als integer-Wert
// Besonderheiten:	
//------------------------------------------------------------------------------
int CDBSchnittstelle::holenErsteFreieProjektID() 
{
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenErsteFreieProjektID"); */ 

    
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	typedef struct	
	{
 		int id;
		/* VARCHAR Bezeichnung[30]; */ 
struct { unsigned short len; unsigned char arr[30]; } Bezeichnung;

//		int Zustand;
	} projektelement;
	projektelement element;
	int testid=0;
	/* EXEC SQL END DECLARE SECTION; */ 
	

	// Testen ,ob ID schon vergeben:	
	// sollte ID bereits vergeben sein, nimm die naechste ID und teste wieder, usw...
	do{
		element.id=-1;
		// erzeuge die Cursor, mit dem Daten durchlaufen werden:
		/* EXEC SQL DECLARE projekt_erstefreieid_cursor CURSOR FOR
			SELECT id, Bezeichnung 
					//, Zustand
				FROM Speicherstand
				WHERE id = :testid; */ 

        
	
		// jetzt den Cursor oeffnen
		/* EXEC SQL OPEN projekt_erstefreieid_cursor; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = sq0025;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )1086;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&testid;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenErsteFreieProjektID");
}


        	
	        // und jetzt in Schleife alle Dinger holen:
		/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

		for(;;)
		{
			/* EXEC SQL FETCH projekt_erstefreieid_cursor INTO :element; */ 

{
   struct sqlexd sqlstm;

   sqlorat((void **)0, &sqlctx, &oraca);
   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 7;
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )1104;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlstm.sqhstv[0] = (unsigned char  *)&element.id;
   sqlstm.sqhstl[0] = (unsigned int  )4;
   sqlstm.sqindv[0] = (         short *)0;
   sqlstm.sqharm[0] = (unsigned int  )0;
   sqlstm.sqhstv[1] = (unsigned char  *)&element.Bezeichnung;
   sqlstm.sqhstl[1] = (unsigned int  )32;
   sqlstm.sqindv[1] = (         short *)0;
   sqlstm.sqharm[1] = (unsigned int  )0;
   sqlstm.sqphsv = sqlstm.sqhstv;
   sqlstm.sqphsl = sqlstm.sqhstl;
   sqlstm.sqpind = sqlstm.sqindv;
   sqlstm.sqparm = sqlstm.sqharm;
   sqlstm.sqparc = sqlstm.sqharc;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
   if (sqlca.sqlcode == 1403) break;
   if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenErsteFreieProjektID");
}


			testid++; // hier testid um eins erhoehen => nimm naechste moegliche ID
		}
        	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

		// und nach getaner arbeit Cursor wieder schliessen:
		/* EXEC SQL CLOSE projekt_erstefreieid_cursor; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )1126;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenErsteFreieProjektID");
}


		
	}while(element.id!=-1);
	// hier steht jetzt in testid, genau die id, die unser neues Projekt erhalten darf.

	return testid;
}
//------------------------------------------------------------------------------
// Funktionsname:	holenErsteFreieProjektIDPG369
// Beschreibung:	holt die erste Projekt-ID, die noch von keinem Projekt belegt wurde
// Parameter:		
// Rueckgabe:		Die ID als integer-Wert
// Besonderheiten:	
//------------------------------------------------------------------------------
int CDBSchnittstelle::holenErsteFreieProjektIDPG369() 
{
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenErsteFreieProjektIDPG369"); */ 

    
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	typedef struct	
	{
 		int id;
		/* VARCHAR Bezeichnung[30]; */ 
struct { unsigned short len; unsigned char arr[30]; } Bezeichnung;

//		int Zustand;
	} projektelement;
	projektelement element;
	int testid=0;
	/* EXEC SQL END DECLARE SECTION; */ 
	

	// Testen ,ob ID schon vergeben:	
	// sollte ID bereits vergeben sein, nimm die naechste ID und teste wieder, usw...
	do{
		element.id=-1;
		// erzeuge die Cursor, mit dem Daten durchlaufen werden:
		/* EXEC SQL DECLARE projekt_erstefreieid_cursor_pg369 CURSOR FOR
			SELECT id, Bezeichnung 
					//, Zustand
				FROM pg369.Speicherstand
				WHERE id = :testid; */ 

        
	
		// jetzt den Cursor oeffnen
		/* EXEC SQL OPEN projekt_erstefreieid_cursor_pg369; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = sq0026;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )1140;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&testid;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenErsteFreieProjektIDPG369");
}


        	
	        // und jetzt in Schleife alle Dinger holen:
		/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

		for(;;)
		{
			/* EXEC SQL FETCH projekt_erstefreieid_cursor_pg369 INTO :element; */ 

{
   struct sqlexd sqlstm;

   sqlorat((void **)0, &sqlctx, &oraca);
   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 7;
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )1158;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlstm.sqhstv[0] = (unsigned char  *)&element.id;
   sqlstm.sqhstl[0] = (unsigned int  )4;
   sqlstm.sqindv[0] = (         short *)0;
   sqlstm.sqharm[0] = (unsigned int  )0;
   sqlstm.sqhstv[1] = (unsigned char  *)&element.Bezeichnung;
   sqlstm.sqhstl[1] = (unsigned int  )32;
   sqlstm.sqindv[1] = (         short *)0;
   sqlstm.sqharm[1] = (unsigned int  )0;
   sqlstm.sqphsv = sqlstm.sqhstv;
   sqlstm.sqphsl = sqlstm.sqhstl;
   sqlstm.sqpind = sqlstm.sqindv;
   sqlstm.sqparm = sqlstm.sqharm;
   sqlstm.sqparc = sqlstm.sqharc;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
   if (sqlca.sqlcode == 1403) break;
   if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenErsteFreieProjektIDPG369");
}


			testid++; // hier testid um eins erhoehen => nimm naechste moegliche ID
		}
        	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

		// und nach getaner arbeit Cursor wieder schliessen:
		/* EXEC SQL CLOSE projekt_erstefreieid_cursor_pg369; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )1180;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenErsteFreieProjektIDPG369");
}


		
	}while(element.id!=-1);
	// hier steht jetzt in testid, genau die id, die unser neues Projekt erhalten darf.

	return testid;
}
//------------------------------------------------------------------------------
// Funktionsname:	loeschenProjekt
// Beschreibung:	loescht das Projekt mit der ID "id"
// Parameter:		die Projekt ID als Integer-Wert
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::loeschenProjekt(int id) 
{
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in loeschenProjekt"); */ 


	const int anzahl_tabellen=31;
	int aktuelle_tabelle=1;

	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	int speicherid=id;
	/* EXEC SQL END DECLARE SECTION; */ 
	
        
	CFortschritt* fortschritt=0;
	char* ueberschrift=0;
	try{ueberschrift=new char[strlen("Loesche Projekt ")+20];}
	catch(...)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Ueberschrift der Fortschrittsanzeige beim Loeschen eines Projektes konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}
	sprintf(ueberschrift, "Loesche Projekt %d", id);
//	if(batchbetrieb==false) CFortschritt* fortschritt=new CFortschritt(ueberschrift);
        CFortschritt fort(ueberschrift);
	fortschritt= &fort;
	if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Loesche Projekt... bitte etwas Geduld");

	// und jetzt alle anderen Tabellen durchlaufen:
	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM Knoten WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from Knoten  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1194;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}


	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1212;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM KnotenWerte WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from KnotenWerte  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1226;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}


	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1244;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM KantenStrassen WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from KantenStrassen  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1258;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1276;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM Kanten WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from Kanten  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1290;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1308;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM LinienPlan WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from LinienPlan  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1322;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1340;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM LinienWeg WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from LinienWeg  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1354;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1372;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM LinienWerte WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from LinienWerte  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1386;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1404;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM Anschluss WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from Anschluss  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1418;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1436;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM Fahrplan WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from Fahrplan  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1450;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1468;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM QuelleZielMatrix WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from QuelleZielMatrix  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1482;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1500;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM QuelleZielListe WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from QuelleZielListe  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1514;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1532;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM UrsprungsQZMatrix WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from UrsprungsQZMatrix  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1546;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1564;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM UrsprungsQZListe WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from UrsprungsQZListe  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1578;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1596;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM Pendlermatrix WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from Pendlermatrix  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1610;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1628;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM Pendlerliste WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from Pendlerliste  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1642;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1660;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM Zusammenhangskomponente WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from Zusammenhangskomponente  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1674;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1692;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM Ausgangsloesung WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from Ausgangsloesung  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1706;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1724;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM AusgangsloesungHaltestelle WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from AusgangsloesungHaltestelle  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1738;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1756;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM LinienplanBewertung WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from LinienplanBewertung  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1770;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1788;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM HaltestellenModulParameter WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from HaltestellenModulParameter  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1802;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1820;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM LinienplanModulParameter WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from LinienplanModulParameter  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1834;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1852;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM FahrplanModulParameter WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from FahrplanModulParameter  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1866;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1884;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM Bevoelkerungsdichte WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from Bevoelkerungsdichte  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1898;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1916;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM Mindestumsteigezeit WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from Mindestumsteigezeit  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1930;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1948;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM Mindesthaltezeit WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from Mindesthaltezeit  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1962;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1980;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}


        if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM Pflichthaltestellen WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from Pflichthaltestellen  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1994;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}


	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2012;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM Ausschnitt WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from Ausschnitt  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2026;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2044;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM Guetemasse WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from Guetemasse  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2058;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2076;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM GuetemassReisezeitAuto WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from GuetemassReisezeitAuto  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2090;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2108;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM Pflichtlinien WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from Pflichtlinien  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2122;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2140;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}



	// als erstes den Eintrag in Speicherstand killen:
	/* EXEC SQL DELETE FROM Speicherstand WHERE id = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from Speicherstand  where id=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2154;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}


	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2172;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjekt");
}



        delete[] ueberschrift;
	// und den speicherstand auf 0 setzten: (lt. Helge nicht noetig)
	//speicherstand=0;	
}
//------------------------------------------------------------------------------
// Funktionsname:	loeschenProjektPG369
// Beschreibung:	loescht das Projekt mit der ID "id" des Datenaustausch-Users
// Parameter:		die Projekt ID als Integer-Wert
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::loeschenProjektPG369(int id) 
{
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in loeschenProjektPG369"); */ 


	const int anzahl_tabellen=31;
	int aktuelle_tabelle=1;

	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	int speicherid=id;
	/* EXEC SQL END DECLARE SECTION; */ 
	
        
	CFortschritt* fortschritt=0;
	char* ueberschrift=0;
	try{ueberschrift=new char[strlen("Loesche Projekt ")+20];}
	catch(...)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Ueberschrift der Fortschrittsanzeige beim Loeschen eines Projektes im Austauschpool konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}
	sprintf(ueberschrift, "Loesche Projekt %d", id);
//	if(batchbetrieb==false) CFortschritt* fortschritt=new CFortschritt(ueberschrift);
        CFortschritt fort(ueberschrift);
	fortschritt= &fort;
	if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Bereite Loeschvorgang vor... bitte etwas Geduld");

	Debug(2, "Username lautet:"<<benutzername);
	Debug(2, "Schliesse Verbindung");
	beendenVerbindung();
	Debug(2, "Baue Verbindung fuer den Imaginaeren Benutezer auf");
	aufbauenVerbindung("pg369");

        if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Loesche Projekt im Datenaustauschpool... bitte etwas Geduld");
	// und jetzt alle anderen Tabellen durchlaufen:
	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM pg369.Knoten WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from pg369.Knoten  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2186;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}


	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2204;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM pg369.KnotenWerte WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from pg369.KnotenWerte  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2218;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}


	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2236;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM pg369.KantenStrassen WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from pg369.KantenStrassen  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2250;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2268;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM pg369.Kanten WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from pg369.Kanten  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2282;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2300;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM pg369.LinienPlan WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from pg369.LinienPlan  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2314;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2332;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM pg369.LinienWeg WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from pg369.LinienWeg  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2346;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2364;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM pg369.LinienWerte WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from pg369.LinienWerte  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2378;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2396;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM pg369.Anschluss WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from pg369.Anschluss  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2410;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2428;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM pg369.Fahrplan WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from pg369.Fahrplan  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2442;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2460;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM pg369.QuelleZielMatrix WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from pg369.QuelleZielMatrix  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2474;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2492;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM pg369.QuelleZielListe WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from pg369.QuelleZielListe  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2506;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2524;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM pg369.UrsprungsQZMatrix WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from pg369.UrsprungsQZMatrix  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2538;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2556;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM pg369.UrsprungsQZListe WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from pg369.UrsprungsQZListe  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2570;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2588;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM pg369.Pendlermatrix WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from pg369.Pendlermatrix  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2602;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2620;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM pg369.Pendlerliste WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from pg369.Pendlerliste  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2634;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2652;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM pg369.Zusammenhangskomponente WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from pg369.Zusammenhangskomponente  where SpeicherID=\
:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2666;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2684;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM pg369.Ausgangsloesung WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from pg369.Ausgangsloesung  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2698;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2716;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM pg369.AusgangsloesungHaltestelle WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from pg369.AusgangsloesungHaltestelle  where Speicher\
ID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2730;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2748;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM pg369.LinienplanBewertung WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from pg369.LinienplanBewertung  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2762;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2780;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM pg369.HaltestellenModulParameter WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from pg369.HaltestellenModulParameter  where Speicher\
ID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2794;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2812;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM pg369.LinienplanModulParameter WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from pg369.LinienplanModulParameter  where SpeicherID\
=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2826;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2844;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM pg369.FahrplanModulParameter WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from pg369.FahrplanModulParameter  where SpeicherID=:\
b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2858;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2876;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM pg369.Bevoelkerungsdichte WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from pg369.Bevoelkerungsdichte  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2890;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2908;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM pg369.Mindestumsteigezeit WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from pg369.Mindestumsteigezeit  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2922;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2940;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM pg369.Mindesthaltezeit WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from pg369.Mindesthaltezeit  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2954;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2972;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}


        if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM pg369.Pflichthaltestellen WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from pg369.Pflichthaltestellen  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )2986;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}


	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )3004;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM pg369.Ausschnitt WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from pg369.Ausschnitt  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )3018;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )3036;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM pg369.Guetemasse WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from pg369.Guetemasse  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )3050;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )3068;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM pg369.GuetemassReisezeitAuto WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from pg369.GuetemassReisezeitAuto  where SpeicherID=:\
b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )3082;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )3100;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}


	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
	/* EXEC SQL DELETE FROM pg369.Pflichtlinien WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from pg369.Pflichtlinien  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )3114;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}

	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )3132;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}


        
	// als letztes den Eintrag in Speicherstand killen:
	/* EXEC SQL DELETE FROM pg369.Speicherstand WHERE id = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from pg369.Speicherstand  where id=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )3146;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}


	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )3164;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenProjektPG369");
}



	if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Schliesse Loeschvorgang ab... bitte etwas Geduld");

	// und wieder als alter User anmelden:
	Debug(2, "Username lautet:"<<benutzername);
	Debug(2, "Schliesse Verbindung");
	beendenVerbindung();
	Debug(2, "Baue Verbindung fuer den Imaginaeren Benutezer auf");
	aufbauenVerbindung(benutzername);

        delete[] ueberschrift;
	// und den speicherstand auf 0 setzten: (lt. Helge nicht noetig)
	//speicherstand=0;	
}
//------------------------------------------------------------------------------
// Funktionsname:	kopierenProjekt
// Beschreibung:	kopiert das Projekt mit der ID "quellid" in das Projekt mit der ID "zielid", liefert die ID des Zielprojektes zuerueck
// Parameter:		die ID des Quellprojekts und die ID des Zielprojektes
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
int CDBSchnittstelle::kopierenProjekt(int quellid, int zielid, char* beschreibung=0) 
{
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in kopierenProjekt"); */ 

    
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	typedef struct	
	{
 		int id;
		/* VARCHAR Bezeichnung[30]; */ 
struct { unsigned short len; unsigned char arr[30]; } Bezeichnung;

		int Zustand;
	} projektelement;
	projektelement element;
	int quell_id=quellid;
	int ziel_id=zielid;
	/* EXEC SQL END DECLARE SECTION; */ 
	
	
	CFortschritt* fortschritt=0;
	if(batchbetrieb==false) 
	{
		try{fortschritt=new CFortschritt("Projekt kopieren");}
		catch(...)
		{
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Fortschrittsanzeige beim Kopieren eines Projektes konnte nicht angelegt werden. Speichermangel?"<<endl;
			cerr.flush();
		}
	}
	if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Pruefe, ob ID bereits vergeben...");	

	// Testen ,ob ID schon vergeben:	
	// sollte ID bereits vergeben sein, nimm die naechste ID und teste wieder, usw...
	do{
		element.id=-1;
		// erzeuge die Cursor, mit dem Daten durchlaufen werden:
		/* EXEC SQL DECLARE projekt_test_id_kopieren_cursor CURSOR FOR
			SELECT id, Bezeichnung, Zustand
				FROM Speicherstand
				WHERE id = :ziel_id; */ 

        
	
		// jetzt den Cursor oeffnen
		/* EXEC SQL OPEN projekt_test_id_kopieren_cursor; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = sq0151;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )3178;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


        	
	        // und jetzt in Schleife alle Dinger holen:
		/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

		for(;;)
		{
			/* EXEC SQL FETCH projekt_test_id_kopieren_cursor INTO :element; */ 

{
   struct sqlexd sqlstm;

   sqlorat((void **)0, &sqlctx, &oraca);
   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 7;
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )3196;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlstm.sqhstv[0] = (unsigned char  *)&element.id;
   sqlstm.sqhstl[0] = (unsigned int  )4;
   sqlstm.sqindv[0] = (         short *)0;
   sqlstm.sqharm[0] = (unsigned int  )0;
   sqlstm.sqhstv[1] = (unsigned char  *)&element.Bezeichnung;
   sqlstm.sqhstl[1] = (unsigned int  )32;
   sqlstm.sqindv[1] = (         short *)0;
   sqlstm.sqharm[1] = (unsigned int  )0;
   sqlstm.sqhstv[2] = (unsigned char  *)&element.Zustand;
   sqlstm.sqhstl[2] = (unsigned int  )4;
   sqlstm.sqindv[2] = (         short *)0;
   sqlstm.sqharm[2] = (unsigned int  )0;
   sqlstm.sqphsv = sqlstm.sqhstv;
   sqlstm.sqphsl = sqlstm.sqhstl;
   sqlstm.sqpind = sqlstm.sqindv;
   sqlstm.sqparm = sqlstm.sqharm;
   sqlstm.sqparc = sqlstm.sqharc;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
   if (sqlca.sqlcode == 1403) break;
   if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


			ziel_id++; // hier ziel_id um eins erhoehen => nimm naechste moegliche ID
		}
        	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

		// und nach getaner arbeit Cursor wieder schliessen:
		/* EXEC SQL CLOSE projekt_test_id_kopieren_cursor; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )3222;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		
	}while(element.id!=-1);
	// hier steht jetzt in ziel_id, genau die id, die unser neues Projekt erhalten darf.
        
	/* EXEC SQL SELECT id, Bezeichnung, Zustand INTO :element FROM Speicherstand WHERE id = :quell_id; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "select id ,Bezeichnung ,Zustand into :s1 ,:s2 ,:s3   from Sp\
eicherstand where id=:b1";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )3236;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&element.id;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqhstv[1] = (unsigned char  *)&element.Bezeichnung;
 sqlstm.sqhstl[1] = (unsigned int  )32;
 sqlstm.sqindv[1] = (         short *)0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqhstv[2] = (unsigned char  *)&element.Zustand;
 sqlstm.sqhstl[2] = (unsigned int  )4;
 sqlstm.sqindv[2] = (         short *)0;
 sqlstm.sqharm[2] = (unsigned int  )0;
 sqlstm.sqhstv[3] = (unsigned char  *)&quell_id;
 sqlstm.sqhstl[3] = (unsigned int  )4;
 sqlstm.sqindv[3] = (         short *)0;
 sqlstm.sqharm[3] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


	// vor dem Kopieren, legen wir also das neue Projekt erstmal an:
	anlegenNeuesProjekt(ziel_id, beschreibung, element.Zustand);

	if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Projekt...");	


		const int anzahl_tabellen=30;
		int aktuelle_tabelle=1;
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
                if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Knoten...");
		Debug(2, "Kopiere Tabelle Knoten...");
//		EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2), HaltestellenID NUMBER NOT NULL, Name VARCHAR2(30) NULL, 
//						XKoordinate NUMBER NOT NULL, YKoordinate NUMBER NOT NULL, Prioritaet NUMBER(2) NOT NULL, 
//						Pflicht NUMBER(1) NOT NULL, PRIMARY KEY (SpeicherID,HaltestellenID));
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2), HaltestellenID NUMBER NOT NULL, Name VARCHAR2(30) NULL, XKoordinate NUMBER NOT NULL, YKoordinate NUMBER NOT NULL, Prioritaet NUMBER(2) NOT NULL, Pflicht NUMBER(1) NOT NULL, PRIMARY KEY (SpeicherID,HaltestellenID)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) , Haltestell\
enID NUMBER NOT NULL , Name VARCHAR2 ( 30 ) NULL , XKoordinate NUMBER NOT NULL\
 , YKoordinate NUMBER NOT NULL , Prioritaet NUMBER ( 2 ) NOT NULL , Pflicht NU\
MBER ( 1 ) NOT NULL , PRIMARY KEY ( SpeicherID , HaltestellenID ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )3266;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		Debug(2, "1");
		// temporaere Tabelle anlegen:
	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM Knoten WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from Knoten where Spei\
cherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )3280;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		Debug(2, "2");
		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )3298;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		Debug(2, "3.");
		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO  Knoten SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into Knoten select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )3316;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		Debug(2, "4");
		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )3330;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		Debug(2, "5");
		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )3344;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}




		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle KnotenWerte...");
		Debug(2, "Kopiere Tabelle KnotenWerte...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, HaltestellenID NUMBER NOT NULL, 
						UmsteigezeitMinuten NUMBER NOT NULL, MindesthaltezeitMinuten NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID,HaltestellenID)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , H\
altestellenID NUMBER NOT NULL , UmsteigezeitMinuten NUMBER NOT NULL , Mindesth\
altezeitMinuten NUMBER NOT NULL , PRIMARY KEY ( SpeicherID , HaltestellenID ) \
)";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )3358;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM KnotenWerte  WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from KnotenWerte where\
 SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )3372;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )3390;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO KnotenWerte SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into KnotenWerte select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )3408;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )3422;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )3436;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle KantenStrasse...");
		Debug(2, "Kopiere Tabelle KantenStrasse...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, StrassenID NUMBER NOT NULL, LfdNr NUMBER NOT NULL, 
						XKoordinaten NUMBER NOT NULL, YKoordinaten NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID,StrassenID,LfdNr)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , S\
trassenID NUMBER NOT NULL , LfdNr NUMBER NOT NULL , XKoordinaten NUMBER NOT NU\
LL , YKoordinaten NUMBER NOT NULL , PRIMARY KEY ( SpeicherID , StrassenID , Lf\
dNr ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )3450;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}

	        
		/* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM  KantenStrassen WHERE SpeicherID = :quell_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "insert into tmp_tbl select *  from KantenStrassen where Spe\
icherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )3464;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )3482;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO KantenStrassen SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into KantenStrassen select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )3500;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )3514;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )3528;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Kanten...");
		Debug(2, "Kopiere Tabelle Kanten...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, KantenID NUMBER NOT NULL, 
						StartHaltestelle NUMBER NOT NULL, EndHaltestelle NUMBER NOT NULL, 
						ReisezeitMinuten NUMBER(2) NOT NULL, Laenge NUMBER NOT NULL, ReiseFluss NUMBER NULL, 
						StrassenID NUMBER NOT NULL, PRIMARY KEY (SpeicherID,KantenID)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , K\
antenID NUMBER NOT NULL , StartHaltestelle NUMBER NOT NULL , EndHaltestelle NU\
MBER NOT NULL , ReisezeitMinuten NUMBER ( 2 ) NOT NULL , Laenge NUMBER NOT NUL\
L , ReiseFluss NUMBER NULL , StrassenID NUMBER NOT NULL , PRIMARY KEY ( Speich\
erID , KantenID ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )3542;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM  Kanten WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from Kanten where Spei\
cherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )3556;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )3574;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO Kanten SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into Kanten select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )3592;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )3606;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )3620;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle LinienPlan...");
		Debug(2, "Kopiere Tabelle LinienPlan...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, PlanID NUMBER NOT NULL, Beschreibung VARCHAR2(70) NULL, 
						LinienID NUMBER NOT NULL, PRIMARY KEY (SpeicherID,PlanID,LinienID)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , P\
lanID NUMBER NOT NULL , Beschreibung VARCHAR2 ( 70 ) NULL , LinienID NUMBER NO\
T NULL , PRIMARY KEY ( SpeicherID , PlanID , LinienID ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )3634;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM  LinienPlan WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from LinienPlan where \
SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )3648;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )3666;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO LinienPlan SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into LinienPlan select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )3684;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )3698;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )3712;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}



         	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle LinienWeg...");
		Debug(2, "Kopiere Tabelle LinienWeg...");
	        // temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, PlanID NUMBER NOT NULL, LinienID NUMBER NOT NULL, 
						LfdNr NUMBER NOT NULL, HaltestellenID NUMBER NOT NULL, PRIMARY KEY (SpeicherID,LinienID,LfdNr)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , P\
lanID NUMBER NOT NULL , LinienID NUMBER NOT NULL , LfdNr NUMBER NOT NULL , Hal\
testellenID NUMBER NOT NULL , PRIMARY KEY ( SpeicherID , LinienID , LfdNr ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )3726;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM LinienWeg WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from LinienWeg where S\
peicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )3740;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )3758;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO LinienWeg SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into LinienWeg select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )3776;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )3790;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )3804;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


	
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle LinienWerte...");
		Debug(2, "Kopiere Tabelle LinienWerte...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, LfdNr NUMBER NOT NULL, PlanID NUMBER NOT NULL, 
						LinienID NUMBER NOT NULL, VonHaltestelle NUMBER NOT NULL, 
						NachHaltestelle NUMBER NOT NULL, Reisezeit NUMBER NOT NULL, 
						Verkehrsstrom NUMBER NOT NULL, PRIMARY KEY (SpeicherID,PlanID,LinienID,LfdNr)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , L\
fdNr NUMBER NOT NULL , PlanID NUMBER NOT NULL , LinienID NUMBER NOT NULL , Von\
Haltestelle NUMBER NOT NULL , NachHaltestelle NUMBER NOT NULL , Reisezeit NUMB\
ER NOT NULL , Verkehrsstrom NUMBER NOT NULL , PRIMARY KEY ( SpeicherID , PlanI\
D , LinienID , LfdNr ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )3818;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM LinienWerte WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from LinienWerte where\
 SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )3832;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )3850;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO LinienWerte SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into LinienWerte select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )3868;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )3882;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )3896;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Anschluss...");
		Debug(2, "Kopiere Tabelle Anschluss...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, LinieVon NUMBER NOT NULL, LinieNach NUMBER NOT NULL, 
						Haltestelle NUMBER NOT NULL, PRIMARY KEY (SpeicherID,LinieVon,LinieNach,Haltestelle)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , L\
inieVon NUMBER NOT NULL , LinieNach NUMBER NOT NULL , Haltestelle NUMBER NOT N\
ULL , PRIMARY KEY ( SpeicherID , LinieVon , LinieNach , Haltestelle ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )3910;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM Anschluss WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from Anschluss where S\
peicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )3924;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )3942;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO Anschluss SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into Anschluss select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )3960;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )3974;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )3988;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Fahrplan...");
		Debug(2, "Kopiere Tabelle Fahrplan...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, HaltestellenID NUMBER NOT NULL, 
						LinienID NUMBER NOT NULL, AbfahrtszeitStd NUMBER(2) NOT NULL, 
						AbfahrtszeitMin NUMBER(2) NOT NULL, PRIMARY KEY(SpeicherID,HaltestellenID,LinienID)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , H\
altestellenID NUMBER NOT NULL , LinienID NUMBER NOT NULL , AbfahrtszeitStd NUM\
BER ( 2 ) NOT NULL , AbfahrtszeitMin NUMBER ( 2 ) NOT NULL , PRIMARY KEY ( Spe\
icherID , HaltestellenID , LinienID ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4002;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM Fahrplan WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from Fahrplan where Sp\
eicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )4016;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4034;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO Fahrplan SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into Fahrplan select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )4052;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4066;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4080;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle QuelleZielMatrix...");
		Debug(2, "Kopiere Tabelle QuelleZielMatrix...");
         	// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, VonHaltestelle NUMBER NOT NULL, 
						NachHaltestelle NUMBER NOT NULL, Reiseaufkommen NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID,VonHaltestelle,NachHaltestelle)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , V\
onHaltestelle NUMBER NOT NULL , NachHaltestelle NUMBER NOT NULL , Reiseaufkomm\
en NUMBER NOT NULL , PRIMARY KEY ( SpeicherID , VonHaltestelle , NachHaltestel\
le ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4094;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM  QuelleZielMatrix WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from QuelleZielMatrix \
where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )4108;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4126;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO QuelleZielMatrix SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into QuelleZielMatrix select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )4144;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4158;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4172;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle QuelleZielListe...");
		Debug(2, "Kopiere Tabelle QuelleZielListe...");
	        // temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, xKoordinate NUMBER NOT NULL, 
						yKoordinate NUMBER NOT NULL, ElementID NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID,xKoordinate,yKoordinate)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , x\
Koordinate NUMBER NOT NULL , yKoordinate NUMBER NOT NULL , ElementID NUMBER NO\
T NULL , PRIMARY KEY ( SpeicherID , xKoordinate , yKoordinate ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4186;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM QuelleZielListe WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from QuelleZielListe w\
here SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )4200;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4218;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO QuelleZielListe SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into QuelleZielListe select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )4236;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4250;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4264;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle UrsprungsQZMatrix...");
		Debug(2, "Kopiere Tabelle UrsprungsQZMatrix...");
         	// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, VonHaltestelle NUMBER NOT NULL, 
						NachHaltestelle NUMBER NOT NULL, Reiseaufkommen NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID,VonHaltestelle,NachHaltestelle)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , V\
onHaltestelle NUMBER NOT NULL , NachHaltestelle NUMBER NOT NULL , Reiseaufkomm\
en NUMBER NOT NULL , PRIMARY KEY ( SpeicherID , VonHaltestelle , NachHaltestel\
le ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4278;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM  UrsprungsQZMatrix WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from UrsprungsQZMatrix\
 where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )4292;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4310;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO UrsprungsQZMatrix SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into UrsprungsQZMatrix select *  from tmp_tbl\
 ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )4328;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4342;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4356;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle UrsprungsQZListe...");
		Debug(2, "Kopiere Tabelle UrsprungsQZListe...");
	        // temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, xKoordinate NUMBER NOT NULL, 
						yKoordinate NUMBER NOT NULL, ElementID NUMBER NOT NULL, PRIMARY KEY (SpeicherID,xKoordinate,yKoordinate)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , x\
Koordinate NUMBER NOT NULL , yKoordinate NUMBER NOT NULL , ElementID NUMBER NO\
T NULL , PRIMARY KEY ( SpeicherID , xKoordinate , yKoordinate ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4370;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM UrsprungsQZListe WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from UrsprungsQZListe \
where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )4384;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4402;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO UrsprungsQZListe SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into UrsprungsQZListe select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )4420;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4434;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4448;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Pendlermatrix...");
		Debug(2, "Kopiere Tabelle Pendlermatrix...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, StadtteilVon NUMBER NOT NULL, 
						StadtteilNach NUMBER NOT NULL, Dichte NUMBER NOT NULL, PRIMARY KEY (SpeicherID,StadtteilVon,StadtteilNach)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , S\
tadtteilVon NUMBER NOT NULL , StadtteilNach NUMBER NOT NULL , Dichte NUMBER NO\
T NULL , PRIMARY KEY ( SpeicherID , StadtteilVon , StadtteilNach ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4462;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM Pendlermatrix WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from Pendlermatrix whe\
re SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )4476;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4494;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO Pendlermatrix SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into Pendlermatrix select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )4512;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4526;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4540;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Pendlerliste...");
		Debug(2, "Kopiere Tabelle Pendlerliste...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, xKoordinate NUMBER NOT NULL, 
						yKoordinate NUMBER NOT NULL, ElementID NUMBER NOT NULL, Radius NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID,xKoordinate,yKoordinate)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , x\
Koordinate NUMBER NOT NULL , yKoordinate NUMBER NOT NULL , ElementID NUMBER NO\
T NULL , Radius NUMBER NOT NULL , PRIMARY KEY ( SpeicherID , xKoordinate , yKo\
ordinate ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4554;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM Pendlerliste WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from Pendlerliste wher\
e SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )4568;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4586;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO Pendlerliste SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into Pendlerliste select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )4604;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4618;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4632;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Zusammenhangskomponenten...");
		Debug(2, "Kopiere Tabelle Zusammenhangskomponenten...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, KomponentenID NUMBER NOT NULL, 
						LfdNummer NUMBER NOT NULL, HaltestellenIDVon NUMBER NOT NULL, 
						HaltestellenIDNach NUMBER NOT NULL, LinienID NUMBER NOT NULL, 
						PRIMARY KEY(SpeicherID,KomponentenID,LfdNummer)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , K\
omponentenID NUMBER NOT NULL , LfdNummer NUMBER NOT NULL , HaltestellenIDVon N\
UMBER NOT NULL , HaltestellenIDNach NUMBER NOT NULL , LinienID NUMBER NOT NULL\
 , PRIMARY KEY ( SpeicherID , KomponentenID , LfdNummer ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4646;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM Zusammenhangskomponente WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from Zusammenhangskomp\
onente where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )4660;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4678;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO Zusammenhangskomponente SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into Zusammenhangskomponente select *  from t\
mp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )4696;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4710;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4724;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Ausgangsloesung...");
		Debug(2, "Kopiere Tabelle Ausgangsloesung...");
                // temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, LoesungsID NUMBER NOT NULL, 
						Beschreibung VARCHAR2(70) NULL, WartezeitaufwandMin NUMBER NOT NULL, 
						MindestwartezeitMin NUMBER NOT NULL, GesamtwartezeitMin NUMBER NOT NULL, 
						AnzahlBusse NUMBER, PRIMARY KEY (SpeicherID,LoesungsID)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , L\
oesungsID NUMBER NOT NULL , Beschreibung VARCHAR2 ( 70 ) NULL , Wartezeitaufwa\
ndMin NUMBER NOT NULL , MindestwartezeitMin NUMBER NOT NULL , GesamtwartezeitM\
in NUMBER NOT NULL , AnzahlBusse NUMBER , PRIMARY KEY ( SpeicherID , LoesungsI\
D ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4738;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM Ausgangsloesung WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from Ausgangsloesung w\
here SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )4752;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4770;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO Ausgangsloesung SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into Ausgangsloesung select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )4788;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4802;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4816;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle AusgangsloesungHaltestelle...");
		Debug(2, "Kopiere Tabelle AusgangsloesungHaltestelle...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, LoesungsID NUMBER NOT NULL, 
						Haltestelle NUMBER NOT NULL, NetzbedingteWartezeit NUMBER(2) NOT NULL, 
						Wartezeitaufwand NUMBER(2) NOT NULL, PRIMARY KEY (SpeicherID,LoesungsID,Haltestelle)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , L\
oesungsID NUMBER NOT NULL , Haltestelle NUMBER NOT NULL , NetzbedingteWartezei\
t NUMBER ( 2 ) NOT NULL , Wartezeitaufwand NUMBER ( 2 ) NOT NULL , PRIMARY KEY\
 ( SpeicherID , LoesungsID , Haltestelle ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4830;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM AusgangsloesungHaltestelle WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from AusgangsloesungHa\
ltestelle where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )4844;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4862;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO AusgangsloesungHaltestelle SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into AusgangsloesungHaltestelle select *  fro\
m tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )4880;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4894;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4908;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle LinienplanBewertung...");
		Debug(2, "Kopiere Tabelle LinienplanBewertung...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, LinienplanID NUMBER NOT NULL, 
						MittlereReisezeit NUMBER NOT NULL, Direktfahreranteil NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID,LinienplanID)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , L\
inienplanID NUMBER NOT NULL , MittlereReisezeit NUMBER NOT NULL , Direktfahrer\
anteil NUMBER NOT NULL , PRIMARY KEY ( SpeicherID , LinienplanID ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4922;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM LinienplanBewertung WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from LinienplanBewertu\
ng where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )4936;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4954;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO LinienplanBewertung SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into LinienplanBewertung select *  from tmp_t\
bl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )4972;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )4986;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5000;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


	
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle HaltestellenModulParameter...");
		Debug(2, "Kopiere Tabelle HaltestellenModulParameter...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, Aufruf NUMBER NOT NULL, Algorithmus NUMBER NOT NULL,
						ZufiInitialisierung NUMBER NOT NULL, MinRadius NUMBER NOT NULL, MaxRadius NUMBER NOT NULL,
						VerbindungsRadiusStadt NUMBER NOT NULL, VerbindungsRadiusLand NUMBER NOT NULL,
						Radiustyp NUMBER NOT NULL, HaltestellenLage NUMBER NOT NULL, Toleranzgrenze NUMBER NOT NULL,
						BevoelkerungsRaster NUMBER NOT NULL, Bevoelkerungsueberversorgung NUMBER NOT NULL,
						Bevoelkerungsunterversorgung NUMBER NOT NULL, Flaechenueberversorgung NUMBER NOT NULL,
						Flaechenunterversorgung NUMBER NOT NULL, Fahrtwunscheinbeziehung NUMBER NOT NULL,
						Strassenanpassung NUMBER NOT NULL, AnzahlHaltestellen NUMBER NOT NULL,
						AnzStrassenkarte NUMBER NOT NULL, AnzBevoelkerungsversorgung NUMBER NOT NULL,
						AnzFlaechenversorgung NUMBER NOT NULL, Anzkomplettunterdruecken NUMBER NOT NULL,
						Strategie NUMBER NOT NULL, AnzahlEltern NUMBER NOT NULL, AnzahlKinder NUMBER NOT NULL,
						Generationen NUMBER NOT NULL, AbbruchGueteunterschreitung NUMBER NOT NULL,
						GrenzwGueteunterschreitung NUMBER NOT NULL, PRIMARY KEY (SpeicherID,Aufruf)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlbuft((void **)0, 
    "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , Aufruf NUMBER\
 NOT NULL , Algorithmus NUMBER NOT NULL , ZufiInitialisierung NUMBER NOT NUL\
L , MinRadius NUMBER NOT NULL , MaxRadius NUMBER NOT NULL , VerbindungsRadiu\
sStadt NUMBER NOT NULL , VerbindungsRadiusLand NUMBER NOT NULL , Radiustyp N\
UMBER NOT NULL , HaltestellenLage NUMBER NOT NULL , Toleranzgrenze NUMBER NO\
T NULL , BevoelkerungsRaster NUMBER NOT NULL , Bevoelkerungsueberversorgung \
NUMBER NOT NULL , Bevoelkerungsunterversorgung NUMBER NOT NULL , Flaechenueb\
erversorgung NUMBER NOT NULL , Flaechenunterversorgung NUMBER NOT NULL , Fah\
rtwunscheinbeziehung NUMBER NOT NULL , Strassenanpassung NUMBER NOT NULL , A\
nzahlHaltestellen NUMBER NOT NULL , AnzStrassenkarte NUMBER NOT NULL , AnzBe\
voelkerungsversorgung NUMBER NOT NULL , AnzFlaechenversorgung NUMBER NOT NUL\
L , Anzkomplettunterdruecken NUMBER NOT NULL , Strategie NUMBER NOT NULL , A\
nzahlEltern NUMBER NOT NULL , AnzahlKinder NUMBER NOT NULL , Generationen NU\
MBER NOT NULL , AbbruchGueteunterschreitu");
  sqlstm.stmt = "ng NUMBER NOT NULL , GrenzwGueteunterschreitung NUMBER NOT \
NULL , PRIMARY KEY ( SpeicherID , Aufruf ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5014;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM HaltestellenModulParameter WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from HaltestellenModul\
Parameter where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )5028;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5046;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO HaltestellenModulParameter SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into HaltestellenModulParameter select *  fro\
m tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )5064;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5078;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5092;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);		
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle LinienplanModulParameter...");
		Debug(2, "Kopiere Tabelle LinienplanModulParameter...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, Aufruf NUMBER NOT NULL, Gesamtlaenge NUMBER NOT NULL, 
						MaxLinienLaenge NUMBER NOT NULL, MaxLinienAnzahl NUMBER NOT NULL, 
						LinienplanID NUMBER NOT NULL, Geschwindigkeit NUMBER, Algorithmus NUMBER, 
						AnzeigeBerechnung NUMBER, EindeutigeLinienverkn NUMBER NOT NULL, 
						MehrdeutigeLinienverkn NUMBER NOT NULL, Aufbruchsverknuepfung NUMBER NOT NULL, 
						Linienendverknuepfung NUMBER NOT NULL, Basislinienwahl NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID,Aufruf)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , A\
ufruf NUMBER NOT NULL , Gesamtlaenge NUMBER NOT NULL , MaxLinienLaenge NUMBER \
NOT NULL , MaxLinienAnzahl NUMBER NOT NULL , LinienplanID NUMBER NOT NULL , Ge\
schwindigkeit NUMBER , Algorithmus NUMBER , AnzeigeBerechnung NUMBER , Eindeut\
igeLinienverkn NUMBER NOT NULL , MehrdeutigeLinienverkn NUMBER NOT NULL , Aufb\
ruchsverknuepfung NUMBER NOT NULL , Linienendverknuepfung NUMBER NOT NULL , Ba\
sislinienwahl NUMBER NOT NULL , PRIMARY KEY ( SpeicherID , Aufruf ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5106;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM LinienplanModulParameter WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from LinienplanModulPa\
rameter where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )5120;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5138;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO LinienplanModulParameter SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into LinienplanModulParameter select *  from \
tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )5156;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5170;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5184;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle FahrplanModulParameter...");
		Debug(2, "Kopiere Tabelle FahrplanModulParameter...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, Aufruf NUMBER NOT NULL, 
						MaxFahrzeuganzahl NUMBER NOT NULL, AllgemeinerTakt NUMBER(2) NOT NULL, 
						Mindesthaltezeit NUMBER NOT NULL, Mindestumsteigezeit NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID,Aufruf)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , A\
ufruf NUMBER NOT NULL , MaxFahrzeuganzahl NUMBER NOT NULL , AllgemeinerTakt NU\
MBER ( 2 ) NOT NULL , Mindesthaltezeit NUMBER NOT NULL , Mindestumsteigezeit N\
UMBER NOT NULL , PRIMARY KEY ( SpeicherID , Aufruf ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5198;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM FahrplanModulParameter WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from FahrplanModulPara\
meter where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )5212;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5230;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO FahrplanModulParameter SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into FahrplanModulParameter select *  from tm\
p_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )5248;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5262;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5276;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Bevoelkerungsdichte...");
		Debug(2, "Kopiere Tabelle Bevoelkerungsdichte...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, XKoordinate NUMBER NOT NULL, 
						YKoordinate NUMBER NOT NULL, Radius NUMBER NOT NULL, Dichte NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID, XKoordinate,YKoordinate)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , X\
Koordinate NUMBER NOT NULL , YKoordinate NUMBER NOT NULL , Radius NUMBER NOT N\
ULL , Dichte NUMBER NOT NULL , PRIMARY KEY ( SpeicherID , XKoordinate , YKoord\
inate ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5290;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM Bevoelkerungsdichte WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from Bevoelkerungsdich\
te where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )5304;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5322;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO Bevoelkerungsdichte SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into Bevoelkerungsdichte select *  from tmp_t\
bl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )5340;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5354;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5368;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Mindestumsteigezeit...");
		Debug(2, "Kopiere Tabelle Mindestumsteigezeit...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, HaltestellenID NUMBER NOT NULL, 
						LinieA NUMBER NOT NULL, LinieB NUMBER NOT NULL, Umsteigezeit NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID, HaltestellenID)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , H\
altestellenID NUMBER NOT NULL , LinieA NUMBER NOT NULL , LinieB NUMBER NOT NUL\
L , Umsteigezeit NUMBER NOT NULL , PRIMARY KEY ( SpeicherID , HaltestellenID )\
 )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5382;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM Mindestumsteigezeit WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from Mindestumsteigeze\
it where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )5396;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5414;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO Mindestumsteigezeit SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into Mindestumsteigezeit select *  from tmp_t\
bl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )5432;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5446;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5460;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Mindesthaltezeit...");
		Debug(2, "Kopiere Tabelle Mindesthaltezeit...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, HaltestellenID NUMBER NOT NULL, 
						Haltezeit NUMBER NOT NULL, PRIMARY KEY (SpeicherID, HaltestellenID)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , H\
altestellenID NUMBER NOT NULL , Haltezeit NUMBER NOT NULL , PRIMARY KEY ( Spei\
cherID , HaltestellenID ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5474;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM Mindesthaltezeit WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from Mindesthaltezeit \
where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )5488;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5506;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO Mindesthaltezeit SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into Mindesthaltezeit select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )5524;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5538;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5552;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Pflichthaltestellen...");
		Debug(2, "Kopiere Tabelle Pflichthaltestellen...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, XKoordinate NUMBER NOT NULL, 
						YKoordinate NUMBER NOT NULL, PRIMARY KEY (SpeicherID, XKoordinate)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , X\
Koordinate NUMBER NOT NULL , YKoordinate NUMBER NOT NULL , PRIMARY KEY ( Speic\
herID , XKoordinate ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5566;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM Pflichthaltestellen WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from Pflichthaltestell\
en where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )5580;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5598;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO Pflichthaltestellen SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into Pflichthaltestellen select *  from tmp_t\
bl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )5616;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5630;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5644;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Ausschnitt...");
		Debug(2, "Kopiere Tabelle Ausschnitt...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, Links NUMBER NOT NULL, Oben NUMBER NOT NULL, 
						Rechts NUMBER NOT NULL, Unten NUMBER NOT NULL, PRIMARY KEY (SpeicherID, Links)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , L\
inks NUMBER NOT NULL , Oben NUMBER NOT NULL , Rechts NUMBER NOT NULL , Unten N\
UMBER NOT NULL , PRIMARY KEY ( SpeicherID , Links ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5658;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM Ausschnitt WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from Ausschnitt where \
SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )5672;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5690;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO Ausschnitt SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into Ausschnitt select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )5708;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5722;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5736;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Guetemasse...");
		Debug(2, "Kopiere Tabelle Guetemasse...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, HSAnzahlHaltestellen NUMBER NOT NULL, 
						HSBevUeberVersorgung NUMBER NOT NULL, HSBevUnterVersorgung NUMBER NOT NULL, 
						HSFlUeberVersorgung NUMBER NOT NULL, HSFlUnterVersorgung NUMBER NOT NULL, 
						HSBevVersorgungProzent NUMBER NOT NULL, HSFlVersorgungProzent NUMBER NOT NULL, 
						HSFussweg NUMBER NOT NULL, HSDirekteReisezeitAuto NUMBER NOT NULL, 
						LPAnzahlUmstiege NUMBER NOT NULL, LPVerbindungenUmstiegszwang NUMBER NOT NULL, 
						LPGesamtfahrer NUMBER NOT NULL, LPDirektfahrer NUMBER NOT NULL, 
						LPMittlereReisezeit NUMBER NOT NULL, LPDirektfahreranteil NUMBER NOT NULL, 
						LPStreckenkilometer NUMBER NOT NULL, LPGesamteStreckenkilometer NUMBER NOT NULL, 
						LPMittlereMindestreisezeit NUMBER NOT NULL, LPReisezeitverlaengerung NUMBER NOT NULL, 
						LPAnzahlLinien NUMBER NOT NULL, LPMittlererVerknuepfungsgrad NUMBER NOT NULL, 
						FPAnzahlBusse NUMBER NOT NULL, FPNetzbedingteWartezeit NUMBER NOT NULL, 
						FPWartezeitAufwandGesamt NUMBER NOT NULL, FPMindestwartezeitAufwand NUMBER NOT NULL, 
						FPGesamtzeitAufwand NUMBER NOT NULL, FPFahrplanwirkungsgrad NUMBER NOT NULL, 
						GBDurchschnittAnzahlBusse NUMBER NOT NULL, GBMittlereReisezeit NUMBER NOT NULL, 
						GBAnzahlPersonen NUMBER NOT NULL, GBReisezeitZuDirektfahrer NUMBER NOT NULL, 
						GBMindestreisezeitZuDirekt NUMBER NOT NULL, LPProzentVerbkeineDir NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID, HSAnzahlHaltestellen)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlbuft((void **)0, 
    "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , HSAnzahlHalte\
stellen NUMBER NOT NULL , HSBevUeberVersorgung NUMBER NOT NULL , HSBevUnterV\
ersorgung NUMBER NOT NULL , HSFlUeberVersorgung NUMBER NOT NULL , HSFlUnterV\
ersorgung NUMBER NOT NULL , HSBevVersorgungProzent NUMBER NOT NULL , HSFlVer\
sorgungProzent NUMBER NOT NULL , HSFussweg NUMBER NOT NULL , HSDirekteReisez\
eitAuto NUMBER NOT NULL , LPAnzahlUmstiege NUMBER NOT NULL , LPVerbindungenU\
mstiegszwang NUMBER NOT NULL , LPGesamtfahrer NUMBER NOT NULL , LPDirektfahr\
er NUMBER NOT NULL , LPMittlereReisezeit NUMBER NOT NULL , LPDirektfahrerant\
eil NUMBER NOT NULL , LPStreckenkilometer NUMBER NOT NULL , LPGesamteStrecke\
nkilometer NUMBER NOT NULL , LPMittlereMindestreisezeit NUMBER NOT NULL , LP\
Reisezeitverlaengerung NUMBER NOT NULL , LPAnzahlLinien NUMBER NOT NULL , LP\
MittlererVerknuepfungsgrad NUMBER NOT NULL , FPAnzahlBusse NUMBER NOT NULL ,\
 FPNetzbedingteWartezeit NUMBER NOT NULL , FPWartezeitAufwandGesamt NUMBER N\
OT NULL , FPMindestwartezeitAufwand NUMBE");
  sqlstm.stmt = "R NOT NULL , FPGesamtzeitAufwand NUMBER NOT NULL , FPFahrpl\
anwirkungsgrad NUMBER NOT NULL , GBDurchschnittAnzahlBusse NUMBER NOT NULL , G\
BMittlereReisezeit NUMBER NOT NULL , GBAnzahlPersonen NUMBER NOT NULL , GBReis\
ezeitZuDirektfahrer NUMBER NOT NULL , GBMindestreisezeitZuDirekt NUMBER NOT NU\
LL , LPProzentVerbkeineDir NUMBER NOT NULL , PRIMARY KEY ( SpeicherID , HSAnza\
hlHaltestellen ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5750;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM Guetemasse WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from Guetemasse where \
SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )5764;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5782;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO Guetemasse SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into Guetemasse select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )5800;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5814;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5828;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle GuetemasseReisezeitAuto...");
		Debug(2, "Kopiere Tabelle GuetemasseReisezeitAuto...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, HaltestelleA NUMBER NOT NULL, 
						HaltestelleB NUMBER NOT NULL, Reisezeit NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID, HaltestelleA, HaltestelleB)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , H\
altestelleA NUMBER NOT NULL , HaltestelleB NUMBER NOT NULL , Reisezeit NUMBER \
NOT NULL , PRIMARY KEY ( SpeicherID , HaltestelleA , HaltestelleB ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5842;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM GuetemassReisezeitAuto WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from GuetemassReisezei\
tAuto where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )5856;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5874;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO GuetemassReisezeitAuto SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into GuetemassReisezeitAuto select *  from tm\
p_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )5892;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5906;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5920;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Pflichtlinien...");
		Debug(2, "Kopiere Tabelle Pflichtlinien...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, LinienID NUMBER NOT NULL, LfNr NUMBER NOT NULL,
						 HaltestellenID NUMBER NOT NULL, PRIMARY KEY (SpeicherID, LinienID, LfNr)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , L\
inienID NUMBER NOT NULL , LfNr NUMBER NOT NULL , HaltestellenID NUMBER NOT NUL\
L , PRIMARY KEY ( SpeicherID , LinienID , LfNr ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5934;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM Pflichtlinien WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from Pflichtlinien whe\
re SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )5948;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5966;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO Pflichtlinien SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into Pflichtlinien select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )5984;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5998;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6012;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjekt");
}


		

	if(fortschritt!=0) delete fortschritt;
	return ziel_id;
}
//------------------------------------------------------------------------------
// Funktionsname:	kopierenProjektVonPG369
// Beschreibung:	kopiert das Projekt mit der ID "quellid" des Datenaustausch-Users in das Projekt mit der ID "zielid", liefert die ID des Zielprojektes zuerueck
// Parameter:		die ID des Quellprojekts und die ID des Zielprojektes
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
int CDBSchnittstelle::kopierenProjektVonPG369(int quellid, int zielid, char* beschreibung=0) 
{
	if(beschreibung==0) { Debug(2, "kopierenProjektVonPG369 (1): Die Beschreibung des Projektes ist NULL"); }
	else { Debug(2, "kopierenProjektVonPG369 (1): Die Beschreibung des Projektes lautet: |"<<beschreibung<<"|"); }

	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in kopierenProjektVonPG369"); */ 

    
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	typedef struct	
	{
 		int id;
		/* VARCHAR Bezeichnung[30]; */ 
struct { unsigned short len; unsigned char arr[30]; } Bezeichnung;

		int Zustand;
	} projektelement;
	projektelement element;
	int quell_id=quellid;
	int ziel_id=zielid;
	/* EXEC SQL END DECLARE SECTION; */ 
	
	
	CFortschritt* fortschritt=0;
	if(batchbetrieb==false) 
	{
		try{fortschritt=new CFortschritt("Projekt aus Datenaustauschpool uebernehmen");}
		catch(...)
		{	
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Fortschrittsanzeige beim Kopieren eines Projektes aus dem Datenaustauschpool konnte nicht angelegt werden. Speichermangel?"<<endl;
			cerr.flush();
		}
	}
	if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Pruefe, ob ID bereits vergeben...");	

	// Testen ,ob ID schon vergeben:	
	// sollte ID bereits vergeben sein, nimm die naechste ID und teste wieder, usw...
	do{
		element.id=-1;
		// erzeuge die Cursor, mit dem Daten durchlaufen werden:
		/* EXEC SQL DECLARE projekt_test_id_kopieren_cursor_pg369 CURSOR FOR
			SELECT id, Bezeichnung, Zustand
				FROM Speicherstand
				WHERE id = :ziel_id; */ 

        
	
		// jetzt den Cursor oeffnen
		/* EXEC SQL OPEN projekt_test_id_kopieren_cursor_pg369; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = sq0333;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6026;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


        	
	        // und jetzt in Schleife alle Dinger holen:
		/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

		for(;;)
		{
			/* EXEC SQL FETCH projekt_test_id_kopieren_cursor_pg369 INTO :element; */ 

{
   struct sqlexd sqlstm;

   sqlorat((void **)0, &sqlctx, &oraca);
   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 7;
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )6044;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlstm.sqhstv[0] = (unsigned char  *)&element.id;
   sqlstm.sqhstl[0] = (unsigned int  )4;
   sqlstm.sqindv[0] = (         short *)0;
   sqlstm.sqharm[0] = (unsigned int  )0;
   sqlstm.sqhstv[1] = (unsigned char  *)&element.Bezeichnung;
   sqlstm.sqhstl[1] = (unsigned int  )32;
   sqlstm.sqindv[1] = (         short *)0;
   sqlstm.sqharm[1] = (unsigned int  )0;
   sqlstm.sqhstv[2] = (unsigned char  *)&element.Zustand;
   sqlstm.sqhstl[2] = (unsigned int  )4;
   sqlstm.sqindv[2] = (         short *)0;
   sqlstm.sqharm[2] = (unsigned int  )0;
   sqlstm.sqphsv = sqlstm.sqhstv;
   sqlstm.sqphsl = sqlstm.sqhstl;
   sqlstm.sqpind = sqlstm.sqindv;
   sqlstm.sqparm = sqlstm.sqharm;
   sqlstm.sqparc = sqlstm.sqharc;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
   if (sqlca.sqlcode == 1403) break;
   if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


			ziel_id++; // hier ziel_id um eins erhoehen => nimm naechste moegliche ID
		}
        	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

		// und nach getaner arbeit Cursor wieder schliessen:
		/* EXEC SQL CLOSE projekt_test_id_kopieren_cursor_pg369; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6070;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		
	}while(element.id!=-1);
	// hier steht jetzt in ziel_id, genau die id, die unser neues Projekt erhalten darf.
        
	// vor dem Kopieren, legen wir also das neue Projekt erstmal an:
	if(beschreibung==0) { Debug(2, "kopierenProjektVonPG369 (2): Die Beschreibung des Projektes ist NULL"); }
	else { Debug(2, "kopierenProjektVonPG369 (2): Die Beschreibung des Projektes lautet: |"<<beschreibung<<"|"); }

	/* EXEC SQL SELECT id, Bezeichnung, Zustand INTO :element FROM pg369.Speicherstand WHERE id = :quell_id; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "select id ,Bezeichnung ,Zustand into :s1 ,:s2 ,:s3   from pg\
369.Speicherstand where id=:b1";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )6084;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&element.id;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqhstv[1] = (unsigned char  *)&element.Bezeichnung;
 sqlstm.sqhstl[1] = (unsigned int  )32;
 sqlstm.sqindv[1] = (         short *)0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqhstv[2] = (unsigned char  *)&element.Zustand;
 sqlstm.sqhstl[2] = (unsigned int  )4;
 sqlstm.sqindv[2] = (         short *)0;
 sqlstm.sqharm[2] = (unsigned int  )0;
 sqlstm.sqhstv[3] = (unsigned char  *)&quell_id;
 sqlstm.sqhstl[3] = (unsigned int  )4;
 sqlstm.sqindv[3] = (         short *)0;
 sqlstm.sqharm[3] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


	anlegenNeuesProjekt(ziel_id, beschreibung, element.Zustand);

	if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Projekt...");	


		const int anzahl_tabellen=30;
		int aktuelle_tabelle=1;
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
                if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Knoten...");
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2), HaltestellenID NUMBER NOT NULL, Name VARCHAR2(30) NULL, XKoordinate NUMBER NOT NULL, YKoordinate NUMBER NOT NULL, Prioritaet NUMBER(2) NOT NULL, Pflicht NUMBER(1) NOT NULL, PRIMARY KEY (SpeicherID,HaltestellenID)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) , Haltestell\
enID NUMBER NOT NULL , Name VARCHAR2 ( 30 ) NULL , XKoordinate NUMBER NOT NULL\
 , YKoordinate NUMBER NOT NULL , Prioritaet NUMBER ( 2 ) NOT NULL , Pflicht NU\
MBER ( 1 ) NOT NULL , PRIMARY KEY ( SpeicherID , HaltestellenID ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6114;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// temporaere Tabelle anlegen:
	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM pg369.Knoten WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from pg369.Knoten wher\
e SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )6128;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6146;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO Knoten SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into Knoten select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )6164;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6178;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6192;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle KnotenWerte...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, HaltestellenID NUMBER NOT NULL, 
						UmsteigezeitMinuten NUMBER NOT NULL, MindesthaltezeitMinuten NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID,HaltestellenID)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , H\
altestellenID NUMBER NOT NULL , UmsteigezeitMinuten NUMBER NOT NULL , Mindesth\
altezeitMinuten NUMBER NOT NULL , PRIMARY KEY ( SpeicherID , HaltestellenID ) \
)";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6206;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM pg369.KnotenWerte  WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from pg369.KnotenWerte\
 where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )6220;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6238;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO KnotenWerte SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into KnotenWerte select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )6256;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6270;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6284;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle KantenStrasse...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, StrassenID NUMBER NOT NULL, LfdNr NUMBER NOT NULL, 
						XKoordinaten NUMBER NOT NULL, YKoordinaten NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID,StrassenID,LfdNr)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , S\
trassenID NUMBER NOT NULL , LfdNr NUMBER NOT NULL , XKoordinaten NUMBER NOT NU\
LL , YKoordinaten NUMBER NOT NULL , PRIMARY KEY ( SpeicherID , StrassenID , Lf\
dNr ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6298;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}

	        
		/* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM  pg369.KantenStrassen WHERE SpeicherID = :quell_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "insert into tmp_tbl select *  from pg369.KantenStrassen whe\
re SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6312;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6330;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO KantenStrassen SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into KantenStrassen select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )6348;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6362;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6376;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Kanten...");
		Debug(2, "Kopiere Tabelle Kanten...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, KantenID NUMBER NOT NULL, 
						StartHaltestelle NUMBER NOT NULL, EndHaltestelle NUMBER NOT NULL, 
						ReisezeitMinuten NUMBER(2) NOT NULL, Laenge NUMBER NOT NULL, ReiseFluss NUMBER NULL, 
						StrassenID NUMBER NOT NULL, PRIMARY KEY (SpeicherID,KantenID)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , K\
antenID NUMBER NOT NULL , StartHaltestelle NUMBER NOT NULL , EndHaltestelle NU\
MBER NOT NULL , ReisezeitMinuten NUMBER ( 2 ) NOT NULL , Laenge NUMBER NOT NUL\
L , ReiseFluss NUMBER NULL , StrassenID NUMBER NOT NULL , PRIMARY KEY ( Speich\
erID , KantenID ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6390;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM  pg369.Kanten WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from pg369.Kanten wher\
e SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )6404;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6422;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO Kanten SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into Kanten select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )6440;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6454;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6468;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle LinienPlan...");
		Debug(2, "Kopiere Tabelle LinienPlan...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, PlanID NUMBER NOT NULL, Beschreibung VARCHAR2(70) NULL, 
						LinienID NUMBER NOT NULL, PRIMARY KEY (SpeicherID,PlanID,LinienID)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , P\
lanID NUMBER NOT NULL , Beschreibung VARCHAR2 ( 70 ) NULL , LinienID NUMBER NO\
T NULL , PRIMARY KEY ( SpeicherID , PlanID , LinienID ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6482;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM  pg369.LinienPlan WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from pg369.LinienPlan \
where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )6496;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6514;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO LinienPlan SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into LinienPlan select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )6532;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6546;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6560;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}



         	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle LinienWeg...");
		Debug(2, "Kopiere Tabelle LinienWeg...");
	        // temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, PlanID NUMBER NOT NULL, LinienID NUMBER NOT NULL, 
						LfdNr NUMBER NOT NULL, HaltestellenID NUMBER NOT NULL, PRIMARY KEY (SpeicherID,LinienID,LfdNr)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , P\
lanID NUMBER NOT NULL , LinienID NUMBER NOT NULL , LfdNr NUMBER NOT NULL , Hal\
testellenID NUMBER NOT NULL , PRIMARY KEY ( SpeicherID , LinienID , LfdNr ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6574;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM pg369.LinienWeg WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from pg369.LinienWeg w\
here SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )6588;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6606;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO LinienWeg SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into LinienWeg select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )6624;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6638;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6652;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


	
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle LinienWerte...");
		Debug(2, "Kopiere Tabelle LinienWerte...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, LfdNr NUMBER NOT NULL, PlanID NUMBER NOT NULL, 
						LinienID NUMBER NOT NULL, VonHaltestelle NUMBER NOT NULL, 
						NachHaltestelle NUMBER NOT NULL, Reisezeit NUMBER NOT NULL, 
						Verkehrsstrom NUMBER NOT NULL, PRIMARY KEY (SpeicherID,PlanID,LinienID,LfdNr)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , L\
fdNr NUMBER NOT NULL , PlanID NUMBER NOT NULL , LinienID NUMBER NOT NULL , Von\
Haltestelle NUMBER NOT NULL , NachHaltestelle NUMBER NOT NULL , Reisezeit NUMB\
ER NOT NULL , Verkehrsstrom NUMBER NOT NULL , PRIMARY KEY ( SpeicherID , PlanI\
D , LinienID , LfdNr ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6666;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM pg369.LinienWerte WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from pg369.LinienWerte\
 where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )6680;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6698;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO LinienWerte SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into LinienWerte select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )6716;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6730;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6744;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Anschluss...");
		Debug(2, "Kopiere Tabelle Anschluss...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, LinieVon NUMBER NOT NULL, LinieNach NUMBER NOT NULL, 
						Haltestelle NUMBER NOT NULL, PRIMARY KEY (SpeicherID,LinieVon,LinieNach,Haltestelle)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , L\
inieVon NUMBER NOT NULL , LinieNach NUMBER NOT NULL , Haltestelle NUMBER NOT N\
ULL , PRIMARY KEY ( SpeicherID , LinieVon , LinieNach , Haltestelle ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6758;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM pg369.Anschluss WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from pg369.Anschluss w\
here SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )6772;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6790;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO Anschluss SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into Anschluss select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )6808;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6822;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6836;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Fahrplan...");
		Debug(2, "Kopiere Tabelle Fahrplan...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, HaltestellenID NUMBER NOT NULL, 
						LinienID NUMBER NOT NULL, AbfahrtszeitStd NUMBER(2) NOT NULL, 
						AbfahrtszeitMin NUMBER(2) NOT NULL, PRIMARY KEY(SpeicherID,HaltestellenID,LinienID)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , H\
altestellenID NUMBER NOT NULL , LinienID NUMBER NOT NULL , AbfahrtszeitStd NUM\
BER ( 2 ) NOT NULL , AbfahrtszeitMin NUMBER ( 2 ) NOT NULL , PRIMARY KEY ( Spe\
icherID , HaltestellenID , LinienID ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6850;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM pg369.Fahrplan WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from pg369.Fahrplan wh\
ere SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )6864;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6882;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO Fahrplan SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into Fahrplan select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )6900;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6914;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6928;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle QuelleZielMatrix...");
		Debug(2, "Kopiere Tabelle QuelleZielMatrix...");
         	// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, VonHaltestelle NUMBER NOT NULL, 
						NachHaltestelle NUMBER NOT NULL, Reiseaufkommen NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID,VonHaltestelle,NachHaltestelle)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , V\
onHaltestelle NUMBER NOT NULL , NachHaltestelle NUMBER NOT NULL , Reiseaufkomm\
en NUMBER NOT NULL , PRIMARY KEY ( SpeicherID , VonHaltestelle , NachHaltestel\
le ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6942;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM  pg369.QuelleZielMatrix WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from pg369.QuelleZielM\
atrix where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )6956;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )6974;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO QuelleZielMatrix SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into QuelleZielMatrix select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )6992;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7006;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7020;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle QuelleZielListe...");
		Debug(2, "Kopiere Tabelle QuelleZielListe...");
	        // temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, xKoordinate NUMBER NOT NULL, 
						yKoordinate NUMBER NOT NULL, ElementID NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID,xKoordinate,yKoordinate)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , x\
Koordinate NUMBER NOT NULL , yKoordinate NUMBER NOT NULL , ElementID NUMBER NO\
T NULL , PRIMARY KEY ( SpeicherID , xKoordinate , yKoordinate ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7034;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM pg369.QuelleZielListe WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from pg369.QuelleZielL\
iste where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )7048;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7066;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO QuelleZielListe SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into QuelleZielListe select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )7084;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7098;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7112;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle UrsprungsQZMatrix...");
		Debug(2, "Kopiere Tabelle UrsprungsQZMatrix...");
         	// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, VonHaltestelle NUMBER NOT NULL, 
						NachHaltestelle NUMBER NOT NULL, Reiseaufkommen NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID,VonHaltestelle,NachHaltestelle)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , V\
onHaltestelle NUMBER NOT NULL , NachHaltestelle NUMBER NOT NULL , Reiseaufkomm\
en NUMBER NOT NULL , PRIMARY KEY ( SpeicherID , VonHaltestelle , NachHaltestel\
le ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7126;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM  pg369.UrsprungsQZMatrix WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from pg369.UrsprungsQZ\
Matrix where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )7140;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7158;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO UrsprungsQZMatrix SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into UrsprungsQZMatrix select *  from tmp_tbl\
 ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )7176;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7190;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7204;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle UrsprungsQZListe...");
		Debug(2, "Kopiere Tabelle UrsprungsQZListe...");
	        // temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, xKoordinate NUMBER NOT NULL, 
						yKoordinate NUMBER NOT NULL, ElementID NUMBER NOT NULL, PRIMARY KEY (SpeicherID,xKoordinate,yKoordinate)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , x\
Koordinate NUMBER NOT NULL , yKoordinate NUMBER NOT NULL , ElementID NUMBER NO\
T NULL , PRIMARY KEY ( SpeicherID , xKoordinate , yKoordinate ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7218;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM pg369.UrsprungsQZListe WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from pg369.UrsprungsQZ\
Liste where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )7232;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7250;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO UrsprungsQZListe SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into UrsprungsQZListe select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )7268;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7282;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7296;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Pendlermatrix...");
		Debug(2, "Kopiere Tabelle Pendlermatrix...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, StadtteilVon NUMBER NOT NULL, 
						StadtteilNach NUMBER NOT NULL, Dichte NUMBER NOT NULL, PRIMARY KEY (SpeicherID,StadtteilVon,StadtteilNach)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , S\
tadtteilVon NUMBER NOT NULL , StadtteilNach NUMBER NOT NULL , Dichte NUMBER NO\
T NULL , PRIMARY KEY ( SpeicherID , StadtteilVon , StadtteilNach ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7310;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM pg369.Pendlermatrix WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from pg369.Pendlermatr\
ix where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )7324;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7342;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO Pendlermatrix SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into Pendlermatrix select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )7360;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7374;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7388;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Pendlerliste...");
		Debug(2, "Kopiere Tabelle Pendlerliste...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, xKoordinate NUMBER NOT NULL, 
						yKoordinate NUMBER NOT NULL, ElementID NUMBER NOT NULL, Radius NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID,xKoordinate,yKoordinate)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , x\
Koordinate NUMBER NOT NULL , yKoordinate NUMBER NOT NULL , ElementID NUMBER NO\
T NULL , Radius NUMBER NOT NULL , PRIMARY KEY ( SpeicherID , xKoordinate , yKo\
ordinate ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7402;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM pg369.Pendlerliste WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from pg369.Pendlerlist\
e where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )7416;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7434;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO Pendlerliste SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into Pendlerliste select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )7452;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7466;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7480;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Zusammenhangskomponenten...");
		Debug(2, "Kopiere Tabelle Zusammenhangskomponenten...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, KomponentenID NUMBER NOT NULL, 
						LfdNummer NUMBER NOT NULL, HaltestellenIDVon NUMBER NOT NULL, 
						HaltestellenIDNach NUMBER NOT NULL, LinienID NUMBER NOT NULL, 
						PRIMARY KEY(SpeicherID,KomponentenID,LfdNummer)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , K\
omponentenID NUMBER NOT NULL , LfdNummer NUMBER NOT NULL , HaltestellenIDVon N\
UMBER NOT NULL , HaltestellenIDNach NUMBER NOT NULL , LinienID NUMBER NOT NULL\
 , PRIMARY KEY ( SpeicherID , KomponentenID , LfdNummer ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7494;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM pg369.Zusammenhangskomponente WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from pg369.Zusammenhan\
gskomponente where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )7508;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7526;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO Zusammenhangskomponente SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into Zusammenhangskomponente select *  from t\
mp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )7544;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7558;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7572;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Ausgangsloesung...");
		Debug(2, "Kopiere Tabelle Ausgangsloesung...");
                // temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, LoesungsID NUMBER NOT NULL, 
						Beschreibung VARCHAR2(70) NULL, WartezeitaufwandMin NUMBER NOT NULL, 
						MindestwartezeitMin NUMBER NOT NULL, GesamtwartezeitMin NUMBER NOT NULL, 
						AnzahlBusse NUMBER, PRIMARY KEY (SpeicherID,LoesungsID)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , L\
oesungsID NUMBER NOT NULL , Beschreibung VARCHAR2 ( 70 ) NULL , Wartezeitaufwa\
ndMin NUMBER NOT NULL , MindestwartezeitMin NUMBER NOT NULL , GesamtwartezeitM\
in NUMBER NOT NULL , AnzahlBusse NUMBER , PRIMARY KEY ( SpeicherID , LoesungsI\
D ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7586;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM pg369.Ausgangsloesung WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from pg369.Ausgangsloe\
sung where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )7600;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7618;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO Ausgangsloesung SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into Ausgangsloesung select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )7636;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7650;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7664;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle AusgangsloesungHaltestelle...");
		Debug(2, "Kopiere Tabelle AusgangsloesungHaltestelle...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, LoesungsID NUMBER NOT NULL, 
						Haltestelle NUMBER NOT NULL, NetzbedingteWartezeit NUMBER(2) NOT NULL, 
						Wartezeitaufwand NUMBER(2) NOT NULL, PRIMARY KEY (SpeicherID,LoesungsID,Haltestelle)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , L\
oesungsID NUMBER NOT NULL , Haltestelle NUMBER NOT NULL , NetzbedingteWartezei\
t NUMBER ( 2 ) NOT NULL , Wartezeitaufwand NUMBER ( 2 ) NOT NULL , PRIMARY KEY\
 ( SpeicherID , LoesungsID , Haltestelle ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7678;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM pg369.AusgangsloesungHaltestelle WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from pg369.Ausgangsloe\
sungHaltestelle where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )7692;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7710;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO AusgangsloesungHaltestelle SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into AusgangsloesungHaltestelle select *  fro\
m tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )7728;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7742;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7756;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle LinienplanBewertung...");
		Debug(2, "Kopiere Tabelle LinienplanBewertung...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, LinienplanID NUMBER NOT NULL, 
						MittlereReisezeit NUMBER NOT NULL, Direktfahreranteil NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID,LinienplanID)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , L\
inienplanID NUMBER NOT NULL , MittlereReisezeit NUMBER NOT NULL , Direktfahrer\
anteil NUMBER NOT NULL , PRIMARY KEY ( SpeicherID , LinienplanID ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7770;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM pg369.LinienplanBewertung WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from pg369.LinienplanB\
ewertung where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )7784;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7802;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO LinienplanBewertung SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into LinienplanBewertung select *  from tmp_t\
bl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )7820;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7834;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7848;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


	
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle HaltestellenModulParameter...");
		Debug(2, "Kopiere Tabelle HaltestellenModulParameter...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, Aufruf NUMBER NOT NULL, Algorithmus NUMBER NOT NULL,
						ZufiInitialisierung NUMBER NOT NULL, MinRadius NUMBER NOT NULL, MaxRadius NUMBER NOT NULL,
						VerbindungsRadiusStadt NUMBER NOT NULL, VerbindungsRadiusLand NUMBER NOT NULL,
						Radiustyp NUMBER NOT NULL, HaltestellenLage NUMBER NOT NULL, Toleranzgrenze NUMBER NOT NULL,
						BevoelkerungsRaster NUMBER NOT NULL, Bevoelkerungsueberversorgung NUMBER NOT NULL,
						Bevoelkerungsunterversorgung NUMBER NOT NULL, Flaechenueberversorgung NUMBER NOT NULL,
						Flaechenunterversorgung NUMBER NOT NULL, Fahrtwunscheinbeziehung NUMBER NOT NULL,
						Strassenanpassung NUMBER NOT NULL, AnzahlHaltestellen NUMBER NOT NULL,
						AnzStrassenkarte NUMBER NOT NULL, AnzBevoelkerungsversorgung NUMBER NOT NULL,
						AnzFlaechenversorgung NUMBER NOT NULL, Anzkomplettunterdruecken NUMBER NOT NULL,
						Strategie NUMBER NOT NULL, AnzahlEltern NUMBER NOT NULL, AnzahlKinder NUMBER NOT NULL,
						Generationen NUMBER NOT NULL, AbbruchGueteunterschreitung NUMBER NOT NULL,
						GrenzwGueteunterschreitung NUMBER NOT NULL, PRIMARY KEY (SpeicherID,Aufruf)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlbuft((void **)0, 
    "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , Aufruf NUMBER\
 NOT NULL , Algorithmus NUMBER NOT NULL , ZufiInitialisierung NUMBER NOT NUL\
L , MinRadius NUMBER NOT NULL , MaxRadius NUMBER NOT NULL , VerbindungsRadiu\
sStadt NUMBER NOT NULL , VerbindungsRadiusLand NUMBER NOT NULL , Radiustyp N\
UMBER NOT NULL , HaltestellenLage NUMBER NOT NULL , Toleranzgrenze NUMBER NO\
T NULL , BevoelkerungsRaster NUMBER NOT NULL , Bevoelkerungsueberversorgung \
NUMBER NOT NULL , Bevoelkerungsunterversorgung NUMBER NOT NULL , Flaechenueb\
erversorgung NUMBER NOT NULL , Flaechenunterversorgung NUMBER NOT NULL , Fah\
rtwunscheinbeziehung NUMBER NOT NULL , Strassenanpassung NUMBER NOT NULL , A\
nzahlHaltestellen NUMBER NOT NULL , AnzStrassenkarte NUMBER NOT NULL , AnzBe\
voelkerungsversorgung NUMBER NOT NULL , AnzFlaechenversorgung NUMBER NOT NUL\
L , Anzkomplettunterdruecken NUMBER NOT NULL , Strategie NUMBER NOT NULL , A\
nzahlEltern NUMBER NOT NULL , AnzahlKinder NUMBER NOT NULL , Generationen NU\
MBER NOT NULL , AbbruchGueteunterschreitu");
  sqlstm.stmt = "ng NUMBER NOT NULL , GrenzwGueteunterschreitung NUMBER NOT \
NULL , PRIMARY KEY ( SpeicherID , Aufruf ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7862;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM pg369.HaltestellenModulParameter WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from pg369.Haltestelle\
nModulParameter where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )7876;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7894;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO HaltestellenModulParameter SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into HaltestellenModulParameter select *  fro\
m tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )7912;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7926;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7940;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);		
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle LinienplanModulParameter...");
		Debug(2, "Kopiere Tabelle LinienplanModulParameter...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, Aufruf NUMBER NOT NULL, Gesamtlaenge NUMBER NOT NULL, 
						MaxLinienLaenge NUMBER NOT NULL, MaxLinienAnzahl NUMBER NOT NULL, 
						LinienplanID NUMBER NOT NULL, Geschwindigkeit NUMBER, Algorithmus NUMBER, 
						AnzeigeBerechnung NUMBER, EindeutigeLinienverkn NUMBER NOT NULL, 
						MehrdeutigeLinienverkn NUMBER NOT NULL, Aufbruchsverknuepfung NUMBER NOT NULL, 
						Linienendverknuepfung NUMBER NOT NULL, Basislinienwahl NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID,Aufruf)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , A\
ufruf NUMBER NOT NULL , Gesamtlaenge NUMBER NOT NULL , MaxLinienLaenge NUMBER \
NOT NULL , MaxLinienAnzahl NUMBER NOT NULL , LinienplanID NUMBER NOT NULL , Ge\
schwindigkeit NUMBER , Algorithmus NUMBER , AnzeigeBerechnung NUMBER , Eindeut\
igeLinienverkn NUMBER NOT NULL , MehrdeutigeLinienverkn NUMBER NOT NULL , Aufb\
ruchsverknuepfung NUMBER NOT NULL , Linienendverknuepfung NUMBER NOT NULL , Ba\
sislinienwahl NUMBER NOT NULL , PRIMARY KEY ( SpeicherID , Aufruf ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7954;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM pg369.LinienplanModulParameter WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from pg369.LinienplanM\
odulParameter where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )7968;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )7986;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO LinienplanModulParameter SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into LinienplanModulParameter select *  from \
tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )8004;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8018;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8032;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle FahrplanModulParameter...");
		Debug(2, "Kopiere Tabelle FahrplanModulParameter...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, Aufruf NUMBER NOT NULL, 
						MaxFahrzeuganzahl NUMBER NOT NULL, AllgemeinerTakt NUMBER(2) NOT NULL, 
						Mindesthaltezeit NUMBER NOT NULL, Mindestumsteigezeit NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID,Aufruf)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , A\
ufruf NUMBER NOT NULL , MaxFahrzeuganzahl NUMBER NOT NULL , AllgemeinerTakt NU\
MBER ( 2 ) NOT NULL , Mindesthaltezeit NUMBER NOT NULL , Mindestumsteigezeit N\
UMBER NOT NULL , PRIMARY KEY ( SpeicherID , Aufruf ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8046;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM pg369.FahrplanModulParameter WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from pg369.FahrplanMod\
ulParameter where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )8060;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8078;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO FahrplanModulParameter SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into FahrplanModulParameter select *  from tm\
p_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )8096;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8110;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8124;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Bevoelkerungsdichte...");
		Debug(2, "Kopiere Tabelle Bevoelkerungsdichte...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, XKoordinate NUMBER NOT NULL, 
						YKoordinate NUMBER NOT NULL, Radius NUMBER NOT NULL, Dichte NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID, XKoordinate,YKoordinate)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , X\
Koordinate NUMBER NOT NULL , YKoordinate NUMBER NOT NULL , Radius NUMBER NOT N\
ULL , Dichte NUMBER NOT NULL , PRIMARY KEY ( SpeicherID , XKoordinate , YKoord\
inate ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8138;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM pg369.Bevoelkerungsdichte WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from pg369.Bevoelkerun\
gsdichte where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )8152;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8170;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO Bevoelkerungsdichte SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into Bevoelkerungsdichte select *  from tmp_t\
bl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )8188;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8202;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8216;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Mindestumsteigezeit...");
		Debug(2, "Kopiere Tabelle Mindestumsteigezeit...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, HaltestellenID NUMBER NOT NULL, 
						LinieA NUMBER NOT NULL, LinieB NUMBER NOT NULL, Umsteigezeit NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID, HaltestellenID)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , H\
altestellenID NUMBER NOT NULL , LinieA NUMBER NOT NULL , LinieB NUMBER NOT NUL\
L , Umsteigezeit NUMBER NOT NULL , PRIMARY KEY ( SpeicherID , HaltestellenID )\
 )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8230;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM pg369.Mindestumsteigezeit WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from pg369.Mindestumst\
eigezeit where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )8244;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8262;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO Mindestumsteigezeit SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into Mindestumsteigezeit select *  from tmp_t\
bl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )8280;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8294;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8308;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Mindesthaltezeit...");
		Debug(2, "Kopiere Tabelle Mindesthaltezeit...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, HaltestellenID NUMBER NOT NULL, 
						Haltezeit NUMBER NOT NULL, PRIMARY KEY (SpeicherID, HaltestellenID)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , H\
altestellenID NUMBER NOT NULL , Haltezeit NUMBER NOT NULL , PRIMARY KEY ( Spei\
cherID , HaltestellenID ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8322;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM pg369.Mindesthaltezeit WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from pg369.Mindesthalt\
ezeit where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )8336;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8354;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO Mindesthaltezeit SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into Mindesthaltezeit select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )8372;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8386;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8400;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Pflichthaltestellen...");
		Debug(2, "Kopiere Tabelle Pflichthaltestellen...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, XKoordinate NUMBER NOT NULL, 
						YKoordinate NUMBER NOT NULL, PRIMARY KEY (SpeicherID, XKoordinate)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , X\
Koordinate NUMBER NOT NULL , YKoordinate NUMBER NOT NULL , PRIMARY KEY ( Speic\
herID , XKoordinate ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8414;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM pg369.Pflichthaltestellen WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from pg369.Pflichthalt\
estellen where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )8428;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8446;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO Pflichthaltestellen SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into Pflichthaltestellen select *  from tmp_t\
bl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )8464;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8478;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8492;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Ausschnitt...");
		Debug(2, "Kopiere Tabelle Ausschnitt...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, Links NUMBER NOT NULL, Oben NUMBER NOT NULL, 
						Rechts NUMBER NOT NULL, Unten NUMBER NOT NULL, PRIMARY KEY (SpeicherID, Links)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , L\
inks NUMBER NOT NULL , Oben NUMBER NOT NULL , Rechts NUMBER NOT NULL , Unten N\
UMBER NOT NULL , PRIMARY KEY ( SpeicherID , Links ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8506;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM pg369.Ausschnitt WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from pg369.Ausschnitt \
where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )8520;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8538;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO Ausschnitt SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into Ausschnitt select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )8556;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8570;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8584;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Guetemasse...");
		Debug(2, "Kopiere Tabelle Guetemasse...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, HSAnzahlHaltestellen NUMBER NOT NULL, 
						HSBevUeberVersorgung NUMBER NOT NULL, HSBevUnterVersorgung NUMBER NOT NULL, 
						HSFlUeberVersorgung NUMBER NOT NULL, HSFlUnterVersorgung NUMBER NOT NULL, 
						HSBevVersorgungProzent NUMBER NOT NULL, HSFlVersorgungProzent NUMBER NOT NULL, 
						HSFussweg NUMBER NOT NULL, HSDirekteReisezeitAuto NUMBER NOT NULL, 
						LPAnzahlUmstiege NUMBER NOT NULL, LPVerbindungenUmstiegszwang NUMBER NOT NULL, 
						LPGesamtfahrer NUMBER NOT NULL, LPDirektfahrer NUMBER NOT NULL, 
						LPMittlereReisezeit NUMBER NOT NULL, LPDirektfahreranteil NUMBER NOT NULL, 
						LPStreckenkilometer NUMBER NOT NULL, LPGesamteStreckenkilometer NUMBER NOT NULL, 
						LPMittlereMindestreisezeit NUMBER NOT NULL, LPReisezeitverlaengerung NUMBER NOT NULL, 
						LPAnzahlLinien NUMBER NOT NULL, LPMittlererVerknuepfungsgrad NUMBER NOT NULL, 
						FPAnzahlBusse NUMBER NOT NULL, FPNetzbedingteWartezeit NUMBER NOT NULL, 
						FPWartezeitAufwandGesamt NUMBER NOT NULL, FPMindestwartezeitAufwand NUMBER NOT NULL, 
						FPGesamtzeitAufwand NUMBER NOT NULL, FPFahrplanwirkungsgrad NUMBER NOT NULL, 
						GBDurchschnittAnzahlBusse NUMBER NOT NULL, GBMittlereReisezeit NUMBER NOT NULL, 
						GBAnzahlPersonen NUMBER NOT NULL, GBReisezeitZuDirektfahrer NUMBER NOT NULL, 
						GBMindestreisezeitZuDirekt NUMBER NOT NULL, LPProzentVerbkeineDir NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID, HSAnzahlHaltestellen)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlbuft((void **)0, 
    "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , HSAnzahlHalte\
stellen NUMBER NOT NULL , HSBevUeberVersorgung NUMBER NOT NULL , HSBevUnterV\
ersorgung NUMBER NOT NULL , HSFlUeberVersorgung NUMBER NOT NULL , HSFlUnterV\
ersorgung NUMBER NOT NULL , HSBevVersorgungProzent NUMBER NOT NULL , HSFlVer\
sorgungProzent NUMBER NOT NULL , HSFussweg NUMBER NOT NULL , HSDirekteReisez\
eitAuto NUMBER NOT NULL , LPAnzahlUmstiege NUMBER NOT NULL , LPVerbindungenU\
mstiegszwang NUMBER NOT NULL , LPGesamtfahrer NUMBER NOT NULL , LPDirektfahr\
er NUMBER NOT NULL , LPMittlereReisezeit NUMBER NOT NULL , LPDirektfahrerant\
eil NUMBER NOT NULL , LPStreckenkilometer NUMBER NOT NULL , LPGesamteStrecke\
nkilometer NUMBER NOT NULL , LPMittlereMindestreisezeit NUMBER NOT NULL , LP\
Reisezeitverlaengerung NUMBER NOT NULL , LPAnzahlLinien NUMBER NOT NULL , LP\
MittlererVerknuepfungsgrad NUMBER NOT NULL , FPAnzahlBusse NUMBER NOT NULL ,\
 FPNetzbedingteWartezeit NUMBER NOT NULL , FPWartezeitAufwandGesamt NUMBER N\
OT NULL , FPMindestwartezeitAufwand NUMBE");
  sqlstm.stmt = "R NOT NULL , FPGesamtzeitAufwand NUMBER NOT NULL , FPFahrpl\
anwirkungsgrad NUMBER NOT NULL , GBDurchschnittAnzahlBusse NUMBER NOT NULL , G\
BMittlereReisezeit NUMBER NOT NULL , GBAnzahlPersonen NUMBER NOT NULL , GBReis\
ezeitZuDirektfahrer NUMBER NOT NULL , GBMindestreisezeitZuDirekt NUMBER NOT NU\
LL , LPProzentVerbkeineDir NUMBER NOT NULL , PRIMARY KEY ( SpeicherID , HSAnza\
hlHaltestellen ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8598;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM pg369.Guetemasse WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from pg369.Guetemasse \
where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )8612;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8630;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO Guetemasse SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into Guetemasse select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )8648;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8662;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8676;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle GuetemasseReisezeitAuto...");
		Debug(2, "Kopiere Tabelle GuetemasseReisezeitAuto...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, HaltestelleA NUMBER NOT NULL, 
						HaltestelleB NUMBER NOT NULL, Reisezeit NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID, HaltestelleA, HaltestelleB)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , H\
altestelleA NUMBER NOT NULL , HaltestelleB NUMBER NOT NULL , Reisezeit NUMBER \
NOT NULL , PRIMARY KEY ( SpeicherID , HaltestelleA , HaltestelleB ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8690;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM pg369.GuetemassReisezeitAuto WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from pg369.GuetemassRe\
isezeitAuto where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )8704;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8722;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO GuetemassReisezeitAuto SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into GuetemassReisezeitAuto select *  from tm\
p_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )8740;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8754;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8768;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Pflichtlinien...");
		Debug(2, "Kopiere Tabelle Pflichtlinien...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, LinienID NUMBER NOT NULL, LfNr NUMBER NOT NULL,
						 HaltestellenID NUMBER NOT NULL, PRIMARY KEY (SpeicherID, LinienID, LfNr)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , L\
inienID NUMBER NOT NULL , LfNr NUMBER NOT NULL , HaltestellenID NUMBER NOT NUL\
L , PRIMARY KEY ( SpeicherID , LinienID , LfNr ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8782;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM pg369.Pflichtlinien WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from pg369.Pflichtlini\
en where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )8796;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8814;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO Pflichtlinien SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into Pflichtlinien select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )8832;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8846;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8860;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektVonPG369");
}


		

	if(fortschritt!=0) delete fortschritt;
	return ziel_id;
}
//------------------------------------------------------------------------------
// Funktionsname:	kopierenProjektNachPG369
// Beschreibung:	kopiert das Projekt mit der ID "quellid"  in das Projekt mit der ID "zielid" des Datenaustausch-Users, liefert die ID des Zielprojektes zuerueck
// Parameter:		die ID des Quellprojekts und die ID des Zielprojektes
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
int CDBSchnittstelle::kopierenProjektNachPG369(int quellid, int zielid, char* beschreibung=0) 
{
	if(beschreibung==0) { Debug(2, "kopierenProjektNachPG369 (1): Die Beschreibung des Projektes ist NULL"); }
	else { Debug(2, "kopierenProjektNachPG369 (1): Die Beschreibung des Projektes lautet: |"<<beschreibung<<"|"); }

	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in kopierenProjektNachPG369"); */ 

    
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	typedef struct	
	{
 		int id;
//		VARCHAR Bezeichnung[30];
//		int Zustand;
	} projektelement;
	projektelement element;
	int quell_id=quellid;
	int ziel_id=zielid;
	int zustand=0;
	/* EXEC SQL END DECLARE SECTION; */ 
	
	
	Debug(2, "ZielID des Users vor dem ermitteln: "<<ziel_id);

	CFortschritt* fortschritt=0;
	if(batchbetrieb==false) 
	{
		try{fortschritt=new CFortschritt("Projekt in Datenaustauschpool kopieren");}
		catch(...)
		{
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Fortschrittsanzeige beim Kopieren eines Projektes in den Datenaustauschpool konnte nicht angelegt werden. Speichermangel?"<<endl;
			cerr.flush();
		}
	}
	if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Pruefe, ob ID bereits vergeben...");	

	// Testen ,ob ID schon vergeben:	
	// sollte ID bereits vergeben sein, nimm die naechste ID und teste wieder, usw...
	do{
		element.id=-1;
		// erzeuge die Cursor, mit dem Daten durchlaufen werden:
		/* EXEC SQL DECLARE projekt_pg369_kopieren_cursor CURSOR FOR
			SELECT id//, Bezeichnung , Zustand
				FROM pg369.Speicherstand
				WHERE id = :ziel_id; */ 

        
	
		// jetzt den Cursor oeffnen
		/* EXEC SQL OPEN projekt_pg369_kopieren_cursor; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = sq0515;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8874;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


        	
	        // und jetzt in Schleife alle Dinger holen:
		/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

		for(;;)
		{
			/* EXEC SQL FETCH projekt_pg369_kopieren_cursor INTO :element; */ 

{
   struct sqlexd sqlstm;

   sqlorat((void **)0, &sqlctx, &oraca);
   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 7;
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )8892;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlstm.sqhstv[0] = (unsigned char  *)&element.id;
   sqlstm.sqhstl[0] = (unsigned int  )4;
   sqlstm.sqindv[0] = (         short *)0;
   sqlstm.sqharm[0] = (unsigned int  )0;
   sqlstm.sqphsv = sqlstm.sqhstv;
   sqlstm.sqphsl = sqlstm.sqhstl;
   sqlstm.sqpind = sqlstm.sqindv;
   sqlstm.sqparm = sqlstm.sqharm;
   sqlstm.sqparc = sqlstm.sqharc;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
   if (sqlca.sqlcode == 1403) break;
   if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


			ziel_id++; // hier ziel_id um eins erhoehen => nimm naechste moegliche ID
		}
        	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

		// und nach getaner arbeit Cursor wieder schliessen:
		/* EXEC SQL CLOSE projekt_pg369_kopieren_cursor; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8910;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		
	}while(element.id!=-1);
	// hier steht jetzt in ziel_id, genau die id, die unser neues Projekt erhalten darf.
	
	Debug(2, "ZielID des Users vor anlegenNeuesProjekt: "<<ziel_id);

        if(beschreibung==0) { Debug(2, "kopierenProjektNachPG369 (2): Die Beschreibung des Projektes ist NULL"); }
	else { Debug(2, "kopierenProjektNachPG369 (2): Die Beschreibung des Projektes lautet: |"<<beschreibung<<"|"); }

	// vor dem Kopieren, legen wir also das neue Projekt erstmal an:
	/* EXEC SQL SELECT Zustand INTO :zustand FROM Speicherstand WHERE id = :quell_id; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "select Zustand into :b0  from Speicherstand where id=:b1";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )8924;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&zustand;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqhstv[1] = (unsigned char  *)&quell_id;
 sqlstm.sqhstl[1] = (unsigned int  )4;
 sqlstm.sqindv[1] = (         short *)0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


	anlegenNeuesProjektPG369(ziel_id, beschreibung, zustand);
        
	if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Projekt...");	
        Debug(2, "ZielID des Users: "<<zielid<<" ZielID von Oracle: "<<ziel_id);

		const int anzahl_tabellen=30;
		int aktuelle_tabelle=1;
		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
                if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Knoten...");
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2), HaltestellenID NUMBER NOT NULL, Name VARCHAR2(30) NULL, XKoordinate NUMBER NOT NULL, YKoordinate NUMBER NOT NULL, Prioritaet NUMBER(2) NOT NULL, Pflicht NUMBER(1) NOT NULL, PRIMARY KEY (SpeicherID,HaltestellenID)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) , Haltestell\
enID NUMBER NOT NULL , Name VARCHAR2 ( 30 ) NULL , XKoordinate NUMBER NOT NULL\
 , YKoordinate NUMBER NOT NULL , Prioritaet NUMBER ( 2 ) NOT NULL , Pflicht NU\
MBER ( 1 ) NOT NULL , PRIMARY KEY ( SpeicherID , HaltestellenID ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8946;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// temporaere Tabelle anlegen:
	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM Knoten WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from Knoten where Spei\
cherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )8960;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )8978;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO  pg369.Knoten SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into pg369.Knoten select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )8996;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9010;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9024;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle KnotenWerte...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, HaltestellenID NUMBER NOT NULL, 
						UmsteigezeitMinuten NUMBER NOT NULL, MindesthaltezeitMinuten NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID,HaltestellenID)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , H\
altestellenID NUMBER NOT NULL , UmsteigezeitMinuten NUMBER NOT NULL , Mindesth\
altezeitMinuten NUMBER NOT NULL , PRIMARY KEY ( SpeicherID , HaltestellenID ) \
)";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9038;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM KnotenWerte  WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from KnotenWerte where\
 SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )9052;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9070;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO pg369.KnotenWerte SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into pg369.KnotenWerte select *  from tmp_tbl\
 ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )9088;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9102;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9116;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle KantenStrasse...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, StrassenID NUMBER NOT NULL, LfdNr NUMBER NOT NULL, 
						XKoordinaten NUMBER NOT NULL, YKoordinaten NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID,StrassenID,LfdNr)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , S\
trassenID NUMBER NOT NULL , LfdNr NUMBER NOT NULL , XKoordinaten NUMBER NOT NU\
LL , YKoordinaten NUMBER NOT NULL , PRIMARY KEY ( SpeicherID , StrassenID , Lf\
dNr ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9130;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}

	        
		/* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM  KantenStrassen WHERE SpeicherID = :quell_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "insert into tmp_tbl select *  from KantenStrassen where Spe\
icherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9144;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9162;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO pg369.KantenStrassen SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into pg369.KantenStrassen select *  from tmp_\
tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )9180;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9194;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9208;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Kanten...");
		Debug(2, "Kopiere Tabelle Kanten...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, KantenID NUMBER NOT NULL, 
						StartHaltestelle NUMBER NOT NULL, EndHaltestelle NUMBER NOT NULL, 
						ReisezeitMinuten NUMBER(2) NOT NULL, Laenge NUMBER NOT NULL, ReiseFluss NUMBER NULL, 
						StrassenID NUMBER NOT NULL, PRIMARY KEY (SpeicherID,KantenID)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , K\
antenID NUMBER NOT NULL , StartHaltestelle NUMBER NOT NULL , EndHaltestelle NU\
MBER NOT NULL , ReisezeitMinuten NUMBER ( 2 ) NOT NULL , Laenge NUMBER NOT NUL\
L , ReiseFluss NUMBER NULL , StrassenID NUMBER NOT NULL , PRIMARY KEY ( Speich\
erID , KantenID ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9222;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM  Kanten WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from Kanten where Spei\
cherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )9236;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9254;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO pg369.Kanten SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into pg369.Kanten select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )9272;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9286;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9300;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle LinienPlan...");
		Debug(2, "Kopiere Tabelle LinienPlan...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, PlanID NUMBER NOT NULL, Beschreibung VARCHAR2(70) NULL, 
						LinienID NUMBER NOT NULL, PRIMARY KEY (SpeicherID,PlanID,LinienID)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , P\
lanID NUMBER NOT NULL , Beschreibung VARCHAR2 ( 70 ) NULL , LinienID NUMBER NO\
T NULL , PRIMARY KEY ( SpeicherID , PlanID , LinienID ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9314;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM  LinienPlan WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from LinienPlan where \
SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )9328;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9346;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO pg369.LinienPlan SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into pg369.LinienPlan select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )9364;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9378;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9392;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}



         	if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle LinienWeg...");
		Debug(2, "Kopiere Tabelle LinienWeg...");
	        // temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, PlanID NUMBER NOT NULL, LinienID NUMBER NOT NULL, 
						LfdNr NUMBER NOT NULL, HaltestellenID NUMBER NOT NULL, PRIMARY KEY (SpeicherID,LinienID,LfdNr)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , P\
lanID NUMBER NOT NULL , LinienID NUMBER NOT NULL , LfdNr NUMBER NOT NULL , Hal\
testellenID NUMBER NOT NULL , PRIMARY KEY ( SpeicherID , LinienID , LfdNr ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9406;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM LinienWeg WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from LinienWeg where S\
peicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )9420;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9438;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO pg369.LinienWeg SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into pg369.LinienWeg select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )9456;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9470;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9484;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


	
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle LinienWerte...");
		Debug(2, "Kopiere Tabelle LinienWerte...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, LfdNr NUMBER NOT NULL, PlanID NUMBER NOT NULL, 
						LinienID NUMBER NOT NULL, VonHaltestelle NUMBER NOT NULL, 
						NachHaltestelle NUMBER NOT NULL, Reisezeit NUMBER NOT NULL, 
						Verkehrsstrom NUMBER NOT NULL, PRIMARY KEY (SpeicherID,PlanID,LinienID,LfdNr)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , L\
fdNr NUMBER NOT NULL , PlanID NUMBER NOT NULL , LinienID NUMBER NOT NULL , Von\
Haltestelle NUMBER NOT NULL , NachHaltestelle NUMBER NOT NULL , Reisezeit NUMB\
ER NOT NULL , Verkehrsstrom NUMBER NOT NULL , PRIMARY KEY ( SpeicherID , PlanI\
D , LinienID , LfdNr ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9498;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM LinienWerte WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from LinienWerte where\
 SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )9512;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9530;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO pg369.LinienWerte SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into pg369.LinienWerte select *  from tmp_tbl\
 ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )9548;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9562;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9576;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Anschluss...");
		Debug(2, "Kopiere Tabelle Anschluss...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, LinieVon NUMBER NOT NULL, LinieNach NUMBER NOT NULL, 
						Haltestelle NUMBER NOT NULL, PRIMARY KEY (SpeicherID,LinieVon,LinieNach,Haltestelle)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , L\
inieVon NUMBER NOT NULL , LinieNach NUMBER NOT NULL , Haltestelle NUMBER NOT N\
ULL , PRIMARY KEY ( SpeicherID , LinieVon , LinieNach , Haltestelle ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9590;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM Anschluss WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from Anschluss where S\
peicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )9604;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9622;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO pg369.Anschluss SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into pg369.Anschluss select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )9640;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9654;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9668;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Fahrplan...");
		Debug(2, "Kopiere Tabelle Fahrplan...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, HaltestellenID NUMBER NOT NULL, 
						LinienID NUMBER NOT NULL, AbfahrtszeitStd NUMBER(2) NOT NULL, 
						AbfahrtszeitMin NUMBER(2) NOT NULL, PRIMARY KEY(SpeicherID,HaltestellenID,LinienID)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , H\
altestellenID NUMBER NOT NULL , LinienID NUMBER NOT NULL , AbfahrtszeitStd NUM\
BER ( 2 ) NOT NULL , AbfahrtszeitMin NUMBER ( 2 ) NOT NULL , PRIMARY KEY ( Spe\
icherID , HaltestellenID , LinienID ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9682;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM Fahrplan WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from Fahrplan where Sp\
eicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )9696;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9714;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO pg369.Fahrplan SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into pg369.Fahrplan select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )9732;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9746;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9760;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle QuelleZielMatrix...");
		Debug(2, "Kopiere Tabelle QuelleZielMatrix...");
         	// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, VonHaltestelle NUMBER NOT NULL, 
						NachHaltestelle NUMBER NOT NULL, Reiseaufkommen NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID,VonHaltestelle,NachHaltestelle)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , V\
onHaltestelle NUMBER NOT NULL , NachHaltestelle NUMBER NOT NULL , Reiseaufkomm\
en NUMBER NOT NULL , PRIMARY KEY ( SpeicherID , VonHaltestelle , NachHaltestel\
le ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9774;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM  QuelleZielMatrix WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from QuelleZielMatrix \
where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )9788;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9806;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO pg369.QuelleZielMatrix SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into pg369.QuelleZielMatrix select *  from tm\
p_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )9824;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9838;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9852;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle QuelleZielListe...");
		Debug(2, "Kopiere Tabelle QuelleZielListe...");
	        // temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, xKoordinate NUMBER NOT NULL, 
						yKoordinate NUMBER NOT NULL, ElementID NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID,xKoordinate,yKoordinate)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , x\
Koordinate NUMBER NOT NULL , yKoordinate NUMBER NOT NULL , ElementID NUMBER NO\
T NULL , PRIMARY KEY ( SpeicherID , xKoordinate , yKoordinate ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9866;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM QuelleZielListe WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from QuelleZielListe w\
here SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )9880;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9898;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO pg369.QuelleZielListe SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into pg369.QuelleZielListe select *  from tmp\
_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )9916;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9930;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9944;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle UrsprungsQZMatrix...");
		Debug(2, "Kopiere Tabelle UrsprungsQZMatrix...");
         	// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, VonHaltestelle NUMBER NOT NULL, 
						NachHaltestelle NUMBER NOT NULL, Reiseaufkommen NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID,VonHaltestelle,NachHaltestelle)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , V\
onHaltestelle NUMBER NOT NULL , NachHaltestelle NUMBER NOT NULL , Reiseaufkomm\
en NUMBER NOT NULL , PRIMARY KEY ( SpeicherID , VonHaltestelle , NachHaltestel\
le ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9958;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM  UrsprungsQZMatrix WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from UrsprungsQZMatrix\
 where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )9972;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )9990;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO pg369.UrsprungsQZMatrix SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into pg369.UrsprungsQZMatrix select *  from t\
mp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )10008;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10022;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10036;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle UrsprungsQZListe...");
		Debug(2, "Kopiere Tabelle UrsprungsQZListe...");
	        // temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, xKoordinate NUMBER NOT NULL, 
						yKoordinate NUMBER NOT NULL, ElementID NUMBER NOT NULL, PRIMARY KEY (SpeicherID,xKoordinate,yKoordinate)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , x\
Koordinate NUMBER NOT NULL , yKoordinate NUMBER NOT NULL , ElementID NUMBER NO\
T NULL , PRIMARY KEY ( SpeicherID , xKoordinate , yKoordinate ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10050;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM UrsprungsQZListe WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from UrsprungsQZListe \
where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )10064;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10082;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO pg369.UrsprungsQZListe SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into pg369.UrsprungsQZListe select *  from tm\
p_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )10100;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10114;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10128;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Pendlermatrix...");
		Debug(2, "Kopiere Tabelle Pendlermatrix...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, StadtteilVon NUMBER NOT NULL, 
						StadtteilNach NUMBER NOT NULL, Dichte NUMBER NOT NULL, PRIMARY KEY (SpeicherID,StadtteilVon,StadtteilNach)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , S\
tadtteilVon NUMBER NOT NULL , StadtteilNach NUMBER NOT NULL , Dichte NUMBER NO\
T NULL , PRIMARY KEY ( SpeicherID , StadtteilVon , StadtteilNach ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10142;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM Pendlermatrix WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from Pendlermatrix whe\
re SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )10156;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10174;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO pg369.Pendlermatrix SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into pg369.Pendlermatrix select *  from tmp_t\
bl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )10192;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10206;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10220;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Pendlerliste...");
		Debug(2, "Kopiere Tabelle Pendlerliste...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, xKoordinate NUMBER NOT NULL, 
						yKoordinate NUMBER NOT NULL, ElementID NUMBER NOT NULL, Radius NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID,xKoordinate,yKoordinate)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , x\
Koordinate NUMBER NOT NULL , yKoordinate NUMBER NOT NULL , ElementID NUMBER NO\
T NULL , Radius NUMBER NOT NULL , PRIMARY KEY ( SpeicherID , xKoordinate , yKo\
ordinate ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10234;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM Pendlerliste WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from Pendlerliste wher\
e SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )10248;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10266;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO pg369.Pendlerliste SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into pg369.Pendlerliste select *  from tmp_tb\
l ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )10284;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10298;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10312;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Zusammenhangskomponenten...");
		Debug(2, "Kopiere Tabelle Zusammenhangskomponenten...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, KomponentenID NUMBER NOT NULL, 
						LfdNummer NUMBER NOT NULL, HaltestellenIDVon NUMBER NOT NULL, 
						HaltestellenIDNach NUMBER NOT NULL, LinienID NUMBER NOT NULL, 
						PRIMARY KEY(SpeicherID,KomponentenID,LfdNummer)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , K\
omponentenID NUMBER NOT NULL , LfdNummer NUMBER NOT NULL , HaltestellenIDVon N\
UMBER NOT NULL , HaltestellenIDNach NUMBER NOT NULL , LinienID NUMBER NOT NULL\
 , PRIMARY KEY ( SpeicherID , KomponentenID , LfdNummer ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10326;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM Zusammenhangskomponente WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from Zusammenhangskomp\
onente where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )10340;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10358;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO pg369.Zusammenhangskomponente SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into pg369.Zusammenhangskomponente select *  \
from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )10376;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10390;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10404;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Ausgangsloesung...");
		Debug(2, "Kopiere Tabelle Ausgangsloesung...");
                // temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, LoesungsID NUMBER NOT NULL, 
						Beschreibung VARCHAR2(70) NULL, WartezeitaufwandMin NUMBER NOT NULL, 
						MindestwartezeitMin NUMBER NOT NULL, GesamtwartezeitMin NUMBER NOT NULL, 
						AnzahlBusse NUMBER, PRIMARY KEY (SpeicherID,LoesungsID)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , L\
oesungsID NUMBER NOT NULL , Beschreibung VARCHAR2 ( 70 ) NULL , Wartezeitaufwa\
ndMin NUMBER NOT NULL , MindestwartezeitMin NUMBER NOT NULL , GesamtwartezeitM\
in NUMBER NOT NULL , AnzahlBusse NUMBER , PRIMARY KEY ( SpeicherID , LoesungsI\
D ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10418;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM Ausgangsloesung WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from Ausgangsloesung w\
here SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )10432;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10450;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO pg369.Ausgangsloesung SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into pg369.Ausgangsloesung select *  from tmp\
_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )10468;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10482;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10496;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle AusgangsloesungHaltestelle...");
		Debug(2, "Kopiere Tabelle AusgangsloesungHaltestelle...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, LoesungsID NUMBER NOT NULL, 
						Haltestelle NUMBER NOT NULL, NetzbedingteWartezeit NUMBER(2) NOT NULL, 
						Wartezeitaufwand NUMBER(2) NOT NULL, PRIMARY KEY (SpeicherID,LoesungsID,Haltestelle)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , L\
oesungsID NUMBER NOT NULL , Haltestelle NUMBER NOT NULL , NetzbedingteWartezei\
t NUMBER ( 2 ) NOT NULL , Wartezeitaufwand NUMBER ( 2 ) NOT NULL , PRIMARY KEY\
 ( SpeicherID , LoesungsID , Haltestelle ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10510;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM AusgangsloesungHaltestelle WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from AusgangsloesungHa\
ltestelle where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )10524;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10542;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO pg369.AusgangsloesungHaltestelle SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into pg369.AusgangsloesungHaltestelle select \
*  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )10560;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10574;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10588;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle LinienplanBewertung...");
		Debug(2, "Kopiere Tabelle LinienplanBewertung...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, LinienplanID NUMBER NOT NULL, 
						MittlereReisezeit NUMBER NOT NULL, Direktfahreranteil NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID,LinienplanID)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , L\
inienplanID NUMBER NOT NULL , MittlereReisezeit NUMBER NOT NULL , Direktfahrer\
anteil NUMBER NOT NULL , PRIMARY KEY ( SpeicherID , LinienplanID ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10602;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM LinienplanBewertung WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from LinienplanBewertu\
ng where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )10616;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10634;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO pg369.LinienplanBewertung SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into pg369.LinienplanBewertung select *  from\
 tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )10652;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10666;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10680;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


	
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle HaltestellenModulParameter...");
		Debug(2, "Kopiere Tabelle HaltestellenModulParameter...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, Aufruf NUMBER NOT NULL, Algorithmus NUMBER NOT NULL,
						ZufiInitialisierung NUMBER NOT NULL, MinRadius NUMBER NOT NULL, MaxRadius NUMBER NOT NULL,
						VerbindungsRadiusStadt NUMBER NOT NULL, VerbindungsRadiusLand NUMBER NOT NULL,
						Radiustyp NUMBER NOT NULL, HaltestellenLage NUMBER NOT NULL, Toleranzgrenze NUMBER NOT NULL,
						BevoelkerungsRaster NUMBER NOT NULL, Bevoelkerungsueberversorgung NUMBER NOT NULL,
						Bevoelkerungsunterversorgung NUMBER NOT NULL, Flaechenueberversorgung NUMBER NOT NULL,
						Flaechenunterversorgung NUMBER NOT NULL, Fahrtwunscheinbeziehung NUMBER NOT NULL,
						Strassenanpassung NUMBER NOT NULL, AnzahlHaltestellen NUMBER NOT NULL,
						AnzStrassenkarte NUMBER NOT NULL, AnzBevoelkerungsversorgung NUMBER NOT NULL,
						AnzFlaechenversorgung NUMBER NOT NULL, Anzkomplettunterdruecken NUMBER NOT NULL,
						Strategie NUMBER NOT NULL, AnzahlEltern NUMBER NOT NULL, AnzahlKinder NUMBER NOT NULL,
						Generationen NUMBER NOT NULL, AbbruchGueteunterschreitung NUMBER NOT NULL,
						GrenzwGueteunterschreitung NUMBER NOT NULL, PRIMARY KEY (SpeicherID,Aufruf)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlbuft((void **)0, 
    "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , Aufruf NUMBER\
 NOT NULL , Algorithmus NUMBER NOT NULL , ZufiInitialisierung NUMBER NOT NUL\
L , MinRadius NUMBER NOT NULL , MaxRadius NUMBER NOT NULL , VerbindungsRadiu\
sStadt NUMBER NOT NULL , VerbindungsRadiusLand NUMBER NOT NULL , Radiustyp N\
UMBER NOT NULL , HaltestellenLage NUMBER NOT NULL , Toleranzgrenze NUMBER NO\
T NULL , BevoelkerungsRaster NUMBER NOT NULL , Bevoelkerungsueberversorgung \
NUMBER NOT NULL , Bevoelkerungsunterversorgung NUMBER NOT NULL , Flaechenueb\
erversorgung NUMBER NOT NULL , Flaechenunterversorgung NUMBER NOT NULL , Fah\
rtwunscheinbeziehung NUMBER NOT NULL , Strassenanpassung NUMBER NOT NULL , A\
nzahlHaltestellen NUMBER NOT NULL , AnzStrassenkarte NUMBER NOT NULL , AnzBe\
voelkerungsversorgung NUMBER NOT NULL , AnzFlaechenversorgung NUMBER NOT NUL\
L , Anzkomplettunterdruecken NUMBER NOT NULL , Strategie NUMBER NOT NULL , A\
nzahlEltern NUMBER NOT NULL , AnzahlKinder NUMBER NOT NULL , Generationen NU\
MBER NOT NULL , AbbruchGueteunterschreitu");
  sqlstm.stmt = "ng NUMBER NOT NULL , GrenzwGueteunterschreitung NUMBER NOT \
NULL , PRIMARY KEY ( SpeicherID , Aufruf ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10694;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM HaltestellenModulParameter WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from HaltestellenModul\
Parameter where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )10708;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10726;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO pg369.HaltestellenModulParameter SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into pg369.HaltestellenModulParameter select \
*  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )10744;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10758;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10772;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);		
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle LinienplanModulParameter...");
		Debug(2, "Kopiere Tabelle LinienplanModulParameter...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, Aufruf NUMBER NOT NULL, Gesamtlaenge NUMBER NOT NULL, 
						MaxLinienLaenge NUMBER NOT NULL, MaxLinienAnzahl NUMBER NOT NULL, 
						LinienplanID NUMBER NOT NULL, Geschwindigkeit NUMBER, Algorithmus NUMBER, 
						AnzeigeBerechnung NUMBER, EindeutigeLinienverkn NUMBER NOT NULL, 
						MehrdeutigeLinienverkn NUMBER NOT NULL, Aufbruchsverknuepfung NUMBER NOT NULL, 
						Linienendverknuepfung NUMBER NOT NULL, Basislinienwahl NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID,Aufruf)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , A\
ufruf NUMBER NOT NULL , Gesamtlaenge NUMBER NOT NULL , MaxLinienLaenge NUMBER \
NOT NULL , MaxLinienAnzahl NUMBER NOT NULL , LinienplanID NUMBER NOT NULL , Ge\
schwindigkeit NUMBER , Algorithmus NUMBER , AnzeigeBerechnung NUMBER , Eindeut\
igeLinienverkn NUMBER NOT NULL , MehrdeutigeLinienverkn NUMBER NOT NULL , Aufb\
ruchsverknuepfung NUMBER NOT NULL , Linienendverknuepfung NUMBER NOT NULL , Ba\
sislinienwahl NUMBER NOT NULL , PRIMARY KEY ( SpeicherID , Aufruf ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10786;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM LinienplanModulParameter WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from LinienplanModulPa\
rameter where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )10800;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10818;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO pg369.LinienplanModulParameter SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into pg369.LinienplanModulParameter select * \
 from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )10836;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10850;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10864;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle FahrplanModulParameter...");
		Debug(2, "Kopiere Tabelle FahrplanModulParameter...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, Aufruf NUMBER NOT NULL, 
						MaxFahrzeuganzahl NUMBER NOT NULL, AllgemeinerTakt NUMBER(2) NOT NULL, 
						Mindesthaltezeit NUMBER NOT NULL, Mindestumsteigezeit NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID,Aufruf)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , A\
ufruf NUMBER NOT NULL , MaxFahrzeuganzahl NUMBER NOT NULL , AllgemeinerTakt NU\
MBER ( 2 ) NOT NULL , Mindesthaltezeit NUMBER NOT NULL , Mindestumsteigezeit N\
UMBER NOT NULL , PRIMARY KEY ( SpeicherID , Aufruf ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10878;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM FahrplanModulParameter WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from FahrplanModulPara\
meter where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )10892;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10910;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO pg369.FahrplanModulParameter SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into pg369.FahrplanModulParameter select *  f\
rom tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )10928;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10942;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10956;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Bevoelkerungsdichte...");
		Debug(2, "Kopiere Tabelle Bevoelkerungsdichte...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, XKoordinate NUMBER NOT NULL, 
						YKoordinate NUMBER NOT NULL, Radius NUMBER NOT NULL, Dichte NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID, XKoordinate,YKoordinate)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , X\
Koordinate NUMBER NOT NULL , YKoordinate NUMBER NOT NULL , Radius NUMBER NOT N\
ULL , Dichte NUMBER NOT NULL , PRIMARY KEY ( SpeicherID , XKoordinate , YKoord\
inate ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )10970;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM Bevoelkerungsdichte WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from Bevoelkerungsdich\
te where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )10984;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )11002;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO pg369.Bevoelkerungsdichte SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into pg369.Bevoelkerungsdichte select *  from\
 tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )11020;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )11034;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )11048;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}




		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Mindestumsteigezeit...");
		Debug(2, "Kopiere Tabelle Mindestumsteigezeit...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, HaltestellenID NUMBER NOT NULL, 
						LinieA NUMBER NOT NULL, LinieB NUMBER NOT NULL, Umsteigezeit NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID, HaltestellenID)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , H\
altestellenID NUMBER NOT NULL , LinieA NUMBER NOT NULL , LinieB NUMBER NOT NUL\
L , Umsteigezeit NUMBER NOT NULL , PRIMARY KEY ( SpeicherID , HaltestellenID )\
 )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )11062;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM Mindestumsteigezeit WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from Mindestumsteigeze\
it where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )11076;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )11094;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO pg369.Mindestumsteigezeit SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into pg369.Mindestumsteigezeit select *  from\
 tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )11112;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )11126;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )11140;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Mindesthaltezeit...");
		Debug(2, "Kopiere Tabelle Mindesthaltezeit...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, HaltestellenID NUMBER NOT NULL, 
						Haltezeit NUMBER NOT NULL, PRIMARY KEY (SpeicherID, HaltestellenID)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , H\
altestellenID NUMBER NOT NULL , Haltezeit NUMBER NOT NULL , PRIMARY KEY ( Spei\
cherID , HaltestellenID ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )11154;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM Mindesthaltezeit WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from Mindesthaltezeit \
where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )11168;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )11186;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO pg369.Mindesthaltezeit SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into pg369.Mindesthaltezeit select *  from tm\
p_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )11204;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )11218;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )11232;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Pflichthaltestellen...");
		Debug(2, "Kopiere Tabelle Pflichthaltestellen...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, XKoordinate NUMBER NOT NULL, 
						YKoordinate NUMBER NOT NULL, PRIMARY KEY (SpeicherID, XKoordinate)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , X\
Koordinate NUMBER NOT NULL , YKoordinate NUMBER NOT NULL , PRIMARY KEY ( Speic\
herID , XKoordinate ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )11246;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM Pflichthaltestellen WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from Pflichthaltestell\
en where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )11260;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )11278;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO pg369.Pflichthaltestellen SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into pg369.Pflichthaltestellen select *  from\
 tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )11296;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )11310;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )11324;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Ausschnitt...");
		Debug(2, "Kopiere Tabelle Ausschnitt...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, Links NUMBER NOT NULL, Oben NUMBER NOT NULL, 
						Rechts NUMBER NOT NULL, Unten NUMBER NOT NULL, PRIMARY KEY (SpeicherID, Links)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , L\
inks NUMBER NOT NULL , Oben NUMBER NOT NULL , Rechts NUMBER NOT NULL , Unten N\
UMBER NOT NULL , PRIMARY KEY ( SpeicherID , Links ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )11338;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM Ausschnitt WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from Ausschnitt where \
SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )11352;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )11370;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO pg369.Ausschnitt SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into pg369.Ausschnitt select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )11388;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )11402;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )11416;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Guetemasse...");
		Debug(2, "Kopiere Tabelle Guetemasse...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, HSAnzahlHaltestellen NUMBER NOT NULL, 
						HSBevUeberVersorgung NUMBER NOT NULL, HSBevUnterVersorgung NUMBER NOT NULL, 
						HSFlUeberVersorgung NUMBER NOT NULL, HSFlUnterVersorgung NUMBER NOT NULL, 
						HSBevVersorgungProzent NUMBER NOT NULL, HSFlVersorgungProzent NUMBER NOT NULL, 
						HSFussweg NUMBER NOT NULL, HSDirekteReisezeitAuto NUMBER NOT NULL, 
						LPAnzahlUmstiege NUMBER NOT NULL, LPVerbindungenUmstiegszwang NUMBER NOT NULL, 
						LPGesamtfahrer NUMBER NOT NULL, LPDirektfahrer NUMBER NOT NULL, 
						LPMittlereReisezeit NUMBER NOT NULL, LPDirektfahreranteil NUMBER NOT NULL, 
						LPStreckenkilometer NUMBER NOT NULL, LPGesamteStreckenkilometer NUMBER NOT NULL, 
						LPMittlereMindestreisezeit NUMBER NOT NULL, LPReisezeitverlaengerung NUMBER NOT NULL, 
						LPAnzahlLinien NUMBER NOT NULL, LPMittlererVerknuepfungsgrad NUMBER NOT NULL, 
						FPAnzahlBusse NUMBER NOT NULL, FPNetzbedingteWartezeit NUMBER NOT NULL, 
						FPWartezeitAufwandGesamt NUMBER NOT NULL, FPMindestwartezeitAufwand NUMBER NOT NULL, 
						FPGesamtzeitAufwand NUMBER NOT NULL, FPFahrplanwirkungsgrad NUMBER NOT NULL, 
						GBDurchschnittAnzahlBusse NUMBER NOT NULL, GBMittlereReisezeit NUMBER NOT NULL, 
						GBAnzahlPersonen NUMBER NOT NULL, GBReisezeitZuDirektfahrer NUMBER NOT NULL, 
						GBMindestreisezeitZuDirekt NUMBER NOT NULL, LPProzentVerbkeineDir NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID, HSAnzahlHaltestellen)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlbuft((void **)0, 
    "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , HSAnzahlHalte\
stellen NUMBER NOT NULL , HSBevUeberVersorgung NUMBER NOT NULL , HSBevUnterV\
ersorgung NUMBER NOT NULL , HSFlUeberVersorgung NUMBER NOT NULL , HSFlUnterV\
ersorgung NUMBER NOT NULL , HSBevVersorgungProzent NUMBER NOT NULL , HSFlVer\
sorgungProzent NUMBER NOT NULL , HSFussweg NUMBER NOT NULL , HSDirekteReisez\
eitAuto NUMBER NOT NULL , LPAnzahlUmstiege NUMBER NOT NULL , LPVerbindungenU\
mstiegszwang NUMBER NOT NULL , LPGesamtfahrer NUMBER NOT NULL , LPDirektfahr\
er NUMBER NOT NULL , LPMittlereReisezeit NUMBER NOT NULL , LPDirektfahrerant\
eil NUMBER NOT NULL , LPStreckenkilometer NUMBER NOT NULL , LPGesamteStrecke\
nkilometer NUMBER NOT NULL , LPMittlereMindestreisezeit NUMBER NOT NULL , LP\
Reisezeitverlaengerung NUMBER NOT NULL , LPAnzahlLinien NUMBER NOT NULL , LP\
MittlererVerknuepfungsgrad NUMBER NOT NULL , FPAnzahlBusse NUMBER NOT NULL ,\
 FPNetzbedingteWartezeit NUMBER NOT NULL , FPWartezeitAufwandGesamt NUMBER N\
OT NULL , FPMindestwartezeitAufwand NUMBE");
  sqlstm.stmt = "R NOT NULL , FPGesamtzeitAufwand NUMBER NOT NULL , FPFahrpl\
anwirkungsgrad NUMBER NOT NULL , GBDurchschnittAnzahlBusse NUMBER NOT NULL , G\
BMittlereReisezeit NUMBER NOT NULL , GBAnzahlPersonen NUMBER NOT NULL , GBReis\
ezeitZuDirektfahrer NUMBER NOT NULL , GBMindestreisezeitZuDirekt NUMBER NOT NU\
LL , LPProzentVerbkeineDir NUMBER NOT NULL , PRIMARY KEY ( SpeicherID , HSAnza\
hlHaltestellen ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )11430;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM Guetemasse WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from Guetemasse where \
SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )11444;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )11462;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO pg369.Guetemasse SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into pg369.Guetemasse select *  from tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )11480;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )11494;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )11508;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle GuetemasseReisezeitAuto...");
		Debug(2, "Kopiere Tabelle GuetemasseReisezeitAuto...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, HaltestelleA NUMBER NOT NULL, 
						HaltestelleB NUMBER NOT NULL, Reisezeit NUMBER NOT NULL, 
						PRIMARY KEY (SpeicherID, HaltestelleA, HaltestelleB)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , H\
altestelleA NUMBER NOT NULL , HaltestelleB NUMBER NOT NULL , Reisezeit NUMBER \
NOT NULL , PRIMARY KEY ( SpeicherID , HaltestelleA , HaltestelleB ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )11522;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM GuetemassReisezeitAuto WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from GuetemassReisezei\
tAuto where SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )11536;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )11554;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO pg369.GuetemassReisezeitAuto SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into pg369.GuetemassReisezeitAuto select *  f\
rom tmp_tbl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )11572;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )11586;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )11600;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}



		if(fortschritt!=0) fortschritt->anzeigenFortschritt(aktuelle_tabelle++, anzahl_tabellen);
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Kopiere Tabelle Pflichtlinien...");
		Debug(2, "Kopiere Tabelle Pflichtlinien...");
		// temporaere Tabelle anlegen:
		/* EXEC SQL CREATE TABLE tmp_tbl (SpeicherID NUMBER(2) NOT NULL, LinienID NUMBER NOT NULL, LfNr NUMBER NOT NULL,
						 HaltestellenID NUMBER NOT NULL, PRIMARY KEY (SpeicherID, LinienID, LfNr)); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "create TABLE tmp_tbl ( SpeicherID NUMBER ( 2 ) NOT NULL , L\
inienID NUMBER NOT NULL , LfNr NUMBER NOT NULL , HaltestellenID NUMBER NOT NUL\
L , PRIMARY KEY ( SpeicherID , LinienID , LfNr ) )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )11614;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


	        /* EXEC SQL INSERT INTO tmp_tbl SELECT * FROM Pflichtlinien WHERE SpeicherID = :quell_id; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into tmp_tbl select *  from Pflichtlinien whe\
re SpeicherID=:b0";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )11628;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlstm.sqhstv[0] = (unsigned char  *)&quell_id;
         sqlstm.sqhstl[0] = (unsigned int  )4;
         sqlstm.sqindv[0] = (         short *)0;
         sqlstm.sqharm[0] = (unsigned int  )0;
         sqlstm.sqphsv = sqlstm.sqhstv;
         sqlstm.sqphsl = sqlstm.sqhstl;
         sqlstm.sqpind = sqlstm.sqindv;
         sqlstm.sqparm = sqlstm.sqharm;
         sqlstm.sqparc = sqlstm.sqharc;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// jetzt die SpeicherID updaten
		/* EXEC SQL UPDATE tmp_tbl SET SpeicherID = :ziel_id; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update tmp_tbl  set SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )11646;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ziel_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// und die temporaere Tabelle zurueckschreiben:
	        /* EXEC SQL INSERT INTO pg369.Pflichtlinien SELECT * FROM tmp_tbl; */ 

{
         struct sqlexd sqlstm;

         sqlorat((void **)0, &sqlctx, &oraca);
         sqlstm.sqlvsn = 8;
         sqlstm.arrsiz = 7;
         sqlstm.stmt = "insert into pg369.Pflichtlinien select *  from tmp_t\
bl ";
         sqlstm.iters = (unsigned int  )1;
         sqlstm.offset = (unsigned int  )11664;
         sqlstm.cud = sqlcud0;
         sqlstm.sqlest = (unsigned char  *)&sqlca;
         sqlstm.sqlety = (unsigned short)0;
         sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
         if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		// temporaere Tabelle entfernen:
		/* EXEC SQL DROP TABLE tmp_tbl; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "drop TABLE tmp_tbl";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )11678;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )11692;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in kopierenProjektNachPG369");
}



		

	if(fortschritt!=0) delete fortschritt;
	return ziel_id;
}

//------------------------------------------------------------------------------
// Funktionsname:	speichernPflichthaltestellen
// Beschreibung:	speichert die Koordinaten der Pflichthaltestellen in Oracle
// Parameter:		pflichthaltestellen
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::speichernPflichthaltestellen(list<CPunkt*>* pflichthaltestellen=NULL)
{
    /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in speichernPflichthaltestellen"); */ 

    
    Debug(2, "SpeichernPflichthaltestellen");
    if(pflichthaltestellen!=0) 
    {
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	double speicherID[10000];
	double XKoordinate[10000];
	double YKoordinate[10000];
	
	int speicherNummer;
	int zeilenZaehler;
	/* EXEC SQL END DECLARE SECTION; */ 

	
	speicherNummer = speicherstand;
	
	//zunaechst die Tabelle loeschen:
	/* EXEC SQL DELETE FROM Pflichthaltestellen WHERE SpeicherID = :speicherNummer; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from Pflichthaltestellen  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )11706;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherNummer;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernPflichthaltestellen");
}


	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )11724;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernPflichthaltestellen");
}


	
	// jetzt alle Punkte aus der arc durchlaufen:
	CPunkt* dummyelement;
	
	zeilenZaehler = 0;
	forall(dummyelement, *pflichthaltestellen)
	    {
		// diesen Punkt jetzt ins element einsetzen:
		double x,y;
		dummyelement->holen(&x,&y);
		XKoordinate[zeilenZaehler] = x;
		YKoordinate[zeilenZaehler] = y;
		speicherID[zeilenZaehler] = speicherstand;
		zeilenZaehler++;
		// und ab in die Datenbank wenn der zeilenZaehler = 10000:
		if (zeilenZaehler == 10000) {
		    /* EXEC SQL INSERT INTO Pflichthaltestellen
			VALUES (:speicherID,:XKoordinate,:YKoordinate); */ 

{
      struct sqlexd sqlstm;

      sqlorat((void **)0, &sqlctx, &oraca);
      sqlstm.sqlvsn = 8;
      sqlstm.arrsiz = 7;
      sqlstm.stmt = "insert into Pflichthaltestellen values (:b0,:b1,:b2)";
      sqlstm.iters = (unsigned int  )10000;
      sqlstm.offset = (unsigned int  )11738;
      sqlstm.cud = sqlcud0;
      sqlstm.sqlest = (unsigned char  *)&sqlca;
      sqlstm.sqlety = (unsigned short)0;
      sqlstm.sqhstv[0] = (unsigned char  *)speicherID;
      sqlstm.sqhstl[0] = (unsigned int  )8;
      sqlstm.sqindv[0] = (         short *)0;
      sqlstm.sqharm[0] = (unsigned int  )0;
      sqlstm.sqharc[0] = (unsigned int   *)0;
      sqlstm.sqhstv[1] = (unsigned char  *)XKoordinate;
      sqlstm.sqhstl[1] = (unsigned int  )8;
      sqlstm.sqindv[1] = (         short *)0;
      sqlstm.sqharm[1] = (unsigned int  )0;
      sqlstm.sqharc[1] = (unsigned int   *)0;
      sqlstm.sqhstv[2] = (unsigned char  *)YKoordinate;
      sqlstm.sqhstl[2] = (unsigned int  )8;
      sqlstm.sqindv[2] = (         short *)0;
      sqlstm.sqharm[2] = (unsigned int  )0;
      sqlstm.sqharc[2] = (unsigned int   *)0;
      sqlstm.sqphsv = sqlstm.sqhstv;
      sqlstm.sqphsl = sqlstm.sqhstl;
      sqlstm.sqpind = sqlstm.sqindv;
      sqlstm.sqparm = sqlstm.sqharm;
      sqlstm.sqparc = sqlstm.sqharc;
      sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
      if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernPflichthaltestellen");
}


		    /* EXEC SQL COMMIT; */ 

{
      struct sqlexd sqlstm;

      sqlorat((void **)0, &sqlctx, &oraca);
      sqlstm.sqlvsn = 8;
      sqlstm.arrsiz = 7;
      sqlstm.iters = (unsigned int  )1;
      sqlstm.offset = (unsigned int  )11764;
      sqlstm.cud = sqlcud0;
      sqlstm.sqlest = (unsigned char  *)&sqlca;
      sqlstm.sqlety = (unsigned short)0;
      sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
      if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernPflichthaltestellen");
}


		    zeilenZaehler = 0;
		}
	    }
	if (zeilenZaehler > 0) {
	    /* EXEC SQL FOR :zeilenZaehler 
		INSERT INTO Pflichthaltestellen
		VALUES (:speicherID,:XKoordinate,:YKoordinate); */ 

{
     struct sqlexd sqlstm;

     sqlorat((void **)0, &sqlctx, &oraca);
     sqlstm.sqlvsn = 8;
     sqlstm.arrsiz = 7;
     sqlstm.stmt = "insert into Pflichthaltestellen values (:b1,:b2,:b3)";
     sqlstm.iters = (unsigned int  )zeilenZaehler;
     sqlstm.offset = (unsigned int  )11778;
     sqlstm.cud = sqlcud0;
     sqlstm.sqlest = (unsigned char  *)&sqlca;
     sqlstm.sqlety = (unsigned short)0;
     sqlstm.sqhstv[0] = (unsigned char  *)speicherID;
     sqlstm.sqhstl[0] = (unsigned int  )8;
     sqlstm.sqindv[0] = (         short *)0;
     sqlstm.sqharm[0] = (unsigned int  )0;
     sqlstm.sqhstv[1] = (unsigned char  *)XKoordinate;
     sqlstm.sqhstl[1] = (unsigned int  )8;
     sqlstm.sqindv[1] = (         short *)0;
     sqlstm.sqharm[1] = (unsigned int  )0;
     sqlstm.sqhstv[2] = (unsigned char  *)YKoordinate;
     sqlstm.sqhstl[2] = (unsigned int  )8;
     sqlstm.sqindv[2] = (         short *)0;
     sqlstm.sqharm[2] = (unsigned int  )0;
     sqlstm.sqphsv = sqlstm.sqhstv;
     sqlstm.sqphsl = sqlstm.sqhstl;
     sqlstm.sqpind = sqlstm.sqindv;
     sqlstm.sqparm = sqlstm.sqharm;
     sqlstm.sqparc = sqlstm.sqharc;
     sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
     if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernPflichthaltestellen");
}


	    /* EXEC SQL COMMIT; */ 

{
     struct sqlexd sqlstm;

     sqlorat((void **)0, &sqlctx, &oraca);
     sqlstm.sqlvsn = 8;
     sqlstm.arrsiz = 7;
     sqlstm.iters = (unsigned int  )1;
     sqlstm.offset = (unsigned int  )11804;
     sqlstm.cud = sqlcud0;
     sqlstm.sqlest = (unsigned char  *)&sqlca;
     sqlstm.sqlety = (unsigned short)0;
     sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
     if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernPflichthaltestellen");
}


	}
	
    } // endif: test auf Nullzeiger
    else cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: speichernPflichthaltestellen: NULL-Zeiger wurde uebergeben!"<<endl; 		
} 
//------------------------------------------------------------------------------
// Funktionsname:	holenPflichthaltestellen
// Beschreibung:	holt die Pflichthaltestellen wieder aus der DB
// Parameter:		
// Rueckgabe:		die Pflichthaltestellen in Form einer Liste von CPunkten
// Besonderheiten:	
//------------------------------------------------------------------------------
list<CPunkt*>* CDBSchnittstelle::holenPflichthaltestellen() 
{
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenPflichthaltestellen"); */ 


	// Das ist hier die Rueckgabeliste
	list<CPunkt*>* quellezielliste=0;
	try{quellezielliste=new list<CPunkt*>;}
	catch(...)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Quellezielliste konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}

	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	typedef struct
	{
		double XKoordinate;
		double YKoordinate;
	} qz_element;
	qz_element element;
	int speicherid=speicherstand;
	/* EXEC SQL END DECLARE SECTION; */ 


	// erzeuge den Cursor, mit dem Daten durchlaufen werden:
	/* EXEC SQL DECLARE pflichthaltestellen_cursor CURSOR FOR
		SELECT XKoordinate, YKoordinate
			FROM Pflichthaltestellen
			WHERE SpeicherID = :speicherid; */ 


	// jetzt den Cursor oeffnen
	/* EXEC SQL OPEN pflichthaltestellen_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = sq0703;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )11818;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenPflichthaltestellen");
}



        // und jetzt in Schleife alle Dinger holen:
	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

	for(;;)
	{
		/* EXEC SQL FETCH pflichthaltestellen_cursor INTO :element; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )11836;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&element.XKoordinate;
  sqlstm.sqhstl[0] = (unsigned int  )8;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&element.YKoordinate;
  sqlstm.sqhstl[1] = (unsigned int  )8;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenPflichthaltestellen");
}



		try{quellezielliste->append(new CPunkt(element.XKoordinate, element.YKoordinate));}
		catch(...)
		{
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: ein Element der QuelleZielListe konnte nicht angelegt werden. Speichermangel?"<<endl;
			cerr.flush();
		}
	}

        /* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	// und nach getaner arbeit Cursor wieder schliessen:
	/* EXEC SQL CLOSE pflichthaltestellen_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )11858;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenPflichthaltestellen");
}



	return quellezielliste;
}
//------------------------------------------------------------------------------
// Funktionsname:	speichernAusschnitt
// Beschreibung:	speichert die Abmessungen des zu beruecksichtigenden Ausschnitts
// Parameter:		die Koordinaten als double-Werte
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::speichernAusschnitt(double links, double oben, double rechts, double unten) 
{
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in speichernAusschnitt"); */ 

    
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	typedef struct	
	{
 		int SpeicherID;
		double Links;
		double Oben;
		double Rechts;
		double Unten;
	} ausschnittelement;
	ausschnittelement element;
	int speichernummer = speicherstand;
	/* EXEC SQL END DECLARE SECTION; */ 
	

	element.SpeicherID=speicherstand;
	element.Links=links;
	element.Oben=oben;
	element.Rechts=rechts;
	element.Unten=unten;

	/* EXEC SQL DELETE FROM Ausschnitt WHERE SpeicherID = :speichernummer; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from Ausschnitt  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )11872;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speichernummer;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernAusschnitt");
}



	/* EXEC SQL INSERT INTO Ausschnitt
		VALUES (:element); */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "insert into Ausschnitt values (:s1 ,:s2 ,:s3 ,:s4 ,:s5 )";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )11890;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&element.SpeicherID;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqhstv[1] = (unsigned char  *)&element.Links;
 sqlstm.sqhstl[1] = (unsigned int  )8;
 sqlstm.sqindv[1] = (         short *)0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqhstv[2] = (unsigned char  *)&element.Oben;
 sqlstm.sqhstl[2] = (unsigned int  )8;
 sqlstm.sqindv[2] = (         short *)0;
 sqlstm.sqharm[2] = (unsigned int  )0;
 sqlstm.sqhstv[3] = (unsigned char  *)&element.Rechts;
 sqlstm.sqhstl[3] = (unsigned int  )8;
 sqlstm.sqindv[3] = (         short *)0;
 sqlstm.sqharm[3] = (unsigned int  )0;
 sqlstm.sqhstv[4] = (unsigned char  *)&element.Unten;
 sqlstm.sqhstl[4] = (unsigned int  )8;
 sqlstm.sqindv[4] = (         short *)0;
 sqlstm.sqharm[4] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernAusschnitt");
}


	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )11924;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernAusschnitt");
}



}
//------------------------------------------------------------------------------
// Funktionsname:	holenAusschnitt
// Beschreibung:	holt die Abmessungen des zu beruecksichtigendesn Ausschnitts
// Parameter:		
// Rueckgabe:		die Koordinaten als double-Werte
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::holenAusschnitt(double& links, double& oben, double& rechts, double& unten) 
{
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenAusschnitt"); */ 

    
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	typedef struct	
	{
 		int SpeicherID;
		double Links;
		double Oben;
		double Rechts;
		double Unten;
	} ausschnittelement;
	ausschnittelement element;
	int speichernummer = speicherstand;
	/* EXEC SQL END DECLARE SECTION; */ 


	element.Links=0.0;
	element.Rechts=0.0;
	element.Unten=0.0;
	element.Oben=0.0;

	// erzeuge die Cursor, mit dem Daten durchlaufen werden:
	/* EXEC SQL DECLARE ausschnitt_cursor CURSOR FOR
		SELECT SpeicherID, Links, Oben, Rechts, Unten
			FROM Ausschnitt
			WHERE SpeicherID = :speichernummer; */ 

        
	
	// jetzt den Cursor oeffnen
	/* EXEC SQL OPEN ausschnitt_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = sq0707;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )11938;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speichernummer;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenAusschnitt");
}


        	
	// und jetzt in Schleife alle Dinger holen:
	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

	for(;;)
	{
		/* EXEC SQL FETCH ausschnitt_cursor INTO :element; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )11956;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&element.SpeicherID;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&element.Links;
  sqlstm.sqhstl[1] = (unsigned int  )8;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&element.Oben;
  sqlstm.sqhstl[2] = (unsigned int  )8;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqhstv[3] = (unsigned char  *)&element.Rechts;
  sqlstm.sqhstl[3] = (unsigned int  )8;
  sqlstm.sqindv[3] = (         short *)0;
  sqlstm.sqharm[3] = (unsigned int  )0;
  sqlstm.sqhstv[4] = (unsigned char  *)&element.Unten;
  sqlstm.sqhstl[4] = (unsigned int  )8;
  sqlstm.sqindv[4] = (         short *)0;
  sqlstm.sqharm[4] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenAusschnitt");
}


	}
        /* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	// und nach getaner arbeit Cursor wieder schliessen:
	/* EXEC SQL CLOSE ausschnitt_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )11990;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenAusschnitt");
}



	links=element.Links;
	oben=element.Oben;
	rechts=element.Rechts;
	unten=element.Unten;
}







// Allgemeine (von mehreren Modulen benutzt): -------------------------------------------------------------
//       EXEC SQL DELETE <tabellenname> WHERE SpeicherID = <speicherstand>;
//       WHERE SpeicherID = element.speicherID;
//------------------------------------------------------------------------------
// Funktionsname:	holenQuelleZielMatrix
// Beschreibung:	Mit dieser Methode wird die QuelleZielMatrix aus der Datenbank geholt
// Parameter:		
// Rueckgabe:		Zeiger auf eine matrix (LEDA)
// Besonderheiten:	
//------------------------------------------------------------------------------
matrix* CDBSchnittstelle::holenQuelleZielMatrix()
{

   /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenQuelleZielMatrix"); */ 


	Debug(3,"Lege Quelle-Ziel-Matrix an");

	// Datenfelder anlegen, die im folgenden als Zwischenspeicher dienen:
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	
	typedef struct
	{
		int vonHaltestelle;
		int nachHaltestelle;
		//double reiseAufkommen;	
		int reiseAufkommen;
	} qzelem;
	qzelem element;
	int speicherid=speicherstand;
	/* EXEC SQL END DECLARE SECTION; */ 
		

        // Problem: LEDA-Matrix muss beim erzeugen eine feste Groesse zugewiesen werden
	// Daher muss ich zuerst schauen, fuer wie viele Elemente die Matrix geruesstet
	// sein soll.
	// Da die Matrix quadratisch ist, hole ich mir eine Zeile und zaehle die
	// Eintraege per Cursor. Dann kann ich einfach davon das Quadrat nehmen und
	// habe die Matrix groesse.
	// Also:
	// schauen, wieviele Elemente in einer Reihe stehen:
	// erzeuge den Cursor:
	/* EXEC SQL DECLARE qz_cursor CURSOR FOR
		SELECT VonHaltestelle, NachHaltestelle, Reiseaufkommen
			FROM QuelleZielMatrix
			WHERE VonHaltestelle LIKE 1 AND SpeicherID = :speicherid; */ 


	// jetzt den Cursor oeffnen
	/* EXEC SQL OPEN qz_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = sq0708;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )12004;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenQuelleZielMatrix");
}


	// Jetzt Schleife durchlaufen, bis keine Daten mehr im
	// Cursor sind, dabei einen Zaehler erhoehen:
	int zaehler=0; // Anzahl der Elemente in einer Zeile

	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

	for(;;)
	{
		/* EXEC SQL FETCH qz_cursor INTO :element; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )12022;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&element.vonHaltestelle;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&element.nachHaltestelle;
  sqlstm.sqhstl[1] = (unsigned int  )4;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&element.reiseAufkommen;
  sqlstm.sqhstl[2] = (unsigned int  )4;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenQuelleZielMatrix");
}


		// Zaehle jetzt, wieviele Elemente es in einer Zeile gibtt
		zaehler++;
	}
	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	// und nach getaner arbeit Cursor wieder schliessen:
	/* EXEC SQL CLOSE qz_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )12048;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenQuelleZielMatrix");
}


        // jetzt steht in zaehler die Anzahl der Elemente in einer Zeile
	Debug(2, "holenQuelleZielMatrix: Zaehler steht auf:"<<zaehler);


	// jetzt ein Array der entsprechenden groesse (quadratisch anlegen):
	matrix* quelleZielMatrix =0;
	if(zaehler>0)
	{
		double* qz=0;
		try{qz=new double[zaehler*zaehler];} // ueber Zeiger, da es ansonsten Speicherueberlaufen koennte
		catch(...)
		{
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die QuelleZielMatrix konnte nicht angelegt werden. Speichermangel?"<<endl;
			cerr.flush();
		}
		// Array-Werte mit -1 initialisieren:
		for(int loescher=0; loescher<zaehler*zaehler; loescher++) qz[loescher]=-1;
	        // Jetzt einen Cursor anlegen, der alle Dinger durchlaeuft:
		/* EXEC SQL DECLARE qz_cursor2 CURSOR FOR
			SELECT VonHaltestelle, NachHaltestelle, Reiseaufkommen
				FROM QuelleZielMatrix
				WHERE SpeicherID = :speicherid; */ 

        	// Cursor wieder oeffnen
		/* EXEC SQL OPEN qz_cursor2; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = sq0709;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )12062;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenQuelleZielMatrix");
}


        	
	        // Jetzt in einer Schleife die einzelnen Elemente einlesen:
		/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

		int position=0;
		for(;;)
		{
			/* EXEC SQL FETCH qz_cursor2 INTO :element; */ 

{
   struct sqlexd sqlstm;

   sqlorat((void **)0, &sqlctx, &oraca);
   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 7;
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )12080;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlstm.sqhstv[0] = (unsigned char  *)&element.vonHaltestelle;
   sqlstm.sqhstl[0] = (unsigned int  )4;
   sqlstm.sqindv[0] = (         short *)0;
   sqlstm.sqharm[0] = (unsigned int  )0;
   sqlstm.sqhstv[1] = (unsigned char  *)&element.nachHaltestelle;
   sqlstm.sqhstl[1] = (unsigned int  )4;
   sqlstm.sqindv[1] = (         short *)0;
   sqlstm.sqharm[1] = (unsigned int  )0;
   sqlstm.sqhstv[2] = (unsigned char  *)&element.reiseAufkommen;
   sqlstm.sqhstl[2] = (unsigned int  )4;
   sqlstm.sqindv[2] = (         short *)0;
   sqlstm.sqharm[2] = (unsigned int  )0;
   sqlstm.sqphsv = sqlstm.sqhstv;
   sqlstm.sqphsl = sqlstm.sqhstl;
   sqlstm.sqpind = sqlstm.sqindv;
   sqlstm.sqparm = sqlstm.sqharm;
   sqlstm.sqparc = sqlstm.sqharc;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
   if (sqlca.sqlcode == 1403) break;
   if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenQuelleZielMatrix");
}


			qz[element.vonHaltestelle*zaehler+element.nachHaltestelle]=element.reiseAufkommen;
			position++;
		}
	        /* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

		// und nach getaner arbeit Cursor wieder schliessen:
		/* EXEC SQL CLOSE qz_cursor2; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )12106;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenQuelleZielMatrix");
}


	
		//Debug(2, "Matrix erzeugen:");
		// Jetzt die Matrix erzeugen
	
		try{    
			quelleZielMatrix = new matrix(zaehler,zaehler,qz);
		}
		catch(std::bad_alloc)
		{       	
			cerr<<"Datenbank: "<<__LINE__<<": "<<"Fehler: "<<__LINE__<<": "<<"quellezielmatrix konnte nicht angelegt werden, Speichermangel"<<endl;
		}
		delete[] qz;
        }

	return quelleZielMatrix; // und zurueckgeben
}
//------------------------------------------------------------------------------
// Funktionsname:	holenUrsprungsQZMatrix
// Beschreibung:	Mit dieser Methode wird die urspruengliche QuelleZielMatrix aus der Datenbank geholt
// Parameter:		
// Rueckgabe:		Zeiger auf eine matrix (LEDA)
// Besonderheiten:	
//------------------------------------------------------------------------------
matrix* CDBSchnittstelle::holenUrsprungsQZMatrix()
{

   /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenQuelleZielMatrix"); */ 


	Debug(3,"Lege urspruengliche Quelle-Ziel-Matrix an");

	// Datenfelder anlegen, die im folgenden als Zwischenspeicher dienen:
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	
	typedef struct
	{
		int vonHaltestelle;
		int nachHaltestelle;
		//double reiseAufkommen;	
		int reiseAufkommen;
	} qzelem;
	qzelem element;
	int speicherid=speicherstand;
	/* EXEC SQL END DECLARE SECTION; */ 
		

        // Problem: LEDA-Matrix muss beim erzeugen eine feste Groesse zugewiesen werden
	// Daher muss ich zuerst schauen, fuer wie viele Elemente die Matrix geruesstet
	// sein soll.
	// Da die Matrix quadratisch ist, hole ich mir eine Zeile und zaehle die
	// Eintraege per Cursor. Dann kann ich einfach davon das Quadrat nehmen und
	// habe die Matrix groesse.
	// Also:
	// schauen, wieviele Elemente in einer Reihe stehen:
	// erzeuge den Cursor:
	/* EXEC SQL DECLARE ursprungs_qz_cursor CURSOR FOR
		SELECT VonHaltestelle, NachHaltestelle, Reiseaufkommen
			FROM UrsprungsQZMatrix
			WHERE VonHaltestelle LIKE 1 AND SpeicherID = :speicherid; */ 


	// jetzt den Cursor oeffnen
	/* EXEC SQL OPEN ursprungs_qz_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = sq0710;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )12120;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenQuelleZielMatrix");
}


	// Jetzt Schleife durchlaufen, bis keine Daten mehr im
	// Cursor sind, dabei einen Zaehler erhoehen:
	int zaehler=0; // Anzahl der Elemente in einer Zeile

	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

	for(;;)
	{
		/* EXEC SQL FETCH ursprungs_qz_cursor INTO :element; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )12138;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&element.vonHaltestelle;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&element.nachHaltestelle;
  sqlstm.sqhstl[1] = (unsigned int  )4;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&element.reiseAufkommen;
  sqlstm.sqhstl[2] = (unsigned int  )4;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenQuelleZielMatrix");
}


		// Zaehle jetzt, wieviele Elemente es in einer Zeile gibtt
		zaehler++;
	}
	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	// und nach getaner arbeit Cursor wieder schliessen:
	/* EXEC SQL CLOSE ursprungs_qz_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )12164;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenQuelleZielMatrix");
}


        // jetzt steht in zaehler die Anzahl der Elemente in einer Zeile
//	Debug(2, "holenQuelleZielMatrix: Zaehler steht auf:"<<zaehler);

        matrix* quelleZielMatrix =0;
	if(zaehler>0)
	{

		// jetzt ein Array der entsprechenden groesse (quadratisch anlegen):
		double* qz=0;
		try{qz=new double[zaehler*zaehler];}
		catch(...)
		{
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die urspruengliche QuelleZielMatrix konnte nicht angelegt werden. Speichermangel?"<<endl;
			cerr.flush();
		}
		// Array-Werte mit -1 initialisieren:
		for(int loescher=0; loescher<zaehler*zaehler; loescher++) qz[loescher]=-1;
	        // Jetzt einen Cursor anlegen, der alle Dinger durchlaeuft:
		/* EXEC SQL DECLARE ursprungs_qz_cursor2 CURSOR FOR
			SELECT VonHaltestelle, NachHaltestelle, Reiseaufkommen
				FROM UrsprungsQZMatrix
				WHERE SpeicherID = :speicherid; */ 

        	// Cursor wieder oeffnen
		/* EXEC SQL OPEN ursprungs_qz_cursor2; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = sq0711;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )12178;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenQuelleZielMatrix");
}


        	
	        // Jetzt in einer Schleife die einzelnen Elemente einlesen:
		/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

		int position=0;
		for(;;)
		{
			/* EXEC SQL FETCH ursprungs_qz_cursor2 INTO :element; */ 

{
   struct sqlexd sqlstm;

   sqlorat((void **)0, &sqlctx, &oraca);
   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 7;
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )12196;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlstm.sqhstv[0] = (unsigned char  *)&element.vonHaltestelle;
   sqlstm.sqhstl[0] = (unsigned int  )4;
   sqlstm.sqindv[0] = (         short *)0;
   sqlstm.sqharm[0] = (unsigned int  )0;
   sqlstm.sqhstv[1] = (unsigned char  *)&element.nachHaltestelle;
   sqlstm.sqhstl[1] = (unsigned int  )4;
   sqlstm.sqindv[1] = (         short *)0;
   sqlstm.sqharm[1] = (unsigned int  )0;
   sqlstm.sqhstv[2] = (unsigned char  *)&element.reiseAufkommen;
   sqlstm.sqhstl[2] = (unsigned int  )4;
   sqlstm.sqindv[2] = (         short *)0;
   sqlstm.sqharm[2] = (unsigned int  )0;
   sqlstm.sqphsv = sqlstm.sqhstv;
   sqlstm.sqphsl = sqlstm.sqhstl;
   sqlstm.sqpind = sqlstm.sqindv;
   sqlstm.sqparm = sqlstm.sqharm;
   sqlstm.sqparc = sqlstm.sqharc;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
   if (sqlca.sqlcode == 1403) break;
   if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenQuelleZielMatrix");
}


			qz[element.vonHaltestelle*zaehler+element.nachHaltestelle]=element.reiseAufkommen;
			position++;
		}
	        /* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

		// und nach getaner arbeit Cursor wieder schliessen:
		/* EXEC SQL CLOSE ursprungs_qz_cursor2; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )12222;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenQuelleZielMatrix");
}



		// Jetzt die Matrix erzeugen
		try{
		quelleZielMatrix = new matrix(zaehler,zaehler,qz);
		}catch(std::bad_alloc)
		{
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: "<<__LINE__<<": "<<"urspruengliche quellezielmatrix konnte nicht angelegt werden, Speichermangel"<<endl;
		}
                delete[] qz;
	}
	return quelleZielMatrix; // und zurueckgeben
}
//------------------------------------------------------------------------------
// Funktionsname:	speichernQuelleZielMatrix
// Beschreibung:	Mit dieser Methode wird die QuelleZielMatrix gespeichert
// Parameter:		Zeiger auf eine matrix (LEDA)
// Rueckgabe:		
// Besonderheiten:	Array-Groesse liegt bei 10000
//------------------------------------------------------------------------------
void CDBSchnittstelle::speichernQuelleZielMatrix(matrix* quellezielmatrix=0)
{
    /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in speichernQuelleZielMatrix"); */ 


    if(quellezielmatrix!=0)
    {
	
	Debug(2, "Speichere QuelleZielMatrix");

	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	
	int speicherID[10000]; // Tabellen Spalte
	int vonHaltestelle[10000]; // Tabellen Spalte
	int nachHaltestelle[10000]; // Tabellen Spalte
	int reiseAufkommen[10000]; // Tabellen Spalte
	int speicher; // SpeicherID zum loeschen der Tabelle
	int zeilenZaehler; // zeilenZaehler zum bestimmen der eigentlichen Arraygroesse
	/* EXEC SQL END DECLARE SECTION; */ 
	
	
	speicher = speicherstand; 

	zeilenZaehler = 0;

	CFortschritt* fortschritt=0;
	if(batchbetrieb==false) 
	{
		try{fortschritt=new CFortschritt("Speichern der Ergebnisdaten");}
		catch(...)
		{
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Fortschrittsanzeige beim Speichern der QuelleZielMatrix konnte nicht angelegt werden. Speichermangel?"<<endl;
			cerr.flush();
		}
	}
	if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Loesche alte Ziel-Matrix in der Datenbank...");

	//zunaechst die Tabelle loeschen:
	/* EXEC SQL DELETE FROM QuelleZielMatrix WHERE SpeicherID = :speicher; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from QuelleZielMatrix  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )12236;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicher;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernQuelleZielMatrix");
}


	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )12254;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernQuelleZielMatrix");
}



//	Debug(2, "speichernQuelleZielMatrix: QuelleZielmatrix geloescht; vor Schleife");
	
	if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Speichere QuelleZiel-Matrix in der Datenbank...");
	int fortschrittzaehler=0;
	// durchlaufe Matrix
	for( int x=0; x < quellezielmatrix->dim1(); x++)
	{
	    for(int y=0; y < quellezielmatrix->dim2(); y++)
	    {
		// Werte zuweisen:
		vonHaltestelle[zeilenZaehler]=x;
		nachHaltestelle[zeilenZaehler]=y;
		reiseAufkommen[zeilenZaehler]=(*quellezielmatrix)(x,y);
		speicherID[zeilenZaehler] = speicherstand;
		zeilenZaehler++; // Incrementiere um 1, da ein weiterer Eintrag hinzugefuegt wurde
		
		

		// Wenn schon 10000 Zeilen eingefuegt wurden, speichere diese in der Datenbank
		if (zeilenZaehler == 10000) { 
//		    Debug(2,"10000 QuelleZiel Eintragungen abgearbeitet");
		    /* EXEC SQL INSERT INTO QuelleZielMatrix VALUES (:speicherID, :vonHaltestelle, :nachHaltestelle, :reiseAufkommen); */ 

{
      struct sqlexd sqlstm;

      sqlorat((void **)0, &sqlctx, &oraca);
      sqlstm.sqlvsn = 8;
      sqlstm.arrsiz = 7;
      sqlstm.stmt = "insert into QuelleZielMatrix values (:b0,:b1,:b2,:b3)";
      sqlstm.iters = (unsigned int  )10000;
      sqlstm.offset = (unsigned int  )12268;
      sqlstm.cud = sqlcud0;
      sqlstm.sqlest = (unsigned char  *)&sqlca;
      sqlstm.sqlety = (unsigned short)0;
      sqlstm.sqhstv[0] = (unsigned char  *)speicherID;
      sqlstm.sqhstl[0] = (unsigned int  )4;
      sqlstm.sqindv[0] = (         short *)0;
      sqlstm.sqharm[0] = (unsigned int  )0;
      sqlstm.sqharc[0] = (unsigned int   *)0;
      sqlstm.sqhstv[1] = (unsigned char  *)vonHaltestelle;
      sqlstm.sqhstl[1] = (unsigned int  )4;
      sqlstm.sqindv[1] = (         short *)0;
      sqlstm.sqharm[1] = (unsigned int  )0;
      sqlstm.sqharc[1] = (unsigned int   *)0;
      sqlstm.sqhstv[2] = (unsigned char  *)nachHaltestelle;
      sqlstm.sqhstl[2] = (unsigned int  )4;
      sqlstm.sqindv[2] = (         short *)0;
      sqlstm.sqharm[2] = (unsigned int  )0;
      sqlstm.sqharc[2] = (unsigned int   *)0;
      sqlstm.sqhstv[3] = (unsigned char  *)reiseAufkommen;
      sqlstm.sqhstl[3] = (unsigned int  )4;
      sqlstm.sqindv[3] = (         short *)0;
      sqlstm.sqharm[3] = (unsigned int  )0;
      sqlstm.sqharc[3] = (unsigned int   *)0;
      sqlstm.sqphsv = sqlstm.sqhstv;
      sqlstm.sqphsl = sqlstm.sqhstl;
      sqlstm.sqpind = sqlstm.sqindv;
      sqlstm.sqparm = sqlstm.sqharm;
      sqlstm.sqparc = sqlstm.sqharc;
      sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
      if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernQuelleZielMatrix");
}


		    /* EXEC SQL COMMIT; */ 

{
      struct sqlexd sqlstm;

      sqlorat((void **)0, &sqlctx, &oraca);
      sqlstm.sqlvsn = 8;
      sqlstm.arrsiz = 7;
      sqlstm.iters = (unsigned int  )1;
      sqlstm.offset = (unsigned int  )12298;
      sqlstm.cud = sqlcud0;
      sqlstm.sqlest = (unsigned char  *)&sqlca;
      sqlstm.sqlety = (unsigned short)0;
      sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
      if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernQuelleZielMatrix");
}


		    zeilenZaehler = 0;

		    fortschrittzaehler=fortschrittzaehler+10000;
		    if(fortschritt!=0) fortschritt->anzeigenFortschritt(fortschrittzaehler, (quellezielmatrix->dim1() * quellezielmatrix->dim2()) );
		}
	    }
	}
	// Speichere den Rest in der Datenbank
	if (zeilenZaehler > 0) {
//	    Debug(2,zeilenZaehler <<  " QuelleZiel Eintragungen abgearbeitet");
	    /* EXEC SQL FOR :zeilenZaehler
		INSERT INTO QuelleZielMatrix VALUES (:speicherID, :vonHaltestelle, :nachHaltestelle, :reiseAufkommen); */ 

{
     struct sqlexd sqlstm;

     sqlorat((void **)0, &sqlctx, &oraca);
     sqlstm.sqlvsn = 8;
     sqlstm.arrsiz = 7;
     sqlstm.stmt = "insert into QuelleZielMatrix values (:b1,:b2,:b3,:b4)";
     sqlstm.iters = (unsigned int  )zeilenZaehler;
     sqlstm.offset = (unsigned int  )12312;
     sqlstm.cud = sqlcud0;
     sqlstm.sqlest = (unsigned char  *)&sqlca;
     sqlstm.sqlety = (unsigned short)0;
     sqlstm.sqhstv[0] = (unsigned char  *)speicherID;
     sqlstm.sqhstl[0] = (unsigned int  )4;
     sqlstm.sqindv[0] = (         short *)0;
     sqlstm.sqharm[0] = (unsigned int  )0;
     sqlstm.sqhstv[1] = (unsigned char  *)vonHaltestelle;
     sqlstm.sqhstl[1] = (unsigned int  )4;
     sqlstm.sqindv[1] = (         short *)0;
     sqlstm.sqharm[1] = (unsigned int  )0;
     sqlstm.sqhstv[2] = (unsigned char  *)nachHaltestelle;
     sqlstm.sqhstl[2] = (unsigned int  )4;
     sqlstm.sqindv[2] = (         short *)0;
     sqlstm.sqharm[2] = (unsigned int  )0;
     sqlstm.sqhstv[3] = (unsigned char  *)reiseAufkommen;
     sqlstm.sqhstl[3] = (unsigned int  )4;
     sqlstm.sqindv[3] = (         short *)0;
     sqlstm.sqharm[3] = (unsigned int  )0;
     sqlstm.sqphsv = sqlstm.sqhstv;
     sqlstm.sqphsl = sqlstm.sqhstl;
     sqlstm.sqpind = sqlstm.sqindv;
     sqlstm.sqparm = sqlstm.sqharm;
     sqlstm.sqparc = sqlstm.sqharc;
     sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
     if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernQuelleZielMatrix");
}


	    /* EXEC SQL COMMIT; */ 

{
     struct sqlexd sqlstm;

     sqlorat((void **)0, &sqlctx, &oraca);
     sqlstm.sqlvsn = 8;
     sqlstm.arrsiz = 7;
     sqlstm.iters = (unsigned int  )1;
     sqlstm.offset = (unsigned int  )12342;
     sqlstm.cud = sqlcud0;
     sqlstm.sqlest = (unsigned char  *)&sqlca;
     sqlstm.sqlety = (unsigned short)0;
     sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
     if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernQuelleZielMatrix");
}


	}
	if(fortschritt!=0) fortschritt->anzeigenFortschritt((quellezielmatrix->dim1() * quellezielmatrix->dim2()), (quellezielmatrix->dim1() * quellezielmatrix->dim2()) );
//	Debug(2, "speichernQuelleZielMatrix: ende der Methode");
	delete quellezielmatrix;
	if(fortschritt!=0) delete fortschritt;
    } // endif: test auf Nullzeiger
    else cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: speichernQuelleZielMatrix: NULL-Zeiger wurde uebergeben!"<<endl;
}
//------------------------------------------------------------------------------
// Funktionsname:	speichernUrsprungsQZMatrix
// Beschreibung:	Mit dieser Methode wird die urspruengliche QuelleZielMatrix gespeichert
// Parameter:		Zeiger auf eine matrix (LEDA)
// Rueckgabe:		
// Besonderheiten:	Array-Groesse liegt bei 10000
//------------------------------------------------------------------------------
void CDBSchnittstelle::speichernUrsprungsQZMatrix(matrix* quellezielmatrix=0)
{
    /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in speichernUrsrpungsQZMatrix"); */ 


    if(quellezielmatrix!=0)
    {
	
	Debug(2, "Speichere ursrpuengliche QuelleZielMatrix");

	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	
	int speicherID[10000]; // Tabellen Spalte
	int vonHaltestelle[10000]; // Tabellen Spalte
	int nachHaltestelle[10000]; // Tabellen Spalte
	int reiseAufkommen[10000]; // Tabellen Spalte
	int speicher; // SpeicherID zum loeschen der Tabelle
	int zeilenZaehler; // zeilenZaehler zum bestimmen der eigentlichen Arraygroesse
	/* EXEC SQL END DECLARE SECTION; */ 
	
	
	speicher = speicherstand; 

	zeilenZaehler = 0;

	CFortschritt* fortschritt=0;
	if(batchbetrieb==false) 
	{
		try{fortschritt=new CFortschritt("Speichern der Ausgangsdaten");}
		catch(...)
		{
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Fortschrittsanzeige beim Speichern der urspruenglichen QuelleZielMatrix konnte nicht angelegt werden. Speichermangel?"<<endl;
			cerr.flush();
		}
	}
	if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Loesche alte, urspruengliche Quelle-Ziel-Matrix in der Datenbank...");

	//zunaechst die Tabelle loeschen:
	/* EXEC SQL DELETE FROM UrsprungsQZMatrix WHERE SpeicherID = :speicher; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from UrsprungsQZMatrix  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )12356;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicher;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernUrsrpungsQZMatrix");
}


	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )12374;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernUrsrpungsQZMatrix");
}



//	Debug(2, "speichernQuelleZielMatrix: QuelleZielmatrix geloescht; vor Schleife");
	
	if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Speichere ursrpruengliche QuelleZiel-Matrix in der Datenbank...");

	// durchlaufe Matrix
	int fortschrittzaehler=0;
	for( int x=0; x < quellezielmatrix->dim1(); x++)
	{
	    for(int y=0; y < quellezielmatrix->dim2(); y++)
	    {
		// Werte zuweisen:
		vonHaltestelle[zeilenZaehler]=x;
		nachHaltestelle[zeilenZaehler]=y;
		reiseAufkommen[zeilenZaehler]=(*quellezielmatrix)(x,y);
		speicherID[zeilenZaehler] = speicherstand;
		zeilenZaehler++; // Incrementiere um 1, da ein weiterer Eintrag hinzugefuegt wurde
		
		

		// Wenn schon 10000 Zeilen eingefuegt wurden, speichere diese in der Datenbank
		if (zeilenZaehler == 10000) { 
//		    Debug(2,"10000 QuelleZiel Eintragungen abgearbeitet");
		    /* EXEC SQL INSERT INTO UrsprungsQZMatrix VALUES (:speicherID, :vonHaltestelle, :nachHaltestelle, :reiseAufkommen); */ 

{
      struct sqlexd sqlstm;

      sqlorat((void **)0, &sqlctx, &oraca);
      sqlstm.sqlvsn = 8;
      sqlstm.arrsiz = 7;
      sqlstm.stmt = "insert into UrsprungsQZMatrix values (:b0,:b1,:b2,:b3)";
      sqlstm.iters = (unsigned int  )10000;
      sqlstm.offset = (unsigned int  )12388;
      sqlstm.cud = sqlcud0;
      sqlstm.sqlest = (unsigned char  *)&sqlca;
      sqlstm.sqlety = (unsigned short)0;
      sqlstm.sqhstv[0] = (unsigned char  *)speicherID;
      sqlstm.sqhstl[0] = (unsigned int  )4;
      sqlstm.sqindv[0] = (         short *)0;
      sqlstm.sqharm[0] = (unsigned int  )0;
      sqlstm.sqharc[0] = (unsigned int   *)0;
      sqlstm.sqhstv[1] = (unsigned char  *)vonHaltestelle;
      sqlstm.sqhstl[1] = (unsigned int  )4;
      sqlstm.sqindv[1] = (         short *)0;
      sqlstm.sqharm[1] = (unsigned int  )0;
      sqlstm.sqharc[1] = (unsigned int   *)0;
      sqlstm.sqhstv[2] = (unsigned char  *)nachHaltestelle;
      sqlstm.sqhstl[2] = (unsigned int  )4;
      sqlstm.sqindv[2] = (         short *)0;
      sqlstm.sqharm[2] = (unsigned int  )0;
      sqlstm.sqharc[2] = (unsigned int   *)0;
      sqlstm.sqhstv[3] = (unsigned char  *)reiseAufkommen;
      sqlstm.sqhstl[3] = (unsigned int  )4;
      sqlstm.sqindv[3] = (         short *)0;
      sqlstm.sqharm[3] = (unsigned int  )0;
      sqlstm.sqharc[3] = (unsigned int   *)0;
      sqlstm.sqphsv = sqlstm.sqhstv;
      sqlstm.sqphsl = sqlstm.sqhstl;
      sqlstm.sqpind = sqlstm.sqindv;
      sqlstm.sqparm = sqlstm.sqharm;
      sqlstm.sqparc = sqlstm.sqharc;
      sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
      if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernUrsrpungsQZMatrix");
}


		    /* EXEC SQL COMMIT; */ 

{
      struct sqlexd sqlstm;

      sqlorat((void **)0, &sqlctx, &oraca);
      sqlstm.sqlvsn = 8;
      sqlstm.arrsiz = 7;
      sqlstm.iters = (unsigned int  )1;
      sqlstm.offset = (unsigned int  )12418;
      sqlstm.cud = sqlcud0;
      sqlstm.sqlest = (unsigned char  *)&sqlca;
      sqlstm.sqlety = (unsigned short)0;
      sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
      if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernUrsrpungsQZMatrix");
}


		    zeilenZaehler = 0;

		    fortschrittzaehler=fortschrittzaehler+10000;
		    if(fortschritt!=0) fortschritt->anzeigenFortschritt(fortschrittzaehler, (quellezielmatrix->dim1() * quellezielmatrix->dim2()) );
		}
	    }
	}
	// Speichere den Rest in der Datenbank
	if (zeilenZaehler > 0) {
//	    Debug(2,zeilenZaehler <<  " QuelleZiel Eintragungen abgearbeitet");
	    /* EXEC SQL FOR :zeilenZaehler
		INSERT INTO UrsprungsQZMatrix VALUES (:speicherID, :vonHaltestelle, :nachHaltestelle, :reiseAufkommen); */ 

{
     struct sqlexd sqlstm;

     sqlorat((void **)0, &sqlctx, &oraca);
     sqlstm.sqlvsn = 8;
     sqlstm.arrsiz = 7;
     sqlstm.stmt = "insert into UrsprungsQZMatrix values (:b1,:b2,:b3,:b4)";
     sqlstm.iters = (unsigned int  )zeilenZaehler;
     sqlstm.offset = (unsigned int  )12432;
     sqlstm.cud = sqlcud0;
     sqlstm.sqlest = (unsigned char  *)&sqlca;
     sqlstm.sqlety = (unsigned short)0;
     sqlstm.sqhstv[0] = (unsigned char  *)speicherID;
     sqlstm.sqhstl[0] = (unsigned int  )4;
     sqlstm.sqindv[0] = (         short *)0;
     sqlstm.sqharm[0] = (unsigned int  )0;
     sqlstm.sqhstv[1] = (unsigned char  *)vonHaltestelle;
     sqlstm.sqhstl[1] = (unsigned int  )4;
     sqlstm.sqindv[1] = (         short *)0;
     sqlstm.sqharm[1] = (unsigned int  )0;
     sqlstm.sqhstv[2] = (unsigned char  *)nachHaltestelle;
     sqlstm.sqhstl[2] = (unsigned int  )4;
     sqlstm.sqindv[2] = (         short *)0;
     sqlstm.sqharm[2] = (unsigned int  )0;
     sqlstm.sqhstv[3] = (unsigned char  *)reiseAufkommen;
     sqlstm.sqhstl[3] = (unsigned int  )4;
     sqlstm.sqindv[3] = (         short *)0;
     sqlstm.sqharm[3] = (unsigned int  )0;
     sqlstm.sqphsv = sqlstm.sqhstv;
     sqlstm.sqphsl = sqlstm.sqhstl;
     sqlstm.sqpind = sqlstm.sqindv;
     sqlstm.sqparm = sqlstm.sqharm;
     sqlstm.sqparc = sqlstm.sqharc;
     sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
     if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernUrsrpungsQZMatrix");
}


	    /* EXEC SQL COMMIT; */ 

{
     struct sqlexd sqlstm;

     sqlorat((void **)0, &sqlctx, &oraca);
     sqlstm.sqlvsn = 8;
     sqlstm.arrsiz = 7;
     sqlstm.iters = (unsigned int  )1;
     sqlstm.offset = (unsigned int  )12462;
     sqlstm.cud = sqlcud0;
     sqlstm.sqlest = (unsigned char  *)&sqlca;
     sqlstm.sqlety = (unsigned short)0;
     sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
     if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernUrsrpungsQZMatrix");
}


	}
	if(fortschritt!=0) fortschritt->anzeigenFortschritt((quellezielmatrix->dim1() * quellezielmatrix->dim2()), (quellezielmatrix->dim1() * quellezielmatrix->dim2()) );
//	Debug(2, "speichernQuelleZielMatrix: ende der Methode");
	delete quellezielmatrix;
	if(fortschritt!=0) delete fortschritt;
    } // endif: test auf Nullzeiger
    else cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: speichernUrsprungsQZMatrix: NULL-Zeiger wurde uebergeben!"<<endl;
}

//------------------------------------------------------------------------------
// Funktionsname:	holenQuelleZielListe
// Beschreibung:	Mit dieser Methode wird die QuelleZielListe aus der Datenbank geholt
// Parameter:		
// Rueckgabe:		Zeiger auf eine liste, die Zeiger auf CQuelleZielListeElemente aufnimmt
// Besonderheiten:	
//------------------------------------------------------------------------------
list<CQuelleZielListeElement*>* CDBSchnittstelle::holenQuelleZielListe()
{
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenQuelleZielListe"); */ 


	// Das ist hier die Rueckgabeliste
	list<CQuelleZielListeElement*>* quellezielliste=0;
	try{quellezielliste=new list<CQuelleZielListeElement*>;}
	catch(...)
	{	
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die QuelleZielListe konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}

	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	typedef struct
	{
		double XKoordinate;
		double YKoordinate;
		int ElementID;
	} qz_element;
	qz_element element;
	int speicherid=speicherstand;
	/* EXEC SQL END DECLARE SECTION; */ 


	// erzeuge den Cursor, mit dem Daten durchlaufen werden:
	/* EXEC SQL DECLARE qz_cursor CURSOR FOR
		SELECT XKoordinate, YKoordinate, ElementID
			FROM QuelleZielListe
			WHERE SpeicherID = :speicherid; */ 


	// jetzt den Cursor oeffnen
	/* EXEC SQL OPEN qz_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = sq0708;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )12476;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenQuelleZielListe");
}



        // und jetzt in Schleife alle Dinger holen:
	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

	for(;;)
	{
		/* EXEC SQL FETCH qz_cursor INTO :element; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )12494;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&element.XKoordinate;
  sqlstm.sqhstl[0] = (unsigned int  )8;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&element.YKoordinate;
  sqlstm.sqhstl[1] = (unsigned int  )8;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&element.ElementID;
  sqlstm.sqhstl[2] = (unsigned int  )4;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenQuelleZielListe");
}



		try{quellezielliste->append(new CQuelleZielListeElement(new CPunkt(element.XKoordinate, element.YKoordinate), element.ElementID));}
		catch(...)
		{
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: ein Element der QuelleZielListe konnte nicht angelegt werden. Speichermangel?"<<endl;
			cerr.flush();
		}
	}

        /* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	// und nach getaner arbeit Cursor wieder schliessen:
	/* EXEC SQL CLOSE qz_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )12520;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenQuelleZielListe");
}



	return quellezielliste;
}
//------------------------------------------------------------------------------
// Funktionsname:	holenUrsprungsQZListe
// Beschreibung:	Mit dieser Methode wird die urspruengliche QuelleZielListe aus der Datenbank geholt
// Parameter:		
// Rueckgabe:		Zeiger auf eine liste, die Zeiger auf CQuelleZielListeElemente aufnimmt
// Besonderheiten:	
//------------------------------------------------------------------------------
list<CQuelleZielListeElement*>* CDBSchnittstelle::holenUrsprungsQZListe()
{
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenUrsprungsQZListe"); */ 


	// Das ist hier die Rueckgabeliste
	list<CQuelleZielListeElement*>* quellezielliste=0;
	try{quellezielliste=new list<CQuelleZielListeElement*>;}
	catch(...)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die urspruengliche QuelleZielListe konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}

	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	typedef struct
	{
		double XKoordinate;
		double YKoordinate;
		int ElementID;
	} qz_element;
	qz_element element;
	int speicherid=speicherstand;
	/* EXEC SQL END DECLARE SECTION; */ 


	// erzeuge den Cursor, mit dem Daten durchlaufen werden:
	/* EXEC SQL DECLARE urspruengliche_qz_cursor CURSOR FOR
		SELECT XKoordinate, YKoordinate, ElementID
			FROM UrsprungsQZListe
			WHERE SpeicherID = :speicherid; */ 


	// jetzt den Cursor oeffnen
	/* EXEC SQL OPEN urspruengliche_qz_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = sq0724;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )12534;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenUrsprungsQZListe");
}



        // und jetzt in Schleife alle Dinger holen:
	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

	for(;;)
	{
		/* EXEC SQL FETCH urspruengliche_qz_cursor INTO :element; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )12552;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&element.XKoordinate;
  sqlstm.sqhstl[0] = (unsigned int  )8;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&element.YKoordinate;
  sqlstm.sqhstl[1] = (unsigned int  )8;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&element.ElementID;
  sqlstm.sqhstl[2] = (unsigned int  )4;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenUrsprungsQZListe");
}



		try{quellezielliste->append(new CQuelleZielListeElement(new CPunkt(element.XKoordinate, element.YKoordinate), element.ElementID));}
		catch(...)
		{
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: ein Element der urspruenglichen QuelleZielListe konnte nicht angelegt werden. Speichermangel?"<<endl;
			cerr.flush();
		}
	}

        /* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	// und nach getaner arbeit Cursor wieder schliessen:
	/* EXEC SQL CLOSE urspruengliche_qz_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )12578;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenUrsprungsQZListe");
}



	return quellezielliste;
}

//------------------------------------------------------------------------------
// Funktionsname:	speichernQuelleZielListe
// Beschreibung:	Mit dieser Methode wird die LISTE der QuelleZielMatrix gespeichert
// Parameter:		Zeiger auf eine liste, die Zeiger auf CQuelleZielListeElemente aufnimmt
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::speichernQuelleZielListe(list<CQuelleZielListeElement*>* quellezielliste)
{
    /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in speichernQuelleZielListe"); */ 

    
    Debug(2, "SpeichernQuelleZielListe");
    if(quellezielliste!=0) 
    {
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	double speicherID[10000];
	double XKoordinate[10000];
	double YKoordinate[10000];
	int ElementID[10000];
	
	int speicherNummer;
	int zeilenZaehler;
	/* EXEC SQL END DECLARE SECTION; */ 

	
	speicherNummer = speicherstand;
	
	CFortschritt* fortschritt=0;
	if(batchbetrieb==false) 
	{
		try{fortschritt=new CFortschritt("Speichern der Ergebnisdaten");}
		catch(...)
		{
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Fortschrittsanzeige beim Speichern der QuelleZielMatrix konnte nicht angelegt werden. Speichermangel?"<<endl;
			cerr.flush();
		}
	}
	if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Loesche alte QuelleZiel-Liste in der Datenbank...");

	//zunaechst die Tabelle loeschen:
	/* EXEC SQL DELETE FROM QuelleZielListe WHERE SpeicherID = :speicherNummer; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from QuelleZielListe  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )12592;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherNummer;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernQuelleZielListe");
}


	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )12610;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernQuelleZielListe");
}


	
	// jetzt alle Punkte aus der arc durchlaufen:
	CQuelleZielListeElement* dummyelement;
	
	if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Speichere QuelleZiel-Liste in der Datenbank...");
	
	zeilenZaehler = 0;
	int fortschrittzaehler=0;
	forall(dummyelement, *quellezielliste)
	    {
		// diesen Punkt jetzt ins element einsetzen:
		double x,y;
		CPunkt* dummypunkt=dummyelement->holenPunkt();
		dummypunkt->holen(&x,&y);
		ElementID[zeilenZaehler] = dummyelement->holenID();
		XKoordinate[zeilenZaehler] = x;
		YKoordinate[zeilenZaehler] = y;
		speicherID[zeilenZaehler] = speicherstand;
		zeilenZaehler++;
		

		// und ab in die Datenbank wenn der zeilenZaehler = 10000:
		if (zeilenZaehler == 10000) {
		    /* EXEC SQL INSERT INTO QuelleZielListe 
			VALUES (:speicherID,:XKoordinate,:YKoordinate,:ElementID); */ 

{
      struct sqlexd sqlstm;

      sqlorat((void **)0, &sqlctx, &oraca);
      sqlstm.sqlvsn = 8;
      sqlstm.arrsiz = 7;
      sqlstm.stmt = "insert into QuelleZielListe values (:b0,:b1,:b2,:b3)";
      sqlstm.iters = (unsigned int  )10000;
      sqlstm.offset = (unsigned int  )12624;
      sqlstm.cud = sqlcud0;
      sqlstm.sqlest = (unsigned char  *)&sqlca;
      sqlstm.sqlety = (unsigned short)0;
      sqlstm.sqhstv[0] = (unsigned char  *)speicherID;
      sqlstm.sqhstl[0] = (unsigned int  )8;
      sqlstm.sqindv[0] = (         short *)0;
      sqlstm.sqharm[0] = (unsigned int  )0;
      sqlstm.sqharc[0] = (unsigned int   *)0;
      sqlstm.sqhstv[1] = (unsigned char  *)XKoordinate;
      sqlstm.sqhstl[1] = (unsigned int  )8;
      sqlstm.sqindv[1] = (         short *)0;
      sqlstm.sqharm[1] = (unsigned int  )0;
      sqlstm.sqharc[1] = (unsigned int   *)0;
      sqlstm.sqhstv[2] = (unsigned char  *)YKoordinate;
      sqlstm.sqhstl[2] = (unsigned int  )8;
      sqlstm.sqindv[2] = (         short *)0;
      sqlstm.sqharm[2] = (unsigned int  )0;
      sqlstm.sqharc[2] = (unsigned int   *)0;
      sqlstm.sqhstv[3] = (unsigned char  *)ElementID;
      sqlstm.sqhstl[3] = (unsigned int  )4;
      sqlstm.sqindv[3] = (         short *)0;
      sqlstm.sqharm[3] = (unsigned int  )0;
      sqlstm.sqharc[3] = (unsigned int   *)0;
      sqlstm.sqphsv = sqlstm.sqhstv;
      sqlstm.sqphsl = sqlstm.sqhstl;
      sqlstm.sqpind = sqlstm.sqindv;
      sqlstm.sqparm = sqlstm.sqharm;
      sqlstm.sqparc = sqlstm.sqharc;
      sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
      if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernQuelleZielListe");
}


		    /* EXEC SQL COMMIT; */ 

{
      struct sqlexd sqlstm;

      sqlorat((void **)0, &sqlctx, &oraca);
      sqlstm.sqlvsn = 8;
      sqlstm.arrsiz = 7;
      sqlstm.iters = (unsigned int  )1;
      sqlstm.offset = (unsigned int  )12654;
      sqlstm.cud = sqlcud0;
      sqlstm.sqlest = (unsigned char  *)&sqlca;
      sqlstm.sqlety = (unsigned short)0;
      sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
      if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernQuelleZielListe");
}


		    zeilenZaehler = 0;
		
		    fortschrittzaehler=fortschrittzaehler+10000;
                    if(fortschritt!=0) fortschritt->anzeigenFortschritt(fortschrittzaehler, quellezielliste->length() );
		}
		if(fortschritt!=0) fortschritt->anzeigenFortschritt(zeilenZaehler, quellezielliste->length());
	    }
	if (zeilenZaehler > 0) {
	    /* EXEC SQL FOR :zeilenZaehler 
		INSERT INTO QuelleZielListe 
		VALUES (:speicherID,:XKoordinate,:YKoordinate,:ElementID); */ 

{
     struct sqlexd sqlstm;

     sqlorat((void **)0, &sqlctx, &oraca);
     sqlstm.sqlvsn = 8;
     sqlstm.arrsiz = 7;
     sqlstm.stmt = "insert into QuelleZielListe values (:b1,:b2,:b3,:b4)";
     sqlstm.iters = (unsigned int  )zeilenZaehler;
     sqlstm.offset = (unsigned int  )12668;
     sqlstm.cud = sqlcud0;
     sqlstm.sqlest = (unsigned char  *)&sqlca;
     sqlstm.sqlety = (unsigned short)0;
     sqlstm.sqhstv[0] = (unsigned char  *)speicherID;
     sqlstm.sqhstl[0] = (unsigned int  )8;
     sqlstm.sqindv[0] = (         short *)0;
     sqlstm.sqharm[0] = (unsigned int  )0;
     sqlstm.sqhstv[1] = (unsigned char  *)XKoordinate;
     sqlstm.sqhstl[1] = (unsigned int  )8;
     sqlstm.sqindv[1] = (         short *)0;
     sqlstm.sqharm[1] = (unsigned int  )0;
     sqlstm.sqhstv[2] = (unsigned char  *)YKoordinate;
     sqlstm.sqhstl[2] = (unsigned int  )8;
     sqlstm.sqindv[2] = (         short *)0;
     sqlstm.sqharm[2] = (unsigned int  )0;
     sqlstm.sqhstv[3] = (unsigned char  *)ElementID;
     sqlstm.sqhstl[3] = (unsigned int  )4;
     sqlstm.sqindv[3] = (         short *)0;
     sqlstm.sqharm[3] = (unsigned int  )0;
     sqlstm.sqphsv = sqlstm.sqhstv;
     sqlstm.sqphsl = sqlstm.sqhstl;
     sqlstm.sqpind = sqlstm.sqindv;
     sqlstm.sqparm = sqlstm.sqharm;
     sqlstm.sqparc = sqlstm.sqharc;
     sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
     if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernQuelleZielListe");
}


	    /* EXEC SQL COMMIT; */ 

{
     struct sqlexd sqlstm;

     sqlorat((void **)0, &sqlctx, &oraca);
     sqlstm.sqlvsn = 8;
     sqlstm.arrsiz = 7;
     sqlstm.iters = (unsigned int  )1;
     sqlstm.offset = (unsigned int  )12698;
     sqlstm.cud = sqlcud0;
     sqlstm.sqlest = (unsigned char  *)&sqlca;
     sqlstm.sqlety = (unsigned short)0;
     sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
     if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernQuelleZielListe");
}


	}
	if(fortschritt!=0) delete fortschritt;
    } // endif: test auf Nullzeiger
    else cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: speichernQuelleZielListe: NULL-Zeiger wurde uebergeben!"<<endl; 	
}
//------------------------------------------------------------------------------
// Funktionsname:	speichernUrsprungsQZListe
// Beschreibung:	Mit dieser Methode wird die urspruengliche LISTE der QuelleZielMatrix gespeichert
// Parameter:		Zeiger auf eine liste, die Zeiger auf CQuelleZielListeElemente aufnimmt
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::speichernUrsprungsQZListe(list<CQuelleZielListeElement*>* quellezielliste)
{
    /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in speichernUrsprungsQZListe"); */ 

    
    Debug(2, "SpeichernUrsprungsQZListe");
    if(quellezielliste!=0) 
    {
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	double speicherID[10000];
	double XKoordinate[10000];
	double YKoordinate[10000];
	int ElementID[10000];
	
	int speicherNummer;
	int zeilenZaehler;
	/* EXEC SQL END DECLARE SECTION; */ 

	
	speicherNummer = speicherstand;
	
	CFortschritt* fortschritt=0;
	if(batchbetrieb==false) 
	{
		try{fortschritt=new CFortschritt("Speichern der Ausgangsdaten");}
		catch(...)
		{
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Fortschrittsanzeige beim Speichern der urspruenglichen QuelleZielMatrix konnte nicht angelegt werden. Speichermangel?"<<endl;
			cerr.flush();
		}
	}
	if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Loesche alte, urspruengliche QuelleZiel-Liste in der Datenbank...");

	//zunaechst die Tabelle loeschen:
	/* EXEC SQL DELETE FROM UrsprungsQZListe WHERE SpeicherID = :speicherNummer; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from UrsprungsQZListe  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )12712;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherNummer;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernUrsprungsQZListe");
}


	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )12730;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernUrsprungsQZListe");
}


	
	// jetzt alle Punkte aus der arc durchlaufen:
	CQuelleZielListeElement* dummyelement;
	
	if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Speichere urspruengliche QuelleZiel-Liste in der Datenbank...");
	
	zeilenZaehler = 0;
	int fortschrittzaehler=0;
	forall(dummyelement, *quellezielliste)
	    {
		// diesen Punkt jetzt ins element einsetzen:
		double x,y;
		CPunkt* dummypunkt=dummyelement->holenPunkt();
		dummypunkt->holen(&x,&y);
		ElementID[zeilenZaehler] = dummyelement->holenID();
		XKoordinate[zeilenZaehler] = x;
		YKoordinate[zeilenZaehler] = y;
		speicherID[zeilenZaehler] = speicherstand;
		zeilenZaehler++;

		// und ab in die Datenbank wenn der zeilenZaehler = 10000:
		if (zeilenZaehler == 10000) {
		    /* EXEC SQL INSERT INTO UrsprungsQZListe 
			VALUES (:speicherID,:XKoordinate,:YKoordinate,:ElementID); */ 

{
      struct sqlexd sqlstm;

      sqlorat((void **)0, &sqlctx, &oraca);
      sqlstm.sqlvsn = 8;
      sqlstm.arrsiz = 7;
      sqlstm.stmt = "insert into UrsprungsQZListe values (:b0,:b1,:b2,:b3)";
      sqlstm.iters = (unsigned int  )10000;
      sqlstm.offset = (unsigned int  )12744;
      sqlstm.cud = sqlcud0;
      sqlstm.sqlest = (unsigned char  *)&sqlca;
      sqlstm.sqlety = (unsigned short)0;
      sqlstm.sqhstv[0] = (unsigned char  *)speicherID;
      sqlstm.sqhstl[0] = (unsigned int  )8;
      sqlstm.sqindv[0] = (         short *)0;
      sqlstm.sqharm[0] = (unsigned int  )0;
      sqlstm.sqharc[0] = (unsigned int   *)0;
      sqlstm.sqhstv[1] = (unsigned char  *)XKoordinate;
      sqlstm.sqhstl[1] = (unsigned int  )8;
      sqlstm.sqindv[1] = (         short *)0;
      sqlstm.sqharm[1] = (unsigned int  )0;
      sqlstm.sqharc[1] = (unsigned int   *)0;
      sqlstm.sqhstv[2] = (unsigned char  *)YKoordinate;
      sqlstm.sqhstl[2] = (unsigned int  )8;
      sqlstm.sqindv[2] = (         short *)0;
      sqlstm.sqharm[2] = (unsigned int  )0;
      sqlstm.sqharc[2] = (unsigned int   *)0;
      sqlstm.sqhstv[3] = (unsigned char  *)ElementID;
      sqlstm.sqhstl[3] = (unsigned int  )4;
      sqlstm.sqindv[3] = (         short *)0;
      sqlstm.sqharm[3] = (unsigned int  )0;
      sqlstm.sqharc[3] = (unsigned int   *)0;
      sqlstm.sqphsv = sqlstm.sqhstv;
      sqlstm.sqphsl = sqlstm.sqhstl;
      sqlstm.sqpind = sqlstm.sqindv;
      sqlstm.sqparm = sqlstm.sqharm;
      sqlstm.sqparc = sqlstm.sqharc;
      sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
      if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernUrsprungsQZListe");
}


		    /* EXEC SQL COMMIT; */ 

{
      struct sqlexd sqlstm;

      sqlorat((void **)0, &sqlctx, &oraca);
      sqlstm.sqlvsn = 8;
      sqlstm.arrsiz = 7;
      sqlstm.iters = (unsigned int  )1;
      sqlstm.offset = (unsigned int  )12774;
      sqlstm.cud = sqlcud0;
      sqlstm.sqlest = (unsigned char  *)&sqlca;
      sqlstm.sqlety = (unsigned short)0;
      sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
      if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernUrsprungsQZListe");
}


		    zeilenZaehler = 0;

		    fortschrittzaehler=fortschrittzaehler+10000;
		    if(fortschritt!=0) fortschritt->anzeigenFortschritt(fortschrittzaehler, quellezielliste->length() );
		}
	    }
	if (zeilenZaehler > 0) {
	    /* EXEC SQL FOR :zeilenZaehler 
		INSERT INTO UrsprungsQZListe 
		VALUES (:speicherID,:XKoordinate,:YKoordinate,:ElementID); */ 

{
     struct sqlexd sqlstm;

     sqlorat((void **)0, &sqlctx, &oraca);
     sqlstm.sqlvsn = 8;
     sqlstm.arrsiz = 7;
     sqlstm.stmt = "insert into UrsprungsQZListe values (:b1,:b2,:b3,:b4)";
     sqlstm.iters = (unsigned int  )zeilenZaehler;
     sqlstm.offset = (unsigned int  )12788;
     sqlstm.cud = sqlcud0;
     sqlstm.sqlest = (unsigned char  *)&sqlca;
     sqlstm.sqlety = (unsigned short)0;
     sqlstm.sqhstv[0] = (unsigned char  *)speicherID;
     sqlstm.sqhstl[0] = (unsigned int  )8;
     sqlstm.sqindv[0] = (         short *)0;
     sqlstm.sqharm[0] = (unsigned int  )0;
     sqlstm.sqhstv[1] = (unsigned char  *)XKoordinate;
     sqlstm.sqhstl[1] = (unsigned int  )8;
     sqlstm.sqindv[1] = (         short *)0;
     sqlstm.sqharm[1] = (unsigned int  )0;
     sqlstm.sqhstv[2] = (unsigned char  *)YKoordinate;
     sqlstm.sqhstl[2] = (unsigned int  )8;
     sqlstm.sqindv[2] = (         short *)0;
     sqlstm.sqharm[2] = (unsigned int  )0;
     sqlstm.sqhstv[3] = (unsigned char  *)ElementID;
     sqlstm.sqhstl[3] = (unsigned int  )4;
     sqlstm.sqindv[3] = (         short *)0;
     sqlstm.sqharm[3] = (unsigned int  )0;
     sqlstm.sqphsv = sqlstm.sqhstv;
     sqlstm.sqphsl = sqlstm.sqhstl;
     sqlstm.sqpind = sqlstm.sqindv;
     sqlstm.sqparm = sqlstm.sqharm;
     sqlstm.sqparc = sqlstm.sqharc;
     sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
     if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernUrsprungsQZListe");
}


	    /* EXEC SQL COMMIT; */ 

{
     struct sqlexd sqlstm;

     sqlorat((void **)0, &sqlctx, &oraca);
     sqlstm.sqlvsn = 8;
     sqlstm.arrsiz = 7;
     sqlstm.iters = (unsigned int  )1;
     sqlstm.offset = (unsigned int  )12818;
     sqlstm.cud = sqlcud0;
     sqlstm.sqlest = (unsigned char  *)&sqlca;
     sqlstm.sqlety = (unsigned short)0;
     sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
     if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernUrsprungsQZListe");
}


	}
	if(fortschritt!=0) fortschritt->anzeigenFortschritt(quellezielliste->length(), quellezielliste->length() );
	if(fortschritt!=0) delete fortschritt;
    } // endif: test auf Nullzeiger
    else cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: speichernUrsprungsQZListe: NULL-Zeiger wurde uebergeben!"<<endl; 	
}
    
//------------------------------------------------------------------------------
// Funktionsname:	holenWegenetzknoten
// Beschreibung:	Holt die Knoten des Wegenetzgraphen (Ergebnis der Haltestellen) aus der Datenbank
// Parameter:		
// Rueckgabe:		Liste mit Wegenetzknoten, die in den Graphen gehoeren (list<CWegenetzKnoten*>)
// Besonderheiten:	
//------------------------------------------------------------------------------
list<CWegenetzKnoten*>* CDBSchnittstelle::holenWegenetzKnoten()
{
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenWegenetzKnoten"); */ 


	// erst mal eine Liste anlegen, die wir dann zurueckgeben koennen:
	list<CWegenetzKnoten*>* wegenetzknotenliste=0;
	try{wegenetzknotenliste=new list<CWegenetzKnoten*>;}
	catch(...)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Liste der Wegenetzknoten konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}
        /* EXEC SQL BEGIN DECLARE SECTION; */ 
	

	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	typedef struct
	{
		int HaltestellenID;
 		/* VARCHAR Name[30]; */ 
struct { unsigned short len; unsigned char arr[30]; } Name;

 		double XKoordinate;
		double YKoordinate;
		int Prioritaet; 
		int Pflicht;
	} wegenetzelement;
	wegenetzelement element;
	int speicherid=speicherstand;
	/* EXEC SQL END DECLARE SECTION; */ 
	

        // erzeuge den Cursor, mit dem Daten durchlaufen werden:
	/* EXEC SQL DECLARE wegeknotencursor CURSOR FOR
		SELECT HaltestellenID, Name, XKoordinate, YKoordinate, Prioritaet, Pflicht
			FROM Knoten
			WHERE SpeicherID = :speicherid; */ 


	// jetzt den Cursor oeffnen
	/* EXEC SQL OPEN wegeknotencursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = sq0737;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )12832;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenWegenetzKnoten");
}



        // und jetzt in Schleife alle Dinger holen:
	CWegenetzKnoten* dummyknoten=0;
	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

	for(;;)
	{
		/* EXEC SQL FETCH wegeknotencursor INTO :element; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )12850;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&element.HaltestellenID;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&element.Name;
  sqlstm.sqhstl[1] = (unsigned int  )32;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&element.XKoordinate;
  sqlstm.sqhstl[2] = (unsigned int  )8;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqhstv[3] = (unsigned char  *)&element.YKoordinate;
  sqlstm.sqhstl[3] = (unsigned int  )8;
  sqlstm.sqindv[3] = (         short *)0;
  sqlstm.sqharm[3] = (unsigned int  )0;
  sqlstm.sqhstv[4] = (unsigned char  *)&element.Prioritaet;
  sqlstm.sqhstl[4] = (unsigned int  )4;
  sqlstm.sqindv[4] = (         short *)0;
  sqlstm.sqharm[4] = (unsigned int  )0;
  sqlstm.sqhstv[5] = (unsigned char  *)&element.Pflicht;
  sqlstm.sqhstl[5] = (unsigned int  )4;
  sqlstm.sqindv[5] = (         short *)0;
  sqlstm.sqharm[5] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenWegenetzKnoten");
}


		try{
		dummyknoten=new CWegenetzKnoten(element.HaltestellenID, element.Prioritaet);
		}catch(std::bad_alloc)
		{
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: "<<__LINE__<<": "<<"Liste mit den Wegenetzknoten konnte nicht angelegt werden, Speichermangel"<<endl;
		}
		dummyknoten->setzenPosition(element.XKoordinate, element.YKoordinate);
		wegenetzknotenliste->append(dummyknoten);

	}
        /* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	// und nach getaner arbeit Cursor wieder schliessen:
	/* EXEC SQL CLOSE wegeknotencursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )12888;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenWegenetzKnoten");
}



	return wegenetzknotenliste;
}
//------------------------------------------------------------------------------
// Funktionsname:	speichernWegenetzknoten
// Beschreibung:	Mit dieser Methode wird der Wegenetzgraph gespeichert (Ergebnis der Haltestellen)
// Parameter:		Der Wegenetzgraph
// Rueckgabe:		
// Besonderheiten:	loescht den uebergebenen Zeiger nicht!
//------------------------------------------------------------------------------
void CDBSchnittstelle::speichernWegenetzKnoten(GRAPH<CWegenetzKnoten*, CWegenetzKante*>* wegenetzgraph=0)
{
    /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in speichernWegenetzKnoten"); */ 

    
//    Debug(2, "SpeichernWegenetzKnoten (Haltestllen-Ergebnis)");
    if(wegenetzgraph!=0) 
    {
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	int speicherID[10000];
	int HaltestellenID[10000];
	/* VARCHAR Name[10000][30]; */ 
struct { unsigned short len; unsigned char arr[30]; } Name[10000];

	double XKoordinate[10000];
	double YKoordinate[10000];
	int Prioritaet[10000];
	int Pflicht[10000];
	int speicherNummer;
	int zeilenZaehler;
	/* EXEC SQL END DECLARE SECTION; */ 
	
	speicherNummer = speicherstand;

	CFortschritt* fortschritt=0;
	if(batchbetrieb==false) 
	{
		try{fortschritt=new CFortschritt("Speichern der Ergebnisdaten");}
		catch(...)
		{
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Fortschrittsanzeige beim Speichern der Wegenetzknoten konnte nicht angelegt werden. Speichermangel?"<<endl;
			cerr.flush();
		}
		
	}
	if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Loesche alte Knoten des Wegenetzgraphen in der Datenbank...");	

	// ersmal Tabelle loeschen:
	/* EXEC SQL DELETE FROM Knoten WHERE SpeicherID = :speicherNummer; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from Knoten  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )12902;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherNummer;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernWegenetzKnoten");
}


	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )12920;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernWegenetzKnoten");
}



	if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Speichere alle Knoten des Wegenetzgraphen in der Datenbank...");

	// Gehe alle Knoten durch und speichere sie in der Datenbank ab
	node knoten;
	CWegenetzKnoten* wknoten=0;
	double x,y; // dummy-Werte fuer die Koordinaten
	zeilenZaehler = 0;
	int fortschrittszaehler=0;
	forall_nodes(knoten, *wegenetzgraph)
	    {
		speicherID[zeilenZaehler] = speicherstand;
		wknoten=wegenetzgraph->inf(knoten);
		// jetzt den Knoten ausfuellen
		HaltestellenID[zeilenZaehler]=wknoten->holenKnotenId();
//			cout<<"............->KnotenID: "<<element.HaltestellenID<<endl;
		//strncpy((char*)element.Name.arr, "Standardstr.", 30);
		sprintf((char*)Name[zeilenZaehler].arr, "Standardstr.");
		Name[zeilenZaehler].len=strlen((char*)Name[zeilenZaehler].arr);
		(wknoten->holenPosition())->holen(&x,&y);
		XKoordinate[zeilenZaehler]=x;
		YKoordinate[zeilenZaehler]=y;
		Prioritaet[zeilenZaehler]=wknoten->holenPrioritaet();
		if(wknoten->holenPrioritaet()==10) Pflicht[zeilenZaehler]=1;
		else Pflicht[zeilenZaehler]=0;
		zeilenZaehler++;

		if (zeilenZaehler == 10000) {
//		    Debug(2,"Speichern von " << zeilenZaehler << " Datensaetzen");
		    /* EXEC SQL INSERT INTO Knoten
			VALUES (:speicherID,:HaltestellenID,:Name,:XKoordinate,:YKoordinate,:Prioritaet,:Pflicht); */ 

{
      struct sqlexd sqlstm;

      sqlorat((void **)0, &sqlctx, &oraca);
      sqlstm.sqlvsn = 8;
      sqlstm.arrsiz = 7;
      sqlstm.stmt = "insert into Knoten values (:b0,:b1,:b2,:b3,:b4,:b5,:b6)";
      sqlstm.iters = (unsigned int  )10000;
      sqlstm.offset = (unsigned int  )12934;
      sqlstm.cud = sqlcud0;
      sqlstm.sqlest = (unsigned char  *)&sqlca;
      sqlstm.sqlety = (unsigned short)0;
      sqlstm.sqhstv[0] = (unsigned char  *)speicherID;
      sqlstm.sqhstl[0] = (unsigned int  )4;
      sqlstm.sqindv[0] = (         short *)0;
      sqlstm.sqharm[0] = (unsigned int  )0;
      sqlstm.sqharc[0] = (unsigned int   *)0;
      sqlstm.sqhstv[1] = (unsigned char  *)HaltestellenID;
      sqlstm.sqhstl[1] = (unsigned int  )4;
      sqlstm.sqindv[1] = (         short *)0;
      sqlstm.sqharm[1] = (unsigned int  )0;
      sqlstm.sqharc[1] = (unsigned int   *)0;
      sqlstm.sqhstv[2] = (unsigned char  *)Name;
      sqlstm.sqhstl[2] = (unsigned int  )32;
      sqlstm.sqindv[2] = (         short *)0;
      sqlstm.sqharm[2] = (unsigned int  )0;
      sqlstm.sqharc[2] = (unsigned int   *)0;
      sqlstm.sqhstv[3] = (unsigned char  *)XKoordinate;
      sqlstm.sqhstl[3] = (unsigned int  )8;
      sqlstm.sqindv[3] = (         short *)0;
      sqlstm.sqharm[3] = (unsigned int  )0;
      sqlstm.sqharc[3] = (unsigned int   *)0;
      sqlstm.sqhstv[4] = (unsigned char  *)YKoordinate;
      sqlstm.sqhstl[4] = (unsigned int  )8;
      sqlstm.sqindv[4] = (         short *)0;
      sqlstm.sqharm[4] = (unsigned int  )0;
      sqlstm.sqharc[4] = (unsigned int   *)0;
      sqlstm.sqhstv[5] = (unsigned char  *)Prioritaet;
      sqlstm.sqhstl[5] = (unsigned int  )4;
      sqlstm.sqindv[5] = (         short *)0;
      sqlstm.sqharm[5] = (unsigned int  )0;
      sqlstm.sqharc[5] = (unsigned int   *)0;
      sqlstm.sqhstv[6] = (unsigned char  *)Pflicht;
      sqlstm.sqhstl[6] = (unsigned int  )4;
      sqlstm.sqindv[6] = (         short *)0;
      sqlstm.sqharm[6] = (unsigned int  )0;
      sqlstm.sqharc[6] = (unsigned int   *)0;
      sqlstm.sqphsv = sqlstm.sqhstv;
      sqlstm.sqphsl = sqlstm.sqhstl;
      sqlstm.sqpind = sqlstm.sqindv;
      sqlstm.sqparm = sqlstm.sqharm;
      sqlstm.sqparc = sqlstm.sqharc;
      sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
      if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernWegenetzKnoten");
}


		    /* EXEC SQL COMMIT; */ 

{
      struct sqlexd sqlstm;

      sqlorat((void **)0, &sqlctx, &oraca);
      sqlstm.sqlvsn = 8;
      sqlstm.arrsiz = 7;
      sqlstm.iters = (unsigned int  )1;
      sqlstm.offset = (unsigned int  )12976;
      sqlstm.cud = sqlcud0;
      sqlstm.sqlest = (unsigned char  *)&sqlca;
      sqlstm.sqlety = (unsigned short)0;
      sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
      if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernWegenetzKnoten");
}


		    zeilenZaehler = 0;

		    fortschrittszaehler=fortschrittszaehler+10000;
		    if(fortschritt!=0) fortschritt->anzeigenFortschritt(fortschrittszaehler, wegenetzgraph->number_of_nodes());
		}
	    }
	if (zeilenZaehler > 0) {
	    
//	    Debug(2,"Speichern von " << zeilenZaehler << " Datensaetzen");
	    /* EXEC SQL FOR :zeilenZaehler INSERT INTO Knoten
		VALUES (:speicherID,:HaltestellenID,:Name,:XKoordinate,:YKoordinate,:Prioritaet,:Pflicht); */ 

{
     struct sqlexd sqlstm;

     sqlorat((void **)0, &sqlctx, &oraca);
     sqlstm.sqlvsn = 8;
     sqlstm.arrsiz = 7;
     sqlstm.stmt = "insert into Knoten values (:b1,:b2,:b3,:b4,:b5,:b6,:b7)";
     sqlstm.iters = (unsigned int  )zeilenZaehler;
     sqlstm.offset = (unsigned int  )12990;
     sqlstm.cud = sqlcud0;
     sqlstm.sqlest = (unsigned char  *)&sqlca;
     sqlstm.sqlety = (unsigned short)0;
     sqlstm.sqhstv[0] = (unsigned char  *)speicherID;
     sqlstm.sqhstl[0] = (unsigned int  )4;
     sqlstm.sqindv[0] = (         short *)0;
     sqlstm.sqharm[0] = (unsigned int  )0;
     sqlstm.sqhstv[1] = (unsigned char  *)HaltestellenID;
     sqlstm.sqhstl[1] = (unsigned int  )4;
     sqlstm.sqindv[1] = (         short *)0;
     sqlstm.sqharm[1] = (unsigned int  )0;
     sqlstm.sqhstv[2] = (unsigned char  *)Name;
     sqlstm.sqhstl[2] = (unsigned int  )32;
     sqlstm.sqindv[2] = (         short *)0;
     sqlstm.sqharm[2] = (unsigned int  )0;
     sqlstm.sqhstv[3] = (unsigned char  *)XKoordinate;
     sqlstm.sqhstl[3] = (unsigned int  )8;
     sqlstm.sqindv[3] = (         short *)0;
     sqlstm.sqharm[3] = (unsigned int  )0;
     sqlstm.sqhstv[4] = (unsigned char  *)YKoordinate;
     sqlstm.sqhstl[4] = (unsigned int  )8;
     sqlstm.sqindv[4] = (         short *)0;
     sqlstm.sqharm[4] = (unsigned int  )0;
     sqlstm.sqhstv[5] = (unsigned char  *)Prioritaet;
     sqlstm.sqhstl[5] = (unsigned int  )4;
     sqlstm.sqindv[5] = (         short *)0;
     sqlstm.sqharm[5] = (unsigned int  )0;
     sqlstm.sqhstv[6] = (unsigned char  *)Pflicht;
     sqlstm.sqhstl[6] = (unsigned int  )4;
     sqlstm.sqindv[6] = (         short *)0;
     sqlstm.sqharm[6] = (unsigned int  )0;
     sqlstm.sqphsv = sqlstm.sqhstv;
     sqlstm.sqphsl = sqlstm.sqhstl;
     sqlstm.sqpind = sqlstm.sqindv;
     sqlstm.sqparm = sqlstm.sqharm;
     sqlstm.sqparc = sqlstm.sqharc;
     sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
     if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernWegenetzKnoten");
}


	    /* EXEC SQL COMMIT; */ 

{
     struct sqlexd sqlstm;

     sqlorat((void **)0, &sqlctx, &oraca);
     sqlstm.sqlvsn = 8;
     sqlstm.arrsiz = 7;
     sqlstm.iters = (unsigned int  )1;
     sqlstm.offset = (unsigned int  )13032;
     sqlstm.cud = sqlcud0;
     sqlstm.sqlest = (unsigned char  *)&sqlca;
     sqlstm.sqlety = (unsigned short)0;
     sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
     if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernWegenetzKnoten");
}


	}
	if(fortschritt!=0) fortschritt->anzeigenFortschritt(wegenetzgraph->number_of_nodes(), wegenetzgraph->number_of_nodes());
	if(fortschritt!=0) delete fortschritt;
    } // endif: test auf Nullzeiger
    else cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: speichernWegenetzKnoten: NULL-Zeiger wurde uebergeben!"<<endl; 
}

//------------------------------------------------------------------------------
// Funktionsname:	holenWegenetzKanten
// Beschreibung:	Holt die Kanten des Wegenetzgraphen (Ergebnis der Haltestellen) aus der Datenbank
// Parameter:		GRAPH mit Knoten; der Graph wird dann um die Kanten erweitert.
// Rueckgabe:		
// Besonderheiten:	Ruft die Methode holenKantenStrassen auf, um die Strassen, ueber die Kante laeuft zu speichern
//------------------------------------------------------------------------------
void CDBSchnittstelle::holenWegenetzKanten(GRAPH<CWegenetzKnoten*, CWegenetzKante*>* wegenetzgraph=0) // gehoert zum Wegenetzgraphen
{
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenWegenetzKanten"); */ 


	if(wegenetzgraph!=0)
	{

	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	typedef struct
	{
		int KantenID;
		int StartHaltestelle;
		int EndHaltestelle;
		int ReisezeitMinuten;
 		int Laenge;
		int ReiseFluss;
		int StrassenID;
	} wegenetzelement;
	wegenetzelement element;
	int speicherid=speicherstand;
	/* EXEC SQL END DECLARE SECTION; */ 
	
	
        // erzeuge den Cursor, mit dem Daten durchlaufen werden:
	/* EXEC SQL DECLARE wegekantencursor CURSOR FOR
		SELECT KantenID, StartHaltestelle, EndHaltestelle, ReisezeitMinuten, Laenge, ReiseFluss, StrassenID
			FROM Kanten
			WHERE SpeicherID = :speicherid; */ 


	// jetzt den Cursor oeffnen
	/* EXEC SQL OPEN wegekantencursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = sq0744;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )13046;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenWegenetzKanten");
}



        // und jetzt in Schleife alle Dinger holen:
	CWegenetzKante* dummykante=0;
	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

	for(;;)
	{
		/* EXEC SQL FETCH wegekantencursor INTO :element; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )13064;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&element.KantenID;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&element.StartHaltestelle;
  sqlstm.sqhstl[1] = (unsigned int  )4;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&element.EndHaltestelle;
  sqlstm.sqhstl[2] = (unsigned int  )4;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqhstv[3] = (unsigned char  *)&element.ReisezeitMinuten;
  sqlstm.sqhstl[3] = (unsigned int  )4;
  sqlstm.sqindv[3] = (         short *)0;
  sqlstm.sqharm[3] = (unsigned int  )0;
  sqlstm.sqhstv[4] = (unsigned char  *)&element.Laenge;
  sqlstm.sqhstl[4] = (unsigned int  )4;
  sqlstm.sqindv[4] = (         short *)0;
  sqlstm.sqharm[4] = (unsigned int  )0;
  sqlstm.sqhstv[5] = (unsigned char  *)&element.ReiseFluss;
  sqlstm.sqhstl[5] = (unsigned int  )4;
  sqlstm.sqindv[5] = (         short *)0;
  sqlstm.sqharm[5] = (unsigned int  )0;
  sqlstm.sqhstv[6] = (unsigned char  *)&element.StrassenID;
  sqlstm.sqhstl[6] = (unsigned int  )4;
  sqlstm.sqindv[6] = (         short *)0;
  sqlstm.sqharm[6] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenWegenetzKanten");
}


		// jetzt haben wir die Kante, die wir einordnen muessen.
		// Dazu aber erstmal die Strassen holen, die ueber die Kante fuehren
		list<CPunkt*>* strassenliste=holenKantenStrasse(element.KantenID);
		// jetzt die Kante anlegen:
		try{dummykante=new CWegenetzKante(element.Laenge);}
		catch(...)
		{
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: eine Kante des Wegenetzgraphen konnte nicht angelegt werden. Speichermangel?"<<endl;
			cerr.flush();
		}
		dummykante->setzenKantenListe(strassenliste);
		// hole die beiden Knoten, die den beiden IDs uebereinstimmt
                node sourcenode;
		node targetnode;
		node dummynode;
		forall_nodes(dummynode, *wegenetzgraph)
		{
			if((wegenetzgraph->inf(dummynode))->holenKnotenId()==element.StartHaltestelle) sourcenode=dummynode;
			if((wegenetzgraph->inf(dummynode))->holenKnotenId()==element.EndHaltestelle) targetnode=dummynode;
		}

		// und packe den fertigen Knoten rein:
		wegenetzgraph->new_edge(sourcenode, targetnode, dummykante);
	}
        /* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	// und nach getaner arbeit Cursor wieder schliessen:
	/* EXEC SQL CLOSE wegekantencursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )13106;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenWegenetzKanten");
}




	} //endif: Abfrage, ob Uebergabe-Parameter
	else cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: holenWegenetzKanten: NULL-Zeiger wurde uebergeben!"<<endl; 
}
//------------------------------------------------------------------------------
// Funktionsname:	speichernWegenetzKanten
// Beschreibung:	Mit dieser Methode werden die Knoten des Wegenetzgraphs gespeichert (Ergebnis der Haltestellen)
// Parameter:		Der Wegenetzgraph
// Rueckgabe:		
// Besonderheiten:	Ruft die Methode speichernKantenStrassen auf, um die Strassen, ueber die Kante laeuft zu speichern/ loescht den uebergebenen Zeiger nicht!
//------------------------------------------------------------------------------
void CDBSchnittstelle::speichernWegenetzKanten(GRAPH<CWegenetzKnoten*, CWegenetzKante*>* wegenetzgraph=0) // gehoert zum Wegenetzgraphen
{
    /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in speichernWegenetzKanten"); */ 

    
    // Debug(2, "SpeichernWegenetzKanten (Haltestellen-Ergebnis)");
    if(wegenetzgraph!=0) 
    {
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	int speicherID[10000];
	int KantenID[10000];
	int StartHaltestelle[10000];
	int EndHaltestelle[10000];
	int ReisezeitMinuten[10000];
	int Laenge[10000];
	int ReiseFluss[10000];
	int StrassenID[10000];
	int zeilenZaehler;
	int speicherNummer;
	/* EXEC SQL END DECLARE SECTION; */ 
	
	speicherNummer = speicherstand;
	
	CFortschritt* fortschritt=0;
	if(batchbetrieb==false) 
	{
		try{fortschritt=new CFortschritt("Speichern der Ergebnisdaten");}
		catch(...)
		{
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Fortschrittsanzeige beim Speichern der Wegenetzkanten konnte nicht angelegt werden. Speichermangel?"<<endl;
			cerr.flush();
		}
	}
	if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Loesche alte Kanten des Wegenetzgraphen in der Datenbank...");

	// erstmal die verbundenen Tabelle loeschen:
	/* EXEC SQL DELETE FROM Kanten WHERE SpeicherID = :speicherNummer; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from Kanten  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )13120;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherNummer;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernWegenetzKanten");
}

         // mit den Daten der Kanten
	/* EXEC SQL DELETE FROM KantenStrassen WHERE SpeicherID = :speicherNummer; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from KantenStrassen  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )13138;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherNummer;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernWegenetzKanten");
}

 // die Daten der Strassen ueber die jeweils die Kanten fuehren
	
	if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Speichere alle Kanten des Wegenetzgraphen in der Datenbank...");

	// Durchlaufe alle Kanten und speichere die bekannten Werte in der Datenbank ab:
	edge kante;
	node sourceknoten;
	node targetknoten;
	CWegenetzKante* wkante=0;
	int id=0;         // die ID muessen wir anlegen, beginnen wir bei 0 und nummerieren laufend fort
	int strassenid=0; // die ID der realten Strasse in der Tabelle KantenStrasse, ueber die diese Kante fuehrt
	zeilenZaehler = 0;
	list<list<CPunkt*>*>* strassenListe =0;
	try{strassenListe = new list<list<CPunkt*>*>();}
	catch(...)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Liste der Strassen konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}
	int durchlauf=0;
	forall_edges(kante, *wegenetzgraph)
	    {
		
		// Start- und Zielknoten der Kante holen:
		sourceknoten=source(kante);
		targetknoten=target(kante);
		// jetzt den Knoten ausfuellen
		speicherID[zeilenZaehler] = speicherstand;
		KantenID[zeilenZaehler]=id;
		id++;
		StartHaltestelle[zeilenZaehler]=(wegenetzgraph->inf(sourceknoten))->holenKnotenId();
		EndHaltestelle[zeilenZaehler]=(wegenetzgraph->inf(targetknoten))->holenKnotenId();
		ReisezeitMinuten[zeilenZaehler]=0; // wissen wir hier noch nicht
		Laenge[zeilenZaehler]=(wegenetzgraph->inf(kante))->holenEntfernung(); 
		ReiseFluss[zeilenZaehler]=0; // hier ebenfalls noch unbekannt
		StrassenID[zeilenZaehler]=strassenid;
		zeilenZaehler++;
		
		// und ab in die Tabelle, wenn der zeilenZaehler bei 10000 liegt
		if (zeilenZaehler == 10000) {
		    /* EXEC SQL INSERT INTO Kanten
			VALUES (:speicherID,:KantenID,:StartHaltestelle,:EndHaltestelle,:ReisezeitMinuten,
				:Laenge,:ReiseFluss,:StrassenID); */ 

{
      struct sqlexd sqlstm;

      sqlorat((void **)0, &sqlctx, &oraca);
      sqlstm.sqlvsn = 8;
      sqlstm.arrsiz = 8;
      sqlstm.stmt = "insert into Kanten values (:b0,:b1,:b2,:b3,:b4,:b5,:b6,\
:b7)";
      sqlstm.iters = (unsigned int  )10000;
      sqlstm.offset = (unsigned int  )13156;
      sqlstm.cud = sqlcud0;
      sqlstm.sqlest = (unsigned char  *)&sqlca;
      sqlstm.sqlety = (unsigned short)0;
      sqlstm.sqhstv[0] = (unsigned char  *)speicherID;
      sqlstm.sqhstl[0] = (unsigned int  )4;
      sqlstm.sqindv[0] = (         short *)0;
      sqlstm.sqharm[0] = (unsigned int  )0;
      sqlstm.sqharc[0] = (unsigned int   *)0;
      sqlstm.sqhstv[1] = (unsigned char  *)KantenID;
      sqlstm.sqhstl[1] = (unsigned int  )4;
      sqlstm.sqindv[1] = (         short *)0;
      sqlstm.sqharm[1] = (unsigned int  )0;
      sqlstm.sqharc[1] = (unsigned int   *)0;
      sqlstm.sqhstv[2] = (unsigned char  *)StartHaltestelle;
      sqlstm.sqhstl[2] = (unsigned int  )4;
      sqlstm.sqindv[2] = (         short *)0;
      sqlstm.sqharm[2] = (unsigned int  )0;
      sqlstm.sqharc[2] = (unsigned int   *)0;
      sqlstm.sqhstv[3] = (unsigned char  *)EndHaltestelle;
      sqlstm.sqhstl[3] = (unsigned int  )4;
      sqlstm.sqindv[3] = (         short *)0;
      sqlstm.sqharm[3] = (unsigned int  )0;
      sqlstm.sqharc[3] = (unsigned int   *)0;
      sqlstm.sqhstv[4] = (unsigned char  *)ReisezeitMinuten;
      sqlstm.sqhstl[4] = (unsigned int  )4;
      sqlstm.sqindv[4] = (         short *)0;
      sqlstm.sqharm[4] = (unsigned int  )0;
      sqlstm.sqharc[4] = (unsigned int   *)0;
      sqlstm.sqhstv[5] = (unsigned char  *)Laenge;
      sqlstm.sqhstl[5] = (unsigned int  )4;
      sqlstm.sqindv[5] = (         short *)0;
      sqlstm.sqharm[5] = (unsigned int  )0;
      sqlstm.sqharc[5] = (unsigned int   *)0;
      sqlstm.sqhstv[6] = (unsigned char  *)ReiseFluss;
      sqlstm.sqhstl[6] = (unsigned int  )4;
      sqlstm.sqindv[6] = (         short *)0;
      sqlstm.sqharm[6] = (unsigned int  )0;
      sqlstm.sqharc[6] = (unsigned int   *)0;
      sqlstm.sqhstv[7] = (unsigned char  *)StrassenID;
      sqlstm.sqhstl[7] = (unsigned int  )4;
      sqlstm.sqindv[7] = (         short *)0;
      sqlstm.sqharm[7] = (unsigned int  )0;
      sqlstm.sqharc[7] = (unsigned int   *)0;
      sqlstm.sqphsv = sqlstm.sqhstv;
      sqlstm.sqphsl = sqlstm.sqhstl;
      sqlstm.sqpind = sqlstm.sqindv;
      sqlstm.sqparm = sqlstm.sqharm;
      sqlstm.sqparc = sqlstm.sqharc;
      sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
      if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernWegenetzKanten");
}


		    /* EXEC SQL COMMIT; */ 

{
      struct sqlexd sqlstm;

      sqlorat((void **)0, &sqlctx, &oraca);
      sqlstm.sqlvsn = 8;
      sqlstm.arrsiz = 8;
      sqlstm.iters = (unsigned int  )1;
      sqlstm.offset = (unsigned int  )13202;
      sqlstm.cud = sqlcud0;
      sqlstm.sqlest = (unsigned char  *)&sqlca;
      sqlstm.sqlety = (unsigned short)0;
      sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
      if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernWegenetzKanten");
}


		    zeilenZaehler = 0;
		}
		// und die darunter liegende Strasse speichern (ueber speichernKantenStrasse)
		// speichernKantenStrasse((wegenetzgraph->inf(kante))->holenKantenListe(), strassenid);
		strassenListe->append((wegenetzgraph->inf(kante))->holenKantenListe());
	
		strassenid++;
	
		//Debug(2, "Kanten: "<<element.KantenID<<" "<<element.StartHaltestelle<<" "<<element.EndHaltestelle<<" "<<element.ReisezeitMinuten<<" "<<element.Laenge<<" "<<element.ReiseFluss<<" "<<element.StrassenID); 
	    }
	if (zeilenZaehler > 0) {
	    /* EXEC SQL FOR :zeilenZaehler INSERT INTO Kanten
		VALUES (:speicherID,:KantenID,:StartHaltestelle,:EndHaltestelle,:ReisezeitMinuten,
			:Laenge,:ReiseFluss,:StrassenID); */ 

{
     struct sqlexd sqlstm;

     sqlorat((void **)0, &sqlctx, &oraca);
     sqlstm.sqlvsn = 8;
     sqlstm.arrsiz = 8;
     sqlstm.stmt = "insert into Kanten values (:b1,:b2,:b3,:b4,:b5,:b6,:b7,:\
b8)";
     sqlstm.iters = (unsigned int  )zeilenZaehler;
     sqlstm.offset = (unsigned int  )13216;
     sqlstm.cud = sqlcud0;
     sqlstm.sqlest = (unsigned char  *)&sqlca;
     sqlstm.sqlety = (unsigned short)0;
     sqlstm.sqhstv[0] = (unsigned char  *)speicherID;
     sqlstm.sqhstl[0] = (unsigned int  )4;
     sqlstm.sqindv[0] = (         short *)0;
     sqlstm.sqharm[0] = (unsigned int  )0;
     sqlstm.sqhstv[1] = (unsigned char  *)KantenID;
     sqlstm.sqhstl[1] = (unsigned int  )4;
     sqlstm.sqindv[1] = (         short *)0;
     sqlstm.sqharm[1] = (unsigned int  )0;
     sqlstm.sqhstv[2] = (unsigned char  *)StartHaltestelle;
     sqlstm.sqhstl[2] = (unsigned int  )4;
     sqlstm.sqindv[2] = (         short *)0;
     sqlstm.sqharm[2] = (unsigned int  )0;
     sqlstm.sqhstv[3] = (unsigned char  *)EndHaltestelle;
     sqlstm.sqhstl[3] = (unsigned int  )4;
     sqlstm.sqindv[3] = (         short *)0;
     sqlstm.sqharm[3] = (unsigned int  )0;
     sqlstm.sqhstv[4] = (unsigned char  *)ReisezeitMinuten;
     sqlstm.sqhstl[4] = (unsigned int  )4;
     sqlstm.sqindv[4] = (         short *)0;
     sqlstm.sqharm[4] = (unsigned int  )0;
     sqlstm.sqhstv[5] = (unsigned char  *)Laenge;
     sqlstm.sqhstl[5] = (unsigned int  )4;
     sqlstm.sqindv[5] = (         short *)0;
     sqlstm.sqharm[5] = (unsigned int  )0;
     sqlstm.sqhstv[6] = (unsigned char  *)ReiseFluss;
     sqlstm.sqhstl[6] = (unsigned int  )4;
     sqlstm.sqindv[6] = (         short *)0;
     sqlstm.sqharm[6] = (unsigned int  )0;
     sqlstm.sqhstv[7] = (unsigned char  *)StrassenID;
     sqlstm.sqhstl[7] = (unsigned int  )4;
     sqlstm.sqindv[7] = (         short *)0;
     sqlstm.sqharm[7] = (unsigned int  )0;
     sqlstm.sqphsv = sqlstm.sqhstv;
     sqlstm.sqphsl = sqlstm.sqhstl;
     sqlstm.sqpind = sqlstm.sqindv;
     sqlstm.sqparm = sqlstm.sqharm;
     sqlstm.sqparc = sqlstm.sqharc;
     sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
     if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernWegenetzKanten");
}


	    /* EXEC SQL COMMIT; */ 

{
     struct sqlexd sqlstm;

     sqlorat((void **)0, &sqlctx, &oraca);
     sqlstm.sqlvsn = 8;
     sqlstm.arrsiz = 8;
     sqlstm.iters = (unsigned int  )1;
     sqlstm.offset = (unsigned int  )13262;
     sqlstm.cud = sqlcud0;
     sqlstm.sqlest = (unsigned char  *)&sqlca;
     sqlstm.sqlety = (unsigned short)0;
     sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
     if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernWegenetzKanten");
}

	    
		
	}
	strassenid = 0;
	list<CPunkt*>* punktListe;
	forall(punktListe,*strassenListe){
	    speichernKantenStrasse(punktListe, strassenid);
	    strassenid++;

	if(fortschritt!=0) fortschritt->anzeigenFortschritt(++durchlauf, wegenetzgraph->number_of_edges());
	}
	Debug(2, "Alle Kanten gespeichert");
	if(fortschritt!=0) delete fortschritt;
    } // endif: test auf Nullzeiger
    else cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: speichernWegenetzKanten: NULL-Zeiger wurde uebergeben!"<<endl; 
}

//------------------------------------------------------------------------------
// Funktionsname:	holenKantenStrasse
// Beschreibung:	holt eine Strasse des Wegenetzgraphen (Ergebnis der Haltestellen) aus der Datenbank
// Parameter:		id der Strasse, die zurueckgegeben werden soll
// Rueckgabe:		Strasse in Form eine Liste von Punkten
// Besonderheiten:	wird von holenWegenetzKanten aufgerufen
//------------------------------------------------------------------------------
list<CPunkt*>* CDBSchnittstelle::holenKantenStrasse(int kantenid=0) // gehoert zum Wegenetzgraphen
{
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenKantenStrasse"); */ 


	// Das ist hier die Rueckgabeliste
	list<CPunkt*>* strassenliste=0;
	try{strassenliste=new list<CPunkt*>;}
	catch(...)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Liste der Strassen konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}

	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	typedef struct
	{
		double StrassenID;
		double LfdNr;
		double XKoordinaten;
		double YKoordinaten;
	} strassenelement;
	strassenelement element;
	int speicherid=speicherstand;
	int kid=kantenid;
	/* EXEC SQL END DECLARE SECTION; */ 


	// erzeuge den Cursor, mit dem Daten durchlaufen werden:
	/* EXEC SQL DECLARE strassencursor CURSOR FOR
		SELECT StrassenID, LfdNr, XKoordinaten, YKoordinaten
			FROM KantenStrassen
			WHERE SpeicherID = :speicherid AND StrassenID = :kid; */ 


	// jetzt den Cursor oeffnen
	/* EXEC SQL OPEN strassencursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 8;
 sqlstm.stmt = sq0751;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )13276;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqhstv[1] = (unsigned char  *)&kid;
 sqlstm.sqhstl[1] = (unsigned int  )4;
 sqlstm.sqindv[1] = (         short *)0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenKantenStrasse");
}



        // und jetzt in Schleife alle Dinger holen:
	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

	for(;;)
	{
		/* EXEC SQL FETCH strassencursor INTO :element; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 8;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )13298;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&element.StrassenID;
  sqlstm.sqhstl[0] = (unsigned int  )8;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&element.LfdNr;
  sqlstm.sqhstl[1] = (unsigned int  )8;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&element.XKoordinaten;
  sqlstm.sqhstl[2] = (unsigned int  )8;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqhstv[3] = (unsigned char  *)&element.YKoordinaten;
  sqlstm.sqhstl[3] = (unsigned int  )8;
  sqlstm.sqindv[3] = (         short *)0;
  sqlstm.sqharm[3] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenKantenStrasse");
}



		try{strassenliste->append(new CPunkt(element.XKoordinaten, element.YKoordinaten));}
		catch(...)
		{
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: ein Element der Strassenliste konnte nicht angelegt werden. Speichermangel?"<<endl;
			cerr.flush();
		}
	}

        /* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	// und nach getaner arbeit Cursor wieder schliessen:
	/* EXEC SQL CLOSE strassencursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 8;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )13328;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenKantenStrasse");
}



	return strassenliste;		
}
//------------------------------------------------------------------------------
// Funktionsname:	speichernKantenStrasse
// Beschreibung:	Mit dieser Methode wird eine Strasse, ueber die die Busse fahren duerfen gespeichert (Ergebnis der Haltestellen)
// Parameter:		Liste mit den Knotenpunkten (= eine Strasse = eine "arc")
// Rueckgabe:		
// Besonderheiten:	wird von speichernWegenetzKanten aufgerufen
//------------------------------------------------------------------------------
void CDBSchnittstelle::speichernKantenStrasse(list<CPunkt*>* arc=0, int id=0) // gehoert zum Wegenetzgraphen
{
    /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in speichernKantenStrasse"); */ 

    
    //Debug(2, "SpeichernWegenetzStrasse(Haltestellen-Ergebnis)");
    if(arc!=0) 
    {
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	int speicherID[10000];
	int StrassenID[10000];
	int LfdNr[10000];
	int XKoordinaten[10000];
	int YKoordinaten[10000];
	int zeilenZaehler;
	/* EXEC SQL END DECLARE SECTION; */ 
	
	
	// jetzt alle Punkte aus der arc durchlaufen:
	CPunkt* dummypunkt;
	zeilenZaehler = 0;
	forall(dummypunkt, *arc)
	    {
		// diesen Punkt jetzt ins element einsetzen:
		double x,y;
		dummypunkt->holen(&x,&y);
		StrassenID[zeilenZaehler] = id;
		LfdNr[zeilenZaehler] = zeilenZaehler;
		XKoordinaten[zeilenZaehler] = x;
		YKoordinaten[zeilenZaehler] = y;
		speicherID[zeilenZaehler] = speicherstand;
		zeilenZaehler++;
		// und ab in die Datenbank, wenn zeilenZaehler = 10000
		if (zeilenZaehler == 10000) {
		    /* EXEC SQL INSERT INTO KantenStrassen
			VALUES (:speicherID,:StrassenID,:LfdNr,:XKoordinaten,:YKoordinaten); */ 

{
      struct sqlexd sqlstm;

      sqlorat((void **)0, &sqlctx, &oraca);
      sqlstm.sqlvsn = 8;
      sqlstm.arrsiz = 8;
      sqlstm.stmt = "insert into KantenStrassen values (:b0,:b1,:b2,:b3,:b4)";
      sqlstm.iters = (unsigned int  )10000;
      sqlstm.offset = (unsigned int  )13342;
      sqlstm.cud = sqlcud0;
      sqlstm.sqlest = (unsigned char  *)&sqlca;
      sqlstm.sqlety = (unsigned short)0;
      sqlstm.sqhstv[0] = (unsigned char  *)speicherID;
      sqlstm.sqhstl[0] = (unsigned int  )4;
      sqlstm.sqindv[0] = (         short *)0;
      sqlstm.sqharm[0] = (unsigned int  )0;
      sqlstm.sqharc[0] = (unsigned int   *)0;
      sqlstm.sqhstv[1] = (unsigned char  *)StrassenID;
      sqlstm.sqhstl[1] = (unsigned int  )4;
      sqlstm.sqindv[1] = (         short *)0;
      sqlstm.sqharm[1] = (unsigned int  )0;
      sqlstm.sqharc[1] = (unsigned int   *)0;
      sqlstm.sqhstv[2] = (unsigned char  *)LfdNr;
      sqlstm.sqhstl[2] = (unsigned int  )4;
      sqlstm.sqindv[2] = (         short *)0;
      sqlstm.sqharm[2] = (unsigned int  )0;
      sqlstm.sqharc[2] = (unsigned int   *)0;
      sqlstm.sqhstv[3] = (unsigned char  *)XKoordinaten;
      sqlstm.sqhstl[3] = (unsigned int  )4;
      sqlstm.sqindv[3] = (         short *)0;
      sqlstm.sqharm[3] = (unsigned int  )0;
      sqlstm.sqharc[3] = (unsigned int   *)0;
      sqlstm.sqhstv[4] = (unsigned char  *)YKoordinaten;
      sqlstm.sqhstl[4] = (unsigned int  )4;
      sqlstm.sqindv[4] = (         short *)0;
      sqlstm.sqharm[4] = (unsigned int  )0;
      sqlstm.sqharc[4] = (unsigned int   *)0;
      sqlstm.sqphsv = sqlstm.sqhstv;
      sqlstm.sqphsl = sqlstm.sqhstl;
      sqlstm.sqpind = sqlstm.sqindv;
      sqlstm.sqparm = sqlstm.sqharm;
      sqlstm.sqparc = sqlstm.sqharc;
      sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
      if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernKantenStrasse");
}


		    /* EXEC SQL COMMIT; */ 

{
      struct sqlexd sqlstm;

      sqlorat((void **)0, &sqlctx, &oraca);
      sqlstm.sqlvsn = 8;
      sqlstm.arrsiz = 8;
      sqlstm.iters = (unsigned int  )1;
      sqlstm.offset = (unsigned int  )13376;
      sqlstm.cud = sqlcud0;
      sqlstm.sqlest = (unsigned char  *)&sqlca;
      sqlstm.sqlety = (unsigned short)0;
      sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
      if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernKantenStrasse");
}


		    zeilenZaehler = 0;
		}
		//		Debug(2, "STRASSE: "<<element.StrassenID<<" "<<element.LfdNr<<" "<<element.XKoordinaten<<","<<element.YKoordinaten);
	    }
	if (zeilenZaehler > 0) {
	    /* EXEC SQL FOR :zeilenZaehler INSERT INTO KantenStrassen
		VALUES (:speicherID,:StrassenID,:LfdNr,:XKoordinaten,:YKoordinaten); */ 

{
     struct sqlexd sqlstm;

     sqlorat((void **)0, &sqlctx, &oraca);
     sqlstm.sqlvsn = 8;
     sqlstm.arrsiz = 8;
     sqlstm.stmt = "insert into KantenStrassen values (:b1,:b2,:b3,:b4,:b5)";
     sqlstm.iters = (unsigned int  )zeilenZaehler;
     sqlstm.offset = (unsigned int  )13390;
     sqlstm.cud = sqlcud0;
     sqlstm.sqlest = (unsigned char  *)&sqlca;
     sqlstm.sqlety = (unsigned short)0;
     sqlstm.sqhstv[0] = (unsigned char  *)speicherID;
     sqlstm.sqhstl[0] = (unsigned int  )4;
     sqlstm.sqindv[0] = (         short *)0;
     sqlstm.sqharm[0] = (unsigned int  )0;
     sqlstm.sqhstv[1] = (unsigned char  *)StrassenID;
     sqlstm.sqhstl[1] = (unsigned int  )4;
     sqlstm.sqindv[1] = (         short *)0;
     sqlstm.sqharm[1] = (unsigned int  )0;
     sqlstm.sqhstv[2] = (unsigned char  *)LfdNr;
     sqlstm.sqhstl[2] = (unsigned int  )4;
     sqlstm.sqindv[2] = (         short *)0;
     sqlstm.sqharm[2] = (unsigned int  )0;
     sqlstm.sqhstv[3] = (unsigned char  *)XKoordinaten;
     sqlstm.sqhstl[3] = (unsigned int  )4;
     sqlstm.sqindv[3] = (         short *)0;
     sqlstm.sqharm[3] = (unsigned int  )0;
     sqlstm.sqhstv[4] = (unsigned char  *)YKoordinaten;
     sqlstm.sqhstl[4] = (unsigned int  )4;
     sqlstm.sqindv[4] = (         short *)0;
     sqlstm.sqharm[4] = (unsigned int  )0;
     sqlstm.sqphsv = sqlstm.sqhstv;
     sqlstm.sqphsl = sqlstm.sqhstl;
     sqlstm.sqpind = sqlstm.sqindv;
     sqlstm.sqparm = sqlstm.sqharm;
     sqlstm.sqparc = sqlstm.sqharc;
     sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
     if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernKantenStrasse");
}


	    /* EXEC SQL COMMIT; */ 

{
     struct sqlexd sqlstm;

     sqlorat((void **)0, &sqlctx, &oraca);
     sqlstm.sqlvsn = 8;
     sqlstm.arrsiz = 8;
     sqlstm.iters = (unsigned int  )1;
     sqlstm.offset = (unsigned int  )13424;
     sqlstm.cud = sqlcud0;
     sqlstm.sqlest = (unsigned char  *)&sqlca;
     sqlstm.sqlety = (unsigned short)0;
     sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
     if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernKantenStrasse");
}


	}
	
    } // endif: test auf Nullzeiger
    else cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: speichernWegenetzStrasse: NULL-Zeiger wurde uebergeben!"<<endl; 
    
}

//------------------------------------------------------------------------------
// Funktionsname:	holenBusLinien
// Beschreibung:	holt eine Liste mit saemtlichen Buslinien aus der Datenbank (Linienplan Ergebnis)
// Parameter:		id des Plans, dessen Buslinien geholt werden sollen
// Rueckgabe:		Buslinie in Form eine Liste von CLinien
// Besonderheiten:	
//------------------------------------------------------------------------------
list<CLinie*>* CDBSchnittstelle::holenBusLinien(int plannummer=0) // gehoert zum Wegenetzgraphen: liefert die Knoten des Graphen, der fuer LP und FP als Input dient
{
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenBuslinien"); */ 


        Debug(2, "HolenBusLinien");

	// Rueckgabeliste anlegen:
	list<CLinie*>* buslinien=0;
	try{buslinien=new list<CLinie*>;}
	catch(...)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Liste der Buslinien konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}
        /* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
	
	// Die Liste wird aus zwei Tabellen gleichzeitig erzeugt:

	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	typedef struct	// unser gesamter Buslinienplan
	{
		int PlanID;
		/* VARCHAR Beschreibung[70]; */ 
struct { unsigned short len; unsigned char arr[70]; } Beschreibung;

		int LinienID;
	} buslinienplanelement;
	buslinienplanelement planelement;
       
	typedef struct	// eine Buslinie -> LinienWeg
	{
		int LinienID;
		int LfdNr;
		int HaltestellenID;
	} buslinienelement;
	buslinienelement linienelement;
	int speicherid=speicherstand;
	int plannr=plannummer;
	/* EXEC SQL END DECLARE SECTION; */ 
	
	
	// erzeuge die Cursor, mit dem Daten durchlaufen werden:
	/* EXEC SQL DECLARE plancursor CURSOR FOR
		SELECT PlanID, Beschreibung, LinienID
			FROM LinienPlan
			WHERE SpeicherID = :speicherid AND PlanID = :plannr; */ 


	// jetzt die Cursor oeffnen
        /* EXEC SQL OPEN plancursor; */ 

{
        struct sqlexd sqlstm;

        sqlorat((void **)0, &sqlctx, &oraca);
        sqlstm.sqlvsn = 8;
        sqlstm.arrsiz = 8;
        sqlstm.stmt = sq0756;
        sqlstm.iters = (unsigned int  )1;
        sqlstm.offset = (unsigned int  )13438;
        sqlstm.cud = sqlcud0;
        sqlstm.sqlest = (unsigned char  *)&sqlca;
        sqlstm.sqlety = (unsigned short)0;
        sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
        sqlstm.sqhstl[0] = (unsigned int  )4;
        sqlstm.sqindv[0] = (         short *)0;
        sqlstm.sqharm[0] = (unsigned int  )0;
        sqlstm.sqhstv[1] = (unsigned char  *)&plannr;
        sqlstm.sqhstl[1] = (unsigned int  )4;
        sqlstm.sqindv[1] = (         short *)0;
        sqlstm.sqharm[1] = (unsigned int  )0;
        sqlstm.sqphsv = sqlstm.sqhstv;
        sqlstm.sqphsl = sqlstm.sqhstl;
        sqlstm.sqpind = sqlstm.sqindv;
        sqlstm.sqparm = sqlstm.sqharm;
        sqlstm.sqparc = sqlstm.sqharc;
        sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
        if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenBuslinien");
}



        // und jetzt in Schleife alle Dinger holen:
	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

	for(;;)
	{
		/* EXEC SQL FETCH plancursor INTO :planelement; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 8;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )13460;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&planelement.PlanID;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&planelement.Beschreibung;
  sqlstm.sqhstl[1] = (unsigned int  )72;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&planelement.LinienID;
  sqlstm.sqhstl[2] = (unsigned int  )4;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenBuslinien");
}


		// Hier habe ich die erste Linie:
		// Lege neue Linie an:
		CLinie* einelinie=0;
		try{einelinie=new CLinie;}
		catch(...)
		{
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: ein Element der Buslinien konnte nicht angelegt werden. Speichermangel?"<<endl;
			cerr.flush();
		}
		einelinie->setzenID(planelement.LinienID); // ID auf die ID setzen
//		Debug(2, "ID: "<<planelement.LinienID);
		
		// jetzt neue Haltestellenfolge anlegen (hListe ausfuellen)
		list<int>* haltestellenfolge=0;
		try{haltestellenfolge=new list<int>;} // Liste mit den Punkten
		catch(...)
		{
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Haltestellenfolge konnte nicht angelegt werden. Speichermangel?"<<endl;
			cerr.flush();
		}
				
//                // Haltestllenfolge ausfuellen:
		/* EXEC SQL DECLARE liniencursor CURSOR FOR
			SELECT LinienID, LfdNr, HaltestellenID
				FROM LinienWeg
				WHERE SpeicherID = :speicherid AND LinienID = :planelement.LinienID; */ 

                /* EXEC SQL OPEN liniencursor; */ 

{
                struct sqlexd sqlstm;

                sqlorat((void **)0, &sqlctx, &oraca);
                sqlstm.sqlvsn = 8;
                sqlstm.arrsiz = 8;
                sqlstm.stmt = sq0757;
                sqlstm.iters = (unsigned int  )1;
                sqlstm.offset = (unsigned int  )13486;
                sqlstm.cud = sqlcud0;
                sqlstm.sqlest = (unsigned char  *)&sqlca;
                sqlstm.sqlety = (unsigned short)0;
                sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
                sqlstm.sqhstl[0] = (unsigned int  )4;
                sqlstm.sqindv[0] = (         short *)0;
                sqlstm.sqharm[0] = (unsigned int  )0;
                sqlstm.sqhstv[1] = (unsigned char  *)&(planelement.LinienID);
                sqlstm.sqhstl[1] = (unsigned int  )4;
                sqlstm.sqindv[1] = (         short *)0;
                sqlstm.sqharm[1] = (unsigned int  )0;
                sqlstm.sqphsv = sqlstm.sqhstv;
                sqlstm.sqphsl = sqlstm.sqhstl;
                sqlstm.sqpind = sqlstm.sqindv;
                sqlstm.sqparm = sqlstm.sqharm;
                sqlstm.sqparc = sqlstm.sqharc;
                sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
                if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenBuslinien");
}


                for(;;)
		{
			/* EXEC SQL FETCH liniencursor INTO :linienelement; */ 

{
   struct sqlexd sqlstm;

   sqlorat((void **)0, &sqlctx, &oraca);
   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 8;
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )13508;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlstm.sqhstv[0] = (unsigned char  *)&linienelement.LinienID;
   sqlstm.sqhstl[0] = (unsigned int  )4;
   sqlstm.sqindv[0] = (         short *)0;
   sqlstm.sqharm[0] = (unsigned int  )0;
   sqlstm.sqhstv[1] = (unsigned char  *)&linienelement.LfdNr;
   sqlstm.sqhstl[1] = (unsigned int  )4;
   sqlstm.sqindv[1] = (         short *)0;
   sqlstm.sqharm[1] = (unsigned int  )0;
   sqlstm.sqhstv[2] = (unsigned char  *)&linienelement.HaltestellenID;
   sqlstm.sqhstl[2] = (unsigned int  )4;
   sqlstm.sqindv[2] = (         short *)0;
   sqlstm.sqharm[2] = (unsigned int  )0;
   sqlstm.sqphsv = sqlstm.sqhstv;
   sqlstm.sqphsl = sqlstm.sqhstl;
   sqlstm.sqpind = sqlstm.sqindv;
   sqlstm.sqparm = sqlstm.sqharm;
   sqlstm.sqparc = sqlstm.sqharc;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
   if (sqlca.sqlcode == 1403) break;
   if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenBuslinien");
}


                        haltestellenfolge->append(linienelement.HaltestellenID);			
//			Debug(2, "...-> "<<linienelement.HaltestellenID);
		}
		/* EXEC SQL CLOSE liniencursor; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 8;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )13534;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenBuslinien");
}



		
		// Haltestellenfolge jetzt an die Linie haengen:
		einelinie->setzenhListe(haltestellenfolge);
		// Und in die Buslinien einhaengen:
		buslinien->append(einelinie);
	}

        /* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	
	// und nach getaner arbeit Cursor wieder schliessen:
	/* EXEC SQL CLOSE plancursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 8;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )13548;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenBuslinien");
}



	return buslinien;
}
//------------------------------------------------------------------------------
// Funktionsname:	speichernBusLinien
// Beschreibung:	Mit dieser Methode werden die Buslinien gespeichert (Ergebnis des Linienplans)
// Parameter:		Wegenetzgraph und Liste mit Linien
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::speichernBusLinien(GRAPH<CFPlanGraphKnoten*, CFPlanGraphKante*>* fpgraph=0,list<CLinie*>* buslinien=0, int planid=0) // gehoert zum Wegenetzgraphen: speichert die Knoten des Graphen, der vom LP zurueck gegeben wird
{
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in speichernBusLinien"); */ 


	Debug(2, "SpeichernBusLinien(Linienplan-Ergebnis)");
	if((buslinien!=0)&&(fpgraph!=0))
        {
		//1. Lege fuer die Liste in LinienPlan-Tablle ab, welche Linien zu speichern sind
		//2. Speichere jede Linie in LinienWeg und in LinienWerte. Hole dabei die benoetigten Werte aus dem Graphen
                /* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
		// Datenfelder anlegen, die als Zwischenspeicher dienen:
		typedef struct	// unser gesamter Buslinienplan
		{
			double speicherID;
			int PlanID;
			/* VARCHAR Beschreibung[70]; */ 
struct { unsigned short len; unsigned char arr[70]; } Beschreibung;

			int LinienID;
		} buslinienplanelement;
		buslinienplanelement planelement;

		typedef struct	// eine Buslinie -> LinienWeg
		{
			double speicherID;
			int PlanID;
			int LinienID;
			int LfdNr;
			int HaltestellenID;
		} buslinienelement;
		buslinienelement linienwegelement;

		typedef struct	// der Rest des Graphen (was an Linien dran steht) -> LinienWerte
		{
			double speicherID;
			long LfdNr;
			int PlanID;
			int LinienID;
			int VonHaltestelle;
			int NachHaltestelle;
			int Reisezeit;
			int Verkehrsstrom;
		} buslinienwerteelement;
		buslinienwerteelement linienwerteelement;
		
		/* EXEC SQL END DECLARE SECTION; */ 
	
                planelement.speicherID = speicherstand;
		linienwegelement.speicherID=speicherstand;
		linienwerteelement.speicherID=speicherstand;

                // PlanID ist im 1.Prototypen immer 0
		planelement.PlanID=planid;
		// Beschreibung ist im 1.Prototypen immer "StandardPlan"
		//strncpy((char*)planelement.Beschreibung.arr, "StandardPlan", 70);
		sprintf((char*)planelement.Beschreibung.arr, "StandardPlan");
		planelement.Beschreibung.len=strlen((char*)planelement.Beschreibung.arr);

		CFortschritt* fortschritt=0;
		if(batchbetrieb==false) 
		{
			try{fortschritt=new CFortschritt("Speichern der Ergebnisdaten");}
			catch(...)
			{
				cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Fortschrittsanzeige beim Speichern der Buslinien konnte nicht angelegt werden. Speichermangel?"<<endl;
				cerr.flush();
			}
		}
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Loesche alte Buslinien in der Datenbank...");

		// Loesche die entsprechenden Bereiche:
		/* EXEC SQL DELETE FROM LinienPlan WHERE SpeicherID = :planelement.speicherID; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 8;
  sqlstm.stmt = "delete from LinienPlan  where SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )13562;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&(planelement.speicherID);
  sqlstm.sqhstl[0] = (unsigned int  )8;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernBusLinien");
}


		/* EXEC SQL DELETE FROM LinienWeg WHERE SpeicherID = :linienwegelement.speicherID; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 8;
  sqlstm.stmt = "delete from LinienWeg  where SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )13580;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&(linienwegelement.speicherID);
  sqlstm.sqhstl[0] = (unsigned int  )8;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernBusLinien");
}


		/* EXEC SQL DELETE FROM LinienWerte WHERE SpeicherID = :linienwerteelement.speicherID; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 8;
  sqlstm.stmt = "delete from LinienWerte  where SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )13598;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&(linienwerteelement.speicherID);
  sqlstm.sqhstl[0] = (unsigned int  )8;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernBusLinien");
}



		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Speichere alle Buslinien in der Datenbank...");
		
		//Durchlaufe jetzt alle Linien, weise ihnen eine ID zu (beg. bei 0) und schiebe den ganzen Kram
		// in Oracle
//		planelement.LinienID=0;
		CLinie* einelinie=0;
		int durchlauf=0;
		forall(einelinie, *buslinien)
		{

			planelement.LinienID=einelinie->holenID();
			// Fuer alle Linien des Plans (LinienPLAN)
			// sage erstmal, dass diese Linie zu dem Plan gehoert:
		        /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in speichernBuslinie: insert Linienplan"); */ 

                	/* EXEC SQL INSERT INTO LinienPlan
				VALUES (:planelement); */ 

{
                 struct sqlexd sqlstm;

                 sqlorat((void **)0, &sqlctx, &oraca);
                 sqlstm.sqlvsn = 8;
                 sqlstm.arrsiz = 8;
                 sqlstm.stmt = "insert into LinienPlan values (:s1 ,:s2 ,:s3\
 ,:s4 )";
                 sqlstm.iters = (unsigned int  )1;
                 sqlstm.offset = (unsigned int  )13616;
                 sqlstm.cud = sqlcud0;
                 sqlstm.sqlest = (unsigned char  *)&sqlca;
                 sqlstm.sqlety = (unsigned short)0;
                 sqlstm.sqhstv[0] = (unsigned char  *)&planelement.speicherID;
                 sqlstm.sqhstl[0] = (unsigned int  )8;
                 sqlstm.sqindv[0] = (         short *)0;
                 sqlstm.sqharm[0] = (unsigned int  )0;
                 sqlstm.sqhstv[1] = (unsigned char  *)&planelement.PlanID;
                 sqlstm.sqhstl[1] = (unsigned int  )4;
                 sqlstm.sqindv[1] = (         short *)0;
                 sqlstm.sqharm[1] = (unsigned int  )0;
                 sqlstm.sqhstv[2] = (unsigned char  *)&planelement.Beschreibung;
                 sqlstm.sqhstl[2] = (unsigned int  )72;
                 sqlstm.sqindv[2] = (         short *)0;
                 sqlstm.sqharm[2] = (unsigned int  )0;
                 sqlstm.sqhstv[3] = (unsigned char  *)&planelement.LinienID;
                 sqlstm.sqhstl[3] = (unsigned int  )4;
                 sqlstm.sqindv[3] = (         short *)0;
                 sqlstm.sqharm[3] = (unsigned int  )0;
                 sqlstm.sqphsv = sqlstm.sqhstv;
                 sqlstm.sqphsl = sqlstm.sqhstl;
                 sqlstm.sqpind = sqlstm.sqindv;
                 sqlstm.sqparm = sqlstm.sqharm;
                 sqlstm.sqparc = sqlstm.sqharc;
                 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
                 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernBuslinie: insert Linienplan");
}


                        
                        // Jetzt durchalaufe die Linie uns sage, welche Knoten (IDs) zur Linie gehoeren:
			int hst;
			int laufendenummer=0;
			forall(hst, *(einelinie->holenhListe()))
			{
				linienwegelement.PlanID=planid;
				linienwegelement.LinienID=planelement.LinienID; // zu dieser Linie gehoert die Haltestelle
				linienwegelement.LfdNr=laufendenummer; // einfach nur eine laufende Nummer
				laufendenummer++;
				linienwegelement.HaltestellenID=hst; // das Wichtigste ueberhaupt: die ID der Haltestelle				
				
				// LinienWEG
				/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in speichernBusLinien: insert LinienWeg"); */ 

				/* EXEC SQL INSERT INTO LinienWeg
					VALUES (:linienwegelement); */ 

{
    struct sqlexd sqlstm;

    sqlorat((void **)0, &sqlctx, &oraca);
    sqlstm.sqlvsn = 8;
    sqlstm.arrsiz = 8;
    sqlstm.stmt = "insert into LinienWeg values (:s1 ,:s2 ,:s3 ,:s4 ,:s5 )";
    sqlstm.iters = (unsigned int  )1;
    sqlstm.offset = (unsigned int  )13646;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char  *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlstm.sqhstv[0] = (unsigned char  *)&linienwegelement.speicherID;
    sqlstm.sqhstl[0] = (unsigned int  )8;
    sqlstm.sqindv[0] = (         short *)0;
    sqlstm.sqharm[0] = (unsigned int  )0;
    sqlstm.sqhstv[1] = (unsigned char  *)&linienwegelement.PlanID;
    sqlstm.sqhstl[1] = (unsigned int  )4;
    sqlstm.sqindv[1] = (         short *)0;
    sqlstm.sqharm[1] = (unsigned int  )0;
    sqlstm.sqhstv[2] = (unsigned char  *)&linienwegelement.LinienID;
    sqlstm.sqhstl[2] = (unsigned int  )4;
    sqlstm.sqindv[2] = (         short *)0;
    sqlstm.sqharm[2] = (unsigned int  )0;
    sqlstm.sqhstv[3] = (unsigned char  *)&linienwegelement.LfdNr;
    sqlstm.sqhstl[3] = (unsigned int  )4;
    sqlstm.sqindv[3] = (         short *)0;
    sqlstm.sqharm[3] = (unsigned int  )0;
    sqlstm.sqhstv[4] = (unsigned char  *)&linienwegelement.HaltestellenID;
    sqlstm.sqhstl[4] = (unsigned int  )4;
    sqlstm.sqindv[4] = (         short *)0;
    sqlstm.sqharm[4] = (unsigned int  )0;
    sqlstm.sqphsv = sqlstm.sqhstv;
    sqlstm.sqphsl = sqlstm.sqhstl;
    sqlstm.sqpind = sqlstm.sqindv;
    sqlstm.sqparm = sqlstm.sqharm;
    sqlstm.sqparc = sqlstm.sqharc;
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
    if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernBusLinien: insert LinienWeg");
}



//				Debug(2, "...-> "<<linienwegelement.LinienID<<","<<linienwegelement.LfdNr<<","<<linienwegelement.HaltestellenID);
                        	
				/* EXEC SQL COMMIT; */ 

{
    struct sqlexd sqlstm;

    sqlorat((void **)0, &sqlctx, &oraca);
    sqlstm.sqlvsn = 8;
    sqlstm.arrsiz = 8;
    sqlstm.iters = (unsigned int  )1;
    sqlstm.offset = (unsigned int  )13680;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char  *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
    if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernBusLinien: insert LinienWeg");
}


			}		
			
			if(fortschritt!=0) fortschritt->anzeigenFortschritt(++durchlauf, buslinien->length());

//			Debug(2, planelement.PlanID<<","<<planelement.Beschreibung.arr<<","<<planelement.LinienID);
//			planelement.LinienID++; // und die ID der Linie um eins erhoehen
		}
  
	
                // LinienWERTE fuellen (=Rest des Graphen):
		// durchlaufe jede Kante des Graphen:
		// hole die IDs der beiden Knoten, fuelle die entsprechende Struktur und ab damit 
		// in die Datenbank:
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Speichere alle Kanten des Fahrplangraphen in der Datenbank...");

//		Debug(2, "Speichern der LinienWERTE (Rest des Graphen):");
		linienwerteelement.LfdNr=0;
		edge e;
		durchlauf=0;
	        forall_edges(e, *fpgraph)
		{
			//fuelle die Struktur aus:
			//linienwerteelement.PlanID=planid;
			linienwerteelement.PlanID=0;
			linienwerteelement.LinienID=(fpgraph->inf(e))->holenLinienID();
			linienwerteelement.LfdNr++;
			linienwerteelement.VonHaltestelle=(fpgraph->inf(fpgraph->source(e)))->holenID();
			linienwerteelement.NachHaltestelle=(fpgraph->inf(fpgraph->target(e)))->holenID();
			linienwerteelement.Reisezeit=(fpgraph->inf(e))->holenFahrtzeit();
			linienwerteelement.Verkehrsstrom=(fpgraph->inf(e))->holenVerkehrsstrom();
			// LinienWERTE
			/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in speichernBusLinien: insert LinienWerte"); */ 

			/* EXEC SQL INSERT INTO LinienWerte
				VALUES (:linienwerteelement); */ 

{
   struct sqlexd sqlstm;

   sqlorat((void **)0, &sqlctx, &oraca);
   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 8;
   sqlstm.stmt = "insert into LinienWerte values (:s1 ,:s2 ,:s3 ,:s4 ,:s5 ,:\
s6 ,:s7 ,:s8 )";
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )13694;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlstm.sqhstv[0] = (unsigned char  *)&linienwerteelement.speicherID;
   sqlstm.sqhstl[0] = (unsigned int  )8;
   sqlstm.sqindv[0] = (         short *)0;
   sqlstm.sqharm[0] = (unsigned int  )0;
   sqlstm.sqhstv[1] = (unsigned char  *)&linienwerteelement.LfdNr;
   sqlstm.sqhstl[1] = (unsigned int  )4;
   sqlstm.sqindv[1] = (         short *)0;
   sqlstm.sqharm[1] = (unsigned int  )0;
   sqlstm.sqhstv[2] = (unsigned char  *)&linienwerteelement.PlanID;
   sqlstm.sqhstl[2] = (unsigned int  )4;
   sqlstm.sqindv[2] = (         short *)0;
   sqlstm.sqharm[2] = (unsigned int  )0;
   sqlstm.sqhstv[3] = (unsigned char  *)&linienwerteelement.LinienID;
   sqlstm.sqhstl[3] = (unsigned int  )4;
   sqlstm.sqindv[3] = (         short *)0;
   sqlstm.sqharm[3] = (unsigned int  )0;
   sqlstm.sqhstv[4] = (unsigned char  *)&linienwerteelement.VonHaltestelle;
   sqlstm.sqhstl[4] = (unsigned int  )4;
   sqlstm.sqindv[4] = (         short *)0;
   sqlstm.sqharm[4] = (unsigned int  )0;
   sqlstm.sqhstv[5] = (unsigned char  *)&linienwerteelement.NachHaltestelle;
   sqlstm.sqhstl[5] = (unsigned int  )4;
   sqlstm.sqindv[5] = (         short *)0;
   sqlstm.sqharm[5] = (unsigned int  )0;
   sqlstm.sqhstv[6] = (unsigned char  *)&linienwerteelement.Reisezeit;
   sqlstm.sqhstl[6] = (unsigned int  )4;
   sqlstm.sqindv[6] = (         short *)0;
   sqlstm.sqharm[6] = (unsigned int  )0;
   sqlstm.sqhstv[7] = (unsigned char  *)&linienwerteelement.Verkehrsstrom;
   sqlstm.sqhstl[7] = (unsigned int  )4;
   sqlstm.sqindv[7] = (         short *)0;
   sqlstm.sqharm[7] = (unsigned int  )0;
   sqlstm.sqphsv = sqlstm.sqhstv;
   sqlstm.sqphsl = sqlstm.sqhstl;
   sqlstm.sqpind = sqlstm.sqindv;
   sqlstm.sqparm = sqlstm.sqharm;
   sqlstm.sqparc = sqlstm.sqharc;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
   if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernBusLinien: insert LinienWerte");
}


			
			/* EXEC SQL COMMIT; */ 

{
   struct sqlexd sqlstm;

   sqlorat((void **)0, &sqlctx, &oraca);
   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 8;
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )13740;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
   if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernBusLinien: insert LinienWerte");
}


//			Debug(2, "...-> "<<linienwerteelement.PlanID<<","<<linienwerteelement.LinienID<<","<<linienwerteelement.VonHaltestelle<<","<<linienwerteelement.NachHaltestelle<<","<<linienwerteelement.Reisezeit<<","<<linienwerteelement.Verkehrsstrom);
			if(fortschritt!=0) fortschritt->anzeigenFortschritt(++durchlauf, fpgraph->number_of_edges());
		}

				
                /* EXEC SQL COMMIT; */ 

{
                struct sqlexd sqlstm;

                sqlorat((void **)0, &sqlctx, &oraca);
                sqlstm.sqlvsn = 8;
                sqlstm.arrsiz = 8;
                sqlstm.iters = (unsigned int  )1;
                sqlstm.offset = (unsigned int  )13754;
                sqlstm.cud = sqlcud0;
                sqlstm.sqlest = (unsigned char  *)&sqlca;
                sqlstm.sqlety = (unsigned short)0;
                sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
                if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernBusLinien: insert LinienWerte");
}



		CLinie* terminator=0;
		list<int> *terminator2=0;
		forall(terminator, *buslinien) {
			terminator2=terminator->holenhListe();
			delete terminator2;
		}
		delete buslinien;
                if(fortschritt!=0) delete fortschritt;
	}// endif: test auf Nullzeiger
	else cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: speichernBusLinien: NULL-Zeiger wurde uebergeben!"<<endl;
}

//------------------------------------------------------------------------------
// Funktionsname:	holenFahrplanGraph
// Beschreibung:	holt den Fahrplan-Graphen mit saemtlichen Buslinien aus der Datenbank (Linienplan Ergebnis)
// Parameter:		id des Plans, dessen Graph geholt werden sollen
// Rueckgabe:		Buslinie in Form eine Liste von CLinien
// Besonderheiten:	
//------------------------------------------------------------------------------
GRAPH<CFPlanGraphKnoten*, CFPlanGraphKante*>* CDBSchnittstelle::holenFahrplanGraph(int planid=0)
{
	// den Rueckgabegraphen anlegen: 
	GRAPH<CFPlanGraphKnoten*, CFPlanGraphKante*>* fahrplangraph=0;
	try{fahrplangraph=new GRAPH<CFPlanGraphKnoten*, CFPlanGraphKante*>;}
	catch(...)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: der Fahrplangraph konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}

        // Vorgehen:
	// Hole eine Kante nach der anderen aus der Datenbank
	// Schaue, ob die Knoten im Graphen schon drin sind, wenn ja verwende dies
	// erstelle eine neue Kante zwischen den beiden Knoten und fuege sie in den Graphen ein:
	/* EXEC SQL BEGIN DECLARE SECTION; */ 

	typedef struct	// der Rest des Graphen (was an Linien dran steht) -> LinienWerte
	{
		double speicherID;
		long LfdNr;
		int PlanID;
		int LinienID;
		int VonHaltestelle;
		int NachHaltestelle;
		int Reisezeit;
		int Verkehrsstrom;
	} buslinienwerteelement;
	buslinienwerteelement linienwerteelement;
	int speicherid=speicherstand;
	int plannummer=planid;
	/* EXEC SQL END DECLARE SECTION; */ 
	
	
	// erzeuge die Cursor, mit dem Daten durchlaufen werden:
	/* EXEC SQL DECLARE linienwertecursor CURSOR FOR
		SELECT SpeicherID, LfdNr, PlanID, LinienID, VonHaltestelle, NachHaltestelle, Reisezeit, Verkehrsstrom
			FROM LinienWerte
			WHERE SpeicherID = :speicherid AND PlanID = :plannummer; */ 


	// jetzt die Cursor oeffnen
        /* EXEC SQL OPEN linienwertecursor; */ 

{
        struct sqlexd sqlstm;

        sqlorat((void **)0, &sqlctx, &oraca);
        sqlstm.sqlvsn = 8;
        sqlstm.arrsiz = 8;
        sqlstm.stmt = sq0767;
        sqlstm.iters = (unsigned int  )1;
        sqlstm.offset = (unsigned int  )13768;
        sqlstm.cud = sqlcud0;
        sqlstm.sqlest = (unsigned char  *)&sqlca;
        sqlstm.sqlety = (unsigned short)0;
        sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
        sqlstm.sqhstl[0] = (unsigned int  )4;
        sqlstm.sqindv[0] = (         short *)0;
        sqlstm.sqharm[0] = (unsigned int  )0;
        sqlstm.sqhstv[1] = (unsigned char  *)&plannummer;
        sqlstm.sqhstl[1] = (unsigned int  )4;
        sqlstm.sqindv[1] = (         short *)0;
        sqlstm.sqharm[1] = (unsigned int  )0;
        sqlstm.sqphsv = sqlstm.sqhstv;
        sqlstm.sqphsl = sqlstm.sqhstl;
        sqlstm.sqpind = sqlstm.sqindv;
        sqlstm.sqparm = sqlstm.sqharm;
        sqlstm.sqparc = sqlstm.sqharc;
        sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
        if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernBusLinien: insert LinienWerte");
}


        // und jetzt in Schleife alle Dinger holen:
	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

	for(;;)
	{
		/* EXEC SQL FETCH linienwertecursor INTO :linienwerteelement; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 8;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )13790;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&linienwerteelement.speicherID;
  sqlstm.sqhstl[0] = (unsigned int  )8;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&linienwerteelement.LfdNr;
  sqlstm.sqhstl[1] = (unsigned int  )4;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&linienwerteelement.PlanID;
  sqlstm.sqhstl[2] = (unsigned int  )4;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqhstv[3] = (unsigned char  *)&linienwerteelement.LinienID;
  sqlstm.sqhstl[3] = (unsigned int  )4;
  sqlstm.sqindv[3] = (         short *)0;
  sqlstm.sqharm[3] = (unsigned int  )0;
  sqlstm.sqhstv[4] = (unsigned char  *)&linienwerteelement.VonHaltestelle;
  sqlstm.sqhstl[4] = (unsigned int  )4;
  sqlstm.sqindv[4] = (         short *)0;
  sqlstm.sqharm[4] = (unsigned int  )0;
  sqlstm.sqhstv[5] = (unsigned char  *)&linienwerteelement.NachHaltestelle;
  sqlstm.sqhstl[5] = (unsigned int  )4;
  sqlstm.sqindv[5] = (         short *)0;
  sqlstm.sqharm[5] = (unsigned int  )0;
  sqlstm.sqhstv[6] = (unsigned char  *)&linienwerteelement.Reisezeit;
  sqlstm.sqhstl[6] = (unsigned int  )4;
  sqlstm.sqindv[6] = (         short *)0;
  sqlstm.sqharm[6] = (unsigned int  )0;
  sqlstm.sqhstv[7] = (unsigned char  *)&linienwerteelement.Verkehrsstrom;
  sqlstm.sqhstl[7] = (unsigned int  )4;
  sqlstm.sqindv[7] = (         short *)0;
  sqlstm.sqharm[7] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernBusLinien: insert LinienWerte");
}



		// OK, jetzt haben wir eine Kante.
		// a) Nachschauen, ob der Startknoten drin ist:
		node* startknoten=0;
		node* endknoten=0;
		node tempknoten;
		forall_nodes(tempknoten, *fahrplangraph)
		{
			// Startknoten:
			if((fahrplangraph->inf(tempknoten))->holenID()==linienwerteelement.VonHaltestelle)
			{
				try{startknoten = new node(tempknoten);}
				catch(...)
				{
					cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: ein (Start)Knoten des Fahrplangraphen konnte nicht angelegt werden. Speichermangel?"<<endl;
					cerr.flush();
				}
			}
			// Endknoten:
			if((fahrplangraph->inf(tempknoten))->holenID()==linienwerteelement.NachHaltestelle)	
			{
				try{endknoten = new node(tempknoten);}
				catch(...)
				{
					cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER:  ein (End)Knoten konnte nicht angelegt werden. Speichermangel?"<<endl;
					cerr.flush();
				}
			}
			if((startknoten!=0) && (endknoten!=0)) break; // vorzeitiger Abbruch, wenn wir schon was gefunden haben
		}
		// jetzt habe ich die beiden Knoten. Sollte einer NULL sein, muessen wir den jetzt anlegen:
		if(startknoten==0)
		{
			CFPlanGraphKnoten* tempfpknoten=0;
			try{tempfpknoten=new CFPlanGraphKnoten();}
			catch(...)
			{
				cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: ein Hilfsknoten (Start) konnte nicht angelegt werden. Speichermangel?"<<endl;
				cerr.flush();
			}
			tempfpknoten->setzenID(linienwerteelement.VonHaltestelle);
			try{startknoten=new node(fahrplangraph->new_node(tempfpknoten));}
			catch(...)
			{
				cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: ein Hilfsknoten (LEDA/Start) konnte nicht angelegt werden. Speichermangel?"<<endl;
				cerr.flush();
			}
		}
		if(endknoten==0)
		{
			CFPlanGraphKnoten* tempfpknoten=0;
			try{tempfpknoten=new CFPlanGraphKnoten();}
			catch(...)
			{
				cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: ein Hilfsknoten (Ende) konnte nicht angelegt werden. Speichermangel?"<<endl;
				cerr.flush();
			}
			tempfpknoten->setzenID(linienwerteelement.NachHaltestelle);
			try{endknoten=new node(fahrplangraph->new_node(tempfpknoten));}
			catch(...)
			{
				cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: ein Hilfsknoten (LEDA/Ende) konnte nicht angelegt werden. Speichermangel?"<<endl;
				cerr.flush();
			}
		}
  
		// Jetzt habe ich den Anfangs- und Endknoten aus dem Graph;
		// d.h. lege jetzt eine neue Kante an:
		CFPlanGraphKante* neueKante=0;
		try{neueKante=new CFPlanGraphKante();}
		catch(...)
		{
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: eine Kante des Fahrplangraphen konnte nicht angelegt werden. Speichermangel?"<<endl;
			cerr.flush();
		}
		neueKante->setzenLinienID(linienwerteelement.LinienID);
		neueKante->setzenFahrtzeit(linienwerteelement.Reisezeit);
		neueKante->setzenVerkehrsstrom(linienwerteelement.Verkehrsstrom);
		
		// Kante an den Knoten in den Graph haengen:
		fahrplangraph->new_edge(*startknoten, *endknoten, neueKante);

		// und wieder aufraeumen:
		delete startknoten;
		delete endknoten;
	}

	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	
	// und nach getaner arbeit Cursor wieder schliessen:
		/* EXEC SQL CLOSE linienwertecursor; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 8;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )13836;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernBusLinien: insert LinienWerte");
}



	return fahrplangraph; // und den Graphen rausgeben
}

//------------------------------------------------------------------------------
// Funktionsname:	speichernGuetemasse
// Beschreibung:	Mit dieser Methode werden die Guetemasse in der Datenbank gepseichert
// Parameter:		ein Zeiger auf eine Guetemassklasse
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::speichernGuetemasse(CGuetemasse * guetemasse)
{
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in speichernGuetemasse"); */ 

	if(guetemasse!=0)
	{
		Debug(2, "speichernGuetemasse");
	        CFortschritt* fortschritt=0;
		if(batchbetrieb==false) 
		{
			try{fortschritt=new CFortschritt("Speichern der Ergebnisdaten");}
			catch(...)
			{
				cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Fortschrittsanzeige beim Speichern der Guetemasse konnte nicht angelegt werden. Speichermangel?"<<endl;
				cerr.flush();
			}
		}
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("speichere die Guetemasse");
		Debug(2, "nach dem Anlegen der Fortschrittsanzeige");
		// erst ein paar dummywerte anlegen, damit Oracle die erkennt:
		/* EXEC SQL BEGIN DECLARE SECTION; */ 
	
		typedef struct
		{
			int SpeicherID;

			int HSAnzahlHaltestellen;
 			double HSBevUeberVersorgung;
			double HSBevUnterVersorgung;
 			double HSFlUeberVersorgung;
 			double HSFlUnterVersorgung;
 			double HSBevVersorgungProzent;
 			double HSFlVersorgungProzent;
			double HSFussweg;
			int HSDirekteReisezeitAuto;

			int LPAnzahlUmstiege;
			double LPVerbindungenUmstiegszwang;
			int LPGesamtfahrer;
			int LPDirektfahrer;
			int LPMittlereReisezeit;
			double LPDirektfahreranteil;
			int LPStreckenkilometer;
			int LPGesamteStreckenkilometer;
			int LPMittlereMindestreisezeit;
			double LPReisezeitverlaengerung;
			int LPAnzahlLinien;
			double LPMittlererVerknuepfungsgrad;

			double FPAnzahlBusse;
 			double FPNetzbedingteWartezeit;
			double FPWartezeitAufwandGesamt;
			double FPMindestwartezeitAufwand;
			double FPGesamtzeitAufwand;
			double FPFahrplanwirkungsgrad;

			double GBDurchschnittAnzahlBusse;
			double GBMittlereReisezeit;
			double GBAnzahlPersonen;
			double GBReisezeitZuDirektfahrer;
			double GBMindestreisezeitZuDirekt;

			double LPProzentVerbkeineDir;
		} gmelem;
		gmelem element;

		typedef struct
		{
			int SpeicherID;
			int HaltestelleA;
			int HaltestelleB;
			double Reisezeit;
		} rzaelem;
		rzaelem reiseelement;

		double rz_speicherID[10000];
		int HaltestelleA[10000];
		int HaltestelleB[10000];
		double Reisezeit[10000];
		int speicherNummer;
		int zeilenZaehler;
		int speichernr=speicherstand;
 		/* EXEC SQL END DECLARE SECTION; */ 


		element.SpeicherID=speicherstand;
                // Mit Werten fuellen:
		Debug(2, "holenAnzahlHaltestellen() ");
		element.HSAnzahlHaltestellen=guetemasse->holenAnzahlHaltestellen();
		Debug(2, " "<<element.HSAnzahlHaltestellen);
		Debug(2, "holenBevoelkerungsUeberversorgung()");
		element.HSBevUeberVersorgung=guetemasse->holenBevoelkerungsUeberversorgung();
		Debug(2, " "<<element.HSBevUeberVersorgung);
		Debug(2, "holenBevoelkerungsUnterversorgung()");
		element.HSBevUnterVersorgung=guetemasse->holenBevoelkerungsUnterversorgung();
		Debug(2, " "<<element.HSBevUnterVersorgung);
		Debug(2, "holenFlaechenUeberversorgung()");
 		element.HSFlUeberVersorgung=guetemasse->holenFlaechenUeberversorgung();
		Debug(2, " "<<element.HSFlUeberVersorgung);
		Debug(2, "holenFlaechenUnterversorgung()");
 		element.HSFlUnterVersorgung=guetemasse->holenFlaechenUnterversorgung();
		Debug(2, " "<<element.HSFlUnterVersorgung);
		Debug(2, "holenFlaechenVersorgunginProzent()");
 		element.HSBevVersorgungProzent=guetemasse->holenFlaechenVersorgunginProzent();
		Debug(2, " "<<element.HSBevVersorgungProzent);
		Debug(2, "holenBevoelkerungsVersorgunginProzent()");
 		element.HSFlVersorgungProzent=guetemasse->holenBevoelkerungsVersorgunginProzent();
		Debug(2, " "<<element.HSFlVersorgungProzent);
		Debug(2, "holenFusswegProHaltestelle()");
		element.HSFussweg=guetemasse->holenFusswegProHaltestelle();
		Debug(2, " "<<element.HSFussweg);
		Debug(2, "HSDirekteReisezeitAuto=0");
		element.HSDirekteReisezeitAuto=0;// ist immer 0, da komplexere Struktur!!!
		Debug(2, " "<<element.HSDirekteReisezeitAuto);

		Debug(2, "holenAnzahlUmstiege()");
		element.LPAnzahlUmstiege=guetemasse->holenAnzahlUmstiege();
		Debug(2, " "<<element.LPAnzahlUmstiege);
		Debug(2, "holenAnzahlVerbindungenmitUmstiegzwang()");
		element.LPVerbindungenUmstiegszwang=guetemasse->holenAnzahlVerbindungenmitUmstiegzwang();
		Debug(2, " "<<element.LPVerbindungenUmstiegszwang);
		Debug(2, "holenGesamtfahrer()");
		element.LPGesamtfahrer=guetemasse->holenGesamtfahrer();
		Debug(2, " "<<element.LPGesamtfahrer);
		Debug(2, "holenDirektfahrer()");
		element.LPDirektfahrer=guetemasse->holenDirektfahrer();
		Debug(2, " "<<element.LPDirektfahrer);
		Debug(2, "holenMittlereResezeit()");
		element.LPMittlereReisezeit=guetemasse->holenMittlereResezeit();
		Debug(2, " "<<element.LPMittlereReisezeit);
		Debug(2, "holenDirektfahreranteil()");
		element.LPDirektfahreranteil=guetemasse->holenDirektfahreranteil();
		Debug(2, " "<<element.LPDirektfahreranteil);
		Debug(2, "holenStreckenkilometer()");
		element.LPStreckenkilometer=guetemasse->holenStreckenkilometer();
		Debug(2, " "<<element.LPStreckenkilometer);
		Debug(2, "holenGesamteStreckenkilometer()");
		element.LPGesamteStreckenkilometer=guetemasse->holenGesamteStreckenkilometer();
		Debug(2, " "<<element.LPGesamteStreckenkilometer);
		Debug(2, "holenMittlereMindestreisezeit()");
		element.LPMittlereMindestreisezeit=guetemasse->holenMittlereMindestreisezeit();
		Debug(2, " "<<element.LPMittlereMindestreisezeit);
		Debug(2, "holenReisezeitverlaengerung()");
		element.LPReisezeitverlaengerung=guetemasse->holenReisezeitverlaengerung();
		Debug(2, " "<<element.LPReisezeitverlaengerung);
		Debug(2, "holenLinienanzahl()");
		element.LPAnzahlLinien=guetemasse->holenLinienanzahl();
		Debug(2, " "<<element.LPAnzahlLinien);
		Debug(2, "holenMittlerenVerknuepfungsgrad()");
		element.LPMittlererVerknuepfungsgrad=guetemasse->holenMittlerenVerknuepfungsgrad();
		Debug(2, " "<<element.LPMittlererVerknuepfungsgrad);
		Debug(2, "holenAnzahlBusse()");
		element.FPAnzahlBusse=guetemasse->holenAnzahlBusse();
		Debug(2, " "<<element.FPAnzahlBusse);
		Debug(2, "holenNetzbedingteWartezeitenGesamt()");
 		element.FPNetzbedingteWartezeit=guetemasse->holenNetzbedingteWartezeitenGesamt();
		Debug(2, " "<<element.FPNetzbedingteWartezeit);
		Debug(2, "holenWartezeitenAufwandGesamt()");
		element.FPWartezeitAufwandGesamt=guetemasse->holenWartezeitenAufwandGesamt();
		Debug(2, " "<<element.FPWartezeitAufwandGesamt);
		Debug(2, "holenMindestwartezeitaufwand()");
		element.FPMindestwartezeitAufwand=guetemasse->holenMindestwartezeitaufwand();
		Debug(2, " "<<element.FPMindestwartezeitAufwand);
		Debug(2, "holenGesamtzeitaufwand()");
		element.FPGesamtzeitAufwand=guetemasse->holenGesamtzeitaufwand();
		Debug(2, " "<<element.FPGesamtzeitAufwand);
		Debug(2, "holenFahrplanwirkungsgrad()");
		element.FPFahrplanwirkungsgrad=guetemasse->holenFahrplanwirkungsgrad();
		Debug(2, " "<<element.FPFahrplanwirkungsgrad);
		Debug(2, "holenDurchschnittlicheAnzahlBusse()");
		element.GBDurchschnittAnzahlBusse=guetemasse->holenDurchschnittlicheAnzahlBusse();
		Debug(2, " "<<element.GBDurchschnittAnzahlBusse);
		Debug(2, "holenMittlereReisezeit()");
		element.GBMittlereReisezeit=guetemasse->holenMittlereReisezeit();
		Debug(2, " "<<element.GBMittlereReisezeit);
		Debug(2, "holenAnzahlPersonen()");
		element.GBAnzahlPersonen=guetemasse->holenAnzahlPersonen();
		Debug(2, " "<<element.GBAnzahlPersonen);
		Debug(2, "holenReisezeitZuDirektfahrer()");
		element.GBReisezeitZuDirektfahrer=guetemasse->holenReisezeitZuDirektfahrer();
		Debug(2, " "<<element.GBReisezeitZuDirektfahrer);
		Debug(2, "holenMindestreisezeitZuDirektfahrer()");
		element.GBMindestreisezeitZuDirekt=guetemasse->holenMindestreisezeitZuDirektfahrer();
		Debug(2, " "<<element.GBMindestreisezeitZuDirekt);
		Debug(2, "holenProzentsatzVerbindungendiekeineDirektfahrten()");

		element.LPProzentVerbkeineDir=guetemasse->holenProzentsatzVerbindungendiekeineDirektfahrten();
		Debug(2, " "<<element.LPProzentVerbkeineDir);

		Debug(2, "loesche Tabelle Guetemasse...");
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("loesche die Tabellen...");
		//zunaechst die Tabelle loeschen:
		/* EXEC SQL DELETE FROM Guetemasse WHERE SpeicherID = :element.SpeicherID; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 8;
  sqlstm.stmt = "delete from Guetemasse  where SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )13850;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&(element.SpeicherID);
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernGuetemasse");
}


		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 8;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )13868;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernGuetemasse");
}


		

		Debug(2, "Speichere die einfachen Guetemasse...");
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("speichere die einfachen Guetemasse...");
		/* EXEC SQL INSERT INTO Guetemasse
			VALUES (:element); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 34;
  sqlstm.stmt = "insert into Guetemasse values (:s1 ,:s2 ,:s3 ,:s4 ,:s5 ,:s6\
 ,:s7 ,:s8 ,:s9 ,:s10 ,:s11 ,:s12 ,:s13 ,:s14 ,:s15 ,:s16 ,:s17 ,:s18 ,:s19 ,:\
s20 ,:s21 ,:s22 ,:s23 ,:s24 ,:s25 ,:s26 ,:s27 ,:s28 ,:s29 ,:s30 ,:s31 ,:s32 ,:\
s33 ,:s34 )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )13882;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&element.SpeicherID;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&element.HSAnzahlHaltestellen;
  sqlstm.sqhstl[1] = (unsigned int  )4;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&element.HSBevUeberVersorgung;
  sqlstm.sqhstl[2] = (unsigned int  )8;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqhstv[3] = (unsigned char  *)&element.HSBevUnterVersorgung;
  sqlstm.sqhstl[3] = (unsigned int  )8;
  sqlstm.sqindv[3] = (         short *)0;
  sqlstm.sqharm[3] = (unsigned int  )0;
  sqlstm.sqhstv[4] = (unsigned char  *)&element.HSFlUeberVersorgung;
  sqlstm.sqhstl[4] = (unsigned int  )8;
  sqlstm.sqindv[4] = (         short *)0;
  sqlstm.sqharm[4] = (unsigned int  )0;
  sqlstm.sqhstv[5] = (unsigned char  *)&element.HSFlUnterVersorgung;
  sqlstm.sqhstl[5] = (unsigned int  )8;
  sqlstm.sqindv[5] = (         short *)0;
  sqlstm.sqharm[5] = (unsigned int  )0;
  sqlstm.sqhstv[6] = (unsigned char  *)&element.HSBevVersorgungProzent;
  sqlstm.sqhstl[6] = (unsigned int  )8;
  sqlstm.sqindv[6] = (         short *)0;
  sqlstm.sqharm[6] = (unsigned int  )0;
  sqlstm.sqhstv[7] = (unsigned char  *)&element.HSFlVersorgungProzent;
  sqlstm.sqhstl[7] = (unsigned int  )8;
  sqlstm.sqindv[7] = (         short *)0;
  sqlstm.sqharm[7] = (unsigned int  )0;
  sqlstm.sqhstv[8] = (unsigned char  *)&element.HSFussweg;
  sqlstm.sqhstl[8] = (unsigned int  )8;
  sqlstm.sqindv[8] = (         short *)0;
  sqlstm.sqharm[8] = (unsigned int  )0;
  sqlstm.sqhstv[9] = (unsigned char  *)&element.HSDirekteReisezeitAuto;
  sqlstm.sqhstl[9] = (unsigned int  )4;
  sqlstm.sqindv[9] = (         short *)0;
  sqlstm.sqharm[9] = (unsigned int  )0;
  sqlstm.sqhstv[10] = (unsigned char  *)&element.LPAnzahlUmstiege;
  sqlstm.sqhstl[10] = (unsigned int  )4;
  sqlstm.sqindv[10] = (         short *)0;
  sqlstm.sqharm[10] = (unsigned int  )0;
  sqlstm.sqhstv[11] = (unsigned char  *)&element.LPVerbindungenUmstiegszwang;
  sqlstm.sqhstl[11] = (unsigned int  )8;
  sqlstm.sqindv[11] = (         short *)0;
  sqlstm.sqharm[11] = (unsigned int  )0;
  sqlstm.sqhstv[12] = (unsigned char  *)&element.LPGesamtfahrer;
  sqlstm.sqhstl[12] = (unsigned int  )4;
  sqlstm.sqindv[12] = (         short *)0;
  sqlstm.sqharm[12] = (unsigned int  )0;
  sqlstm.sqhstv[13] = (unsigned char  *)&element.LPDirektfahrer;
  sqlstm.sqhstl[13] = (unsigned int  )4;
  sqlstm.sqindv[13] = (         short *)0;
  sqlstm.sqharm[13] = (unsigned int  )0;
  sqlstm.sqhstv[14] = (unsigned char  *)&element.LPMittlereReisezeit;
  sqlstm.sqhstl[14] = (unsigned int  )4;
  sqlstm.sqindv[14] = (         short *)0;
  sqlstm.sqharm[14] = (unsigned int  )0;
  sqlstm.sqhstv[15] = (unsigned char  *)&element.LPDirektfahreranteil;
  sqlstm.sqhstl[15] = (unsigned int  )8;
  sqlstm.sqindv[15] = (         short *)0;
  sqlstm.sqharm[15] = (unsigned int  )0;
  sqlstm.sqhstv[16] = (unsigned char  *)&element.LPStreckenkilometer;
  sqlstm.sqhstl[16] = (unsigned int  )4;
  sqlstm.sqindv[16] = (         short *)0;
  sqlstm.sqharm[16] = (unsigned int  )0;
  sqlstm.sqhstv[17] = (unsigned char  *)&element.LPGesamteStreckenkilometer;
  sqlstm.sqhstl[17] = (unsigned int  )4;
  sqlstm.sqindv[17] = (         short *)0;
  sqlstm.sqharm[17] = (unsigned int  )0;
  sqlstm.sqhstv[18] = (unsigned char  *)&element.LPMittlereMindestreisezeit;
  sqlstm.sqhstl[18] = (unsigned int  )4;
  sqlstm.sqindv[18] = (         short *)0;
  sqlstm.sqharm[18] = (unsigned int  )0;
  sqlstm.sqhstv[19] = (unsigned char  *)&element.LPReisezeitverlaengerung;
  sqlstm.sqhstl[19] = (unsigned int  )8;
  sqlstm.sqindv[19] = (         short *)0;
  sqlstm.sqharm[19] = (unsigned int  )0;
  sqlstm.sqhstv[20] = (unsigned char  *)&element.LPAnzahlLinien;
  sqlstm.sqhstl[20] = (unsigned int  )4;
  sqlstm.sqindv[20] = (         short *)0;
  sqlstm.sqharm[20] = (unsigned int  )0;
  sqlstm.sqhstv[21] = (unsigned char  *)&element.LPMittlererVerknuepfungsgrad;
  sqlstm.sqhstl[21] = (unsigned int  )8;
  sqlstm.sqindv[21] = (         short *)0;
  sqlstm.sqharm[21] = (unsigned int  )0;
  sqlstm.sqhstv[22] = (unsigned char  *)&element.FPAnzahlBusse;
  sqlstm.sqhstl[22] = (unsigned int  )8;
  sqlstm.sqindv[22] = (         short *)0;
  sqlstm.sqharm[22] = (unsigned int  )0;
  sqlstm.sqhstv[23] = (unsigned char  *)&element.FPNetzbedingteWartezeit;
  sqlstm.sqhstl[23] = (unsigned int  )8;
  sqlstm.sqindv[23] = (         short *)0;
  sqlstm.sqharm[23] = (unsigned int  )0;
  sqlstm.sqhstv[24] = (unsigned char  *)&element.FPWartezeitAufwandGesamt;
  sqlstm.sqhstl[24] = (unsigned int  )8;
  sqlstm.sqindv[24] = (         short *)0;
  sqlstm.sqharm[24] = (unsigned int  )0;
  sqlstm.sqhstv[25] = (unsigned char  *)&element.FPMindestwartezeitAufwand;
  sqlstm.sqhstl[25] = (unsigned int  )8;
  sqlstm.sqindv[25] = (         short *)0;
  sqlstm.sqharm[25] = (unsigned int  )0;
  sqlstm.sqhstv[26] = (unsigned char  *)&element.FPGesamtzeitAufwand;
  sqlstm.sqhstl[26] = (unsigned int  )8;
  sqlstm.sqindv[26] = (         short *)0;
  sqlstm.sqharm[26] = (unsigned int  )0;
  sqlstm.sqhstv[27] = (unsigned char  *)&element.FPFahrplanwirkungsgrad;
  sqlstm.sqhstl[27] = (unsigned int  )8;
  sqlstm.sqindv[27] = (         short *)0;
  sqlstm.sqharm[27] = (unsigned int  )0;
  sqlstm.sqhstv[28] = (unsigned char  *)&element.GBDurchschnittAnzahlBusse;
  sqlstm.sqhstl[28] = (unsigned int  )8;
  sqlstm.sqindv[28] = (         short *)0;
  sqlstm.sqharm[28] = (unsigned int  )0;
  sqlstm.sqhstv[29] = (unsigned char  *)&element.GBMittlereReisezeit;
  sqlstm.sqhstl[29] = (unsigned int  )8;
  sqlstm.sqindv[29] = (         short *)0;
  sqlstm.sqharm[29] = (unsigned int  )0;
  sqlstm.sqhstv[30] = (unsigned char  *)&element.GBAnzahlPersonen;
  sqlstm.sqhstl[30] = (unsigned int  )8;
  sqlstm.sqindv[30] = (         short *)0;
  sqlstm.sqharm[30] = (unsigned int  )0;
  sqlstm.sqhstv[31] = (unsigned char  *)&element.GBReisezeitZuDirektfahrer;
  sqlstm.sqhstl[31] = (unsigned int  )8;
  sqlstm.sqindv[31] = (         short *)0;
  sqlstm.sqharm[31] = (unsigned int  )0;
  sqlstm.sqhstv[32] = (unsigned char  *)&element.GBMindestreisezeitZuDirekt;
  sqlstm.sqhstl[32] = (unsigned int  )8;
  sqlstm.sqindv[32] = (         short *)0;
  sqlstm.sqharm[32] = (unsigned int  )0;
  sqlstm.sqhstv[33] = (unsigned char  *)&element.LPProzentVerbkeineDir;
  sqlstm.sqhstl[33] = (unsigned int  )8;
  sqlstm.sqindv[33] = (         short *)0;
  sqlstm.sqharm[33] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernGuetemasse");
}

 
                /* EXEC SQL COMMIT; */ 

{
                struct sqlexd sqlstm;

                sqlorat((void **)0, &sqlctx, &oraca);
                sqlstm.sqlvsn = 8;
                sqlstm.arrsiz = 34;
                sqlstm.iters = (unsigned int  )1;
                sqlstm.offset = (unsigned int  )14032;
                sqlstm.cud = sqlcud0;
                sqlstm.sqlest = (unsigned char  *)&sqlca;
                sqlstm.sqlety = (unsigned short)0;
                sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
                if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernGuetemasse");
}





		bool auto_existiert=false;		
		// pruefen, ob die Autoreisezeit existiert:
		// erzeuge den Cursor, mit dem Daten durchlaufen werden:
		/* EXEC SQL DECLARE hallo CURSOR FOR
			SELECT *
				FROM GuetemassReisezeitAuto
				WHERE SpeicherID = :speichernr; */ 

        	
		// jetzt den Cursor oeffnen
		/* EXEC SQL OPEN hallo; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 34;
  sqlstm.stmt = sq0772;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )14046;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&speichernr;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernGuetemasse");
}



	        // und jetzt in Schleife alle Dinger holen:
		/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

		for(;;)
		{
			/* EXEC SQL FETCH hallo INTO :reiseelement; */ 

{
   struct sqlexd sqlstm;

   sqlorat((void **)0, &sqlctx, &oraca);
   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 34;
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )14064;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlstm.sqhstv[0] = (unsigned char  *)&reiseelement.SpeicherID;
   sqlstm.sqhstl[0] = (unsigned int  )4;
   sqlstm.sqindv[0] = (         short *)0;
   sqlstm.sqharm[0] = (unsigned int  )0;
   sqlstm.sqhstv[1] = (unsigned char  *)&reiseelement.HaltestelleA;
   sqlstm.sqhstl[1] = (unsigned int  )4;
   sqlstm.sqindv[1] = (         short *)0;
   sqlstm.sqharm[1] = (unsigned int  )0;
   sqlstm.sqhstv[2] = (unsigned char  *)&reiseelement.HaltestelleB;
   sqlstm.sqhstl[2] = (unsigned int  )4;
   sqlstm.sqindv[2] = (         short *)0;
   sqlstm.sqharm[2] = (unsigned int  )0;
   sqlstm.sqhstv[3] = (unsigned char  *)&reiseelement.Reisezeit;
   sqlstm.sqhstl[3] = (unsigned int  )8;
   sqlstm.sqindv[3] = (         short *)0;
   sqlstm.sqharm[3] = (unsigned int  )0;
   sqlstm.sqphsv = sqlstm.sqhstv;
   sqlstm.sqphsl = sqlstm.sqhstl;
   sqlstm.sqpind = sqlstm.sqindv;
   sqlstm.sqparm = sqlstm.sqharm;
   sqlstm.sqparc = sqlstm.sqharc;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
   if (sqlca.sqlcode == 1403) break;
   if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernGuetemasse");
}


			auto_existiert=true;
			break;
		}
	        /* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

		// und nach getaner arbeit Cursor wieder schliessen:
		/* EXEC SQL CLOSE hallo; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 34;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )14094;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernGuetemasse");
}


 
		if(auto_existiert==false)
		{
                        Debug(2, "Loesche Autoreisezeittabelle...");
			/* EXEC SQL DELETE FROM GuetemassReisezeitAuto WHERE SpeicherID = :element.SpeicherID; */ 

{
   struct sqlexd sqlstm;

   sqlorat((void **)0, &sqlctx, &oraca);
   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 34;
   sqlstm.stmt = "delete from GuetemassReisezeitAuto  where SpeicherID=:b0";
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )14108;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlstm.sqhstv[0] = (unsigned char  *)&(element.SpeicherID);
   sqlstm.sqhstl[0] = (unsigned int  )4;
   sqlstm.sqindv[0] = (         short *)0;
   sqlstm.sqharm[0] = (unsigned int  )0;
   sqlstm.sqphsv = sqlstm.sqhstv;
   sqlstm.sqphsl = sqlstm.sqhstl;
   sqlstm.sqpind = sqlstm.sqindv;
   sqlstm.sqparm = sqlstm.sqharm;
   sqlstm.sqparc = sqlstm.sqharc;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
   if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernGuetemasse");
}


			/* EXEC SQL COMMIT; */ 

{
   struct sqlexd sqlstm;

   sqlorat((void **)0, &sqlctx, &oraca);
   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 34;
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )14126;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
   if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernGuetemasse");
}



	                Debug(2, "Speichere die Auto-Reisezeit (HS)...");
			if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("speichere die Auto-Reisezeit...");
			// und jetzt die Auto-Reisezeit
	                map2<int, int, double >* rzauto=guetemasse->holenReisezeitHS2HSAuto();
			
			speicherNummer = speicherstand;
			zeilenZaehler = 0;
			int fortschrittzaehler=0;
			// jetzt reinschreiben:
			int anzahlHaltestellen=guetemasse->holenAnzahlHaltestellen();
			for(int x=0; x<anzahlHaltestellen; x++)
			{
				for(int y=0; y<anzahlHaltestellen; y++)
				{
					// nur speichern, wenn unter dem Eintrag auch ein Wert steht:
					if(rzauto->defined(x,y)==true)
					{
						// diesen Punkt jetzt ins element einsetzen:
						HaltestelleA[zeilenZaehler]=x;
						HaltestelleB[zeilenZaehler]=y;
						Reisezeit[zeilenZaehler]=(*rzauto)(x,y);
						rz_speicherID[zeilenZaehler] = speicherstand;
						zeilenZaehler++;
						// und ab in die Datenbank wenn der zeilenZaehler = 10000:
//              	                        cout<<"AutoReisezeit x: "<<x<<" y: "<<y<<" Zeit: "<<(*rzauto)(x,y)<<endl;
//						cout.flush();
					        

						if (zeilenZaehler == 10000) 
						{
						    /* EXEC SQL INSERT INTO GuetemassReisezeitAuto
							VALUES (:rz_speicherID,:HaltestelleA,:HaltestelleB,:Reisezeit); */ 

{
          struct sqlexd sqlstm;

          sqlorat((void **)0, &sqlctx, &oraca);
          sqlstm.sqlvsn = 8;
          sqlstm.arrsiz = 34;
          sqlstm.stmt = "insert into GuetemassReisezeitAuto values (:b0,:b1,\
:b2,:b3)";
          sqlstm.iters = (unsigned int  )10000;
          sqlstm.offset = (unsigned int  )14140;
          sqlstm.cud = sqlcud0;
          sqlstm.sqlest = (unsigned char  *)&sqlca;
          sqlstm.sqlety = (unsigned short)0;
          sqlstm.sqhstv[0] = (unsigned char  *)rz_speicherID;
          sqlstm.sqhstl[0] = (unsigned int  )8;
          sqlstm.sqindv[0] = (         short *)0;
          sqlstm.sqharm[0] = (unsigned int  )0;
          sqlstm.sqharc[0] = (unsigned int   *)0;
          sqlstm.sqhstv[1] = (unsigned char  *)HaltestelleA;
          sqlstm.sqhstl[1] = (unsigned int  )4;
          sqlstm.sqindv[1] = (         short *)0;
          sqlstm.sqharm[1] = (unsigned int  )0;
          sqlstm.sqharc[1] = (unsigned int   *)0;
          sqlstm.sqhstv[2] = (unsigned char  *)HaltestelleB;
          sqlstm.sqhstl[2] = (unsigned int  )4;
          sqlstm.sqindv[2] = (         short *)0;
          sqlstm.sqharm[2] = (unsigned int  )0;
          sqlstm.sqharc[2] = (unsigned int   *)0;
          sqlstm.sqhstv[3] = (unsigned char  *)Reisezeit;
          sqlstm.sqhstl[3] = (unsigned int  )8;
          sqlstm.sqindv[3] = (         short *)0;
          sqlstm.sqharm[3] = (unsigned int  )0;
          sqlstm.sqharc[3] = (unsigned int   *)0;
          sqlstm.sqphsv = sqlstm.sqhstv;
          sqlstm.sqphsl = sqlstm.sqhstl;
          sqlstm.sqpind = sqlstm.sqindv;
          sqlstm.sqparm = sqlstm.sqharm;
          sqlstm.sqparc = sqlstm.sqharc;
          sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
          if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernGuetemasse");
}


							    /* EXEC SQL COMMIT; */ 

{
           struct sqlexd sqlstm;

           sqlorat((void **)0, &sqlctx, &oraca);
           sqlstm.sqlvsn = 8;
           sqlstm.arrsiz = 34;
           sqlstm.iters = (unsigned int  )1;
           sqlstm.offset = (unsigned int  )14170;
           sqlstm.cud = sqlcud0;
           sqlstm.sqlest = (unsigned char  *)&sqlca;
           sqlstm.sqlety = (unsigned short)0;
           sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
           if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernGuetemasse");
}


						    zeilenZaehler = 0;
                                                	
						    fortschrittzaehler=fortschrittzaehler+10000;
						    if(fortschritt!=0) fortschritt->anzeigenFortschritt(fortschrittzaehler, guetemasse->holenAnzahlHaltestellen() * guetemasse->holenAnzahlHaltestellen());
						}
					}
				}       	
		        }
        	
			if (zeilenZaehler > 0) 
			{
			    /* EXEC SQL FOR :zeilenZaehler 
				INSERT INTO GuetemassReisezeitAuto
				VALUES (:rz_speicherID,:HaltestelleA,:HaltestelleB,:Reisezeit); */ 

{
       struct sqlexd sqlstm;

       sqlorat((void **)0, &sqlctx, &oraca);
       sqlstm.sqlvsn = 8;
       sqlstm.arrsiz = 34;
       sqlstm.stmt = "insert into GuetemassReisezeitAuto values (:b1,:b2,:b3\
,:b4)";
       sqlstm.iters = (unsigned int  )zeilenZaehler;
       sqlstm.offset = (unsigned int  )14184;
       sqlstm.cud = sqlcud0;
       sqlstm.sqlest = (unsigned char  *)&sqlca;
       sqlstm.sqlety = (unsigned short)0;
       sqlstm.sqhstv[0] = (unsigned char  *)rz_speicherID;
       sqlstm.sqhstl[0] = (unsigned int  )8;
       sqlstm.sqindv[0] = (         short *)0;
       sqlstm.sqharm[0] = (unsigned int  )0;
       sqlstm.sqhstv[1] = (unsigned char  *)HaltestelleA;
       sqlstm.sqhstl[1] = (unsigned int  )4;
       sqlstm.sqindv[1] = (         short *)0;
       sqlstm.sqharm[1] = (unsigned int  )0;
       sqlstm.sqhstv[2] = (unsigned char  *)HaltestelleB;
       sqlstm.sqhstl[2] = (unsigned int  )4;
       sqlstm.sqindv[2] = (         short *)0;
       sqlstm.sqharm[2] = (unsigned int  )0;
       sqlstm.sqhstv[3] = (unsigned char  *)Reisezeit;
       sqlstm.sqhstl[3] = (unsigned int  )8;
       sqlstm.sqindv[3] = (         short *)0;
       sqlstm.sqharm[3] = (unsigned int  )0;
       sqlstm.sqphsv = sqlstm.sqhstv;
       sqlstm.sqphsl = sqlstm.sqhstl;
       sqlstm.sqpind = sqlstm.sqindv;
       sqlstm.sqparm = sqlstm.sqharm;
       sqlstm.sqparc = sqlstm.sqharc;
       sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
       if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernGuetemasse");
}


			    /* EXEC SQL COMMIT; */ 

{
       struct sqlexd sqlstm;

       sqlorat((void **)0, &sqlctx, &oraca);
       sqlstm.sqlvsn = 8;
       sqlstm.arrsiz = 34;
       sqlstm.iters = (unsigned int  )1;
       sqlstm.offset = (unsigned int  )14214;
       sqlstm.cud = sqlcud0;
       sqlstm.sqlest = (unsigned char  *)&sqlca;
       sqlstm.sqlety = (unsigned short)0;
       sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
       if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernGuetemasse");
}


			}
			if(fortschritt!=0) fortschritt->anzeigenFortschritt(guetemasse->holenAnzahlHaltestellen() * guetemasse->holenAnzahlHaltestellen(), guetemasse->holenAnzahlHaltestellen() * guetemasse->holenAnzahlHaltestellen());
                        	
			
		} // Abfrage: exisitiert schon eine Autoreisezeit?
		else {Debug(2, "Autoreisezeit ist schon in DB; wird ignoriert"); }

		if(fortschritt!=0) delete fortschritt;
	}
	// Guetemasse nicht loeschen, da sie z.Zt. noch gebraucht werden
	//if(guetemasse!=0) delete guetemasse;
}
//------------------------------------------------------------------------------
// Funktionsname:	holenGuetemasse
// Beschreibung:	Mit dieser Methode werden die Guetemasse aus der Datenbank geholt
// Parameter:		
// Rueckgabe:		Zeiger auf eine (teilweise) gefuellte Guetemassklasse
// Besonderheiten:	
//------------------------------------------------------------------------------
CGuetemasse* CDBSchnittstelle::holenGuetemasse()
{
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenGuetemasse"); */ 

        
	// erst ein paar dummywerte anlegen, damit Oracle die erkennt:
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	
	typedef struct
	{
		int SpeicherID;

		int HSAnzahlHaltestellen;
 		double HSBevUeberVersorgung;
		double HSBevUnterVersorgung;
 		double HSFlUeberVersorgung;
 		double HSFlUnterVersorgung;
 		double HSBevVersorgungProzent;
 		double HSFlVersorgungProzent;
		double HSFussweg;
		int HSDirekteReisezeitAuto;
                
		int LPAnzahlUmstiege;
		double LPVerbindungenUmstiegszwang;
		int LPGesamtfahrer;
		int LPDirektfahrer;
		int LPMittlereReisezeit;
		double LPDirektfahreranteil;
		int LPStreckenkilometer;
		int LPGesamteStreckenkilometer;
		int LPMittlereMindestreisezeit;
		double LPReisezeitverlaengerung;
		int LPAnzahlLinien;
		double LPMittlererVerknuepfungsgrad;
                
		double FPAnzahlBusse;
 		double FPNetzbedingteWartezeit;
		double FPWartezeitAufwandGesamt;
		double FPMindestwartezeitAufwand;
		double FPGesamtzeitAufwand;
		double FPFahrplanwirkungsgrad;

		double GBDurchschnittAnzahlBusse;
		double GBMittlereReisezeit;
		double GBAnzahlPersonen;
		double GBReisezeitZuDirektfahrer;
		double GBMindestreisezeitZuDirekt;

		double LPProzentVerbkeineDir;	
	} gmelem;
	gmelem element;

	typedef struct
	{
		int SpeicherID;
		int HaltestelleA;
		int HaltestelleB;
		double Reisezeit;
	} rzaelem;
	rzaelem reiseelement;

	int speicherid=speicherstand;
	/* EXEC SQL END DECLARE SECTION; */ 


        // die Variablen werden erst mit -1 initialisiert, fuer den Fall,
	// dass in der Datenbank nichts drin steht:
	element.HSAnzahlHaltestellen=-1;
	element.HSBevUeberVersorgung=-1;
	element.HSBevUnterVersorgung=-1;
	element.HSFlUeberVersorgung=-1;
	element.HSFlUnterVersorgung=-1;
	element.HSBevVersorgungProzent=-1;
	element.HSFlVersorgungProzent=-1;
	element.HSFussweg=-1;
	element.HSDirekteReisezeitAuto=0;// ist immer 0, da komplexere Struktur!!!

	element.LPAnzahlUmstiege=-1;
	element.LPVerbindungenUmstiegszwang=-1;
	element.LPGesamtfahrer=-1;
	element.LPDirektfahrer=-1;
	element.LPMittlereReisezeit=-1;
	element.LPDirektfahreranteil=-1;
	element.LPStreckenkilometer=-1;
	element.LPGesamteStreckenkilometer=-1;
	element.LPMittlereMindestreisezeit=-1;
	element.LPReisezeitverlaengerung=-1;
	element.LPAnzahlLinien=-1;
	element.LPMittlererVerknuepfungsgrad=-1;

	element.FPAnzahlBusse=-1;
 	element.FPNetzbedingteWartezeit=-1;
	element.FPWartezeitAufwandGesamt=-1;
	element.FPMindestwartezeitAufwand=-1;
	element.FPGesamtzeitAufwand=-1;
	element.FPFahrplanwirkungsgrad=-1;

	element.GBDurchschnittAnzahlBusse=-1;
	element.GBMittlereReisezeit=-1;
	element.GBAnzahlPersonen=-1;
	element.GBReisezeitZuDirektfahrer=-1;
	element.GBMindestreisezeitZuDirekt=-1;

	element.LPProzentVerbkeineDir=-1;

	// erzeuge die Cursor, mit dem Daten durchlaufen werden:
	/* EXEC SQL SELECT *
		INTO :element
		FROM  Guetemasse
		WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.stmt = "select * into :s1 ,:s2 ,:s3 ,:s4 ,:s5 ,:s6 ,:s7 ,:s8 ,:s9 ,:\
s10 ,:s11 ,:s12 ,:s13 ,:s14 ,:s15 ,:s16 ,:s17 ,:s18 ,:s19 ,:s20 ,:s21 ,:s22 ,:\
s23 ,:s24 ,:s25 ,:s26 ,:s27 ,:s28 ,:s29 ,:s30 ,:s31 ,:s32 ,:s33 ,:s34   from G\
uetemasse where SpeicherID=:b1";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )14228;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&element.SpeicherID;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqhstv[1] = (unsigned char  *)&element.HSAnzahlHaltestellen;
 sqlstm.sqhstl[1] = (unsigned int  )4;
 sqlstm.sqindv[1] = (         short *)0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqhstv[2] = (unsigned char  *)&element.HSBevUeberVersorgung;
 sqlstm.sqhstl[2] = (unsigned int  )8;
 sqlstm.sqindv[2] = (         short *)0;
 sqlstm.sqharm[2] = (unsigned int  )0;
 sqlstm.sqhstv[3] = (unsigned char  *)&element.HSBevUnterVersorgung;
 sqlstm.sqhstl[3] = (unsigned int  )8;
 sqlstm.sqindv[3] = (         short *)0;
 sqlstm.sqharm[3] = (unsigned int  )0;
 sqlstm.sqhstv[4] = (unsigned char  *)&element.HSFlUeberVersorgung;
 sqlstm.sqhstl[4] = (unsigned int  )8;
 sqlstm.sqindv[4] = (         short *)0;
 sqlstm.sqharm[4] = (unsigned int  )0;
 sqlstm.sqhstv[5] = (unsigned char  *)&element.HSFlUnterVersorgung;
 sqlstm.sqhstl[5] = (unsigned int  )8;
 sqlstm.sqindv[5] = (         short *)0;
 sqlstm.sqharm[5] = (unsigned int  )0;
 sqlstm.sqhstv[6] = (unsigned char  *)&element.HSBevVersorgungProzent;
 sqlstm.sqhstl[6] = (unsigned int  )8;
 sqlstm.sqindv[6] = (         short *)0;
 sqlstm.sqharm[6] = (unsigned int  )0;
 sqlstm.sqhstv[7] = (unsigned char  *)&element.HSFlVersorgungProzent;
 sqlstm.sqhstl[7] = (unsigned int  )8;
 sqlstm.sqindv[7] = (         short *)0;
 sqlstm.sqharm[7] = (unsigned int  )0;
 sqlstm.sqhstv[8] = (unsigned char  *)&element.HSFussweg;
 sqlstm.sqhstl[8] = (unsigned int  )8;
 sqlstm.sqindv[8] = (         short *)0;
 sqlstm.sqharm[8] = (unsigned int  )0;
 sqlstm.sqhstv[9] = (unsigned char  *)&element.HSDirekteReisezeitAuto;
 sqlstm.sqhstl[9] = (unsigned int  )4;
 sqlstm.sqindv[9] = (         short *)0;
 sqlstm.sqharm[9] = (unsigned int  )0;
 sqlstm.sqhstv[10] = (unsigned char  *)&element.LPAnzahlUmstiege;
 sqlstm.sqhstl[10] = (unsigned int  )4;
 sqlstm.sqindv[10] = (         short *)0;
 sqlstm.sqharm[10] = (unsigned int  )0;
 sqlstm.sqhstv[11] = (unsigned char  *)&element.LPVerbindungenUmstiegszwang;
 sqlstm.sqhstl[11] = (unsigned int  )8;
 sqlstm.sqindv[11] = (         short *)0;
 sqlstm.sqharm[11] = (unsigned int  )0;
 sqlstm.sqhstv[12] = (unsigned char  *)&element.LPGesamtfahrer;
 sqlstm.sqhstl[12] = (unsigned int  )4;
 sqlstm.sqindv[12] = (         short *)0;
 sqlstm.sqharm[12] = (unsigned int  )0;
 sqlstm.sqhstv[13] = (unsigned char  *)&element.LPDirektfahrer;
 sqlstm.sqhstl[13] = (unsigned int  )4;
 sqlstm.sqindv[13] = (         short *)0;
 sqlstm.sqharm[13] = (unsigned int  )0;
 sqlstm.sqhstv[14] = (unsigned char  *)&element.LPMittlereReisezeit;
 sqlstm.sqhstl[14] = (unsigned int  )4;
 sqlstm.sqindv[14] = (         short *)0;
 sqlstm.sqharm[14] = (unsigned int  )0;
 sqlstm.sqhstv[15] = (unsigned char  *)&element.LPDirektfahreranteil;
 sqlstm.sqhstl[15] = (unsigned int  )8;
 sqlstm.sqindv[15] = (         short *)0;
 sqlstm.sqharm[15] = (unsigned int  )0;
 sqlstm.sqhstv[16] = (unsigned char  *)&element.LPStreckenkilometer;
 sqlstm.sqhstl[16] = (unsigned int  )4;
 sqlstm.sqindv[16] = (         short *)0;
 sqlstm.sqharm[16] = (unsigned int  )0;
 sqlstm.sqhstv[17] = (unsigned char  *)&element.LPGesamteStreckenkilometer;
 sqlstm.sqhstl[17] = (unsigned int  )4;
 sqlstm.sqindv[17] = (         short *)0;
 sqlstm.sqharm[17] = (unsigned int  )0;
 sqlstm.sqhstv[18] = (unsigned char  *)&element.LPMittlereMindestreisezeit;
 sqlstm.sqhstl[18] = (unsigned int  )4;
 sqlstm.sqindv[18] = (         short *)0;
 sqlstm.sqharm[18] = (unsigned int  )0;
 sqlstm.sqhstv[19] = (unsigned char  *)&element.LPReisezeitverlaengerung;
 sqlstm.sqhstl[19] = (unsigned int  )8;
 sqlstm.sqindv[19] = (         short *)0;
 sqlstm.sqharm[19] = (unsigned int  )0;
 sqlstm.sqhstv[20] = (unsigned char  *)&element.LPAnzahlLinien;
 sqlstm.sqhstl[20] = (unsigned int  )4;
 sqlstm.sqindv[20] = (         short *)0;
 sqlstm.sqharm[20] = (unsigned int  )0;
 sqlstm.sqhstv[21] = (unsigned char  *)&element.LPMittlererVerknuepfungsgrad;
 sqlstm.sqhstl[21] = (unsigned int  )8;
 sqlstm.sqindv[21] = (         short *)0;
 sqlstm.sqharm[21] = (unsigned int  )0;
 sqlstm.sqhstv[22] = (unsigned char  *)&element.FPAnzahlBusse;
 sqlstm.sqhstl[22] = (unsigned int  )8;
 sqlstm.sqindv[22] = (         short *)0;
 sqlstm.sqharm[22] = (unsigned int  )0;
 sqlstm.sqhstv[23] = (unsigned char  *)&element.FPNetzbedingteWartezeit;
 sqlstm.sqhstl[23] = (unsigned int  )8;
 sqlstm.sqindv[23] = (         short *)0;
 sqlstm.sqharm[23] = (unsigned int  )0;
 sqlstm.sqhstv[24] = (unsigned char  *)&element.FPWartezeitAufwandGesamt;
 sqlstm.sqhstl[24] = (unsigned int  )8;
 sqlstm.sqindv[24] = (         short *)0;
 sqlstm.sqharm[24] = (unsigned int  )0;
 sqlstm.sqhstv[25] = (unsigned char  *)&element.FPMindestwartezeitAufwand;
 sqlstm.sqhstl[25] = (unsigned int  )8;
 sqlstm.sqindv[25] = (         short *)0;
 sqlstm.sqharm[25] = (unsigned int  )0;
 sqlstm.sqhstv[26] = (unsigned char  *)&element.FPGesamtzeitAufwand;
 sqlstm.sqhstl[26] = (unsigned int  )8;
 sqlstm.sqindv[26] = (         short *)0;
 sqlstm.sqharm[26] = (unsigned int  )0;
 sqlstm.sqhstv[27] = (unsigned char  *)&element.FPFahrplanwirkungsgrad;
 sqlstm.sqhstl[27] = (unsigned int  )8;
 sqlstm.sqindv[27] = (         short *)0;
 sqlstm.sqharm[27] = (unsigned int  )0;
 sqlstm.sqhstv[28] = (unsigned char  *)&element.GBDurchschnittAnzahlBusse;
 sqlstm.sqhstl[28] = (unsigned int  )8;
 sqlstm.sqindv[28] = (         short *)0;
 sqlstm.sqharm[28] = (unsigned int  )0;
 sqlstm.sqhstv[29] = (unsigned char  *)&element.GBMittlereReisezeit;
 sqlstm.sqhstl[29] = (unsigned int  )8;
 sqlstm.sqindv[29] = (         short *)0;
 sqlstm.sqharm[29] = (unsigned int  )0;
 sqlstm.sqhstv[30] = (unsigned char  *)&element.GBAnzahlPersonen;
 sqlstm.sqhstl[30] = (unsigned int  )8;
 sqlstm.sqindv[30] = (         short *)0;
 sqlstm.sqharm[30] = (unsigned int  )0;
 sqlstm.sqhstv[31] = (unsigned char  *)&element.GBReisezeitZuDirektfahrer;
 sqlstm.sqhstl[31] = (unsigned int  )8;
 sqlstm.sqindv[31] = (         short *)0;
 sqlstm.sqharm[31] = (unsigned int  )0;
 sqlstm.sqhstv[32] = (unsigned char  *)&element.GBMindestreisezeitZuDirekt;
 sqlstm.sqhstl[32] = (unsigned int  )8;
 sqlstm.sqindv[32] = (         short *)0;
 sqlstm.sqharm[32] = (unsigned int  )0;
 sqlstm.sqhstv[33] = (unsigned char  *)&element.LPProzentVerbkeineDir;
 sqlstm.sqhstl[33] = (unsigned int  )8;
 sqlstm.sqindv[33] = (         short *)0;
 sqlstm.sqharm[33] = (unsigned int  )0;
 sqlstm.sqhstv[34] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[34] = (unsigned int  )4;
 sqlstm.sqindv[34] = (         short *)0;
 sqlstm.sqharm[34] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenGuetemasse");
}




	// Und die Elemente uebergeben:
	CGuetemasse* guetemasse=0;
	try{guetemasse=new CGuetemasse();}
	catch(...)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Guetemasse konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}
	guetemasse->speichernAnzahlHaltestellen(element.HSAnzahlHaltestellen);
	guetemasse->speichernBevoelkerungsUeberversorgung(element.HSBevUeberVersorgung);
	guetemasse->speichernBevoelkerungsUnterversorgung(element.HSBevUnterVersorgung);
	guetemasse->speichernFlaechenUeberversorgung(element.HSFlUeberVersorgung);
	guetemasse->speichernFlaechenUnterversorgung(element.HSFlUnterVersorgung);
	guetemasse->speichernFlaechenVersorgunginProzent(element.HSFlVersorgungProzent);
	guetemasse->speichernBevoelkerungsVersorgunginProzent(element.HSBevVersorgungProzent);
	guetemasse->speichernFusswegProHaltestelle(element.HSFussweg);

	guetemasse->speichernAnzahlUmstiege(element.LPAnzahlUmstiege);
	guetemasse->speichernAnzahlVerbindungenmitUmstiegzwang(element.LPVerbindungenUmstiegszwang);
	guetemasse->speichernGesamtfahrer(element.LPGesamtfahrer);
	guetemasse->speichernDirektfahrer(element.LPDirektfahrer);
	guetemasse->speichernMittlereReisezeit(element.LPMittlereReisezeit);
	guetemasse->speichernProzentsatzVerbindungendiekeineDirektfahrten(element.LPProzentVerbkeineDir);
	guetemasse->speichernDirektfahreranteil(element.LPDirektfahreranteil);
	guetemasse->speichernStreckenkilometer(element.LPStreckenkilometer);
	guetemasse->speichernGesamteStreckenkilometer(element.LPGesamteStreckenkilometer);
	guetemasse->speichernMittlereMindestreisezeit(element.LPMittlereMindestreisezeit);
	guetemasse->speichernReisezeitverlaengerung(element.LPReisezeitverlaengerung);
	guetemasse->setzenLinienanzahl(element.LPAnzahlLinien);
	guetemasse->speichernMittlerenVerknuepfungsgrad(element.LPMittlererVerknuepfungsgrad);
	
	guetemasse->speichernAnzahlBusse(element.FPAnzahlBusse);
	guetemasse->speichernNetzbedingteWartezeitenGesamt(element.FPNetzbedingteWartezeit);
	guetemasse->speichernWartezeiteAufwandGesamt(element.FPWartezeitAufwandGesamt);
	guetemasse->speichernMindestwartezeitaufwand(element.FPMindestwartezeitAufwand);
	guetemasse->speichernGesamtzeitaufwand(element.FPGesamtzeitAufwand);
	guetemasse->speichernFahrplanwirkungsgrad(element.FPFahrplanwirkungsgrad);

	guetemasse->speichernDurchschnittlicheAnzahlBusse(element.GBDurchschnittAnzahlBusse);
	guetemasse->speichernMittlereReisezeit(element.GBMittlereReisezeit);
	guetemasse->speichernAnzahlPersonen(element.GBAnzahlPersonen);
	guetemasse->speichernReisezeitZuDirektfahrer(element.GBReisezeitZuDirektfahrer);
	guetemasse->speichernMindestreisezeitZuDirektfahrer(element.GBMindestreisezeitZuDirekt);



	// und die Reisezeit:
	map2<int, int, double >* autoreisezeit=0;
        try{autoreisezeit=new  map2<int, int, double >;}
	catch(...)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Autoreisezeit bei den Guetemassen konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}
	
	// erzeuge den Cursor, mit dem Daten durchlaufen werden:
	/* EXEC SQL DECLARE rzauto_cursor CURSOR FOR
		SELECT *
			FROM GuetemassReisezeitAuto
			WHERE SpeicherID = :speicherid; */ 


	// jetzt den Cursor oeffnen
	/* EXEC SQL OPEN rzauto_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.stmt = sq0780;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )14382;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenGuetemasse");
}



        // und jetzt in Schleife alle Dinger holen:
	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

	for(;;)
	{
		/* EXEC SQL FETCH rzauto_cursor INTO :reiseelement; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )14400;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&reiseelement.SpeicherID;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&reiseelement.HaltestelleA;
  sqlstm.sqhstl[1] = (unsigned int  )4;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&reiseelement.HaltestelleB;
  sqlstm.sqhstl[2] = (unsigned int  )4;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqhstv[3] = (unsigned char  *)&reiseelement.Reisezeit;
  sqlstm.sqhstl[3] = (unsigned int  )8;
  sqlstm.sqindv[3] = (         short *)0;
  sqlstm.sqharm[3] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenGuetemasse");
}


		(*autoreisezeit)(reiseelement.HaltestelleA, reiseelement.HaltestelleB)=reiseelement.Reisezeit;
	}
        /* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	// und nach getaner arbeit Cursor wieder schliessen:
	/* EXEC SQL CLOSE rzauto_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )14430;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenGuetemasse");
}




        guetemasse->speichernReisezeitHS2HSAuto(autoreisezeit);
        

	// und noch die QuelleZielMatrix holen:
	guetemasse->setzenQuelleZielMatrix(holenQuelleZielMatrix());

	Debug(2, "holenGuetemasseklasse BEENDET");
	return guetemasse;
}




  
// Haltestellen: ------------------------------------------------------------------------------------------
// Eingaben:
//------------------------------------------------------------------------------
// Funktionsname:	holenHaltestellenModulParameter
// Beschreibung:	Mit dieser Methode werden die Parameter aus der Datenbank geholt
// Parameter:		Nummer des Aufrufs, Toleranzgrenze, max. Radius, min. Radius, Verbindungsradius Stadt und Land
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::holenHaltestellenModulParameter(int aufruf, int& algorithmus, int& zufallsgeneratorInitialisierung,
							double& minRadius, double& maxRadius, double& verbindungsRadiusStadt,
							double& verbindungsRadiusLand, int& radiustyp, double& haltestellenLage,
							double& toleranzgrenze, int& bevoelkerungsRaster, double& koeffizientBevoelkerungsueberversorgung,
							double& koeffizientBevoelkerungsunterversorgung, double& koeffizientFlaechenueberversorgung,
							double& koeffizientFlaechenunterversorgung, double& koeffizientFahrtwunscheinbeziehung,
							double& koeffizientStrassenanpassung,
							int& AnzahlHaltestellen, bool& AnzStrassenkarte,
							bool& AnzBevoelkerungsversorgung, bool& AnzFlaechenversorgung, bool& Anzkomplettunterdruecken,
							int& Strategie, int& AnzahlEltern, int& AnzahlKinder, int& Generationen, 
							bool& AbbruchGueteunterschreitung, double& GrenzwGueteunterschreitung)
{
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenHaltestellenModulParameter"); */ 

        
	// erst ein paar dummywerte anlegen, damit Oracle die erkennt:
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	
	typedef struct
	{
		int Aufruf;
		int Algorithmus;
		int ZufallsgeneratorInitialisierung;
		double MinRadius;
		double MaxRadius;
		double VerbindungsRadiusStadt;
		double VerbindungsRadiusLand;
		int Radiustyp;
		double HaltestellenLage;
		double Toleranzgrenze;
		int BevoelkerungsRaster;
		double KoeffizientBevoelkerungsueberversorgung;
		double KoeffizientBevoelkerungsunterversorgung;
		double KoeffizientFlaechenueberversorgung;
		double KoeffizientFlaechenunterversorgung;
		double KoeffizientFahrtwunscheinbeziehung;
		double KoeffizientStrassenanpassung;

		int AnzahlHaltestellen;
		int AnzStrassenkarte; //bool
 		int AnzBevoelkerungsversorgung;//bool
 		int AnzFlaechenversorgung;//bool
 		int Anzkomplettunterdruecken;//bool
 		int Strategie;
		int AnzahlEltern;
 		int AnzahlKinder;
 		int Generationen;
		int AbbruchGueteunterschreitung;//bool
		double GrenzwGueteunterschreitung;
	} hselem;
	hselem element;
	int speicherid=speicherstand;
	int aufr=aufruf; // diesen Speicherstand moechte ich haben
	/* EXEC SQL END DECLARE SECTION; */ 


        // die Variablen werden erst mit -1 initialisiert, fuer den Fall,
	// dass in der Datenbank nichts drin steht:
	element.Aufruf=-1;
	element.Algorithmus=-1;
	element.ZufallsgeneratorInitialisierung=-1;
	element.MinRadius=-1.0;
	element.MaxRadius=-1.0;
	element.VerbindungsRadiusStadt=-1.0;
	element.VerbindungsRadiusLand=-1.0;
	element.Radiustyp=-1;
	element.HaltestellenLage=-1.0;
	element.Toleranzgrenze=-1.0;
	element.BevoelkerungsRaster=-1;
	element.KoeffizientBevoelkerungsueberversorgung=-1.0;
	element.KoeffizientBevoelkerungsunterversorgung=-1.0;
	element.KoeffizientFlaechenueberversorgung=-1.0;
	element.KoeffizientFlaechenunterversorgung=-1.0;
	element.KoeffizientFahrtwunscheinbeziehung=-1.0;
	element.KoeffizientStrassenanpassung=-1.0;

	element.AnzahlHaltestellen=-1;
	element.AnzStrassenkarte=0; //bool
 	element.AnzBevoelkerungsversorgung=0;//bool
 	element.AnzFlaechenversorgung=0;//bool
 	element.Anzkomplettunterdruecken=0;//bool
 	element.Strategie=-1;
	element.AnzahlEltern=-1;
 	element.AnzahlKinder=-1;
 	element.Generationen=-1;
	element.AbbruchGueteunterschreitung=0;//bool
	element.GrenzwGueteunterschreitung=-1.0;

	// erzeuge die Cursor, mit dem Daten durchlaufen werden:
	/* EXEC SQL DECLARE haltestellenmodulcursor CURSOR FOR
		SELECT Aufruf, Algorithmus, ZufiInitialisierung, MinRadius, MaxRadius, VerbindungsRadiusStadt, VerbindungsRadiusLand, Radiustyp, HaltestellenLage, Toleranzgrenze, BevoelkerungsRaster, Bevoelkerungsueberversorgung, Bevoelkerungsunterversorgung, Flaechenueberversorgung, Flaechenunterversorgung, Fahrtwunscheinbeziehung, Strassenanpassung, AnzahlHaltestellen, AnzStrassenkarte, AnzBevoelkerungsversorgung, AnzFlaechenversorgung, Anzkomplettunterdruecken, Strategie, AnzahlEltern, AnzahlKinder, Generationen, AbbruchGueteunterschreitung, GrenzwGueteunterschreitung
			FROM HaltestellenModulParameter
			WHERE SpeicherID = :speicherid AND Aufruf= :aufr; */ 

	int anzahl_reihen=0; // hiermit wird die Anzahl der Eintraege ermittelt
        /* EXEC SQL OPEN haltestellenmodulcursor; */ 

{
        struct sqlexd sqlstm;

        sqlorat((void **)0, &sqlctx, &oraca);
        sqlstm.sqlvsn = 8;
        sqlstm.arrsiz = 35;
        sqlstm.stmt = sq0781;
        sqlstm.iters = (unsigned int  )1;
        sqlstm.offset = (unsigned int  )14444;
        sqlstm.cud = sqlcud0;
        sqlstm.sqlest = (unsigned char  *)&sqlca;
        sqlstm.sqlety = (unsigned short)0;
        sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
        sqlstm.sqhstl[0] = (unsigned int  )4;
        sqlstm.sqindv[0] = (         short *)0;
        sqlstm.sqharm[0] = (unsigned int  )0;
        sqlstm.sqhstv[1] = (unsigned char  *)&aufr;
        sqlstm.sqhstl[1] = (unsigned int  )4;
        sqlstm.sqindv[1] = (         short *)0;
        sqlstm.sqharm[1] = (unsigned int  )0;
        sqlstm.sqphsv = sqlstm.sqhstv;
        sqlstm.sqphsl = sqlstm.sqhstl;
        sqlstm.sqpind = sqlstm.sqindv;
        sqlstm.sqparm = sqlstm.sqharm;
        sqlstm.sqparc = sqlstm.sqharc;
        sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
        if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenHaltestellenModulParameter");
}


        /* EXEC SQL WHENEVER NOT FOUND DO break; */ 

	for(;;)
	{
		/* EXEC SQL FETCH haltestellenmodulcursor INTO :element; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )14466;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&element.Aufruf;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&element.Algorithmus;
  sqlstm.sqhstl[1] = (unsigned int  )4;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&element.ZufallsgeneratorInitialisierung;
  sqlstm.sqhstl[2] = (unsigned int  )4;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqhstv[3] = (unsigned char  *)&element.MinRadius;
  sqlstm.sqhstl[3] = (unsigned int  )8;
  sqlstm.sqindv[3] = (         short *)0;
  sqlstm.sqharm[3] = (unsigned int  )0;
  sqlstm.sqhstv[4] = (unsigned char  *)&element.MaxRadius;
  sqlstm.sqhstl[4] = (unsigned int  )8;
  sqlstm.sqindv[4] = (         short *)0;
  sqlstm.sqharm[4] = (unsigned int  )0;
  sqlstm.sqhstv[5] = (unsigned char  *)&element.VerbindungsRadiusStadt;
  sqlstm.sqhstl[5] = (unsigned int  )8;
  sqlstm.sqindv[5] = (         short *)0;
  sqlstm.sqharm[5] = (unsigned int  )0;
  sqlstm.sqhstv[6] = (unsigned char  *)&element.VerbindungsRadiusLand;
  sqlstm.sqhstl[6] = (unsigned int  )8;
  sqlstm.sqindv[6] = (         short *)0;
  sqlstm.sqharm[6] = (unsigned int  )0;
  sqlstm.sqhstv[7] = (unsigned char  *)&element.Radiustyp;
  sqlstm.sqhstl[7] = (unsigned int  )4;
  sqlstm.sqindv[7] = (         short *)0;
  sqlstm.sqharm[7] = (unsigned int  )0;
  sqlstm.sqhstv[8] = (unsigned char  *)&element.HaltestellenLage;
  sqlstm.sqhstl[8] = (unsigned int  )8;
  sqlstm.sqindv[8] = (         short *)0;
  sqlstm.sqharm[8] = (unsigned int  )0;
  sqlstm.sqhstv[9] = (unsigned char  *)&element.Toleranzgrenze;
  sqlstm.sqhstl[9] = (unsigned int  )8;
  sqlstm.sqindv[9] = (         short *)0;
  sqlstm.sqharm[9] = (unsigned int  )0;
  sqlstm.sqhstv[10] = (unsigned char  *)&element.BevoelkerungsRaster;
  sqlstm.sqhstl[10] = (unsigned int  )4;
  sqlstm.sqindv[10] = (         short *)0;
  sqlstm.sqharm[10] = (unsigned int  )0;
  sqlstm.sqhstv[11] = (unsigned char  *)&element.KoeffizientBevoelkerungsueberversorgung;
  sqlstm.sqhstl[11] = (unsigned int  )8;
  sqlstm.sqindv[11] = (         short *)0;
  sqlstm.sqharm[11] = (unsigned int  )0;
  sqlstm.sqhstv[12] = (unsigned char  *)&element.KoeffizientBevoelkerungsunterversorgung;
  sqlstm.sqhstl[12] = (unsigned int  )8;
  sqlstm.sqindv[12] = (         short *)0;
  sqlstm.sqharm[12] = (unsigned int  )0;
  sqlstm.sqhstv[13] = (unsigned char  *)&element.KoeffizientFlaechenueberversorgung;
  sqlstm.sqhstl[13] = (unsigned int  )8;
  sqlstm.sqindv[13] = (         short *)0;
  sqlstm.sqharm[13] = (unsigned int  )0;
  sqlstm.sqhstv[14] = (unsigned char  *)&element.KoeffizientFlaechenunterversorgung;
  sqlstm.sqhstl[14] = (unsigned int  )8;
  sqlstm.sqindv[14] = (         short *)0;
  sqlstm.sqharm[14] = (unsigned int  )0;
  sqlstm.sqhstv[15] = (unsigned char  *)&element.KoeffizientFahrtwunscheinbeziehung;
  sqlstm.sqhstl[15] = (unsigned int  )8;
  sqlstm.sqindv[15] = (         short *)0;
  sqlstm.sqharm[15] = (unsigned int  )0;
  sqlstm.sqhstv[16] = (unsigned char  *)&element.KoeffizientStrassenanpassung;
  sqlstm.sqhstl[16] = (unsigned int  )8;
  sqlstm.sqindv[16] = (         short *)0;
  sqlstm.sqharm[16] = (unsigned int  )0;
  sqlstm.sqhstv[17] = (unsigned char  *)&element.AnzahlHaltestellen;
  sqlstm.sqhstl[17] = (unsigned int  )4;
  sqlstm.sqindv[17] = (         short *)0;
  sqlstm.sqharm[17] = (unsigned int  )0;
  sqlstm.sqhstv[18] = (unsigned char  *)&element.AnzStrassenkarte;
  sqlstm.sqhstl[18] = (unsigned int  )4;
  sqlstm.sqindv[18] = (         short *)0;
  sqlstm.sqharm[18] = (unsigned int  )0;
  sqlstm.sqhstv[19] = (unsigned char  *)&element.AnzBevoelkerungsversorgung;
  sqlstm.sqhstl[19] = (unsigned int  )4;
  sqlstm.sqindv[19] = (         short *)0;
  sqlstm.sqharm[19] = (unsigned int  )0;
  sqlstm.sqhstv[20] = (unsigned char  *)&element.AnzFlaechenversorgung;
  sqlstm.sqhstl[20] = (unsigned int  )4;
  sqlstm.sqindv[20] = (         short *)0;
  sqlstm.sqharm[20] = (unsigned int  )0;
  sqlstm.sqhstv[21] = (unsigned char  *)&element.Anzkomplettunterdruecken;
  sqlstm.sqhstl[21] = (unsigned int  )4;
  sqlstm.sqindv[21] = (         short *)0;
  sqlstm.sqharm[21] = (unsigned int  )0;
  sqlstm.sqhstv[22] = (unsigned char  *)&element.Strategie;
  sqlstm.sqhstl[22] = (unsigned int  )4;
  sqlstm.sqindv[22] = (         short *)0;
  sqlstm.sqharm[22] = (unsigned int  )0;
  sqlstm.sqhstv[23] = (unsigned char  *)&element.AnzahlEltern;
  sqlstm.sqhstl[23] = (unsigned int  )4;
  sqlstm.sqindv[23] = (         short *)0;
  sqlstm.sqharm[23] = (unsigned int  )0;
  sqlstm.sqhstv[24] = (unsigned char  *)&element.AnzahlKinder;
  sqlstm.sqhstl[24] = (unsigned int  )4;
  sqlstm.sqindv[24] = (         short *)0;
  sqlstm.sqharm[24] = (unsigned int  )0;
  sqlstm.sqhstv[25] = (unsigned char  *)&element.Generationen;
  sqlstm.sqhstl[25] = (unsigned int  )4;
  sqlstm.sqindv[25] = (         short *)0;
  sqlstm.sqharm[25] = (unsigned int  )0;
  sqlstm.sqhstv[26] = (unsigned char  *)&element.AbbruchGueteunterschreitung;
  sqlstm.sqhstl[26] = (unsigned int  )4;
  sqlstm.sqindv[26] = (         short *)0;
  sqlstm.sqharm[26] = (unsigned int  )0;
  sqlstm.sqhstv[27] = (unsigned char  *)&element.GrenzwGueteunterschreitung;
  sqlstm.sqhstl[27] = (unsigned int  )8;
  sqlstm.sqindv[27] = (         short *)0;
  sqlstm.sqharm[27] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenHaltestellenModulParameter");
}


		anzahl_reihen++;
	}
	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	/* EXEC SQL CLOSE haltestellenmodulcursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )14592;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenHaltestellenModulParameter");
}


	

//	Debug(2, "Anzahl REIHEN:"<<anzahl_reihen);
	/*EXEC SQL SELECT Aufruf, Toleranzgrenze, MaxRadius, MinRadius, VerbindungsRadiusStadt, VerbindungsRadiusLand
		INTO :element
		FROM HaltestellenModulParameter
		WHERE SpeicherID = :speicherid;*/

	// Und die Elemente uebergeben:
	algorithmus=element.Algorithmus;
	zufallsgeneratorInitialisierung=element.ZufallsgeneratorInitialisierung;
	minRadius=element.MinRadius;
	maxRadius=element.MaxRadius;
	verbindungsRadiusStadt=element.VerbindungsRadiusStadt;
	verbindungsRadiusLand=element.VerbindungsRadiusLand;
	radiustyp=element.Radiustyp;
	haltestellenLage=element.HaltestellenLage;
	toleranzgrenze=element.Toleranzgrenze;
	bevoelkerungsRaster=element.BevoelkerungsRaster;
	koeffizientBevoelkerungsueberversorgung=element.KoeffizientBevoelkerungsueberversorgung;
	koeffizientBevoelkerungsunterversorgung=element.KoeffizientBevoelkerungsunterversorgung;
	koeffizientFlaechenueberversorgung=element.KoeffizientFlaechenueberversorgung;
	koeffizientFlaechenunterversorgung=element.KoeffizientFlaechenunterversorgung;
	koeffizientFahrtwunscheinbeziehung=element.KoeffizientFahrtwunscheinbeziehung;
	koeffizientStrassenanpassung=element.KoeffizientStrassenanpassung;

	AnzahlHaltestellen=element.AnzahlHaltestellen;
	if(element.AnzStrassenkarte==1) AnzStrassenkarte=true;
	else AnzStrassenkarte=false;
 	if(element.AnzBevoelkerungsversorgung==1) AnzBevoelkerungsversorgung=true;
	else AnzBevoelkerungsversorgung=false;
 	if(element.AnzFlaechenversorgung==1) AnzFlaechenversorgung=true;
	else AnzFlaechenversorgung=false;
 	if(element.Anzkomplettunterdruecken==1) Anzkomplettunterdruecken=true;
	else Anzkomplettunterdruecken=false;
 	Strategie=element.Strategie;
	AnzahlEltern=element.AnzahlEltern;
 	AnzahlKinder=element.AnzahlKinder;
 	Generationen=element.Generationen;
	if(element.AbbruchGueteunterschreitung==1) AbbruchGueteunterschreitung=true;
	else AbbruchGueteunterschreitung=false;
	GrenzwGueteunterschreitung=element.GrenzwGueteunterschreitung;

	//und in die uebergebenen Variablen eingeben (werden erst mit 0 initialisiert)
	// sofern aber kein Eintrag exisitert (z.B. nach einem Neustart der Anwendung)
	// d.h. anzahl_reihen == 0, dann setze alle Werte auf 0:
	/*if(anzahl_reihen==0)
	{
	        toleranzgrenze=0;
		maxradius=0;
		minradius=0;
		verbindungsradiusstadt=0;
		verbindungsradiusland=0;
	}
	else
	{
		toleranzgrenze=element.toleranzgrenze2;
		maxradius=element.maxradius2;
		minradius=element.minradius2;
		verbindungsradiusstadt=element.verbindungsradiusstadt2;
		verbindungsradiusland=element.verbindungsradiusland2;
	} */

	//Debug(2, "ModulParameter lauten:"<<toleranzgrenze<<","<<maxradius<<","<<minradius<<","<<verbindungsradiusstadt<<","<<verbindungsradiusland);
}
//------------------------------------------------------------------------------
// Funktionsname:	speichernHaltestellenModulParameter
// Beschreibung:	Mit dieser Methode werden die grundlegenden Aufrufparameter gespeichert
// Parameter:		Nummer des Aufrufs, Toleranzgrenze, max. Radius, min. Radius, Verbindungsradius Stadt und Land
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::speichernHaltestellenModulParameter(int aufruf, int algorithmus, int zufallsgeneratorInitialisierung,
							double minRadius, double maxRadius, double verbindungsRadiusStadt,
							double verbindungsRadiusLand, int radiustyp, double haltestellenLage,
							double toleranzgrenze, int bevoelkerungsRaster, double koeffizientBevoelkerungsueberversorgung,
							double koeffizientBevoelkerungsunterversorgung, double koeffizientFlaechenueberversorgung,
							double koeffizientFlaechenunterversorgung, double koeffizientFahrtwunscheinbeziehung,
							double koeffizientStrassenanpassung, 
							int AnzahlHaltestellen, bool AnzStrassenkarte,
							bool AnzBevoelkerungsversorgung, bool AnzFlaechenversorgung, bool Anzkomplettunterdruecken,
							int Strategie, int AnzahlEltern, int AnzahlKinder, int Generationen, 
							bool AbbruchGueteunterschreitung, double GrenzwGueteunterschreitung)
{
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in speichernHaltestellenModulParameter"); */ 


	Debug(2, "Haltestellenmodulparameter");
	
	// erst ein paar dummywerte anlegen, damit Oracle die erkennt:
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	
	typedef struct
	{
		int speicherID;
		int Aufruf;
		int Algorithmus;
		int ZufallsgeneratorInitialisierung;
		double MinRadius;
		double MaxRadius;
		double VerbindungsRadiusStadt;
		double VerbindungsRadiusLand;
		int Radiustyp;
		double HaltestellenLage;
		double Toleranzgrenze;
		int BevoelkerungsRaster;
		double KoeffizientBevoelkerungsueberversorgung;
		double KoeffizientBevoelkerungsunterversorgung;
		double KoeffizientFlaechenueberversorgung;
		double KoeffizientFlaechenunterversorgung;
		double KoeffizientFahrtwunscheinbeziehung;
		double KoeffizientStrassenanpassung;

  		int AnzahlHaltestellen;
		int AnzStrassenkarte; //bool
 		int AnzBevoelkerungsversorgung;//bool
 		int AnzFlaechenversorgung;//bool
 		int Anzkomplettunterdruecken;//bool
 		int Strategie;
		int AnzahlEltern;
 		int AnzahlKinder;
 		int Generationen;
		int AbbruchGueteunterschreitung;//bool
		double GrenzwGueteunterschreitung;
	} hselem;
	hselem element;
	/* EXEC SQL END DECLARE SECTION; */ 

	element.speicherID = speicherstand;
        element.Aufruf=aufruf;
	element.Algorithmus=algorithmus;
	element.ZufallsgeneratorInitialisierung=zufallsgeneratorInitialisierung;
	element.MinRadius=minRadius;
	element.MaxRadius=maxRadius;
	element.VerbindungsRadiusStadt=verbindungsRadiusStadt;
	element.VerbindungsRadiusLand=verbindungsRadiusLand;
	element.Radiustyp=radiustyp;
	element.HaltestellenLage=haltestellenLage;
	element.Toleranzgrenze=toleranzgrenze;
	element.BevoelkerungsRaster=bevoelkerungsRaster;
	element.KoeffizientBevoelkerungsueberversorgung=koeffizientBevoelkerungsueberversorgung;
	element.KoeffizientBevoelkerungsunterversorgung=koeffizientBevoelkerungsunterversorgung;
	element.KoeffizientFlaechenueberversorgung=koeffizientFlaechenueberversorgung;
	element.KoeffizientFlaechenunterversorgung=koeffizientFlaechenunterversorgung;
	element.KoeffizientFahrtwunscheinbeziehung=koeffizientFahrtwunscheinbeziehung;
	element.KoeffizientStrassenanpassung=koeffizientStrassenanpassung;

	element.AnzahlHaltestellen=AnzahlHaltestellen;
	if(AnzStrassenkarte==true) element.AnzStrassenkarte=1;
	else element.AnzStrassenkarte=0;
	if(AnzBevoelkerungsversorgung==true) element.AnzBevoelkerungsversorgung=1; 
	else element.AnzBevoelkerungsversorgung=0;
	if(AnzFlaechenversorgung==true) element.AnzFlaechenversorgung=1;
	else element.AnzFlaechenversorgung=0;
	if(Anzkomplettunterdruecken==true) element.Anzkomplettunterdruecken=1;
	else element.Anzkomplettunterdruecken=0;
	element.Strategie=Strategie;
	element.AnzahlEltern=AnzahlEltern;
 	element.AnzahlKinder=AnzahlKinder;
 	element.Generationen=Generationen;
	if(AbbruchGueteunterschreitung==true) element.AbbruchGueteunterschreitung=1;
	else element.AbbruchGueteunterschreitung=0;
	element.GrenzwGueteunterschreitung=GrenzwGueteunterschreitung;

//        Debug(2, ".........->"<<element.KoeffizientBevoelkerungsueberversorgung);
	
	//zunaechst die Tabelle loeschen:
	/* EXEC SQL DELETE FROM HaltestellenModulParameter WHERE SpeicherID = :element.speicherID; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.stmt = "delete from HaltestellenModulParameter  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )14606;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&(element.speicherID);
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernHaltestellenModulParameter");
}



	/* EXEC SQL INSERT INTO HaltestellenModulParameter
		VALUES (:element); */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.stmt = "insert into HaltestellenModulParameter values (:s1 ,:s2 ,:s3\
 ,:s4 ,:s5 ,:s6 ,:s7 ,:s8 ,:s9 ,:s10 ,:s11 ,:s12 ,:s13 ,:s14 ,:s15 ,:s16 ,:s17\
 ,:s18 ,:s19 ,:s20 ,:s21 ,:s22 ,:s23 ,:s24 ,:s25 ,:s26 ,:s27 ,:s28 ,:s29 )";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )14624;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&element.speicherID;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqhstv[1] = (unsigned char  *)&element.Aufruf;
 sqlstm.sqhstl[1] = (unsigned int  )4;
 sqlstm.sqindv[1] = (         short *)0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqhstv[2] = (unsigned char  *)&element.Algorithmus;
 sqlstm.sqhstl[2] = (unsigned int  )4;
 sqlstm.sqindv[2] = (         short *)0;
 sqlstm.sqharm[2] = (unsigned int  )0;
 sqlstm.sqhstv[3] = (unsigned char  *)&element.ZufallsgeneratorInitialisierung;
 sqlstm.sqhstl[3] = (unsigned int  )4;
 sqlstm.sqindv[3] = (         short *)0;
 sqlstm.sqharm[3] = (unsigned int  )0;
 sqlstm.sqhstv[4] = (unsigned char  *)&element.MinRadius;
 sqlstm.sqhstl[4] = (unsigned int  )8;
 sqlstm.sqindv[4] = (         short *)0;
 sqlstm.sqharm[4] = (unsigned int  )0;
 sqlstm.sqhstv[5] = (unsigned char  *)&element.MaxRadius;
 sqlstm.sqhstl[5] = (unsigned int  )8;
 sqlstm.sqindv[5] = (         short *)0;
 sqlstm.sqharm[5] = (unsigned int  )0;
 sqlstm.sqhstv[6] = (unsigned char  *)&element.VerbindungsRadiusStadt;
 sqlstm.sqhstl[6] = (unsigned int  )8;
 sqlstm.sqindv[6] = (         short *)0;
 sqlstm.sqharm[6] = (unsigned int  )0;
 sqlstm.sqhstv[7] = (unsigned char  *)&element.VerbindungsRadiusLand;
 sqlstm.sqhstl[7] = (unsigned int  )8;
 sqlstm.sqindv[7] = (         short *)0;
 sqlstm.sqharm[7] = (unsigned int  )0;
 sqlstm.sqhstv[8] = (unsigned char  *)&element.Radiustyp;
 sqlstm.sqhstl[8] = (unsigned int  )4;
 sqlstm.sqindv[8] = (         short *)0;
 sqlstm.sqharm[8] = (unsigned int  )0;
 sqlstm.sqhstv[9] = (unsigned char  *)&element.HaltestellenLage;
 sqlstm.sqhstl[9] = (unsigned int  )8;
 sqlstm.sqindv[9] = (         short *)0;
 sqlstm.sqharm[9] = (unsigned int  )0;
 sqlstm.sqhstv[10] = (unsigned char  *)&element.Toleranzgrenze;
 sqlstm.sqhstl[10] = (unsigned int  )8;
 sqlstm.sqindv[10] = (         short *)0;
 sqlstm.sqharm[10] = (unsigned int  )0;
 sqlstm.sqhstv[11] = (unsigned char  *)&element.BevoelkerungsRaster;
 sqlstm.sqhstl[11] = (unsigned int  )4;
 sqlstm.sqindv[11] = (         short *)0;
 sqlstm.sqharm[11] = (unsigned int  )0;
 sqlstm.sqhstv[12] = (unsigned char  *)&element.KoeffizientBevoelkerungsueberversorgung;
 sqlstm.sqhstl[12] = (unsigned int  )8;
 sqlstm.sqindv[12] = (         short *)0;
 sqlstm.sqharm[12] = (unsigned int  )0;
 sqlstm.sqhstv[13] = (unsigned char  *)&element.KoeffizientBevoelkerungsunterversorgung;
 sqlstm.sqhstl[13] = (unsigned int  )8;
 sqlstm.sqindv[13] = (         short *)0;
 sqlstm.sqharm[13] = (unsigned int  )0;
 sqlstm.sqhstv[14] = (unsigned char  *)&element.KoeffizientFlaechenueberversorgung;
 sqlstm.sqhstl[14] = (unsigned int  )8;
 sqlstm.sqindv[14] = (         short *)0;
 sqlstm.sqharm[14] = (unsigned int  )0;
 sqlstm.sqhstv[15] = (unsigned char  *)&element.KoeffizientFlaechenunterversorgung;
 sqlstm.sqhstl[15] = (unsigned int  )8;
 sqlstm.sqindv[15] = (         short *)0;
 sqlstm.sqharm[15] = (unsigned int  )0;
 sqlstm.sqhstv[16] = (unsigned char  *)&element.KoeffizientFahrtwunscheinbeziehung;
 sqlstm.sqhstl[16] = (unsigned int  )8;
 sqlstm.sqindv[16] = (         short *)0;
 sqlstm.sqharm[16] = (unsigned int  )0;
 sqlstm.sqhstv[17] = (unsigned char  *)&element.KoeffizientStrassenanpassung;
 sqlstm.sqhstl[17] = (unsigned int  )8;
 sqlstm.sqindv[17] = (         short *)0;
 sqlstm.sqharm[17] = (unsigned int  )0;
 sqlstm.sqhstv[18] = (unsigned char  *)&element.AnzahlHaltestellen;
 sqlstm.sqhstl[18] = (unsigned int  )4;
 sqlstm.sqindv[18] = (         short *)0;
 sqlstm.sqharm[18] = (unsigned int  )0;
 sqlstm.sqhstv[19] = (unsigned char  *)&element.AnzStrassenkarte;
 sqlstm.sqhstl[19] = (unsigned int  )4;
 sqlstm.sqindv[19] = (         short *)0;
 sqlstm.sqharm[19] = (unsigned int  )0;
 sqlstm.sqhstv[20] = (unsigned char  *)&element.AnzBevoelkerungsversorgung;
 sqlstm.sqhstl[20] = (unsigned int  )4;
 sqlstm.sqindv[20] = (         short *)0;
 sqlstm.sqharm[20] = (unsigned int  )0;
 sqlstm.sqhstv[21] = (unsigned char  *)&element.AnzFlaechenversorgung;
 sqlstm.sqhstl[21] = (unsigned int  )4;
 sqlstm.sqindv[21] = (         short *)0;
 sqlstm.sqharm[21] = (unsigned int  )0;
 sqlstm.sqhstv[22] = (unsigned char  *)&element.Anzkomplettunterdruecken;
 sqlstm.sqhstl[22] = (unsigned int  )4;
 sqlstm.sqindv[22] = (         short *)0;
 sqlstm.sqharm[22] = (unsigned int  )0;
 sqlstm.sqhstv[23] = (unsigned char  *)&element.Strategie;
 sqlstm.sqhstl[23] = (unsigned int  )4;
 sqlstm.sqindv[23] = (         short *)0;
 sqlstm.sqharm[23] = (unsigned int  )0;
 sqlstm.sqhstv[24] = (unsigned char  *)&element.AnzahlEltern;
 sqlstm.sqhstl[24] = (unsigned int  )4;
 sqlstm.sqindv[24] = (         short *)0;
 sqlstm.sqharm[24] = (unsigned int  )0;
 sqlstm.sqhstv[25] = (unsigned char  *)&element.AnzahlKinder;
 sqlstm.sqhstl[25] = (unsigned int  )4;
 sqlstm.sqindv[25] = (         short *)0;
 sqlstm.sqharm[25] = (unsigned int  )0;
 sqlstm.sqhstv[26] = (unsigned char  *)&element.Generationen;
 sqlstm.sqhstl[26] = (unsigned int  )4;
 sqlstm.sqindv[26] = (         short *)0;
 sqlstm.sqharm[26] = (unsigned int  )0;
 sqlstm.sqhstv[27] = (unsigned char  *)&element.AbbruchGueteunterschreitung;
 sqlstm.sqhstl[27] = (unsigned int  )4;
 sqlstm.sqindv[27] = (         short *)0;
 sqlstm.sqharm[27] = (unsigned int  )0;
 sqlstm.sqhstv[28] = (unsigned char  *)&element.GrenzwGueteunterschreitung;
 sqlstm.sqhstl[28] = (unsigned int  )8;
 sqlstm.sqindv[28] = (         short *)0;
 sqlstm.sqharm[28] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernHaltestellenModulParameter");
}

 
	//(:aufruf2, :toleranzgrenze2, :maxradius2, :minradius2, :verbindungsradiusstadt2, :verbindungsradiusland2);
	//Debug(2, aufruf2<<toleranzgrenze2<<maxradius2<<minradius2<<verbindungsradiusstadt2<<verbindungsradiusland2);
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )14754;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernHaltestellenModulParameter");
}



//	Debug(2, "HaltestellenModulParameter eingetragen");		


}

//------------------------------------------------------------------------------
// Funktionsname:	holenBevoelkerungsdichte
// Beschreibung:	Mit dieser Methode wird die Bevoelkerungsdichte aus der Datenbank geholt
// Parameter:		
// Rueckgabe:		Zeiger auf eine Liste mit Zeigern auf BevoelkerungsdichteElemente
// Besonderheiten:	
//------------------------------------------------------------------------------
list<CBevoelkerungsdichteElement*>* CDBSchnittstelle::holenBevoelkerungsDichte()
{
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenBevoelkerungsdichte"); */ 


	Debug(3,"Lege Bevoelkerungsdichte-Liste an");
	
        // Datenfelder anlegen, die im folgenden als Zwischenspeicher dienen:
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	
	typedef struct
	{
		double x;
		double y;
		double radius;	
		double dichte;
	} dichteelement;
	dichteelement element;
	int speicherid=speicherstand;
	/* EXEC SQL END DECLARE SECTION; */ 
		

        // erzeuge den Cursor, mit dem Daten durchlaufen werden:
	/* EXEC SQL DECLARE dichtecursor CURSOR FOR
		SELECT XKoordinate, YKoordinate, Radius, Dichte
			FROM Bevoelkerungsdichte
			WHERE SpeicherID = :speicherid; */ 


	// jetzt den Cursor oeffnen
	/* EXEC SQL OPEN dichtecursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.stmt = sq0785;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )14768;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenBevoelkerungsdichte");
}



	// neue Liste fuer die Rueckgabe anlegen:
	list<CBevoelkerungsdichteElement*>* dichteliste=0;
	try{dichteliste=new list<CBevoelkerungsdichteElement*>;}
	catch(...)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Liste der Bevoelkerungsdichte konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}
	
	// uund jetzt in Schleife alle Dinger holen:
	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

	for(;;)
	{
		/* EXEC SQL FETCH dichtecursor INTO :element; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )14786;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&element.x;
  sqlstm.sqhstl[0] = (unsigned int  )8;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&element.y;
  sqlstm.sqhstl[1] = (unsigned int  )8;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&element.radius;
  sqlstm.sqhstl[2] = (unsigned int  )8;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqhstv[3] = (unsigned char  *)&element.dichte;
  sqlstm.sqhstl[3] = (unsigned int  )8;
  sqlstm.sqindv[3] = (         short *)0;
  sqlstm.sqharm[3] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenBevoelkerungsdichte");
}


		try{		
		dichteliste->append(new CBevoelkerungsdichteElement(new CPunkt(element.x, element.y),  element.dichte, element.radius));
		}catch(std::bad_alloc)
		{
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: "<<__LINE__<<": "<<"Ein Element der BevoelkerungsdichtenListe konnte nicht angelegt werden, Speichermangel"<<endl;
		}
	}
        /* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	// und nach getaner arbeit Cursor wieder schliessen:
	/* EXEC SQL CLOSE dichtecursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )14816;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenBevoelkerungsdichte");
}



	return dichteliste;
}
//------------------------------------------------------------------------------
// Funktionsname:	speichernBevoelkerungsdichte
// Beschreibung:	Mit dieser Methode wird die Bevoelkerungsdichte gespeichert
// Parameter:		Zeiger auf eine lsite mit den Bevoelkerungsdichte-Elementen
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::speichernBevoelkerungsDichte(list<CBevoelkerungsdichteElement*>* bevdichte=0)
{
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in speichernBevoelkerungsDichte"); */ 


	if(bevdichte!=0)
	{
	
	Debug(2, "speichereBevoelkerungsdichte");
	
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	typedef struct
	{
		int speicherID;
		double x;
		double y;
		double radius;	
		double dichte;
	} dichteelement;
        dichteelement element;
        /* EXEC SQL END DECLARE SECTION; */ 
	
	element.speicherID = speicherstand;

	CFortschritt* fortschritt=0;
	if(batchbetrieb==false) 
	{
		try{fortschritt=new CFortschritt("Speichern der Ausgangsdaten");}
		catch(...)
		{
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Fortschrittsanzeige beim Speichern der Bevoelkerungsdichte konnte nicht angelegt werden. Speichermangel?"<<endl;
			cerr.flush();
		}
	}
	if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Loesche alte Bevoelkerungsdichte in der Datenbank...");

	//zunaechst die Tabelle loeschen:
	/* EXEC SQL DELETE FROM Bevoelkerungsdichte WHERE SpeicherID = :element.speicherID; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.stmt = "delete from Bevoelkerungsdichte  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )14830;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&(element.speicherID);
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernBevoelkerungsDichte");
}



//	Debug(2, "speichernBevoelkerungsdichte: bevoelkerungsdichte geloescht; vor Schleife");
	// durchlaufe Liste
	
	if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Speichere die Bevoelkerungsdichte in der Datenbank...");

	CBevoelkerungsdichteElement* listenelement=0;
	try{listenelement=new CBevoelkerungsdichteElement(new CPunkt, 0,0);}
	catch(...)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: eine Element der Bevoelkerungsdichte konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}
	int durchlauf=0;
	forall(listenelement, (*bevdichte))
	{
		        if(fortschritt!=0) fortschritt->anzeigenFortschritt(++durchlauf, bevdichte->length());

			// Struktur fuellen:
			(listenelement->holenPunkt())->holen(&element.x, &element.y);
			element.radius=listenelement->holenRadius();
			element.dichte=listenelement->holenDichte();
		
			// und reinschieben: (VonHaltestelle, NachHaltestelle, Reiseaufkommen)
			/* EXEC SQL INSERT INTO Bevoelkerungsdichte
				VALUES(:element); */ 

{
   struct sqlexd sqlstm;

   sqlorat((void **)0, &sqlctx, &oraca);
   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 35;
   sqlstm.stmt = "insert into Bevoelkerungsdichte values (:s1 ,:s2 ,:s3 ,:s4\
 ,:s5 )";
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )14848;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlstm.sqhstv[0] = (unsigned char  *)&element.speicherID;
   sqlstm.sqhstl[0] = (unsigned int  )4;
   sqlstm.sqindv[0] = (         short *)0;
   sqlstm.sqharm[0] = (unsigned int  )0;
   sqlstm.sqhstv[1] = (unsigned char  *)&element.x;
   sqlstm.sqhstl[1] = (unsigned int  )8;
   sqlstm.sqindv[1] = (         short *)0;
   sqlstm.sqharm[1] = (unsigned int  )0;
   sqlstm.sqhstv[2] = (unsigned char  *)&element.y;
   sqlstm.sqhstl[2] = (unsigned int  )8;
   sqlstm.sqindv[2] = (         short *)0;
   sqlstm.sqharm[2] = (unsigned int  )0;
   sqlstm.sqhstv[3] = (unsigned char  *)&element.radius;
   sqlstm.sqhstl[3] = (unsigned int  )8;
   sqlstm.sqindv[3] = (         short *)0;
   sqlstm.sqharm[3] = (unsigned int  )0;
   sqlstm.sqhstv[4] = (unsigned char  *)&element.dichte;
   sqlstm.sqhstl[4] = (unsigned int  )8;
   sqlstm.sqindv[4] = (         short *)0;
   sqlstm.sqharm[4] = (unsigned int  )0;
   sqlstm.sqphsv = sqlstm.sqhstv;
   sqlstm.sqphsl = sqlstm.sqhstl;
   sqlstm.sqpind = sqlstm.sqindv;
   sqlstm.sqparm = sqlstm.sqharm;
   sqlstm.sqparc = sqlstm.sqharc;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
   if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernBevoelkerungsDichte");
}




			/* EXEC SQL COMMIT; */ 

{
   struct sqlexd sqlstm;

   sqlorat((void **)0, &sqlctx, &oraca);
   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 35;
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )14882;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
   if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernBevoelkerungsDichte");
}


//			Debug(2, "Werte: "<<element.x<<", "<<element.y<<" radius:"<<element.radius<<" dichte:"<<element.dichte);

			// ALle Werte zur Sicherheit auf 0 setzen:
			element.x=0;
			element.y=0;
			element.radius=0;
			element.dichte=0;
	} 
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )14896;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernBevoelkerungsDichte");
}


	
//	Debug(2, "speichernBevoelkerungsdichte: ende der Methode");
	
	//ordentliches Zerstoeren der Bevoelkerungsliste
	CBevoelkerungsdichteElement* terminator=0;
	forall(terminator, *bevdichte) {
		delete terminator;
	}
    delete bevdichte;
	if(fortschritt!=0) delete fortschritt;
	} // endif: test auf Nullzeiger
	else cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: speichernBevoelkerungsdichte: NULL-Zeiger wurde uebergeben!"<<endl;
	
}

//------------------------------------------------------------------------------
// Funktionsname:	holenPendlerMatrix
// Beschreibung:	Mit dieser Methode wird die Pendler-Matrix aus der Datenbank geholt
// Parameter:		
// Rueckgabe:		Zeiger auf eine matrix (LEDA)
// Besonderheiten:	
//------------------------------------------------------------------------------
matrix* CDBSchnittstelle::holenPendlermatrix()
{
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenPendlermatrix"); */ 


	Debug(3,"Lege Pendler-Matrix an");
	
        // Datenfelder anlegen, die im folgenden als Zwischenspeicher dienen:
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	
	typedef struct
	{
		int StadtteilVon;
		int StadtteilNach;
		double Dichte;	
	} pendlerelem;
	pendlerelem element;
	int speicherid=speicherstand;
	/* EXEC SQL END DECLARE SECTION; */ 
		

        // Problem: LEDA-Matrix muss beim erzeugen eine feste Groesse zugewiesen werden
	// Daher muss ich zuerst schauen, fuer wie viele Elemente die Matrix geruesstet
	// sein soll.
	// Da die Matrix quadratisch ist, hole ich mir eine Zeile und zaehle die
	// Eintraege per Cursor. Dann kann ich einfach davon das Quadrat nehmen und
	// habe die Matrix groesse.
	// Also:
	// schauen, wieviele Elemente in einer Reihe stehen:
	// erzeuge den Cursor:
	/* EXEC SQL DECLARE pendler_cursor CURSOR FOR
		SELECT StadtteilVon, StadtteilNach, Dichte
			FROM Pendlermatrix
			WHERE StadtteilVon LIKE 1 AND SpeicherID = :speicherid; */ 


	// jetzt den Cursor oeffnen
	/* EXEC SQL OPEN pendler_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.stmt = sq0790;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )14910;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenPendlermatrix");
}


	// Jetzt Schleife durchlaufen, bis keine Daten mehr im
	// Cursor sind, dabei einen Zaehler erhoehen:
	int zaehler=0; // Anzahl der Elemente in einer Zeile

	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

	for(;;)
	{
		/* EXEC SQL FETCH pendler_cursor INTO :element; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )14928;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&element.StadtteilVon;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&element.StadtteilNach;
  sqlstm.sqhstl[1] = (unsigned int  )4;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&element.Dichte;
  sqlstm.sqhstl[2] = (unsigned int  )8;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenPendlermatrix");
}


		// Zaehle jetzt, wieviele Elemente es in einer Zeile gibtt
		zaehler++;
	}
	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	// und nach getaner arbeit Cursor wieder schliessen:
	/* EXEC SQL CLOSE pendler_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )14954;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenPendlermatrix");
}


        // jetzt steht in zaehler die Anzahl der Elemente in einer Zeile
//	Debug(2, "holenPendlermatrix: Zaehler steht auf:"<<zaehler);


	// AB HIER IST ALLES IM TODO-STADIUM
	// jetzt ein Array der entsprechenden groesse (quadratisch anlegen):
	double pm[zaehler*zaehler];
	// Array-Werte mit -1 initialisieren:
	for(int loescher=0; loescher<zaehler*zaehler; loescher++) pm[loescher]=-1;
//        Debug(2, "Array angelegt");
        // Jetzt einen Cursor anlegen, der alle Dinger durchlaeuft:
	/* EXEC SQL DECLARE pendler_cursor2 CURSOR FOR
		SELECT StadtteilVon, StadtteilNach, Dichte
			FROM Pendlermatrix
			WHERE SpeicherID = :speicherid; */ 

        // Cursor wieder oeffnen
	/* EXEC SQL OPEN pendler_cursor2; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.stmt = sq0791;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )14968;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenPendlermatrix");
}



        // Jetzt in einer Schleife die einzelnen Elemente einlesen:
	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

	int position=0;
	for(;;)
	{
		/* EXEC SQL FETCH pendler_cursor2 INTO :element; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )14986;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&element.StadtteilVon;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&element.StadtteilNach;
  sqlstm.sqhstl[1] = (unsigned int  )4;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&element.Dichte;
  sqlstm.sqhstl[2] = (unsigned int  )8;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenPendlermatrix");
}


		pm[element.StadtteilVon*zaehler+element.StadtteilNach]=element.Dichte;
		position++;
	}
        /* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	// und nach getaner arbeit Cursor wieder schliessen:
	/* EXEC SQL CLOSE pendler_cursor2; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )15012;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenPendlermatrix");
}



//	Debug(2, "Matrix erzeugen:");
	// Jetzt die Matrix erzeugen
	matrix* pendlerMatrix =0;
	try{
	pendlerMatrix = new matrix(zaehler,zaehler,pm);
	}catch(std::bad_alloc)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: "<<__LINE__<<": "<<"pendlermatrix konnte nicht angelegt werden, Speichermangel"<<endl;
	}

	return pendlerMatrix; // und zurueckgeben

}
//------------------------------------------------------------------------------
// Funktionsname:	speichernPendlermatrix
// Beschreibung:	Mit dieser Methode wird die Pendlermatrix gespeichert
// Parameter:		Zeiger auf eine Matrix
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::speichernPendlermatrix(matrix* pendlermatrix=0)
{
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in speichernPendlerMatrix"); */ 


	if(pendlermatrix!=0)
	{
	
	Debug(2, "speichernPendlermatrix");

	CFortschritt* fortschritt=0;
	if(batchbetrieb==false) 
	{
		try{fortschritt=new CFortschritt("Speichern der Ausgangsdaten");}
		catch(...)
		{	
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Fortschrittsanzeige beim Speichern der PendlerMatrix konnte nicht angelegt werden. Speichermangel?"<<endl;
			cerr.flush();
		}
	}
	if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Loesche alte Pendlermatrix in der Datenbank...");

	//zunaechst die Tabelle loeschen:
	/* EXEC SQL DELETE FROM Pendlermatrix; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.stmt = "delete from Pendlermatrix ";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )15026;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernPendlerMatrix");
}



	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	typedef struct
	{
		int speicherID;
		int vonStadtteil;
		int nachStadtteil;
		double pendler;	
	} pendlerelement;
	pendlerelement element;
	/* EXEC SQL END DECLARE SECTION; */ 

	element.speicherID = speicherstand;	

	if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Speichere die Pendlermatrix in der Datenbank...");

//	Debug(2, "speichernPendlermatrix: Pendlermatrix geloescht; vor Schleife");
	// durchlaufe Matrix
	int durchlauf=0;
	for( int x=0; x<pendlermatrix->dim1(); x++)
	{
		for(int y=0; y<pendlermatrix->dim2(); y++)
		{
			if(fortschritt!=0) fortschritt->anzeigenFortschritt(++durchlauf, (pendlermatrix->dim1()) * (pendlermatrix->dim2()));
			// Werte zuweisen:
			element.vonStadtteil=x;
			element.nachStadtteil=y;
			element.pendler=(*pendlermatrix)(x,y);
	
			// und reinschieben: (VonHaltestelle, NachHaltestelle, Reiseaufkommen)
			/* EXEC SQL INSERT INTO Pendlermatrix
				VALUES(:element); */ 

{
   struct sqlexd sqlstm;

   sqlorat((void **)0, &sqlctx, &oraca);
   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 35;
   sqlstm.stmt = "insert into Pendlermatrix values (:s1 ,:s2 ,:s3 ,:s4 )";
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )15040;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlstm.sqhstv[0] = (unsigned char  *)&element.speicherID;
   sqlstm.sqhstl[0] = (unsigned int  )4;
   sqlstm.sqindv[0] = (         short *)0;
   sqlstm.sqharm[0] = (unsigned int  )0;
   sqlstm.sqhstv[1] = (unsigned char  *)&element.vonStadtteil;
   sqlstm.sqhstl[1] = (unsigned int  )4;
   sqlstm.sqindv[1] = (         short *)0;
   sqlstm.sqharm[1] = (unsigned int  )0;
   sqlstm.sqhstv[2] = (unsigned char  *)&element.nachStadtteil;
   sqlstm.sqhstl[2] = (unsigned int  )4;
   sqlstm.sqindv[2] = (         short *)0;
   sqlstm.sqharm[2] = (unsigned int  )0;
   sqlstm.sqhstv[3] = (unsigned char  *)&element.pendler;
   sqlstm.sqhstl[3] = (unsigned int  )8;
   sqlstm.sqindv[3] = (         short *)0;
   sqlstm.sqharm[3] = (unsigned int  )0;
   sqlstm.sqphsv = sqlstm.sqhstv;
   sqlstm.sqphsl = sqlstm.sqhstl;
   sqlstm.sqpind = sqlstm.sqindv;
   sqlstm.sqparm = sqlstm.sqharm;
   sqlstm.sqparc = sqlstm.sqharc;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
   if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernPendlerMatrix");
}



//			Debug(2, "Eintrag: "<<x<<","<<y<<" Wert: "<<element.pendler);

			/* EXEC SQL COMMIT; */ 

{
   struct sqlexd sqlstm;

   sqlorat((void **)0, &sqlctx, &oraca);
   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 35;
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )15070;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
   if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernPendlerMatrix");
}



			// Zur vorsicht alles auf 0 setzten
			element.vonStadtteil=0;
			element.nachStadtteil=0;
			element.pendler=0;
             	}
	} 
	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )15084;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernPendlerMatrix");
}


//	Debug(2, "speichernPendlermatrix: ende der Methode");
        delete pendlermatrix;
	if(fortschritt!=0) delete fortschritt;
	} // endif: test auf Nullzeiger
	else cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: speichernPendlermatrix: NULL-Zeiger wurde uebergeben!"<<endl;
}

//------------------------------------------------------------------------------
// Funktionsname:	holenPendlerliste
// Beschreibung:	Mit dieser Methode wird die Pendlerliste aus der Datenbank geholt
// Parameter:		
// Rueckgabe:		Zeiger auf eine Liste mit Zeigern auf PendlerlisteElemente
// Besonderheiten:	
//------------------------------------------------------------------------------
list<CPendlerListeElement*>* CDBSchnittstelle::holenPendlerliste()
{
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenPendlerliste"); */ 


	Debug(3,"Lege Pendlerliste an");
	
        // Datenfelder anlegen, die im folgenden als Zwischenspeicher dienen:
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	
	typedef struct
	{
		double xKoordinate;
		double yKoordinate;
		int ElementID;	
		double Radius;	
	} pendlerelement;
	pendlerelement element;
	int speicherid=speicherstand;
	/* EXEC SQL END DECLARE SECTION; */ 
		

        // erzeuge den Cursor, mit dem Daten durchlaufen werden:
	/* EXEC SQL DECLARE pendlercursor CURSOR FOR
		SELECT xKoordinate, yKoordinate, ElementID, Radius
			FROM Pendlerliste
			WHERE SpeicherID = :speicherid; */ 


	// jetzt den Cursor oeffnen
	/* EXEC SQL OPEN pendlercursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.stmt = sq0796;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )15098;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenPendlerliste");
}



	// neue Liste fuer die Rueckgabe anlegen:
	list<CPendlerListeElement*>* pendlerliste=0;
	try{pendlerliste=new list<CPendlerListeElement*>;}
	catch(...)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Pendlerliste konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}
	
	// uund jetzt in Schleife alle Dinger holen:
	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

	for(;;)
	{
		/* EXEC SQL FETCH pendlercursor INTO :element; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )15116;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&element.xKoordinate;
  sqlstm.sqhstl[0] = (unsigned int  )8;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&element.yKoordinate;
  sqlstm.sqhstl[1] = (unsigned int  )8;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&element.ElementID;
  sqlstm.sqhstl[2] = (unsigned int  )4;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqhstv[3] = (unsigned char  *)&element.Radius;
  sqlstm.sqhstl[3] = (unsigned int  )8;
  sqlstm.sqindv[3] = (         short *)0;
  sqlstm.sqharm[3] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenPendlerliste");
}


		try{		
		pendlerliste->append(new CPendlerListeElement(new CPunkt(element.xKoordinate, element.yKoordinate), element.ElementID, element.Radius));
		}catch(std::bad_alloc)
		{
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: "<<__LINE__<<": "<<"ein Element der PendlerListe konnte nicht angelegt werden, Speichermangel"<<endl;
		}
	}
        /* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	// und nach getaner arbeit Cursor wieder schliessen:
	/* EXEC SQL CLOSE pendlercursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )15146;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenPendlerliste");
}



	return pendlerliste;
}
//------------------------------------------------------------------------------
// Funktionsname:	speichernPendlerliste
// Beschreibung:	Mit dieser Methode wird die Pendlerliste gespeichert
// Parameter:		Zeiger auf eine liste mit den Bevoelkerungsdichte-Elementen
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::speichernPendlerliste(list<CPendlerListeElement*>* pendlerliste=0)
{
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in speichernPendlerliste"); */ 


	if(pendlerliste!=0)
	{
	
	Debug(2, "speichernPenderliste");
	
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	typedef struct
	{
		int speicherID;
		double xKoordinate;
		double yKoordinate;
		int ElementID;	
		double Radius;
	} pendlerelement;
        pendlerelement element;
        /* EXEC SQL END DECLARE SECTION; */ 
	
	element.speicherID = speicherstand;

	CFortschritt* fortschritt=0;
	if(batchbetrieb==false) 
	{
		try{fortschritt=new CFortschritt("Speichern der Ausgangsdaten");}
		catch(...)
		{
			cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Fortschrittsanzeige beim Speichern der Pendlerliste konnte nicht angelegt werden. Speichermangel?"<<endl;
			cerr.flush();
		}
	}
	if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Loesche alte Pendlerliste in der Datenbank...");

	//zunaechst die Tabelle loeschen:
	/* EXEC SQL DELETE FROM Pendlerliste WHERE SpeicherID = :element.speicherID; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.stmt = "delete from Pendlerliste  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )15160;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&(element.speicherID);
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernPendlerliste");
}



//	Debug(2, "speichernPendlerliste: pendlerliste geloescht; vor Schleife");
	// durchlaufe Liste
	
	if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Speichere die Pendlerliste in der Datenbank...");

	CPendlerListeElement* listenelement=0;
	try{listenelement=new CPendlerListeElement(new CPunkt, 0,0);}
	catch(...)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: ein Element der Pendlerliste konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}
	int durchlauf=0;
	forall(listenelement, (*pendlerliste))
	{
			if(fortschritt!=0) fortschritt->anzeigenFortschritt(++durchlauf, pendlerliste->length());

		        // Struktur fuellen:
			(listenelement->holenPunkt())->holen(&element.xKoordinate, &element.yKoordinate);
			element.ElementID=listenelement->holenID();
			element.Radius=listenelement->holenRadius();

  			// und reinschieben:
			/* EXEC SQL INSERT INTO Pendlerliste
				VALUES(:element); */ 

{
   struct sqlexd sqlstm;

   sqlorat((void **)0, &sqlctx, &oraca);
   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 35;
   sqlstm.stmt = "insert into Pendlerliste values (:s1 ,:s2 ,:s3 ,:s4 ,:s5 )";
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )15178;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlstm.sqhstv[0] = (unsigned char  *)&element.speicherID;
   sqlstm.sqhstl[0] = (unsigned int  )4;
   sqlstm.sqindv[0] = (         short *)0;
   sqlstm.sqharm[0] = (unsigned int  )0;
   sqlstm.sqhstv[1] = (unsigned char  *)&element.xKoordinate;
   sqlstm.sqhstl[1] = (unsigned int  )8;
   sqlstm.sqindv[1] = (         short *)0;
   sqlstm.sqharm[1] = (unsigned int  )0;
   sqlstm.sqhstv[2] = (unsigned char  *)&element.yKoordinate;
   sqlstm.sqhstl[2] = (unsigned int  )8;
   sqlstm.sqindv[2] = (         short *)0;
   sqlstm.sqharm[2] = (unsigned int  )0;
   sqlstm.sqhstv[3] = (unsigned char  *)&element.ElementID;
   sqlstm.sqhstl[3] = (unsigned int  )4;
   sqlstm.sqindv[3] = (         short *)0;
   sqlstm.sqharm[3] = (unsigned int  )0;
   sqlstm.sqhstv[4] = (unsigned char  *)&element.Radius;
   sqlstm.sqhstl[4] = (unsigned int  )8;
   sqlstm.sqindv[4] = (         short *)0;
   sqlstm.sqharm[4] = (unsigned int  )0;
   sqlstm.sqphsv = sqlstm.sqhstv;
   sqlstm.sqphsl = sqlstm.sqhstl;
   sqlstm.sqpind = sqlstm.sqindv;
   sqlstm.sqparm = sqlstm.sqharm;
   sqlstm.sqparc = sqlstm.sqharc;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
   if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernPendlerliste");
}



//			Debug(2, "Werte: "<<element.xKoordinate<<", "<<element.yKoordinate<<" ElementID:"<<element.ElementID<<" Radius:"<<element.Radius);

			// ALle Werte zur Sicherheit auf 0 setzen:
			element.xKoordinate=0;
			element.yKoordinate=0;
			element.ElementID=0;
			element.Radius=0;

			/* EXEC SQL COMMIT; */ 

{
   struct sqlexd sqlstm;

   sqlorat((void **)0, &sqlctx, &oraca);
   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 35;
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )15212;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
   if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernPendlerliste");
}


	} 
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )15226;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernPendlerliste");
}


	
//	Debug(2, "speichernPendlerliste: ende der Methode");
	
	//Durchlaufen der Liste und Stueck fuer Stueck wegwerfen
	CPendlerListeElement* terminator=0;
	list<int> *terminator2=0;
	forall(terminator, *pendlerliste) {
		delete terminator;
	}
    delete pendlerliste;
	if(fortschritt!=0) delete fortschritt;
	} // endif: test auf Nullzeiger
	else cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: speichernPendlerliste: NULL-Zeiger wurde uebergeben!"<<endl;	
}







// Linienplan: --------------------------------------------------------------------------------------------
// Eingaben:
//------------------------------------------------------------------------------
// Funktionsname:	holenLinienplanModulParameter
// Beschreibung:	Mit dieser Methode werden die Parameter aus der Datenbank geholt
// Parameter:		Nummer des Aufrufs, Gesamtlaenge, min. Linienanzahl, max. Linienanzahl, Linienplan-ID
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::holenLinienplanModulParameter(int aufruf, int& gesamtlaenge, int& maxLinienLaenge, 
							int& maxLinienAnzahl, double& linienplanID,
							int& geschwindigkeit, int& algorithmus, int& anzeigegraphen,
							bool& EindeutigeLinienverkn, bool& MehrdeutigeLinienverkn, 
							bool& Aufbruchsverknuepfung, bool& Linienendverknuepfung,
							bool& Basislinienwahl)
{
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenLinienplanModulParameter"); */ 


	// Holt den Linienplan mit dem Aufruf aufruf	

	// erst ein paar dummywerte anlegen, damit Oracle die erkennt:
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	
	typedef struct
	{
		double aufruf2;
		int gesamtlaenge2; 
		int maxLinienLaenge2;
		int maxLinienAnzahl2;
		double linienplanID2;
		int geschwindigkeit2;
		int algorithmus2;
		int anzeigegraphen2;
		int EindeutigeLinienverkn;
		int MehrdeutigeLinienverkn;
		int Aufbruchsverknuepfung;
		int Linienendverknuepfung;
		int Basislinienwahl;
	} lpelem;
	lpelem element;
	int speicherid=speicherstand;
	/* EXEC SQL END DECLARE SECTION; */ 


	// erst die Elemente der Struktur mit -1 initialisieren, falls in der Tabelle
	// nichts drin steht:
	element.aufruf2=aufruf;
	element.gesamtlaenge2=-1;
	element.maxLinienLaenge2=-1;
	element.maxLinienAnzahl2=-1;
	element.linienplanID2=-1;
	element.geschwindigkeit2=-1;
	element.algorithmus2=-1;
	element.anzeigegraphen2=-1;
	element.EindeutigeLinienverkn=-1;
	element.MehrdeutigeLinienverkn=-1;
	element.Aufbruchsverknuepfung=-1;
	element.Linienendverknuepfung=-1;
	element.Basislinienwahl=-1;

	/* EXEC SQL SELECT Aufruf, Gesamtlaenge, MaxLinienLaenge, MaxLinienAnzahl, LinienplanID, Geschwindigkeit, Algorithmus, AnzeigeBerechnung, EindeutigeLinienverkn, MehrdeutigeLinienverkn, Aufbruchsverknuepfung, Linienendverknuepfung, Basislinienwahl
		INTO :element
		FROM LinienplanModulParameter
		WHERE SpeicherID = :speicherid AND Aufruf = :element.aufruf2; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.stmt = "select Aufruf ,Gesamtlaenge ,MaxLinienLaenge ,MaxLinienAnzah\
l ,LinienplanID ,Geschwindigkeit ,Algorithmus ,AnzeigeBerechnung ,EindeutigeLi\
nienverkn ,MehrdeutigeLinienverkn ,Aufbruchsverknuepfung ,Linienendverknuepfun\
g ,Basislinienwahl into :s1 ,:s2 ,:s3 ,:s4 ,:s5 ,:s6 ,:s7 ,:s8 ,:s9 ,:s10 ,:s1\
1 ,:s12 ,:s13   from LinienplanModulParameter where (SpeicherID=:b1 and Aufruf\
=:b2)";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )15240;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&element.aufruf2;
 sqlstm.sqhstl[0] = (unsigned int  )8;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqhstv[1] = (unsigned char  *)&element.gesamtlaenge2;
 sqlstm.sqhstl[1] = (unsigned int  )4;
 sqlstm.sqindv[1] = (         short *)0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqhstv[2] = (unsigned char  *)&element.maxLinienLaenge2;
 sqlstm.sqhstl[2] = (unsigned int  )4;
 sqlstm.sqindv[2] = (         short *)0;
 sqlstm.sqharm[2] = (unsigned int  )0;
 sqlstm.sqhstv[3] = (unsigned char  *)&element.maxLinienAnzahl2;
 sqlstm.sqhstl[3] = (unsigned int  )4;
 sqlstm.sqindv[3] = (         short *)0;
 sqlstm.sqharm[3] = (unsigned int  )0;
 sqlstm.sqhstv[4] = (unsigned char  *)&element.linienplanID2;
 sqlstm.sqhstl[4] = (unsigned int  )8;
 sqlstm.sqindv[4] = (         short *)0;
 sqlstm.sqharm[4] = (unsigned int  )0;
 sqlstm.sqhstv[5] = (unsigned char  *)&element.geschwindigkeit2;
 sqlstm.sqhstl[5] = (unsigned int  )4;
 sqlstm.sqindv[5] = (         short *)0;
 sqlstm.sqharm[5] = (unsigned int  )0;
 sqlstm.sqhstv[6] = (unsigned char  *)&element.algorithmus2;
 sqlstm.sqhstl[6] = (unsigned int  )4;
 sqlstm.sqindv[6] = (         short *)0;
 sqlstm.sqharm[6] = (unsigned int  )0;
 sqlstm.sqhstv[7] = (unsigned char  *)&element.anzeigegraphen2;
 sqlstm.sqhstl[7] = (unsigned int  )4;
 sqlstm.sqindv[7] = (         short *)0;
 sqlstm.sqharm[7] = (unsigned int  )0;
 sqlstm.sqhstv[8] = (unsigned char  *)&element.EindeutigeLinienverkn;
 sqlstm.sqhstl[8] = (unsigned int  )4;
 sqlstm.sqindv[8] = (         short *)0;
 sqlstm.sqharm[8] = (unsigned int  )0;
 sqlstm.sqhstv[9] = (unsigned char  *)&element.MehrdeutigeLinienverkn;
 sqlstm.sqhstl[9] = (unsigned int  )4;
 sqlstm.sqindv[9] = (         short *)0;
 sqlstm.sqharm[9] = (unsigned int  )0;
 sqlstm.sqhstv[10] = (unsigned char  *)&element.Aufbruchsverknuepfung;
 sqlstm.sqhstl[10] = (unsigned int  )4;
 sqlstm.sqindv[10] = (         short *)0;
 sqlstm.sqharm[10] = (unsigned int  )0;
 sqlstm.sqhstv[11] = (unsigned char  *)&element.Linienendverknuepfung;
 sqlstm.sqhstl[11] = (unsigned int  )4;
 sqlstm.sqindv[11] = (         short *)0;
 sqlstm.sqharm[11] = (unsigned int  )0;
 sqlstm.sqhstv[12] = (unsigned char  *)&element.Basislinienwahl;
 sqlstm.sqhstl[12] = (unsigned int  )4;
 sqlstm.sqindv[12] = (         short *)0;
 sqlstm.sqharm[12] = (unsigned int  )0;
 sqlstm.sqhstv[13] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[13] = (unsigned int  )4;
 sqlstm.sqindv[13] = (         short *)0;
 sqlstm.sqharm[13] = (unsigned int  )0;
 sqlstm.sqhstv[14] = (unsigned char  *)&(element.aufruf2);
 sqlstm.sqhstl[14] = (unsigned int  )8;
 sqlstm.sqindv[14] = (         short *)0;
 sqlstm.sqharm[14] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenLinienplanModulParameter");
}


        
//	Debug(2, element.aufruf2<<" "<<element.gesamtlaenge2<<" "<<element.maxLinienLaenge2<<element.maxLinienAnzahl2<<element.linienplanID2);
	//und in die uebergebenen Variablen eingeben:
	aufruf=element.aufruf2;
	gesamtlaenge=element.gesamtlaenge2; 
	maxLinienLaenge=element.maxLinienLaenge2;
	maxLinienAnzahl=element.maxLinienAnzahl2;
	linienplanID=element.linienplanID2;
	geschwindigkeit=element.geschwindigkeit2;
	algorithmus=element.algorithmus2;
	anzeigegraphen=element.anzeigegraphen2;
	if(element.EindeutigeLinienverkn==0) EindeutigeLinienverkn=false;
	else EindeutigeLinienverkn=true;
	if(element.MehrdeutigeLinienverkn==0) MehrdeutigeLinienverkn=false;
	else MehrdeutigeLinienverkn=true;
	if(element.Aufbruchsverknuepfung==0) Aufbruchsverknuepfung=false;
	else Aufbruchsverknuepfung=true;
	if(element.Linienendverknuepfung==0) Linienendverknuepfung=false;
	else Linienendverknuepfung=true;
	if(element.Basislinienwahl==0) Basislinienwahl=false;
	else Basislinienwahl=true;

}
//------------------------------------------------------------------------------
// Funktionsname:	speichernLinienplanModulParameter
// Beschreibung:	Mit dieser Methode werden die grundlegenden Aufrufparameter gespeichert
// Parameter:		Nummer des Aufrufs, Gesamtlaenge, min. Linienanzahl, max. Linienanzahl, Linienplan-ID
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::speichernLinienplanModulParameter(int aufruf, int gesamtlaenge, int maxLinienLaenge, 
							int maxLinienAnzahl, double linienplanID,
							int geschwindigkeit=15, int algorithmus=0, int anzeigegraphen=0, 
							bool EindeutigeLinienverkn=false, bool MehrdeutigeLinienverkn=false, 
							bool Aufbruchsverknuepfung=false, bool Linienendverknuepfung=false,
							bool Basislinienwahl=false)
{
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in speichernLinienplanModulParameter"); */ 


	Debug(2, "speichernLinienplanModulParameter");
	
        // erst ein paar dummywerte anlegen, damit Oracle die erkennt:
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	
	typedef struct
	{
		int speicherID;
		double aufruf2;
		int gesamtlaenge2; 
		int maxLinienLaenge2;
		int maxLinienAnzahl2;
		double linienplanID2;
		int geschwindigkeit2;
		int algorithmus2;
		int anzeigegraphen2;
		int EindeutigeLinienverkn;
		int MehrdeutigeLinienverkn;
		int Aufbruchsverknuepfung;
		int Linienendverknuepfung;
		int Basislinienwahl;
	} lpelem;
	lpelem element;
	/* EXEC SQL END DECLARE SECTION; */ 

	element.speicherID = speicherstand;
	element.aufruf2=aufruf;
	element.gesamtlaenge2=gesamtlaenge; 
	element.maxLinienLaenge2=maxLinienLaenge;
	element.maxLinienAnzahl2=maxLinienAnzahl;
	element.linienplanID2=linienplanID;
	element.geschwindigkeit2=geschwindigkeit;
	element.algorithmus2=algorithmus;
	element.anzeigegraphen2=anzeigegraphen;
	if(EindeutigeLinienverkn==false) element.EindeutigeLinienverkn=0;
	else element.EindeutigeLinienverkn=1;
	if(MehrdeutigeLinienverkn==false)element.MehrdeutigeLinienverkn=0;
	else element.MehrdeutigeLinienverkn=1;
	if(Aufbruchsverknuepfung==false) element.Aufbruchsverknuepfung=0;
	else element.Aufbruchsverknuepfung=1;
	if(Linienendverknuepfung==false) element.Linienendverknuepfung=0;
	else element.Linienendverknuepfung=1;
	if(Basislinienwahl==false) element.Basislinienwahl=0;
	else element.Basislinienwahl=1;

	//zunaechst die Tabelle loeschen:
	/* EXEC SQL DELETE FROM LinienplanModulParameter WHERE SpeicherID = :element.speicherID; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.stmt = "delete from LinienplanModulParameter  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )15314;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&(element.speicherID);
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernLinienplanModulParameter");
}



	/* EXEC SQL INSERT INTO LinienplanModulParameter
		VALUES (:element); */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.stmt = "insert into LinienplanModulParameter values (:s1 ,:s2 ,:s3 ,\
:s4 ,:s5 ,:s6 ,:s7 ,:s8 ,:s9 ,:s10 ,:s11 ,:s12 ,:s13 ,:s14 )";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )15332;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&element.speicherID;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqhstv[1] = (unsigned char  *)&element.aufruf2;
 sqlstm.sqhstl[1] = (unsigned int  )8;
 sqlstm.sqindv[1] = (         short *)0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqhstv[2] = (unsigned char  *)&element.gesamtlaenge2;
 sqlstm.sqhstl[2] = (unsigned int  )4;
 sqlstm.sqindv[2] = (         short *)0;
 sqlstm.sqharm[2] = (unsigned int  )0;
 sqlstm.sqhstv[3] = (unsigned char  *)&element.maxLinienLaenge2;
 sqlstm.sqhstl[3] = (unsigned int  )4;
 sqlstm.sqindv[3] = (         short *)0;
 sqlstm.sqharm[3] = (unsigned int  )0;
 sqlstm.sqhstv[4] = (unsigned char  *)&element.maxLinienAnzahl2;
 sqlstm.sqhstl[4] = (unsigned int  )4;
 sqlstm.sqindv[4] = (         short *)0;
 sqlstm.sqharm[4] = (unsigned int  )0;
 sqlstm.sqhstv[5] = (unsigned char  *)&element.linienplanID2;
 sqlstm.sqhstl[5] = (unsigned int  )8;
 sqlstm.sqindv[5] = (         short *)0;
 sqlstm.sqharm[5] = (unsigned int  )0;
 sqlstm.sqhstv[6] = (unsigned char  *)&element.geschwindigkeit2;
 sqlstm.sqhstl[6] = (unsigned int  )4;
 sqlstm.sqindv[6] = (         short *)0;
 sqlstm.sqharm[6] = (unsigned int  )0;
 sqlstm.sqhstv[7] = (unsigned char  *)&element.algorithmus2;
 sqlstm.sqhstl[7] = (unsigned int  )4;
 sqlstm.sqindv[7] = (         short *)0;
 sqlstm.sqharm[7] = (unsigned int  )0;
 sqlstm.sqhstv[8] = (unsigned char  *)&element.anzeigegraphen2;
 sqlstm.sqhstl[8] = (unsigned int  )4;
 sqlstm.sqindv[8] = (         short *)0;
 sqlstm.sqharm[8] = (unsigned int  )0;
 sqlstm.sqhstv[9] = (unsigned char  *)&element.EindeutigeLinienverkn;
 sqlstm.sqhstl[9] = (unsigned int  )4;
 sqlstm.sqindv[9] = (         short *)0;
 sqlstm.sqharm[9] = (unsigned int  )0;
 sqlstm.sqhstv[10] = (unsigned char  *)&element.MehrdeutigeLinienverkn;
 sqlstm.sqhstl[10] = (unsigned int  )4;
 sqlstm.sqindv[10] = (         short *)0;
 sqlstm.sqharm[10] = (unsigned int  )0;
 sqlstm.sqhstv[11] = (unsigned char  *)&element.Aufbruchsverknuepfung;
 sqlstm.sqhstl[11] = (unsigned int  )4;
 sqlstm.sqindv[11] = (         short *)0;
 sqlstm.sqharm[11] = (unsigned int  )0;
 sqlstm.sqhstv[12] = (unsigned char  *)&element.Linienendverknuepfung;
 sqlstm.sqhstl[12] = (unsigned int  )4;
 sqlstm.sqindv[12] = (         short *)0;
 sqlstm.sqharm[12] = (unsigned int  )0;
 sqlstm.sqhstv[13] = (unsigned char  *)&element.Basislinienwahl;
 sqlstm.sqhstl[13] = (unsigned int  )4;
 sqlstm.sqindv[13] = (         short *)0;
 sqlstm.sqharm[13] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernLinienplanModulParameter");
}

 
	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )15402;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernLinienplanModulParameter");
}



}

//------------------------------------------------------------------------------
// Funktionsname:	holenLinienweg
// Beschreibung:	Mit dieser Methode wird ein Linienweg des Linienplans aus Oracle geholt
// Parameter:		Die ID des Weges, der aus Oracle geholt werden soll
// Rueckgabe:		der Linienweg (= CLinie*)
// Besonderheiten:	wird vin holenLinienweg fuer jede zu holende Linie aufgerufen.
//------------------------------------------------------------------------------
CLinie* CDBSchnittstelle::holenLinienweg(int id)
{
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenLinienweg"); */ 


//	Debug(3,"Lege Linienweg an");
	
        // Datenfelder anlegen, die im folgenden als Zwischenspeicher dienen:
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	
	typedef struct
	{
		int LinienID;
		int LfdNr;
 		int HaltestellenID;
	} linienwegelement;
	linienwegelement element;
	int id2=id;
	int speicherid=speicherstand;
	/* EXEC SQL END DECLARE SECTION; */ 
		

        // erzeuge den Cursor, mit dem Daten durchlaufen werden:
	/* EXEC SQL DECLARE linienwegcursor CURSOR FOR
		SELECT LinienID, LfdNr, HaltestellenID
			FROM LinienWeg
			WHERE LinienID = :id2 AND SpeicherID = :speicherid; */ 


	// jetzt den Cursor oeffnen
	/* EXEC SQL OPEN linienwegcursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.stmt = sq0805;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )15416;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&id2;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqhstv[1] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[1] = (unsigned int  )4;
 sqlstm.sqindv[1] = (         short *)0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenLinienweg");
}



	// neue Liste fuer die Rueckgabe anlegen:
	CLinie* linienweg=0;
	try{
	linienweg=new CLinie;
	}catch(std::bad_alloc)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: "<<__LINE__<<": "<<"linienweg konnte nicht angelegt werden, Speichermangel"<<endl;
		exit(1);
	}
	
	// und jetzt in Schleife alle Dinger holen:
	list<int>* punkteliste=0;
	try{
	punkteliste=new list<int>;
	}catch(std::bad_alloc)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: "<<__LINE__<<": "<<"die punkteliste fuer den Linienweg konnte nicht angelegt werden, Speichermangel"<<endl;
		exit(1);
	}
	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

	for(;;)
	{
		/* EXEC SQL FETCH linienwegcursor INTO :element; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )15438;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&element.LinienID;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&element.LfdNr;
  sqlstm.sqhstl[1] = (unsigned int  )4;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&element.HaltestellenID;
  sqlstm.sqhstl[2] = (unsigned int  )4;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenLinienweg");
}


		punkteliste->append(element.HaltestellenID);

//		Debug(2, "Linienweg: HaltestllenID: "<<element.HaltestellenID);		
	}
	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 


	linienweg->setzenhListe(punkteliste);
	linienweg->setzenID(id);
	
	// und nach getaner arbeit Cursor wieder schliessen:
	/* EXEC SQL CLOSE linienwegcursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )15464;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenLinienweg");
}



	return linienweg;
}
//------------------------------------------------------------------------------
// Funktionsname:	speichernLinienweg
// Beschreibung:	Mit dieser Methode wird eine Linie im Linienplan gespeichert
// Parameter:		Ein Linienweg (= CLinie)
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::speichernLinienweg(CLinie* linienweg=0)
{
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in speichernLinienweg"); */ 


	if(linienweg!=0)
	{
		/* EXEC SQL BEGIN DECLARE SECTION; */ 
	
		// Datenfelder anlegen, die als Zwischenspeicher dienen:
		typedef struct
		{
			int speicherID;
			int LinienID;
			int LfdNr;
 			int HaltestellenID;
		} linienwegelement;
		linienwegelement element;
		/* EXEC SQL END DECLARE SECTION; */ 

		element.speicherID = speicherstand;

		// Liste durchlaufen
		// und jede Linie ueber speichernLinienweg abspeichern
		// dabei die Daten in Oracle schieben:
		int laufendenummer=0;
		list<int>* listeausclinie=linienweg->holenhListe(); // die eingentliche Liste aus CLinie extrahieren
		int inhalt;
		forall(inhalt, *listeausclinie)
		{
			// jetzt die Daten in die DB-Tabelle Linienweg schreiben
			element.LinienID=linienweg->holenID(); 
			element.LfdNr=laufendenummer; // noetig um korrekte Reihenfolge zu gewaehrleisten
			element.HaltestellenID=inhalt;
			
			/* EXEC SQL INSERT INTO LinienWeg
				VALUES (:element); */ 

{
   struct sqlexd sqlstm;

   sqlorat((void **)0, &sqlctx, &oraca);
   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 35;
   sqlstm.stmt = "insert into LinienWeg values (:s1 ,:s2 ,:s3 ,:s4 )";
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )15478;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlstm.sqhstv[0] = (unsigned char  *)&element.speicherID;
   sqlstm.sqhstl[0] = (unsigned int  )4;
   sqlstm.sqindv[0] = (         short *)0;
   sqlstm.sqharm[0] = (unsigned int  )0;
   sqlstm.sqhstv[1] = (unsigned char  *)&element.LinienID;
   sqlstm.sqhstl[1] = (unsigned int  )4;
   sqlstm.sqindv[1] = (         short *)0;
   sqlstm.sqharm[1] = (unsigned int  )0;
   sqlstm.sqhstv[2] = (unsigned char  *)&element.LfdNr;
   sqlstm.sqhstl[2] = (unsigned int  )4;
   sqlstm.sqindv[2] = (         short *)0;
   sqlstm.sqharm[2] = (unsigned int  )0;
   sqlstm.sqhstv[3] = (unsigned char  *)&element.HaltestellenID;
   sqlstm.sqhstl[3] = (unsigned int  )4;
   sqlstm.sqindv[3] = (         short *)0;
   sqlstm.sqharm[3] = (unsigned int  )0;
   sqlstm.sqphsv = sqlstm.sqhstv;
   sqlstm.sqphsl = sqlstm.sqhstl;
   sqlstm.sqpind = sqlstm.sqindv;
   sqlstm.sqparm = sqlstm.sqharm;
   sqlstm.sqparc = sqlstm.sqharc;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
   if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernLinienweg");
}

 
//			Debug(2, element.LinienID<<" "<<element.LfdNr<<" "<<element.HaltestellenID);
			laufendenummer++;

			/* EXEC SQL COMMIT; */ 

{
   struct sqlexd sqlstm;

   sqlorat((void **)0, &sqlctx, &oraca);
   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 35;
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )15508;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
   if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernLinienweg");
}


		}
//                Debug(2, "speichernLinienweg: fedisch");

		//Liste durchlaufen und Stueck fuer Stueck wegwerfen
		list<int> *terminator=0;
		terminator=linienweg->holenhListe();
		delete terminator;
		delete linienweg;
		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )15522;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernLinienweg");
}



	} // endif: test auf Nullzeiger
	else cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: speichernLinienweg: NULL-Zeiger wurde uebergeben!"<<endl;	
}

//------------------------------------------------------------------------------
// Funktionsname:	holenLinienplan
// Beschreibung:	Mit dieser Methode wird der Linienplan aus Oracle geholt
// Parameter:		
// Rueckgabe:		der Linienplan (= list<CLinie*>)
// Besonderheiten:	Ruft fuer jede im Linienplan enthaltene Linie holenLinienweg auf.
//------------------------------------------------------------------------------
list<CLinie*>* CDBSchnittstelle::holenLinienplan()
{
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenLinienplan"); */ 


	Debug(2,"Lege Linienplan an");
	
        // Datenfelder anlegen, die im folgenden als Zwischenspeicher dienen:
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	
	typedef struct
	{
		double PlanID;
		/* VARCHAR Beschreibung[70]; */ 
struct { unsigned short len; unsigned char arr[70]; } Beschreibung;

		int LinienID;
	} linienplanelement;
	linienplanelement element;
	int speicherid=speicherstand;
	/* EXEC SQL END DECLARE SECTION; */ 
		

        // erzeuge den Cursor, mit dem Daten durchlaufen werden:
	/* EXEC SQL DECLARE linienplancursor CURSOR FOR
		SELECT PlanID, Beschreibung, LinienID
			FROM LinienPlan
			WHERE SpeicherID = :speicherid; */ 


	// jetzt den Cursor oeffnen
	/* EXEC SQL OPEN linienplancursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.stmt = sq0809;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )15536;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenLinienplan");
}



	// neue Liste fuer die Rueckgabe anlegen:
	list<CLinie*>* linienplan=0;
	try{
	linienplan=new list<CLinie*>;
	}catch(std::bad_alloc)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: "<<__LINE__<<": "<<"linienplan konnte nicht angelegt werden, Speichermangel"<<endl;
		exit(1);
	}
	
//	Debug(2, "....... Vor Schleife");
	// und jetzt in Schleife alle Dinger holen:
	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

	for(;;)
	{
		/* EXEC SQL FETCH linienplancursor INTO :element; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )15554;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&element.PlanID;
  sqlstm.sqhstl[0] = (unsigned int  )8;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&element.Beschreibung;
  sqlstm.sqhstl[1] = (unsigned int  )72;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&element.LinienID;
  sqlstm.sqhstl[2] = (unsigned int  )4;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenLinienplan");
}


//		Debug(2, "holenLinienplan: bearbeite LinienID:"<<element.LinienID);
		linienplan->append(holenLinienweg(element.LinienID));
	}
        /* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	// und nach getaner arbeit Cursor wieder schliessen:
	/* EXEC SQL CLOSE linienplancursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )15580;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenLinienplan");
}



	return linienplan;
}
//------------------------------------------------------------------------------
// Funktionsname:	speichernLinienplan
// Beschreibung:	Mit dieser Methode wird der Linienplan gespeichert
// Parameter:		der Linienplan (= list<CLinie*>)
// Rueckgabe:		
// Besonderheiten:	Ruft fuer jede im Linienplan enthaltene Linie speichernLinienweg auf.
//------------------------------------------------------------------------------
void CDBSchnittstelle::speichernLinienplan(list<CLinie*>* linienPlan=0)
{
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in speichernLinienplan"); */ 


	if(linienPlan!=0)
	{
		/* EXEC SQL BEGIN DECLARE SECTION; */ 
	
		// Datenfelder anlegen, die als Zwischenspeicher dienen:
		typedef struct
		{
			int speicherID;
			double PlanID;
			/* VARCHAR Beschreibung[70]; */ 
struct { unsigned short len; unsigned char arr[70]; } Beschreibung;

			int LinienID;
		} linienplanelement;
		linienplanelement element;
		/* EXEC SQL END DECLARE SECTION; */ 
	
                element.speicherID = speicherstand;

		CFortschritt* fortschritt=0;
		if(batchbetrieb==false) 
		{
			try{fortschritt=new CFortschritt("Speichern der Ergebnisdaten");}
			catch(...)
			{
				cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Fortschrittsanzeige beim Speichern des Linienplans konnte nicht angelegt werden. Speichermangel?"<<endl;
				cerr.flush();
			}
		}
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Loesche alten Linienplan in der Datenbank...");

		//zunaechst die Tabelle loeschen:
		/* EXEC SQL DELETE FROM LinienPlan WHERE SpeicherID = :element.speicherID; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.stmt = "delete from LinienPlan  where SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )15594;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&(element.speicherID);
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernLinienplan");
}


//		Debug(2, "speichernLinienplan: Tabelle geloescht");
		/* EXEC SQL DELETE FROM LinienWeg WHERE SpeicherID = :element.speicherID; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.stmt = "delete from LinienWeg  where SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )15612;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&(element.speicherID);
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernLinienplan");
}


//		Debug(2, "speichernLinienplan: Linienweg-Tabelle geloescht");

        	if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Speichere den Linienplan in der Datenbank...");
	

		// Liste durchlaufen
		// und jede Linie ueber speichernLinienweg abspeichern
		// dabei die Daten in Oracle schieben:
		CLinie* eineliste;
		int durchlauf=0;
		forall(eineliste, *linienPlan)
		{
			if(fortschritt!=0) fortschritt->anzeigenFortschritt(++durchlauf, linienPlan->length());

			// jetzt die wichtigen Daten erstmal in die DB-Tabelle LinienPlan schreiben
			element.PlanID=0; // ist im ersten Prototyen immer 0, geht aus Liste nicht hervor
			strncpy((char*)element.Beschreibung.arr, "Standard", 70);
			element.LinienID=eineliste->holenID();
			
			/* EXEC SQL INSERT INTO LinienPlan
				VALUES (:element); */ 

{
   struct sqlexd sqlstm;

   sqlorat((void **)0, &sqlctx, &oraca);
   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 35;
   sqlstm.stmt = "insert into LinienPlan values (:s1 ,:s2 ,:s3 ,:s4 )";
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )15630;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlstm.sqhstv[0] = (unsigned char  *)&element.speicherID;
   sqlstm.sqhstl[0] = (unsigned int  )4;
   sqlstm.sqindv[0] = (         short *)0;
   sqlstm.sqharm[0] = (unsigned int  )0;
   sqlstm.sqhstv[1] = (unsigned char  *)&element.PlanID;
   sqlstm.sqhstl[1] = (unsigned int  )8;
   sqlstm.sqindv[1] = (         short *)0;
   sqlstm.sqharm[1] = (unsigned int  )0;
   sqlstm.sqhstv[2] = (unsigned char  *)&element.Beschreibung;
   sqlstm.sqhstl[2] = (unsigned int  )72;
   sqlstm.sqindv[2] = (         short *)0;
   sqlstm.sqharm[2] = (unsigned int  )0;
   sqlstm.sqhstv[3] = (unsigned char  *)&element.LinienID;
   sqlstm.sqhstl[3] = (unsigned int  )4;
   sqlstm.sqindv[3] = (         short *)0;
   sqlstm.sqharm[3] = (unsigned int  )0;
   sqlstm.sqphsv = sqlstm.sqhstv;
   sqlstm.sqphsl = sqlstm.sqhstl;
   sqlstm.sqpind = sqlstm.sqindv;
   sqlstm.sqparm = sqlstm.sqharm;
   sqlstm.sqparc = sqlstm.sqharc;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
   if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernLinienplan");
}

 
//			Debug(2, element.Beschreibung.arr<<" "<<element.PlanID<<" "<<element.LinienID);

			// und jetzt die Linie einzeln speichern
			speichernLinienweg(eineliste);
			/* EXEC SQL COMMIT; */ 

{
   struct sqlexd sqlstm;

   sqlorat((void **)0, &sqlctx, &oraca);
   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 35;
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )15660;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
   if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernLinienplan");
}


		}
//                Debug(2, "speichernLinienplan: fedisch");
				
		//Liste durchlaufen und Stueck fuer Stueck wegwerfen
		CLinie* terminator=0;
		list<int> *terminator2=0;
		forall(terminator, *linienPlan) {
			terminator2=terminator->holenhListe();
			delete terminator2;
		}
		delete linienPlan;
		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )15674;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernLinienplan");
}


                if(fortschritt!=0) delete fortschritt;
	} // endif: test auf Nullzeiger
	else cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: speichernLinienplan: NULL-Zeiger wurde uebergeben!"<<endl;
}

//------------------------------------------------------------------------------
// Funktionsname:	holenPflichtlinien
// Beschreibung:	Mit dieser Methode die Pflichtlinien aus Oracle geholt
// Parameter:		
// Rueckgabe:		die Pflichtlinien (= list<CLinie*>)
// Besonderheiten:	verwendet holenPflichtlinie
//------------------------------------------------------------------------------
list<CLinie*>* CDBSchnittstelle::holenPflichtlinien()				
{
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenPflichtlinien (alle Linien)"); */ 


	Debug(2,"Lege Pflichtlinien an");


	// neue Liste fuer die Rueckgabe anlegen:
	list<CLinie*>* pflichtlinien=0;
	try{pflichtlinien=new list<CLinie*>;}
	catch(std::bad_alloc)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: "<<__LINE__<<": "<<"Pflichtlinien konnte nicht angelegt werden, Speichermangel"<<endl;
		exit(1);
	}


	// Datenfelder anlegen, die im folgenden als Zwischenspeicher dienen:
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	
	typedef struct
	{
		int LinienID;
		int LfNr;
		int HaltestellenID;
	} pflichtlinienplanelement;
	pflichtlinienplanelement element;
	int speicherid=speicherstand;
	/* EXEC SQL END DECLARE SECTION; */ 
		

        if(pflichtlinien!=0)
	{
	        // erzeuge den Cursor, mit dem Daten durchlaufen werden:
		/* EXEC SQL DECLARE pflichtl_durchlauf_cursor CURSOR FOR
			SELECT LinienID, LfNr, HaltestellenID
				FROM Pflichtlinien
				WHERE SpeicherID = :speicherid; */ 


		// jetzt den Cursor oeffnen
		/* EXEC SQL OPEN pflichtl_durchlauf_cursor; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.stmt = sq0815;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )15688;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenPflichtlinien (alle Linien)");
}



		list<int> allelinienids;
		// und jetzt in Schleife alle Dinger holen:
		/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

		for(;;)
		{
			/* EXEC SQL FETCH pflichtl_durchlauf_cursor INTO :element; */ 

{
   struct sqlexd sqlstm;

   sqlorat((void **)0, &sqlctx, &oraca);
   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 35;
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )15706;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlstm.sqhstv[0] = (unsigned char  *)&element.LinienID;
   sqlstm.sqhstl[0] = (unsigned int  )4;
   sqlstm.sqindv[0] = (         short *)0;
   sqlstm.sqharm[0] = (unsigned int  )0;
   sqlstm.sqhstv[1] = (unsigned char  *)&element.LfNr;
   sqlstm.sqhstl[1] = (unsigned int  )4;
   sqlstm.sqindv[1] = (         short *)0;
   sqlstm.sqharm[1] = (unsigned int  )0;
   sqlstm.sqhstv[2] = (unsigned char  *)&element.HaltestellenID;
   sqlstm.sqhstl[2] = (unsigned int  )4;
   sqlstm.sqindv[2] = (         short *)0;
   sqlstm.sqharm[2] = (unsigned int  )0;
   sqlstm.sqphsv = sqlstm.sqhstv;
   sqlstm.sqphsl = sqlstm.sqhstl;
   sqlstm.sqpind = sqlstm.sqindv;
   sqlstm.sqparm = sqlstm.sqharm;
   sqlstm.sqparc = sqlstm.sqharc;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
   if (sqlca.sqlcode == 1403) break;
   if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenPflichtlinien (alle Linien)");
}


			// wenn element.LinienID schon als ID vergeben ist, tue nichts, ansonsten hole diese ID:
			int nummer=0;
			bool istinliste=false;
			forall(nummer, allelinienids)
			{
				if(nummer==element.LinienID) istinliste=true;
			}
			if(istinliste==false) allelinienids.append(element.LinienID);
		}
		/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 


		// und nach getaner arbeit Cursor wieder schliessen:
		/* EXEC SQL CLOSE pflichtl_durchlauf_cursor; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )15732;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenPflichtlinien (alle Linien)");
}



		// und jetzt alle Linien holen, deren IDs wir zuvor gesammelt hatten:
		int nummer=0;
		forall(nummer, allelinienids)
		{
			pflichtlinien->append(holenPflichtlinie(nummer));
		}
	}

	Debug(2, " gebe alle Pflichtlinen aus");
	return pflichtlinien;
}
//------------------------------------------------------------------------------
// Funktionsname:	holenPflichtlinie
// Beschreibung:	Mit dieser Methode wird EINE Pflichtlinie aus Oracle geholt
// Parameter:		
// Rueckgabe:		die Pflichtlinie (= CLinie*)
// Besonderheiten:	wird von holenPflichtlinien aufgerufen
//------------------------------------------------------------------------------
CLinie* CDBSchnittstelle::holenPflichtlinie(int linienid)				
{
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenPflichtlinie (eine Linie)"); */ 


	Debug(2,"Lege Pflichtlinie an");
	
        // Datenfelder anlegen, die im folgenden als Zwischenspeicher dienen:
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	
	typedef struct
	{
		int LinienID;
		int LfNr;
		int HaltestellenID;
	} pflichtlinienplanelement;
	pflichtlinienplanelement element;
	int speicherid=speicherstand;
	int id=linienid;
	/* EXEC SQL END DECLARE SECTION; */ 
		

        // erzeuge den Cursor, mit dem Daten durchlaufen werden:
	/* EXEC SQL DECLARE pflichtliniencursor CURSOR FOR
		SELECT LinienID, LfNr, HaltestellenID
			FROM Pflichtlinien
			WHERE SpeicherID = :speicherid AND LinienID = :id; */ 


	// jetzt den Cursor oeffnen
	/* EXEC SQL OPEN pflichtliniencursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.stmt = sq0816;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )15746;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqhstv[1] = (unsigned char  *)&id;
 sqlstm.sqhstl[1] = (unsigned int  )4;
 sqlstm.sqindv[1] = (         short *)0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenPflichtlinie (eine Linie)");
}



	// neue Liste fuer die Rueckgabe anlegen:
	CLinie* pflichtlinie=0;
	try{  pflichtlinie=new CLinie;}
	catch(std::bad_alloc)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: "<<__LINE__<<": "<<"Pflichtlinie konnte nicht angelegt werden, Speichermangel"<<endl;
		exit(1);
	}
	

	// Erst eine neue HaltestellenListe anlegen
	list<int>* hliste=0;
        try{hliste=new list<int>;}
	catch(...)
	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Haltestellenliste einer Pflichlinie konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}
	if((pflichtlinie!=0)&&(hliste!=0))
	{
		
		// und jetzt in Schleife alle Dinger holen:
		/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

		for(;;)
		{
			/* EXEC SQL FETCH pflichtliniencursor INTO :element; */ 

{
   struct sqlexd sqlstm;

   sqlorat((void **)0, &sqlctx, &oraca);
   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 35;
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )15768;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlstm.sqhstv[0] = (unsigned char  *)&element.LinienID;
   sqlstm.sqhstl[0] = (unsigned int  )4;
   sqlstm.sqindv[0] = (         short *)0;
   sqlstm.sqharm[0] = (unsigned int  )0;
   sqlstm.sqhstv[1] = (unsigned char  *)&element.LfNr;
   sqlstm.sqhstl[1] = (unsigned int  )4;
   sqlstm.sqindv[1] = (         short *)0;
   sqlstm.sqharm[1] = (unsigned int  )0;
   sqlstm.sqhstv[2] = (unsigned char  *)&element.HaltestellenID;
   sqlstm.sqhstl[2] = (unsigned int  )4;
   sqlstm.sqindv[2] = (         short *)0;
   sqlstm.sqharm[2] = (unsigned int  )0;
   sqlstm.sqphsv = sqlstm.sqhstv;
   sqlstm.sqphsl = sqlstm.sqhstl;
   sqlstm.sqpind = sqlstm.sqindv;
   sqlstm.sqparm = sqlstm.sqharm;
   sqlstm.sqparc = sqlstm.sqharc;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
   if (sqlca.sqlcode == 1403) break;
   if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenPflichtlinie (eine Linie)");
}


			Debug(2, "LinienID:"<<element.LinienID<<" HS-ID:"<<element.HaltestellenID);
			pflichtlinie->setzenPflicht(true);
			pflichtlinie->setzenID(element.LinienID);
			hliste->append(element.HaltestellenID);
//			Debug(2, "Am Ende der Liste steht die HS-ID:"<< (dielinie->holenhListe())->contents( (dielinie->holenhListe())->last() ) );
		}
		// die aufgebaute hliste noch reinschieben:
		pflichtlinie->setzenhListe(hliste);

        	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

		
	}
	// und nach getaner arbeit Cursor wieder schliessen:
	/* EXEC SQL CLOSE pflichtliniencursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )15794;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenPflichtlinie (eine Linie)");
}



	Debug(2, " gebe Pflichtline zurueck");
	return pflichtlinie;
}
//------------------------------------------------------------------------------
// Funktionsname:	speichernPflichtlinien
// Beschreibung:	Mit dieser Methode werden die Pflichtlinien speichern
// Parameter:		Pflichtlinien (= list<CLinie*>)
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::speichernPflichtlinien(list<CLinie*>* pflichtlinien)    
{
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in speichernPflichtlinien"); */ 


	if(pflichtlinien!=0)
	{
		/* EXEC SQL BEGIN DECLARE SECTION; */ 
	
		// Datenfelder anlegen, die als Zwischenspeicher dienen:
		typedef struct
		{
			int speicherID;
			int LinienID;
			int LfNr;
			int HaltestellenID;
		} pflichtlinienplanelement;
		pflichtlinienplanelement element;
		/* EXEC SQL END DECLARE SECTION; */ 
	
                element.speicherID = speicherstand;

		CFortschritt* fortschritt=0;
		if(batchbetrieb==false) 
		{
			try{fortschritt=new CFortschritt("Speichern der Ergebnisdaten");}
			catch(...)
			{
				cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Fortschrittsanzeige beim Speichern der Pflichtlinien konnte nicht angelegt werden. Speichermangel?"<<endl;
				cerr.flush();
			}
		}
		if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Loesche alte Pflichtlinien in der Datenbank...");

		//zunaechst die Tabelle loeschen:
		/* EXEC SQL DELETE FROM Pflichtlinien WHERE SpeicherID = :element.speicherID; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.stmt = "delete from Pflichtlinien  where SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )15808;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&(element.speicherID);
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernPflichtlinien");
}


//		Debug(2, "speichernLinienplan: Tabelle geloescht");

        	if(fortschritt!=0) fortschritt->meldenLaufzeitAusgabe("Speichere Pflichtlinien in der Datenbank...");
	

		// Liste durchlaufen
		// und jede Linie ueber speichernLinienweg abspeichern
		// dabei die Daten in Oracle schieben:
		CLinie* eineliste;
		int durchlauf=0;
		forall(eineliste, *pflichtlinien)
		{
			if(fortschritt!=0) fortschritt->anzeigenFortschritt(++durchlauf, pflichtlinien->length());

			// erst die ID holen
			element.LinienID=eineliste->holenID();

			// jetzt die ID-Liste durchlaufen:
                        int einehs=0;
			element.LfNr=0; // laufende Nummer (gibt Position an)
			forall(einehs, *(eineliste->holenhListe()))
			{
			        // die ID holen
				element.HaltestellenID=einehs;
				// und rein damit:
                                /* EXEC SQL INSERT INTO Pflichtlinien
					VALUES (:element); */ 

{
                                struct sqlexd sqlstm;

                                sqlorat((void **)0, &sqlctx, &oraca);
                                sqlstm.sqlvsn = 8;
                                sqlstm.arrsiz = 35;
                                sqlstm.stmt = "insert into Pflichtlinien val\
ues (:s1 ,:s2 ,:s3 ,:s4 )";
                                sqlstm.iters = (unsigned int  )1;
                                sqlstm.offset = (unsigned int  )15826;
                                sqlstm.cud = sqlcud0;
                                sqlstm.sqlest = (unsigned char  *)&sqlca;
                                sqlstm.sqlety = (unsigned short)0;
                                sqlstm.sqhstv[0] = (unsigned char  *)&element.speicherID;
                                sqlstm.sqhstl[0] = (unsigned int  )4;
                                sqlstm.sqindv[0] = (         short *)0;
                                sqlstm.sqharm[0] = (unsigned int  )0;
                                sqlstm.sqhstv[1] = (unsigned char  *)&element.LinienID;
                                sqlstm.sqhstl[1] = (unsigned int  )4;
                                sqlstm.sqindv[1] = (         short *)0;
                                sqlstm.sqharm[1] = (unsigned int  )0;
                                sqlstm.sqhstv[2] = (unsigned char  *)&element.LfNr;
                                sqlstm.sqhstl[2] = (unsigned int  )4;
                                sqlstm.sqindv[2] = (         short *)0;
                                sqlstm.sqharm[2] = (unsigned int  )0;
                                sqlstm.sqhstv[3] = (unsigned char  *)&element.HaltestellenID;
                                sqlstm.sqhstl[3] = (unsigned int  )4;
                                sqlstm.sqindv[3] = (         short *)0;
                                sqlstm.sqharm[3] = (unsigned int  )0;
                                sqlstm.sqphsv = sqlstm.sqhstv;
                                sqlstm.sqphsl = sqlstm.sqhstl;
                                sqlstm.sqpind = sqlstm.sqindv;
                                sqlstm.sqparm = sqlstm.sqharm;
                                sqlstm.sqparc = sqlstm.sqharc;
                                sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
                                if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernPflichtlinien");
}

 

        			element.LfNr++;
	
				Debug(2, "---------------->> "<<element.LinienID<<" , "<<element.HaltestellenID);
			}
			/* EXEC SQL COMMIT; */ 

{
   struct sqlexd sqlstm;

   sqlorat((void **)0, &sqlctx, &oraca);
   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 35;
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )15856;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
   if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernPflichtlinien");
}


		}
				
		//Liste durchlaufen und Stueck fuer Stueck wegwerfen
		CLinie* terminator=0;
		list<int> *terminator2=0;
		forall(terminator, *pflichtlinien) {
			terminator2=terminator->holenhListe();
			delete terminator2;
		}
		delete pflichtlinien;
		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )15870;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernPflichtlinien");
}


                if(fortschritt!=0) delete fortschritt;
	} // endif: test auf Nullzeiger
	else cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: speichernPflichtlinien: NULL-Zeiger wurde uebergeben!"<<endl;
}





  

// Fahrplan: ----------------------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Funktionsname:	holenFahrplanModulParameter
// Beschreibung:	Mit dieser Methode werden die Parameter aus der Datenbank geholt
// Parameter:		max. Fahrzeuganzahl, Allg. Takt, min. Haltezeit, Mindestumsteigezeit
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::holenFahrplanModulParameter(int& maxfahrzeuganzahl, int& allgemeinertakt, int& mindesthaltezeit, int& mindestumsteigezeit)
{
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenFahrplanModulParameter"); */ 


	// Holt den Linienplan mit dem Aufruf aufruf	

	// erst ein paar dummywerte anlegen, damit Oracle die erkennt:
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	
	typedef struct
	{
		int aufruf;
		int maxfahrzeuganzahl; 
		int allgemeinertakt;
		int mindesthaltezeit;
		int mindestumsteigezeit;
	} lpelem;
	lpelem element;
	int speicherid=speicherstand;
	/* EXEC SQL END DECLARE SECTION; */ 


	// erst die Elemente der Struktur mit -1 initialisieren, falls in der Tabelle
	// nichts drin steht:
	element.aufruf=0;
	element.maxfahrzeuganzahl=-1;
	element.allgemeinertakt=-1;
	element.mindesthaltezeit=-1;
	element.mindestumsteigezeit=-1;

	/* EXEC SQL SELECT Aufruf, MaxFahrzeuganzahl, AllgemeinerTakt, Mindesthaltezeit, Mindestumsteigezeit
		INTO :element
		FROM FahrplanModulParameter
		WHERE SpeicherID = :speicherid; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.stmt = "select Aufruf ,MaxFahrzeuganzahl ,AllgemeinerTakt ,Mindestha\
ltezeit ,Mindestumsteigezeit into :s1 ,:s2 ,:s3 ,:s4 ,:s5   from FahrplanModul\
Parameter where SpeicherID=:b1";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )15884;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&element.aufruf;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqhstv[1] = (unsigned char  *)&element.maxfahrzeuganzahl;
 sqlstm.sqhstl[1] = (unsigned int  )4;
 sqlstm.sqindv[1] = (         short *)0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqhstv[2] = (unsigned char  *)&element.allgemeinertakt;
 sqlstm.sqhstl[2] = (unsigned int  )4;
 sqlstm.sqindv[2] = (         short *)0;
 sqlstm.sqharm[2] = (unsigned int  )0;
 sqlstm.sqhstv[3] = (unsigned char  *)&element.mindesthaltezeit;
 sqlstm.sqhstl[3] = (unsigned int  )4;
 sqlstm.sqindv[3] = (         short *)0;
 sqlstm.sqharm[3] = (unsigned int  )0;
 sqlstm.sqhstv[4] = (unsigned char  *)&element.mindestumsteigezeit;
 sqlstm.sqhstl[4] = (unsigned int  )4;
 sqlstm.sqindv[4] = (         short *)0;
 sqlstm.sqharm[4] = (unsigned int  )0;
 sqlstm.sqhstv[5] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[5] = (unsigned int  )4;
 sqlstm.sqindv[5] = (         short *)0;
 sqlstm.sqharm[5] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenFahrplanModulParameter");
}


        
	//und in die uebergebenen Variablen eingeben:
	maxfahrzeuganzahl=element.maxfahrzeuganzahl;
	allgemeinertakt=element.allgemeinertakt;
	mindesthaltezeit=element.mindesthaltezeit;
	mindestumsteigezeit=element.mindestumsteigezeit;
}
//------------------------------------------------------------------------------
// Funktionsname:	speichernFahrplanModulParameter
// Beschreibung:	Mit dieser Methode werden die grundlegenden Aufrufparameter gespeichert
// Parameter:		max. Fahrzeuganzahl, Allg. Takt, min. Haltezeit, Mindestumsteigezeit
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::speichernFahrplanModulParameter(int maxfahrzeuganzahl, int allgemeinertakt, int mindesthaltezeit, int mindestumsteigezeit)
{
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in speichernFahrplanModulParameter"); */ 


	Debug(2, "speichernLinienplanModulParameter");
	
        // erst ein paar dummywerte anlegen, damit Oracle die erkennt:
	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	
	typedef struct
	{
		int speicherID;
		int aufruf;
		int maxfahrzeuganzahl; 
		int allgemeinertakt;
		int mindesthaltezeit;
		int mindestumsteigezeit;	
	} lpelem;
	lpelem element;
	/* EXEC SQL END DECLARE SECTION; */ 

	element.speicherID = speicherstand;
	element.aufruf=0;
	element.maxfahrzeuganzahl=maxfahrzeuganzahl;
	element.allgemeinertakt=allgemeinertakt;
	element.mindesthaltezeit=mindesthaltezeit;
	element.mindestumsteigezeit=mindestumsteigezeit;

	//zunaechst die Tabelle loeschen:
	/* EXEC SQL DELETE FROM FahrplanModulParameter WHERE SpeicherID = :element.speicherID; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.stmt = "delete from FahrplanModulParameter  where SpeicherID=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )15922;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&(element.speicherID);
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernFahrplanModulParameter");
}



	/* EXEC SQL INSERT INTO FahrplanModulParameter
		VALUES (:element); */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.stmt = "insert into FahrplanModulParameter values (:s1 ,:s2 ,:s3 ,:s\
4 ,:s5 ,:s6 )";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )15940;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&element.speicherID;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqhstv[1] = (unsigned char  *)&element.aufruf;
 sqlstm.sqhstl[1] = (unsigned int  )4;
 sqlstm.sqindv[1] = (         short *)0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqhstv[2] = (unsigned char  *)&element.maxfahrzeuganzahl;
 sqlstm.sqhstl[2] = (unsigned int  )4;
 sqlstm.sqindv[2] = (         short *)0;
 sqlstm.sqharm[2] = (unsigned int  )0;
 sqlstm.sqhstv[3] = (unsigned char  *)&element.allgemeinertakt;
 sqlstm.sqhstl[3] = (unsigned int  )4;
 sqlstm.sqindv[3] = (         short *)0;
 sqlstm.sqharm[3] = (unsigned int  )0;
 sqlstm.sqhstv[4] = (unsigned char  *)&element.mindesthaltezeit;
 sqlstm.sqhstl[4] = (unsigned int  )4;
 sqlstm.sqindv[4] = (         short *)0;
 sqlstm.sqharm[4] = (unsigned int  )0;
 sqlstm.sqhstv[5] = (unsigned char  *)&element.mindestumsteigezeit;
 sqlstm.sqhstl[5] = (unsigned int  )4;
 sqlstm.sqindv[5] = (         short *)0;
 sqlstm.sqharm[5] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernFahrplanModulParameter");
}

 
	
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )15978;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernFahrplanModulParameter");
}


}

//------------------------------------------------------------------------------
// Funktionsname:	holenKnotenWerte
// Beschreibung:	Diese Methode holt alle Informationen aus der Tabelle Knoten
// Parameter:		
// Rueckgabe:		h_array<int,two_tuple<int,int>* >*
// Besonderheiten:	
//------------------------------------------------------------------------------
h_array<int,two_tuple<int,int>* >* CDBSchnittstelle::holenKnotenWerte()
{
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenKnotenWerte"); */ 


  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    typedef struct {
      int haltestelle;
      int umsteigezeit;
      int mindesthaltezeit;
    } Eintrag;
    Eintrag eintrag;
    int speicherID;
  /* EXEC SQL END DECLARE SECTION; */ 


  speicherID = this->speicherstand;

  /* EXEC SQL DECLARE ergebnis_cursor CURSOR FOR
    SELECT HaltestellenID,UmsteigezeitMinuten,MindesthaltezeitMinuten FROM KnotenWerte
    WHERE SpeicherID = :speicherID; */ 


  h_array<int,two_tuple<int,int>* >* knotenwerte = 0;
  try{knotenwerte=new h_array<int,two_tuple<int,int>* >;}
  catch(...)
  {
	cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Knotenwerte konnte nicht angelegt werden. Speichermangel?"<<endl;
	cerr.flush();
  }

  /* EXEC SQL WHENEVER NOT FOUND DO break; */ 

  /* EXEC SQL OPEN ergebnis_cursor; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.stmt = sq0825;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )15992;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&speicherID;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenKnotenWerte");
}



  while(1) {
    /* EXEC SQL FETCH ergebnis_cursor INTO :eintrag; */ 

{
    struct sqlexd sqlstm;

    sqlorat((void **)0, &sqlctx, &oraca);
    sqlstm.sqlvsn = 8;
    sqlstm.arrsiz = 35;
    sqlstm.iters = (unsigned int  )1;
    sqlstm.offset = (unsigned int  )16010;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char  *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlstm.sqhstv[0] = (unsigned char  *)&eintrag.haltestelle;
    sqlstm.sqhstl[0] = (unsigned int  )4;
    sqlstm.sqindv[0] = (         short *)0;
    sqlstm.sqharm[0] = (unsigned int  )0;
    sqlstm.sqhstv[1] = (unsigned char  *)&eintrag.umsteigezeit;
    sqlstm.sqhstl[1] = (unsigned int  )4;
    sqlstm.sqindv[1] = (         short *)0;
    sqlstm.sqharm[1] = (unsigned int  )0;
    sqlstm.sqhstv[2] = (unsigned char  *)&eintrag.mindesthaltezeit;
    sqlstm.sqhstl[2] = (unsigned int  )4;
    sqlstm.sqindv[2] = (         short *)0;
    sqlstm.sqharm[2] = (unsigned int  )0;
    sqlstm.sqphsv = sqlstm.sqhstv;
    sqlstm.sqphsl = sqlstm.sqhstl;
    sqlstm.sqpind = sqlstm.sqindv;
    sqlstm.sqparm = sqlstm.sqharm;
    sqlstm.sqparc = sqlstm.sqharc;
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
    if (sqlca.sqlcode == 1403) break;
    if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenKnotenWerte");
}


    two_tuple<int,int>* eintragTuple = 0;
    try{eintragTuple=new two_tuple<int,int>(eintrag.umsteigezeit,eintrag.mindesthaltezeit);}
    catch(...)
    {
	cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: ein Eintrag der Knotenwerte konnte nicht angelegt werden. Speichermangel?"<<endl;
	cerr.flush();
    }
    knotenwerte[eintrag.haltestelle] = eintragTuple;
  }
  
  /* EXEC SQL CLOSE ergebnis_cursor; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )16036;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenKnotenWerte");
}



  /* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 


  return knotenwerte;
}

//------------------------------------------------------------------------------
// Funktionsname:	speichernKnotenWerte
// Beschreibung:	
// Parameter:		h_array<int,two_tuple<int,int>* >*
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::speichernKnotenWerte(h_array<int,two_tuple<int,int>* >* knotenwerte)
{
  loeschenKnotenWerte();

  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in speichernKnotenWerte"); */ 


  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    typedef struct {
      int speicherID;
      int haltestelleID;
      int umsteigezeit;
      int mindesthaltezeit;
    } Eintrag;
    Eintrag eintrag;
  /* EXEC SQL END DECLARE SECTION; */ 


  eintrag.speicherID = this->speicherstand;

  two_tuple<int,int>* arrayEintrag;

  int haltestelle;

  forall_defined(haltestelle,*knotenwerte) {
    arrayEintrag = (*knotenwerte)[haltestelle];
    eintrag.haltestelleID = haltestelle;
    eintrag.umsteigezeit = arrayEintrag->first();
    eintrag.mindesthaltezeit = arrayEintrag->second();
    /* EXEC SQL INSERT INTO LinienWerte VALUES (:eintrag); */ 

{
    struct sqlexd sqlstm;

    sqlorat((void **)0, &sqlctx, &oraca);
    sqlstm.sqlvsn = 8;
    sqlstm.arrsiz = 35;
    sqlstm.stmt = "insert into LinienWerte values (:s1 ,:s2 ,:s3 ,:s4 )";
    sqlstm.iters = (unsigned int  )1;
    sqlstm.offset = (unsigned int  )16050;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char  *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlstm.sqhstv[0] = (unsigned char  *)&eintrag.speicherID;
    sqlstm.sqhstl[0] = (unsigned int  )4;
    sqlstm.sqindv[0] = (         short *)0;
    sqlstm.sqharm[0] = (unsigned int  )0;
    sqlstm.sqhstv[1] = (unsigned char  *)&eintrag.haltestelleID;
    sqlstm.sqhstl[1] = (unsigned int  )4;
    sqlstm.sqindv[1] = (         short *)0;
    sqlstm.sqharm[1] = (unsigned int  )0;
    sqlstm.sqhstv[2] = (unsigned char  *)&eintrag.umsteigezeit;
    sqlstm.sqhstl[2] = (unsigned int  )4;
    sqlstm.sqindv[2] = (         short *)0;
    sqlstm.sqharm[2] = (unsigned int  )0;
    sqlstm.sqhstv[3] = (unsigned char  *)&eintrag.mindesthaltezeit;
    sqlstm.sqhstl[3] = (unsigned int  )4;
    sqlstm.sqindv[3] = (         short *)0;
    sqlstm.sqharm[3] = (unsigned int  )0;
    sqlstm.sqphsv = sqlstm.sqhstv;
    sqlstm.sqphsl = sqlstm.sqhstl;
    sqlstm.sqpind = sqlstm.sqindv;
    sqlstm.sqparm = sqlstm.sqharm;
    sqlstm.sqparc = sqlstm.sqharc;
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
    if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernKnotenWerte");
}


  }
  /* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )16080;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernKnotenWerte");
}


}

//------------------------------------------------------------------------------
// Funktionsname:	loeschenKnotenWerte
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::loeschenKnotenWerte() {
  // Falls ein Fehler auftritt
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in loeschenKnotenWerte"); */ 


  // Hostvariablen definieren
  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    int speicherID;
  /* EXEC SQL END DECLARE SECTION; */ 


  speicherID = this->speicherstand;

  // Loesche alle Eintraege der Tabelle Fahrplan
  /* EXEC SQL DELETE TABLE KnotenWerte WHERE SpeicherID = :speicherID; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.stmt = "delete from TABLE KnotenWerte where SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )16094;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&speicherID;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenKnotenWerte");
}


}
     
//------------------------------------------------------------------------------
// Funktionsname:	holenLinienwerte
// Beschreibung:	
// Parameter:		
// Rueckgabe:		h_array<int,three_tuple<int,int,int>* >*
// Besonderheiten:	
//------------------------------------------------------------------------------
h_array<int,three_tuple<int,int,bool>* >* CDBSchnittstelle::holenLinienwerte()
{
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenLinienwerte"); */ 


  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    typedef struct {
      int linienID;
      int reisezeitMin;
      int reisezeitStd;
      int pflicht;
    } Eintrag;
    Eintrag eintrag;
    int speicherID;
  /* EXEC SQL END DECLARE SECTION; */ 


  speicherID = this->speicherstand;

  /* EXEC SQL DECLARE ergebnis_cursor CURSOR FOR
    SELECT LinienID,ReisezeitMinute,ReisezeitStunde,Pflichtlinie FROM LinienWerte
    WHERE SpeicherID = :speicherID; */ 


  h_array<int,three_tuple<int,int,bool>* >* linienwerte = 0;
  try{ linienwerte=new h_array<int,three_tuple<int,int,bool>* >;}
  catch(...)
  {
	cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Linienwerte konnte nicht angelegt werden. Speichermangel?"<<endl;
	cerr.flush();
  }

  /* EXEC SQL WHENEVER NOT FOUND DO break; */ 

  /* EXEC SQL OPEN ergebnis_cursor; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.stmt = sq0825;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )16112;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&speicherID;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenLinienwerte");
}



  while(1){
    /* EXEC SQL FETCH ergebnis_cursor INTO :eintrag; */ 

{
    struct sqlexd sqlstm;

    sqlorat((void **)0, &sqlctx, &oraca);
    sqlstm.sqlvsn = 8;
    sqlstm.arrsiz = 35;
    sqlstm.iters = (unsigned int  )1;
    sqlstm.offset = (unsigned int  )16130;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char  *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlstm.sqhstv[0] = (unsigned char  *)&eintrag.linienID;
    sqlstm.sqhstl[0] = (unsigned int  )4;
    sqlstm.sqindv[0] = (         short *)0;
    sqlstm.sqharm[0] = (unsigned int  )0;
    sqlstm.sqhstv[1] = (unsigned char  *)&eintrag.reisezeitMin;
    sqlstm.sqhstl[1] = (unsigned int  )4;
    sqlstm.sqindv[1] = (         short *)0;
    sqlstm.sqharm[1] = (unsigned int  )0;
    sqlstm.sqhstv[2] = (unsigned char  *)&eintrag.reisezeitStd;
    sqlstm.sqhstl[2] = (unsigned int  )4;
    sqlstm.sqindv[2] = (         short *)0;
    sqlstm.sqharm[2] = (unsigned int  )0;
    sqlstm.sqhstv[3] = (unsigned char  *)&eintrag.pflicht;
    sqlstm.sqhstl[3] = (unsigned int  )4;
    sqlstm.sqindv[3] = (         short *)0;
    sqlstm.sqharm[3] = (unsigned int  )0;
    sqlstm.sqphsv = sqlstm.sqhstv;
    sqlstm.sqphsl = sqlstm.sqhstl;
    sqlstm.sqpind = sqlstm.sqindv;
    sqlstm.sqparm = sqlstm.sqharm;
    sqlstm.sqparc = sqlstm.sqharc;
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
    if (sqlca.sqlcode == 1403) break;
    if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenLinienwerte");
}


    int min = eintrag.reisezeitMin;
    int std = eintrag.reisezeitStd;
    bool pflicht;
    if (eintrag.pflicht == 1) pflicht = true;
    else pflicht = false;
    three_tuple<int,int,bool>* listenTuple =0;
    try{listenTuple= new three_tuple<int,int,bool>(min,std,pflicht);}
    catch(...)
    {
	cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: ein Eintrag der Linienwerte konnte nicht angelegt werden. Speichermangel?"<<endl;
	cerr.flush();
    }
    linienwerte[eintrag.linienID] = listenTuple;
  }

  /* EXEC SQL CLOSE ergebnis_cursor; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )16160;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenLinienwerte");
}



  /* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 


  return linienwerte;
}

//------------------------------------------------------------------------------
// Funktionsname:	speichernLinienwerte
// Beschreibung:	
// Parameter:		h_array<int,three_tuple<int,int,int>* >* linienwerte
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::speichernLinienwerte(h_array<int,three_tuple<int,int,bool>* >* linienwerte)
{
  loeschenLinienwerte();

  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in speichernLinienwerte"); */ 


  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    typedef struct {
      int speicherID;
      int linienID;
      int reisezeitMin;
      int reisezeitStd;
      int pflicht;
    } Eintrag;
    Eintrag eintrag;
  /* EXEC SQL END DECLARE SECTION; */ 


  eintrag.speicherID = this->speicherstand;

  int linie;
  three_tuple<int,int,bool>* arrayEintrag;

  forall_defined(linie,*linienwerte) {
    arrayEintrag = (*linienwerte)[linie];
    eintrag.linienID = linie;
    eintrag.reisezeitMin = arrayEintrag->first();
    eintrag.reisezeitStd = arrayEintrag->second();
    if (arrayEintrag->third()) eintrag.pflicht = 1;
    else eintrag.pflicht = 0;
    /* EXEC SQL INSERT INTO LinienWerte VALUES (:eintrag); */ 

{
    struct sqlexd sqlstm;

    sqlorat((void **)0, &sqlctx, &oraca);
    sqlstm.sqlvsn = 8;
    sqlstm.arrsiz = 35;
    sqlstm.stmt = "insert into LinienWerte values (:s1 ,:s2 ,:s3 ,:s4 ,:s5 )";
    sqlstm.iters = (unsigned int  )1;
    sqlstm.offset = (unsigned int  )16174;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char  *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlstm.sqhstv[0] = (unsigned char  *)&eintrag.speicherID;
    sqlstm.sqhstl[0] = (unsigned int  )4;
    sqlstm.sqindv[0] = (         short *)0;
    sqlstm.sqharm[0] = (unsigned int  )0;
    sqlstm.sqhstv[1] = (unsigned char  *)&eintrag.linienID;
    sqlstm.sqhstl[1] = (unsigned int  )4;
    sqlstm.sqindv[1] = (         short *)0;
    sqlstm.sqharm[1] = (unsigned int  )0;
    sqlstm.sqhstv[2] = (unsigned char  *)&eintrag.reisezeitMin;
    sqlstm.sqhstl[2] = (unsigned int  )4;
    sqlstm.sqindv[2] = (         short *)0;
    sqlstm.sqharm[2] = (unsigned int  )0;
    sqlstm.sqhstv[3] = (unsigned char  *)&eintrag.reisezeitStd;
    sqlstm.sqhstl[3] = (unsigned int  )4;
    sqlstm.sqindv[3] = (         short *)0;
    sqlstm.sqharm[3] = (unsigned int  )0;
    sqlstm.sqhstv[4] = (unsigned char  *)&eintrag.pflicht;
    sqlstm.sqhstl[4] = (unsigned int  )4;
    sqlstm.sqindv[4] = (         short *)0;
    sqlstm.sqharm[4] = (unsigned int  )0;
    sqlstm.sqphsv = sqlstm.sqhstv;
    sqlstm.sqphsl = sqlstm.sqhstl;
    sqlstm.sqpind = sqlstm.sqindv;
    sqlstm.sqparm = sqlstm.sqharm;
    sqlstm.sqparc = sqlstm.sqharc;
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
    if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernLinienwerte");
}



	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )16208;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernLinienwerte");
}


  }
  /* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )16222;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernLinienwerte");
}


}

//------------------------------------------------------------------------------
// Funktionsname:	loeschenLinienwerte
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::loeschenLinienwerte() {
  // Falls ein Fehler auftritt
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in loeschenLinienwerte"); */ 


  // Hostvariablen definieren
  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    int speicherID;
  /* EXEC SQL END DECLARE SECTION; */ 


  speicherID = this->speicherstand;

  // Loesche alle Eintraege der Tabelle Fahrplan
  /* EXEC SQL DELETE TABLE LinienWerte WHERE SpeicherID = :speicherID; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.stmt = "delete from TABLE LinienWerte where SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )16236;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&speicherID;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenLinienwerte");
}


}
  
//------------------------------------------------------------------------------
// Funktionsname:	holenAnschluss
// Beschreibung:	
// Parameter:		
// Rueckgabe:		three_tuple<int,int,int>* >*
// Besonderheiten:	
//------------------------------------------------------------------------------
list<three_tuple<int,int,int>* >* CDBSchnittstelle::holenAnschluss() {
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenAnschluss"); */ 


  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    typedef struct {
      int linieVon;
      int linieNach;
      int haltestelle;
    } Eintrag;
    Eintrag eintrag;
    int speicherID;
  /* EXEC SQL END DECLARE SECTION; */ 


  speicherID = this->speicherstand;

  /* EXEC SQL DECLARE ergebnis_cursor CURSOR FOR
    SELECT LinieVon,LinieNach,Haltestelle FROM Anschluss
    WHERE SpeicherID = :speicherID; */ 


  list<three_tuple<int,int,int>* >* anschluss =0;
  try{anschluss = new list<three_tuple<int,int,int>* >;}
  catch(...)
  {
	cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Liste der Anschluesse konnte nicht angelegt werden. Speichermangel?"<<endl;
	cerr.flush();
  }


  /* EXEC SQL WHENEVER NOT FOUND DO break; */ 

  /* EXEC SQL OPEN ergebnis_cursor; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.stmt = sq0825;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )16254;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&speicherID;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenAnschluss");
}



  while(1) {
    /* EXEC SQL FETCH ergebnis_cursor INTO :eintrag; */ 

{
    struct sqlexd sqlstm;

    sqlorat((void **)0, &sqlctx, &oraca);
    sqlstm.sqlvsn = 8;
    sqlstm.arrsiz = 35;
    sqlstm.iters = (unsigned int  )1;
    sqlstm.offset = (unsigned int  )16272;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char  *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlstm.sqhstv[0] = (unsigned char  *)&eintrag.linieVon;
    sqlstm.sqhstl[0] = (unsigned int  )4;
    sqlstm.sqindv[0] = (         short *)0;
    sqlstm.sqharm[0] = (unsigned int  )0;
    sqlstm.sqhstv[1] = (unsigned char  *)&eintrag.linieNach;
    sqlstm.sqhstl[1] = (unsigned int  )4;
    sqlstm.sqindv[1] = (         short *)0;
    sqlstm.sqharm[1] = (unsigned int  )0;
    sqlstm.sqhstv[2] = (unsigned char  *)&eintrag.haltestelle;
    sqlstm.sqhstl[2] = (unsigned int  )4;
    sqlstm.sqindv[2] = (         short *)0;
    sqlstm.sqharm[2] = (unsigned int  )0;
    sqlstm.sqphsv = sqlstm.sqhstv;
    sqlstm.sqphsl = sqlstm.sqhstl;
    sqlstm.sqpind = sqlstm.sqindv;
    sqlstm.sqparm = sqlstm.sqharm;
    sqlstm.sqparc = sqlstm.sqharc;
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
    if (sqlca.sqlcode == 1403) break;
    if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenAnschluss");
}


    three_tuple<int,int,int>* listenEintrag =0;
    try{listenEintrag= new three_tuple<int,int,int>(eintrag.linieVon, eintrag.linieNach, eintrag.haltestelle);}
    catch(...)
    {
	cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: ein Element der Anschluesse konnte nicht angelegt werden. Speichermangel?"<<endl;
	cerr.flush();
    }
    anschluss->append(listenEintrag);
  }

  /* EXEC SQL CLOSE ergebnis_cursor; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )16298;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenAnschluss");
}



  /* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 


  return anschluss;
}

//------------------------------------------------------------------------------
// Funktionsname:	speichernAnschluss
// Beschreibung:	
// Parameter:		list<three_tuple<int,int,int>* >* anschluss
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::speichernAnschluss(list<three_tuple<int,int,int>* >* anschluss) {
  loeschenAnschluss();

  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in speichernAnschluss"); */ 


  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    typedef struct {
      int speicherID;
      int linieVon;
      int linieNach;
      int haltestelle;
    } Eintrag;
    Eintrag eintrag;
  /* EXEC SQL END DECLARE SECTION; */ 


  eintrag.speicherID = this->speicherstand;
  three_tuple<int,int,int>* listenEintrag;
  forall(listenEintrag,*anschluss) {
    eintrag.linieVon = listenEintrag->first();
    eintrag.linieNach = listenEintrag->second();
    eintrag.haltestelle = listenEintrag->third();
    /* EXEC SQL INSERT INTO Anschluss VALUES (:eintrag); */ 

{
    struct sqlexd sqlstm;

    sqlorat((void **)0, &sqlctx, &oraca);
    sqlstm.sqlvsn = 8;
    sqlstm.arrsiz = 35;
    sqlstm.stmt = "insert into Anschluss values (:s1 ,:s2 ,:s3 ,:s4 )";
    sqlstm.iters = (unsigned int  )1;
    sqlstm.offset = (unsigned int  )16312;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char  *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlstm.sqhstv[0] = (unsigned char  *)&eintrag.speicherID;
    sqlstm.sqhstl[0] = (unsigned int  )4;
    sqlstm.sqindv[0] = (         short *)0;
    sqlstm.sqharm[0] = (unsigned int  )0;
    sqlstm.sqhstv[1] = (unsigned char  *)&eintrag.linieVon;
    sqlstm.sqhstl[1] = (unsigned int  )4;
    sqlstm.sqindv[1] = (         short *)0;
    sqlstm.sqharm[1] = (unsigned int  )0;
    sqlstm.sqhstv[2] = (unsigned char  *)&eintrag.linieNach;
    sqlstm.sqhstl[2] = (unsigned int  )4;
    sqlstm.sqindv[2] = (         short *)0;
    sqlstm.sqharm[2] = (unsigned int  )0;
    sqlstm.sqhstv[3] = (unsigned char  *)&eintrag.haltestelle;
    sqlstm.sqhstl[3] = (unsigned int  )4;
    sqlstm.sqindv[3] = (         short *)0;
    sqlstm.sqharm[3] = (unsigned int  )0;
    sqlstm.sqphsv = sqlstm.sqhstv;
    sqlstm.sqphsl = sqlstm.sqhstl;
    sqlstm.sqpind = sqlstm.sqindv;
    sqlstm.sqparm = sqlstm.sqharm;
    sqlstm.sqparc = sqlstm.sqharc;
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
    if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernAnschluss");
}


	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )16342;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernAnschluss");
}


  }
  /* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )16356;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernAnschluss");
}


}

//------------------------------------------------------------------------------
// Funktionsname:	loeschenAnschluss
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::loeschenAnschluss() {
  // Falls ein Fehler auftritt
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in loeschenAnschluss"); */ 


  // Hostvariablen definieren
  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    int speicherID;
  /* EXEC SQL END DECLARE SECTION; */ 


  speicherID = this->speicherstand;

  // Loesche alle Eintraege der Tabelle Fahrplan
  /* EXEC SQL DELETE TABLE Anschluss WHERE SpeicherID = :speicherID; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.stmt = "delete from TABLE Anschluss where SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )16370;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&speicherID;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenAnschluss");
}


}

//------------------------------------------------------------------------------
// Funktionsname:	holenFahrplanHaltestellen
// Beschreibung:	Holt den Fahrplan aus der Datenbank
// Parameter:		
// Rueckgabe:		Liste des Fahrplans
// Besonderheiten:	Die zurueckgegebene Liste hat die Sortierung Haltestelle, Linie, 
//                      AbfahrtszeitStd, AbfahrtszeitMinute
//------------------------------------------------------------------------------   
list<CFahrplanElement*>* CDBSchnittstelle::holenFahrplanHaltestellen(){
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenFahrplanHaltestellen"); */ 


  // Deklarieren der Hostvariablen zur Speicherung der Ergebnissmenge.
  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    typedef struct
    {
      int haltestellenID;
      int linienID;
      int abfahrtszeitStd;
      int abfahrtszeitMin;
    } fpElement;
    fpElement fahrplanElement;
    int speicherID;
  /* EXEC SQL END DECLARE SECTION; */ 


  speicherID = this->speicherstand;

  // Den Cursor mit der select Anweisung definieren
  /* EXEC SQL DECLARE fahrplanCursor CURSOR FOR SELECT HaltestellenID, LinienID, AbfahrtszeitStd, AbfahrtszeitMin 
    INTO :fahrplanElement FROM Fahrplan WHERE SpeicherID = :speicherID
    ORDER BY HaltestellenID, LinienID, AbfahrtszeitStd, AbfahrtszeitMin; */ 


  /* EXEC SQL WHENEVER NOT FOUND DO break; */ 

  /* EXEC SQL OPEN fahrplancursor; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.stmt = sq0837;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )16388;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&fahrplanElement.haltestellenID;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&fahrplanElement.linienID;
  sqlstm.sqhstl[1] = (unsigned int  )4;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&fahrplanElement.abfahrtszeitStd;
  sqlstm.sqhstl[2] = (unsigned int  )4;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqhstv[3] = (unsigned char  *)&fahrplanElement.abfahrtszeitMin;
  sqlstm.sqhstl[3] = (unsigned int  )4;
  sqlstm.sqindv[3] = (         short *)0;
  sqlstm.sqharm[3] = (unsigned int  )0;
  sqlstm.sqhstv[4] = (unsigned char  *)&speicherID;
  sqlstm.sqhstl[4] = (unsigned int  )4;
  sqlstm.sqindv[4] = (         short *)0;
  sqlstm.sqharm[4] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenFahrplanHaltestellen");
}



  // Die Datenbank durchlaufen und alle Elemente in einer Liste speichern.
  list<CFahrplanElement*>* fahrplanListe =0;
  try{ fahrplanListe= new list<CFahrplanElement*>();}
  catch(...)
  {
	cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Fahrplanliste konnte nicht angelegt werden. Speichermangel?"<<endl;
	cerr.flush();
  }
  while(1){
    /* EXEC SQL FETCH fahrplanCursor INTO :fahrplanElement; */ 

{
    struct sqlexd sqlstm;

    sqlorat((void **)0, &sqlctx, &oraca);
    sqlstm.sqlvsn = 8;
    sqlstm.arrsiz = 35;
    sqlstm.iters = (unsigned int  )1;
    sqlstm.offset = (unsigned int  )16422;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char  *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlstm.sqhstv[0] = (unsigned char  *)&fahrplanElement.haltestellenID;
    sqlstm.sqhstl[0] = (unsigned int  )4;
    sqlstm.sqindv[0] = (         short *)0;
    sqlstm.sqharm[0] = (unsigned int  )0;
    sqlstm.sqhstv[1] = (unsigned char  *)&fahrplanElement.linienID;
    sqlstm.sqhstl[1] = (unsigned int  )4;
    sqlstm.sqindv[1] = (         short *)0;
    sqlstm.sqharm[1] = (unsigned int  )0;
    sqlstm.sqhstv[2] = (unsigned char  *)&fahrplanElement.abfahrtszeitStd;
    sqlstm.sqhstl[2] = (unsigned int  )4;
    sqlstm.sqindv[2] = (         short *)0;
    sqlstm.sqharm[2] = (unsigned int  )0;
    sqlstm.sqhstv[3] = (unsigned char  *)&fahrplanElement.abfahrtszeitMin;
    sqlstm.sqhstl[3] = (unsigned int  )4;
    sqlstm.sqindv[3] = (         short *)0;
    sqlstm.sqharm[3] = (unsigned int  )0;
    sqlstm.sqphsv = sqlstm.sqhstv;
    sqlstm.sqphsl = sqlstm.sqhstl;
    sqlstm.sqpind = sqlstm.sqindv;
    sqlstm.sqparm = sqlstm.sqharm;
    sqlstm.sqparc = sqlstm.sqharc;
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
    if (sqlca.sqlcode == 1403) break;
    if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenFahrplanHaltestellen");
}


    CFahrplanElement* listenElement =0;
    try{listenElement= new CFahrplanElement();}
    catch(...)
    {
	cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: ein Element der Fahrplanliste konnte nicht angelegt werden. Speichermangel?"<<endl;
	cerr.flush();
    }
    listenElement->setzenHaltestelle(fahrplanElement.haltestellenID);
    listenElement->setzenLinie(fahrplanElement.linienID);
    listenElement->setzenAbfahrtszeitStunde(fahrplanElement.abfahrtszeitStd);
    listenElement->setzenAbfahrtszeitMinute(fahrplanElement.abfahrtszeitMin);
    fahrplanListe->append(listenElement);
  }

  /* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 


  // Den Cursor wieder schliessen
  /* EXEC SQL CLOSE fahrplanCursor; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )16452;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenFahrplanHaltestellen");
}



  return fahrplanListe;
}

//------------------------------------------------------------------------------
// Funktionsname:	holenFahrplanLinien
// Beschreibung:	Gibt den Fahrplan zurueck
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
list<CFahrplanElement*>* CDBSchnittstelle::holenFahrplanLinien(){
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenFahrplanLinien"); */ 


  // Deklarieren der Hostvariablen zur Speicherung der Ergebnissmenge.
  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    typedef struct
    {
      int haltestellenID;
      int linienID;
      int abfahrtszeitStd;
      int abfahrtszeitMin;
    } fpElement;
    fpElement fahrplanElement;
    int speicherID;
  /* EXEC SQL END DECLARE SECTION; */ 

  
  speicherID = this->speicherstand;

  // Den Cursor mit der select Anweisung definieren
  /* EXEC SQL DECLARE fahrplanCursor CURSOR FOR SELECT LinienID, HaltestellenID, AbfahrtszeitStd, AbfahrtszeitMin 
    FROM Fahrplan WHERE SpeicherID = :speicherID
    ORDER BY LinienID, HaltestellenID, AbfahrtszeitStd, AbfahrtszeitMin; */ 


  /* EXEC SQL WHENEVER NOT FOUND DO break; */ 

  /* EXEC SQL OPEN fahrplancursor; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.stmt = sq0837;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )16466;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&fahrplanElement.haltestellenID;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&fahrplanElement.linienID;
  sqlstm.sqhstl[1] = (unsigned int  )4;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&fahrplanElement.abfahrtszeitStd;
  sqlstm.sqhstl[2] = (unsigned int  )4;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqhstv[3] = (unsigned char  *)&fahrplanElement.abfahrtszeitMin;
  sqlstm.sqhstl[3] = (unsigned int  )4;
  sqlstm.sqindv[3] = (         short *)0;
  sqlstm.sqharm[3] = (unsigned int  )0;
  sqlstm.sqhstv[4] = (unsigned char  *)&speicherID;
  sqlstm.sqhstl[4] = (unsigned int  )4;
  sqlstm.sqindv[4] = (         short *)0;
  sqlstm.sqharm[4] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenFahrplanLinien");
}



  // Die Datenbank durchlaufen und alle Elemente in einer Liste speichern.
  list<CFahrplanElement*>* fahrplanListe =0;
  try{ fahrplanListe= new list<CFahrplanElement*>();}
  catch(...)
  {
	cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Fahrplanliste konnte nicht angelegt werden. Speichermangel?"<<endl;
	cerr.flush();
  }
  while(1){
    /* EXEC SQL FETCH fahrplanCursor INTO :fahrplanElement; */ 

{
    struct sqlexd sqlstm;

    sqlorat((void **)0, &sqlctx, &oraca);
    sqlstm.sqlvsn = 8;
    sqlstm.arrsiz = 35;
    sqlstm.iters = (unsigned int  )1;
    sqlstm.offset = (unsigned int  )16500;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char  *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlstm.sqhstv[0] = (unsigned char  *)&fahrplanElement.haltestellenID;
    sqlstm.sqhstl[0] = (unsigned int  )4;
    sqlstm.sqindv[0] = (         short *)0;
    sqlstm.sqharm[0] = (unsigned int  )0;
    sqlstm.sqhstv[1] = (unsigned char  *)&fahrplanElement.linienID;
    sqlstm.sqhstl[1] = (unsigned int  )4;
    sqlstm.sqindv[1] = (         short *)0;
    sqlstm.sqharm[1] = (unsigned int  )0;
    sqlstm.sqhstv[2] = (unsigned char  *)&fahrplanElement.abfahrtszeitStd;
    sqlstm.sqhstl[2] = (unsigned int  )4;
    sqlstm.sqindv[2] = (         short *)0;
    sqlstm.sqharm[2] = (unsigned int  )0;
    sqlstm.sqhstv[3] = (unsigned char  *)&fahrplanElement.abfahrtszeitMin;
    sqlstm.sqhstl[3] = (unsigned int  )4;
    sqlstm.sqindv[3] = (         short *)0;
    sqlstm.sqharm[3] = (unsigned int  )0;
    sqlstm.sqphsv = sqlstm.sqhstv;
    sqlstm.sqphsl = sqlstm.sqhstl;
    sqlstm.sqpind = sqlstm.sqindv;
    sqlstm.sqparm = sqlstm.sqharm;
    sqlstm.sqparc = sqlstm.sqharc;
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
    if (sqlca.sqlcode == 1403) break;
    if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenFahrplanLinien");
}


    CFahrplanElement* listenElement =0;
    try{listenElement= new CFahrplanElement();}
    catch(...)
    {
	cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: ein Element der Fahrplanliste konnte nicht angelegt werden. Speichermangel?"<<endl;
	cerr.flush();
    }
    listenElement->setzenHaltestelle(fahrplanElement.haltestellenID);
    listenElement->setzenLinie(fahrplanElement.linienID);
    listenElement->setzenAbfahrtszeitStunde(fahrplanElement.abfahrtszeitStd);
    listenElement->setzenAbfahrtszeitMinute(fahrplanElement.abfahrtszeitMin);
    fahrplanListe->append(listenElement);
  }

  /* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 


  // Den Cursor wieder schliessen
  /* EXEC SQL CLOSE fahrplanCursor; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )16530;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenFahrplanLinien");
}



  return fahrplanListe;
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::loeschenFahrplan(){
  // Falls ein Fehler auftritt
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in loeschenFahrplan"); */ 


  // Hostvariablen definieren
  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    int speicherID;
  /* EXEC SQL END DECLARE SECTION; */ 


  speicherID = this->speicherstand;

  // Loesche alle Eintraege der Tabelle Fahrplan
  /* EXEC SQL DELETE FROM Fahrplan WHERE SpeicherID = :speicherID; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.stmt = "delete from Fahrplan  where SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )16544;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&speicherID;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenFahrplan");
}


}

//------------------------------------------------------------------------------
// Funktionsname:	speichernFahrplan
// Beschreibung:	Mite dieser Methode wird der Fahrplan in der Datenbank gespeichert
// Parameter:		Fahrplan
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::speichernFahrplan(list<CFahrplanElement*>* fahrplan){
  loeschenFahrplan();

  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in speichernFahrplan"); */ 


  // Declarieren der Hostvariablen fuer die Datenbank
  loeschenFahrplan();

  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    int speicherID;
    int HaltestellenID;
    int LinienID;
    int AbfahrtszeitStd;
    int AbfahrtszeitMin;
  /* EXEC SQL END DECLARE SECTION; */ 


  speicherID = this->speicherstand;

  // Durchlaufe die Fahrplanliste, ...
  CFahrplanElement* fahrplanElement;
  forall(fahrplanElement, *(fahrplan)){
    // ... gebe die Werte der Hostvariablen und ...
    HaltestellenID = fahrplanElement->gebenHaltestelle();
    LinienID = fahrplanElement->gebenLinie();
    AbfahrtszeitStd = fahrplanElement->gebenAbfahrtszeitStunde();
    AbfahrtszeitMin = fahrplanElement->gebenAbfahrtszeitMinute();
    // ... speichere die Werte in die Datenbank
    /* EXEC SQL INSERT INTO Fahrplan VALUES (:speicherID, :HaltestellenID, :LinienID, :AbfahrtszeitStd, :AbfahrtszeitMin); */ 

{
    struct sqlexd sqlstm;

    sqlorat((void **)0, &sqlctx, &oraca);
    sqlstm.sqlvsn = 8;
    sqlstm.arrsiz = 35;
    sqlstm.stmt = "insert into Fahrplan values (:b0,:b1,:b2,:b3,:b4)";
    sqlstm.iters = (unsigned int  )1;
    sqlstm.offset = (unsigned int  )16562;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char  *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlstm.sqhstv[0] = (unsigned char  *)&speicherID;
    sqlstm.sqhstl[0] = (unsigned int  )4;
    sqlstm.sqindv[0] = (         short *)0;
    sqlstm.sqharm[0] = (unsigned int  )0;
    sqlstm.sqhstv[1] = (unsigned char  *)&HaltestellenID;
    sqlstm.sqhstl[1] = (unsigned int  )4;
    sqlstm.sqindv[1] = (         short *)0;
    sqlstm.sqharm[1] = (unsigned int  )0;
    sqlstm.sqhstv[2] = (unsigned char  *)&LinienID;
    sqlstm.sqhstl[2] = (unsigned int  )4;
    sqlstm.sqindv[2] = (         short *)0;
    sqlstm.sqharm[2] = (unsigned int  )0;
    sqlstm.sqhstv[3] = (unsigned char  *)&AbfahrtszeitStd;
    sqlstm.sqhstl[3] = (unsigned int  )4;
    sqlstm.sqindv[3] = (         short *)0;
    sqlstm.sqharm[3] = (unsigned int  )0;
    sqlstm.sqhstv[4] = (unsigned char  *)&AbfahrtszeitMin;
    sqlstm.sqhstl[4] = (unsigned int  )4;
    sqlstm.sqindv[4] = (         short *)0;
    sqlstm.sqharm[4] = (unsigned int  )0;
    sqlstm.sqphsv = sqlstm.sqhstv;
    sqlstm.sqphsl = sqlstm.sqhstl;
    sqlstm.sqpind = sqlstm.sqindv;
    sqlstm.sqparm = sqlstm.sqharm;
    sqlstm.sqparc = sqlstm.sqharc;
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
    if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernFahrplan");
}


	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )16596;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernFahrplan");
}


  }	
  /* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )16610;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernFahrplan");
}


}
    
//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
array<list<three_tuple<int,int,int>* >* >* CDBSchnittstelle::holenZusammenhangskomponenten()
{
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenZusammenhangskomponenten"); */ 


  // Hostvariablen fuer die Datenbank
  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    typedef struct {
      int komponentenID;
      int haltestelleVon;
      int haltestelleNach;
      int linienID;
    } Eintrag;
    Eintrag eintrag;
    int speicherID;
    // Diese Variable wird zur Ermittlung der Anzahl Zusammenhangskomponenten benoetigt
    int komponentenIDZaehl;
  /* EXEC SQL END DECLARE SECTION; */ 


  speicherID = this->speicherstand;

  // Als erstes die groesse des Array ermitteln

  int komponentenzaehler = 0;
 
  /* EXEC SQL DECLARE zaehl_cursor CURSOR FOR
    SELECT KomponentenID FROM Zusammenhangskomponente WHERE SpeicherID = :speicherID
    GROUP BY KomponentenID; */ 


  /* EXEC SQL WHENEVER NOT FOUND DO break; */ 

  /* EXEC SQL OPEN zaehl_cursor; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.stmt = sq0842;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )16624;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&speicherID;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenZusammenhangskomponenten");
}



  while(1) {
    /* EXEC SQL FETCH zaehl_cursor INTO :komponentenIDZaehl; */ 

{
    struct sqlexd sqlstm;

    sqlorat((void **)0, &sqlctx, &oraca);
    sqlstm.sqlvsn = 8;
    sqlstm.arrsiz = 35;
    sqlstm.iters = (unsigned int  )1;
    sqlstm.offset = (unsigned int  )16642;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char  *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlstm.sqhstv[0] = (unsigned char  *)&komponentenIDZaehl;
    sqlstm.sqhstl[0] = (unsigned int  )4;
    sqlstm.sqindv[0] = (         short *)0;
    sqlstm.sqharm[0] = (unsigned int  )0;
    sqlstm.sqphsv = sqlstm.sqhstv;
    sqlstm.sqphsl = sqlstm.sqhstl;
    sqlstm.sqpind = sqlstm.sqindv;
    sqlstm.sqparm = sqlstm.sqharm;
    sqlstm.sqparc = sqlstm.sqharc;
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
    if (sqlca.sqlcode == 1403) break;
    if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenZusammenhangskomponenten");
}


    komponentenzaehler++;
  }

  /* EXEC SQL CLOSE zaehl_cursor; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )16660;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenZusammenhangskomponenten");
}



  // Dann die Werte Auslesen

  if (komponentenzaehler > 0) {

    array<list<three_tuple<int,int,int>* >* >* zusammenhangskomponenten =0;
    try{ zusammenhangskomponenten= new array<list<three_tuple<int,int,int>* >* >(komponentenzaehler);}
    catch(...)
    {
	cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Liste der Zusammenhangskomponenten konnte nicht angelegt werden. Speichermangel?"<<endl;
	cerr.flush();
    }
    
    // Die KomponentenID faengt immer bei 0 an
    
    komponentenzaehler = 0;
    
    list<three_tuple<int,int,int>* >* komponentenListe = 0;
    try{komponentenListe=new list<three_tuple<int,int,int>* >;}
    catch(...)
    {
	cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: eine Zusammenhangskomponente konnte nicht angelegt werden. Speichermangel?"<<endl;
	cerr.flush();
    }
    
    three_tuple<int,int,int>* listenEintrag;
    
    /* EXEC SQL DECLARE ergebnis_cursor CURSOR FOR SELECT KomponentenID,HaltestellenIDVon,HaltestellenIDNach,LinienID
      FROM Zusammenhangskomponente WHERE SpeicherID = :speicherID
      ORDER BY KomponentenID,LfdNummer; */ 

    
    /* EXEC SQL WHENEVER NOT FOUND DO break; */ 

    /* EXEC SQL OPEN ergebnis_cursor; */ 

{
    struct sqlexd sqlstm;

    sqlorat((void **)0, &sqlctx, &oraca);
    sqlstm.sqlvsn = 8;
    sqlstm.arrsiz = 35;
    sqlstm.stmt = sq0825;
    sqlstm.iters = (unsigned int  )1;
    sqlstm.offset = (unsigned int  )16674;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char  *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlstm.sqhstv[0] = (unsigned char  *)&speicherID;
    sqlstm.sqhstl[0] = (unsigned int  )4;
    sqlstm.sqindv[0] = (         short *)0;
    sqlstm.sqharm[0] = (unsigned int  )0;
    sqlstm.sqphsv = sqlstm.sqhstv;
    sqlstm.sqphsl = sqlstm.sqhstl;
    sqlstm.sqpind = sqlstm.sqindv;
    sqlstm.sqparm = sqlstm.sqharm;
    sqlstm.sqparc = sqlstm.sqharc;
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
    if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenZusammenhangskomponenten");
}


    
    while(1) {
      /* EXEC SQL FETCH ergebnis_cursor INTO :eintrag; */ 

{
      struct sqlexd sqlstm;

      sqlorat((void **)0, &sqlctx, &oraca);
      sqlstm.sqlvsn = 8;
      sqlstm.arrsiz = 35;
      sqlstm.iters = (unsigned int  )1;
      sqlstm.offset = (unsigned int  )16692;
      sqlstm.cud = sqlcud0;
      sqlstm.sqlest = (unsigned char  *)&sqlca;
      sqlstm.sqlety = (unsigned short)0;
      sqlstm.sqhstv[0] = (unsigned char  *)&eintrag.komponentenID;
      sqlstm.sqhstl[0] = (unsigned int  )4;
      sqlstm.sqindv[0] = (         short *)0;
      sqlstm.sqharm[0] = (unsigned int  )0;
      sqlstm.sqhstv[1] = (unsigned char  *)&eintrag.haltestelleVon;
      sqlstm.sqhstl[1] = (unsigned int  )4;
      sqlstm.sqindv[1] = (         short *)0;
      sqlstm.sqharm[1] = (unsigned int  )0;
      sqlstm.sqhstv[2] = (unsigned char  *)&eintrag.haltestelleNach;
      sqlstm.sqhstl[2] = (unsigned int  )4;
      sqlstm.sqindv[2] = (         short *)0;
      sqlstm.sqharm[2] = (unsigned int  )0;
      sqlstm.sqhstv[3] = (unsigned char  *)&eintrag.linienID;
      sqlstm.sqhstl[3] = (unsigned int  )4;
      sqlstm.sqindv[3] = (         short *)0;
      sqlstm.sqharm[3] = (unsigned int  )0;
      sqlstm.sqphsv = sqlstm.sqhstv;
      sqlstm.sqphsl = sqlstm.sqhstl;
      sqlstm.sqpind = sqlstm.sqindv;
      sqlstm.sqparm = sqlstm.sqharm;
      sqlstm.sqparc = sqlstm.sqharc;
      sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
      if (sqlca.sqlcode == 1403) break;
      if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenZusammenhangskomponenten");
}


      try{listenEintrag = new three_tuple<int,int,int>(eintrag.haltestelleVon,eintrag.haltestelleNach,eintrag.linienID);}
      catch(...)
      {
	cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: ein Eintrag der Zusammenhangskomponente konnte nicht angelegt werden (1). Speichermangel?"<<endl;
	cerr.flush();
      }
      // Entweder muss der Eintrag an die Liste angehaengt werden ...
      if (komponentenzaehler == eintrag.komponentenID) {
	komponentenListe->append(listenEintrag);
      }
      // oder die Liste muss an das Array gehangen werden und der Eintrag kommt in eine neue Liste
      else {
	komponentenzaehler = eintrag.komponentenID;
	zusammenhangskomponenten->set(eintrag.komponentenID - 1,komponentenListe);
	try{komponentenListe = new list<three_tuple<int,int,int>* >;}
	catch(...)
      {
	cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: ein Eintrag der Zusammenhangskomponente konnte nicht angelegt werden (2). Speichermangel?"<<endl;
	cerr.flush();
      }
	
	komponentenListe->append(listenEintrag);
      }
    }
    
    /* EXEC SQL CLOSE ergebnis_cursor; */ 

{
    struct sqlexd sqlstm;

    sqlorat((void **)0, &sqlctx, &oraca);
    sqlstm.sqlvsn = 8;
    sqlstm.arrsiz = 35;
    sqlstm.iters = (unsigned int  )1;
    sqlstm.offset = (unsigned int  )16722;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char  *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
    if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenZusammenhangskomponenten");
}


    
    /* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

    
    return zusammenhangskomponenten;
  }
  else return 0;
}

//------------------------------------------------------------------------------
// Funktionsname:	speichernZusammenhangskomponente
// Beschreibung:	In dieser Methode werden alle Zusammenhangskomponenten gespeichert
// Parameter:		Array der Zusammenhangskomponenten, mit:
//                      HaltestellenIDVon, HaltestellenIDNach und LinienID
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::speichernZusammenhangskomponenten(array<list<three_tuple<int,int,int>* >* >* zusammenhangskomponenten) {
  loeschenZusammenhangskomponenten();

  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in speichernZusammenhangskomponenten"); */ 

 
  // Als erstes die Datenbankvariablen
  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    int speicherID;
    int komponente;
    int lfdNummer;
    int haltestelleVon;
    int haltestelleNach;
    int linienNummer;
  /* EXEC SQL END DECLARE SECTION; */ 


  // Fuer jede Zusammenhangskomponente muss die Liste durchlaufen werden
  list<three_tuple<int,int,int>* >* zusammenhangskomponentenListe;
  three_tuple<int,int,int>* werte;
  speicherID = this->speicherstand;
  for (int i = 0;i<(zusammenhangskomponenten->size());i++){
    zusammenhangskomponentenListe = (*zusammenhangskomponenten)[i];
    komponente = i;
    lfdNummer = 0;
    // Und die einzelnen Werte gespeichert werden.
    forall(werte,*zusammenhangskomponentenListe){
      lfdNummer++;
      haltestelleVon = werte->first();
      haltestelleNach = werte->second();
      linienNummer = werte->third();
      /* EXEC SQL INSERT INTO Zusammenhangskomponente VALUES(
                           :speicherID, :komponente, :lfdNummer, :haltestelleVon,:haltestelleNach,:linienNummer); */ 

{
      struct sqlexd sqlstm;

      sqlorat((void **)0, &sqlctx, &oraca);
      sqlstm.sqlvsn = 8;
      sqlstm.arrsiz = 35;
      sqlstm.stmt = "insert into Zusammenhangskomponente values (:b0,:b1,:b2\
,:b3,:b4,:b5)";
      sqlstm.iters = (unsigned int  )1;
      sqlstm.offset = (unsigned int  )16736;
      sqlstm.cud = sqlcud0;
      sqlstm.sqlest = (unsigned char  *)&sqlca;
      sqlstm.sqlety = (unsigned short)0;
      sqlstm.sqhstv[0] = (unsigned char  *)&speicherID;
      sqlstm.sqhstl[0] = (unsigned int  )4;
      sqlstm.sqindv[0] = (         short *)0;
      sqlstm.sqharm[0] = (unsigned int  )0;
      sqlstm.sqhstv[1] = (unsigned char  *)&komponente;
      sqlstm.sqhstl[1] = (unsigned int  )4;
      sqlstm.sqindv[1] = (         short *)0;
      sqlstm.sqharm[1] = (unsigned int  )0;
      sqlstm.sqhstv[2] = (unsigned char  *)&lfdNummer;
      sqlstm.sqhstl[2] = (unsigned int  )4;
      sqlstm.sqindv[2] = (         short *)0;
      sqlstm.sqharm[2] = (unsigned int  )0;
      sqlstm.sqhstv[3] = (unsigned char  *)&haltestelleVon;
      sqlstm.sqhstl[3] = (unsigned int  )4;
      sqlstm.sqindv[3] = (         short *)0;
      sqlstm.sqharm[3] = (unsigned int  )0;
      sqlstm.sqhstv[4] = (unsigned char  *)&haltestelleNach;
      sqlstm.sqhstl[4] = (unsigned int  )4;
      sqlstm.sqindv[4] = (         short *)0;
      sqlstm.sqharm[4] = (unsigned int  )0;
      sqlstm.sqhstv[5] = (unsigned char  *)&linienNummer;
      sqlstm.sqhstl[5] = (unsigned int  )4;
      sqlstm.sqindv[5] = (         short *)0;
      sqlstm.sqharm[5] = (unsigned int  )0;
      sqlstm.sqphsv = sqlstm.sqhstv;
      sqlstm.sqphsl = sqlstm.sqhstl;
      sqlstm.sqpind = sqlstm.sqindv;
      sqlstm.sqparm = sqlstm.sqharm;
      sqlstm.sqparc = sqlstm.sqharc;
      sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
      if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernZusammenhangskomponenten");
}



		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )16774;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernZusammenhangskomponenten");
}


    }
  }
  /* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )16788;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernZusammenhangskomponenten");
}


}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::loeschenZusammenhangskomponenten() {
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in loeschenZusammenhangskomponenten"); */ 


  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    int speicherID;
  /* EXEC SQL END DECLARE SECTION; */ 


  speicherID = this->speicherstand;

  /* EXEC SQL DELETE Zusammenhangskomponente WHERE SpeicherID = :speicherID; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.stmt = "delete from Zusammenhangskomponente  where SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )16802;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&speicherID;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenZusammenhangskomponenten");
}


}
  
//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::holenAusgangsloesung(int loesungsID,double& wartezeitaufwand,double& mindestwartezeit,double& gesamtwartezeit, int& anzahl_busse) {
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenAusgangsloesung"); */ 


  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    int speicherID;
    int tblLoesungsID;
    typedef struct {
      double wartezeitaufwand;
      double mindestwartezeit;
      double gesamtwartezeit;
      int AnzahlBusse;
    } Eintrag;
    Eintrag eintrag;
  /* EXEC SQL END DECLARE SECTION; */ 


  speicherID = this->speicherstand;
  tblLoesungsID = loesungsID;
  eintrag.wartezeitaufwand = 0;
  eintrag.mindestwartezeit = 0;
  eintrag.gesamtwartezeit = 0;
  eintrag.AnzahlBusse = 0;

  /* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 


  /* EXEC SQL SELECT WartezeitaufwandMin,MindestwartezeitMin,GesamtwartezeitMin,AnzahlBusse INTO :eintrag
    FROM Ausgangsloesung WHERE SpeicherID = :speicherID AND LoesungsID = :tblLoesungsID; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.stmt = "select WartezeitaufwandMin ,MindestwartezeitMin ,Gesamtwart\
ezeitMin ,AnzahlBusse into :s1 ,:s2 ,:s3 ,:s4   from Ausgangsloesung where (Sp\
eicherID=:b1 and LoesungsID=:b2)";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )16820;
  sqlstm.selerr = (unsigned short)1;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&eintrag.wartezeitaufwand;
  sqlstm.sqhstl[0] = (unsigned int  )8;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&eintrag.mindestwartezeit;
  sqlstm.sqhstl[1] = (unsigned int  )8;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&eintrag.gesamtwartezeit;
  sqlstm.sqhstl[2] = (unsigned int  )8;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqhstv[3] = (unsigned char  *)&eintrag.AnzahlBusse;
  sqlstm.sqhstl[3] = (unsigned int  )4;
  sqlstm.sqindv[3] = (         short *)0;
  sqlstm.sqharm[3] = (unsigned int  )0;
  sqlstm.sqhstv[4] = (unsigned char  *)&speicherID;
  sqlstm.sqhstl[4] = (unsigned int  )4;
  sqlstm.sqindv[4] = (         short *)0;
  sqlstm.sqharm[4] = (unsigned int  )0;
  sqlstm.sqhstv[5] = (unsigned char  *)&tblLoesungsID;
  sqlstm.sqhstl[5] = (unsigned int  )4;
  sqlstm.sqindv[5] = (         short *)0;
  sqlstm.sqharm[5] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenAusgangsloesung");
}



   wartezeitaufwand=eintrag.wartezeitaufwand;
   mindestwartezeit=eintrag.mindestwartezeit;
   gesamtwartezeit=eintrag.gesamtwartezeit;
   anzahl_busse=eintrag.AnzahlBusse;
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::speichernAusgangsloesung(int loesungsID,double wartezeitaufwand,double mindestwartezeit,double gesamtwartezeit, int anzahl_busse)
{
  loeschenAusgangsloesung(loesungsID);

  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in speichernAusgangsloesung"); */ 


  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    typedef struct {
      int speicherID;
      int loesungsID;
      double wartezeit;
      double mindestwartezeit;
      double gesamtwartezeit;
      int AnzahlBusse;
    } Eintrag;
    Eintrag eintrag;
  /* EXEC SQL END DECLARE SECTION; */ 


  eintrag.speicherID = this->speicherstand;
  eintrag.loesungsID = 0; // ist immer 0! //loesungsID;
  eintrag.wartezeit = wartezeitaufwand;
  eintrag.mindestwartezeit = mindestwartezeit;
  eintrag.gesamtwartezeit = gesamtwartezeit;
  eintrag.AnzahlBusse = anzahl_busse;

  /* EXEC SQL INSERT INTO Ausgangsloesung(SpeicherID,LoesungsID,WartezeitaufwandMin,MindestwartezeitMin,GesamtwartezeitMin,AnzahlBusse) 
    VALUES (:eintrag); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.stmt = "insert into Ausgangsloesung(SpeicherID,LoesungsID,Wartezeit\
aufwandMin,MindestwartezeitMin,GesamtwartezeitMin,AnzahlBusse) values (:s1 ,:s\
2 ,:s3 ,:s4 ,:s5 ,:s6 )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )16858;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&eintrag.speicherID;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&eintrag.loesungsID;
  sqlstm.sqhstl[1] = (unsigned int  )4;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&eintrag.wartezeit;
  sqlstm.sqhstl[2] = (unsigned int  )8;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqhstv[3] = (unsigned char  *)&eintrag.mindestwartezeit;
  sqlstm.sqhstl[3] = (unsigned int  )8;
  sqlstm.sqindv[3] = (         short *)0;
  sqlstm.sqharm[3] = (unsigned int  )0;
  sqlstm.sqhstv[4] = (unsigned char  *)&eintrag.gesamtwartezeit;
  sqlstm.sqhstl[4] = (unsigned int  )8;
  sqlstm.sqindv[4] = (         short *)0;
  sqlstm.sqharm[4] = (unsigned int  )0;
  sqlstm.sqhstv[5] = (unsigned char  *)&eintrag.AnzahlBusse;
  sqlstm.sqhstl[5] = (unsigned int  )4;
  sqlstm.sqindv[5] = (         short *)0;
  sqlstm.sqharm[5] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernAusgangsloesung");
}


  /* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )16896;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernAusgangsloesung");
}


}

//------------------------------------------------------------------------------
// Funktionsname:	fahrplanerstellungWartezeiten
// Beschreibung:	speichert die Wartezeiten in der Datenbanktabelle Ausgangsloesung
// Parameter:		summeNetzbedingteWartezeiten, wartezeitAufwand,  mindestWartezeitAufwand, gesamtWarteaufwand
// Rueckgabe:		
// Besonderheiten:	 gesamtwarteaufwand = summe aus mindestWA und wartezeitAuf und wird daher nicht mit gespeichert
//------------------------------------------------------------------------------
void CDBSchnittstelle::fahrplanerstellungWartezeiten(double summeNetzbedingteWartezeiten, double wartezeitAufwand, double mindestWartezeitAufwand, double gesamtWarteaufwand)
{
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in fahrplanerstellungWartezeiten"); */ 


  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    typedef struct {
      int speicherID;
      int loesungsID;
      double wartezeit;
      double mindestwartezeit;
      double gesamtwartezeit;
    } Eintrag;
    Eintrag eintrag;
  /* EXEC SQL END DECLARE SECTION; */ 


  eintrag.speicherID = this->speicherstand;
  eintrag.loesungsID = 0;
  eintrag.wartezeit = wartezeitAufwand;
  eintrag.mindestwartezeit = mindestWartezeitAufwand;
  eintrag.gesamtwartezeit = summeNetzbedingteWartezeiten;

  /* EXEC SQL UPDATE Ausgangsloesung
	SET WartezeitaufwandMin = eintrag.wartezeit,
		MindestwartezeitMin = eintrag.mindestwartezeit,
		GesamtwartezeitMin = eintrag.gesamtwartezeit
	WHERE SpeicherID = eintrag.speicherstand; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.stmt = "update Ausgangsloesung  set WartezeitaufwandMin=eintrag.war\
tezeit,MindestwartezeitMin=eintrag.mindestwartezeit,GesamtwartezeitMin=eintrag\
.gesamtwartezeit where SpeicherID=eintrag.speicherstand";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )16910;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in fahrplanerstellungWartezeiten");
}



  /* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )16924;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in fahrplanerstellungWartezeiten");
}


}
//------------------------------------------------------------------------------
// Funktionsname:	fahrplanerstellungAnzahlBenoetigterFahrzeuge	
// Beschreibung:	speichert die Anzahl benoetigter Fahrzeuge in der Datenbanktabelle Ausgangsloesung
// Parameter:		fahrzeugAnzahl
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::fahrplanerstellungAnzahlBenoetigterFahrzeuge (int fahrzeugAnzahl)
{
	 /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in fahrplanerstellungAnzahlBenoetigterFahrzeuge "); */ 


  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    typedef struct {
      int speicherID;
      int anzahlFahrzeuge;
    } Eintrag;
    Eintrag eintrag;
  /* EXEC SQL END DECLARE SECTION; */ 


  eintrag.speicherID = this->speicherstand;
  eintrag.anzahlFahrzeuge = fahrzeugAnzahl;

  /* EXEC SQL UPDATE Ausgangsloesung
	SET AnzahlBusse = eintrag.anzahlFahrzeuge
	WHERE SpeicherID = eintrag.speicherstand; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.stmt = "update Ausgangsloesung  set AnzahlBusse=eintrag.anzahlFahrz\
euge where SpeicherID=eintrag.speicherstand";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )16938;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in fahrplanerstellungAnzahlBenoetigterFahrzeuge ");
}



  /* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )16952;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in fahrplanerstellungAnzahlBenoetigterFahrzeuge ");
}


}


//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::loeschenAusgangsloesung(int loesungsID) {
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in loeschenAusgangsloesung"); */ 


  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    int speicherID;
    int tblLoesungsID;

    typedef struct {
      int speicherID;
      int loesungsID;
      int wartezeit;
      int mindestwartezeit;
      int gesamtwartezeit;
      int AnzahlBusse;
    } Eintrag;
    Eintrag eintrag;
  /* EXEC SQL END DECLARE SECTION; */ 


  speicherID = this->speicherstand;
  tblLoesungsID = loesungsID;

  /* EXEC SQL DELETE Ausgangsloesung WHERE SpeicherID = :speicherID; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.stmt = "delete from Ausgangsloesung  where SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )16966;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&speicherID;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenAusgangsloesung");
}

 //AND LoesungsID = :tblLoesungsID;

	// jetzt wieder mit einer Zeile mit -1 fuellen

  eintrag.speicherID = this->speicherstand;
  eintrag.loesungsID = 0; // ist immer 0! //loesungsID;
  eintrag.wartezeit = -1;
  eintrag.mindestwartezeit = -1;
  eintrag.gesamtwartezeit = -1;
  eintrag.AnzahlBusse = -1;

  /* EXEC SQL INSERT INTO Ausgangsloesung(SpeicherID,LoesungsID,WartezeitaufwandMin,MindestwartezeitMin,GesamtwartezeitMin,AnzahlBusse) 
    VALUES (:eintrag); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.stmt = "insert into Ausgangsloesung(SpeicherID,LoesungsID,Wartezeit\
aufwandMin,MindestwartezeitMin,GesamtwartezeitMin,AnzahlBusse) values (:s1 ,:s\
2 ,:s3 ,:s4 ,:s5 ,:s6 )";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )16984;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&eintrag.speicherID;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&eintrag.loesungsID;
  sqlstm.sqhstl[1] = (unsigned int  )4;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&eintrag.wartezeit;
  sqlstm.sqhstl[2] = (unsigned int  )4;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqhstv[3] = (unsigned char  *)&eintrag.mindestwartezeit;
  sqlstm.sqhstl[3] = (unsigned int  )4;
  sqlstm.sqindv[3] = (         short *)0;
  sqlstm.sqharm[3] = (unsigned int  )0;
  sqlstm.sqhstv[4] = (unsigned char  *)&eintrag.gesamtwartezeit;
  sqlstm.sqhstl[4] = (unsigned int  )4;
  sqlstm.sqindv[4] = (         short *)0;
  sqlstm.sqharm[4] = (unsigned int  )0;
  sqlstm.sqhstv[5] = (unsigned char  *)&eintrag.AnzahlBusse;
  sqlstm.sqhstl[5] = (unsigned int  )4;
  sqlstm.sqindv[5] = (         short *)0;
  sqlstm.sqharm[5] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenAusgangsloesung");
}


  /* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )17022;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenAusgangsloesung");
}

	

}
  
//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
list<three_tuple<int,int,int>* >* CDBSchnittstelle::holenAusgangsloesungHaltestelle(int loesungsID) {
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenAusgangsloesungHaltestellen"); */ 


  list<three_tuple<int,int,int>* >* ergebnis =0;
  try{ergebnis= new list<three_tuple<int,int,int>* >;}
  catch(...)
  {
	cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: das Ergebnis der Ausgangsloesung der Haltestellen konnte nicht angelegt werden. Speichermangel?"<<endl;
	cerr.flush();
  }

  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    typedef struct {
      int haltestellenID;
      int netzbedingteWartezeit;
      int wartezeitaufwand;
    } Eintrag;
    Eintrag eintrag;
    int speicherID;
    int tblLoesungsID;
  /* EXEC SQL END DECLARE SECTION; */ 


  speicherID = this->speicherstand;
  tblLoesungsID = loesungsID;

  /* EXEC SQL DECLARE ergebnis_cursor CURSOR FOR SELECT Haltestelle, NetzbedingteWartezeit, Wartezeitaufwand
    FROM AusgangsloesungHaltestlle WHERE SpeicherID = :speicherID AND LoesungsID = :tblLoesungsID; */ 


  /* EXEC SQL WHENEVER NOT FOUND DO break; */ 

  /* EXEC SQL OPEN ergebnis_cursor; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.stmt = sq0825;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )17036;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&speicherID;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenAusgangsloesungHaltestellen");
}



  while(1) {
    /* EXEC SQL FETCH ergebnis_cursor INTO :eintrag; */ 

{
    struct sqlexd sqlstm;

    sqlorat((void **)0, &sqlctx, &oraca);
    sqlstm.sqlvsn = 8;
    sqlstm.arrsiz = 35;
    sqlstm.iters = (unsigned int  )1;
    sqlstm.offset = (unsigned int  )17054;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char  *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlstm.sqhstv[0] = (unsigned char  *)&eintrag.haltestellenID;
    sqlstm.sqhstl[0] = (unsigned int  )4;
    sqlstm.sqindv[0] = (         short *)0;
    sqlstm.sqharm[0] = (unsigned int  )0;
    sqlstm.sqhstv[1] = (unsigned char  *)&eintrag.netzbedingteWartezeit;
    sqlstm.sqhstl[1] = (unsigned int  )4;
    sqlstm.sqindv[1] = (         short *)0;
    sqlstm.sqharm[1] = (unsigned int  )0;
    sqlstm.sqhstv[2] = (unsigned char  *)&eintrag.wartezeitaufwand;
    sqlstm.sqhstl[2] = (unsigned int  )4;
    sqlstm.sqindv[2] = (         short *)0;
    sqlstm.sqharm[2] = (unsigned int  )0;
    sqlstm.sqphsv = sqlstm.sqhstv;
    sqlstm.sqphsl = sqlstm.sqhstl;
    sqlstm.sqpind = sqlstm.sqindv;
    sqlstm.sqparm = sqlstm.sqharm;
    sqlstm.sqparc = sqlstm.sqharc;
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
    if (sqlca.sqlcode == 1403) break;
    if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenAusgangsloesungHaltestellen");
}


    three_tuple<int,int,int>* haltestellenParameter = 0;
    try{haltestellenParameter= new three_tuple<int,int,int>(eintrag.haltestellenID,  eintrag.netzbedingteWartezeit,  eintrag.wartezeitaufwand);}
    catch(...)
    {
	cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: ein Eintrag der Ausgangsloesung der Haltestellen konnte nicht angelegt werden. Speichermangel?"<<endl;
	cerr.flush();
    }
    ergebnis->append(haltestellenParameter);
  }

  /* EXEC SQL CLOSE ergebnis_cursor; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )17080;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenAusgangsloesungHaltestellen");
}


  /* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 


  return ergebnis;
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::speichernAusgangsloesungHaltestelle(int loesungsID,list<three_tuple<int,int,int>* >* haltestellenListe) {

  // Erst die alten Eintraege loeschen
  loeschenAusgangsloesungHaltestelle(loesungsID);

  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in speichernAusgangsloesungHaltestelle"); */ 


  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    typedef struct {
      int speicherID;
      int loesungsID;
      int haltestelleID;
      int netzbedingteWartezeit;
      int wartezeitaufwand;
    } Eintrag;
    Eintrag eintrag;
  /* EXEC SQL END DECLARE SECTION; */ 


  eintrag.speicherID = this->speicherstand;
  eintrag.loesungsID = loesungsID;

  three_tuple<int,int,int>* haltestellenParameter;

  forall(haltestellenParameter,*haltestellenListe) {
    eintrag.haltestelleID = haltestellenParameter->first();
    eintrag.netzbedingteWartezeit = haltestellenParameter->second();
    eintrag.wartezeitaufwand = haltestellenParameter->third();
    /* EXEC SQL INSERT INTO AusgangsloesungHaltestelle VALUES (:eintrag); */ 

{
    struct sqlexd sqlstm;

    sqlorat((void **)0, &sqlctx, &oraca);
    sqlstm.sqlvsn = 8;
    sqlstm.arrsiz = 35;
    sqlstm.stmt = "insert into AusgangsloesungHaltestelle values (:s1 ,:s2 ,\
:s3 ,:s4 ,:s5 )";
    sqlstm.iters = (unsigned int  )1;
    sqlstm.offset = (unsigned int  )17094;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char  *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlstm.sqhstv[0] = (unsigned char  *)&eintrag.speicherID;
    sqlstm.sqhstl[0] = (unsigned int  )4;
    sqlstm.sqindv[0] = (         short *)0;
    sqlstm.sqharm[0] = (unsigned int  )0;
    sqlstm.sqhstv[1] = (unsigned char  *)&eintrag.loesungsID;
    sqlstm.sqhstl[1] = (unsigned int  )4;
    sqlstm.sqindv[1] = (         short *)0;
    sqlstm.sqharm[1] = (unsigned int  )0;
    sqlstm.sqhstv[2] = (unsigned char  *)&eintrag.haltestelleID;
    sqlstm.sqhstl[2] = (unsigned int  )4;
    sqlstm.sqindv[2] = (         short *)0;
    sqlstm.sqharm[2] = (unsigned int  )0;
    sqlstm.sqhstv[3] = (unsigned char  *)&eintrag.netzbedingteWartezeit;
    sqlstm.sqhstl[3] = (unsigned int  )4;
    sqlstm.sqindv[3] = (         short *)0;
    sqlstm.sqharm[3] = (unsigned int  )0;
    sqlstm.sqhstv[4] = (unsigned char  *)&eintrag.wartezeitaufwand;
    sqlstm.sqhstl[4] = (unsigned int  )4;
    sqlstm.sqindv[4] = (         short *)0;
    sqlstm.sqharm[4] = (unsigned int  )0;
    sqlstm.sqphsv = sqlstm.sqhstv;
    sqlstm.sqphsl = sqlstm.sqhstl;
    sqlstm.sqpind = sqlstm.sqindv;
    sqlstm.sqparm = sqlstm.sqharm;
    sqlstm.sqparc = sqlstm.sqharc;
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
    if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernAusgangsloesungHaltestelle");
}


	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )17128;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernAusgangsloesungHaltestelle");
}


  }
  /* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )17142;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernAusgangsloesungHaltestelle");
}


}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::loeschenAusgangsloesungHaltestelle(int loesungsID) {
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in loeschenAusgangsloesungHaltestelle"); */ 


  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    int speicherID;
    int tblLoesungsID;
  /* EXEC SQL END DECLARE SECTION; */ 


  speicherID = this->speicherstand;
  tblLoesungsID = loesungsID;

  /* EXEC SQL DELETE AusgangsloesungHaltestelle WHERE SpeicherID = :speicherID AND LoesungsID = :tblLoesungsID; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.stmt = "delete from AusgangsloesungHaltestelle  where (SpeicherID=:\
b0 and LoesungsID=:b1)";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )17156;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&speicherID;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&tblLoesungsID;
  sqlstm.sqhstl[1] = (unsigned int  )4;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenAusgangsloesungHaltestelle");
}


}
  
//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::holenLinienplanBewertung(int linienplanID, int& mittlereReisezeit, int& direktfahreranteil) {
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenLinienplanBewertung"); */ 


  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    typedef struct {
      int mittlereReisezeit;
      int direktfahreranteil;
    } Eintrag;
    Eintrag eintrag;
    int speicherID;
    int planID;
  /* EXEC SQL END DECLARE SECTION; */ 


  speicherID = this->speicherstand;
  planID = linienplanID;
  eintrag.mittlereReisezeit = 0;
  eintrag.direktfahreranteil = 0;
  
  /* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 


  /* EXEC SQL SELECT LinienplanID, MittlereReisezeit, Direktfahreranteil INTO :eintrag
    FROM LinienplanBewertung WHERE SpeicherID = :speicherID AND LinienplanID = :planID; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.stmt = "select LinienplanID ,MittlereReisezeit ,Direktfahreranteil \
into :s1 ,:s2   from LinienplanBewertung where (SpeicherID=:b1 and LinienplanI\
D=:b2)";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )17178;
  sqlstm.selerr = (unsigned short)1;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&eintrag.mittlereReisezeit;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&eintrag.direktfahreranteil;
  sqlstm.sqhstl[1] = (unsigned int  )4;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&speicherID;
  sqlstm.sqhstl[2] = (unsigned int  )4;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqhstv[3] = (unsigned char  *)&planID;
  sqlstm.sqhstl[3] = (unsigned int  )4;
  sqlstm.sqindv[3] = (         short *)0;
  sqlstm.sqharm[3] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenLinienplanBewertung");
}



  mittlereReisezeit = eintrag.mittlereReisezeit;
  direktfahreranteil = eintrag.direktfahreranteil;
}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::speichernLinienplanBewertung(int linienplanID, int mittlereReisezeit, int direktfahreranteil) {
  // Alten Eintraege loeschen
  loeschenLinienplanBewertung();

  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in speichernLinienplanBewertung"); */ 


  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    typedef struct {
      int speicherID;
      int linienplanID;
      int mittlereReisezeit;
      int direktfahreranteil;
    } Eintrag;
    Eintrag eintrag;
  /* EXEC SQL END DECLARE SECTION; */ 


  eintrag.speicherID = this->speicherstand;
  eintrag.linienplanID = linienplanID;
  eintrag.mittlereReisezeit = mittlereReisezeit;
  eintrag.direktfahreranteil = direktfahreranteil;
  
  /* EXEC SQL INSERT INTO LinienplanBewertung VALUES(:eintrag); */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.stmt = "insert into LinienplanBewertung values (:s1 ,:s2 ,:s3 ,:s4 \
)";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )17208;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&eintrag.speicherID;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&eintrag.linienplanID;
  sqlstm.sqhstl[1] = (unsigned int  )4;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&eintrag.mittlereReisezeit;
  sqlstm.sqhstl[2] = (unsigned int  )4;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqhstv[3] = (unsigned char  *)&eintrag.direktfahreranteil;
  sqlstm.sqhstl[3] = (unsigned int  )4;
  sqlstm.sqindv[3] = (         short *)0;
  sqlstm.sqharm[3] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernLinienplanBewertung");
}


  /* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )17238;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernLinienplanBewertung");
}


}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::loeschenLinienplanBewertung() {
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in loeschenLinienplanBewertung"); */ 


  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    int speicherID;
  /* EXEC SQL END DECLARE SECTION; */ 


  speicherID = this->speicherstand;

  /* EXEC SQL DELETE LinienplanBewertung WHERE SpeicherID = :speicherID; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.stmt = "delete from LinienplanBewertung  where SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )17252;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&speicherID;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in loeschenLinienplanBewertung");
}


}
    

//------------------------------------------------------------------------------
// Funktionsname:	speichernMindestumsteigezeit
// Beschreibung:	Speichert die Mindestumsteigezeiten in der Datenbank
// Parameter:		ein Hash-Array, das die Haltestelle beeinhaltet und eine Liste mit: Linie1, Linie2 und der Mindestumsteigezeit
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::speichernMindestumsteigezeit(h_array<int,list<three_tuple<int,int,int>* >*>* input)
{
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in speichernMindestumsteigezeit"); */ 


	if(input!=0) 
	{
        	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
		// Datenfelder anlegen, die als Zwischenspeicher dienen:
		typedef struct
		{
			double SpeicherID;
			int HaltestellenID;
 			int LinieA;
			int LinieB;
			int Umsteigezeit;
		} umsteigeelement;
		umsteigeelement element;
		/* EXEC SQL END DECLARE SECTION; */ 
	
                element.SpeicherID = speicherstand;

		//zunaechst die Tabelle loeschen:
		/* EXEC SQL DELETE FROM Mindestumsteigezeit WHERE SpeicherID = :element.SpeicherID; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.stmt = "delete from Mindestumsteigezeit  where SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )17270;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&(element.SpeicherID);
  sqlstm.sqhstl[0] = (unsigned int  )8;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernMindestumsteigezeit");
}



		// jetzt alle Punkte aus der arc durchlaufen:
		list<three_tuple<int,int,int>*>* dummyliste;
		int hs_id=0;
		forall(dummyliste, *input)
		{
			// erstmal den Punkt auslesen:
			element.HaltestellenID=hs_id;
			// diesen Punkt jetzt ins element einsetzen:
			if(dummyliste!=0)
			{
				three_tuple<int,int,int>* dummytupel;
				forall(dummytupel, *dummyliste)
				{
					if(dummytupel!=0)
					{
						element.LinieA=dummytupel->first();
						element.LinieB=dummytupel->second();
						element.Umsteigezeit=dummytupel->third();
					}else cerr<<"Datenbank: "<<__LINE__<<": "<<"Datenbank: Umsteige-Tupel fuer die Haltestelle "<<hs_id<<" fehlt!"<<endl;
				}
				// und ab in die Datenbank:
        	        	/* EXEC SQL INSERT INTO Mindestumsteigezeit
					VALUES (:element); */ 

{
                  struct sqlexd sqlstm;

                  sqlorat((void **)0, &sqlctx, &oraca);
                  sqlstm.sqlvsn = 8;
                  sqlstm.arrsiz = 35;
                  sqlstm.stmt = "insert into Mindestumsteigezeit values (:s1\
 ,:s2 ,:s3 ,:s4 ,:s5 )";
                  sqlstm.iters = (unsigned int  )1;
                  sqlstm.offset = (unsigned int  )17288;
                  sqlstm.cud = sqlcud0;
                  sqlstm.sqlest = (unsigned char  *)&sqlca;
                  sqlstm.sqlety = (unsigned short)0;
                  sqlstm.sqhstv[0] = (unsigned char  *)&element.SpeicherID;
                  sqlstm.sqhstl[0] = (unsigned int  )8;
                  sqlstm.sqindv[0] = (         short *)0;
                  sqlstm.sqharm[0] = (unsigned int  )0;
                  sqlstm.sqhstv[1] = (unsigned char  *)&element.HaltestellenID;
                  sqlstm.sqhstl[1] = (unsigned int  )4;
                  sqlstm.sqindv[1] = (         short *)0;
                  sqlstm.sqharm[1] = (unsigned int  )0;
                  sqlstm.sqhstv[2] = (unsigned char  *)&element.LinieA;
                  sqlstm.sqhstl[2] = (unsigned int  )4;
                  sqlstm.sqindv[2] = (         short *)0;
                  sqlstm.sqharm[2] = (unsigned int  )0;
                  sqlstm.sqhstv[3] = (unsigned char  *)&element.LinieB;
                  sqlstm.sqhstl[3] = (unsigned int  )4;
                  sqlstm.sqindv[3] = (         short *)0;
                  sqlstm.sqharm[3] = (unsigned int  )0;
                  sqlstm.sqhstv[4] = (unsigned char  *)&element.Umsteigezeit;
                  sqlstm.sqhstl[4] = (unsigned int  )4;
                  sqlstm.sqindv[4] = (         short *)0;
                  sqlstm.sqharm[4] = (unsigned int  )0;
                  sqlstm.sqphsv = sqlstm.sqhstv;
                  sqlstm.sqphsl = sqlstm.sqhstl;
                  sqlstm.sqpind = sqlstm.sqindv;
                  sqlstm.sqparm = sqlstm.sqharm;
                  sqlstm.sqparc = sqlstm.sqharc;
                  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
                  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernMindestumsteigezeit");
}

	
				/* EXEC SQL COMMIT; */ 

{
    struct sqlexd sqlstm;

    sqlorat((void **)0, &sqlctx, &oraca);
    sqlstm.sqlvsn = 8;
    sqlstm.arrsiz = 35;
    sqlstm.iters = (unsigned int  )1;
    sqlstm.offset = (unsigned int  )17322;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char  *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
    if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernMindestumsteigezeit");
}


			} else cerr<<"Datenbank: "<<__LINE__<<": "<<"Datenbank: Mindestumsteigezeit fuer die Haltestelle "<<hs_id<<" fehlt!"<<endl;
			hs_id++;

			// Zur Vorsicht alle Werte wieder auf 0 setzen:
			element.HaltestellenID=0;
                        element.LinieA=0;
			element.LinieB=0;
			element.Umsteigezeit=0;
		}
		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )17336;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernMindestumsteigezeit");
}



	} // endif: test auf Nullzeiger
	else cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: speichernMindestumsteigezeit: NULL-Zeiger wurde uebergeben!"<<endl; 
}
//------------------------------------------------------------------------------
// Funktionsname:	holenMindestumsteigezeit
// Beschreibung:	holt die Mindestumsteigezeiten in der Datenbank
// Parameter:		
// Rueckgabe:		ein Hash-Array, das die Haltestelle beeinhaltet und eine Liste mit: Linie1, Linie2 und der Mindestumsteigezeit
// Besonderheiten:	
//------------------------------------------------------------------------------
h_array<int,list<three_tuple<int,int,int>* >*>* CDBSchnittstelle::holenMindestumsteigezeit()
{
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenMindestumsteigezeit"); */ 


	// Rueckgabeliste anlegen:
	h_array<int,list<three_tuple<int,int,int>* >*>* rueckgabearray=0;
	try{rueckgabearray=new h_array<int,list<three_tuple<int,int,int>* >*>;}
	catch(...)
        {
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Mindestumsteigezeit konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
        }
	list<three_tuple<int,int,int>*>* hilfliste=0;
        /* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
	
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	typedef struct	// eine Buslinie -> LinienWeg
	{
		int HaltestellenID;
		int LinieA;
		int LinieB;
		int Umsteigezeit;
	} umsteigeelement;
	umsteigeelement element;
	int speicherid=speicherstand;
	/* EXEC SQL END DECLARE SECTION; */ 
	
	
	// erzeuge die Cursor, mit dem Daten durchlaufen werden:
	/* EXEC SQL DECLARE umsteigezeit_cursor CURSOR FOR
		SELECT HaltestellenID, LinieA, LinieB, Umsteigezeit
			FROM Mindestumsteigezeit
			WHERE SpeicherID = :speicherid; */ 

        
	// jetzt den Cursor oeffnen
	/* EXEC SQL OPEN umsteigezeit_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.stmt = sq0869;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )17350;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenMindestumsteigezeit");
}



        // und jetzt in Schleife alle Dinger holen:
	int hs_id=0;
	try{hilfliste=new list<three_tuple<int,int,int>*>;}
	catch(...)
    	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: eine Hilfsliste fuer die Mindestumsteigezeit konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}   	
	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

	for(;;)
	{
		/* EXEC SQL FETCH umsteigezeit_cursor INTO :element; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )17368;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&element.HaltestellenID;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&element.LinieA;
  sqlstm.sqhstl[1] = (unsigned int  )4;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&element.LinieB;
  sqlstm.sqhstl[2] = (unsigned int  )4;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqhstv[3] = (unsigned char  *)&element.Umsteigezeit;
  sqlstm.sqhstl[3] = (unsigned int  )4;
  sqlstm.sqindv[3] = (         short *)0;
  sqlstm.sqharm[3] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenMindestumsteigezeit");
}


		// und anlegen:
		if(element.HaltestellenID==hs_id)
		{
			// solange es sich um eine Haltestelle handelt, fuellen wir die zugehoerige Liste:
			three_tuple<int,int,int>* hilftupel=0;
			try{hilftupel=new three_tuple<int,int,int>(element.LinieA, element.LinieB, element.Umsteigezeit);} // neues Tupel anlegen}
			catch(...)
			{
				cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: ein Hilfstupel fuer die Mindestumsteigezeit konnte nicht angelegt werden. Speichermangel?"<<endl;
				cerr.flush();
			}
			hilfliste->append(hilftupel);
		}
		else
		{
			// hier wissen wir: es kommt eine andere Haltestelle, also schieben wir die Daten
			// der Haltestelle in das Array
                	(*rueckgabearray)[hs_id]=hilfliste; 
			// jetzt muessen wir eine neue Liste anlegen und das schon gelesene Element einfuegen:
			try{hilfliste=new list<three_tuple<int,int,int>*>;}
			catch(...)
		    	{
				cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: eine Hilfsliste fuer die Mindestumsteigezeit konnte nicht angelegt werden. (2) Speichermangel?"<<endl;
				cerr.flush();
			}
			three_tuple<int,int,int>* hilftupel=0;
			try{hilftupel=new three_tuple<int,int,int>(element.LinieA, element.LinieB, element.Umsteigezeit);} // neues Tupel anlegen
			catch(...)
		    	{
				cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: ein Hilfstupel fuer die Mindestumsteigezeit konnte nicht angelegt werden. (2) Speichermangel?"<<endl;
				cerr.flush();
			}
			
			hilfliste->append(hilftupel);
			// und die nummer um einen erhoehen:
			hs_id++;
		}
	}
        /* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	// und nach getaner arbeit Cursor wieder schliessen:
	/* EXEC SQL CLOSE umsteigezeit_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )17398;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenMindestumsteigezeit");
}



	// das letzte Element wurde nocht nicht eingehangen:
	(*rueckgabearray)[hs_id]=hilfliste; 

	return rueckgabearray;	
}

//------------------------------------------------------------------------------
// Funktionsname:	speichernMindesthaltezeiten
// Beschreibung:	Speichert die Mindesthaltezeiten aller Haltestellen in der Datenbank
// Parameter:		ein Hash-Array, das die Haltestelle beeinhaltet und die dazugehoerige Mindesthaltezeit
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::speichernMindesthaltezeiten(h_array<int,int>* mh)
{
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in speichernMindesthaltezeiten"); */ 


	if(mh!=0) 
	{
        	/* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
		// Datenfelder anlegen, die als Zwischenspeicher dienen:
		typedef struct
		{
			double SpeicherID;
			int HaltestellenID;
			int Haltezeit;
		} haltezeitelement;
		haltezeitelement element;
		/* EXEC SQL END DECLARE SECTION; */ 
	
                element.SpeicherID = speicherstand;

		//zunaechst die Tabelle loeschen:
		/* EXEC SQL DELETE FROM Mindesthaltezeiten WHERE SpeicherID = :element.SpeicherID; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.stmt = "delete from Mindesthaltezeiten  where SpeicherID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )17412;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&(element.SpeicherID);
  sqlstm.sqhstl[0] = (unsigned int  )8;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernMindesthaltezeiten");
}



		// jetzt alle Punkte aus der arc durchlaufen:
		int hilf_hz;
		int hs_id=0;
		forall(hilf_hz, *mh)
		{
			element.HaltestellenID=hs_id;
			hs_id++;
			element.Haltezeit=hilf_hz;

			// und ab in die Datenbank:
       	        	/* EXEC SQL INSERT INTO Mindesthaltezeit
				VALUES (:element); */ 

{
                 struct sqlexd sqlstm;

                 sqlorat((void **)0, &sqlctx, &oraca);
                 sqlstm.sqlvsn = 8;
                 sqlstm.arrsiz = 35;
                 sqlstm.stmt = "insert into Mindesthaltezeit values (:s1 ,:s\
2 ,:s3 )";
                 sqlstm.iters = (unsigned int  )1;
                 sqlstm.offset = (unsigned int  )17430;
                 sqlstm.cud = sqlcud0;
                 sqlstm.sqlest = (unsigned char  *)&sqlca;
                 sqlstm.sqlety = (unsigned short)0;
                 sqlstm.sqhstv[0] = (unsigned char  *)&element.SpeicherID;
                 sqlstm.sqhstl[0] = (unsigned int  )8;
                 sqlstm.sqindv[0] = (         short *)0;
                 sqlstm.sqharm[0] = (unsigned int  )0;
                 sqlstm.sqhstv[1] = (unsigned char  *)&element.HaltestellenID;
                 sqlstm.sqhstl[1] = (unsigned int  )4;
                 sqlstm.sqindv[1] = (         short *)0;
                 sqlstm.sqharm[1] = (unsigned int  )0;
                 sqlstm.sqhstv[2] = (unsigned char  *)&element.Haltezeit;
                 sqlstm.sqhstl[2] = (unsigned int  )4;
                 sqlstm.sqindv[2] = (         short *)0;
                 sqlstm.sqharm[2] = (unsigned int  )0;
                 sqlstm.sqphsv = sqlstm.sqhstv;
                 sqlstm.sqphsl = sqlstm.sqhstl;
                 sqlstm.sqpind = sqlstm.sqindv;
                 sqlstm.sqparm = sqlstm.sqharm;
                 sqlstm.sqparc = sqlstm.sqharc;
                 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
                 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernMindesthaltezeiten");
}

	
			hs_id++;

			// Zur Vorsicht alle Werte wieder auf 0 setzen:
			element.HaltestellenID=0;
			element.Haltezeit=0;

			/* EXEC SQL COMMIT; */ 

{
   struct sqlexd sqlstm;

   sqlorat((void **)0, &sqlctx, &oraca);
   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 35;
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )17456;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
   if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernMindesthaltezeiten");
}


		}
		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )17470;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in speichernMindesthaltezeiten");
}



	} // endif: test auf Nullzeiger
	else cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: speichernMindesthaltezeiten: NULL-Zeiger wurde uebergeben!"<<endl; 
}
//------------------------------------------------------------------------------
// Funktionsname:	holenMindesthaltezeiten
// Beschreibung:	holt die Mindesthaltezeiten aus der Datenbank
// Parameter:		
// Rueckgabe:		ein Hash-Array, das die Haltestelle beeinhaltet und die dazugehoerige Mindestwartezeit
// Besonderheiten:	
//------------------------------------------------------------------------------
h_array<int,int>* CDBSchnittstelle::holenMindesthaltezeiten()
{
	/* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenMindesthaltezeiten"); */ 


	// Rueckgabeliste anlegen:
	h_array<int,int>* rueckgabearray=0;
	try{rueckgabearray=new h_array<int,int>;}
	catch(...)
    	{
		cerr<<"Datenbank: "<<__LINE__<<": "<<"FEHLER: die Liste der Mindesthaltezeiten konnte nicht angelegt werden. Speichermangel?"<<endl;
		cerr.flush();
	}
        /* EXEC SQL BEGIN DECLARE SECTION; */ 
	                                   
	
	// Datenfelder anlegen, die als Zwischenspeicher dienen:
	typedef struct	// eine Buslinie -> LinienWeg
	{
		int HaltestellenID;
		int Haltezeiten;
	} halteelement;
	halteelement element;
	int speicherid=speicherstand;
	/* EXEC SQL END DECLARE SECTION; */ 
	
	
	// erzeuge die Cursor, mit dem Daten durchlaufen werden:
	/* EXEC SQL DECLARE haltezeit_cursor CURSOR FOR
		SELECT HaltestellenID, Haltezeit
			FROM Mindesthaltezeit
			WHERE SpeicherID = :speicherid; */ 

        
	// jetzt den Cursor oeffnen
	/* EXEC SQL OPEN haltezeit_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.stmt = sq0874;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )17484;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&speicherid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenMindesthaltezeiten");
}



        // und jetzt in Schleife alle Dinger holen:
	int hs_id=0;
	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

	for(;;)
	{
		/* EXEC SQL FETCH haltezeit_cursor INTO :element; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )17502;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&element.HaltestellenID;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&element.Haltezeiten;
  sqlstm.sqhstl[1] = (unsigned int  )4;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenMindesthaltezeiten");
}


		// und anlegen:
               	(*rueckgabearray)[hs_id]=element.Haltezeiten; 
		hs_id++;
	}
        /* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	// und nach getaner arbeit Cursor wieder schliessen:
	/* EXEC SQL CLOSE haltezeit_cursor; */ 

{
 struct sqlexd sqlstm;

 sqlorat((void **)0, &sqlctx, &oraca);
 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 35;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )17524;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in holenMindesthaltezeiten");
}



	return rueckgabearray;		
}



// Datenbank interne Funktionen: ---------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------
// Funktionsname:	aufbauenVerbindung
// Beschreibung:	Aufbau einer Verbindung zur Datenbank
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	Loginname und Passwort sind Hartkodiert
// Aenderung:           Loginname und Passwort sind die gleichen, und werden uebergeben
//------------------------------------------------------------------------------
void CDBSchnittstelle::aufbauenVerbindung(char* username){
  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    /* VARCHAR user[20]; */ 
struct { unsigned short len; unsigned char arr[20]; } user;

  /* EXEC SQL END DECLARE SECTION; */ 


  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler beim ffnen der Datenbank!Bitte an Ihren Datenbankadministrator wenden!"); */ 

  
  user.len = strlen(strcpy((char *)user.arr, username));

  /* EXEC SQL CONNECT :user IDENTIFIED BY :user; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )10;
  sqlstm.offset = (unsigned int  )17538;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&user;
  sqlstm.sqhstl[0] = (unsigned int  )22;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&user;
  sqlstm.sqhstl[1] = (unsigned int  )22;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler beim ffnen der Datenbank!Bitte an Ihren Datenbankadministrator wenden!");
}


  /* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )17564;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler beim ffnen der Datenbank!Bitte an Ihren Datenbankadministrator wenden!");
}



  std::cout << "Verbindung zur Datenbank wurde hergestellt"<<endl;
} // ende aufbauenVerbindung

//------------------------------------------------------------------------------
// Funktionsname:	anlegenUserInDatenbank
// Beschreibung:	Legt einen neuen User an
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	Funktion ist nicht in Benutzung und nicht funktionsfaehig
//------------------------------------------------------------------------------
void CDBSchnittstelle::anlegenUserInDatenbank(char* username){
  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    /* VARCHAR prguser[20]; */ 
struct { unsigned short len; unsigned char arr[20]; } prguser;

    /* VARCHAR stmt[200]; */ 
struct { unsigned short len; unsigned char arr[200]; } stmt;

    /* VARCHAR user[20]; */ 
struct { unsigned short len; unsigned char arr[20]; } user;

  /* EXEC SQL END DECLARE SECTION; */ 


  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler beim ffnen der Datenbank[2]!"); */ 


  prguser.len = strlen(strcpy((char *)prguser.arr, "prguser"));

  /* EXEC SQL CONNECT :prguser IDENTIFIED BY :prguser; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )10;
  sqlstm.offset = (unsigned int  )17578;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&prguser;
  sqlstm.sqhstl[0] = (unsigned int  )22;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&prguser;
  sqlstm.sqhstl[1] = (unsigned int  )22;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler beim ffnen der Datenbank[2]!");
}



  char* sqlString = "CREATE USER ";
  sqlString = strcpy(sqlString, username);
  sqlString = strcpy(sqlString, " IDENTIFIED BY ");
  sqlString = strcpy(sqlString, username);
  sqlString = strcpy(sqlString, " DEFAULT TABLESPACE PG369SPACE TEMPORARY TABLESPACE PG369SPACE");

  /* EXEC SQL DECLARE create_statement STATEMENT; */ 

  /* EXEC SQL PREPARE create_statement FROM :stmt; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.stmt = "";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )17604;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&stmt;
  sqlstm.sqhstl[0] = (unsigned int  )202;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler beim ffnen der Datenbank[2]!");
}


  /* EXEC SQL EXECUTE create_statement; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.stmt = "";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )17622;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler beim ffnen der Datenbank[2]!");
}



  /* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )17636;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler beim ffnen der Datenbank[2]!");
}



  /* EXEC SQL ROLLBACK; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )17650;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler beim ffnen der Datenbank[2]!");
}

 

  user.len = strlen(strcpy((char *)user.arr, username));

  /* EXEC SQL CONNECT :user IDENTIFIED BY :user; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )10;
  sqlstm.offset = (unsigned int  )17664;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&user;
  sqlstm.sqhstl[0] = (unsigned int  )22;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&user;
  sqlstm.sqhstl[1] = (unsigned int  )22;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler beim ffnen der Datenbank[2]!");
}


  std::cout << "Verbindung zur Datenbank wurde hergestellt"<<endl;
}
//------------------------------------------------------------------------------
// Funktionsname:	holenSpeicherstand
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
int CDBSchnittstelle::holenSpeicherstand(char* speicherName){
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in holenSpeicherstand"); */ 


  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    /* VARCHAR bezeichnung[30]; */ 
struct { unsigned short len; unsigned char arr[30]; } bezeichnung;

    int speicherID = -1;
    int hilfsZahl = -1;
    int phase = 0;
  /* EXEC SQL END DECLARE SECTION; */ 


  bezeichnung.len = strlen(strcpy((char *)bezeichnung.arr, speicherName));

  /* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 


  // Erst mal nachschauen, ob Speicherplatz schon vorhanden ist

 // EXEC SQL SELECT id INTO :speicherID FROM Speicherstand WHERE Bezeichnung = :bezeichnung;
 list<two_tuple<int,char*>*>* projinfos=holenAlleProjektInformationen();

  // Ansonsten neuen Anlegen
  if (projinfos->empty()==true) 
  {
    Debug(2, "ES SIND KEINE PROJEKTE VORHANDEN, LEGE PROJEKT 0 AN!");
    anlegenNeuesProjekt(0, "Standard", 0);
    speicherID=0;
    /*hilfsZahl = -1;
    while (speicherID == hilfsZahl)
    {
      hilfsZahl++;
      EXEC SQL SELECT id INTO :speicherID FROM Speicherstand WHERE id = :hilfsZahl;
    } 
    speicherID = hilfsZahl;
    EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler beim holen des Speicherstandes");
    EXEC SQL INSERT INTO Speicherstand VALUES(:speicherID,:bezeichnung,:phase);
    EXEC SQL COMMIT;
    */

  }
  else
  {
	// andernfalls geben wir die niedrigste Projektnummer zurueck
	speicherID=99;
	two_tuple<int,char*>* eintrag;
	forall(eintrag, *projinfos)
	{
		if(speicherID>eintrag->first()) speicherID=eintrag->first();
	}
	Debug(2, "erstes Projekt lautet:"<<speicherID);
  }

  cout << "Speicher Nummer: " << speicherID << endl;
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Oracle Fehler"); */ 

  return speicherID;
}

//------------------------------------------------------------------------------
// Funktionsname:	beendenVerbindung
// Beschreibung:	Abbau einer Datenbankverbindung
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::beendenVerbindung(){
  /* EXEC SQL WHENEVER SQLERROR DO ausgebenSQLFehler("Fehler in beendenVerbindung"); */ 

  
  /* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )17690;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in beendenVerbindung");
}


  /* EXEC SQL ROLLBACK RELEASE; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )17704;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) ausgebenSQLFehler("Fehler in beendenVerbindung");
}


 // EXEC SQL COMMIT;
  std::cout << "Verbindung zur Datenbank wurde beendet"<<endl;
} // ende beendenVerbindung

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CDBSchnittstelle::ausgebenSQLFehler(char* Meldung){
  /* EXEC SQL WHENEVER SQLERROR CONTINUE; */ 

  std::cout << endl << "Oracle Fehler: " << Meldung << endl;
  std::cout << sqlca.sqlerrm.sqlerrmc << endl;
  std::cout.flush();
  /* EXEC SQL ROLLBACK RELEASE; */ 

{
  struct sqlexd sqlstm;

  sqlorat((void **)0, &sqlctx, &oraca);
  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 35;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )17718;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


  exit(1);
}

